#include "registers/AMDGPU/amdgpu_gfx908_regs.h"
#include "InstructionDecoder-amdgpu-gfx908.h"

namespace Dyninst {
namespace InstructionAPI {
    Expression::Ptr InstructionDecoder_amdgpu_gfx908::decodeOPR_ACCVGPR(uint64_t input, uint32_t output_vec_len)
    {
        switch (input)  {
            case 0:  return makeRegisterExpression(amdgpu_gfx908::acc0, output_vec_len );
            case 1:  return makeRegisterExpression(amdgpu_gfx908::acc1, output_vec_len );
            case 2:  return makeRegisterExpression(amdgpu_gfx908::acc2, output_vec_len );
            case 3:  return makeRegisterExpression(amdgpu_gfx908::acc3, output_vec_len );
            case 4:  return makeRegisterExpression(amdgpu_gfx908::acc4, output_vec_len );
            case 5:  return makeRegisterExpression(amdgpu_gfx908::acc5, output_vec_len );
            case 6:  return makeRegisterExpression(amdgpu_gfx908::acc6, output_vec_len );
            case 7:  return makeRegisterExpression(amdgpu_gfx908::acc7, output_vec_len );
            case 8:  return makeRegisterExpression(amdgpu_gfx908::acc8, output_vec_len );
            case 9:  return makeRegisterExpression(amdgpu_gfx908::acc9, output_vec_len );
            case 10:  return makeRegisterExpression(amdgpu_gfx908::acc10, output_vec_len );
            case 11:  return makeRegisterExpression(amdgpu_gfx908::acc11, output_vec_len );
            case 12:  return makeRegisterExpression(amdgpu_gfx908::acc12, output_vec_len );
            case 13:  return makeRegisterExpression(amdgpu_gfx908::acc13, output_vec_len );
            case 14:  return makeRegisterExpression(amdgpu_gfx908::acc14, output_vec_len );
            case 15:  return makeRegisterExpression(amdgpu_gfx908::acc15, output_vec_len );
            case 16:  return makeRegisterExpression(amdgpu_gfx908::acc16, output_vec_len );
            case 17:  return makeRegisterExpression(amdgpu_gfx908::acc17, output_vec_len );
            case 18:  return makeRegisterExpression(amdgpu_gfx908::acc18, output_vec_len );
            case 19:  return makeRegisterExpression(amdgpu_gfx908::acc19, output_vec_len );
            case 20:  return makeRegisterExpression(amdgpu_gfx908::acc20, output_vec_len );
            case 21:  return makeRegisterExpression(amdgpu_gfx908::acc21, output_vec_len );
            case 22:  return makeRegisterExpression(amdgpu_gfx908::acc22, output_vec_len );
            case 23:  return makeRegisterExpression(amdgpu_gfx908::acc23, output_vec_len );
            case 24:  return makeRegisterExpression(amdgpu_gfx908::acc24, output_vec_len );
            case 25:  return makeRegisterExpression(amdgpu_gfx908::acc25, output_vec_len );
            case 26:  return makeRegisterExpression(amdgpu_gfx908::acc26, output_vec_len );
            case 27:  return makeRegisterExpression(amdgpu_gfx908::acc27, output_vec_len );
            case 28:  return makeRegisterExpression(amdgpu_gfx908::acc28, output_vec_len );
            case 29:  return makeRegisterExpression(amdgpu_gfx908::acc29, output_vec_len );
            case 30:  return makeRegisterExpression(amdgpu_gfx908::acc30, output_vec_len );
            case 31:  return makeRegisterExpression(amdgpu_gfx908::acc31, output_vec_len );
            case 32:  return makeRegisterExpression(amdgpu_gfx908::acc32, output_vec_len );
            case 33:  return makeRegisterExpression(amdgpu_gfx908::acc33, output_vec_len );
            case 34:  return makeRegisterExpression(amdgpu_gfx908::acc34, output_vec_len );
            case 35:  return makeRegisterExpression(amdgpu_gfx908::acc35, output_vec_len );
            case 36:  return makeRegisterExpression(amdgpu_gfx908::acc36, output_vec_len );
            case 37:  return makeRegisterExpression(amdgpu_gfx908::acc37, output_vec_len );
            case 38:  return makeRegisterExpression(amdgpu_gfx908::acc38, output_vec_len );
            case 39:  return makeRegisterExpression(amdgpu_gfx908::acc39, output_vec_len );
            case 40:  return makeRegisterExpression(amdgpu_gfx908::acc40, output_vec_len );
            case 41:  return makeRegisterExpression(amdgpu_gfx908::acc41, output_vec_len );
            case 42:  return makeRegisterExpression(amdgpu_gfx908::acc42, output_vec_len );
            case 43:  return makeRegisterExpression(amdgpu_gfx908::acc43, output_vec_len );
            case 44:  return makeRegisterExpression(amdgpu_gfx908::acc44, output_vec_len );
            case 45:  return makeRegisterExpression(amdgpu_gfx908::acc45, output_vec_len );
            case 46:  return makeRegisterExpression(amdgpu_gfx908::acc46, output_vec_len );
            case 47:  return makeRegisterExpression(amdgpu_gfx908::acc47, output_vec_len );
            case 48:  return makeRegisterExpression(amdgpu_gfx908::acc48, output_vec_len );
            case 49:  return makeRegisterExpression(amdgpu_gfx908::acc49, output_vec_len );
            case 50:  return makeRegisterExpression(amdgpu_gfx908::acc50, output_vec_len );
            case 51:  return makeRegisterExpression(amdgpu_gfx908::acc51, output_vec_len );
            case 52:  return makeRegisterExpression(amdgpu_gfx908::acc52, output_vec_len );
            case 53:  return makeRegisterExpression(amdgpu_gfx908::acc53, output_vec_len );
            case 54:  return makeRegisterExpression(amdgpu_gfx908::acc54, output_vec_len );
            case 55:  return makeRegisterExpression(amdgpu_gfx908::acc55, output_vec_len );
            case 56:  return makeRegisterExpression(amdgpu_gfx908::acc56, output_vec_len );
            case 57:  return makeRegisterExpression(amdgpu_gfx908::acc57, output_vec_len );
            case 58:  return makeRegisterExpression(amdgpu_gfx908::acc58, output_vec_len );
            case 59:  return makeRegisterExpression(amdgpu_gfx908::acc59, output_vec_len );
            case 60:  return makeRegisterExpression(amdgpu_gfx908::acc60, output_vec_len );
            case 61:  return makeRegisterExpression(amdgpu_gfx908::acc61, output_vec_len );
            case 62:  return makeRegisterExpression(amdgpu_gfx908::acc62, output_vec_len );
            case 63:  return makeRegisterExpression(amdgpu_gfx908::acc63, output_vec_len );
            case 64:  return makeRegisterExpression(amdgpu_gfx908::acc64, output_vec_len );
            case 65:  return makeRegisterExpression(amdgpu_gfx908::acc65, output_vec_len );
            case 66:  return makeRegisterExpression(amdgpu_gfx908::acc66, output_vec_len );
            case 67:  return makeRegisterExpression(amdgpu_gfx908::acc67, output_vec_len );
            case 68:  return makeRegisterExpression(amdgpu_gfx908::acc68, output_vec_len );
            case 69:  return makeRegisterExpression(amdgpu_gfx908::acc69, output_vec_len );
            case 70:  return makeRegisterExpression(amdgpu_gfx908::acc70, output_vec_len );
            case 71:  return makeRegisterExpression(amdgpu_gfx908::acc71, output_vec_len );
            case 72:  return makeRegisterExpression(amdgpu_gfx908::acc72, output_vec_len );
            case 73:  return makeRegisterExpression(amdgpu_gfx908::acc73, output_vec_len );
            case 74:  return makeRegisterExpression(amdgpu_gfx908::acc74, output_vec_len );
            case 75:  return makeRegisterExpression(amdgpu_gfx908::acc75, output_vec_len );
            case 76:  return makeRegisterExpression(amdgpu_gfx908::acc76, output_vec_len );
            case 77:  return makeRegisterExpression(amdgpu_gfx908::acc77, output_vec_len );
            case 78:  return makeRegisterExpression(amdgpu_gfx908::acc78, output_vec_len );
            case 79:  return makeRegisterExpression(amdgpu_gfx908::acc79, output_vec_len );
            case 80:  return makeRegisterExpression(amdgpu_gfx908::acc80, output_vec_len );
            case 81:  return makeRegisterExpression(amdgpu_gfx908::acc81, output_vec_len );
            case 82:  return makeRegisterExpression(amdgpu_gfx908::acc82, output_vec_len );
            case 83:  return makeRegisterExpression(amdgpu_gfx908::acc83, output_vec_len );
            case 84:  return makeRegisterExpression(amdgpu_gfx908::acc84, output_vec_len );
            case 85:  return makeRegisterExpression(amdgpu_gfx908::acc85, output_vec_len );
            case 86:  return makeRegisterExpression(amdgpu_gfx908::acc86, output_vec_len );
            case 87:  return makeRegisterExpression(amdgpu_gfx908::acc87, output_vec_len );
            case 88:  return makeRegisterExpression(amdgpu_gfx908::acc88, output_vec_len );
            case 89:  return makeRegisterExpression(amdgpu_gfx908::acc89, output_vec_len );
            case 90:  return makeRegisterExpression(amdgpu_gfx908::acc90, output_vec_len );
            case 91:  return makeRegisterExpression(amdgpu_gfx908::acc91, output_vec_len );
            case 92:  return makeRegisterExpression(amdgpu_gfx908::acc92, output_vec_len );
            case 93:  return makeRegisterExpression(amdgpu_gfx908::acc93, output_vec_len );
            case 94:  return makeRegisterExpression(amdgpu_gfx908::acc94, output_vec_len );
            case 95:  return makeRegisterExpression(amdgpu_gfx908::acc95, output_vec_len );
            case 96:  return makeRegisterExpression(amdgpu_gfx908::acc96, output_vec_len );
            case 97:  return makeRegisterExpression(amdgpu_gfx908::acc97, output_vec_len );
            case 98:  return makeRegisterExpression(amdgpu_gfx908::acc98, output_vec_len );
            case 99:  return makeRegisterExpression(amdgpu_gfx908::acc99, output_vec_len );
            case 100:  return makeRegisterExpression(amdgpu_gfx908::acc100, output_vec_len );
            case 101:  return makeRegisterExpression(amdgpu_gfx908::acc101, output_vec_len );
            case 102:  return makeRegisterExpression(amdgpu_gfx908::acc102, output_vec_len );
            case 103:  return makeRegisterExpression(amdgpu_gfx908::acc103, output_vec_len );
            case 104:  return makeRegisterExpression(amdgpu_gfx908::acc104, output_vec_len );
            case 105:  return makeRegisterExpression(amdgpu_gfx908::acc105, output_vec_len );
            case 106:  return makeRegisterExpression(amdgpu_gfx908::acc106, output_vec_len );
            case 107:  return makeRegisterExpression(amdgpu_gfx908::acc107, output_vec_len );
            case 108:  return makeRegisterExpression(amdgpu_gfx908::acc108, output_vec_len );
            case 109:  return makeRegisterExpression(amdgpu_gfx908::acc109, output_vec_len );
            case 110:  return makeRegisterExpression(amdgpu_gfx908::acc110, output_vec_len );
            case 111:  return makeRegisterExpression(amdgpu_gfx908::acc111, output_vec_len );
            case 112:  return makeRegisterExpression(amdgpu_gfx908::acc112, output_vec_len );
            case 113:  return makeRegisterExpression(amdgpu_gfx908::acc113, output_vec_len );
            case 114:  return makeRegisterExpression(amdgpu_gfx908::acc114, output_vec_len );
            case 115:  return makeRegisterExpression(amdgpu_gfx908::acc115, output_vec_len );
            case 116:  return makeRegisterExpression(amdgpu_gfx908::acc116, output_vec_len );
            case 117:  return makeRegisterExpression(amdgpu_gfx908::acc117, output_vec_len );
            case 118:  return makeRegisterExpression(amdgpu_gfx908::acc118, output_vec_len );
            case 119:  return makeRegisterExpression(amdgpu_gfx908::acc119, output_vec_len );
            case 120:  return makeRegisterExpression(amdgpu_gfx908::acc120, output_vec_len );
            case 121:  return makeRegisterExpression(amdgpu_gfx908::acc121, output_vec_len );
            case 122:  return makeRegisterExpression(amdgpu_gfx908::acc122, output_vec_len );
            case 123:  return makeRegisterExpression(amdgpu_gfx908::acc123, output_vec_len );
            case 124:  return makeRegisterExpression(amdgpu_gfx908::acc124, output_vec_len );
            case 125:  return makeRegisterExpression(amdgpu_gfx908::acc125, output_vec_len );
            case 126:  return makeRegisterExpression(amdgpu_gfx908::acc126, output_vec_len );
            case 127:  return makeRegisterExpression(amdgpu_gfx908::acc127, output_vec_len );
            case 128:  return makeRegisterExpression(amdgpu_gfx908::acc128, output_vec_len );
            case 129:  return makeRegisterExpression(amdgpu_gfx908::acc129, output_vec_len );
            case 130:  return makeRegisterExpression(amdgpu_gfx908::acc130, output_vec_len );
            case 131:  return makeRegisterExpression(amdgpu_gfx908::acc131, output_vec_len );
            case 132:  return makeRegisterExpression(amdgpu_gfx908::acc132, output_vec_len );
            case 133:  return makeRegisterExpression(amdgpu_gfx908::acc133, output_vec_len );
            case 134:  return makeRegisterExpression(amdgpu_gfx908::acc134, output_vec_len );
            case 135:  return makeRegisterExpression(amdgpu_gfx908::acc135, output_vec_len );
            case 136:  return makeRegisterExpression(amdgpu_gfx908::acc136, output_vec_len );
            case 137:  return makeRegisterExpression(amdgpu_gfx908::acc137, output_vec_len );
            case 138:  return makeRegisterExpression(amdgpu_gfx908::acc138, output_vec_len );
            case 139:  return makeRegisterExpression(amdgpu_gfx908::acc139, output_vec_len );
            case 140:  return makeRegisterExpression(amdgpu_gfx908::acc140, output_vec_len );
            case 141:  return makeRegisterExpression(amdgpu_gfx908::acc141, output_vec_len );
            case 142:  return makeRegisterExpression(amdgpu_gfx908::acc142, output_vec_len );
            case 143:  return makeRegisterExpression(amdgpu_gfx908::acc143, output_vec_len );
            case 144:  return makeRegisterExpression(amdgpu_gfx908::acc144, output_vec_len );
            case 145:  return makeRegisterExpression(amdgpu_gfx908::acc145, output_vec_len );
            case 146:  return makeRegisterExpression(amdgpu_gfx908::acc146, output_vec_len );
            case 147:  return makeRegisterExpression(amdgpu_gfx908::acc147, output_vec_len );
            case 148:  return makeRegisterExpression(amdgpu_gfx908::acc148, output_vec_len );
            case 149:  return makeRegisterExpression(amdgpu_gfx908::acc149, output_vec_len );
            case 150:  return makeRegisterExpression(amdgpu_gfx908::acc150, output_vec_len );
            case 151:  return makeRegisterExpression(amdgpu_gfx908::acc151, output_vec_len );
            case 152:  return makeRegisterExpression(amdgpu_gfx908::acc152, output_vec_len );
            case 153:  return makeRegisterExpression(amdgpu_gfx908::acc153, output_vec_len );
            case 154:  return makeRegisterExpression(amdgpu_gfx908::acc154, output_vec_len );
            case 155:  return makeRegisterExpression(amdgpu_gfx908::acc155, output_vec_len );
            case 156:  return makeRegisterExpression(amdgpu_gfx908::acc156, output_vec_len );
            case 157:  return makeRegisterExpression(amdgpu_gfx908::acc157, output_vec_len );
            case 158:  return makeRegisterExpression(amdgpu_gfx908::acc158, output_vec_len );
            case 159:  return makeRegisterExpression(amdgpu_gfx908::acc159, output_vec_len );
            case 160:  return makeRegisterExpression(amdgpu_gfx908::acc160, output_vec_len );
            case 161:  return makeRegisterExpression(amdgpu_gfx908::acc161, output_vec_len );
            case 162:  return makeRegisterExpression(amdgpu_gfx908::acc162, output_vec_len );
            case 163:  return makeRegisterExpression(amdgpu_gfx908::acc163, output_vec_len );
            case 164:  return makeRegisterExpression(amdgpu_gfx908::acc164, output_vec_len );
            case 165:  return makeRegisterExpression(amdgpu_gfx908::acc165, output_vec_len );
            case 166:  return makeRegisterExpression(amdgpu_gfx908::acc166, output_vec_len );
            case 167:  return makeRegisterExpression(amdgpu_gfx908::acc167, output_vec_len );
            case 168:  return makeRegisterExpression(amdgpu_gfx908::acc168, output_vec_len );
            case 169:  return makeRegisterExpression(amdgpu_gfx908::acc169, output_vec_len );
            case 170:  return makeRegisterExpression(amdgpu_gfx908::acc170, output_vec_len );
            case 171:  return makeRegisterExpression(amdgpu_gfx908::acc171, output_vec_len );
            case 172:  return makeRegisterExpression(amdgpu_gfx908::acc172, output_vec_len );
            case 173:  return makeRegisterExpression(amdgpu_gfx908::acc173, output_vec_len );
            case 174:  return makeRegisterExpression(amdgpu_gfx908::acc174, output_vec_len );
            case 175:  return makeRegisterExpression(amdgpu_gfx908::acc175, output_vec_len );
            case 176:  return makeRegisterExpression(amdgpu_gfx908::acc176, output_vec_len );
            case 177:  return makeRegisterExpression(amdgpu_gfx908::acc177, output_vec_len );
            case 178:  return makeRegisterExpression(amdgpu_gfx908::acc178, output_vec_len );
            case 179:  return makeRegisterExpression(amdgpu_gfx908::acc179, output_vec_len );
            case 180:  return makeRegisterExpression(amdgpu_gfx908::acc180, output_vec_len );
            case 181:  return makeRegisterExpression(amdgpu_gfx908::acc181, output_vec_len );
            case 182:  return makeRegisterExpression(amdgpu_gfx908::acc182, output_vec_len );
            case 183:  return makeRegisterExpression(amdgpu_gfx908::acc183, output_vec_len );
            case 184:  return makeRegisterExpression(amdgpu_gfx908::acc184, output_vec_len );
            case 185:  return makeRegisterExpression(amdgpu_gfx908::acc185, output_vec_len );
            case 186:  return makeRegisterExpression(amdgpu_gfx908::acc186, output_vec_len );
            case 187:  return makeRegisterExpression(amdgpu_gfx908::acc187, output_vec_len );
            case 188:  return makeRegisterExpression(amdgpu_gfx908::acc188, output_vec_len );
            case 189:  return makeRegisterExpression(amdgpu_gfx908::acc189, output_vec_len );
            case 190:  return makeRegisterExpression(amdgpu_gfx908::acc190, output_vec_len );
            case 191:  return makeRegisterExpression(amdgpu_gfx908::acc191, output_vec_len );
            case 192:  return makeRegisterExpression(amdgpu_gfx908::acc192, output_vec_len );
            case 193:  return makeRegisterExpression(amdgpu_gfx908::acc193, output_vec_len );
            case 194:  return makeRegisterExpression(amdgpu_gfx908::acc194, output_vec_len );
            case 195:  return makeRegisterExpression(amdgpu_gfx908::acc195, output_vec_len );
            case 196:  return makeRegisterExpression(amdgpu_gfx908::acc196, output_vec_len );
            case 197:  return makeRegisterExpression(amdgpu_gfx908::acc197, output_vec_len );
            case 198:  return makeRegisterExpression(amdgpu_gfx908::acc198, output_vec_len );
            case 199:  return makeRegisterExpression(amdgpu_gfx908::acc199, output_vec_len );
            case 200:  return makeRegisterExpression(amdgpu_gfx908::acc200, output_vec_len );
            case 201:  return makeRegisterExpression(amdgpu_gfx908::acc201, output_vec_len );
            case 202:  return makeRegisterExpression(amdgpu_gfx908::acc202, output_vec_len );
            case 203:  return makeRegisterExpression(amdgpu_gfx908::acc203, output_vec_len );
            case 204:  return makeRegisterExpression(amdgpu_gfx908::acc204, output_vec_len );
            case 205:  return makeRegisterExpression(amdgpu_gfx908::acc205, output_vec_len );
            case 206:  return makeRegisterExpression(amdgpu_gfx908::acc206, output_vec_len );
            case 207:  return makeRegisterExpression(amdgpu_gfx908::acc207, output_vec_len );
            case 208:  return makeRegisterExpression(amdgpu_gfx908::acc208, output_vec_len );
            case 209:  return makeRegisterExpression(amdgpu_gfx908::acc209, output_vec_len );
            case 210:  return makeRegisterExpression(amdgpu_gfx908::acc210, output_vec_len );
            case 211:  return makeRegisterExpression(amdgpu_gfx908::acc211, output_vec_len );
            case 212:  return makeRegisterExpression(amdgpu_gfx908::acc212, output_vec_len );
            case 213:  return makeRegisterExpression(amdgpu_gfx908::acc213, output_vec_len );
            case 214:  return makeRegisterExpression(amdgpu_gfx908::acc214, output_vec_len );
            case 215:  return makeRegisterExpression(amdgpu_gfx908::acc215, output_vec_len );
            case 216:  return makeRegisterExpression(amdgpu_gfx908::acc216, output_vec_len );
            case 217:  return makeRegisterExpression(amdgpu_gfx908::acc217, output_vec_len );
            case 218:  return makeRegisterExpression(amdgpu_gfx908::acc218, output_vec_len );
            case 219:  return makeRegisterExpression(amdgpu_gfx908::acc219, output_vec_len );
            case 220:  return makeRegisterExpression(amdgpu_gfx908::acc220, output_vec_len );
            case 221:  return makeRegisterExpression(amdgpu_gfx908::acc221, output_vec_len );
            case 222:  return makeRegisterExpression(amdgpu_gfx908::acc222, output_vec_len );
            case 223:  return makeRegisterExpression(amdgpu_gfx908::acc223, output_vec_len );
            case 224:  return makeRegisterExpression(amdgpu_gfx908::acc224, output_vec_len );
            case 225:  return makeRegisterExpression(amdgpu_gfx908::acc225, output_vec_len );
            case 226:  return makeRegisterExpression(amdgpu_gfx908::acc226, output_vec_len );
            case 227:  return makeRegisterExpression(amdgpu_gfx908::acc227, output_vec_len );
            case 228:  return makeRegisterExpression(amdgpu_gfx908::acc228, output_vec_len );
            case 229:  return makeRegisterExpression(amdgpu_gfx908::acc229, output_vec_len );
            case 230:  return makeRegisterExpression(amdgpu_gfx908::acc230, output_vec_len );
            case 231:  return makeRegisterExpression(amdgpu_gfx908::acc231, output_vec_len );
            case 232:  return makeRegisterExpression(amdgpu_gfx908::acc232, output_vec_len );
            case 233:  return makeRegisterExpression(amdgpu_gfx908::acc233, output_vec_len );
            case 234:  return makeRegisterExpression(amdgpu_gfx908::acc234, output_vec_len );
            case 235:  return makeRegisterExpression(amdgpu_gfx908::acc235, output_vec_len );
            case 236:  return makeRegisterExpression(amdgpu_gfx908::acc236, output_vec_len );
            case 237:  return makeRegisterExpression(amdgpu_gfx908::acc237, output_vec_len );
            case 238:  return makeRegisterExpression(amdgpu_gfx908::acc238, output_vec_len );
            case 239:  return makeRegisterExpression(amdgpu_gfx908::acc239, output_vec_len );
            case 240:  return makeRegisterExpression(amdgpu_gfx908::acc240, output_vec_len );
            case 241:  return makeRegisterExpression(amdgpu_gfx908::acc241, output_vec_len );
            case 242:  return makeRegisterExpression(amdgpu_gfx908::acc242, output_vec_len );
            case 243:  return makeRegisterExpression(amdgpu_gfx908::acc243, output_vec_len );
            case 244:  return makeRegisterExpression(amdgpu_gfx908::acc244, output_vec_len );
            case 245:  return makeRegisterExpression(amdgpu_gfx908::acc245, output_vec_len );
            case 246:  return makeRegisterExpression(amdgpu_gfx908::acc246, output_vec_len );
            case 247:  return makeRegisterExpression(amdgpu_gfx908::acc247, output_vec_len );
            case 248:  return makeRegisterExpression(amdgpu_gfx908::acc248, output_vec_len );
            case 249:  return makeRegisterExpression(amdgpu_gfx908::acc249, output_vec_len );
            case 250:  return makeRegisterExpression(amdgpu_gfx908::acc250, output_vec_len );
            case 251:  return makeRegisterExpression(amdgpu_gfx908::acc251, output_vec_len );
            case 252:  return makeRegisterExpression(amdgpu_gfx908::acc252, output_vec_len );
            case 253:  return makeRegisterExpression(amdgpu_gfx908::acc253, output_vec_len );
            case 254:  return makeRegisterExpression(amdgpu_gfx908::acc254, output_vec_len );
            case 255:  return makeRegisterExpression(amdgpu_gfx908::acc255, output_vec_len );
            case 768:  return makeRegisterExpression(amdgpu_gfx908::acc0, output_vec_len );
            case 769:  return makeRegisterExpression(amdgpu_gfx908::acc1, output_vec_len );
            case 770:  return makeRegisterExpression(amdgpu_gfx908::acc2, output_vec_len );
            case 771:  return makeRegisterExpression(amdgpu_gfx908::acc3, output_vec_len );
            case 772:  return makeRegisterExpression(amdgpu_gfx908::acc4, output_vec_len );
            case 773:  return makeRegisterExpression(amdgpu_gfx908::acc5, output_vec_len );
            case 774:  return makeRegisterExpression(amdgpu_gfx908::acc6, output_vec_len );
            case 775:  return makeRegisterExpression(amdgpu_gfx908::acc7, output_vec_len );
            case 776:  return makeRegisterExpression(amdgpu_gfx908::acc8, output_vec_len );
            case 777:  return makeRegisterExpression(amdgpu_gfx908::acc9, output_vec_len );
            case 778:  return makeRegisterExpression(amdgpu_gfx908::acc10, output_vec_len );
            case 779:  return makeRegisterExpression(amdgpu_gfx908::acc11, output_vec_len );
            case 780:  return makeRegisterExpression(amdgpu_gfx908::acc12, output_vec_len );
            case 781:  return makeRegisterExpression(amdgpu_gfx908::acc13, output_vec_len );
            case 782:  return makeRegisterExpression(amdgpu_gfx908::acc14, output_vec_len );
            case 783:  return makeRegisterExpression(amdgpu_gfx908::acc15, output_vec_len );
            case 784:  return makeRegisterExpression(amdgpu_gfx908::acc16, output_vec_len );
            case 785:  return makeRegisterExpression(amdgpu_gfx908::acc17, output_vec_len );
            case 786:  return makeRegisterExpression(amdgpu_gfx908::acc18, output_vec_len );
            case 787:  return makeRegisterExpression(amdgpu_gfx908::acc19, output_vec_len );
            case 788:  return makeRegisterExpression(amdgpu_gfx908::acc20, output_vec_len );
            case 789:  return makeRegisterExpression(amdgpu_gfx908::acc21, output_vec_len );
            case 790:  return makeRegisterExpression(amdgpu_gfx908::acc22, output_vec_len );
            case 791:  return makeRegisterExpression(amdgpu_gfx908::acc23, output_vec_len );
            case 792:  return makeRegisterExpression(amdgpu_gfx908::acc24, output_vec_len );
            case 793:  return makeRegisterExpression(amdgpu_gfx908::acc25, output_vec_len );
            case 794:  return makeRegisterExpression(amdgpu_gfx908::acc26, output_vec_len );
            case 795:  return makeRegisterExpression(amdgpu_gfx908::acc27, output_vec_len );
            case 796:  return makeRegisterExpression(amdgpu_gfx908::acc28, output_vec_len );
            case 797:  return makeRegisterExpression(amdgpu_gfx908::acc29, output_vec_len );
            case 798:  return makeRegisterExpression(amdgpu_gfx908::acc30, output_vec_len );
            case 799:  return makeRegisterExpression(amdgpu_gfx908::acc31, output_vec_len );
            case 800:  return makeRegisterExpression(amdgpu_gfx908::acc32, output_vec_len );
            case 801:  return makeRegisterExpression(amdgpu_gfx908::acc33, output_vec_len );
            case 802:  return makeRegisterExpression(amdgpu_gfx908::acc34, output_vec_len );
            case 803:  return makeRegisterExpression(amdgpu_gfx908::acc35, output_vec_len );
            case 804:  return makeRegisterExpression(amdgpu_gfx908::acc36, output_vec_len );
            case 805:  return makeRegisterExpression(amdgpu_gfx908::acc37, output_vec_len );
            case 806:  return makeRegisterExpression(amdgpu_gfx908::acc38, output_vec_len );
            case 807:  return makeRegisterExpression(amdgpu_gfx908::acc39, output_vec_len );
            case 808:  return makeRegisterExpression(amdgpu_gfx908::acc40, output_vec_len );
            case 809:  return makeRegisterExpression(amdgpu_gfx908::acc41, output_vec_len );
            case 810:  return makeRegisterExpression(amdgpu_gfx908::acc42, output_vec_len );
            case 811:  return makeRegisterExpression(amdgpu_gfx908::acc43, output_vec_len );
            case 812:  return makeRegisterExpression(amdgpu_gfx908::acc44, output_vec_len );
            case 813:  return makeRegisterExpression(amdgpu_gfx908::acc45, output_vec_len );
            case 814:  return makeRegisterExpression(amdgpu_gfx908::acc46, output_vec_len );
            case 815:  return makeRegisterExpression(amdgpu_gfx908::acc47, output_vec_len );
            case 816:  return makeRegisterExpression(amdgpu_gfx908::acc48, output_vec_len );
            case 817:  return makeRegisterExpression(amdgpu_gfx908::acc49, output_vec_len );
            case 818:  return makeRegisterExpression(amdgpu_gfx908::acc50, output_vec_len );
            case 819:  return makeRegisterExpression(amdgpu_gfx908::acc51, output_vec_len );
            case 820:  return makeRegisterExpression(amdgpu_gfx908::acc52, output_vec_len );
            case 821:  return makeRegisterExpression(amdgpu_gfx908::acc53, output_vec_len );
            case 822:  return makeRegisterExpression(amdgpu_gfx908::acc54, output_vec_len );
            case 823:  return makeRegisterExpression(amdgpu_gfx908::acc55, output_vec_len );
            case 824:  return makeRegisterExpression(amdgpu_gfx908::acc56, output_vec_len );
            case 825:  return makeRegisterExpression(amdgpu_gfx908::acc57, output_vec_len );
            case 826:  return makeRegisterExpression(amdgpu_gfx908::acc58, output_vec_len );
            case 827:  return makeRegisterExpression(amdgpu_gfx908::acc59, output_vec_len );
            case 828:  return makeRegisterExpression(amdgpu_gfx908::acc60, output_vec_len );
            case 829:  return makeRegisterExpression(amdgpu_gfx908::acc61, output_vec_len );
            case 830:  return makeRegisterExpression(amdgpu_gfx908::acc62, output_vec_len );
            case 831:  return makeRegisterExpression(amdgpu_gfx908::acc63, output_vec_len );
            case 832:  return makeRegisterExpression(amdgpu_gfx908::acc64, output_vec_len );
            case 833:  return makeRegisterExpression(amdgpu_gfx908::acc65, output_vec_len );
            case 834:  return makeRegisterExpression(amdgpu_gfx908::acc66, output_vec_len );
            case 835:  return makeRegisterExpression(amdgpu_gfx908::acc67, output_vec_len );
            case 836:  return makeRegisterExpression(amdgpu_gfx908::acc68, output_vec_len );
            case 837:  return makeRegisterExpression(amdgpu_gfx908::acc69, output_vec_len );
            case 838:  return makeRegisterExpression(amdgpu_gfx908::acc70, output_vec_len );
            case 839:  return makeRegisterExpression(amdgpu_gfx908::acc71, output_vec_len );
            case 840:  return makeRegisterExpression(amdgpu_gfx908::acc72, output_vec_len );
            case 841:  return makeRegisterExpression(amdgpu_gfx908::acc73, output_vec_len );
            case 842:  return makeRegisterExpression(amdgpu_gfx908::acc74, output_vec_len );
            case 843:  return makeRegisterExpression(amdgpu_gfx908::acc75, output_vec_len );
            case 844:  return makeRegisterExpression(amdgpu_gfx908::acc76, output_vec_len );
            case 845:  return makeRegisterExpression(amdgpu_gfx908::acc77, output_vec_len );
            case 846:  return makeRegisterExpression(amdgpu_gfx908::acc78, output_vec_len );
            case 847:  return makeRegisterExpression(amdgpu_gfx908::acc79, output_vec_len );
            case 848:  return makeRegisterExpression(amdgpu_gfx908::acc80, output_vec_len );
            case 849:  return makeRegisterExpression(amdgpu_gfx908::acc81, output_vec_len );
            case 850:  return makeRegisterExpression(amdgpu_gfx908::acc82, output_vec_len );
            case 851:  return makeRegisterExpression(amdgpu_gfx908::acc83, output_vec_len );
            case 852:  return makeRegisterExpression(amdgpu_gfx908::acc84, output_vec_len );
            case 853:  return makeRegisterExpression(amdgpu_gfx908::acc85, output_vec_len );
            case 854:  return makeRegisterExpression(amdgpu_gfx908::acc86, output_vec_len );
            case 855:  return makeRegisterExpression(amdgpu_gfx908::acc87, output_vec_len );
            case 856:  return makeRegisterExpression(amdgpu_gfx908::acc88, output_vec_len );
            case 857:  return makeRegisterExpression(amdgpu_gfx908::acc89, output_vec_len );
            case 858:  return makeRegisterExpression(amdgpu_gfx908::acc90, output_vec_len );
            case 859:  return makeRegisterExpression(amdgpu_gfx908::acc91, output_vec_len );
            case 860:  return makeRegisterExpression(amdgpu_gfx908::acc92, output_vec_len );
            case 861:  return makeRegisterExpression(amdgpu_gfx908::acc93, output_vec_len );
            case 862:  return makeRegisterExpression(amdgpu_gfx908::acc94, output_vec_len );
            case 863:  return makeRegisterExpression(amdgpu_gfx908::acc95, output_vec_len );
            case 864:  return makeRegisterExpression(amdgpu_gfx908::acc96, output_vec_len );
            case 865:  return makeRegisterExpression(amdgpu_gfx908::acc97, output_vec_len );
            case 866:  return makeRegisterExpression(amdgpu_gfx908::acc98, output_vec_len );
            case 867:  return makeRegisterExpression(amdgpu_gfx908::acc99, output_vec_len );
            case 868:  return makeRegisterExpression(amdgpu_gfx908::acc100, output_vec_len );
            case 869:  return makeRegisterExpression(amdgpu_gfx908::acc101, output_vec_len );
            case 870:  return makeRegisterExpression(amdgpu_gfx908::acc102, output_vec_len );
            case 871:  return makeRegisterExpression(amdgpu_gfx908::acc103, output_vec_len );
            case 872:  return makeRegisterExpression(amdgpu_gfx908::acc104, output_vec_len );
            case 873:  return makeRegisterExpression(amdgpu_gfx908::acc105, output_vec_len );
            case 874:  return makeRegisterExpression(amdgpu_gfx908::acc106, output_vec_len );
            case 875:  return makeRegisterExpression(amdgpu_gfx908::acc107, output_vec_len );
            case 876:  return makeRegisterExpression(amdgpu_gfx908::acc108, output_vec_len );
            case 877:  return makeRegisterExpression(amdgpu_gfx908::acc109, output_vec_len );
            case 878:  return makeRegisterExpression(amdgpu_gfx908::acc110, output_vec_len );
            case 879:  return makeRegisterExpression(amdgpu_gfx908::acc111, output_vec_len );
            case 880:  return makeRegisterExpression(amdgpu_gfx908::acc112, output_vec_len );
            case 881:  return makeRegisterExpression(amdgpu_gfx908::acc113, output_vec_len );
            case 882:  return makeRegisterExpression(amdgpu_gfx908::acc114, output_vec_len );
            case 883:  return makeRegisterExpression(amdgpu_gfx908::acc115, output_vec_len );
            case 884:  return makeRegisterExpression(amdgpu_gfx908::acc116, output_vec_len );
            case 885:  return makeRegisterExpression(amdgpu_gfx908::acc117, output_vec_len );
            case 886:  return makeRegisterExpression(amdgpu_gfx908::acc118, output_vec_len );
            case 887:  return makeRegisterExpression(amdgpu_gfx908::acc119, output_vec_len );
            case 888:  return makeRegisterExpression(amdgpu_gfx908::acc120, output_vec_len );
            case 889:  return makeRegisterExpression(amdgpu_gfx908::acc121, output_vec_len );
            case 890:  return makeRegisterExpression(amdgpu_gfx908::acc122, output_vec_len );
            case 891:  return makeRegisterExpression(amdgpu_gfx908::acc123, output_vec_len );
            case 892:  return makeRegisterExpression(amdgpu_gfx908::acc124, output_vec_len );
            case 893:  return makeRegisterExpression(amdgpu_gfx908::acc125, output_vec_len );
            case 894:  return makeRegisterExpression(amdgpu_gfx908::acc126, output_vec_len );
            case 895:  return makeRegisterExpression(amdgpu_gfx908::acc127, output_vec_len );
            case 896:  return makeRegisterExpression(amdgpu_gfx908::acc128, output_vec_len );
            case 897:  return makeRegisterExpression(amdgpu_gfx908::acc129, output_vec_len );
            case 898:  return makeRegisterExpression(amdgpu_gfx908::acc130, output_vec_len );
            case 899:  return makeRegisterExpression(amdgpu_gfx908::acc131, output_vec_len );
            case 900:  return makeRegisterExpression(amdgpu_gfx908::acc132, output_vec_len );
            case 901:  return makeRegisterExpression(amdgpu_gfx908::acc133, output_vec_len );
            case 902:  return makeRegisterExpression(amdgpu_gfx908::acc134, output_vec_len );
            case 903:  return makeRegisterExpression(amdgpu_gfx908::acc135, output_vec_len );
            case 904:  return makeRegisterExpression(amdgpu_gfx908::acc136, output_vec_len );
            case 905:  return makeRegisterExpression(amdgpu_gfx908::acc137, output_vec_len );
            case 906:  return makeRegisterExpression(amdgpu_gfx908::acc138, output_vec_len );
            case 907:  return makeRegisterExpression(amdgpu_gfx908::acc139, output_vec_len );
            case 908:  return makeRegisterExpression(amdgpu_gfx908::acc140, output_vec_len );
            case 909:  return makeRegisterExpression(amdgpu_gfx908::acc141, output_vec_len );
            case 910:  return makeRegisterExpression(amdgpu_gfx908::acc142, output_vec_len );
            case 911:  return makeRegisterExpression(amdgpu_gfx908::acc143, output_vec_len );
            case 912:  return makeRegisterExpression(amdgpu_gfx908::acc144, output_vec_len );
            case 913:  return makeRegisterExpression(amdgpu_gfx908::acc145, output_vec_len );
            case 914:  return makeRegisterExpression(amdgpu_gfx908::acc146, output_vec_len );
            case 915:  return makeRegisterExpression(amdgpu_gfx908::acc147, output_vec_len );
            case 916:  return makeRegisterExpression(amdgpu_gfx908::acc148, output_vec_len );
            case 917:  return makeRegisterExpression(amdgpu_gfx908::acc149, output_vec_len );
            case 918:  return makeRegisterExpression(amdgpu_gfx908::acc150, output_vec_len );
            case 919:  return makeRegisterExpression(amdgpu_gfx908::acc151, output_vec_len );
            case 920:  return makeRegisterExpression(amdgpu_gfx908::acc152, output_vec_len );
            case 921:  return makeRegisterExpression(amdgpu_gfx908::acc153, output_vec_len );
            case 922:  return makeRegisterExpression(amdgpu_gfx908::acc154, output_vec_len );
            case 923:  return makeRegisterExpression(amdgpu_gfx908::acc155, output_vec_len );
            case 924:  return makeRegisterExpression(amdgpu_gfx908::acc156, output_vec_len );
            case 925:  return makeRegisterExpression(amdgpu_gfx908::acc157, output_vec_len );
            case 926:  return makeRegisterExpression(amdgpu_gfx908::acc158, output_vec_len );
            case 927:  return makeRegisterExpression(amdgpu_gfx908::acc159, output_vec_len );
            case 928:  return makeRegisterExpression(amdgpu_gfx908::acc160, output_vec_len );
            case 929:  return makeRegisterExpression(amdgpu_gfx908::acc161, output_vec_len );
            case 930:  return makeRegisterExpression(amdgpu_gfx908::acc162, output_vec_len );
            case 931:  return makeRegisterExpression(amdgpu_gfx908::acc163, output_vec_len );
            case 932:  return makeRegisterExpression(amdgpu_gfx908::acc164, output_vec_len );
            case 933:  return makeRegisterExpression(amdgpu_gfx908::acc165, output_vec_len );
            case 934:  return makeRegisterExpression(amdgpu_gfx908::acc166, output_vec_len );
            case 935:  return makeRegisterExpression(amdgpu_gfx908::acc167, output_vec_len );
            case 936:  return makeRegisterExpression(amdgpu_gfx908::acc168, output_vec_len );
            case 937:  return makeRegisterExpression(amdgpu_gfx908::acc169, output_vec_len );
            case 938:  return makeRegisterExpression(amdgpu_gfx908::acc170, output_vec_len );
            case 939:  return makeRegisterExpression(amdgpu_gfx908::acc171, output_vec_len );
            case 940:  return makeRegisterExpression(amdgpu_gfx908::acc172, output_vec_len );
            case 941:  return makeRegisterExpression(amdgpu_gfx908::acc173, output_vec_len );
            case 942:  return makeRegisterExpression(amdgpu_gfx908::acc174, output_vec_len );
            case 943:  return makeRegisterExpression(amdgpu_gfx908::acc175, output_vec_len );
            case 944:  return makeRegisterExpression(amdgpu_gfx908::acc176, output_vec_len );
            case 945:  return makeRegisterExpression(amdgpu_gfx908::acc177, output_vec_len );
            case 946:  return makeRegisterExpression(amdgpu_gfx908::acc178, output_vec_len );
            case 947:  return makeRegisterExpression(amdgpu_gfx908::acc179, output_vec_len );
            case 948:  return makeRegisterExpression(amdgpu_gfx908::acc180, output_vec_len );
            case 949:  return makeRegisterExpression(amdgpu_gfx908::acc181, output_vec_len );
            case 950:  return makeRegisterExpression(amdgpu_gfx908::acc182, output_vec_len );
            case 951:  return makeRegisterExpression(amdgpu_gfx908::acc183, output_vec_len );
            case 952:  return makeRegisterExpression(amdgpu_gfx908::acc184, output_vec_len );
            case 953:  return makeRegisterExpression(amdgpu_gfx908::acc185, output_vec_len );
            case 954:  return makeRegisterExpression(amdgpu_gfx908::acc186, output_vec_len );
            case 955:  return makeRegisterExpression(amdgpu_gfx908::acc187, output_vec_len );
            case 956:  return makeRegisterExpression(amdgpu_gfx908::acc188, output_vec_len );
            case 957:  return makeRegisterExpression(amdgpu_gfx908::acc189, output_vec_len );
            case 958:  return makeRegisterExpression(amdgpu_gfx908::acc190, output_vec_len );
            case 959:  return makeRegisterExpression(amdgpu_gfx908::acc191, output_vec_len );
            case 960:  return makeRegisterExpression(amdgpu_gfx908::acc192, output_vec_len );
            case 961:  return makeRegisterExpression(amdgpu_gfx908::acc193, output_vec_len );
            case 962:  return makeRegisterExpression(amdgpu_gfx908::acc194, output_vec_len );
            case 963:  return makeRegisterExpression(amdgpu_gfx908::acc195, output_vec_len );
            case 964:  return makeRegisterExpression(amdgpu_gfx908::acc196, output_vec_len );
            case 965:  return makeRegisterExpression(amdgpu_gfx908::acc197, output_vec_len );
            case 966:  return makeRegisterExpression(amdgpu_gfx908::acc198, output_vec_len );
            case 967:  return makeRegisterExpression(amdgpu_gfx908::acc199, output_vec_len );
            case 968:  return makeRegisterExpression(amdgpu_gfx908::acc200, output_vec_len );
            case 969:  return makeRegisterExpression(amdgpu_gfx908::acc201, output_vec_len );
            case 970:  return makeRegisterExpression(amdgpu_gfx908::acc202, output_vec_len );
            case 971:  return makeRegisterExpression(amdgpu_gfx908::acc203, output_vec_len );
            case 972:  return makeRegisterExpression(amdgpu_gfx908::acc204, output_vec_len );
            case 973:  return makeRegisterExpression(amdgpu_gfx908::acc205, output_vec_len );
            case 974:  return makeRegisterExpression(amdgpu_gfx908::acc206, output_vec_len );
            case 975:  return makeRegisterExpression(amdgpu_gfx908::acc207, output_vec_len );
            case 976:  return makeRegisterExpression(amdgpu_gfx908::acc208, output_vec_len );
            case 977:  return makeRegisterExpression(amdgpu_gfx908::acc209, output_vec_len );
            case 978:  return makeRegisterExpression(amdgpu_gfx908::acc210, output_vec_len );
            case 979:  return makeRegisterExpression(amdgpu_gfx908::acc211, output_vec_len );
            case 980:  return makeRegisterExpression(amdgpu_gfx908::acc212, output_vec_len );
            case 981:  return makeRegisterExpression(amdgpu_gfx908::acc213, output_vec_len );
            case 982:  return makeRegisterExpression(amdgpu_gfx908::acc214, output_vec_len );
            case 983:  return makeRegisterExpression(amdgpu_gfx908::acc215, output_vec_len );
            case 984:  return makeRegisterExpression(amdgpu_gfx908::acc216, output_vec_len );
            case 985:  return makeRegisterExpression(amdgpu_gfx908::acc217, output_vec_len );
            case 986:  return makeRegisterExpression(amdgpu_gfx908::acc218, output_vec_len );
            case 987:  return makeRegisterExpression(amdgpu_gfx908::acc219, output_vec_len );
            case 988:  return makeRegisterExpression(amdgpu_gfx908::acc220, output_vec_len );
            case 989:  return makeRegisterExpression(amdgpu_gfx908::acc221, output_vec_len );
            case 990:  return makeRegisterExpression(amdgpu_gfx908::acc222, output_vec_len );
            case 991:  return makeRegisterExpression(amdgpu_gfx908::acc223, output_vec_len );
            case 992:  return makeRegisterExpression(amdgpu_gfx908::acc224, output_vec_len );
            case 993:  return makeRegisterExpression(amdgpu_gfx908::acc225, output_vec_len );
            case 994:  return makeRegisterExpression(amdgpu_gfx908::acc226, output_vec_len );
            case 995:  return makeRegisterExpression(amdgpu_gfx908::acc227, output_vec_len );
            case 996:  return makeRegisterExpression(amdgpu_gfx908::acc228, output_vec_len );
            case 997:  return makeRegisterExpression(amdgpu_gfx908::acc229, output_vec_len );
            case 998:  return makeRegisterExpression(amdgpu_gfx908::acc230, output_vec_len );
            case 999:  return makeRegisterExpression(amdgpu_gfx908::acc231, output_vec_len );
            case 1000:  return makeRegisterExpression(amdgpu_gfx908::acc232, output_vec_len );
            case 1001:  return makeRegisterExpression(amdgpu_gfx908::acc233, output_vec_len );
            case 1002:  return makeRegisterExpression(amdgpu_gfx908::acc234, output_vec_len );
            case 1003:  return makeRegisterExpression(amdgpu_gfx908::acc235, output_vec_len );
            case 1004:  return makeRegisterExpression(amdgpu_gfx908::acc236, output_vec_len );
            case 1005:  return makeRegisterExpression(amdgpu_gfx908::acc237, output_vec_len );
            case 1006:  return makeRegisterExpression(amdgpu_gfx908::acc238, output_vec_len );
            case 1007:  return makeRegisterExpression(amdgpu_gfx908::acc239, output_vec_len );
            case 1008:  return makeRegisterExpression(amdgpu_gfx908::acc240, output_vec_len );
            case 1009:  return makeRegisterExpression(amdgpu_gfx908::acc241, output_vec_len );
            case 1010:  return makeRegisterExpression(amdgpu_gfx908::acc242, output_vec_len );
            case 1011:  return makeRegisterExpression(amdgpu_gfx908::acc243, output_vec_len );
            case 1012:  return makeRegisterExpression(amdgpu_gfx908::acc244, output_vec_len );
            case 1013:  return makeRegisterExpression(amdgpu_gfx908::acc245, output_vec_len );
            case 1014:  return makeRegisterExpression(amdgpu_gfx908::acc246, output_vec_len );
            case 1015:  return makeRegisterExpression(amdgpu_gfx908::acc247, output_vec_len );
            case 1016:  return makeRegisterExpression(amdgpu_gfx908::acc248, output_vec_len );
            case 1017:  return makeRegisterExpression(amdgpu_gfx908::acc249, output_vec_len );
            case 1018:  return makeRegisterExpression(amdgpu_gfx908::acc250, output_vec_len );
            case 1019:  return makeRegisterExpression(amdgpu_gfx908::acc251, output_vec_len );
            case 1020:  return makeRegisterExpression(amdgpu_gfx908::acc252, output_vec_len );
            case 1021:  return makeRegisterExpression(amdgpu_gfx908::acc253, output_vec_len );
            case 1022:  return makeRegisterExpression(amdgpu_gfx908::acc254, output_vec_len );
            case 1023:  return makeRegisterExpression(amdgpu_gfx908::acc255, output_vec_len );
            default: return makeRegisterExpression(amdgpu_gfx908::invalid);
        }
    }

    Expression::Ptr InstructionDecoder_amdgpu_gfx908::decodeOPR_ATTR(uint64_t input, uint32_t output_vec_len)
    {
        switch (input)  {
            case 0:  return makeRegisterExpression(amdgpu_gfx908::attr0, output_vec_len );
            case 1:  return makeRegisterExpression(amdgpu_gfx908::attr1, output_vec_len );
            case 2:  return makeRegisterExpression(amdgpu_gfx908::attr2, output_vec_len );
            case 3:  return makeRegisterExpression(amdgpu_gfx908::attr3, output_vec_len );
            case 4:  return makeRegisterExpression(amdgpu_gfx908::attr4, output_vec_len );
            case 5:  return makeRegisterExpression(amdgpu_gfx908::attr5, output_vec_len );
            case 6:  return makeRegisterExpression(amdgpu_gfx908::attr6, output_vec_len );
            case 7:  return makeRegisterExpression(amdgpu_gfx908::attr7, output_vec_len );
            case 8:  return makeRegisterExpression(amdgpu_gfx908::attr8, output_vec_len );
            case 9:  return makeRegisterExpression(amdgpu_gfx908::attr9, output_vec_len );
            case 10:  return makeRegisterExpression(amdgpu_gfx908::attr10, output_vec_len );
            case 11:  return makeRegisterExpression(amdgpu_gfx908::attr11, output_vec_len );
            case 12:  return makeRegisterExpression(amdgpu_gfx908::attr12, output_vec_len );
            case 13:  return makeRegisterExpression(amdgpu_gfx908::attr13, output_vec_len );
            case 14:  return makeRegisterExpression(amdgpu_gfx908::attr14, output_vec_len );
            case 15:  return makeRegisterExpression(amdgpu_gfx908::attr15, output_vec_len );
            case 16:  return makeRegisterExpression(amdgpu_gfx908::attr16, output_vec_len );
            case 17:  return makeRegisterExpression(amdgpu_gfx908::attr17, output_vec_len );
            case 18:  return makeRegisterExpression(amdgpu_gfx908::attr18, output_vec_len );
            case 19:  return makeRegisterExpression(amdgpu_gfx908::attr19, output_vec_len );
            case 20:  return makeRegisterExpression(amdgpu_gfx908::attr20, output_vec_len );
            case 21:  return makeRegisterExpression(amdgpu_gfx908::attr21, output_vec_len );
            case 22:  return makeRegisterExpression(amdgpu_gfx908::attr22, output_vec_len );
            case 23:  return makeRegisterExpression(amdgpu_gfx908::attr23, output_vec_len );
            case 24:  return makeRegisterExpression(amdgpu_gfx908::attr24, output_vec_len );
            case 25:  return makeRegisterExpression(amdgpu_gfx908::attr25, output_vec_len );
            case 26:  return makeRegisterExpression(amdgpu_gfx908::attr26, output_vec_len );
            case 27:  return makeRegisterExpression(amdgpu_gfx908::attr27, output_vec_len );
            case 28:  return makeRegisterExpression(amdgpu_gfx908::attr28, output_vec_len );
            case 29:  return makeRegisterExpression(amdgpu_gfx908::attr29, output_vec_len );
            case 30:  return makeRegisterExpression(amdgpu_gfx908::attr30, output_vec_len );
            case 31:  return makeRegisterExpression(amdgpu_gfx908::attr31, output_vec_len );
            case 32:  return makeRegisterExpression(amdgpu_gfx908::attr32, output_vec_len );
            default: return makeRegisterExpression(amdgpu_gfx908::invalid);
        }
    }

    Expression::Ptr InstructionDecoder_amdgpu_gfx908::decodeOPR_DSMEM(uint64_t input, uint32_t output_vec_len)
    {
        switch (input)  {
            case 0:  return makeRegisterExpression(amdgpu_gfx908::dsmem, output_vec_len );
            default: return makeRegisterExpression(amdgpu_gfx908::invalid);
        }
    }

    Expression::Ptr InstructionDecoder_amdgpu_gfx908::decodeOPR_FLAT_SCRATCH(uint64_t input, uint32_t output_vec_len)
    {
        switch (input)  {
            case 0:  return makeRegisterExpression(amdgpu_gfx908::flat_scratch_all, output_vec_len );
            default: return makeRegisterExpression(amdgpu_gfx908::invalid);
        }
    }

    Expression::Ptr InstructionDecoder_amdgpu_gfx908::decodeOPR_PARAM(uint64_t input, uint32_t output_vec_len)
    {
        switch (input)  {
            case 0:  return makeRegisterExpression(amdgpu_gfx908::p10, output_vec_len );
            case 1:  return makeRegisterExpression(amdgpu_gfx908::p20, output_vec_len );
            case 2:  return makeRegisterExpression(amdgpu_gfx908::p0, output_vec_len );
            default: return makeRegisterExpression(amdgpu_gfx908::invalid);
        }
    }

    Expression::Ptr InstructionDecoder_amdgpu_gfx908::decodeOPR_PC(uint64_t input, uint32_t )
    {
        switch (input)  {
            case 0:  return makeRegisterExpression(amdgpu_gfx908::pc_all);
            default: return makeRegisterExpression(amdgpu_gfx908::invalid);
        }
    }

    Expression::Ptr InstructionDecoder_amdgpu_gfx908::decodeOPR_SDST(uint64_t input, uint32_t output_vec_len)
    {
        switch (input)  {
            case 0:  return makeRegisterExpression(amdgpu_gfx908::s0, output_vec_len );
            case 1:  return makeRegisterExpression(amdgpu_gfx908::s1, output_vec_len );
            case 2:  return makeRegisterExpression(amdgpu_gfx908::s2, output_vec_len );
            case 3:  return makeRegisterExpression(amdgpu_gfx908::s3, output_vec_len );
            case 4:  return makeRegisterExpression(amdgpu_gfx908::s4, output_vec_len );
            case 5:  return makeRegisterExpression(amdgpu_gfx908::s5, output_vec_len );
            case 6:  return makeRegisterExpression(amdgpu_gfx908::s6, output_vec_len );
            case 7:  return makeRegisterExpression(amdgpu_gfx908::s7, output_vec_len );
            case 8:  return makeRegisterExpression(amdgpu_gfx908::s8, output_vec_len );
            case 9:  return makeRegisterExpression(amdgpu_gfx908::s9, output_vec_len );
            case 10:  return makeRegisterExpression(amdgpu_gfx908::s10, output_vec_len );
            case 11:  return makeRegisterExpression(amdgpu_gfx908::s11, output_vec_len );
            case 12:  return makeRegisterExpression(amdgpu_gfx908::s12, output_vec_len );
            case 13:  return makeRegisterExpression(amdgpu_gfx908::s13, output_vec_len );
            case 14:  return makeRegisterExpression(amdgpu_gfx908::s14, output_vec_len );
            case 15:  return makeRegisterExpression(amdgpu_gfx908::s15, output_vec_len );
            case 16:  return makeRegisterExpression(amdgpu_gfx908::s16, output_vec_len );
            case 17:  return makeRegisterExpression(amdgpu_gfx908::s17, output_vec_len );
            case 18:  return makeRegisterExpression(amdgpu_gfx908::s18, output_vec_len );
            case 19:  return makeRegisterExpression(amdgpu_gfx908::s19, output_vec_len );
            case 20:  return makeRegisterExpression(amdgpu_gfx908::s20, output_vec_len );
            case 21:  return makeRegisterExpression(amdgpu_gfx908::s21, output_vec_len );
            case 22:  return makeRegisterExpression(amdgpu_gfx908::s22, output_vec_len );
            case 23:  return makeRegisterExpression(amdgpu_gfx908::s23, output_vec_len );
            case 24:  return makeRegisterExpression(amdgpu_gfx908::s24, output_vec_len );
            case 25:  return makeRegisterExpression(amdgpu_gfx908::s25, output_vec_len );
            case 26:  return makeRegisterExpression(amdgpu_gfx908::s26, output_vec_len );
            case 27:  return makeRegisterExpression(amdgpu_gfx908::s27, output_vec_len );
            case 28:  return makeRegisterExpression(amdgpu_gfx908::s28, output_vec_len );
            case 29:  return makeRegisterExpression(amdgpu_gfx908::s29, output_vec_len );
            case 30:  return makeRegisterExpression(amdgpu_gfx908::s30, output_vec_len );
            case 31:  return makeRegisterExpression(amdgpu_gfx908::s31, output_vec_len );
            case 32:  return makeRegisterExpression(amdgpu_gfx908::s32, output_vec_len );
            case 33:  return makeRegisterExpression(amdgpu_gfx908::s33, output_vec_len );
            case 34:  return makeRegisterExpression(amdgpu_gfx908::s34, output_vec_len );
            case 35:  return makeRegisterExpression(amdgpu_gfx908::s35, output_vec_len );
            case 36:  return makeRegisterExpression(amdgpu_gfx908::s36, output_vec_len );
            case 37:  return makeRegisterExpression(amdgpu_gfx908::s37, output_vec_len );
            case 38:  return makeRegisterExpression(amdgpu_gfx908::s38, output_vec_len );
            case 39:  return makeRegisterExpression(amdgpu_gfx908::s39, output_vec_len );
            case 40:  return makeRegisterExpression(amdgpu_gfx908::s40, output_vec_len );
            case 41:  return makeRegisterExpression(amdgpu_gfx908::s41, output_vec_len );
            case 42:  return makeRegisterExpression(amdgpu_gfx908::s42, output_vec_len );
            case 43:  return makeRegisterExpression(amdgpu_gfx908::s43, output_vec_len );
            case 44:  return makeRegisterExpression(amdgpu_gfx908::s44, output_vec_len );
            case 45:  return makeRegisterExpression(amdgpu_gfx908::s45, output_vec_len );
            case 46:  return makeRegisterExpression(amdgpu_gfx908::s46, output_vec_len );
            case 47:  return makeRegisterExpression(amdgpu_gfx908::s47, output_vec_len );
            case 48:  return makeRegisterExpression(amdgpu_gfx908::s48, output_vec_len );
            case 49:  return makeRegisterExpression(amdgpu_gfx908::s49, output_vec_len );
            case 50:  return makeRegisterExpression(amdgpu_gfx908::s50, output_vec_len );
            case 51:  return makeRegisterExpression(amdgpu_gfx908::s51, output_vec_len );
            case 52:  return makeRegisterExpression(amdgpu_gfx908::s52, output_vec_len );
            case 53:  return makeRegisterExpression(amdgpu_gfx908::s53, output_vec_len );
            case 54:  return makeRegisterExpression(amdgpu_gfx908::s54, output_vec_len );
            case 55:  return makeRegisterExpression(amdgpu_gfx908::s55, output_vec_len );
            case 56:  return makeRegisterExpression(amdgpu_gfx908::s56, output_vec_len );
            case 57:  return makeRegisterExpression(amdgpu_gfx908::s57, output_vec_len );
            case 58:  return makeRegisterExpression(amdgpu_gfx908::s58, output_vec_len );
            case 59:  return makeRegisterExpression(amdgpu_gfx908::s59, output_vec_len );
            case 60:  return makeRegisterExpression(amdgpu_gfx908::s60, output_vec_len );
            case 61:  return makeRegisterExpression(amdgpu_gfx908::s61, output_vec_len );
            case 62:  return makeRegisterExpression(amdgpu_gfx908::s62, output_vec_len );
            case 63:  return makeRegisterExpression(amdgpu_gfx908::s63, output_vec_len );
            case 64:  return makeRegisterExpression(amdgpu_gfx908::s64, output_vec_len );
            case 65:  return makeRegisterExpression(amdgpu_gfx908::s65, output_vec_len );
            case 66:  return makeRegisterExpression(amdgpu_gfx908::s66, output_vec_len );
            case 67:  return makeRegisterExpression(amdgpu_gfx908::s67, output_vec_len );
            case 68:  return makeRegisterExpression(amdgpu_gfx908::s68, output_vec_len );
            case 69:  return makeRegisterExpression(amdgpu_gfx908::s69, output_vec_len );
            case 70:  return makeRegisterExpression(amdgpu_gfx908::s70, output_vec_len );
            case 71:  return makeRegisterExpression(amdgpu_gfx908::s71, output_vec_len );
            case 72:  return makeRegisterExpression(amdgpu_gfx908::s72, output_vec_len );
            case 73:  return makeRegisterExpression(amdgpu_gfx908::s73, output_vec_len );
            case 74:  return makeRegisterExpression(amdgpu_gfx908::s74, output_vec_len );
            case 75:  return makeRegisterExpression(amdgpu_gfx908::s75, output_vec_len );
            case 76:  return makeRegisterExpression(amdgpu_gfx908::s76, output_vec_len );
            case 77:  return makeRegisterExpression(amdgpu_gfx908::s77, output_vec_len );
            case 78:  return makeRegisterExpression(amdgpu_gfx908::s78, output_vec_len );
            case 79:  return makeRegisterExpression(amdgpu_gfx908::s79, output_vec_len );
            case 80:  return makeRegisterExpression(amdgpu_gfx908::s80, output_vec_len );
            case 81:  return makeRegisterExpression(amdgpu_gfx908::s81, output_vec_len );
            case 82:  return makeRegisterExpression(amdgpu_gfx908::s82, output_vec_len );
            case 83:  return makeRegisterExpression(amdgpu_gfx908::s83, output_vec_len );
            case 84:  return makeRegisterExpression(amdgpu_gfx908::s84, output_vec_len );
            case 85:  return makeRegisterExpression(amdgpu_gfx908::s85, output_vec_len );
            case 86:  return makeRegisterExpression(amdgpu_gfx908::s86, output_vec_len );
            case 87:  return makeRegisterExpression(amdgpu_gfx908::s87, output_vec_len );
            case 88:  return makeRegisterExpression(amdgpu_gfx908::s88, output_vec_len );
            case 89:  return makeRegisterExpression(amdgpu_gfx908::s89, output_vec_len );
            case 90:  return makeRegisterExpression(amdgpu_gfx908::s90, output_vec_len );
            case 91:  return makeRegisterExpression(amdgpu_gfx908::s91, output_vec_len );
            case 92:  return makeRegisterExpression(amdgpu_gfx908::s92, output_vec_len );
            case 93:  return makeRegisterExpression(amdgpu_gfx908::s93, output_vec_len );
            case 94:  return makeRegisterExpression(amdgpu_gfx908::s94, output_vec_len );
            case 95:  return makeRegisterExpression(amdgpu_gfx908::s95, output_vec_len );
            case 96:  return makeRegisterExpression(amdgpu_gfx908::s96, output_vec_len );
            case 97:  return makeRegisterExpression(amdgpu_gfx908::s97, output_vec_len );
            case 98:  return makeRegisterExpression(amdgpu_gfx908::s98, output_vec_len );
            case 99:  return makeRegisterExpression(amdgpu_gfx908::s99, output_vec_len );
            case 100:  return makeRegisterExpression(amdgpu_gfx908::s100, output_vec_len );
            case 101:  return makeRegisterExpression(amdgpu_gfx908::s101, output_vec_len );
            case 104:  return makeRegisterExpression(amdgpu_gfx908::xnack_mask_lo, output_vec_len );
            case 105:  return makeRegisterExpression(amdgpu_gfx908::xnack_mask_hi, output_vec_len );
            case 102:  return makeRegisterExpression(amdgpu_gfx908::flat_scratch_lo, output_vec_len );
            case 103:  return makeRegisterExpression(amdgpu_gfx908::flat_scratch_hi, output_vec_len );
            case 108:  return makeRegisterExpression(amdgpu_gfx908::ttmp0, output_vec_len );
            case 109:  return makeRegisterExpression(amdgpu_gfx908::ttmp1, output_vec_len );
            case 110:  return makeRegisterExpression(amdgpu_gfx908::ttmp2, output_vec_len );
            case 111:  return makeRegisterExpression(amdgpu_gfx908::ttmp3, output_vec_len );
            case 112:  return makeRegisterExpression(amdgpu_gfx908::ttmp4, output_vec_len );
            case 113:  return makeRegisterExpression(amdgpu_gfx908::ttmp5, output_vec_len );
            case 114:  return makeRegisterExpression(amdgpu_gfx908::ttmp6, output_vec_len );
            case 115:  return makeRegisterExpression(amdgpu_gfx908::ttmp7, output_vec_len );
            case 116:  return makeRegisterExpression(amdgpu_gfx908::ttmp8, output_vec_len );
            case 117:  return makeRegisterExpression(amdgpu_gfx908::ttmp9, output_vec_len );
            case 118:  return makeRegisterExpression(amdgpu_gfx908::ttmp10, output_vec_len );
            case 119:  return makeRegisterExpression(amdgpu_gfx908::ttmp11, output_vec_len );
            case 120:  return makeRegisterExpression(amdgpu_gfx908::ttmp12, output_vec_len );
            case 121:  return makeRegisterExpression(amdgpu_gfx908::ttmp13, output_vec_len );
            case 122:  return makeRegisterExpression(amdgpu_gfx908::ttmp14, output_vec_len );
            case 123:  return makeRegisterExpression(amdgpu_gfx908::ttmp15, output_vec_len );
            case 106:  return makeRegisterExpression(amdgpu_gfx908::vcc_lo, output_vec_len );
            case 107:  return makeRegisterExpression(amdgpu_gfx908::vcc_hi, output_vec_len );
            case 124:  return makeRegisterExpression(amdgpu_gfx908::m0, output_vec_len );
            case 126:  return makeRegisterExpression(amdgpu_gfx908::exec_lo, output_vec_len );
            case 127:  return makeRegisterExpression(amdgpu_gfx908::exec_hi, output_vec_len );
            default: return makeRegisterExpression(amdgpu_gfx908::invalid);
        }
    }

    Expression::Ptr InstructionDecoder_amdgpu_gfx908::decodeOPR_SDST_EXEC(uint64_t input, uint32_t output_vec_len)
    {
        switch (input)  {
            case 126:  return makeRegisterExpression(amdgpu_gfx908::exec_lo, output_vec_len );
            case 127:  return makeRegisterExpression(amdgpu_gfx908::exec_hi, output_vec_len );
            default: return makeRegisterExpression(amdgpu_gfx908::invalid);
        }
    }

    Expression::Ptr InstructionDecoder_amdgpu_gfx908::decodeOPR_SDST_M0(uint64_t input, uint32_t output_vec_len)
    {
        switch (input)  {
            case 124:  return makeRegisterExpression(amdgpu_gfx908::m0, output_vec_len );
            default: return makeRegisterExpression(amdgpu_gfx908::invalid);
        }
    }

    Expression::Ptr InstructionDecoder_amdgpu_gfx908::decodeOPR_SRC(uint64_t input, uint32_t output_vec_len)
    {
        switch (input)  {
            case 0:  return makeRegisterExpression(amdgpu_gfx908::s0, output_vec_len );
            case 1:  return makeRegisterExpression(amdgpu_gfx908::s1, output_vec_len );
            case 2:  return makeRegisterExpression(amdgpu_gfx908::s2, output_vec_len );
            case 3:  return makeRegisterExpression(amdgpu_gfx908::s3, output_vec_len );
            case 4:  return makeRegisterExpression(amdgpu_gfx908::s4, output_vec_len );
            case 5:  return makeRegisterExpression(amdgpu_gfx908::s5, output_vec_len );
            case 6:  return makeRegisterExpression(amdgpu_gfx908::s6, output_vec_len );
            case 7:  return makeRegisterExpression(amdgpu_gfx908::s7, output_vec_len );
            case 8:  return makeRegisterExpression(amdgpu_gfx908::s8, output_vec_len );
            case 9:  return makeRegisterExpression(amdgpu_gfx908::s9, output_vec_len );
            case 10:  return makeRegisterExpression(amdgpu_gfx908::s10, output_vec_len );
            case 11:  return makeRegisterExpression(amdgpu_gfx908::s11, output_vec_len );
            case 12:  return makeRegisterExpression(amdgpu_gfx908::s12, output_vec_len );
            case 13:  return makeRegisterExpression(amdgpu_gfx908::s13, output_vec_len );
            case 14:  return makeRegisterExpression(amdgpu_gfx908::s14, output_vec_len );
            case 15:  return makeRegisterExpression(amdgpu_gfx908::s15, output_vec_len );
            case 16:  return makeRegisterExpression(amdgpu_gfx908::s16, output_vec_len );
            case 17:  return makeRegisterExpression(amdgpu_gfx908::s17, output_vec_len );
            case 18:  return makeRegisterExpression(amdgpu_gfx908::s18, output_vec_len );
            case 19:  return makeRegisterExpression(amdgpu_gfx908::s19, output_vec_len );
            case 20:  return makeRegisterExpression(amdgpu_gfx908::s20, output_vec_len );
            case 21:  return makeRegisterExpression(amdgpu_gfx908::s21, output_vec_len );
            case 22:  return makeRegisterExpression(amdgpu_gfx908::s22, output_vec_len );
            case 23:  return makeRegisterExpression(amdgpu_gfx908::s23, output_vec_len );
            case 24:  return makeRegisterExpression(amdgpu_gfx908::s24, output_vec_len );
            case 25:  return makeRegisterExpression(amdgpu_gfx908::s25, output_vec_len );
            case 26:  return makeRegisterExpression(amdgpu_gfx908::s26, output_vec_len );
            case 27:  return makeRegisterExpression(amdgpu_gfx908::s27, output_vec_len );
            case 28:  return makeRegisterExpression(amdgpu_gfx908::s28, output_vec_len );
            case 29:  return makeRegisterExpression(amdgpu_gfx908::s29, output_vec_len );
            case 30:  return makeRegisterExpression(amdgpu_gfx908::s30, output_vec_len );
            case 31:  return makeRegisterExpression(amdgpu_gfx908::s31, output_vec_len );
            case 32:  return makeRegisterExpression(amdgpu_gfx908::s32, output_vec_len );
            case 33:  return makeRegisterExpression(amdgpu_gfx908::s33, output_vec_len );
            case 34:  return makeRegisterExpression(amdgpu_gfx908::s34, output_vec_len );
            case 35:  return makeRegisterExpression(amdgpu_gfx908::s35, output_vec_len );
            case 36:  return makeRegisterExpression(amdgpu_gfx908::s36, output_vec_len );
            case 37:  return makeRegisterExpression(amdgpu_gfx908::s37, output_vec_len );
            case 38:  return makeRegisterExpression(amdgpu_gfx908::s38, output_vec_len );
            case 39:  return makeRegisterExpression(amdgpu_gfx908::s39, output_vec_len );
            case 40:  return makeRegisterExpression(amdgpu_gfx908::s40, output_vec_len );
            case 41:  return makeRegisterExpression(amdgpu_gfx908::s41, output_vec_len );
            case 42:  return makeRegisterExpression(amdgpu_gfx908::s42, output_vec_len );
            case 43:  return makeRegisterExpression(amdgpu_gfx908::s43, output_vec_len );
            case 44:  return makeRegisterExpression(amdgpu_gfx908::s44, output_vec_len );
            case 45:  return makeRegisterExpression(amdgpu_gfx908::s45, output_vec_len );
            case 46:  return makeRegisterExpression(amdgpu_gfx908::s46, output_vec_len );
            case 47:  return makeRegisterExpression(amdgpu_gfx908::s47, output_vec_len );
            case 48:  return makeRegisterExpression(amdgpu_gfx908::s48, output_vec_len );
            case 49:  return makeRegisterExpression(amdgpu_gfx908::s49, output_vec_len );
            case 50:  return makeRegisterExpression(amdgpu_gfx908::s50, output_vec_len );
            case 51:  return makeRegisterExpression(amdgpu_gfx908::s51, output_vec_len );
            case 52:  return makeRegisterExpression(amdgpu_gfx908::s52, output_vec_len );
            case 53:  return makeRegisterExpression(amdgpu_gfx908::s53, output_vec_len );
            case 54:  return makeRegisterExpression(amdgpu_gfx908::s54, output_vec_len );
            case 55:  return makeRegisterExpression(amdgpu_gfx908::s55, output_vec_len );
            case 56:  return makeRegisterExpression(amdgpu_gfx908::s56, output_vec_len );
            case 57:  return makeRegisterExpression(amdgpu_gfx908::s57, output_vec_len );
            case 58:  return makeRegisterExpression(amdgpu_gfx908::s58, output_vec_len );
            case 59:  return makeRegisterExpression(amdgpu_gfx908::s59, output_vec_len );
            case 60:  return makeRegisterExpression(amdgpu_gfx908::s60, output_vec_len );
            case 61:  return makeRegisterExpression(amdgpu_gfx908::s61, output_vec_len );
            case 62:  return makeRegisterExpression(amdgpu_gfx908::s62, output_vec_len );
            case 63:  return makeRegisterExpression(amdgpu_gfx908::s63, output_vec_len );
            case 64:  return makeRegisterExpression(amdgpu_gfx908::s64, output_vec_len );
            case 65:  return makeRegisterExpression(amdgpu_gfx908::s65, output_vec_len );
            case 66:  return makeRegisterExpression(amdgpu_gfx908::s66, output_vec_len );
            case 67:  return makeRegisterExpression(amdgpu_gfx908::s67, output_vec_len );
            case 68:  return makeRegisterExpression(amdgpu_gfx908::s68, output_vec_len );
            case 69:  return makeRegisterExpression(amdgpu_gfx908::s69, output_vec_len );
            case 70:  return makeRegisterExpression(amdgpu_gfx908::s70, output_vec_len );
            case 71:  return makeRegisterExpression(amdgpu_gfx908::s71, output_vec_len );
            case 72:  return makeRegisterExpression(amdgpu_gfx908::s72, output_vec_len );
            case 73:  return makeRegisterExpression(amdgpu_gfx908::s73, output_vec_len );
            case 74:  return makeRegisterExpression(amdgpu_gfx908::s74, output_vec_len );
            case 75:  return makeRegisterExpression(amdgpu_gfx908::s75, output_vec_len );
            case 76:  return makeRegisterExpression(amdgpu_gfx908::s76, output_vec_len );
            case 77:  return makeRegisterExpression(amdgpu_gfx908::s77, output_vec_len );
            case 78:  return makeRegisterExpression(amdgpu_gfx908::s78, output_vec_len );
            case 79:  return makeRegisterExpression(amdgpu_gfx908::s79, output_vec_len );
            case 80:  return makeRegisterExpression(amdgpu_gfx908::s80, output_vec_len );
            case 81:  return makeRegisterExpression(amdgpu_gfx908::s81, output_vec_len );
            case 82:  return makeRegisterExpression(amdgpu_gfx908::s82, output_vec_len );
            case 83:  return makeRegisterExpression(amdgpu_gfx908::s83, output_vec_len );
            case 84:  return makeRegisterExpression(amdgpu_gfx908::s84, output_vec_len );
            case 85:  return makeRegisterExpression(amdgpu_gfx908::s85, output_vec_len );
            case 86:  return makeRegisterExpression(amdgpu_gfx908::s86, output_vec_len );
            case 87:  return makeRegisterExpression(amdgpu_gfx908::s87, output_vec_len );
            case 88:  return makeRegisterExpression(amdgpu_gfx908::s88, output_vec_len );
            case 89:  return makeRegisterExpression(amdgpu_gfx908::s89, output_vec_len );
            case 90:  return makeRegisterExpression(amdgpu_gfx908::s90, output_vec_len );
            case 91:  return makeRegisterExpression(amdgpu_gfx908::s91, output_vec_len );
            case 92:  return makeRegisterExpression(amdgpu_gfx908::s92, output_vec_len );
            case 93:  return makeRegisterExpression(amdgpu_gfx908::s93, output_vec_len );
            case 94:  return makeRegisterExpression(amdgpu_gfx908::s94, output_vec_len );
            case 95:  return makeRegisterExpression(amdgpu_gfx908::s95, output_vec_len );
            case 96:  return makeRegisterExpression(amdgpu_gfx908::s96, output_vec_len );
            case 97:  return makeRegisterExpression(amdgpu_gfx908::s97, output_vec_len );
            case 98:  return makeRegisterExpression(amdgpu_gfx908::s98, output_vec_len );
            case 99:  return makeRegisterExpression(amdgpu_gfx908::s99, output_vec_len );
            case 100:  return makeRegisterExpression(amdgpu_gfx908::s100, output_vec_len );
            case 101:  return makeRegisterExpression(amdgpu_gfx908::s101, output_vec_len );
            case 104:  return makeRegisterExpression(amdgpu_gfx908::xnack_mask_lo, output_vec_len );
            case 105:  return makeRegisterExpression(amdgpu_gfx908::xnack_mask_hi, output_vec_len );
            case 102:  return makeRegisterExpression(amdgpu_gfx908::flat_scratch_lo, output_vec_len );
            case 103:  return makeRegisterExpression(amdgpu_gfx908::flat_scratch_hi, output_vec_len );
            case 108:  return makeRegisterExpression(amdgpu_gfx908::ttmp0, output_vec_len );
            case 109:  return makeRegisterExpression(amdgpu_gfx908::ttmp1, output_vec_len );
            case 110:  return makeRegisterExpression(amdgpu_gfx908::ttmp2, output_vec_len );
            case 111:  return makeRegisterExpression(amdgpu_gfx908::ttmp3, output_vec_len );
            case 112:  return makeRegisterExpression(amdgpu_gfx908::ttmp4, output_vec_len );
            case 113:  return makeRegisterExpression(amdgpu_gfx908::ttmp5, output_vec_len );
            case 114:  return makeRegisterExpression(amdgpu_gfx908::ttmp6, output_vec_len );
            case 115:  return makeRegisterExpression(amdgpu_gfx908::ttmp7, output_vec_len );
            case 116:  return makeRegisterExpression(amdgpu_gfx908::ttmp8, output_vec_len );
            case 117:  return makeRegisterExpression(amdgpu_gfx908::ttmp9, output_vec_len );
            case 118:  return makeRegisterExpression(amdgpu_gfx908::ttmp10, output_vec_len );
            case 119:  return makeRegisterExpression(amdgpu_gfx908::ttmp11, output_vec_len );
            case 120:  return makeRegisterExpression(amdgpu_gfx908::ttmp12, output_vec_len );
            case 121:  return makeRegisterExpression(amdgpu_gfx908::ttmp13, output_vec_len );
            case 122:  return makeRegisterExpression(amdgpu_gfx908::ttmp14, output_vec_len );
            case 123:  return makeRegisterExpression(amdgpu_gfx908::ttmp15, output_vec_len );
            case 106:  return makeRegisterExpression(amdgpu_gfx908::vcc_lo, output_vec_len );
            case 107:  return makeRegisterExpression(amdgpu_gfx908::vcc_hi, output_vec_len );
            case 124:  return makeRegisterExpression(amdgpu_gfx908::m0, output_vec_len );
            case 126:  return makeRegisterExpression(amdgpu_gfx908::exec_lo, output_vec_len );
            case 127:  return makeRegisterExpression(amdgpu_gfx908::exec_hi, output_vec_len );
            case 128:  return Immediate::makeImmediate(Result(u32, 0));
            case 129:  return Immediate::makeImmediate(Result(u32, 1));
            case 130:  return Immediate::makeImmediate(Result(u32, 2));
            case 131:  return Immediate::makeImmediate(Result(u32, 3));
            case 132:  return Immediate::makeImmediate(Result(u32, 4));
            case 133:  return Immediate::makeImmediate(Result(u32, 5));
            case 134:  return Immediate::makeImmediate(Result(u32, 6));
            case 135:  return Immediate::makeImmediate(Result(u32, 7));
            case 136:  return Immediate::makeImmediate(Result(u32, 8));
            case 137:  return Immediate::makeImmediate(Result(u32, 9));
            case 138:  return Immediate::makeImmediate(Result(u32, 10));
            case 139:  return Immediate::makeImmediate(Result(u32, 11));
            case 140:  return Immediate::makeImmediate(Result(u32, 12));
            case 141:  return Immediate::makeImmediate(Result(u32, 13));
            case 142:  return Immediate::makeImmediate(Result(u32, 14));
            case 143:  return Immediate::makeImmediate(Result(u32, 15));
            case 144:  return Immediate::makeImmediate(Result(u32, 16));
            case 145:  return Immediate::makeImmediate(Result(u32, 17));
            case 146:  return Immediate::makeImmediate(Result(u32, 18));
            case 147:  return Immediate::makeImmediate(Result(u32, 19));
            case 148:  return Immediate::makeImmediate(Result(u32, 20));
            case 149:  return Immediate::makeImmediate(Result(u32, 21));
            case 150:  return Immediate::makeImmediate(Result(u32, 22));
            case 151:  return Immediate::makeImmediate(Result(u32, 23));
            case 152:  return Immediate::makeImmediate(Result(u32, 24));
            case 153:  return Immediate::makeImmediate(Result(u32, 25));
            case 154:  return Immediate::makeImmediate(Result(u32, 26));
            case 155:  return Immediate::makeImmediate(Result(u32, 27));
            case 156:  return Immediate::makeImmediate(Result(u32, 28));
            case 157:  return Immediate::makeImmediate(Result(u32, 29));
            case 158:  return Immediate::makeImmediate(Result(u32, 30));
            case 159:  return Immediate::makeImmediate(Result(u32, 31));
            case 160:  return Immediate::makeImmediate(Result(u32, 32));
            case 161:  return Immediate::makeImmediate(Result(u32, 33));
            case 162:  return Immediate::makeImmediate(Result(u32, 34));
            case 163:  return Immediate::makeImmediate(Result(u32, 35));
            case 164:  return Immediate::makeImmediate(Result(u32, 36));
            case 165:  return Immediate::makeImmediate(Result(u32, 37));
            case 166:  return Immediate::makeImmediate(Result(u32, 38));
            case 167:  return Immediate::makeImmediate(Result(u32, 39));
            case 168:  return Immediate::makeImmediate(Result(u32, 40));
            case 169:  return Immediate::makeImmediate(Result(u32, 41));
            case 170:  return Immediate::makeImmediate(Result(u32, 42));
            case 171:  return Immediate::makeImmediate(Result(u32, 43));
            case 172:  return Immediate::makeImmediate(Result(u32, 44));
            case 173:  return Immediate::makeImmediate(Result(u32, 45));
            case 174:  return Immediate::makeImmediate(Result(u32, 46));
            case 175:  return Immediate::makeImmediate(Result(u32, 47));
            case 176:  return Immediate::makeImmediate(Result(u32, 48));
            case 177:  return Immediate::makeImmediate(Result(u32, 49));
            case 178:  return Immediate::makeImmediate(Result(u32, 50));
            case 179:  return Immediate::makeImmediate(Result(u32, 51));
            case 180:  return Immediate::makeImmediate(Result(u32, 52));
            case 181:  return Immediate::makeImmediate(Result(u32, 53));
            case 182:  return Immediate::makeImmediate(Result(u32, 54));
            case 183:  return Immediate::makeImmediate(Result(u32, 55));
            case 184:  return Immediate::makeImmediate(Result(u32, 56));
            case 185:  return Immediate::makeImmediate(Result(u32, 57));
            case 186:  return Immediate::makeImmediate(Result(u32, 58));
            case 187:  return Immediate::makeImmediate(Result(u32, 59));
            case 188:  return Immediate::makeImmediate(Result(u32, 60));
            case 189:  return Immediate::makeImmediate(Result(u32, 61));
            case 190:  return Immediate::makeImmediate(Result(u32, 62));
            case 191:  return Immediate::makeImmediate(Result(u32, 63));
            case 192:  return Immediate::makeImmediate(Result(u32, 64));
            case 193:  return Immediate::makeImmediate(Result(u32, -1));
            case 194:  return Immediate::makeImmediate(Result(u32, -2));
            case 195:  return Immediate::makeImmediate(Result(u32, -3));
            case 196:  return Immediate::makeImmediate(Result(u32, -4));
            case 197:  return Immediate::makeImmediate(Result(u32, -5));
            case 198:  return Immediate::makeImmediate(Result(u32, -6));
            case 199:  return Immediate::makeImmediate(Result(u32, -7));
            case 200:  return Immediate::makeImmediate(Result(u32, -8));
            case 201:  return Immediate::makeImmediate(Result(u32, -9));
            case 202:  return Immediate::makeImmediate(Result(u32, -10));
            case 203:  return Immediate::makeImmediate(Result(u32, -11));
            case 204:  return Immediate::makeImmediate(Result(u32, -12));
            case 205:  return Immediate::makeImmediate(Result(u32, -13));
            case 206:  return Immediate::makeImmediate(Result(u32, -14));
            case 207:  return Immediate::makeImmediate(Result(u32, -15));
            case 208:  return Immediate::makeImmediate(Result(u32, -16));
            case 240:  return Immediate::makeImmediate(Result(sp_float, 0.5));
            case 241:  return Immediate::makeImmediate(Result(sp_float, -0.5));
            case 242:  return Immediate::makeImmediate(Result(sp_float, 1.0));
            case 243:  return Immediate::makeImmediate(Result(sp_float, -1.0));
            case 244:  return Immediate::makeImmediate(Result(sp_float, 2.0));
            case 245:  return Immediate::makeImmediate(Result(sp_float, -2.0));
            case 246:  return Immediate::makeImmediate(Result(sp_float, 4.0));
            case 247:  return Immediate::makeImmediate(Result(sp_float, -4.0));
            case 248:  return Immediate::makeImmediate(Result(sp_float, 0.15915494));
            case 251:  return makeRegisterExpression(amdgpu_gfx908::src_vccz, output_vec_len );
            case 252:  return makeRegisterExpression(amdgpu_gfx908::src_execz, output_vec_len );
            case 253:  return makeRegisterExpression(amdgpu_gfx908::src_scc, output_vec_len );
            case 235:  return makeRegisterExpression(amdgpu_gfx908::src_shared_base, output_vec_len );
            case 236:  return makeRegisterExpression(amdgpu_gfx908::src_shared_limit, output_vec_len );
            case 237:  return makeRegisterExpression(amdgpu_gfx908::src_private_base, output_vec_len );
            case 238:  return makeRegisterExpression(amdgpu_gfx908::src_private_limit, output_vec_len );
            case 239:  return makeRegisterExpression(amdgpu_gfx908::src_pops_exiting_wave_id, output_vec_len );
            case 256:  return makeRegisterExpression(amdgpu_gfx908::v0, output_vec_len );
            case 257:  return makeRegisterExpression(amdgpu_gfx908::v1, output_vec_len );
            case 258:  return makeRegisterExpression(amdgpu_gfx908::v2, output_vec_len );
            case 259:  return makeRegisterExpression(amdgpu_gfx908::v3, output_vec_len );
            case 260:  return makeRegisterExpression(amdgpu_gfx908::v4, output_vec_len );
            case 261:  return makeRegisterExpression(amdgpu_gfx908::v5, output_vec_len );
            case 262:  return makeRegisterExpression(amdgpu_gfx908::v6, output_vec_len );
            case 263:  return makeRegisterExpression(amdgpu_gfx908::v7, output_vec_len );
            case 264:  return makeRegisterExpression(amdgpu_gfx908::v8, output_vec_len );
            case 265:  return makeRegisterExpression(amdgpu_gfx908::v9, output_vec_len );
            case 266:  return makeRegisterExpression(amdgpu_gfx908::v10, output_vec_len );
            case 267:  return makeRegisterExpression(amdgpu_gfx908::v11, output_vec_len );
            case 268:  return makeRegisterExpression(amdgpu_gfx908::v12, output_vec_len );
            case 269:  return makeRegisterExpression(amdgpu_gfx908::v13, output_vec_len );
            case 270:  return makeRegisterExpression(amdgpu_gfx908::v14, output_vec_len );
            case 271:  return makeRegisterExpression(amdgpu_gfx908::v15, output_vec_len );
            case 272:  return makeRegisterExpression(amdgpu_gfx908::v16, output_vec_len );
            case 273:  return makeRegisterExpression(amdgpu_gfx908::v17, output_vec_len );
            case 274:  return makeRegisterExpression(amdgpu_gfx908::v18, output_vec_len );
            case 275:  return makeRegisterExpression(amdgpu_gfx908::v19, output_vec_len );
            case 276:  return makeRegisterExpression(amdgpu_gfx908::v20, output_vec_len );
            case 277:  return makeRegisterExpression(amdgpu_gfx908::v21, output_vec_len );
            case 278:  return makeRegisterExpression(amdgpu_gfx908::v22, output_vec_len );
            case 279:  return makeRegisterExpression(amdgpu_gfx908::v23, output_vec_len );
            case 280:  return makeRegisterExpression(amdgpu_gfx908::v24, output_vec_len );
            case 281:  return makeRegisterExpression(amdgpu_gfx908::v25, output_vec_len );
            case 282:  return makeRegisterExpression(amdgpu_gfx908::v26, output_vec_len );
            case 283:  return makeRegisterExpression(amdgpu_gfx908::v27, output_vec_len );
            case 284:  return makeRegisterExpression(amdgpu_gfx908::v28, output_vec_len );
            case 285:  return makeRegisterExpression(amdgpu_gfx908::v29, output_vec_len );
            case 286:  return makeRegisterExpression(amdgpu_gfx908::v30, output_vec_len );
            case 287:  return makeRegisterExpression(amdgpu_gfx908::v31, output_vec_len );
            case 288:  return makeRegisterExpression(amdgpu_gfx908::v32, output_vec_len );
            case 289:  return makeRegisterExpression(amdgpu_gfx908::v33, output_vec_len );
            case 290:  return makeRegisterExpression(amdgpu_gfx908::v34, output_vec_len );
            case 291:  return makeRegisterExpression(amdgpu_gfx908::v35, output_vec_len );
            case 292:  return makeRegisterExpression(amdgpu_gfx908::v36, output_vec_len );
            case 293:  return makeRegisterExpression(amdgpu_gfx908::v37, output_vec_len );
            case 294:  return makeRegisterExpression(amdgpu_gfx908::v38, output_vec_len );
            case 295:  return makeRegisterExpression(amdgpu_gfx908::v39, output_vec_len );
            case 296:  return makeRegisterExpression(amdgpu_gfx908::v40, output_vec_len );
            case 297:  return makeRegisterExpression(amdgpu_gfx908::v41, output_vec_len );
            case 298:  return makeRegisterExpression(amdgpu_gfx908::v42, output_vec_len );
            case 299:  return makeRegisterExpression(amdgpu_gfx908::v43, output_vec_len );
            case 300:  return makeRegisterExpression(amdgpu_gfx908::v44, output_vec_len );
            case 301:  return makeRegisterExpression(amdgpu_gfx908::v45, output_vec_len );
            case 302:  return makeRegisterExpression(amdgpu_gfx908::v46, output_vec_len );
            case 303:  return makeRegisterExpression(amdgpu_gfx908::v47, output_vec_len );
            case 304:  return makeRegisterExpression(amdgpu_gfx908::v48, output_vec_len );
            case 305:  return makeRegisterExpression(amdgpu_gfx908::v49, output_vec_len );
            case 306:  return makeRegisterExpression(amdgpu_gfx908::v50, output_vec_len );
            case 307:  return makeRegisterExpression(amdgpu_gfx908::v51, output_vec_len );
            case 308:  return makeRegisterExpression(amdgpu_gfx908::v52, output_vec_len );
            case 309:  return makeRegisterExpression(amdgpu_gfx908::v53, output_vec_len );
            case 310:  return makeRegisterExpression(amdgpu_gfx908::v54, output_vec_len );
            case 311:  return makeRegisterExpression(amdgpu_gfx908::v55, output_vec_len );
            case 312:  return makeRegisterExpression(amdgpu_gfx908::v56, output_vec_len );
            case 313:  return makeRegisterExpression(amdgpu_gfx908::v57, output_vec_len );
            case 314:  return makeRegisterExpression(amdgpu_gfx908::v58, output_vec_len );
            case 315:  return makeRegisterExpression(amdgpu_gfx908::v59, output_vec_len );
            case 316:  return makeRegisterExpression(amdgpu_gfx908::v60, output_vec_len );
            case 317:  return makeRegisterExpression(amdgpu_gfx908::v61, output_vec_len );
            case 318:  return makeRegisterExpression(amdgpu_gfx908::v62, output_vec_len );
            case 319:  return makeRegisterExpression(amdgpu_gfx908::v63, output_vec_len );
            case 320:  return makeRegisterExpression(amdgpu_gfx908::v64, output_vec_len );
            case 321:  return makeRegisterExpression(amdgpu_gfx908::v65, output_vec_len );
            case 322:  return makeRegisterExpression(amdgpu_gfx908::v66, output_vec_len );
            case 323:  return makeRegisterExpression(amdgpu_gfx908::v67, output_vec_len );
            case 324:  return makeRegisterExpression(amdgpu_gfx908::v68, output_vec_len );
            case 325:  return makeRegisterExpression(amdgpu_gfx908::v69, output_vec_len );
            case 326:  return makeRegisterExpression(amdgpu_gfx908::v70, output_vec_len );
            case 327:  return makeRegisterExpression(amdgpu_gfx908::v71, output_vec_len );
            case 328:  return makeRegisterExpression(amdgpu_gfx908::v72, output_vec_len );
            case 329:  return makeRegisterExpression(amdgpu_gfx908::v73, output_vec_len );
            case 330:  return makeRegisterExpression(amdgpu_gfx908::v74, output_vec_len );
            case 331:  return makeRegisterExpression(amdgpu_gfx908::v75, output_vec_len );
            case 332:  return makeRegisterExpression(amdgpu_gfx908::v76, output_vec_len );
            case 333:  return makeRegisterExpression(amdgpu_gfx908::v77, output_vec_len );
            case 334:  return makeRegisterExpression(amdgpu_gfx908::v78, output_vec_len );
            case 335:  return makeRegisterExpression(amdgpu_gfx908::v79, output_vec_len );
            case 336:  return makeRegisterExpression(amdgpu_gfx908::v80, output_vec_len );
            case 337:  return makeRegisterExpression(amdgpu_gfx908::v81, output_vec_len );
            case 338:  return makeRegisterExpression(amdgpu_gfx908::v82, output_vec_len );
            case 339:  return makeRegisterExpression(amdgpu_gfx908::v83, output_vec_len );
            case 340:  return makeRegisterExpression(amdgpu_gfx908::v84, output_vec_len );
            case 341:  return makeRegisterExpression(amdgpu_gfx908::v85, output_vec_len );
            case 342:  return makeRegisterExpression(amdgpu_gfx908::v86, output_vec_len );
            case 343:  return makeRegisterExpression(amdgpu_gfx908::v87, output_vec_len );
            case 344:  return makeRegisterExpression(amdgpu_gfx908::v88, output_vec_len );
            case 345:  return makeRegisterExpression(amdgpu_gfx908::v89, output_vec_len );
            case 346:  return makeRegisterExpression(amdgpu_gfx908::v90, output_vec_len );
            case 347:  return makeRegisterExpression(amdgpu_gfx908::v91, output_vec_len );
            case 348:  return makeRegisterExpression(amdgpu_gfx908::v92, output_vec_len );
            case 349:  return makeRegisterExpression(amdgpu_gfx908::v93, output_vec_len );
            case 350:  return makeRegisterExpression(amdgpu_gfx908::v94, output_vec_len );
            case 351:  return makeRegisterExpression(amdgpu_gfx908::v95, output_vec_len );
            case 352:  return makeRegisterExpression(amdgpu_gfx908::v96, output_vec_len );
            case 353:  return makeRegisterExpression(amdgpu_gfx908::v97, output_vec_len );
            case 354:  return makeRegisterExpression(amdgpu_gfx908::v98, output_vec_len );
            case 355:  return makeRegisterExpression(amdgpu_gfx908::v99, output_vec_len );
            case 356:  return makeRegisterExpression(amdgpu_gfx908::v100, output_vec_len );
            case 357:  return makeRegisterExpression(amdgpu_gfx908::v101, output_vec_len );
            case 358:  return makeRegisterExpression(amdgpu_gfx908::v102, output_vec_len );
            case 359:  return makeRegisterExpression(amdgpu_gfx908::v103, output_vec_len );
            case 360:  return makeRegisterExpression(amdgpu_gfx908::v104, output_vec_len );
            case 361:  return makeRegisterExpression(amdgpu_gfx908::v105, output_vec_len );
            case 362:  return makeRegisterExpression(amdgpu_gfx908::v106, output_vec_len );
            case 363:  return makeRegisterExpression(amdgpu_gfx908::v107, output_vec_len );
            case 364:  return makeRegisterExpression(amdgpu_gfx908::v108, output_vec_len );
            case 365:  return makeRegisterExpression(amdgpu_gfx908::v109, output_vec_len );
            case 366:  return makeRegisterExpression(amdgpu_gfx908::v110, output_vec_len );
            case 367:  return makeRegisterExpression(amdgpu_gfx908::v111, output_vec_len );
            case 368:  return makeRegisterExpression(amdgpu_gfx908::v112, output_vec_len );
            case 369:  return makeRegisterExpression(amdgpu_gfx908::v113, output_vec_len );
            case 370:  return makeRegisterExpression(amdgpu_gfx908::v114, output_vec_len );
            case 371:  return makeRegisterExpression(amdgpu_gfx908::v115, output_vec_len );
            case 372:  return makeRegisterExpression(amdgpu_gfx908::v116, output_vec_len );
            case 373:  return makeRegisterExpression(amdgpu_gfx908::v117, output_vec_len );
            case 374:  return makeRegisterExpression(amdgpu_gfx908::v118, output_vec_len );
            case 375:  return makeRegisterExpression(amdgpu_gfx908::v119, output_vec_len );
            case 376:  return makeRegisterExpression(amdgpu_gfx908::v120, output_vec_len );
            case 377:  return makeRegisterExpression(amdgpu_gfx908::v121, output_vec_len );
            case 378:  return makeRegisterExpression(amdgpu_gfx908::v122, output_vec_len );
            case 379:  return makeRegisterExpression(amdgpu_gfx908::v123, output_vec_len );
            case 380:  return makeRegisterExpression(amdgpu_gfx908::v124, output_vec_len );
            case 381:  return makeRegisterExpression(amdgpu_gfx908::v125, output_vec_len );
            case 382:  return makeRegisterExpression(amdgpu_gfx908::v126, output_vec_len );
            case 383:  return makeRegisterExpression(amdgpu_gfx908::v127, output_vec_len );
            case 384:  return makeRegisterExpression(amdgpu_gfx908::v128, output_vec_len );
            case 385:  return makeRegisterExpression(amdgpu_gfx908::v129, output_vec_len );
            case 386:  return makeRegisterExpression(amdgpu_gfx908::v130, output_vec_len );
            case 387:  return makeRegisterExpression(amdgpu_gfx908::v131, output_vec_len );
            case 388:  return makeRegisterExpression(amdgpu_gfx908::v132, output_vec_len );
            case 389:  return makeRegisterExpression(amdgpu_gfx908::v133, output_vec_len );
            case 390:  return makeRegisterExpression(amdgpu_gfx908::v134, output_vec_len );
            case 391:  return makeRegisterExpression(amdgpu_gfx908::v135, output_vec_len );
            case 392:  return makeRegisterExpression(amdgpu_gfx908::v136, output_vec_len );
            case 393:  return makeRegisterExpression(amdgpu_gfx908::v137, output_vec_len );
            case 394:  return makeRegisterExpression(amdgpu_gfx908::v138, output_vec_len );
            case 395:  return makeRegisterExpression(amdgpu_gfx908::v139, output_vec_len );
            case 396:  return makeRegisterExpression(amdgpu_gfx908::v140, output_vec_len );
            case 397:  return makeRegisterExpression(amdgpu_gfx908::v141, output_vec_len );
            case 398:  return makeRegisterExpression(amdgpu_gfx908::v142, output_vec_len );
            case 399:  return makeRegisterExpression(amdgpu_gfx908::v143, output_vec_len );
            case 400:  return makeRegisterExpression(amdgpu_gfx908::v144, output_vec_len );
            case 401:  return makeRegisterExpression(amdgpu_gfx908::v145, output_vec_len );
            case 402:  return makeRegisterExpression(amdgpu_gfx908::v146, output_vec_len );
            case 403:  return makeRegisterExpression(amdgpu_gfx908::v147, output_vec_len );
            case 404:  return makeRegisterExpression(amdgpu_gfx908::v148, output_vec_len );
            case 405:  return makeRegisterExpression(amdgpu_gfx908::v149, output_vec_len );
            case 406:  return makeRegisterExpression(amdgpu_gfx908::v150, output_vec_len );
            case 407:  return makeRegisterExpression(amdgpu_gfx908::v151, output_vec_len );
            case 408:  return makeRegisterExpression(amdgpu_gfx908::v152, output_vec_len );
            case 409:  return makeRegisterExpression(amdgpu_gfx908::v153, output_vec_len );
            case 410:  return makeRegisterExpression(amdgpu_gfx908::v154, output_vec_len );
            case 411:  return makeRegisterExpression(amdgpu_gfx908::v155, output_vec_len );
            case 412:  return makeRegisterExpression(amdgpu_gfx908::v156, output_vec_len );
            case 413:  return makeRegisterExpression(amdgpu_gfx908::v157, output_vec_len );
            case 414:  return makeRegisterExpression(amdgpu_gfx908::v158, output_vec_len );
            case 415:  return makeRegisterExpression(amdgpu_gfx908::v159, output_vec_len );
            case 416:  return makeRegisterExpression(amdgpu_gfx908::v160, output_vec_len );
            case 417:  return makeRegisterExpression(amdgpu_gfx908::v161, output_vec_len );
            case 418:  return makeRegisterExpression(amdgpu_gfx908::v162, output_vec_len );
            case 419:  return makeRegisterExpression(amdgpu_gfx908::v163, output_vec_len );
            case 420:  return makeRegisterExpression(amdgpu_gfx908::v164, output_vec_len );
            case 421:  return makeRegisterExpression(amdgpu_gfx908::v165, output_vec_len );
            case 422:  return makeRegisterExpression(amdgpu_gfx908::v166, output_vec_len );
            case 423:  return makeRegisterExpression(amdgpu_gfx908::v167, output_vec_len );
            case 424:  return makeRegisterExpression(amdgpu_gfx908::v168, output_vec_len );
            case 425:  return makeRegisterExpression(amdgpu_gfx908::v169, output_vec_len );
            case 426:  return makeRegisterExpression(amdgpu_gfx908::v170, output_vec_len );
            case 427:  return makeRegisterExpression(amdgpu_gfx908::v171, output_vec_len );
            case 428:  return makeRegisterExpression(amdgpu_gfx908::v172, output_vec_len );
            case 429:  return makeRegisterExpression(amdgpu_gfx908::v173, output_vec_len );
            case 430:  return makeRegisterExpression(amdgpu_gfx908::v174, output_vec_len );
            case 431:  return makeRegisterExpression(amdgpu_gfx908::v175, output_vec_len );
            case 432:  return makeRegisterExpression(amdgpu_gfx908::v176, output_vec_len );
            case 433:  return makeRegisterExpression(amdgpu_gfx908::v177, output_vec_len );
            case 434:  return makeRegisterExpression(amdgpu_gfx908::v178, output_vec_len );
            case 435:  return makeRegisterExpression(amdgpu_gfx908::v179, output_vec_len );
            case 436:  return makeRegisterExpression(amdgpu_gfx908::v180, output_vec_len );
            case 437:  return makeRegisterExpression(amdgpu_gfx908::v181, output_vec_len );
            case 438:  return makeRegisterExpression(amdgpu_gfx908::v182, output_vec_len );
            case 439:  return makeRegisterExpression(amdgpu_gfx908::v183, output_vec_len );
            case 440:  return makeRegisterExpression(amdgpu_gfx908::v184, output_vec_len );
            case 441:  return makeRegisterExpression(amdgpu_gfx908::v185, output_vec_len );
            case 442:  return makeRegisterExpression(amdgpu_gfx908::v186, output_vec_len );
            case 443:  return makeRegisterExpression(amdgpu_gfx908::v187, output_vec_len );
            case 444:  return makeRegisterExpression(amdgpu_gfx908::v188, output_vec_len );
            case 445:  return makeRegisterExpression(amdgpu_gfx908::v189, output_vec_len );
            case 446:  return makeRegisterExpression(amdgpu_gfx908::v190, output_vec_len );
            case 447:  return makeRegisterExpression(amdgpu_gfx908::v191, output_vec_len );
            case 448:  return makeRegisterExpression(amdgpu_gfx908::v192, output_vec_len );
            case 449:  return makeRegisterExpression(amdgpu_gfx908::v193, output_vec_len );
            case 450:  return makeRegisterExpression(amdgpu_gfx908::v194, output_vec_len );
            case 451:  return makeRegisterExpression(amdgpu_gfx908::v195, output_vec_len );
            case 452:  return makeRegisterExpression(amdgpu_gfx908::v196, output_vec_len );
            case 453:  return makeRegisterExpression(amdgpu_gfx908::v197, output_vec_len );
            case 454:  return makeRegisterExpression(amdgpu_gfx908::v198, output_vec_len );
            case 455:  return makeRegisterExpression(amdgpu_gfx908::v199, output_vec_len );
            case 456:  return makeRegisterExpression(amdgpu_gfx908::v200, output_vec_len );
            case 457:  return makeRegisterExpression(amdgpu_gfx908::v201, output_vec_len );
            case 458:  return makeRegisterExpression(amdgpu_gfx908::v202, output_vec_len );
            case 459:  return makeRegisterExpression(amdgpu_gfx908::v203, output_vec_len );
            case 460:  return makeRegisterExpression(amdgpu_gfx908::v204, output_vec_len );
            case 461:  return makeRegisterExpression(amdgpu_gfx908::v205, output_vec_len );
            case 462:  return makeRegisterExpression(amdgpu_gfx908::v206, output_vec_len );
            case 463:  return makeRegisterExpression(amdgpu_gfx908::v207, output_vec_len );
            case 464:  return makeRegisterExpression(amdgpu_gfx908::v208, output_vec_len );
            case 465:  return makeRegisterExpression(amdgpu_gfx908::v209, output_vec_len );
            case 466:  return makeRegisterExpression(amdgpu_gfx908::v210, output_vec_len );
            case 467:  return makeRegisterExpression(amdgpu_gfx908::v211, output_vec_len );
            case 468:  return makeRegisterExpression(amdgpu_gfx908::v212, output_vec_len );
            case 469:  return makeRegisterExpression(amdgpu_gfx908::v213, output_vec_len );
            case 470:  return makeRegisterExpression(amdgpu_gfx908::v214, output_vec_len );
            case 471:  return makeRegisterExpression(amdgpu_gfx908::v215, output_vec_len );
            case 472:  return makeRegisterExpression(amdgpu_gfx908::v216, output_vec_len );
            case 473:  return makeRegisterExpression(amdgpu_gfx908::v217, output_vec_len );
            case 474:  return makeRegisterExpression(amdgpu_gfx908::v218, output_vec_len );
            case 475:  return makeRegisterExpression(amdgpu_gfx908::v219, output_vec_len );
            case 476:  return makeRegisterExpression(amdgpu_gfx908::v220, output_vec_len );
            case 477:  return makeRegisterExpression(amdgpu_gfx908::v221, output_vec_len );
            case 478:  return makeRegisterExpression(amdgpu_gfx908::v222, output_vec_len );
            case 479:  return makeRegisterExpression(amdgpu_gfx908::v223, output_vec_len );
            case 480:  return makeRegisterExpression(amdgpu_gfx908::v224, output_vec_len );
            case 481:  return makeRegisterExpression(amdgpu_gfx908::v225, output_vec_len );
            case 482:  return makeRegisterExpression(amdgpu_gfx908::v226, output_vec_len );
            case 483:  return makeRegisterExpression(amdgpu_gfx908::v227, output_vec_len );
            case 484:  return makeRegisterExpression(amdgpu_gfx908::v228, output_vec_len );
            case 485:  return makeRegisterExpression(amdgpu_gfx908::v229, output_vec_len );
            case 486:  return makeRegisterExpression(amdgpu_gfx908::v230, output_vec_len );
            case 487:  return makeRegisterExpression(amdgpu_gfx908::v231, output_vec_len );
            case 488:  return makeRegisterExpression(amdgpu_gfx908::v232, output_vec_len );
            case 489:  return makeRegisterExpression(amdgpu_gfx908::v233, output_vec_len );
            case 490:  return makeRegisterExpression(amdgpu_gfx908::v234, output_vec_len );
            case 491:  return makeRegisterExpression(amdgpu_gfx908::v235, output_vec_len );
            case 492:  return makeRegisterExpression(amdgpu_gfx908::v236, output_vec_len );
            case 493:  return makeRegisterExpression(amdgpu_gfx908::v237, output_vec_len );
            case 494:  return makeRegisterExpression(amdgpu_gfx908::v238, output_vec_len );
            case 495:  return makeRegisterExpression(amdgpu_gfx908::v239, output_vec_len );
            case 496:  return makeRegisterExpression(amdgpu_gfx908::v240, output_vec_len );
            case 497:  return makeRegisterExpression(amdgpu_gfx908::v241, output_vec_len );
            case 498:  return makeRegisterExpression(amdgpu_gfx908::v242, output_vec_len );
            case 499:  return makeRegisterExpression(amdgpu_gfx908::v243, output_vec_len );
            case 500:  return makeRegisterExpression(amdgpu_gfx908::v244, output_vec_len );
            case 501:  return makeRegisterExpression(amdgpu_gfx908::v245, output_vec_len );
            case 502:  return makeRegisterExpression(amdgpu_gfx908::v246, output_vec_len );
            case 503:  return makeRegisterExpression(amdgpu_gfx908::v247, output_vec_len );
            case 504:  return makeRegisterExpression(amdgpu_gfx908::v248, output_vec_len );
            case 505:  return makeRegisterExpression(amdgpu_gfx908::v249, output_vec_len );
            case 506:  return makeRegisterExpression(amdgpu_gfx908::v250, output_vec_len );
            case 507:  return makeRegisterExpression(amdgpu_gfx908::v251, output_vec_len );
            case 508:  return makeRegisterExpression(amdgpu_gfx908::v252, output_vec_len );
            case 509:  return makeRegisterExpression(amdgpu_gfx908::v253, output_vec_len );
            case 510:  return makeRegisterExpression(amdgpu_gfx908::v254, output_vec_len );
            case 511:  return makeRegisterExpression(amdgpu_gfx908::v255, output_vec_len );
            case 254:  return makeRegisterExpression(amdgpu_gfx908::src_lds_direct, output_vec_len );
            case 255:  return Immediate::makeImmediate(Result(u32,decodeOPR_LITERAL()));
            case 249 :  return decodeOPR_SDWA();
            default: return makeRegisterExpression(amdgpu_gfx908::invalid);
        }
    }

    Expression::Ptr InstructionDecoder_amdgpu_gfx908::decodeOPR_SRC_ACCVGPR(uint64_t input, uint32_t output_vec_len)
    {
        switch (input)  {
            case 256:  return makeRegisterExpression(amdgpu_gfx908::acc0, output_vec_len );
            case 257:  return makeRegisterExpression(amdgpu_gfx908::acc1, output_vec_len );
            case 258:  return makeRegisterExpression(amdgpu_gfx908::acc2, output_vec_len );
            case 259:  return makeRegisterExpression(amdgpu_gfx908::acc3, output_vec_len );
            case 260:  return makeRegisterExpression(amdgpu_gfx908::acc4, output_vec_len );
            case 261:  return makeRegisterExpression(amdgpu_gfx908::acc5, output_vec_len );
            case 262:  return makeRegisterExpression(amdgpu_gfx908::acc6, output_vec_len );
            case 263:  return makeRegisterExpression(amdgpu_gfx908::acc7, output_vec_len );
            case 264:  return makeRegisterExpression(amdgpu_gfx908::acc8, output_vec_len );
            case 265:  return makeRegisterExpression(amdgpu_gfx908::acc9, output_vec_len );
            case 266:  return makeRegisterExpression(amdgpu_gfx908::acc10, output_vec_len );
            case 267:  return makeRegisterExpression(amdgpu_gfx908::acc11, output_vec_len );
            case 268:  return makeRegisterExpression(amdgpu_gfx908::acc12, output_vec_len );
            case 269:  return makeRegisterExpression(amdgpu_gfx908::acc13, output_vec_len );
            case 270:  return makeRegisterExpression(amdgpu_gfx908::acc14, output_vec_len );
            case 271:  return makeRegisterExpression(amdgpu_gfx908::acc15, output_vec_len );
            case 272:  return makeRegisterExpression(amdgpu_gfx908::acc16, output_vec_len );
            case 273:  return makeRegisterExpression(amdgpu_gfx908::acc17, output_vec_len );
            case 274:  return makeRegisterExpression(amdgpu_gfx908::acc18, output_vec_len );
            case 275:  return makeRegisterExpression(amdgpu_gfx908::acc19, output_vec_len );
            case 276:  return makeRegisterExpression(amdgpu_gfx908::acc20, output_vec_len );
            case 277:  return makeRegisterExpression(amdgpu_gfx908::acc21, output_vec_len );
            case 278:  return makeRegisterExpression(amdgpu_gfx908::acc22, output_vec_len );
            case 279:  return makeRegisterExpression(amdgpu_gfx908::acc23, output_vec_len );
            case 280:  return makeRegisterExpression(amdgpu_gfx908::acc24, output_vec_len );
            case 281:  return makeRegisterExpression(amdgpu_gfx908::acc25, output_vec_len );
            case 282:  return makeRegisterExpression(amdgpu_gfx908::acc26, output_vec_len );
            case 283:  return makeRegisterExpression(amdgpu_gfx908::acc27, output_vec_len );
            case 284:  return makeRegisterExpression(amdgpu_gfx908::acc28, output_vec_len );
            case 285:  return makeRegisterExpression(amdgpu_gfx908::acc29, output_vec_len );
            case 286:  return makeRegisterExpression(amdgpu_gfx908::acc30, output_vec_len );
            case 287:  return makeRegisterExpression(amdgpu_gfx908::acc31, output_vec_len );
            case 288:  return makeRegisterExpression(amdgpu_gfx908::acc32, output_vec_len );
            case 289:  return makeRegisterExpression(amdgpu_gfx908::acc33, output_vec_len );
            case 290:  return makeRegisterExpression(amdgpu_gfx908::acc34, output_vec_len );
            case 291:  return makeRegisterExpression(amdgpu_gfx908::acc35, output_vec_len );
            case 292:  return makeRegisterExpression(amdgpu_gfx908::acc36, output_vec_len );
            case 293:  return makeRegisterExpression(amdgpu_gfx908::acc37, output_vec_len );
            case 294:  return makeRegisterExpression(amdgpu_gfx908::acc38, output_vec_len );
            case 295:  return makeRegisterExpression(amdgpu_gfx908::acc39, output_vec_len );
            case 296:  return makeRegisterExpression(amdgpu_gfx908::acc40, output_vec_len );
            case 297:  return makeRegisterExpression(amdgpu_gfx908::acc41, output_vec_len );
            case 298:  return makeRegisterExpression(amdgpu_gfx908::acc42, output_vec_len );
            case 299:  return makeRegisterExpression(amdgpu_gfx908::acc43, output_vec_len );
            case 300:  return makeRegisterExpression(amdgpu_gfx908::acc44, output_vec_len );
            case 301:  return makeRegisterExpression(amdgpu_gfx908::acc45, output_vec_len );
            case 302:  return makeRegisterExpression(amdgpu_gfx908::acc46, output_vec_len );
            case 303:  return makeRegisterExpression(amdgpu_gfx908::acc47, output_vec_len );
            case 304:  return makeRegisterExpression(amdgpu_gfx908::acc48, output_vec_len );
            case 305:  return makeRegisterExpression(amdgpu_gfx908::acc49, output_vec_len );
            case 306:  return makeRegisterExpression(amdgpu_gfx908::acc50, output_vec_len );
            case 307:  return makeRegisterExpression(amdgpu_gfx908::acc51, output_vec_len );
            case 308:  return makeRegisterExpression(amdgpu_gfx908::acc52, output_vec_len );
            case 309:  return makeRegisterExpression(amdgpu_gfx908::acc53, output_vec_len );
            case 310:  return makeRegisterExpression(amdgpu_gfx908::acc54, output_vec_len );
            case 311:  return makeRegisterExpression(amdgpu_gfx908::acc55, output_vec_len );
            case 312:  return makeRegisterExpression(amdgpu_gfx908::acc56, output_vec_len );
            case 313:  return makeRegisterExpression(amdgpu_gfx908::acc57, output_vec_len );
            case 314:  return makeRegisterExpression(amdgpu_gfx908::acc58, output_vec_len );
            case 315:  return makeRegisterExpression(amdgpu_gfx908::acc59, output_vec_len );
            case 316:  return makeRegisterExpression(amdgpu_gfx908::acc60, output_vec_len );
            case 317:  return makeRegisterExpression(amdgpu_gfx908::acc61, output_vec_len );
            case 318:  return makeRegisterExpression(amdgpu_gfx908::acc62, output_vec_len );
            case 319:  return makeRegisterExpression(amdgpu_gfx908::acc63, output_vec_len );
            case 320:  return makeRegisterExpression(amdgpu_gfx908::acc64, output_vec_len );
            case 321:  return makeRegisterExpression(amdgpu_gfx908::acc65, output_vec_len );
            case 322:  return makeRegisterExpression(amdgpu_gfx908::acc66, output_vec_len );
            case 323:  return makeRegisterExpression(amdgpu_gfx908::acc67, output_vec_len );
            case 324:  return makeRegisterExpression(amdgpu_gfx908::acc68, output_vec_len );
            case 325:  return makeRegisterExpression(amdgpu_gfx908::acc69, output_vec_len );
            case 326:  return makeRegisterExpression(amdgpu_gfx908::acc70, output_vec_len );
            case 327:  return makeRegisterExpression(amdgpu_gfx908::acc71, output_vec_len );
            case 328:  return makeRegisterExpression(amdgpu_gfx908::acc72, output_vec_len );
            case 329:  return makeRegisterExpression(amdgpu_gfx908::acc73, output_vec_len );
            case 330:  return makeRegisterExpression(amdgpu_gfx908::acc74, output_vec_len );
            case 331:  return makeRegisterExpression(amdgpu_gfx908::acc75, output_vec_len );
            case 332:  return makeRegisterExpression(amdgpu_gfx908::acc76, output_vec_len );
            case 333:  return makeRegisterExpression(amdgpu_gfx908::acc77, output_vec_len );
            case 334:  return makeRegisterExpression(amdgpu_gfx908::acc78, output_vec_len );
            case 335:  return makeRegisterExpression(amdgpu_gfx908::acc79, output_vec_len );
            case 336:  return makeRegisterExpression(amdgpu_gfx908::acc80, output_vec_len );
            case 337:  return makeRegisterExpression(amdgpu_gfx908::acc81, output_vec_len );
            case 338:  return makeRegisterExpression(amdgpu_gfx908::acc82, output_vec_len );
            case 339:  return makeRegisterExpression(amdgpu_gfx908::acc83, output_vec_len );
            case 340:  return makeRegisterExpression(amdgpu_gfx908::acc84, output_vec_len );
            case 341:  return makeRegisterExpression(amdgpu_gfx908::acc85, output_vec_len );
            case 342:  return makeRegisterExpression(amdgpu_gfx908::acc86, output_vec_len );
            case 343:  return makeRegisterExpression(amdgpu_gfx908::acc87, output_vec_len );
            case 344:  return makeRegisterExpression(amdgpu_gfx908::acc88, output_vec_len );
            case 345:  return makeRegisterExpression(amdgpu_gfx908::acc89, output_vec_len );
            case 346:  return makeRegisterExpression(amdgpu_gfx908::acc90, output_vec_len );
            case 347:  return makeRegisterExpression(amdgpu_gfx908::acc91, output_vec_len );
            case 348:  return makeRegisterExpression(amdgpu_gfx908::acc92, output_vec_len );
            case 349:  return makeRegisterExpression(amdgpu_gfx908::acc93, output_vec_len );
            case 350:  return makeRegisterExpression(amdgpu_gfx908::acc94, output_vec_len );
            case 351:  return makeRegisterExpression(amdgpu_gfx908::acc95, output_vec_len );
            case 352:  return makeRegisterExpression(amdgpu_gfx908::acc96, output_vec_len );
            case 353:  return makeRegisterExpression(amdgpu_gfx908::acc97, output_vec_len );
            case 354:  return makeRegisterExpression(amdgpu_gfx908::acc98, output_vec_len );
            case 355:  return makeRegisterExpression(amdgpu_gfx908::acc99, output_vec_len );
            case 356:  return makeRegisterExpression(amdgpu_gfx908::acc100, output_vec_len );
            case 357:  return makeRegisterExpression(amdgpu_gfx908::acc101, output_vec_len );
            case 358:  return makeRegisterExpression(amdgpu_gfx908::acc102, output_vec_len );
            case 359:  return makeRegisterExpression(amdgpu_gfx908::acc103, output_vec_len );
            case 360:  return makeRegisterExpression(amdgpu_gfx908::acc104, output_vec_len );
            case 361:  return makeRegisterExpression(amdgpu_gfx908::acc105, output_vec_len );
            case 362:  return makeRegisterExpression(amdgpu_gfx908::acc106, output_vec_len );
            case 363:  return makeRegisterExpression(amdgpu_gfx908::acc107, output_vec_len );
            case 364:  return makeRegisterExpression(amdgpu_gfx908::acc108, output_vec_len );
            case 365:  return makeRegisterExpression(amdgpu_gfx908::acc109, output_vec_len );
            case 366:  return makeRegisterExpression(amdgpu_gfx908::acc110, output_vec_len );
            case 367:  return makeRegisterExpression(amdgpu_gfx908::acc111, output_vec_len );
            case 368:  return makeRegisterExpression(amdgpu_gfx908::acc112, output_vec_len );
            case 369:  return makeRegisterExpression(amdgpu_gfx908::acc113, output_vec_len );
            case 370:  return makeRegisterExpression(amdgpu_gfx908::acc114, output_vec_len );
            case 371:  return makeRegisterExpression(amdgpu_gfx908::acc115, output_vec_len );
            case 372:  return makeRegisterExpression(amdgpu_gfx908::acc116, output_vec_len );
            case 373:  return makeRegisterExpression(amdgpu_gfx908::acc117, output_vec_len );
            case 374:  return makeRegisterExpression(amdgpu_gfx908::acc118, output_vec_len );
            case 375:  return makeRegisterExpression(amdgpu_gfx908::acc119, output_vec_len );
            case 376:  return makeRegisterExpression(amdgpu_gfx908::acc120, output_vec_len );
            case 377:  return makeRegisterExpression(amdgpu_gfx908::acc121, output_vec_len );
            case 378:  return makeRegisterExpression(amdgpu_gfx908::acc122, output_vec_len );
            case 379:  return makeRegisterExpression(amdgpu_gfx908::acc123, output_vec_len );
            case 380:  return makeRegisterExpression(amdgpu_gfx908::acc124, output_vec_len );
            case 381:  return makeRegisterExpression(amdgpu_gfx908::acc125, output_vec_len );
            case 382:  return makeRegisterExpression(amdgpu_gfx908::acc126, output_vec_len );
            case 383:  return makeRegisterExpression(amdgpu_gfx908::acc127, output_vec_len );
            case 384:  return makeRegisterExpression(amdgpu_gfx908::acc128, output_vec_len );
            case 385:  return makeRegisterExpression(amdgpu_gfx908::acc129, output_vec_len );
            case 386:  return makeRegisterExpression(amdgpu_gfx908::acc130, output_vec_len );
            case 387:  return makeRegisterExpression(amdgpu_gfx908::acc131, output_vec_len );
            case 388:  return makeRegisterExpression(amdgpu_gfx908::acc132, output_vec_len );
            case 389:  return makeRegisterExpression(amdgpu_gfx908::acc133, output_vec_len );
            case 390:  return makeRegisterExpression(amdgpu_gfx908::acc134, output_vec_len );
            case 391:  return makeRegisterExpression(amdgpu_gfx908::acc135, output_vec_len );
            case 392:  return makeRegisterExpression(amdgpu_gfx908::acc136, output_vec_len );
            case 393:  return makeRegisterExpression(amdgpu_gfx908::acc137, output_vec_len );
            case 394:  return makeRegisterExpression(amdgpu_gfx908::acc138, output_vec_len );
            case 395:  return makeRegisterExpression(amdgpu_gfx908::acc139, output_vec_len );
            case 396:  return makeRegisterExpression(amdgpu_gfx908::acc140, output_vec_len );
            case 397:  return makeRegisterExpression(amdgpu_gfx908::acc141, output_vec_len );
            case 398:  return makeRegisterExpression(amdgpu_gfx908::acc142, output_vec_len );
            case 399:  return makeRegisterExpression(amdgpu_gfx908::acc143, output_vec_len );
            case 400:  return makeRegisterExpression(amdgpu_gfx908::acc144, output_vec_len );
            case 401:  return makeRegisterExpression(amdgpu_gfx908::acc145, output_vec_len );
            case 402:  return makeRegisterExpression(amdgpu_gfx908::acc146, output_vec_len );
            case 403:  return makeRegisterExpression(amdgpu_gfx908::acc147, output_vec_len );
            case 404:  return makeRegisterExpression(amdgpu_gfx908::acc148, output_vec_len );
            case 405:  return makeRegisterExpression(amdgpu_gfx908::acc149, output_vec_len );
            case 406:  return makeRegisterExpression(amdgpu_gfx908::acc150, output_vec_len );
            case 407:  return makeRegisterExpression(amdgpu_gfx908::acc151, output_vec_len );
            case 408:  return makeRegisterExpression(amdgpu_gfx908::acc152, output_vec_len );
            case 409:  return makeRegisterExpression(amdgpu_gfx908::acc153, output_vec_len );
            case 410:  return makeRegisterExpression(amdgpu_gfx908::acc154, output_vec_len );
            case 411:  return makeRegisterExpression(amdgpu_gfx908::acc155, output_vec_len );
            case 412:  return makeRegisterExpression(amdgpu_gfx908::acc156, output_vec_len );
            case 413:  return makeRegisterExpression(amdgpu_gfx908::acc157, output_vec_len );
            case 414:  return makeRegisterExpression(amdgpu_gfx908::acc158, output_vec_len );
            case 415:  return makeRegisterExpression(amdgpu_gfx908::acc159, output_vec_len );
            case 416:  return makeRegisterExpression(amdgpu_gfx908::acc160, output_vec_len );
            case 417:  return makeRegisterExpression(amdgpu_gfx908::acc161, output_vec_len );
            case 418:  return makeRegisterExpression(amdgpu_gfx908::acc162, output_vec_len );
            case 419:  return makeRegisterExpression(amdgpu_gfx908::acc163, output_vec_len );
            case 420:  return makeRegisterExpression(amdgpu_gfx908::acc164, output_vec_len );
            case 421:  return makeRegisterExpression(amdgpu_gfx908::acc165, output_vec_len );
            case 422:  return makeRegisterExpression(amdgpu_gfx908::acc166, output_vec_len );
            case 423:  return makeRegisterExpression(amdgpu_gfx908::acc167, output_vec_len );
            case 424:  return makeRegisterExpression(amdgpu_gfx908::acc168, output_vec_len );
            case 425:  return makeRegisterExpression(amdgpu_gfx908::acc169, output_vec_len );
            case 426:  return makeRegisterExpression(amdgpu_gfx908::acc170, output_vec_len );
            case 427:  return makeRegisterExpression(amdgpu_gfx908::acc171, output_vec_len );
            case 428:  return makeRegisterExpression(amdgpu_gfx908::acc172, output_vec_len );
            case 429:  return makeRegisterExpression(amdgpu_gfx908::acc173, output_vec_len );
            case 430:  return makeRegisterExpression(amdgpu_gfx908::acc174, output_vec_len );
            case 431:  return makeRegisterExpression(amdgpu_gfx908::acc175, output_vec_len );
            case 432:  return makeRegisterExpression(amdgpu_gfx908::acc176, output_vec_len );
            case 433:  return makeRegisterExpression(amdgpu_gfx908::acc177, output_vec_len );
            case 434:  return makeRegisterExpression(amdgpu_gfx908::acc178, output_vec_len );
            case 435:  return makeRegisterExpression(amdgpu_gfx908::acc179, output_vec_len );
            case 436:  return makeRegisterExpression(amdgpu_gfx908::acc180, output_vec_len );
            case 437:  return makeRegisterExpression(amdgpu_gfx908::acc181, output_vec_len );
            case 438:  return makeRegisterExpression(amdgpu_gfx908::acc182, output_vec_len );
            case 439:  return makeRegisterExpression(amdgpu_gfx908::acc183, output_vec_len );
            case 440:  return makeRegisterExpression(amdgpu_gfx908::acc184, output_vec_len );
            case 441:  return makeRegisterExpression(amdgpu_gfx908::acc185, output_vec_len );
            case 442:  return makeRegisterExpression(amdgpu_gfx908::acc186, output_vec_len );
            case 443:  return makeRegisterExpression(amdgpu_gfx908::acc187, output_vec_len );
            case 444:  return makeRegisterExpression(amdgpu_gfx908::acc188, output_vec_len );
            case 445:  return makeRegisterExpression(amdgpu_gfx908::acc189, output_vec_len );
            case 446:  return makeRegisterExpression(amdgpu_gfx908::acc190, output_vec_len );
            case 447:  return makeRegisterExpression(amdgpu_gfx908::acc191, output_vec_len );
            case 448:  return makeRegisterExpression(amdgpu_gfx908::acc192, output_vec_len );
            case 449:  return makeRegisterExpression(amdgpu_gfx908::acc193, output_vec_len );
            case 450:  return makeRegisterExpression(amdgpu_gfx908::acc194, output_vec_len );
            case 451:  return makeRegisterExpression(amdgpu_gfx908::acc195, output_vec_len );
            case 452:  return makeRegisterExpression(amdgpu_gfx908::acc196, output_vec_len );
            case 453:  return makeRegisterExpression(amdgpu_gfx908::acc197, output_vec_len );
            case 454:  return makeRegisterExpression(amdgpu_gfx908::acc198, output_vec_len );
            case 455:  return makeRegisterExpression(amdgpu_gfx908::acc199, output_vec_len );
            case 456:  return makeRegisterExpression(amdgpu_gfx908::acc200, output_vec_len );
            case 457:  return makeRegisterExpression(amdgpu_gfx908::acc201, output_vec_len );
            case 458:  return makeRegisterExpression(amdgpu_gfx908::acc202, output_vec_len );
            case 459:  return makeRegisterExpression(amdgpu_gfx908::acc203, output_vec_len );
            case 460:  return makeRegisterExpression(amdgpu_gfx908::acc204, output_vec_len );
            case 461:  return makeRegisterExpression(amdgpu_gfx908::acc205, output_vec_len );
            case 462:  return makeRegisterExpression(amdgpu_gfx908::acc206, output_vec_len );
            case 463:  return makeRegisterExpression(amdgpu_gfx908::acc207, output_vec_len );
            case 464:  return makeRegisterExpression(amdgpu_gfx908::acc208, output_vec_len );
            case 465:  return makeRegisterExpression(amdgpu_gfx908::acc209, output_vec_len );
            case 466:  return makeRegisterExpression(amdgpu_gfx908::acc210, output_vec_len );
            case 467:  return makeRegisterExpression(amdgpu_gfx908::acc211, output_vec_len );
            case 468:  return makeRegisterExpression(amdgpu_gfx908::acc212, output_vec_len );
            case 469:  return makeRegisterExpression(amdgpu_gfx908::acc213, output_vec_len );
            case 470:  return makeRegisterExpression(amdgpu_gfx908::acc214, output_vec_len );
            case 471:  return makeRegisterExpression(amdgpu_gfx908::acc215, output_vec_len );
            case 472:  return makeRegisterExpression(amdgpu_gfx908::acc216, output_vec_len );
            case 473:  return makeRegisterExpression(amdgpu_gfx908::acc217, output_vec_len );
            case 474:  return makeRegisterExpression(amdgpu_gfx908::acc218, output_vec_len );
            case 475:  return makeRegisterExpression(amdgpu_gfx908::acc219, output_vec_len );
            case 476:  return makeRegisterExpression(amdgpu_gfx908::acc220, output_vec_len );
            case 477:  return makeRegisterExpression(amdgpu_gfx908::acc221, output_vec_len );
            case 478:  return makeRegisterExpression(amdgpu_gfx908::acc222, output_vec_len );
            case 479:  return makeRegisterExpression(amdgpu_gfx908::acc223, output_vec_len );
            case 480:  return makeRegisterExpression(amdgpu_gfx908::acc224, output_vec_len );
            case 481:  return makeRegisterExpression(amdgpu_gfx908::acc225, output_vec_len );
            case 482:  return makeRegisterExpression(amdgpu_gfx908::acc226, output_vec_len );
            case 483:  return makeRegisterExpression(amdgpu_gfx908::acc227, output_vec_len );
            case 484:  return makeRegisterExpression(amdgpu_gfx908::acc228, output_vec_len );
            case 485:  return makeRegisterExpression(amdgpu_gfx908::acc229, output_vec_len );
            case 486:  return makeRegisterExpression(amdgpu_gfx908::acc230, output_vec_len );
            case 487:  return makeRegisterExpression(amdgpu_gfx908::acc231, output_vec_len );
            case 488:  return makeRegisterExpression(amdgpu_gfx908::acc232, output_vec_len );
            case 489:  return makeRegisterExpression(amdgpu_gfx908::acc233, output_vec_len );
            case 490:  return makeRegisterExpression(amdgpu_gfx908::acc234, output_vec_len );
            case 491:  return makeRegisterExpression(amdgpu_gfx908::acc235, output_vec_len );
            case 492:  return makeRegisterExpression(amdgpu_gfx908::acc236, output_vec_len );
            case 493:  return makeRegisterExpression(amdgpu_gfx908::acc237, output_vec_len );
            case 494:  return makeRegisterExpression(amdgpu_gfx908::acc238, output_vec_len );
            case 495:  return makeRegisterExpression(amdgpu_gfx908::acc239, output_vec_len );
            case 496:  return makeRegisterExpression(amdgpu_gfx908::acc240, output_vec_len );
            case 497:  return makeRegisterExpression(amdgpu_gfx908::acc241, output_vec_len );
            case 498:  return makeRegisterExpression(amdgpu_gfx908::acc242, output_vec_len );
            case 499:  return makeRegisterExpression(amdgpu_gfx908::acc243, output_vec_len );
            case 500:  return makeRegisterExpression(amdgpu_gfx908::acc244, output_vec_len );
            case 501:  return makeRegisterExpression(amdgpu_gfx908::acc245, output_vec_len );
            case 502:  return makeRegisterExpression(amdgpu_gfx908::acc246, output_vec_len );
            case 503:  return makeRegisterExpression(amdgpu_gfx908::acc247, output_vec_len );
            case 504:  return makeRegisterExpression(amdgpu_gfx908::acc248, output_vec_len );
            case 505:  return makeRegisterExpression(amdgpu_gfx908::acc249, output_vec_len );
            case 506:  return makeRegisterExpression(amdgpu_gfx908::acc250, output_vec_len );
            case 507:  return makeRegisterExpression(amdgpu_gfx908::acc251, output_vec_len );
            case 508:  return makeRegisterExpression(amdgpu_gfx908::acc252, output_vec_len );
            case 509:  return makeRegisterExpression(amdgpu_gfx908::acc253, output_vec_len );
            case 510:  return makeRegisterExpression(amdgpu_gfx908::acc254, output_vec_len );
            case 511:  return makeRegisterExpression(amdgpu_gfx908::acc255, output_vec_len );
            case 768:  return makeRegisterExpression(amdgpu_gfx908::acc0, output_vec_len );
            case 769:  return makeRegisterExpression(amdgpu_gfx908::acc1, output_vec_len );
            case 770:  return makeRegisterExpression(amdgpu_gfx908::acc2, output_vec_len );
            case 771:  return makeRegisterExpression(amdgpu_gfx908::acc3, output_vec_len );
            case 772:  return makeRegisterExpression(amdgpu_gfx908::acc4, output_vec_len );
            case 773:  return makeRegisterExpression(amdgpu_gfx908::acc5, output_vec_len );
            case 774:  return makeRegisterExpression(amdgpu_gfx908::acc6, output_vec_len );
            case 775:  return makeRegisterExpression(amdgpu_gfx908::acc7, output_vec_len );
            case 776:  return makeRegisterExpression(amdgpu_gfx908::acc8, output_vec_len );
            case 777:  return makeRegisterExpression(amdgpu_gfx908::acc9, output_vec_len );
            case 778:  return makeRegisterExpression(amdgpu_gfx908::acc10, output_vec_len );
            case 779:  return makeRegisterExpression(amdgpu_gfx908::acc11, output_vec_len );
            case 780:  return makeRegisterExpression(amdgpu_gfx908::acc12, output_vec_len );
            case 781:  return makeRegisterExpression(amdgpu_gfx908::acc13, output_vec_len );
            case 782:  return makeRegisterExpression(amdgpu_gfx908::acc14, output_vec_len );
            case 783:  return makeRegisterExpression(amdgpu_gfx908::acc15, output_vec_len );
            case 784:  return makeRegisterExpression(amdgpu_gfx908::acc16, output_vec_len );
            case 785:  return makeRegisterExpression(amdgpu_gfx908::acc17, output_vec_len );
            case 786:  return makeRegisterExpression(amdgpu_gfx908::acc18, output_vec_len );
            case 787:  return makeRegisterExpression(amdgpu_gfx908::acc19, output_vec_len );
            case 788:  return makeRegisterExpression(amdgpu_gfx908::acc20, output_vec_len );
            case 789:  return makeRegisterExpression(amdgpu_gfx908::acc21, output_vec_len );
            case 790:  return makeRegisterExpression(amdgpu_gfx908::acc22, output_vec_len );
            case 791:  return makeRegisterExpression(amdgpu_gfx908::acc23, output_vec_len );
            case 792:  return makeRegisterExpression(amdgpu_gfx908::acc24, output_vec_len );
            case 793:  return makeRegisterExpression(amdgpu_gfx908::acc25, output_vec_len );
            case 794:  return makeRegisterExpression(amdgpu_gfx908::acc26, output_vec_len );
            case 795:  return makeRegisterExpression(amdgpu_gfx908::acc27, output_vec_len );
            case 796:  return makeRegisterExpression(amdgpu_gfx908::acc28, output_vec_len );
            case 797:  return makeRegisterExpression(amdgpu_gfx908::acc29, output_vec_len );
            case 798:  return makeRegisterExpression(amdgpu_gfx908::acc30, output_vec_len );
            case 799:  return makeRegisterExpression(amdgpu_gfx908::acc31, output_vec_len );
            case 800:  return makeRegisterExpression(amdgpu_gfx908::acc32, output_vec_len );
            case 801:  return makeRegisterExpression(amdgpu_gfx908::acc33, output_vec_len );
            case 802:  return makeRegisterExpression(amdgpu_gfx908::acc34, output_vec_len );
            case 803:  return makeRegisterExpression(amdgpu_gfx908::acc35, output_vec_len );
            case 804:  return makeRegisterExpression(amdgpu_gfx908::acc36, output_vec_len );
            case 805:  return makeRegisterExpression(amdgpu_gfx908::acc37, output_vec_len );
            case 806:  return makeRegisterExpression(amdgpu_gfx908::acc38, output_vec_len );
            case 807:  return makeRegisterExpression(amdgpu_gfx908::acc39, output_vec_len );
            case 808:  return makeRegisterExpression(amdgpu_gfx908::acc40, output_vec_len );
            case 809:  return makeRegisterExpression(amdgpu_gfx908::acc41, output_vec_len );
            case 810:  return makeRegisterExpression(amdgpu_gfx908::acc42, output_vec_len );
            case 811:  return makeRegisterExpression(amdgpu_gfx908::acc43, output_vec_len );
            case 812:  return makeRegisterExpression(amdgpu_gfx908::acc44, output_vec_len );
            case 813:  return makeRegisterExpression(amdgpu_gfx908::acc45, output_vec_len );
            case 814:  return makeRegisterExpression(amdgpu_gfx908::acc46, output_vec_len );
            case 815:  return makeRegisterExpression(amdgpu_gfx908::acc47, output_vec_len );
            case 816:  return makeRegisterExpression(amdgpu_gfx908::acc48, output_vec_len );
            case 817:  return makeRegisterExpression(amdgpu_gfx908::acc49, output_vec_len );
            case 818:  return makeRegisterExpression(amdgpu_gfx908::acc50, output_vec_len );
            case 819:  return makeRegisterExpression(amdgpu_gfx908::acc51, output_vec_len );
            case 820:  return makeRegisterExpression(amdgpu_gfx908::acc52, output_vec_len );
            case 821:  return makeRegisterExpression(amdgpu_gfx908::acc53, output_vec_len );
            case 822:  return makeRegisterExpression(amdgpu_gfx908::acc54, output_vec_len );
            case 823:  return makeRegisterExpression(amdgpu_gfx908::acc55, output_vec_len );
            case 824:  return makeRegisterExpression(amdgpu_gfx908::acc56, output_vec_len );
            case 825:  return makeRegisterExpression(amdgpu_gfx908::acc57, output_vec_len );
            case 826:  return makeRegisterExpression(amdgpu_gfx908::acc58, output_vec_len );
            case 827:  return makeRegisterExpression(amdgpu_gfx908::acc59, output_vec_len );
            case 828:  return makeRegisterExpression(amdgpu_gfx908::acc60, output_vec_len );
            case 829:  return makeRegisterExpression(amdgpu_gfx908::acc61, output_vec_len );
            case 830:  return makeRegisterExpression(amdgpu_gfx908::acc62, output_vec_len );
            case 831:  return makeRegisterExpression(amdgpu_gfx908::acc63, output_vec_len );
            case 832:  return makeRegisterExpression(amdgpu_gfx908::acc64, output_vec_len );
            case 833:  return makeRegisterExpression(amdgpu_gfx908::acc65, output_vec_len );
            case 834:  return makeRegisterExpression(amdgpu_gfx908::acc66, output_vec_len );
            case 835:  return makeRegisterExpression(amdgpu_gfx908::acc67, output_vec_len );
            case 836:  return makeRegisterExpression(amdgpu_gfx908::acc68, output_vec_len );
            case 837:  return makeRegisterExpression(amdgpu_gfx908::acc69, output_vec_len );
            case 838:  return makeRegisterExpression(amdgpu_gfx908::acc70, output_vec_len );
            case 839:  return makeRegisterExpression(amdgpu_gfx908::acc71, output_vec_len );
            case 840:  return makeRegisterExpression(amdgpu_gfx908::acc72, output_vec_len );
            case 841:  return makeRegisterExpression(amdgpu_gfx908::acc73, output_vec_len );
            case 842:  return makeRegisterExpression(amdgpu_gfx908::acc74, output_vec_len );
            case 843:  return makeRegisterExpression(amdgpu_gfx908::acc75, output_vec_len );
            case 844:  return makeRegisterExpression(amdgpu_gfx908::acc76, output_vec_len );
            case 845:  return makeRegisterExpression(amdgpu_gfx908::acc77, output_vec_len );
            case 846:  return makeRegisterExpression(amdgpu_gfx908::acc78, output_vec_len );
            case 847:  return makeRegisterExpression(amdgpu_gfx908::acc79, output_vec_len );
            case 848:  return makeRegisterExpression(amdgpu_gfx908::acc80, output_vec_len );
            case 849:  return makeRegisterExpression(amdgpu_gfx908::acc81, output_vec_len );
            case 850:  return makeRegisterExpression(amdgpu_gfx908::acc82, output_vec_len );
            case 851:  return makeRegisterExpression(amdgpu_gfx908::acc83, output_vec_len );
            case 852:  return makeRegisterExpression(amdgpu_gfx908::acc84, output_vec_len );
            case 853:  return makeRegisterExpression(amdgpu_gfx908::acc85, output_vec_len );
            case 854:  return makeRegisterExpression(amdgpu_gfx908::acc86, output_vec_len );
            case 855:  return makeRegisterExpression(amdgpu_gfx908::acc87, output_vec_len );
            case 856:  return makeRegisterExpression(amdgpu_gfx908::acc88, output_vec_len );
            case 857:  return makeRegisterExpression(amdgpu_gfx908::acc89, output_vec_len );
            case 858:  return makeRegisterExpression(amdgpu_gfx908::acc90, output_vec_len );
            case 859:  return makeRegisterExpression(amdgpu_gfx908::acc91, output_vec_len );
            case 860:  return makeRegisterExpression(amdgpu_gfx908::acc92, output_vec_len );
            case 861:  return makeRegisterExpression(amdgpu_gfx908::acc93, output_vec_len );
            case 862:  return makeRegisterExpression(amdgpu_gfx908::acc94, output_vec_len );
            case 863:  return makeRegisterExpression(amdgpu_gfx908::acc95, output_vec_len );
            case 864:  return makeRegisterExpression(amdgpu_gfx908::acc96, output_vec_len );
            case 865:  return makeRegisterExpression(amdgpu_gfx908::acc97, output_vec_len );
            case 866:  return makeRegisterExpression(amdgpu_gfx908::acc98, output_vec_len );
            case 867:  return makeRegisterExpression(amdgpu_gfx908::acc99, output_vec_len );
            case 868:  return makeRegisterExpression(amdgpu_gfx908::acc100, output_vec_len );
            case 869:  return makeRegisterExpression(amdgpu_gfx908::acc101, output_vec_len );
            case 870:  return makeRegisterExpression(amdgpu_gfx908::acc102, output_vec_len );
            case 871:  return makeRegisterExpression(amdgpu_gfx908::acc103, output_vec_len );
            case 872:  return makeRegisterExpression(amdgpu_gfx908::acc104, output_vec_len );
            case 873:  return makeRegisterExpression(amdgpu_gfx908::acc105, output_vec_len );
            case 874:  return makeRegisterExpression(amdgpu_gfx908::acc106, output_vec_len );
            case 875:  return makeRegisterExpression(amdgpu_gfx908::acc107, output_vec_len );
            case 876:  return makeRegisterExpression(amdgpu_gfx908::acc108, output_vec_len );
            case 877:  return makeRegisterExpression(amdgpu_gfx908::acc109, output_vec_len );
            case 878:  return makeRegisterExpression(amdgpu_gfx908::acc110, output_vec_len );
            case 879:  return makeRegisterExpression(amdgpu_gfx908::acc111, output_vec_len );
            case 880:  return makeRegisterExpression(amdgpu_gfx908::acc112, output_vec_len );
            case 881:  return makeRegisterExpression(amdgpu_gfx908::acc113, output_vec_len );
            case 882:  return makeRegisterExpression(amdgpu_gfx908::acc114, output_vec_len );
            case 883:  return makeRegisterExpression(amdgpu_gfx908::acc115, output_vec_len );
            case 884:  return makeRegisterExpression(amdgpu_gfx908::acc116, output_vec_len );
            case 885:  return makeRegisterExpression(amdgpu_gfx908::acc117, output_vec_len );
            case 886:  return makeRegisterExpression(amdgpu_gfx908::acc118, output_vec_len );
            case 887:  return makeRegisterExpression(amdgpu_gfx908::acc119, output_vec_len );
            case 888:  return makeRegisterExpression(amdgpu_gfx908::acc120, output_vec_len );
            case 889:  return makeRegisterExpression(amdgpu_gfx908::acc121, output_vec_len );
            case 890:  return makeRegisterExpression(amdgpu_gfx908::acc122, output_vec_len );
            case 891:  return makeRegisterExpression(amdgpu_gfx908::acc123, output_vec_len );
            case 892:  return makeRegisterExpression(amdgpu_gfx908::acc124, output_vec_len );
            case 893:  return makeRegisterExpression(amdgpu_gfx908::acc125, output_vec_len );
            case 894:  return makeRegisterExpression(amdgpu_gfx908::acc126, output_vec_len );
            case 895:  return makeRegisterExpression(amdgpu_gfx908::acc127, output_vec_len );
            case 896:  return makeRegisterExpression(amdgpu_gfx908::acc128, output_vec_len );
            case 897:  return makeRegisterExpression(amdgpu_gfx908::acc129, output_vec_len );
            case 898:  return makeRegisterExpression(amdgpu_gfx908::acc130, output_vec_len );
            case 899:  return makeRegisterExpression(amdgpu_gfx908::acc131, output_vec_len );
            case 900:  return makeRegisterExpression(amdgpu_gfx908::acc132, output_vec_len );
            case 901:  return makeRegisterExpression(amdgpu_gfx908::acc133, output_vec_len );
            case 902:  return makeRegisterExpression(amdgpu_gfx908::acc134, output_vec_len );
            case 903:  return makeRegisterExpression(amdgpu_gfx908::acc135, output_vec_len );
            case 904:  return makeRegisterExpression(amdgpu_gfx908::acc136, output_vec_len );
            case 905:  return makeRegisterExpression(amdgpu_gfx908::acc137, output_vec_len );
            case 906:  return makeRegisterExpression(amdgpu_gfx908::acc138, output_vec_len );
            case 907:  return makeRegisterExpression(amdgpu_gfx908::acc139, output_vec_len );
            case 908:  return makeRegisterExpression(amdgpu_gfx908::acc140, output_vec_len );
            case 909:  return makeRegisterExpression(amdgpu_gfx908::acc141, output_vec_len );
            case 910:  return makeRegisterExpression(amdgpu_gfx908::acc142, output_vec_len );
            case 911:  return makeRegisterExpression(amdgpu_gfx908::acc143, output_vec_len );
            case 912:  return makeRegisterExpression(amdgpu_gfx908::acc144, output_vec_len );
            case 913:  return makeRegisterExpression(amdgpu_gfx908::acc145, output_vec_len );
            case 914:  return makeRegisterExpression(amdgpu_gfx908::acc146, output_vec_len );
            case 915:  return makeRegisterExpression(amdgpu_gfx908::acc147, output_vec_len );
            case 916:  return makeRegisterExpression(amdgpu_gfx908::acc148, output_vec_len );
            case 917:  return makeRegisterExpression(amdgpu_gfx908::acc149, output_vec_len );
            case 918:  return makeRegisterExpression(amdgpu_gfx908::acc150, output_vec_len );
            case 919:  return makeRegisterExpression(amdgpu_gfx908::acc151, output_vec_len );
            case 920:  return makeRegisterExpression(amdgpu_gfx908::acc152, output_vec_len );
            case 921:  return makeRegisterExpression(amdgpu_gfx908::acc153, output_vec_len );
            case 922:  return makeRegisterExpression(amdgpu_gfx908::acc154, output_vec_len );
            case 923:  return makeRegisterExpression(amdgpu_gfx908::acc155, output_vec_len );
            case 924:  return makeRegisterExpression(amdgpu_gfx908::acc156, output_vec_len );
            case 925:  return makeRegisterExpression(amdgpu_gfx908::acc157, output_vec_len );
            case 926:  return makeRegisterExpression(amdgpu_gfx908::acc158, output_vec_len );
            case 927:  return makeRegisterExpression(amdgpu_gfx908::acc159, output_vec_len );
            case 928:  return makeRegisterExpression(amdgpu_gfx908::acc160, output_vec_len );
            case 929:  return makeRegisterExpression(amdgpu_gfx908::acc161, output_vec_len );
            case 930:  return makeRegisterExpression(amdgpu_gfx908::acc162, output_vec_len );
            case 931:  return makeRegisterExpression(amdgpu_gfx908::acc163, output_vec_len );
            case 932:  return makeRegisterExpression(amdgpu_gfx908::acc164, output_vec_len );
            case 933:  return makeRegisterExpression(amdgpu_gfx908::acc165, output_vec_len );
            case 934:  return makeRegisterExpression(amdgpu_gfx908::acc166, output_vec_len );
            case 935:  return makeRegisterExpression(amdgpu_gfx908::acc167, output_vec_len );
            case 936:  return makeRegisterExpression(amdgpu_gfx908::acc168, output_vec_len );
            case 937:  return makeRegisterExpression(amdgpu_gfx908::acc169, output_vec_len );
            case 938:  return makeRegisterExpression(amdgpu_gfx908::acc170, output_vec_len );
            case 939:  return makeRegisterExpression(amdgpu_gfx908::acc171, output_vec_len );
            case 940:  return makeRegisterExpression(amdgpu_gfx908::acc172, output_vec_len );
            case 941:  return makeRegisterExpression(amdgpu_gfx908::acc173, output_vec_len );
            case 942:  return makeRegisterExpression(amdgpu_gfx908::acc174, output_vec_len );
            case 943:  return makeRegisterExpression(amdgpu_gfx908::acc175, output_vec_len );
            case 944:  return makeRegisterExpression(amdgpu_gfx908::acc176, output_vec_len );
            case 945:  return makeRegisterExpression(amdgpu_gfx908::acc177, output_vec_len );
            case 946:  return makeRegisterExpression(amdgpu_gfx908::acc178, output_vec_len );
            case 947:  return makeRegisterExpression(amdgpu_gfx908::acc179, output_vec_len );
            case 948:  return makeRegisterExpression(amdgpu_gfx908::acc180, output_vec_len );
            case 949:  return makeRegisterExpression(amdgpu_gfx908::acc181, output_vec_len );
            case 950:  return makeRegisterExpression(amdgpu_gfx908::acc182, output_vec_len );
            case 951:  return makeRegisterExpression(amdgpu_gfx908::acc183, output_vec_len );
            case 952:  return makeRegisterExpression(amdgpu_gfx908::acc184, output_vec_len );
            case 953:  return makeRegisterExpression(amdgpu_gfx908::acc185, output_vec_len );
            case 954:  return makeRegisterExpression(amdgpu_gfx908::acc186, output_vec_len );
            case 955:  return makeRegisterExpression(amdgpu_gfx908::acc187, output_vec_len );
            case 956:  return makeRegisterExpression(amdgpu_gfx908::acc188, output_vec_len );
            case 957:  return makeRegisterExpression(amdgpu_gfx908::acc189, output_vec_len );
            case 958:  return makeRegisterExpression(amdgpu_gfx908::acc190, output_vec_len );
            case 959:  return makeRegisterExpression(amdgpu_gfx908::acc191, output_vec_len );
            case 960:  return makeRegisterExpression(amdgpu_gfx908::acc192, output_vec_len );
            case 961:  return makeRegisterExpression(amdgpu_gfx908::acc193, output_vec_len );
            case 962:  return makeRegisterExpression(amdgpu_gfx908::acc194, output_vec_len );
            case 963:  return makeRegisterExpression(amdgpu_gfx908::acc195, output_vec_len );
            case 964:  return makeRegisterExpression(amdgpu_gfx908::acc196, output_vec_len );
            case 965:  return makeRegisterExpression(amdgpu_gfx908::acc197, output_vec_len );
            case 966:  return makeRegisterExpression(amdgpu_gfx908::acc198, output_vec_len );
            case 967:  return makeRegisterExpression(amdgpu_gfx908::acc199, output_vec_len );
            case 968:  return makeRegisterExpression(amdgpu_gfx908::acc200, output_vec_len );
            case 969:  return makeRegisterExpression(amdgpu_gfx908::acc201, output_vec_len );
            case 970:  return makeRegisterExpression(amdgpu_gfx908::acc202, output_vec_len );
            case 971:  return makeRegisterExpression(amdgpu_gfx908::acc203, output_vec_len );
            case 972:  return makeRegisterExpression(amdgpu_gfx908::acc204, output_vec_len );
            case 973:  return makeRegisterExpression(amdgpu_gfx908::acc205, output_vec_len );
            case 974:  return makeRegisterExpression(amdgpu_gfx908::acc206, output_vec_len );
            case 975:  return makeRegisterExpression(amdgpu_gfx908::acc207, output_vec_len );
            case 976:  return makeRegisterExpression(amdgpu_gfx908::acc208, output_vec_len );
            case 977:  return makeRegisterExpression(amdgpu_gfx908::acc209, output_vec_len );
            case 978:  return makeRegisterExpression(amdgpu_gfx908::acc210, output_vec_len );
            case 979:  return makeRegisterExpression(amdgpu_gfx908::acc211, output_vec_len );
            case 980:  return makeRegisterExpression(amdgpu_gfx908::acc212, output_vec_len );
            case 981:  return makeRegisterExpression(amdgpu_gfx908::acc213, output_vec_len );
            case 982:  return makeRegisterExpression(amdgpu_gfx908::acc214, output_vec_len );
            case 983:  return makeRegisterExpression(amdgpu_gfx908::acc215, output_vec_len );
            case 984:  return makeRegisterExpression(amdgpu_gfx908::acc216, output_vec_len );
            case 985:  return makeRegisterExpression(amdgpu_gfx908::acc217, output_vec_len );
            case 986:  return makeRegisterExpression(amdgpu_gfx908::acc218, output_vec_len );
            case 987:  return makeRegisterExpression(amdgpu_gfx908::acc219, output_vec_len );
            case 988:  return makeRegisterExpression(amdgpu_gfx908::acc220, output_vec_len );
            case 989:  return makeRegisterExpression(amdgpu_gfx908::acc221, output_vec_len );
            case 990:  return makeRegisterExpression(amdgpu_gfx908::acc222, output_vec_len );
            case 991:  return makeRegisterExpression(amdgpu_gfx908::acc223, output_vec_len );
            case 992:  return makeRegisterExpression(amdgpu_gfx908::acc224, output_vec_len );
            case 993:  return makeRegisterExpression(amdgpu_gfx908::acc225, output_vec_len );
            case 994:  return makeRegisterExpression(amdgpu_gfx908::acc226, output_vec_len );
            case 995:  return makeRegisterExpression(amdgpu_gfx908::acc227, output_vec_len );
            case 996:  return makeRegisterExpression(amdgpu_gfx908::acc228, output_vec_len );
            case 997:  return makeRegisterExpression(amdgpu_gfx908::acc229, output_vec_len );
            case 998:  return makeRegisterExpression(amdgpu_gfx908::acc230, output_vec_len );
            case 999:  return makeRegisterExpression(amdgpu_gfx908::acc231, output_vec_len );
            case 1000:  return makeRegisterExpression(amdgpu_gfx908::acc232, output_vec_len );
            case 1001:  return makeRegisterExpression(amdgpu_gfx908::acc233, output_vec_len );
            case 1002:  return makeRegisterExpression(amdgpu_gfx908::acc234, output_vec_len );
            case 1003:  return makeRegisterExpression(amdgpu_gfx908::acc235, output_vec_len );
            case 1004:  return makeRegisterExpression(amdgpu_gfx908::acc236, output_vec_len );
            case 1005:  return makeRegisterExpression(amdgpu_gfx908::acc237, output_vec_len );
            case 1006:  return makeRegisterExpression(amdgpu_gfx908::acc238, output_vec_len );
            case 1007:  return makeRegisterExpression(amdgpu_gfx908::acc239, output_vec_len );
            case 1008:  return makeRegisterExpression(amdgpu_gfx908::acc240, output_vec_len );
            case 1009:  return makeRegisterExpression(amdgpu_gfx908::acc241, output_vec_len );
            case 1010:  return makeRegisterExpression(amdgpu_gfx908::acc242, output_vec_len );
            case 1011:  return makeRegisterExpression(amdgpu_gfx908::acc243, output_vec_len );
            case 1012:  return makeRegisterExpression(amdgpu_gfx908::acc244, output_vec_len );
            case 1013:  return makeRegisterExpression(amdgpu_gfx908::acc245, output_vec_len );
            case 1014:  return makeRegisterExpression(amdgpu_gfx908::acc246, output_vec_len );
            case 1015:  return makeRegisterExpression(amdgpu_gfx908::acc247, output_vec_len );
            case 1016:  return makeRegisterExpression(amdgpu_gfx908::acc248, output_vec_len );
            case 1017:  return makeRegisterExpression(amdgpu_gfx908::acc249, output_vec_len );
            case 1018:  return makeRegisterExpression(amdgpu_gfx908::acc250, output_vec_len );
            case 1019:  return makeRegisterExpression(amdgpu_gfx908::acc251, output_vec_len );
            case 1020:  return makeRegisterExpression(amdgpu_gfx908::acc252, output_vec_len );
            case 1021:  return makeRegisterExpression(amdgpu_gfx908::acc253, output_vec_len );
            case 1022:  return makeRegisterExpression(amdgpu_gfx908::acc254, output_vec_len );
            case 1023:  return makeRegisterExpression(amdgpu_gfx908::acc255, output_vec_len );
            default: return makeRegisterExpression(amdgpu_gfx908::invalid);
        }
    }

    Expression::Ptr InstructionDecoder_amdgpu_gfx908::decodeOPR_SRC_ACCVGPR_OR_CONST(uint64_t input, uint32_t output_vec_len)
    {
        switch (input)  {
            case 256:  return makeRegisterExpression(amdgpu_gfx908::acc0, output_vec_len );
            case 257:  return makeRegisterExpression(amdgpu_gfx908::acc1, output_vec_len );
            case 258:  return makeRegisterExpression(amdgpu_gfx908::acc2, output_vec_len );
            case 259:  return makeRegisterExpression(amdgpu_gfx908::acc3, output_vec_len );
            case 260:  return makeRegisterExpression(amdgpu_gfx908::acc4, output_vec_len );
            case 261:  return makeRegisterExpression(amdgpu_gfx908::acc5, output_vec_len );
            case 262:  return makeRegisterExpression(amdgpu_gfx908::acc6, output_vec_len );
            case 263:  return makeRegisterExpression(amdgpu_gfx908::acc7, output_vec_len );
            case 264:  return makeRegisterExpression(amdgpu_gfx908::acc8, output_vec_len );
            case 265:  return makeRegisterExpression(amdgpu_gfx908::acc9, output_vec_len );
            case 266:  return makeRegisterExpression(amdgpu_gfx908::acc10, output_vec_len );
            case 267:  return makeRegisterExpression(amdgpu_gfx908::acc11, output_vec_len );
            case 268:  return makeRegisterExpression(amdgpu_gfx908::acc12, output_vec_len );
            case 269:  return makeRegisterExpression(amdgpu_gfx908::acc13, output_vec_len );
            case 270:  return makeRegisterExpression(amdgpu_gfx908::acc14, output_vec_len );
            case 271:  return makeRegisterExpression(amdgpu_gfx908::acc15, output_vec_len );
            case 272:  return makeRegisterExpression(amdgpu_gfx908::acc16, output_vec_len );
            case 273:  return makeRegisterExpression(amdgpu_gfx908::acc17, output_vec_len );
            case 274:  return makeRegisterExpression(amdgpu_gfx908::acc18, output_vec_len );
            case 275:  return makeRegisterExpression(amdgpu_gfx908::acc19, output_vec_len );
            case 276:  return makeRegisterExpression(amdgpu_gfx908::acc20, output_vec_len );
            case 277:  return makeRegisterExpression(amdgpu_gfx908::acc21, output_vec_len );
            case 278:  return makeRegisterExpression(amdgpu_gfx908::acc22, output_vec_len );
            case 279:  return makeRegisterExpression(amdgpu_gfx908::acc23, output_vec_len );
            case 280:  return makeRegisterExpression(amdgpu_gfx908::acc24, output_vec_len );
            case 281:  return makeRegisterExpression(amdgpu_gfx908::acc25, output_vec_len );
            case 282:  return makeRegisterExpression(amdgpu_gfx908::acc26, output_vec_len );
            case 283:  return makeRegisterExpression(amdgpu_gfx908::acc27, output_vec_len );
            case 284:  return makeRegisterExpression(amdgpu_gfx908::acc28, output_vec_len );
            case 285:  return makeRegisterExpression(amdgpu_gfx908::acc29, output_vec_len );
            case 286:  return makeRegisterExpression(amdgpu_gfx908::acc30, output_vec_len );
            case 287:  return makeRegisterExpression(amdgpu_gfx908::acc31, output_vec_len );
            case 288:  return makeRegisterExpression(amdgpu_gfx908::acc32, output_vec_len );
            case 289:  return makeRegisterExpression(amdgpu_gfx908::acc33, output_vec_len );
            case 290:  return makeRegisterExpression(amdgpu_gfx908::acc34, output_vec_len );
            case 291:  return makeRegisterExpression(amdgpu_gfx908::acc35, output_vec_len );
            case 292:  return makeRegisterExpression(amdgpu_gfx908::acc36, output_vec_len );
            case 293:  return makeRegisterExpression(amdgpu_gfx908::acc37, output_vec_len );
            case 294:  return makeRegisterExpression(amdgpu_gfx908::acc38, output_vec_len );
            case 295:  return makeRegisterExpression(amdgpu_gfx908::acc39, output_vec_len );
            case 296:  return makeRegisterExpression(amdgpu_gfx908::acc40, output_vec_len );
            case 297:  return makeRegisterExpression(amdgpu_gfx908::acc41, output_vec_len );
            case 298:  return makeRegisterExpression(amdgpu_gfx908::acc42, output_vec_len );
            case 299:  return makeRegisterExpression(amdgpu_gfx908::acc43, output_vec_len );
            case 300:  return makeRegisterExpression(amdgpu_gfx908::acc44, output_vec_len );
            case 301:  return makeRegisterExpression(amdgpu_gfx908::acc45, output_vec_len );
            case 302:  return makeRegisterExpression(amdgpu_gfx908::acc46, output_vec_len );
            case 303:  return makeRegisterExpression(amdgpu_gfx908::acc47, output_vec_len );
            case 304:  return makeRegisterExpression(amdgpu_gfx908::acc48, output_vec_len );
            case 305:  return makeRegisterExpression(amdgpu_gfx908::acc49, output_vec_len );
            case 306:  return makeRegisterExpression(amdgpu_gfx908::acc50, output_vec_len );
            case 307:  return makeRegisterExpression(amdgpu_gfx908::acc51, output_vec_len );
            case 308:  return makeRegisterExpression(amdgpu_gfx908::acc52, output_vec_len );
            case 309:  return makeRegisterExpression(amdgpu_gfx908::acc53, output_vec_len );
            case 310:  return makeRegisterExpression(amdgpu_gfx908::acc54, output_vec_len );
            case 311:  return makeRegisterExpression(amdgpu_gfx908::acc55, output_vec_len );
            case 312:  return makeRegisterExpression(amdgpu_gfx908::acc56, output_vec_len );
            case 313:  return makeRegisterExpression(amdgpu_gfx908::acc57, output_vec_len );
            case 314:  return makeRegisterExpression(amdgpu_gfx908::acc58, output_vec_len );
            case 315:  return makeRegisterExpression(amdgpu_gfx908::acc59, output_vec_len );
            case 316:  return makeRegisterExpression(amdgpu_gfx908::acc60, output_vec_len );
            case 317:  return makeRegisterExpression(amdgpu_gfx908::acc61, output_vec_len );
            case 318:  return makeRegisterExpression(amdgpu_gfx908::acc62, output_vec_len );
            case 319:  return makeRegisterExpression(amdgpu_gfx908::acc63, output_vec_len );
            case 320:  return makeRegisterExpression(amdgpu_gfx908::acc64, output_vec_len );
            case 321:  return makeRegisterExpression(amdgpu_gfx908::acc65, output_vec_len );
            case 322:  return makeRegisterExpression(amdgpu_gfx908::acc66, output_vec_len );
            case 323:  return makeRegisterExpression(amdgpu_gfx908::acc67, output_vec_len );
            case 324:  return makeRegisterExpression(amdgpu_gfx908::acc68, output_vec_len );
            case 325:  return makeRegisterExpression(amdgpu_gfx908::acc69, output_vec_len );
            case 326:  return makeRegisterExpression(amdgpu_gfx908::acc70, output_vec_len );
            case 327:  return makeRegisterExpression(amdgpu_gfx908::acc71, output_vec_len );
            case 328:  return makeRegisterExpression(amdgpu_gfx908::acc72, output_vec_len );
            case 329:  return makeRegisterExpression(amdgpu_gfx908::acc73, output_vec_len );
            case 330:  return makeRegisterExpression(amdgpu_gfx908::acc74, output_vec_len );
            case 331:  return makeRegisterExpression(amdgpu_gfx908::acc75, output_vec_len );
            case 332:  return makeRegisterExpression(amdgpu_gfx908::acc76, output_vec_len );
            case 333:  return makeRegisterExpression(amdgpu_gfx908::acc77, output_vec_len );
            case 334:  return makeRegisterExpression(amdgpu_gfx908::acc78, output_vec_len );
            case 335:  return makeRegisterExpression(amdgpu_gfx908::acc79, output_vec_len );
            case 336:  return makeRegisterExpression(amdgpu_gfx908::acc80, output_vec_len );
            case 337:  return makeRegisterExpression(amdgpu_gfx908::acc81, output_vec_len );
            case 338:  return makeRegisterExpression(amdgpu_gfx908::acc82, output_vec_len );
            case 339:  return makeRegisterExpression(amdgpu_gfx908::acc83, output_vec_len );
            case 340:  return makeRegisterExpression(amdgpu_gfx908::acc84, output_vec_len );
            case 341:  return makeRegisterExpression(amdgpu_gfx908::acc85, output_vec_len );
            case 342:  return makeRegisterExpression(amdgpu_gfx908::acc86, output_vec_len );
            case 343:  return makeRegisterExpression(amdgpu_gfx908::acc87, output_vec_len );
            case 344:  return makeRegisterExpression(amdgpu_gfx908::acc88, output_vec_len );
            case 345:  return makeRegisterExpression(amdgpu_gfx908::acc89, output_vec_len );
            case 346:  return makeRegisterExpression(amdgpu_gfx908::acc90, output_vec_len );
            case 347:  return makeRegisterExpression(amdgpu_gfx908::acc91, output_vec_len );
            case 348:  return makeRegisterExpression(amdgpu_gfx908::acc92, output_vec_len );
            case 349:  return makeRegisterExpression(amdgpu_gfx908::acc93, output_vec_len );
            case 350:  return makeRegisterExpression(amdgpu_gfx908::acc94, output_vec_len );
            case 351:  return makeRegisterExpression(amdgpu_gfx908::acc95, output_vec_len );
            case 352:  return makeRegisterExpression(amdgpu_gfx908::acc96, output_vec_len );
            case 353:  return makeRegisterExpression(amdgpu_gfx908::acc97, output_vec_len );
            case 354:  return makeRegisterExpression(amdgpu_gfx908::acc98, output_vec_len );
            case 355:  return makeRegisterExpression(amdgpu_gfx908::acc99, output_vec_len );
            case 356:  return makeRegisterExpression(amdgpu_gfx908::acc100, output_vec_len );
            case 357:  return makeRegisterExpression(amdgpu_gfx908::acc101, output_vec_len );
            case 358:  return makeRegisterExpression(amdgpu_gfx908::acc102, output_vec_len );
            case 359:  return makeRegisterExpression(amdgpu_gfx908::acc103, output_vec_len );
            case 360:  return makeRegisterExpression(amdgpu_gfx908::acc104, output_vec_len );
            case 361:  return makeRegisterExpression(amdgpu_gfx908::acc105, output_vec_len );
            case 362:  return makeRegisterExpression(amdgpu_gfx908::acc106, output_vec_len );
            case 363:  return makeRegisterExpression(amdgpu_gfx908::acc107, output_vec_len );
            case 364:  return makeRegisterExpression(amdgpu_gfx908::acc108, output_vec_len );
            case 365:  return makeRegisterExpression(amdgpu_gfx908::acc109, output_vec_len );
            case 366:  return makeRegisterExpression(amdgpu_gfx908::acc110, output_vec_len );
            case 367:  return makeRegisterExpression(amdgpu_gfx908::acc111, output_vec_len );
            case 368:  return makeRegisterExpression(amdgpu_gfx908::acc112, output_vec_len );
            case 369:  return makeRegisterExpression(amdgpu_gfx908::acc113, output_vec_len );
            case 370:  return makeRegisterExpression(amdgpu_gfx908::acc114, output_vec_len );
            case 371:  return makeRegisterExpression(amdgpu_gfx908::acc115, output_vec_len );
            case 372:  return makeRegisterExpression(amdgpu_gfx908::acc116, output_vec_len );
            case 373:  return makeRegisterExpression(amdgpu_gfx908::acc117, output_vec_len );
            case 374:  return makeRegisterExpression(amdgpu_gfx908::acc118, output_vec_len );
            case 375:  return makeRegisterExpression(amdgpu_gfx908::acc119, output_vec_len );
            case 376:  return makeRegisterExpression(amdgpu_gfx908::acc120, output_vec_len );
            case 377:  return makeRegisterExpression(amdgpu_gfx908::acc121, output_vec_len );
            case 378:  return makeRegisterExpression(amdgpu_gfx908::acc122, output_vec_len );
            case 379:  return makeRegisterExpression(amdgpu_gfx908::acc123, output_vec_len );
            case 380:  return makeRegisterExpression(amdgpu_gfx908::acc124, output_vec_len );
            case 381:  return makeRegisterExpression(amdgpu_gfx908::acc125, output_vec_len );
            case 382:  return makeRegisterExpression(amdgpu_gfx908::acc126, output_vec_len );
            case 383:  return makeRegisterExpression(amdgpu_gfx908::acc127, output_vec_len );
            case 384:  return makeRegisterExpression(amdgpu_gfx908::acc128, output_vec_len );
            case 385:  return makeRegisterExpression(amdgpu_gfx908::acc129, output_vec_len );
            case 386:  return makeRegisterExpression(amdgpu_gfx908::acc130, output_vec_len );
            case 387:  return makeRegisterExpression(amdgpu_gfx908::acc131, output_vec_len );
            case 388:  return makeRegisterExpression(amdgpu_gfx908::acc132, output_vec_len );
            case 389:  return makeRegisterExpression(amdgpu_gfx908::acc133, output_vec_len );
            case 390:  return makeRegisterExpression(amdgpu_gfx908::acc134, output_vec_len );
            case 391:  return makeRegisterExpression(amdgpu_gfx908::acc135, output_vec_len );
            case 392:  return makeRegisterExpression(amdgpu_gfx908::acc136, output_vec_len );
            case 393:  return makeRegisterExpression(amdgpu_gfx908::acc137, output_vec_len );
            case 394:  return makeRegisterExpression(amdgpu_gfx908::acc138, output_vec_len );
            case 395:  return makeRegisterExpression(amdgpu_gfx908::acc139, output_vec_len );
            case 396:  return makeRegisterExpression(amdgpu_gfx908::acc140, output_vec_len );
            case 397:  return makeRegisterExpression(amdgpu_gfx908::acc141, output_vec_len );
            case 398:  return makeRegisterExpression(amdgpu_gfx908::acc142, output_vec_len );
            case 399:  return makeRegisterExpression(amdgpu_gfx908::acc143, output_vec_len );
            case 400:  return makeRegisterExpression(amdgpu_gfx908::acc144, output_vec_len );
            case 401:  return makeRegisterExpression(amdgpu_gfx908::acc145, output_vec_len );
            case 402:  return makeRegisterExpression(amdgpu_gfx908::acc146, output_vec_len );
            case 403:  return makeRegisterExpression(amdgpu_gfx908::acc147, output_vec_len );
            case 404:  return makeRegisterExpression(amdgpu_gfx908::acc148, output_vec_len );
            case 405:  return makeRegisterExpression(amdgpu_gfx908::acc149, output_vec_len );
            case 406:  return makeRegisterExpression(amdgpu_gfx908::acc150, output_vec_len );
            case 407:  return makeRegisterExpression(amdgpu_gfx908::acc151, output_vec_len );
            case 408:  return makeRegisterExpression(amdgpu_gfx908::acc152, output_vec_len );
            case 409:  return makeRegisterExpression(amdgpu_gfx908::acc153, output_vec_len );
            case 410:  return makeRegisterExpression(amdgpu_gfx908::acc154, output_vec_len );
            case 411:  return makeRegisterExpression(amdgpu_gfx908::acc155, output_vec_len );
            case 412:  return makeRegisterExpression(amdgpu_gfx908::acc156, output_vec_len );
            case 413:  return makeRegisterExpression(amdgpu_gfx908::acc157, output_vec_len );
            case 414:  return makeRegisterExpression(amdgpu_gfx908::acc158, output_vec_len );
            case 415:  return makeRegisterExpression(amdgpu_gfx908::acc159, output_vec_len );
            case 416:  return makeRegisterExpression(amdgpu_gfx908::acc160, output_vec_len );
            case 417:  return makeRegisterExpression(amdgpu_gfx908::acc161, output_vec_len );
            case 418:  return makeRegisterExpression(amdgpu_gfx908::acc162, output_vec_len );
            case 419:  return makeRegisterExpression(amdgpu_gfx908::acc163, output_vec_len );
            case 420:  return makeRegisterExpression(amdgpu_gfx908::acc164, output_vec_len );
            case 421:  return makeRegisterExpression(amdgpu_gfx908::acc165, output_vec_len );
            case 422:  return makeRegisterExpression(amdgpu_gfx908::acc166, output_vec_len );
            case 423:  return makeRegisterExpression(amdgpu_gfx908::acc167, output_vec_len );
            case 424:  return makeRegisterExpression(amdgpu_gfx908::acc168, output_vec_len );
            case 425:  return makeRegisterExpression(amdgpu_gfx908::acc169, output_vec_len );
            case 426:  return makeRegisterExpression(amdgpu_gfx908::acc170, output_vec_len );
            case 427:  return makeRegisterExpression(amdgpu_gfx908::acc171, output_vec_len );
            case 428:  return makeRegisterExpression(amdgpu_gfx908::acc172, output_vec_len );
            case 429:  return makeRegisterExpression(amdgpu_gfx908::acc173, output_vec_len );
            case 430:  return makeRegisterExpression(amdgpu_gfx908::acc174, output_vec_len );
            case 431:  return makeRegisterExpression(amdgpu_gfx908::acc175, output_vec_len );
            case 432:  return makeRegisterExpression(amdgpu_gfx908::acc176, output_vec_len );
            case 433:  return makeRegisterExpression(amdgpu_gfx908::acc177, output_vec_len );
            case 434:  return makeRegisterExpression(amdgpu_gfx908::acc178, output_vec_len );
            case 435:  return makeRegisterExpression(amdgpu_gfx908::acc179, output_vec_len );
            case 436:  return makeRegisterExpression(amdgpu_gfx908::acc180, output_vec_len );
            case 437:  return makeRegisterExpression(amdgpu_gfx908::acc181, output_vec_len );
            case 438:  return makeRegisterExpression(amdgpu_gfx908::acc182, output_vec_len );
            case 439:  return makeRegisterExpression(amdgpu_gfx908::acc183, output_vec_len );
            case 440:  return makeRegisterExpression(amdgpu_gfx908::acc184, output_vec_len );
            case 441:  return makeRegisterExpression(amdgpu_gfx908::acc185, output_vec_len );
            case 442:  return makeRegisterExpression(amdgpu_gfx908::acc186, output_vec_len );
            case 443:  return makeRegisterExpression(amdgpu_gfx908::acc187, output_vec_len );
            case 444:  return makeRegisterExpression(amdgpu_gfx908::acc188, output_vec_len );
            case 445:  return makeRegisterExpression(amdgpu_gfx908::acc189, output_vec_len );
            case 446:  return makeRegisterExpression(amdgpu_gfx908::acc190, output_vec_len );
            case 447:  return makeRegisterExpression(amdgpu_gfx908::acc191, output_vec_len );
            case 448:  return makeRegisterExpression(amdgpu_gfx908::acc192, output_vec_len );
            case 449:  return makeRegisterExpression(amdgpu_gfx908::acc193, output_vec_len );
            case 450:  return makeRegisterExpression(amdgpu_gfx908::acc194, output_vec_len );
            case 451:  return makeRegisterExpression(amdgpu_gfx908::acc195, output_vec_len );
            case 452:  return makeRegisterExpression(amdgpu_gfx908::acc196, output_vec_len );
            case 453:  return makeRegisterExpression(amdgpu_gfx908::acc197, output_vec_len );
            case 454:  return makeRegisterExpression(amdgpu_gfx908::acc198, output_vec_len );
            case 455:  return makeRegisterExpression(amdgpu_gfx908::acc199, output_vec_len );
            case 456:  return makeRegisterExpression(amdgpu_gfx908::acc200, output_vec_len );
            case 457:  return makeRegisterExpression(amdgpu_gfx908::acc201, output_vec_len );
            case 458:  return makeRegisterExpression(amdgpu_gfx908::acc202, output_vec_len );
            case 459:  return makeRegisterExpression(amdgpu_gfx908::acc203, output_vec_len );
            case 460:  return makeRegisterExpression(amdgpu_gfx908::acc204, output_vec_len );
            case 461:  return makeRegisterExpression(amdgpu_gfx908::acc205, output_vec_len );
            case 462:  return makeRegisterExpression(amdgpu_gfx908::acc206, output_vec_len );
            case 463:  return makeRegisterExpression(amdgpu_gfx908::acc207, output_vec_len );
            case 464:  return makeRegisterExpression(amdgpu_gfx908::acc208, output_vec_len );
            case 465:  return makeRegisterExpression(amdgpu_gfx908::acc209, output_vec_len );
            case 466:  return makeRegisterExpression(amdgpu_gfx908::acc210, output_vec_len );
            case 467:  return makeRegisterExpression(amdgpu_gfx908::acc211, output_vec_len );
            case 468:  return makeRegisterExpression(amdgpu_gfx908::acc212, output_vec_len );
            case 469:  return makeRegisterExpression(amdgpu_gfx908::acc213, output_vec_len );
            case 470:  return makeRegisterExpression(amdgpu_gfx908::acc214, output_vec_len );
            case 471:  return makeRegisterExpression(amdgpu_gfx908::acc215, output_vec_len );
            case 472:  return makeRegisterExpression(amdgpu_gfx908::acc216, output_vec_len );
            case 473:  return makeRegisterExpression(amdgpu_gfx908::acc217, output_vec_len );
            case 474:  return makeRegisterExpression(amdgpu_gfx908::acc218, output_vec_len );
            case 475:  return makeRegisterExpression(amdgpu_gfx908::acc219, output_vec_len );
            case 476:  return makeRegisterExpression(amdgpu_gfx908::acc220, output_vec_len );
            case 477:  return makeRegisterExpression(amdgpu_gfx908::acc221, output_vec_len );
            case 478:  return makeRegisterExpression(amdgpu_gfx908::acc222, output_vec_len );
            case 479:  return makeRegisterExpression(amdgpu_gfx908::acc223, output_vec_len );
            case 480:  return makeRegisterExpression(amdgpu_gfx908::acc224, output_vec_len );
            case 481:  return makeRegisterExpression(amdgpu_gfx908::acc225, output_vec_len );
            case 482:  return makeRegisterExpression(amdgpu_gfx908::acc226, output_vec_len );
            case 483:  return makeRegisterExpression(amdgpu_gfx908::acc227, output_vec_len );
            case 484:  return makeRegisterExpression(amdgpu_gfx908::acc228, output_vec_len );
            case 485:  return makeRegisterExpression(amdgpu_gfx908::acc229, output_vec_len );
            case 486:  return makeRegisterExpression(amdgpu_gfx908::acc230, output_vec_len );
            case 487:  return makeRegisterExpression(amdgpu_gfx908::acc231, output_vec_len );
            case 488:  return makeRegisterExpression(amdgpu_gfx908::acc232, output_vec_len );
            case 489:  return makeRegisterExpression(amdgpu_gfx908::acc233, output_vec_len );
            case 490:  return makeRegisterExpression(amdgpu_gfx908::acc234, output_vec_len );
            case 491:  return makeRegisterExpression(amdgpu_gfx908::acc235, output_vec_len );
            case 492:  return makeRegisterExpression(amdgpu_gfx908::acc236, output_vec_len );
            case 493:  return makeRegisterExpression(amdgpu_gfx908::acc237, output_vec_len );
            case 494:  return makeRegisterExpression(amdgpu_gfx908::acc238, output_vec_len );
            case 495:  return makeRegisterExpression(amdgpu_gfx908::acc239, output_vec_len );
            case 496:  return makeRegisterExpression(amdgpu_gfx908::acc240, output_vec_len );
            case 497:  return makeRegisterExpression(amdgpu_gfx908::acc241, output_vec_len );
            case 498:  return makeRegisterExpression(amdgpu_gfx908::acc242, output_vec_len );
            case 499:  return makeRegisterExpression(amdgpu_gfx908::acc243, output_vec_len );
            case 500:  return makeRegisterExpression(amdgpu_gfx908::acc244, output_vec_len );
            case 501:  return makeRegisterExpression(amdgpu_gfx908::acc245, output_vec_len );
            case 502:  return makeRegisterExpression(amdgpu_gfx908::acc246, output_vec_len );
            case 503:  return makeRegisterExpression(amdgpu_gfx908::acc247, output_vec_len );
            case 504:  return makeRegisterExpression(amdgpu_gfx908::acc248, output_vec_len );
            case 505:  return makeRegisterExpression(amdgpu_gfx908::acc249, output_vec_len );
            case 506:  return makeRegisterExpression(amdgpu_gfx908::acc250, output_vec_len );
            case 507:  return makeRegisterExpression(amdgpu_gfx908::acc251, output_vec_len );
            case 508:  return makeRegisterExpression(amdgpu_gfx908::acc252, output_vec_len );
            case 509:  return makeRegisterExpression(amdgpu_gfx908::acc253, output_vec_len );
            case 510:  return makeRegisterExpression(amdgpu_gfx908::acc254, output_vec_len );
            case 511:  return makeRegisterExpression(amdgpu_gfx908::acc255, output_vec_len );
            case 768:  return makeRegisterExpression(amdgpu_gfx908::acc0, output_vec_len );
            case 769:  return makeRegisterExpression(amdgpu_gfx908::acc1, output_vec_len );
            case 770:  return makeRegisterExpression(amdgpu_gfx908::acc2, output_vec_len );
            case 771:  return makeRegisterExpression(amdgpu_gfx908::acc3, output_vec_len );
            case 772:  return makeRegisterExpression(amdgpu_gfx908::acc4, output_vec_len );
            case 773:  return makeRegisterExpression(amdgpu_gfx908::acc5, output_vec_len );
            case 774:  return makeRegisterExpression(amdgpu_gfx908::acc6, output_vec_len );
            case 775:  return makeRegisterExpression(amdgpu_gfx908::acc7, output_vec_len );
            case 776:  return makeRegisterExpression(amdgpu_gfx908::acc8, output_vec_len );
            case 777:  return makeRegisterExpression(amdgpu_gfx908::acc9, output_vec_len );
            case 778:  return makeRegisterExpression(amdgpu_gfx908::acc10, output_vec_len );
            case 779:  return makeRegisterExpression(amdgpu_gfx908::acc11, output_vec_len );
            case 780:  return makeRegisterExpression(amdgpu_gfx908::acc12, output_vec_len );
            case 781:  return makeRegisterExpression(amdgpu_gfx908::acc13, output_vec_len );
            case 782:  return makeRegisterExpression(amdgpu_gfx908::acc14, output_vec_len );
            case 783:  return makeRegisterExpression(amdgpu_gfx908::acc15, output_vec_len );
            case 784:  return makeRegisterExpression(amdgpu_gfx908::acc16, output_vec_len );
            case 785:  return makeRegisterExpression(amdgpu_gfx908::acc17, output_vec_len );
            case 786:  return makeRegisterExpression(amdgpu_gfx908::acc18, output_vec_len );
            case 787:  return makeRegisterExpression(amdgpu_gfx908::acc19, output_vec_len );
            case 788:  return makeRegisterExpression(amdgpu_gfx908::acc20, output_vec_len );
            case 789:  return makeRegisterExpression(amdgpu_gfx908::acc21, output_vec_len );
            case 790:  return makeRegisterExpression(amdgpu_gfx908::acc22, output_vec_len );
            case 791:  return makeRegisterExpression(amdgpu_gfx908::acc23, output_vec_len );
            case 792:  return makeRegisterExpression(amdgpu_gfx908::acc24, output_vec_len );
            case 793:  return makeRegisterExpression(amdgpu_gfx908::acc25, output_vec_len );
            case 794:  return makeRegisterExpression(amdgpu_gfx908::acc26, output_vec_len );
            case 795:  return makeRegisterExpression(amdgpu_gfx908::acc27, output_vec_len );
            case 796:  return makeRegisterExpression(amdgpu_gfx908::acc28, output_vec_len );
            case 797:  return makeRegisterExpression(amdgpu_gfx908::acc29, output_vec_len );
            case 798:  return makeRegisterExpression(amdgpu_gfx908::acc30, output_vec_len );
            case 799:  return makeRegisterExpression(amdgpu_gfx908::acc31, output_vec_len );
            case 800:  return makeRegisterExpression(amdgpu_gfx908::acc32, output_vec_len );
            case 801:  return makeRegisterExpression(amdgpu_gfx908::acc33, output_vec_len );
            case 802:  return makeRegisterExpression(amdgpu_gfx908::acc34, output_vec_len );
            case 803:  return makeRegisterExpression(amdgpu_gfx908::acc35, output_vec_len );
            case 804:  return makeRegisterExpression(amdgpu_gfx908::acc36, output_vec_len );
            case 805:  return makeRegisterExpression(amdgpu_gfx908::acc37, output_vec_len );
            case 806:  return makeRegisterExpression(amdgpu_gfx908::acc38, output_vec_len );
            case 807:  return makeRegisterExpression(amdgpu_gfx908::acc39, output_vec_len );
            case 808:  return makeRegisterExpression(amdgpu_gfx908::acc40, output_vec_len );
            case 809:  return makeRegisterExpression(amdgpu_gfx908::acc41, output_vec_len );
            case 810:  return makeRegisterExpression(amdgpu_gfx908::acc42, output_vec_len );
            case 811:  return makeRegisterExpression(amdgpu_gfx908::acc43, output_vec_len );
            case 812:  return makeRegisterExpression(amdgpu_gfx908::acc44, output_vec_len );
            case 813:  return makeRegisterExpression(amdgpu_gfx908::acc45, output_vec_len );
            case 814:  return makeRegisterExpression(amdgpu_gfx908::acc46, output_vec_len );
            case 815:  return makeRegisterExpression(amdgpu_gfx908::acc47, output_vec_len );
            case 816:  return makeRegisterExpression(amdgpu_gfx908::acc48, output_vec_len );
            case 817:  return makeRegisterExpression(amdgpu_gfx908::acc49, output_vec_len );
            case 818:  return makeRegisterExpression(amdgpu_gfx908::acc50, output_vec_len );
            case 819:  return makeRegisterExpression(amdgpu_gfx908::acc51, output_vec_len );
            case 820:  return makeRegisterExpression(amdgpu_gfx908::acc52, output_vec_len );
            case 821:  return makeRegisterExpression(amdgpu_gfx908::acc53, output_vec_len );
            case 822:  return makeRegisterExpression(amdgpu_gfx908::acc54, output_vec_len );
            case 823:  return makeRegisterExpression(amdgpu_gfx908::acc55, output_vec_len );
            case 824:  return makeRegisterExpression(amdgpu_gfx908::acc56, output_vec_len );
            case 825:  return makeRegisterExpression(amdgpu_gfx908::acc57, output_vec_len );
            case 826:  return makeRegisterExpression(amdgpu_gfx908::acc58, output_vec_len );
            case 827:  return makeRegisterExpression(amdgpu_gfx908::acc59, output_vec_len );
            case 828:  return makeRegisterExpression(amdgpu_gfx908::acc60, output_vec_len );
            case 829:  return makeRegisterExpression(amdgpu_gfx908::acc61, output_vec_len );
            case 830:  return makeRegisterExpression(amdgpu_gfx908::acc62, output_vec_len );
            case 831:  return makeRegisterExpression(amdgpu_gfx908::acc63, output_vec_len );
            case 832:  return makeRegisterExpression(amdgpu_gfx908::acc64, output_vec_len );
            case 833:  return makeRegisterExpression(amdgpu_gfx908::acc65, output_vec_len );
            case 834:  return makeRegisterExpression(amdgpu_gfx908::acc66, output_vec_len );
            case 835:  return makeRegisterExpression(amdgpu_gfx908::acc67, output_vec_len );
            case 836:  return makeRegisterExpression(amdgpu_gfx908::acc68, output_vec_len );
            case 837:  return makeRegisterExpression(amdgpu_gfx908::acc69, output_vec_len );
            case 838:  return makeRegisterExpression(amdgpu_gfx908::acc70, output_vec_len );
            case 839:  return makeRegisterExpression(amdgpu_gfx908::acc71, output_vec_len );
            case 840:  return makeRegisterExpression(amdgpu_gfx908::acc72, output_vec_len );
            case 841:  return makeRegisterExpression(amdgpu_gfx908::acc73, output_vec_len );
            case 842:  return makeRegisterExpression(amdgpu_gfx908::acc74, output_vec_len );
            case 843:  return makeRegisterExpression(amdgpu_gfx908::acc75, output_vec_len );
            case 844:  return makeRegisterExpression(amdgpu_gfx908::acc76, output_vec_len );
            case 845:  return makeRegisterExpression(amdgpu_gfx908::acc77, output_vec_len );
            case 846:  return makeRegisterExpression(amdgpu_gfx908::acc78, output_vec_len );
            case 847:  return makeRegisterExpression(amdgpu_gfx908::acc79, output_vec_len );
            case 848:  return makeRegisterExpression(amdgpu_gfx908::acc80, output_vec_len );
            case 849:  return makeRegisterExpression(amdgpu_gfx908::acc81, output_vec_len );
            case 850:  return makeRegisterExpression(amdgpu_gfx908::acc82, output_vec_len );
            case 851:  return makeRegisterExpression(amdgpu_gfx908::acc83, output_vec_len );
            case 852:  return makeRegisterExpression(amdgpu_gfx908::acc84, output_vec_len );
            case 853:  return makeRegisterExpression(amdgpu_gfx908::acc85, output_vec_len );
            case 854:  return makeRegisterExpression(amdgpu_gfx908::acc86, output_vec_len );
            case 855:  return makeRegisterExpression(amdgpu_gfx908::acc87, output_vec_len );
            case 856:  return makeRegisterExpression(amdgpu_gfx908::acc88, output_vec_len );
            case 857:  return makeRegisterExpression(amdgpu_gfx908::acc89, output_vec_len );
            case 858:  return makeRegisterExpression(amdgpu_gfx908::acc90, output_vec_len );
            case 859:  return makeRegisterExpression(amdgpu_gfx908::acc91, output_vec_len );
            case 860:  return makeRegisterExpression(amdgpu_gfx908::acc92, output_vec_len );
            case 861:  return makeRegisterExpression(amdgpu_gfx908::acc93, output_vec_len );
            case 862:  return makeRegisterExpression(amdgpu_gfx908::acc94, output_vec_len );
            case 863:  return makeRegisterExpression(amdgpu_gfx908::acc95, output_vec_len );
            case 864:  return makeRegisterExpression(amdgpu_gfx908::acc96, output_vec_len );
            case 865:  return makeRegisterExpression(amdgpu_gfx908::acc97, output_vec_len );
            case 866:  return makeRegisterExpression(amdgpu_gfx908::acc98, output_vec_len );
            case 867:  return makeRegisterExpression(amdgpu_gfx908::acc99, output_vec_len );
            case 868:  return makeRegisterExpression(amdgpu_gfx908::acc100, output_vec_len );
            case 869:  return makeRegisterExpression(amdgpu_gfx908::acc101, output_vec_len );
            case 870:  return makeRegisterExpression(amdgpu_gfx908::acc102, output_vec_len );
            case 871:  return makeRegisterExpression(amdgpu_gfx908::acc103, output_vec_len );
            case 872:  return makeRegisterExpression(amdgpu_gfx908::acc104, output_vec_len );
            case 873:  return makeRegisterExpression(amdgpu_gfx908::acc105, output_vec_len );
            case 874:  return makeRegisterExpression(amdgpu_gfx908::acc106, output_vec_len );
            case 875:  return makeRegisterExpression(amdgpu_gfx908::acc107, output_vec_len );
            case 876:  return makeRegisterExpression(amdgpu_gfx908::acc108, output_vec_len );
            case 877:  return makeRegisterExpression(amdgpu_gfx908::acc109, output_vec_len );
            case 878:  return makeRegisterExpression(amdgpu_gfx908::acc110, output_vec_len );
            case 879:  return makeRegisterExpression(amdgpu_gfx908::acc111, output_vec_len );
            case 880:  return makeRegisterExpression(amdgpu_gfx908::acc112, output_vec_len );
            case 881:  return makeRegisterExpression(amdgpu_gfx908::acc113, output_vec_len );
            case 882:  return makeRegisterExpression(amdgpu_gfx908::acc114, output_vec_len );
            case 883:  return makeRegisterExpression(amdgpu_gfx908::acc115, output_vec_len );
            case 884:  return makeRegisterExpression(amdgpu_gfx908::acc116, output_vec_len );
            case 885:  return makeRegisterExpression(amdgpu_gfx908::acc117, output_vec_len );
            case 886:  return makeRegisterExpression(amdgpu_gfx908::acc118, output_vec_len );
            case 887:  return makeRegisterExpression(amdgpu_gfx908::acc119, output_vec_len );
            case 888:  return makeRegisterExpression(amdgpu_gfx908::acc120, output_vec_len );
            case 889:  return makeRegisterExpression(amdgpu_gfx908::acc121, output_vec_len );
            case 890:  return makeRegisterExpression(amdgpu_gfx908::acc122, output_vec_len );
            case 891:  return makeRegisterExpression(amdgpu_gfx908::acc123, output_vec_len );
            case 892:  return makeRegisterExpression(amdgpu_gfx908::acc124, output_vec_len );
            case 893:  return makeRegisterExpression(amdgpu_gfx908::acc125, output_vec_len );
            case 894:  return makeRegisterExpression(amdgpu_gfx908::acc126, output_vec_len );
            case 895:  return makeRegisterExpression(amdgpu_gfx908::acc127, output_vec_len );
            case 896:  return makeRegisterExpression(amdgpu_gfx908::acc128, output_vec_len );
            case 897:  return makeRegisterExpression(amdgpu_gfx908::acc129, output_vec_len );
            case 898:  return makeRegisterExpression(amdgpu_gfx908::acc130, output_vec_len );
            case 899:  return makeRegisterExpression(amdgpu_gfx908::acc131, output_vec_len );
            case 900:  return makeRegisterExpression(amdgpu_gfx908::acc132, output_vec_len );
            case 901:  return makeRegisterExpression(amdgpu_gfx908::acc133, output_vec_len );
            case 902:  return makeRegisterExpression(amdgpu_gfx908::acc134, output_vec_len );
            case 903:  return makeRegisterExpression(amdgpu_gfx908::acc135, output_vec_len );
            case 904:  return makeRegisterExpression(amdgpu_gfx908::acc136, output_vec_len );
            case 905:  return makeRegisterExpression(amdgpu_gfx908::acc137, output_vec_len );
            case 906:  return makeRegisterExpression(amdgpu_gfx908::acc138, output_vec_len );
            case 907:  return makeRegisterExpression(amdgpu_gfx908::acc139, output_vec_len );
            case 908:  return makeRegisterExpression(amdgpu_gfx908::acc140, output_vec_len );
            case 909:  return makeRegisterExpression(amdgpu_gfx908::acc141, output_vec_len );
            case 910:  return makeRegisterExpression(amdgpu_gfx908::acc142, output_vec_len );
            case 911:  return makeRegisterExpression(amdgpu_gfx908::acc143, output_vec_len );
            case 912:  return makeRegisterExpression(amdgpu_gfx908::acc144, output_vec_len );
            case 913:  return makeRegisterExpression(amdgpu_gfx908::acc145, output_vec_len );
            case 914:  return makeRegisterExpression(amdgpu_gfx908::acc146, output_vec_len );
            case 915:  return makeRegisterExpression(amdgpu_gfx908::acc147, output_vec_len );
            case 916:  return makeRegisterExpression(amdgpu_gfx908::acc148, output_vec_len );
            case 917:  return makeRegisterExpression(amdgpu_gfx908::acc149, output_vec_len );
            case 918:  return makeRegisterExpression(amdgpu_gfx908::acc150, output_vec_len );
            case 919:  return makeRegisterExpression(amdgpu_gfx908::acc151, output_vec_len );
            case 920:  return makeRegisterExpression(amdgpu_gfx908::acc152, output_vec_len );
            case 921:  return makeRegisterExpression(amdgpu_gfx908::acc153, output_vec_len );
            case 922:  return makeRegisterExpression(amdgpu_gfx908::acc154, output_vec_len );
            case 923:  return makeRegisterExpression(amdgpu_gfx908::acc155, output_vec_len );
            case 924:  return makeRegisterExpression(amdgpu_gfx908::acc156, output_vec_len );
            case 925:  return makeRegisterExpression(amdgpu_gfx908::acc157, output_vec_len );
            case 926:  return makeRegisterExpression(amdgpu_gfx908::acc158, output_vec_len );
            case 927:  return makeRegisterExpression(amdgpu_gfx908::acc159, output_vec_len );
            case 928:  return makeRegisterExpression(amdgpu_gfx908::acc160, output_vec_len );
            case 929:  return makeRegisterExpression(amdgpu_gfx908::acc161, output_vec_len );
            case 930:  return makeRegisterExpression(amdgpu_gfx908::acc162, output_vec_len );
            case 931:  return makeRegisterExpression(amdgpu_gfx908::acc163, output_vec_len );
            case 932:  return makeRegisterExpression(amdgpu_gfx908::acc164, output_vec_len );
            case 933:  return makeRegisterExpression(amdgpu_gfx908::acc165, output_vec_len );
            case 934:  return makeRegisterExpression(amdgpu_gfx908::acc166, output_vec_len );
            case 935:  return makeRegisterExpression(amdgpu_gfx908::acc167, output_vec_len );
            case 936:  return makeRegisterExpression(amdgpu_gfx908::acc168, output_vec_len );
            case 937:  return makeRegisterExpression(amdgpu_gfx908::acc169, output_vec_len );
            case 938:  return makeRegisterExpression(amdgpu_gfx908::acc170, output_vec_len );
            case 939:  return makeRegisterExpression(amdgpu_gfx908::acc171, output_vec_len );
            case 940:  return makeRegisterExpression(amdgpu_gfx908::acc172, output_vec_len );
            case 941:  return makeRegisterExpression(amdgpu_gfx908::acc173, output_vec_len );
            case 942:  return makeRegisterExpression(amdgpu_gfx908::acc174, output_vec_len );
            case 943:  return makeRegisterExpression(amdgpu_gfx908::acc175, output_vec_len );
            case 944:  return makeRegisterExpression(amdgpu_gfx908::acc176, output_vec_len );
            case 945:  return makeRegisterExpression(amdgpu_gfx908::acc177, output_vec_len );
            case 946:  return makeRegisterExpression(amdgpu_gfx908::acc178, output_vec_len );
            case 947:  return makeRegisterExpression(amdgpu_gfx908::acc179, output_vec_len );
            case 948:  return makeRegisterExpression(amdgpu_gfx908::acc180, output_vec_len );
            case 949:  return makeRegisterExpression(amdgpu_gfx908::acc181, output_vec_len );
            case 950:  return makeRegisterExpression(amdgpu_gfx908::acc182, output_vec_len );
            case 951:  return makeRegisterExpression(amdgpu_gfx908::acc183, output_vec_len );
            case 952:  return makeRegisterExpression(amdgpu_gfx908::acc184, output_vec_len );
            case 953:  return makeRegisterExpression(amdgpu_gfx908::acc185, output_vec_len );
            case 954:  return makeRegisterExpression(amdgpu_gfx908::acc186, output_vec_len );
            case 955:  return makeRegisterExpression(amdgpu_gfx908::acc187, output_vec_len );
            case 956:  return makeRegisterExpression(amdgpu_gfx908::acc188, output_vec_len );
            case 957:  return makeRegisterExpression(amdgpu_gfx908::acc189, output_vec_len );
            case 958:  return makeRegisterExpression(amdgpu_gfx908::acc190, output_vec_len );
            case 959:  return makeRegisterExpression(amdgpu_gfx908::acc191, output_vec_len );
            case 960:  return makeRegisterExpression(amdgpu_gfx908::acc192, output_vec_len );
            case 961:  return makeRegisterExpression(amdgpu_gfx908::acc193, output_vec_len );
            case 962:  return makeRegisterExpression(amdgpu_gfx908::acc194, output_vec_len );
            case 963:  return makeRegisterExpression(amdgpu_gfx908::acc195, output_vec_len );
            case 964:  return makeRegisterExpression(amdgpu_gfx908::acc196, output_vec_len );
            case 965:  return makeRegisterExpression(amdgpu_gfx908::acc197, output_vec_len );
            case 966:  return makeRegisterExpression(amdgpu_gfx908::acc198, output_vec_len );
            case 967:  return makeRegisterExpression(amdgpu_gfx908::acc199, output_vec_len );
            case 968:  return makeRegisterExpression(amdgpu_gfx908::acc200, output_vec_len );
            case 969:  return makeRegisterExpression(amdgpu_gfx908::acc201, output_vec_len );
            case 970:  return makeRegisterExpression(amdgpu_gfx908::acc202, output_vec_len );
            case 971:  return makeRegisterExpression(amdgpu_gfx908::acc203, output_vec_len );
            case 972:  return makeRegisterExpression(amdgpu_gfx908::acc204, output_vec_len );
            case 973:  return makeRegisterExpression(amdgpu_gfx908::acc205, output_vec_len );
            case 974:  return makeRegisterExpression(amdgpu_gfx908::acc206, output_vec_len );
            case 975:  return makeRegisterExpression(amdgpu_gfx908::acc207, output_vec_len );
            case 976:  return makeRegisterExpression(amdgpu_gfx908::acc208, output_vec_len );
            case 977:  return makeRegisterExpression(amdgpu_gfx908::acc209, output_vec_len );
            case 978:  return makeRegisterExpression(amdgpu_gfx908::acc210, output_vec_len );
            case 979:  return makeRegisterExpression(amdgpu_gfx908::acc211, output_vec_len );
            case 980:  return makeRegisterExpression(amdgpu_gfx908::acc212, output_vec_len );
            case 981:  return makeRegisterExpression(amdgpu_gfx908::acc213, output_vec_len );
            case 982:  return makeRegisterExpression(amdgpu_gfx908::acc214, output_vec_len );
            case 983:  return makeRegisterExpression(amdgpu_gfx908::acc215, output_vec_len );
            case 984:  return makeRegisterExpression(amdgpu_gfx908::acc216, output_vec_len );
            case 985:  return makeRegisterExpression(amdgpu_gfx908::acc217, output_vec_len );
            case 986:  return makeRegisterExpression(amdgpu_gfx908::acc218, output_vec_len );
            case 987:  return makeRegisterExpression(amdgpu_gfx908::acc219, output_vec_len );
            case 988:  return makeRegisterExpression(amdgpu_gfx908::acc220, output_vec_len );
            case 989:  return makeRegisterExpression(amdgpu_gfx908::acc221, output_vec_len );
            case 990:  return makeRegisterExpression(amdgpu_gfx908::acc222, output_vec_len );
            case 991:  return makeRegisterExpression(amdgpu_gfx908::acc223, output_vec_len );
            case 992:  return makeRegisterExpression(amdgpu_gfx908::acc224, output_vec_len );
            case 993:  return makeRegisterExpression(amdgpu_gfx908::acc225, output_vec_len );
            case 994:  return makeRegisterExpression(amdgpu_gfx908::acc226, output_vec_len );
            case 995:  return makeRegisterExpression(amdgpu_gfx908::acc227, output_vec_len );
            case 996:  return makeRegisterExpression(amdgpu_gfx908::acc228, output_vec_len );
            case 997:  return makeRegisterExpression(amdgpu_gfx908::acc229, output_vec_len );
            case 998:  return makeRegisterExpression(amdgpu_gfx908::acc230, output_vec_len );
            case 999:  return makeRegisterExpression(amdgpu_gfx908::acc231, output_vec_len );
            case 1000:  return makeRegisterExpression(amdgpu_gfx908::acc232, output_vec_len );
            case 1001:  return makeRegisterExpression(amdgpu_gfx908::acc233, output_vec_len );
            case 1002:  return makeRegisterExpression(amdgpu_gfx908::acc234, output_vec_len );
            case 1003:  return makeRegisterExpression(amdgpu_gfx908::acc235, output_vec_len );
            case 1004:  return makeRegisterExpression(amdgpu_gfx908::acc236, output_vec_len );
            case 1005:  return makeRegisterExpression(amdgpu_gfx908::acc237, output_vec_len );
            case 1006:  return makeRegisterExpression(amdgpu_gfx908::acc238, output_vec_len );
            case 1007:  return makeRegisterExpression(amdgpu_gfx908::acc239, output_vec_len );
            case 1008:  return makeRegisterExpression(amdgpu_gfx908::acc240, output_vec_len );
            case 1009:  return makeRegisterExpression(amdgpu_gfx908::acc241, output_vec_len );
            case 1010:  return makeRegisterExpression(amdgpu_gfx908::acc242, output_vec_len );
            case 1011:  return makeRegisterExpression(amdgpu_gfx908::acc243, output_vec_len );
            case 1012:  return makeRegisterExpression(amdgpu_gfx908::acc244, output_vec_len );
            case 1013:  return makeRegisterExpression(amdgpu_gfx908::acc245, output_vec_len );
            case 1014:  return makeRegisterExpression(amdgpu_gfx908::acc246, output_vec_len );
            case 1015:  return makeRegisterExpression(amdgpu_gfx908::acc247, output_vec_len );
            case 1016:  return makeRegisterExpression(amdgpu_gfx908::acc248, output_vec_len );
            case 1017:  return makeRegisterExpression(amdgpu_gfx908::acc249, output_vec_len );
            case 1018:  return makeRegisterExpression(amdgpu_gfx908::acc250, output_vec_len );
            case 1019:  return makeRegisterExpression(amdgpu_gfx908::acc251, output_vec_len );
            case 1020:  return makeRegisterExpression(amdgpu_gfx908::acc252, output_vec_len );
            case 1021:  return makeRegisterExpression(amdgpu_gfx908::acc253, output_vec_len );
            case 1022:  return makeRegisterExpression(amdgpu_gfx908::acc254, output_vec_len );
            case 1023:  return makeRegisterExpression(amdgpu_gfx908::acc255, output_vec_len );
            case 128:  return Immediate::makeImmediate(Result(u32, 0));
            case 129:  return Immediate::makeImmediate(Result(u32, 1));
            case 130:  return Immediate::makeImmediate(Result(u32, 2));
            case 131:  return Immediate::makeImmediate(Result(u32, 3));
            case 132:  return Immediate::makeImmediate(Result(u32, 4));
            case 133:  return Immediate::makeImmediate(Result(u32, 5));
            case 134:  return Immediate::makeImmediate(Result(u32, 6));
            case 135:  return Immediate::makeImmediate(Result(u32, 7));
            case 136:  return Immediate::makeImmediate(Result(u32, 8));
            case 137:  return Immediate::makeImmediate(Result(u32, 9));
            case 138:  return Immediate::makeImmediate(Result(u32, 10));
            case 139:  return Immediate::makeImmediate(Result(u32, 11));
            case 140:  return Immediate::makeImmediate(Result(u32, 12));
            case 141:  return Immediate::makeImmediate(Result(u32, 13));
            case 142:  return Immediate::makeImmediate(Result(u32, 14));
            case 143:  return Immediate::makeImmediate(Result(u32, 15));
            case 144:  return Immediate::makeImmediate(Result(u32, 16));
            case 145:  return Immediate::makeImmediate(Result(u32, 17));
            case 146:  return Immediate::makeImmediate(Result(u32, 18));
            case 147:  return Immediate::makeImmediate(Result(u32, 19));
            case 148:  return Immediate::makeImmediate(Result(u32, 20));
            case 149:  return Immediate::makeImmediate(Result(u32, 21));
            case 150:  return Immediate::makeImmediate(Result(u32, 22));
            case 151:  return Immediate::makeImmediate(Result(u32, 23));
            case 152:  return Immediate::makeImmediate(Result(u32, 24));
            case 153:  return Immediate::makeImmediate(Result(u32, 25));
            case 154:  return Immediate::makeImmediate(Result(u32, 26));
            case 155:  return Immediate::makeImmediate(Result(u32, 27));
            case 156:  return Immediate::makeImmediate(Result(u32, 28));
            case 157:  return Immediate::makeImmediate(Result(u32, 29));
            case 158:  return Immediate::makeImmediate(Result(u32, 30));
            case 159:  return Immediate::makeImmediate(Result(u32, 31));
            case 160:  return Immediate::makeImmediate(Result(u32, 32));
            case 161:  return Immediate::makeImmediate(Result(u32, 33));
            case 162:  return Immediate::makeImmediate(Result(u32, 34));
            case 163:  return Immediate::makeImmediate(Result(u32, 35));
            case 164:  return Immediate::makeImmediate(Result(u32, 36));
            case 165:  return Immediate::makeImmediate(Result(u32, 37));
            case 166:  return Immediate::makeImmediate(Result(u32, 38));
            case 167:  return Immediate::makeImmediate(Result(u32, 39));
            case 168:  return Immediate::makeImmediate(Result(u32, 40));
            case 169:  return Immediate::makeImmediate(Result(u32, 41));
            case 170:  return Immediate::makeImmediate(Result(u32, 42));
            case 171:  return Immediate::makeImmediate(Result(u32, 43));
            case 172:  return Immediate::makeImmediate(Result(u32, 44));
            case 173:  return Immediate::makeImmediate(Result(u32, 45));
            case 174:  return Immediate::makeImmediate(Result(u32, 46));
            case 175:  return Immediate::makeImmediate(Result(u32, 47));
            case 176:  return Immediate::makeImmediate(Result(u32, 48));
            case 177:  return Immediate::makeImmediate(Result(u32, 49));
            case 178:  return Immediate::makeImmediate(Result(u32, 50));
            case 179:  return Immediate::makeImmediate(Result(u32, 51));
            case 180:  return Immediate::makeImmediate(Result(u32, 52));
            case 181:  return Immediate::makeImmediate(Result(u32, 53));
            case 182:  return Immediate::makeImmediate(Result(u32, 54));
            case 183:  return Immediate::makeImmediate(Result(u32, 55));
            case 184:  return Immediate::makeImmediate(Result(u32, 56));
            case 185:  return Immediate::makeImmediate(Result(u32, 57));
            case 186:  return Immediate::makeImmediate(Result(u32, 58));
            case 187:  return Immediate::makeImmediate(Result(u32, 59));
            case 188:  return Immediate::makeImmediate(Result(u32, 60));
            case 189:  return Immediate::makeImmediate(Result(u32, 61));
            case 190:  return Immediate::makeImmediate(Result(u32, 62));
            case 191:  return Immediate::makeImmediate(Result(u32, 63));
            case 192:  return Immediate::makeImmediate(Result(u32, 64));
            case 193:  return Immediate::makeImmediate(Result(u32, -1));
            case 194:  return Immediate::makeImmediate(Result(u32, -2));
            case 195:  return Immediate::makeImmediate(Result(u32, -3));
            case 196:  return Immediate::makeImmediate(Result(u32, -4));
            case 197:  return Immediate::makeImmediate(Result(u32, -5));
            case 198:  return Immediate::makeImmediate(Result(u32, -6));
            case 199:  return Immediate::makeImmediate(Result(u32, -7));
            case 200:  return Immediate::makeImmediate(Result(u32, -8));
            case 201:  return Immediate::makeImmediate(Result(u32, -9));
            case 202:  return Immediate::makeImmediate(Result(u32, -10));
            case 203:  return Immediate::makeImmediate(Result(u32, -11));
            case 204:  return Immediate::makeImmediate(Result(u32, -12));
            case 205:  return Immediate::makeImmediate(Result(u32, -13));
            case 206:  return Immediate::makeImmediate(Result(u32, -14));
            case 207:  return Immediate::makeImmediate(Result(u32, -15));
            case 208:  return Immediate::makeImmediate(Result(u32, -16));
            case 240:  return Immediate::makeImmediate(Result(sp_float, 0.5));
            case 241:  return Immediate::makeImmediate(Result(sp_float, -0.5));
            case 242:  return Immediate::makeImmediate(Result(sp_float, 1.0));
            case 243:  return Immediate::makeImmediate(Result(sp_float, -1.0));
            case 244:  return Immediate::makeImmediate(Result(sp_float, 2.0));
            case 245:  return Immediate::makeImmediate(Result(sp_float, -2.0));
            case 246:  return Immediate::makeImmediate(Result(sp_float, 4.0));
            case 247:  return Immediate::makeImmediate(Result(sp_float, -4.0));
            case 248:  return Immediate::makeImmediate(Result(sp_float, 0.15915494));
            default: return makeRegisterExpression(amdgpu_gfx908::invalid);
        }
    }

    Expression::Ptr InstructionDecoder_amdgpu_gfx908::decodeOPR_SRC_NOLDS(uint64_t input, uint32_t output_vec_len)
    {
        switch (input)  {
            case 0:  return makeRegisterExpression(amdgpu_gfx908::s0, output_vec_len );
            case 1:  return makeRegisterExpression(amdgpu_gfx908::s1, output_vec_len );
            case 2:  return makeRegisterExpression(amdgpu_gfx908::s2, output_vec_len );
            case 3:  return makeRegisterExpression(amdgpu_gfx908::s3, output_vec_len );
            case 4:  return makeRegisterExpression(amdgpu_gfx908::s4, output_vec_len );
            case 5:  return makeRegisterExpression(amdgpu_gfx908::s5, output_vec_len );
            case 6:  return makeRegisterExpression(amdgpu_gfx908::s6, output_vec_len );
            case 7:  return makeRegisterExpression(amdgpu_gfx908::s7, output_vec_len );
            case 8:  return makeRegisterExpression(amdgpu_gfx908::s8, output_vec_len );
            case 9:  return makeRegisterExpression(amdgpu_gfx908::s9, output_vec_len );
            case 10:  return makeRegisterExpression(amdgpu_gfx908::s10, output_vec_len );
            case 11:  return makeRegisterExpression(amdgpu_gfx908::s11, output_vec_len );
            case 12:  return makeRegisterExpression(amdgpu_gfx908::s12, output_vec_len );
            case 13:  return makeRegisterExpression(amdgpu_gfx908::s13, output_vec_len );
            case 14:  return makeRegisterExpression(amdgpu_gfx908::s14, output_vec_len );
            case 15:  return makeRegisterExpression(amdgpu_gfx908::s15, output_vec_len );
            case 16:  return makeRegisterExpression(amdgpu_gfx908::s16, output_vec_len );
            case 17:  return makeRegisterExpression(amdgpu_gfx908::s17, output_vec_len );
            case 18:  return makeRegisterExpression(amdgpu_gfx908::s18, output_vec_len );
            case 19:  return makeRegisterExpression(amdgpu_gfx908::s19, output_vec_len );
            case 20:  return makeRegisterExpression(amdgpu_gfx908::s20, output_vec_len );
            case 21:  return makeRegisterExpression(amdgpu_gfx908::s21, output_vec_len );
            case 22:  return makeRegisterExpression(amdgpu_gfx908::s22, output_vec_len );
            case 23:  return makeRegisterExpression(amdgpu_gfx908::s23, output_vec_len );
            case 24:  return makeRegisterExpression(amdgpu_gfx908::s24, output_vec_len );
            case 25:  return makeRegisterExpression(amdgpu_gfx908::s25, output_vec_len );
            case 26:  return makeRegisterExpression(amdgpu_gfx908::s26, output_vec_len );
            case 27:  return makeRegisterExpression(amdgpu_gfx908::s27, output_vec_len );
            case 28:  return makeRegisterExpression(amdgpu_gfx908::s28, output_vec_len );
            case 29:  return makeRegisterExpression(amdgpu_gfx908::s29, output_vec_len );
            case 30:  return makeRegisterExpression(amdgpu_gfx908::s30, output_vec_len );
            case 31:  return makeRegisterExpression(amdgpu_gfx908::s31, output_vec_len );
            case 32:  return makeRegisterExpression(amdgpu_gfx908::s32, output_vec_len );
            case 33:  return makeRegisterExpression(amdgpu_gfx908::s33, output_vec_len );
            case 34:  return makeRegisterExpression(amdgpu_gfx908::s34, output_vec_len );
            case 35:  return makeRegisterExpression(amdgpu_gfx908::s35, output_vec_len );
            case 36:  return makeRegisterExpression(amdgpu_gfx908::s36, output_vec_len );
            case 37:  return makeRegisterExpression(amdgpu_gfx908::s37, output_vec_len );
            case 38:  return makeRegisterExpression(amdgpu_gfx908::s38, output_vec_len );
            case 39:  return makeRegisterExpression(amdgpu_gfx908::s39, output_vec_len );
            case 40:  return makeRegisterExpression(amdgpu_gfx908::s40, output_vec_len );
            case 41:  return makeRegisterExpression(amdgpu_gfx908::s41, output_vec_len );
            case 42:  return makeRegisterExpression(amdgpu_gfx908::s42, output_vec_len );
            case 43:  return makeRegisterExpression(amdgpu_gfx908::s43, output_vec_len );
            case 44:  return makeRegisterExpression(amdgpu_gfx908::s44, output_vec_len );
            case 45:  return makeRegisterExpression(amdgpu_gfx908::s45, output_vec_len );
            case 46:  return makeRegisterExpression(amdgpu_gfx908::s46, output_vec_len );
            case 47:  return makeRegisterExpression(amdgpu_gfx908::s47, output_vec_len );
            case 48:  return makeRegisterExpression(amdgpu_gfx908::s48, output_vec_len );
            case 49:  return makeRegisterExpression(amdgpu_gfx908::s49, output_vec_len );
            case 50:  return makeRegisterExpression(amdgpu_gfx908::s50, output_vec_len );
            case 51:  return makeRegisterExpression(amdgpu_gfx908::s51, output_vec_len );
            case 52:  return makeRegisterExpression(amdgpu_gfx908::s52, output_vec_len );
            case 53:  return makeRegisterExpression(amdgpu_gfx908::s53, output_vec_len );
            case 54:  return makeRegisterExpression(amdgpu_gfx908::s54, output_vec_len );
            case 55:  return makeRegisterExpression(amdgpu_gfx908::s55, output_vec_len );
            case 56:  return makeRegisterExpression(amdgpu_gfx908::s56, output_vec_len );
            case 57:  return makeRegisterExpression(amdgpu_gfx908::s57, output_vec_len );
            case 58:  return makeRegisterExpression(amdgpu_gfx908::s58, output_vec_len );
            case 59:  return makeRegisterExpression(amdgpu_gfx908::s59, output_vec_len );
            case 60:  return makeRegisterExpression(amdgpu_gfx908::s60, output_vec_len );
            case 61:  return makeRegisterExpression(amdgpu_gfx908::s61, output_vec_len );
            case 62:  return makeRegisterExpression(amdgpu_gfx908::s62, output_vec_len );
            case 63:  return makeRegisterExpression(amdgpu_gfx908::s63, output_vec_len );
            case 64:  return makeRegisterExpression(amdgpu_gfx908::s64, output_vec_len );
            case 65:  return makeRegisterExpression(amdgpu_gfx908::s65, output_vec_len );
            case 66:  return makeRegisterExpression(amdgpu_gfx908::s66, output_vec_len );
            case 67:  return makeRegisterExpression(amdgpu_gfx908::s67, output_vec_len );
            case 68:  return makeRegisterExpression(amdgpu_gfx908::s68, output_vec_len );
            case 69:  return makeRegisterExpression(amdgpu_gfx908::s69, output_vec_len );
            case 70:  return makeRegisterExpression(amdgpu_gfx908::s70, output_vec_len );
            case 71:  return makeRegisterExpression(amdgpu_gfx908::s71, output_vec_len );
            case 72:  return makeRegisterExpression(amdgpu_gfx908::s72, output_vec_len );
            case 73:  return makeRegisterExpression(amdgpu_gfx908::s73, output_vec_len );
            case 74:  return makeRegisterExpression(amdgpu_gfx908::s74, output_vec_len );
            case 75:  return makeRegisterExpression(amdgpu_gfx908::s75, output_vec_len );
            case 76:  return makeRegisterExpression(amdgpu_gfx908::s76, output_vec_len );
            case 77:  return makeRegisterExpression(amdgpu_gfx908::s77, output_vec_len );
            case 78:  return makeRegisterExpression(amdgpu_gfx908::s78, output_vec_len );
            case 79:  return makeRegisterExpression(amdgpu_gfx908::s79, output_vec_len );
            case 80:  return makeRegisterExpression(amdgpu_gfx908::s80, output_vec_len );
            case 81:  return makeRegisterExpression(amdgpu_gfx908::s81, output_vec_len );
            case 82:  return makeRegisterExpression(amdgpu_gfx908::s82, output_vec_len );
            case 83:  return makeRegisterExpression(amdgpu_gfx908::s83, output_vec_len );
            case 84:  return makeRegisterExpression(amdgpu_gfx908::s84, output_vec_len );
            case 85:  return makeRegisterExpression(amdgpu_gfx908::s85, output_vec_len );
            case 86:  return makeRegisterExpression(amdgpu_gfx908::s86, output_vec_len );
            case 87:  return makeRegisterExpression(amdgpu_gfx908::s87, output_vec_len );
            case 88:  return makeRegisterExpression(amdgpu_gfx908::s88, output_vec_len );
            case 89:  return makeRegisterExpression(amdgpu_gfx908::s89, output_vec_len );
            case 90:  return makeRegisterExpression(amdgpu_gfx908::s90, output_vec_len );
            case 91:  return makeRegisterExpression(amdgpu_gfx908::s91, output_vec_len );
            case 92:  return makeRegisterExpression(amdgpu_gfx908::s92, output_vec_len );
            case 93:  return makeRegisterExpression(amdgpu_gfx908::s93, output_vec_len );
            case 94:  return makeRegisterExpression(amdgpu_gfx908::s94, output_vec_len );
            case 95:  return makeRegisterExpression(amdgpu_gfx908::s95, output_vec_len );
            case 96:  return makeRegisterExpression(amdgpu_gfx908::s96, output_vec_len );
            case 97:  return makeRegisterExpression(amdgpu_gfx908::s97, output_vec_len );
            case 98:  return makeRegisterExpression(amdgpu_gfx908::s98, output_vec_len );
            case 99:  return makeRegisterExpression(amdgpu_gfx908::s99, output_vec_len );
            case 100:  return makeRegisterExpression(amdgpu_gfx908::s100, output_vec_len );
            case 101:  return makeRegisterExpression(amdgpu_gfx908::s101, output_vec_len );
            case 104:  return makeRegisterExpression(amdgpu_gfx908::xnack_mask_lo, output_vec_len );
            case 105:  return makeRegisterExpression(amdgpu_gfx908::xnack_mask_hi, output_vec_len );
            case 102:  return makeRegisterExpression(amdgpu_gfx908::flat_scratch_lo, output_vec_len );
            case 103:  return makeRegisterExpression(amdgpu_gfx908::flat_scratch_hi, output_vec_len );
            case 108:  return makeRegisterExpression(amdgpu_gfx908::ttmp0, output_vec_len );
            case 109:  return makeRegisterExpression(amdgpu_gfx908::ttmp1, output_vec_len );
            case 110:  return makeRegisterExpression(amdgpu_gfx908::ttmp2, output_vec_len );
            case 111:  return makeRegisterExpression(amdgpu_gfx908::ttmp3, output_vec_len );
            case 112:  return makeRegisterExpression(amdgpu_gfx908::ttmp4, output_vec_len );
            case 113:  return makeRegisterExpression(amdgpu_gfx908::ttmp5, output_vec_len );
            case 114:  return makeRegisterExpression(amdgpu_gfx908::ttmp6, output_vec_len );
            case 115:  return makeRegisterExpression(amdgpu_gfx908::ttmp7, output_vec_len );
            case 116:  return makeRegisterExpression(amdgpu_gfx908::ttmp8, output_vec_len );
            case 117:  return makeRegisterExpression(amdgpu_gfx908::ttmp9, output_vec_len );
            case 118:  return makeRegisterExpression(amdgpu_gfx908::ttmp10, output_vec_len );
            case 119:  return makeRegisterExpression(amdgpu_gfx908::ttmp11, output_vec_len );
            case 120:  return makeRegisterExpression(amdgpu_gfx908::ttmp12, output_vec_len );
            case 121:  return makeRegisterExpression(amdgpu_gfx908::ttmp13, output_vec_len );
            case 122:  return makeRegisterExpression(amdgpu_gfx908::ttmp14, output_vec_len );
            case 123:  return makeRegisterExpression(amdgpu_gfx908::ttmp15, output_vec_len );
            case 106:  return makeRegisterExpression(amdgpu_gfx908::vcc_lo, output_vec_len );
            case 107:  return makeRegisterExpression(amdgpu_gfx908::vcc_hi, output_vec_len );
            case 124:  return makeRegisterExpression(amdgpu_gfx908::m0, output_vec_len );
            case 126:  return makeRegisterExpression(amdgpu_gfx908::exec_lo, output_vec_len );
            case 127:  return makeRegisterExpression(amdgpu_gfx908::exec_hi, output_vec_len );
            case 128:  return Immediate::makeImmediate(Result(u32, 0));
            case 129:  return Immediate::makeImmediate(Result(u32, 1));
            case 130:  return Immediate::makeImmediate(Result(u32, 2));
            case 131:  return Immediate::makeImmediate(Result(u32, 3));
            case 132:  return Immediate::makeImmediate(Result(u32, 4));
            case 133:  return Immediate::makeImmediate(Result(u32, 5));
            case 134:  return Immediate::makeImmediate(Result(u32, 6));
            case 135:  return Immediate::makeImmediate(Result(u32, 7));
            case 136:  return Immediate::makeImmediate(Result(u32, 8));
            case 137:  return Immediate::makeImmediate(Result(u32, 9));
            case 138:  return Immediate::makeImmediate(Result(u32, 10));
            case 139:  return Immediate::makeImmediate(Result(u32, 11));
            case 140:  return Immediate::makeImmediate(Result(u32, 12));
            case 141:  return Immediate::makeImmediate(Result(u32, 13));
            case 142:  return Immediate::makeImmediate(Result(u32, 14));
            case 143:  return Immediate::makeImmediate(Result(u32, 15));
            case 144:  return Immediate::makeImmediate(Result(u32, 16));
            case 145:  return Immediate::makeImmediate(Result(u32, 17));
            case 146:  return Immediate::makeImmediate(Result(u32, 18));
            case 147:  return Immediate::makeImmediate(Result(u32, 19));
            case 148:  return Immediate::makeImmediate(Result(u32, 20));
            case 149:  return Immediate::makeImmediate(Result(u32, 21));
            case 150:  return Immediate::makeImmediate(Result(u32, 22));
            case 151:  return Immediate::makeImmediate(Result(u32, 23));
            case 152:  return Immediate::makeImmediate(Result(u32, 24));
            case 153:  return Immediate::makeImmediate(Result(u32, 25));
            case 154:  return Immediate::makeImmediate(Result(u32, 26));
            case 155:  return Immediate::makeImmediate(Result(u32, 27));
            case 156:  return Immediate::makeImmediate(Result(u32, 28));
            case 157:  return Immediate::makeImmediate(Result(u32, 29));
            case 158:  return Immediate::makeImmediate(Result(u32, 30));
            case 159:  return Immediate::makeImmediate(Result(u32, 31));
            case 160:  return Immediate::makeImmediate(Result(u32, 32));
            case 161:  return Immediate::makeImmediate(Result(u32, 33));
            case 162:  return Immediate::makeImmediate(Result(u32, 34));
            case 163:  return Immediate::makeImmediate(Result(u32, 35));
            case 164:  return Immediate::makeImmediate(Result(u32, 36));
            case 165:  return Immediate::makeImmediate(Result(u32, 37));
            case 166:  return Immediate::makeImmediate(Result(u32, 38));
            case 167:  return Immediate::makeImmediate(Result(u32, 39));
            case 168:  return Immediate::makeImmediate(Result(u32, 40));
            case 169:  return Immediate::makeImmediate(Result(u32, 41));
            case 170:  return Immediate::makeImmediate(Result(u32, 42));
            case 171:  return Immediate::makeImmediate(Result(u32, 43));
            case 172:  return Immediate::makeImmediate(Result(u32, 44));
            case 173:  return Immediate::makeImmediate(Result(u32, 45));
            case 174:  return Immediate::makeImmediate(Result(u32, 46));
            case 175:  return Immediate::makeImmediate(Result(u32, 47));
            case 176:  return Immediate::makeImmediate(Result(u32, 48));
            case 177:  return Immediate::makeImmediate(Result(u32, 49));
            case 178:  return Immediate::makeImmediate(Result(u32, 50));
            case 179:  return Immediate::makeImmediate(Result(u32, 51));
            case 180:  return Immediate::makeImmediate(Result(u32, 52));
            case 181:  return Immediate::makeImmediate(Result(u32, 53));
            case 182:  return Immediate::makeImmediate(Result(u32, 54));
            case 183:  return Immediate::makeImmediate(Result(u32, 55));
            case 184:  return Immediate::makeImmediate(Result(u32, 56));
            case 185:  return Immediate::makeImmediate(Result(u32, 57));
            case 186:  return Immediate::makeImmediate(Result(u32, 58));
            case 187:  return Immediate::makeImmediate(Result(u32, 59));
            case 188:  return Immediate::makeImmediate(Result(u32, 60));
            case 189:  return Immediate::makeImmediate(Result(u32, 61));
            case 190:  return Immediate::makeImmediate(Result(u32, 62));
            case 191:  return Immediate::makeImmediate(Result(u32, 63));
            case 192:  return Immediate::makeImmediate(Result(u32, 64));
            case 193:  return Immediate::makeImmediate(Result(u32, -1));
            case 194:  return Immediate::makeImmediate(Result(u32, -2));
            case 195:  return Immediate::makeImmediate(Result(u32, -3));
            case 196:  return Immediate::makeImmediate(Result(u32, -4));
            case 197:  return Immediate::makeImmediate(Result(u32, -5));
            case 198:  return Immediate::makeImmediate(Result(u32, -6));
            case 199:  return Immediate::makeImmediate(Result(u32, -7));
            case 200:  return Immediate::makeImmediate(Result(u32, -8));
            case 201:  return Immediate::makeImmediate(Result(u32, -9));
            case 202:  return Immediate::makeImmediate(Result(u32, -10));
            case 203:  return Immediate::makeImmediate(Result(u32, -11));
            case 204:  return Immediate::makeImmediate(Result(u32, -12));
            case 205:  return Immediate::makeImmediate(Result(u32, -13));
            case 206:  return Immediate::makeImmediate(Result(u32, -14));
            case 207:  return Immediate::makeImmediate(Result(u32, -15));
            case 208:  return Immediate::makeImmediate(Result(u32, -16));
            case 240:  return Immediate::makeImmediate(Result(sp_float, 0.5));
            case 241:  return Immediate::makeImmediate(Result(sp_float, -0.5));
            case 242:  return Immediate::makeImmediate(Result(sp_float, 1.0));
            case 243:  return Immediate::makeImmediate(Result(sp_float, -1.0));
            case 244:  return Immediate::makeImmediate(Result(sp_float, 2.0));
            case 245:  return Immediate::makeImmediate(Result(sp_float, -2.0));
            case 246:  return Immediate::makeImmediate(Result(sp_float, 4.0));
            case 247:  return Immediate::makeImmediate(Result(sp_float, -4.0));
            case 248:  return Immediate::makeImmediate(Result(sp_float, 0.15915494));
            case 251:  return makeRegisterExpression(amdgpu_gfx908::src_vccz, output_vec_len );
            case 252:  return makeRegisterExpression(amdgpu_gfx908::src_execz, output_vec_len );
            case 253:  return makeRegisterExpression(amdgpu_gfx908::src_scc, output_vec_len );
            case 235:  return makeRegisterExpression(amdgpu_gfx908::src_shared_base, output_vec_len );
            case 236:  return makeRegisterExpression(amdgpu_gfx908::src_shared_limit, output_vec_len );
            case 237:  return makeRegisterExpression(amdgpu_gfx908::src_private_base, output_vec_len );
            case 238:  return makeRegisterExpression(amdgpu_gfx908::src_private_limit, output_vec_len );
            case 239:  return makeRegisterExpression(amdgpu_gfx908::src_pops_exiting_wave_id, output_vec_len );
            case 256:  return makeRegisterExpression(amdgpu_gfx908::v0, output_vec_len );
            case 257:  return makeRegisterExpression(amdgpu_gfx908::v1, output_vec_len );
            case 258:  return makeRegisterExpression(amdgpu_gfx908::v2, output_vec_len );
            case 259:  return makeRegisterExpression(amdgpu_gfx908::v3, output_vec_len );
            case 260:  return makeRegisterExpression(amdgpu_gfx908::v4, output_vec_len );
            case 261:  return makeRegisterExpression(amdgpu_gfx908::v5, output_vec_len );
            case 262:  return makeRegisterExpression(amdgpu_gfx908::v6, output_vec_len );
            case 263:  return makeRegisterExpression(amdgpu_gfx908::v7, output_vec_len );
            case 264:  return makeRegisterExpression(amdgpu_gfx908::v8, output_vec_len );
            case 265:  return makeRegisterExpression(amdgpu_gfx908::v9, output_vec_len );
            case 266:  return makeRegisterExpression(amdgpu_gfx908::v10, output_vec_len );
            case 267:  return makeRegisterExpression(amdgpu_gfx908::v11, output_vec_len );
            case 268:  return makeRegisterExpression(amdgpu_gfx908::v12, output_vec_len );
            case 269:  return makeRegisterExpression(amdgpu_gfx908::v13, output_vec_len );
            case 270:  return makeRegisterExpression(amdgpu_gfx908::v14, output_vec_len );
            case 271:  return makeRegisterExpression(amdgpu_gfx908::v15, output_vec_len );
            case 272:  return makeRegisterExpression(amdgpu_gfx908::v16, output_vec_len );
            case 273:  return makeRegisterExpression(amdgpu_gfx908::v17, output_vec_len );
            case 274:  return makeRegisterExpression(amdgpu_gfx908::v18, output_vec_len );
            case 275:  return makeRegisterExpression(amdgpu_gfx908::v19, output_vec_len );
            case 276:  return makeRegisterExpression(amdgpu_gfx908::v20, output_vec_len );
            case 277:  return makeRegisterExpression(amdgpu_gfx908::v21, output_vec_len );
            case 278:  return makeRegisterExpression(amdgpu_gfx908::v22, output_vec_len );
            case 279:  return makeRegisterExpression(amdgpu_gfx908::v23, output_vec_len );
            case 280:  return makeRegisterExpression(amdgpu_gfx908::v24, output_vec_len );
            case 281:  return makeRegisterExpression(amdgpu_gfx908::v25, output_vec_len );
            case 282:  return makeRegisterExpression(amdgpu_gfx908::v26, output_vec_len );
            case 283:  return makeRegisterExpression(amdgpu_gfx908::v27, output_vec_len );
            case 284:  return makeRegisterExpression(amdgpu_gfx908::v28, output_vec_len );
            case 285:  return makeRegisterExpression(amdgpu_gfx908::v29, output_vec_len );
            case 286:  return makeRegisterExpression(amdgpu_gfx908::v30, output_vec_len );
            case 287:  return makeRegisterExpression(amdgpu_gfx908::v31, output_vec_len );
            case 288:  return makeRegisterExpression(amdgpu_gfx908::v32, output_vec_len );
            case 289:  return makeRegisterExpression(amdgpu_gfx908::v33, output_vec_len );
            case 290:  return makeRegisterExpression(amdgpu_gfx908::v34, output_vec_len );
            case 291:  return makeRegisterExpression(amdgpu_gfx908::v35, output_vec_len );
            case 292:  return makeRegisterExpression(amdgpu_gfx908::v36, output_vec_len );
            case 293:  return makeRegisterExpression(amdgpu_gfx908::v37, output_vec_len );
            case 294:  return makeRegisterExpression(amdgpu_gfx908::v38, output_vec_len );
            case 295:  return makeRegisterExpression(amdgpu_gfx908::v39, output_vec_len );
            case 296:  return makeRegisterExpression(amdgpu_gfx908::v40, output_vec_len );
            case 297:  return makeRegisterExpression(amdgpu_gfx908::v41, output_vec_len );
            case 298:  return makeRegisterExpression(amdgpu_gfx908::v42, output_vec_len );
            case 299:  return makeRegisterExpression(amdgpu_gfx908::v43, output_vec_len );
            case 300:  return makeRegisterExpression(amdgpu_gfx908::v44, output_vec_len );
            case 301:  return makeRegisterExpression(amdgpu_gfx908::v45, output_vec_len );
            case 302:  return makeRegisterExpression(amdgpu_gfx908::v46, output_vec_len );
            case 303:  return makeRegisterExpression(amdgpu_gfx908::v47, output_vec_len );
            case 304:  return makeRegisterExpression(amdgpu_gfx908::v48, output_vec_len );
            case 305:  return makeRegisterExpression(amdgpu_gfx908::v49, output_vec_len );
            case 306:  return makeRegisterExpression(amdgpu_gfx908::v50, output_vec_len );
            case 307:  return makeRegisterExpression(amdgpu_gfx908::v51, output_vec_len );
            case 308:  return makeRegisterExpression(amdgpu_gfx908::v52, output_vec_len );
            case 309:  return makeRegisterExpression(amdgpu_gfx908::v53, output_vec_len );
            case 310:  return makeRegisterExpression(amdgpu_gfx908::v54, output_vec_len );
            case 311:  return makeRegisterExpression(amdgpu_gfx908::v55, output_vec_len );
            case 312:  return makeRegisterExpression(amdgpu_gfx908::v56, output_vec_len );
            case 313:  return makeRegisterExpression(amdgpu_gfx908::v57, output_vec_len );
            case 314:  return makeRegisterExpression(amdgpu_gfx908::v58, output_vec_len );
            case 315:  return makeRegisterExpression(amdgpu_gfx908::v59, output_vec_len );
            case 316:  return makeRegisterExpression(amdgpu_gfx908::v60, output_vec_len );
            case 317:  return makeRegisterExpression(amdgpu_gfx908::v61, output_vec_len );
            case 318:  return makeRegisterExpression(amdgpu_gfx908::v62, output_vec_len );
            case 319:  return makeRegisterExpression(amdgpu_gfx908::v63, output_vec_len );
            case 320:  return makeRegisterExpression(amdgpu_gfx908::v64, output_vec_len );
            case 321:  return makeRegisterExpression(amdgpu_gfx908::v65, output_vec_len );
            case 322:  return makeRegisterExpression(amdgpu_gfx908::v66, output_vec_len );
            case 323:  return makeRegisterExpression(amdgpu_gfx908::v67, output_vec_len );
            case 324:  return makeRegisterExpression(amdgpu_gfx908::v68, output_vec_len );
            case 325:  return makeRegisterExpression(amdgpu_gfx908::v69, output_vec_len );
            case 326:  return makeRegisterExpression(amdgpu_gfx908::v70, output_vec_len );
            case 327:  return makeRegisterExpression(amdgpu_gfx908::v71, output_vec_len );
            case 328:  return makeRegisterExpression(amdgpu_gfx908::v72, output_vec_len );
            case 329:  return makeRegisterExpression(amdgpu_gfx908::v73, output_vec_len );
            case 330:  return makeRegisterExpression(amdgpu_gfx908::v74, output_vec_len );
            case 331:  return makeRegisterExpression(amdgpu_gfx908::v75, output_vec_len );
            case 332:  return makeRegisterExpression(amdgpu_gfx908::v76, output_vec_len );
            case 333:  return makeRegisterExpression(amdgpu_gfx908::v77, output_vec_len );
            case 334:  return makeRegisterExpression(amdgpu_gfx908::v78, output_vec_len );
            case 335:  return makeRegisterExpression(amdgpu_gfx908::v79, output_vec_len );
            case 336:  return makeRegisterExpression(amdgpu_gfx908::v80, output_vec_len );
            case 337:  return makeRegisterExpression(amdgpu_gfx908::v81, output_vec_len );
            case 338:  return makeRegisterExpression(amdgpu_gfx908::v82, output_vec_len );
            case 339:  return makeRegisterExpression(amdgpu_gfx908::v83, output_vec_len );
            case 340:  return makeRegisterExpression(amdgpu_gfx908::v84, output_vec_len );
            case 341:  return makeRegisterExpression(amdgpu_gfx908::v85, output_vec_len );
            case 342:  return makeRegisterExpression(amdgpu_gfx908::v86, output_vec_len );
            case 343:  return makeRegisterExpression(amdgpu_gfx908::v87, output_vec_len );
            case 344:  return makeRegisterExpression(amdgpu_gfx908::v88, output_vec_len );
            case 345:  return makeRegisterExpression(amdgpu_gfx908::v89, output_vec_len );
            case 346:  return makeRegisterExpression(amdgpu_gfx908::v90, output_vec_len );
            case 347:  return makeRegisterExpression(amdgpu_gfx908::v91, output_vec_len );
            case 348:  return makeRegisterExpression(amdgpu_gfx908::v92, output_vec_len );
            case 349:  return makeRegisterExpression(amdgpu_gfx908::v93, output_vec_len );
            case 350:  return makeRegisterExpression(amdgpu_gfx908::v94, output_vec_len );
            case 351:  return makeRegisterExpression(amdgpu_gfx908::v95, output_vec_len );
            case 352:  return makeRegisterExpression(amdgpu_gfx908::v96, output_vec_len );
            case 353:  return makeRegisterExpression(amdgpu_gfx908::v97, output_vec_len );
            case 354:  return makeRegisterExpression(amdgpu_gfx908::v98, output_vec_len );
            case 355:  return makeRegisterExpression(amdgpu_gfx908::v99, output_vec_len );
            case 356:  return makeRegisterExpression(amdgpu_gfx908::v100, output_vec_len );
            case 357:  return makeRegisterExpression(amdgpu_gfx908::v101, output_vec_len );
            case 358:  return makeRegisterExpression(amdgpu_gfx908::v102, output_vec_len );
            case 359:  return makeRegisterExpression(amdgpu_gfx908::v103, output_vec_len );
            case 360:  return makeRegisterExpression(amdgpu_gfx908::v104, output_vec_len );
            case 361:  return makeRegisterExpression(amdgpu_gfx908::v105, output_vec_len );
            case 362:  return makeRegisterExpression(amdgpu_gfx908::v106, output_vec_len );
            case 363:  return makeRegisterExpression(amdgpu_gfx908::v107, output_vec_len );
            case 364:  return makeRegisterExpression(amdgpu_gfx908::v108, output_vec_len );
            case 365:  return makeRegisterExpression(amdgpu_gfx908::v109, output_vec_len );
            case 366:  return makeRegisterExpression(amdgpu_gfx908::v110, output_vec_len );
            case 367:  return makeRegisterExpression(amdgpu_gfx908::v111, output_vec_len );
            case 368:  return makeRegisterExpression(amdgpu_gfx908::v112, output_vec_len );
            case 369:  return makeRegisterExpression(amdgpu_gfx908::v113, output_vec_len );
            case 370:  return makeRegisterExpression(amdgpu_gfx908::v114, output_vec_len );
            case 371:  return makeRegisterExpression(amdgpu_gfx908::v115, output_vec_len );
            case 372:  return makeRegisterExpression(amdgpu_gfx908::v116, output_vec_len );
            case 373:  return makeRegisterExpression(amdgpu_gfx908::v117, output_vec_len );
            case 374:  return makeRegisterExpression(amdgpu_gfx908::v118, output_vec_len );
            case 375:  return makeRegisterExpression(amdgpu_gfx908::v119, output_vec_len );
            case 376:  return makeRegisterExpression(amdgpu_gfx908::v120, output_vec_len );
            case 377:  return makeRegisterExpression(amdgpu_gfx908::v121, output_vec_len );
            case 378:  return makeRegisterExpression(amdgpu_gfx908::v122, output_vec_len );
            case 379:  return makeRegisterExpression(amdgpu_gfx908::v123, output_vec_len );
            case 380:  return makeRegisterExpression(amdgpu_gfx908::v124, output_vec_len );
            case 381:  return makeRegisterExpression(amdgpu_gfx908::v125, output_vec_len );
            case 382:  return makeRegisterExpression(amdgpu_gfx908::v126, output_vec_len );
            case 383:  return makeRegisterExpression(amdgpu_gfx908::v127, output_vec_len );
            case 384:  return makeRegisterExpression(amdgpu_gfx908::v128, output_vec_len );
            case 385:  return makeRegisterExpression(amdgpu_gfx908::v129, output_vec_len );
            case 386:  return makeRegisterExpression(amdgpu_gfx908::v130, output_vec_len );
            case 387:  return makeRegisterExpression(amdgpu_gfx908::v131, output_vec_len );
            case 388:  return makeRegisterExpression(amdgpu_gfx908::v132, output_vec_len );
            case 389:  return makeRegisterExpression(amdgpu_gfx908::v133, output_vec_len );
            case 390:  return makeRegisterExpression(amdgpu_gfx908::v134, output_vec_len );
            case 391:  return makeRegisterExpression(amdgpu_gfx908::v135, output_vec_len );
            case 392:  return makeRegisterExpression(amdgpu_gfx908::v136, output_vec_len );
            case 393:  return makeRegisterExpression(amdgpu_gfx908::v137, output_vec_len );
            case 394:  return makeRegisterExpression(amdgpu_gfx908::v138, output_vec_len );
            case 395:  return makeRegisterExpression(amdgpu_gfx908::v139, output_vec_len );
            case 396:  return makeRegisterExpression(amdgpu_gfx908::v140, output_vec_len );
            case 397:  return makeRegisterExpression(amdgpu_gfx908::v141, output_vec_len );
            case 398:  return makeRegisterExpression(amdgpu_gfx908::v142, output_vec_len );
            case 399:  return makeRegisterExpression(amdgpu_gfx908::v143, output_vec_len );
            case 400:  return makeRegisterExpression(amdgpu_gfx908::v144, output_vec_len );
            case 401:  return makeRegisterExpression(amdgpu_gfx908::v145, output_vec_len );
            case 402:  return makeRegisterExpression(amdgpu_gfx908::v146, output_vec_len );
            case 403:  return makeRegisterExpression(amdgpu_gfx908::v147, output_vec_len );
            case 404:  return makeRegisterExpression(amdgpu_gfx908::v148, output_vec_len );
            case 405:  return makeRegisterExpression(amdgpu_gfx908::v149, output_vec_len );
            case 406:  return makeRegisterExpression(amdgpu_gfx908::v150, output_vec_len );
            case 407:  return makeRegisterExpression(amdgpu_gfx908::v151, output_vec_len );
            case 408:  return makeRegisterExpression(amdgpu_gfx908::v152, output_vec_len );
            case 409:  return makeRegisterExpression(amdgpu_gfx908::v153, output_vec_len );
            case 410:  return makeRegisterExpression(amdgpu_gfx908::v154, output_vec_len );
            case 411:  return makeRegisterExpression(amdgpu_gfx908::v155, output_vec_len );
            case 412:  return makeRegisterExpression(amdgpu_gfx908::v156, output_vec_len );
            case 413:  return makeRegisterExpression(amdgpu_gfx908::v157, output_vec_len );
            case 414:  return makeRegisterExpression(amdgpu_gfx908::v158, output_vec_len );
            case 415:  return makeRegisterExpression(amdgpu_gfx908::v159, output_vec_len );
            case 416:  return makeRegisterExpression(amdgpu_gfx908::v160, output_vec_len );
            case 417:  return makeRegisterExpression(amdgpu_gfx908::v161, output_vec_len );
            case 418:  return makeRegisterExpression(amdgpu_gfx908::v162, output_vec_len );
            case 419:  return makeRegisterExpression(amdgpu_gfx908::v163, output_vec_len );
            case 420:  return makeRegisterExpression(amdgpu_gfx908::v164, output_vec_len );
            case 421:  return makeRegisterExpression(amdgpu_gfx908::v165, output_vec_len );
            case 422:  return makeRegisterExpression(amdgpu_gfx908::v166, output_vec_len );
            case 423:  return makeRegisterExpression(amdgpu_gfx908::v167, output_vec_len );
            case 424:  return makeRegisterExpression(amdgpu_gfx908::v168, output_vec_len );
            case 425:  return makeRegisterExpression(amdgpu_gfx908::v169, output_vec_len );
            case 426:  return makeRegisterExpression(amdgpu_gfx908::v170, output_vec_len );
            case 427:  return makeRegisterExpression(amdgpu_gfx908::v171, output_vec_len );
            case 428:  return makeRegisterExpression(amdgpu_gfx908::v172, output_vec_len );
            case 429:  return makeRegisterExpression(amdgpu_gfx908::v173, output_vec_len );
            case 430:  return makeRegisterExpression(amdgpu_gfx908::v174, output_vec_len );
            case 431:  return makeRegisterExpression(amdgpu_gfx908::v175, output_vec_len );
            case 432:  return makeRegisterExpression(amdgpu_gfx908::v176, output_vec_len );
            case 433:  return makeRegisterExpression(amdgpu_gfx908::v177, output_vec_len );
            case 434:  return makeRegisterExpression(amdgpu_gfx908::v178, output_vec_len );
            case 435:  return makeRegisterExpression(amdgpu_gfx908::v179, output_vec_len );
            case 436:  return makeRegisterExpression(amdgpu_gfx908::v180, output_vec_len );
            case 437:  return makeRegisterExpression(amdgpu_gfx908::v181, output_vec_len );
            case 438:  return makeRegisterExpression(amdgpu_gfx908::v182, output_vec_len );
            case 439:  return makeRegisterExpression(amdgpu_gfx908::v183, output_vec_len );
            case 440:  return makeRegisterExpression(amdgpu_gfx908::v184, output_vec_len );
            case 441:  return makeRegisterExpression(amdgpu_gfx908::v185, output_vec_len );
            case 442:  return makeRegisterExpression(amdgpu_gfx908::v186, output_vec_len );
            case 443:  return makeRegisterExpression(amdgpu_gfx908::v187, output_vec_len );
            case 444:  return makeRegisterExpression(amdgpu_gfx908::v188, output_vec_len );
            case 445:  return makeRegisterExpression(amdgpu_gfx908::v189, output_vec_len );
            case 446:  return makeRegisterExpression(amdgpu_gfx908::v190, output_vec_len );
            case 447:  return makeRegisterExpression(amdgpu_gfx908::v191, output_vec_len );
            case 448:  return makeRegisterExpression(amdgpu_gfx908::v192, output_vec_len );
            case 449:  return makeRegisterExpression(amdgpu_gfx908::v193, output_vec_len );
            case 450:  return makeRegisterExpression(amdgpu_gfx908::v194, output_vec_len );
            case 451:  return makeRegisterExpression(amdgpu_gfx908::v195, output_vec_len );
            case 452:  return makeRegisterExpression(amdgpu_gfx908::v196, output_vec_len );
            case 453:  return makeRegisterExpression(amdgpu_gfx908::v197, output_vec_len );
            case 454:  return makeRegisterExpression(amdgpu_gfx908::v198, output_vec_len );
            case 455:  return makeRegisterExpression(amdgpu_gfx908::v199, output_vec_len );
            case 456:  return makeRegisterExpression(amdgpu_gfx908::v200, output_vec_len );
            case 457:  return makeRegisterExpression(amdgpu_gfx908::v201, output_vec_len );
            case 458:  return makeRegisterExpression(amdgpu_gfx908::v202, output_vec_len );
            case 459:  return makeRegisterExpression(amdgpu_gfx908::v203, output_vec_len );
            case 460:  return makeRegisterExpression(amdgpu_gfx908::v204, output_vec_len );
            case 461:  return makeRegisterExpression(amdgpu_gfx908::v205, output_vec_len );
            case 462:  return makeRegisterExpression(amdgpu_gfx908::v206, output_vec_len );
            case 463:  return makeRegisterExpression(amdgpu_gfx908::v207, output_vec_len );
            case 464:  return makeRegisterExpression(amdgpu_gfx908::v208, output_vec_len );
            case 465:  return makeRegisterExpression(amdgpu_gfx908::v209, output_vec_len );
            case 466:  return makeRegisterExpression(amdgpu_gfx908::v210, output_vec_len );
            case 467:  return makeRegisterExpression(amdgpu_gfx908::v211, output_vec_len );
            case 468:  return makeRegisterExpression(amdgpu_gfx908::v212, output_vec_len );
            case 469:  return makeRegisterExpression(amdgpu_gfx908::v213, output_vec_len );
            case 470:  return makeRegisterExpression(amdgpu_gfx908::v214, output_vec_len );
            case 471:  return makeRegisterExpression(amdgpu_gfx908::v215, output_vec_len );
            case 472:  return makeRegisterExpression(amdgpu_gfx908::v216, output_vec_len );
            case 473:  return makeRegisterExpression(amdgpu_gfx908::v217, output_vec_len );
            case 474:  return makeRegisterExpression(amdgpu_gfx908::v218, output_vec_len );
            case 475:  return makeRegisterExpression(amdgpu_gfx908::v219, output_vec_len );
            case 476:  return makeRegisterExpression(amdgpu_gfx908::v220, output_vec_len );
            case 477:  return makeRegisterExpression(amdgpu_gfx908::v221, output_vec_len );
            case 478:  return makeRegisterExpression(amdgpu_gfx908::v222, output_vec_len );
            case 479:  return makeRegisterExpression(amdgpu_gfx908::v223, output_vec_len );
            case 480:  return makeRegisterExpression(amdgpu_gfx908::v224, output_vec_len );
            case 481:  return makeRegisterExpression(amdgpu_gfx908::v225, output_vec_len );
            case 482:  return makeRegisterExpression(amdgpu_gfx908::v226, output_vec_len );
            case 483:  return makeRegisterExpression(amdgpu_gfx908::v227, output_vec_len );
            case 484:  return makeRegisterExpression(amdgpu_gfx908::v228, output_vec_len );
            case 485:  return makeRegisterExpression(amdgpu_gfx908::v229, output_vec_len );
            case 486:  return makeRegisterExpression(amdgpu_gfx908::v230, output_vec_len );
            case 487:  return makeRegisterExpression(amdgpu_gfx908::v231, output_vec_len );
            case 488:  return makeRegisterExpression(amdgpu_gfx908::v232, output_vec_len );
            case 489:  return makeRegisterExpression(amdgpu_gfx908::v233, output_vec_len );
            case 490:  return makeRegisterExpression(amdgpu_gfx908::v234, output_vec_len );
            case 491:  return makeRegisterExpression(amdgpu_gfx908::v235, output_vec_len );
            case 492:  return makeRegisterExpression(amdgpu_gfx908::v236, output_vec_len );
            case 493:  return makeRegisterExpression(amdgpu_gfx908::v237, output_vec_len );
            case 494:  return makeRegisterExpression(amdgpu_gfx908::v238, output_vec_len );
            case 495:  return makeRegisterExpression(amdgpu_gfx908::v239, output_vec_len );
            case 496:  return makeRegisterExpression(amdgpu_gfx908::v240, output_vec_len );
            case 497:  return makeRegisterExpression(amdgpu_gfx908::v241, output_vec_len );
            case 498:  return makeRegisterExpression(amdgpu_gfx908::v242, output_vec_len );
            case 499:  return makeRegisterExpression(amdgpu_gfx908::v243, output_vec_len );
            case 500:  return makeRegisterExpression(amdgpu_gfx908::v244, output_vec_len );
            case 501:  return makeRegisterExpression(amdgpu_gfx908::v245, output_vec_len );
            case 502:  return makeRegisterExpression(amdgpu_gfx908::v246, output_vec_len );
            case 503:  return makeRegisterExpression(amdgpu_gfx908::v247, output_vec_len );
            case 504:  return makeRegisterExpression(amdgpu_gfx908::v248, output_vec_len );
            case 505:  return makeRegisterExpression(amdgpu_gfx908::v249, output_vec_len );
            case 506:  return makeRegisterExpression(amdgpu_gfx908::v250, output_vec_len );
            case 507:  return makeRegisterExpression(amdgpu_gfx908::v251, output_vec_len );
            case 508:  return makeRegisterExpression(amdgpu_gfx908::v252, output_vec_len );
            case 509:  return makeRegisterExpression(amdgpu_gfx908::v253, output_vec_len );
            case 510:  return makeRegisterExpression(amdgpu_gfx908::v254, output_vec_len );
            case 511:  return makeRegisterExpression(amdgpu_gfx908::v255, output_vec_len );
            case 255:  return Immediate::makeImmediate(Result(u32,decodeOPR_LITERAL()));
            case 249 :  return decodeOPR_SDWA();
            default: return makeRegisterExpression(amdgpu_gfx908::invalid);
        }
    }

    Expression::Ptr InstructionDecoder_amdgpu_gfx908::decodeOPR_SRC_NOLIT(uint64_t input, uint32_t output_vec_len)
    {
        switch (input)  {
            case 0:  return makeRegisterExpression(amdgpu_gfx908::s0, output_vec_len );
            case 1:  return makeRegisterExpression(amdgpu_gfx908::s1, output_vec_len );
            case 2:  return makeRegisterExpression(amdgpu_gfx908::s2, output_vec_len );
            case 3:  return makeRegisterExpression(amdgpu_gfx908::s3, output_vec_len );
            case 4:  return makeRegisterExpression(amdgpu_gfx908::s4, output_vec_len );
            case 5:  return makeRegisterExpression(amdgpu_gfx908::s5, output_vec_len );
            case 6:  return makeRegisterExpression(amdgpu_gfx908::s6, output_vec_len );
            case 7:  return makeRegisterExpression(amdgpu_gfx908::s7, output_vec_len );
            case 8:  return makeRegisterExpression(amdgpu_gfx908::s8, output_vec_len );
            case 9:  return makeRegisterExpression(amdgpu_gfx908::s9, output_vec_len );
            case 10:  return makeRegisterExpression(amdgpu_gfx908::s10, output_vec_len );
            case 11:  return makeRegisterExpression(amdgpu_gfx908::s11, output_vec_len );
            case 12:  return makeRegisterExpression(amdgpu_gfx908::s12, output_vec_len );
            case 13:  return makeRegisterExpression(amdgpu_gfx908::s13, output_vec_len );
            case 14:  return makeRegisterExpression(amdgpu_gfx908::s14, output_vec_len );
            case 15:  return makeRegisterExpression(amdgpu_gfx908::s15, output_vec_len );
            case 16:  return makeRegisterExpression(amdgpu_gfx908::s16, output_vec_len );
            case 17:  return makeRegisterExpression(amdgpu_gfx908::s17, output_vec_len );
            case 18:  return makeRegisterExpression(amdgpu_gfx908::s18, output_vec_len );
            case 19:  return makeRegisterExpression(amdgpu_gfx908::s19, output_vec_len );
            case 20:  return makeRegisterExpression(amdgpu_gfx908::s20, output_vec_len );
            case 21:  return makeRegisterExpression(amdgpu_gfx908::s21, output_vec_len );
            case 22:  return makeRegisterExpression(amdgpu_gfx908::s22, output_vec_len );
            case 23:  return makeRegisterExpression(amdgpu_gfx908::s23, output_vec_len );
            case 24:  return makeRegisterExpression(amdgpu_gfx908::s24, output_vec_len );
            case 25:  return makeRegisterExpression(amdgpu_gfx908::s25, output_vec_len );
            case 26:  return makeRegisterExpression(amdgpu_gfx908::s26, output_vec_len );
            case 27:  return makeRegisterExpression(amdgpu_gfx908::s27, output_vec_len );
            case 28:  return makeRegisterExpression(amdgpu_gfx908::s28, output_vec_len );
            case 29:  return makeRegisterExpression(amdgpu_gfx908::s29, output_vec_len );
            case 30:  return makeRegisterExpression(amdgpu_gfx908::s30, output_vec_len );
            case 31:  return makeRegisterExpression(amdgpu_gfx908::s31, output_vec_len );
            case 32:  return makeRegisterExpression(amdgpu_gfx908::s32, output_vec_len );
            case 33:  return makeRegisterExpression(amdgpu_gfx908::s33, output_vec_len );
            case 34:  return makeRegisterExpression(amdgpu_gfx908::s34, output_vec_len );
            case 35:  return makeRegisterExpression(amdgpu_gfx908::s35, output_vec_len );
            case 36:  return makeRegisterExpression(amdgpu_gfx908::s36, output_vec_len );
            case 37:  return makeRegisterExpression(amdgpu_gfx908::s37, output_vec_len );
            case 38:  return makeRegisterExpression(amdgpu_gfx908::s38, output_vec_len );
            case 39:  return makeRegisterExpression(amdgpu_gfx908::s39, output_vec_len );
            case 40:  return makeRegisterExpression(amdgpu_gfx908::s40, output_vec_len );
            case 41:  return makeRegisterExpression(amdgpu_gfx908::s41, output_vec_len );
            case 42:  return makeRegisterExpression(amdgpu_gfx908::s42, output_vec_len );
            case 43:  return makeRegisterExpression(amdgpu_gfx908::s43, output_vec_len );
            case 44:  return makeRegisterExpression(amdgpu_gfx908::s44, output_vec_len );
            case 45:  return makeRegisterExpression(amdgpu_gfx908::s45, output_vec_len );
            case 46:  return makeRegisterExpression(amdgpu_gfx908::s46, output_vec_len );
            case 47:  return makeRegisterExpression(amdgpu_gfx908::s47, output_vec_len );
            case 48:  return makeRegisterExpression(amdgpu_gfx908::s48, output_vec_len );
            case 49:  return makeRegisterExpression(amdgpu_gfx908::s49, output_vec_len );
            case 50:  return makeRegisterExpression(amdgpu_gfx908::s50, output_vec_len );
            case 51:  return makeRegisterExpression(amdgpu_gfx908::s51, output_vec_len );
            case 52:  return makeRegisterExpression(amdgpu_gfx908::s52, output_vec_len );
            case 53:  return makeRegisterExpression(amdgpu_gfx908::s53, output_vec_len );
            case 54:  return makeRegisterExpression(amdgpu_gfx908::s54, output_vec_len );
            case 55:  return makeRegisterExpression(amdgpu_gfx908::s55, output_vec_len );
            case 56:  return makeRegisterExpression(amdgpu_gfx908::s56, output_vec_len );
            case 57:  return makeRegisterExpression(amdgpu_gfx908::s57, output_vec_len );
            case 58:  return makeRegisterExpression(amdgpu_gfx908::s58, output_vec_len );
            case 59:  return makeRegisterExpression(amdgpu_gfx908::s59, output_vec_len );
            case 60:  return makeRegisterExpression(amdgpu_gfx908::s60, output_vec_len );
            case 61:  return makeRegisterExpression(amdgpu_gfx908::s61, output_vec_len );
            case 62:  return makeRegisterExpression(amdgpu_gfx908::s62, output_vec_len );
            case 63:  return makeRegisterExpression(amdgpu_gfx908::s63, output_vec_len );
            case 64:  return makeRegisterExpression(amdgpu_gfx908::s64, output_vec_len );
            case 65:  return makeRegisterExpression(amdgpu_gfx908::s65, output_vec_len );
            case 66:  return makeRegisterExpression(amdgpu_gfx908::s66, output_vec_len );
            case 67:  return makeRegisterExpression(amdgpu_gfx908::s67, output_vec_len );
            case 68:  return makeRegisterExpression(amdgpu_gfx908::s68, output_vec_len );
            case 69:  return makeRegisterExpression(amdgpu_gfx908::s69, output_vec_len );
            case 70:  return makeRegisterExpression(amdgpu_gfx908::s70, output_vec_len );
            case 71:  return makeRegisterExpression(amdgpu_gfx908::s71, output_vec_len );
            case 72:  return makeRegisterExpression(amdgpu_gfx908::s72, output_vec_len );
            case 73:  return makeRegisterExpression(amdgpu_gfx908::s73, output_vec_len );
            case 74:  return makeRegisterExpression(amdgpu_gfx908::s74, output_vec_len );
            case 75:  return makeRegisterExpression(amdgpu_gfx908::s75, output_vec_len );
            case 76:  return makeRegisterExpression(amdgpu_gfx908::s76, output_vec_len );
            case 77:  return makeRegisterExpression(amdgpu_gfx908::s77, output_vec_len );
            case 78:  return makeRegisterExpression(amdgpu_gfx908::s78, output_vec_len );
            case 79:  return makeRegisterExpression(amdgpu_gfx908::s79, output_vec_len );
            case 80:  return makeRegisterExpression(amdgpu_gfx908::s80, output_vec_len );
            case 81:  return makeRegisterExpression(amdgpu_gfx908::s81, output_vec_len );
            case 82:  return makeRegisterExpression(amdgpu_gfx908::s82, output_vec_len );
            case 83:  return makeRegisterExpression(amdgpu_gfx908::s83, output_vec_len );
            case 84:  return makeRegisterExpression(amdgpu_gfx908::s84, output_vec_len );
            case 85:  return makeRegisterExpression(amdgpu_gfx908::s85, output_vec_len );
            case 86:  return makeRegisterExpression(amdgpu_gfx908::s86, output_vec_len );
            case 87:  return makeRegisterExpression(amdgpu_gfx908::s87, output_vec_len );
            case 88:  return makeRegisterExpression(amdgpu_gfx908::s88, output_vec_len );
            case 89:  return makeRegisterExpression(amdgpu_gfx908::s89, output_vec_len );
            case 90:  return makeRegisterExpression(amdgpu_gfx908::s90, output_vec_len );
            case 91:  return makeRegisterExpression(amdgpu_gfx908::s91, output_vec_len );
            case 92:  return makeRegisterExpression(amdgpu_gfx908::s92, output_vec_len );
            case 93:  return makeRegisterExpression(amdgpu_gfx908::s93, output_vec_len );
            case 94:  return makeRegisterExpression(amdgpu_gfx908::s94, output_vec_len );
            case 95:  return makeRegisterExpression(amdgpu_gfx908::s95, output_vec_len );
            case 96:  return makeRegisterExpression(amdgpu_gfx908::s96, output_vec_len );
            case 97:  return makeRegisterExpression(amdgpu_gfx908::s97, output_vec_len );
            case 98:  return makeRegisterExpression(amdgpu_gfx908::s98, output_vec_len );
            case 99:  return makeRegisterExpression(amdgpu_gfx908::s99, output_vec_len );
            case 100:  return makeRegisterExpression(amdgpu_gfx908::s100, output_vec_len );
            case 101:  return makeRegisterExpression(amdgpu_gfx908::s101, output_vec_len );
            case 104:  return makeRegisterExpression(amdgpu_gfx908::xnack_mask_lo, output_vec_len );
            case 105:  return makeRegisterExpression(amdgpu_gfx908::xnack_mask_hi, output_vec_len );
            case 102:  return makeRegisterExpression(amdgpu_gfx908::flat_scratch_lo, output_vec_len );
            case 103:  return makeRegisterExpression(amdgpu_gfx908::flat_scratch_hi, output_vec_len );
            case 108:  return makeRegisterExpression(amdgpu_gfx908::ttmp0, output_vec_len );
            case 109:  return makeRegisterExpression(amdgpu_gfx908::ttmp1, output_vec_len );
            case 110:  return makeRegisterExpression(amdgpu_gfx908::ttmp2, output_vec_len );
            case 111:  return makeRegisterExpression(amdgpu_gfx908::ttmp3, output_vec_len );
            case 112:  return makeRegisterExpression(amdgpu_gfx908::ttmp4, output_vec_len );
            case 113:  return makeRegisterExpression(amdgpu_gfx908::ttmp5, output_vec_len );
            case 114:  return makeRegisterExpression(amdgpu_gfx908::ttmp6, output_vec_len );
            case 115:  return makeRegisterExpression(amdgpu_gfx908::ttmp7, output_vec_len );
            case 116:  return makeRegisterExpression(amdgpu_gfx908::ttmp8, output_vec_len );
            case 117:  return makeRegisterExpression(amdgpu_gfx908::ttmp9, output_vec_len );
            case 118:  return makeRegisterExpression(amdgpu_gfx908::ttmp10, output_vec_len );
            case 119:  return makeRegisterExpression(amdgpu_gfx908::ttmp11, output_vec_len );
            case 120:  return makeRegisterExpression(amdgpu_gfx908::ttmp12, output_vec_len );
            case 121:  return makeRegisterExpression(amdgpu_gfx908::ttmp13, output_vec_len );
            case 122:  return makeRegisterExpression(amdgpu_gfx908::ttmp14, output_vec_len );
            case 123:  return makeRegisterExpression(amdgpu_gfx908::ttmp15, output_vec_len );
            case 106:  return makeRegisterExpression(amdgpu_gfx908::vcc_lo, output_vec_len );
            case 107:  return makeRegisterExpression(amdgpu_gfx908::vcc_hi, output_vec_len );
            case 124:  return makeRegisterExpression(amdgpu_gfx908::m0, output_vec_len );
            case 126:  return makeRegisterExpression(amdgpu_gfx908::exec_lo, output_vec_len );
            case 127:  return makeRegisterExpression(amdgpu_gfx908::exec_hi, output_vec_len );
            case 128:  return Immediate::makeImmediate(Result(u32, 0));
            case 129:  return Immediate::makeImmediate(Result(u32, 1));
            case 130:  return Immediate::makeImmediate(Result(u32, 2));
            case 131:  return Immediate::makeImmediate(Result(u32, 3));
            case 132:  return Immediate::makeImmediate(Result(u32, 4));
            case 133:  return Immediate::makeImmediate(Result(u32, 5));
            case 134:  return Immediate::makeImmediate(Result(u32, 6));
            case 135:  return Immediate::makeImmediate(Result(u32, 7));
            case 136:  return Immediate::makeImmediate(Result(u32, 8));
            case 137:  return Immediate::makeImmediate(Result(u32, 9));
            case 138:  return Immediate::makeImmediate(Result(u32, 10));
            case 139:  return Immediate::makeImmediate(Result(u32, 11));
            case 140:  return Immediate::makeImmediate(Result(u32, 12));
            case 141:  return Immediate::makeImmediate(Result(u32, 13));
            case 142:  return Immediate::makeImmediate(Result(u32, 14));
            case 143:  return Immediate::makeImmediate(Result(u32, 15));
            case 144:  return Immediate::makeImmediate(Result(u32, 16));
            case 145:  return Immediate::makeImmediate(Result(u32, 17));
            case 146:  return Immediate::makeImmediate(Result(u32, 18));
            case 147:  return Immediate::makeImmediate(Result(u32, 19));
            case 148:  return Immediate::makeImmediate(Result(u32, 20));
            case 149:  return Immediate::makeImmediate(Result(u32, 21));
            case 150:  return Immediate::makeImmediate(Result(u32, 22));
            case 151:  return Immediate::makeImmediate(Result(u32, 23));
            case 152:  return Immediate::makeImmediate(Result(u32, 24));
            case 153:  return Immediate::makeImmediate(Result(u32, 25));
            case 154:  return Immediate::makeImmediate(Result(u32, 26));
            case 155:  return Immediate::makeImmediate(Result(u32, 27));
            case 156:  return Immediate::makeImmediate(Result(u32, 28));
            case 157:  return Immediate::makeImmediate(Result(u32, 29));
            case 158:  return Immediate::makeImmediate(Result(u32, 30));
            case 159:  return Immediate::makeImmediate(Result(u32, 31));
            case 160:  return Immediate::makeImmediate(Result(u32, 32));
            case 161:  return Immediate::makeImmediate(Result(u32, 33));
            case 162:  return Immediate::makeImmediate(Result(u32, 34));
            case 163:  return Immediate::makeImmediate(Result(u32, 35));
            case 164:  return Immediate::makeImmediate(Result(u32, 36));
            case 165:  return Immediate::makeImmediate(Result(u32, 37));
            case 166:  return Immediate::makeImmediate(Result(u32, 38));
            case 167:  return Immediate::makeImmediate(Result(u32, 39));
            case 168:  return Immediate::makeImmediate(Result(u32, 40));
            case 169:  return Immediate::makeImmediate(Result(u32, 41));
            case 170:  return Immediate::makeImmediate(Result(u32, 42));
            case 171:  return Immediate::makeImmediate(Result(u32, 43));
            case 172:  return Immediate::makeImmediate(Result(u32, 44));
            case 173:  return Immediate::makeImmediate(Result(u32, 45));
            case 174:  return Immediate::makeImmediate(Result(u32, 46));
            case 175:  return Immediate::makeImmediate(Result(u32, 47));
            case 176:  return Immediate::makeImmediate(Result(u32, 48));
            case 177:  return Immediate::makeImmediate(Result(u32, 49));
            case 178:  return Immediate::makeImmediate(Result(u32, 50));
            case 179:  return Immediate::makeImmediate(Result(u32, 51));
            case 180:  return Immediate::makeImmediate(Result(u32, 52));
            case 181:  return Immediate::makeImmediate(Result(u32, 53));
            case 182:  return Immediate::makeImmediate(Result(u32, 54));
            case 183:  return Immediate::makeImmediate(Result(u32, 55));
            case 184:  return Immediate::makeImmediate(Result(u32, 56));
            case 185:  return Immediate::makeImmediate(Result(u32, 57));
            case 186:  return Immediate::makeImmediate(Result(u32, 58));
            case 187:  return Immediate::makeImmediate(Result(u32, 59));
            case 188:  return Immediate::makeImmediate(Result(u32, 60));
            case 189:  return Immediate::makeImmediate(Result(u32, 61));
            case 190:  return Immediate::makeImmediate(Result(u32, 62));
            case 191:  return Immediate::makeImmediate(Result(u32, 63));
            case 192:  return Immediate::makeImmediate(Result(u32, 64));
            case 193:  return Immediate::makeImmediate(Result(u32, -1));
            case 194:  return Immediate::makeImmediate(Result(u32, -2));
            case 195:  return Immediate::makeImmediate(Result(u32, -3));
            case 196:  return Immediate::makeImmediate(Result(u32, -4));
            case 197:  return Immediate::makeImmediate(Result(u32, -5));
            case 198:  return Immediate::makeImmediate(Result(u32, -6));
            case 199:  return Immediate::makeImmediate(Result(u32, -7));
            case 200:  return Immediate::makeImmediate(Result(u32, -8));
            case 201:  return Immediate::makeImmediate(Result(u32, -9));
            case 202:  return Immediate::makeImmediate(Result(u32, -10));
            case 203:  return Immediate::makeImmediate(Result(u32, -11));
            case 204:  return Immediate::makeImmediate(Result(u32, -12));
            case 205:  return Immediate::makeImmediate(Result(u32, -13));
            case 206:  return Immediate::makeImmediate(Result(u32, -14));
            case 207:  return Immediate::makeImmediate(Result(u32, -15));
            case 208:  return Immediate::makeImmediate(Result(u32, -16));
            case 240:  return Immediate::makeImmediate(Result(sp_float, 0.5));
            case 241:  return Immediate::makeImmediate(Result(sp_float, -0.5));
            case 242:  return Immediate::makeImmediate(Result(sp_float, 1.0));
            case 243:  return Immediate::makeImmediate(Result(sp_float, -1.0));
            case 244:  return Immediate::makeImmediate(Result(sp_float, 2.0));
            case 245:  return Immediate::makeImmediate(Result(sp_float, -2.0));
            case 246:  return Immediate::makeImmediate(Result(sp_float, 4.0));
            case 247:  return Immediate::makeImmediate(Result(sp_float, -4.0));
            case 248:  return Immediate::makeImmediate(Result(sp_float, 0.15915494));
            case 251:  return makeRegisterExpression(amdgpu_gfx908::src_vccz, output_vec_len );
            case 252:  return makeRegisterExpression(amdgpu_gfx908::src_execz, output_vec_len );
            case 253:  return makeRegisterExpression(amdgpu_gfx908::src_scc, output_vec_len );
            case 235:  return makeRegisterExpression(amdgpu_gfx908::src_shared_base, output_vec_len );
            case 236:  return makeRegisterExpression(amdgpu_gfx908::src_shared_limit, output_vec_len );
            case 237:  return makeRegisterExpression(amdgpu_gfx908::src_private_base, output_vec_len );
            case 238:  return makeRegisterExpression(amdgpu_gfx908::src_private_limit, output_vec_len );
            case 239:  return makeRegisterExpression(amdgpu_gfx908::src_pops_exiting_wave_id, output_vec_len );
            case 256:  return makeRegisterExpression(amdgpu_gfx908::v0, output_vec_len );
            case 257:  return makeRegisterExpression(amdgpu_gfx908::v1, output_vec_len );
            case 258:  return makeRegisterExpression(amdgpu_gfx908::v2, output_vec_len );
            case 259:  return makeRegisterExpression(amdgpu_gfx908::v3, output_vec_len );
            case 260:  return makeRegisterExpression(amdgpu_gfx908::v4, output_vec_len );
            case 261:  return makeRegisterExpression(amdgpu_gfx908::v5, output_vec_len );
            case 262:  return makeRegisterExpression(amdgpu_gfx908::v6, output_vec_len );
            case 263:  return makeRegisterExpression(amdgpu_gfx908::v7, output_vec_len );
            case 264:  return makeRegisterExpression(amdgpu_gfx908::v8, output_vec_len );
            case 265:  return makeRegisterExpression(amdgpu_gfx908::v9, output_vec_len );
            case 266:  return makeRegisterExpression(amdgpu_gfx908::v10, output_vec_len );
            case 267:  return makeRegisterExpression(amdgpu_gfx908::v11, output_vec_len );
            case 268:  return makeRegisterExpression(amdgpu_gfx908::v12, output_vec_len );
            case 269:  return makeRegisterExpression(amdgpu_gfx908::v13, output_vec_len );
            case 270:  return makeRegisterExpression(amdgpu_gfx908::v14, output_vec_len );
            case 271:  return makeRegisterExpression(amdgpu_gfx908::v15, output_vec_len );
            case 272:  return makeRegisterExpression(amdgpu_gfx908::v16, output_vec_len );
            case 273:  return makeRegisterExpression(amdgpu_gfx908::v17, output_vec_len );
            case 274:  return makeRegisterExpression(amdgpu_gfx908::v18, output_vec_len );
            case 275:  return makeRegisterExpression(amdgpu_gfx908::v19, output_vec_len );
            case 276:  return makeRegisterExpression(amdgpu_gfx908::v20, output_vec_len );
            case 277:  return makeRegisterExpression(amdgpu_gfx908::v21, output_vec_len );
            case 278:  return makeRegisterExpression(amdgpu_gfx908::v22, output_vec_len );
            case 279:  return makeRegisterExpression(amdgpu_gfx908::v23, output_vec_len );
            case 280:  return makeRegisterExpression(amdgpu_gfx908::v24, output_vec_len );
            case 281:  return makeRegisterExpression(amdgpu_gfx908::v25, output_vec_len );
            case 282:  return makeRegisterExpression(amdgpu_gfx908::v26, output_vec_len );
            case 283:  return makeRegisterExpression(amdgpu_gfx908::v27, output_vec_len );
            case 284:  return makeRegisterExpression(amdgpu_gfx908::v28, output_vec_len );
            case 285:  return makeRegisterExpression(amdgpu_gfx908::v29, output_vec_len );
            case 286:  return makeRegisterExpression(amdgpu_gfx908::v30, output_vec_len );
            case 287:  return makeRegisterExpression(amdgpu_gfx908::v31, output_vec_len );
            case 288:  return makeRegisterExpression(amdgpu_gfx908::v32, output_vec_len );
            case 289:  return makeRegisterExpression(amdgpu_gfx908::v33, output_vec_len );
            case 290:  return makeRegisterExpression(amdgpu_gfx908::v34, output_vec_len );
            case 291:  return makeRegisterExpression(amdgpu_gfx908::v35, output_vec_len );
            case 292:  return makeRegisterExpression(amdgpu_gfx908::v36, output_vec_len );
            case 293:  return makeRegisterExpression(amdgpu_gfx908::v37, output_vec_len );
            case 294:  return makeRegisterExpression(amdgpu_gfx908::v38, output_vec_len );
            case 295:  return makeRegisterExpression(amdgpu_gfx908::v39, output_vec_len );
            case 296:  return makeRegisterExpression(amdgpu_gfx908::v40, output_vec_len );
            case 297:  return makeRegisterExpression(amdgpu_gfx908::v41, output_vec_len );
            case 298:  return makeRegisterExpression(amdgpu_gfx908::v42, output_vec_len );
            case 299:  return makeRegisterExpression(amdgpu_gfx908::v43, output_vec_len );
            case 300:  return makeRegisterExpression(amdgpu_gfx908::v44, output_vec_len );
            case 301:  return makeRegisterExpression(amdgpu_gfx908::v45, output_vec_len );
            case 302:  return makeRegisterExpression(amdgpu_gfx908::v46, output_vec_len );
            case 303:  return makeRegisterExpression(amdgpu_gfx908::v47, output_vec_len );
            case 304:  return makeRegisterExpression(amdgpu_gfx908::v48, output_vec_len );
            case 305:  return makeRegisterExpression(amdgpu_gfx908::v49, output_vec_len );
            case 306:  return makeRegisterExpression(amdgpu_gfx908::v50, output_vec_len );
            case 307:  return makeRegisterExpression(amdgpu_gfx908::v51, output_vec_len );
            case 308:  return makeRegisterExpression(amdgpu_gfx908::v52, output_vec_len );
            case 309:  return makeRegisterExpression(amdgpu_gfx908::v53, output_vec_len );
            case 310:  return makeRegisterExpression(amdgpu_gfx908::v54, output_vec_len );
            case 311:  return makeRegisterExpression(amdgpu_gfx908::v55, output_vec_len );
            case 312:  return makeRegisterExpression(amdgpu_gfx908::v56, output_vec_len );
            case 313:  return makeRegisterExpression(amdgpu_gfx908::v57, output_vec_len );
            case 314:  return makeRegisterExpression(amdgpu_gfx908::v58, output_vec_len );
            case 315:  return makeRegisterExpression(amdgpu_gfx908::v59, output_vec_len );
            case 316:  return makeRegisterExpression(amdgpu_gfx908::v60, output_vec_len );
            case 317:  return makeRegisterExpression(amdgpu_gfx908::v61, output_vec_len );
            case 318:  return makeRegisterExpression(amdgpu_gfx908::v62, output_vec_len );
            case 319:  return makeRegisterExpression(amdgpu_gfx908::v63, output_vec_len );
            case 320:  return makeRegisterExpression(amdgpu_gfx908::v64, output_vec_len );
            case 321:  return makeRegisterExpression(amdgpu_gfx908::v65, output_vec_len );
            case 322:  return makeRegisterExpression(amdgpu_gfx908::v66, output_vec_len );
            case 323:  return makeRegisterExpression(amdgpu_gfx908::v67, output_vec_len );
            case 324:  return makeRegisterExpression(amdgpu_gfx908::v68, output_vec_len );
            case 325:  return makeRegisterExpression(amdgpu_gfx908::v69, output_vec_len );
            case 326:  return makeRegisterExpression(amdgpu_gfx908::v70, output_vec_len );
            case 327:  return makeRegisterExpression(amdgpu_gfx908::v71, output_vec_len );
            case 328:  return makeRegisterExpression(amdgpu_gfx908::v72, output_vec_len );
            case 329:  return makeRegisterExpression(amdgpu_gfx908::v73, output_vec_len );
            case 330:  return makeRegisterExpression(amdgpu_gfx908::v74, output_vec_len );
            case 331:  return makeRegisterExpression(amdgpu_gfx908::v75, output_vec_len );
            case 332:  return makeRegisterExpression(amdgpu_gfx908::v76, output_vec_len );
            case 333:  return makeRegisterExpression(amdgpu_gfx908::v77, output_vec_len );
            case 334:  return makeRegisterExpression(amdgpu_gfx908::v78, output_vec_len );
            case 335:  return makeRegisterExpression(amdgpu_gfx908::v79, output_vec_len );
            case 336:  return makeRegisterExpression(amdgpu_gfx908::v80, output_vec_len );
            case 337:  return makeRegisterExpression(amdgpu_gfx908::v81, output_vec_len );
            case 338:  return makeRegisterExpression(amdgpu_gfx908::v82, output_vec_len );
            case 339:  return makeRegisterExpression(amdgpu_gfx908::v83, output_vec_len );
            case 340:  return makeRegisterExpression(amdgpu_gfx908::v84, output_vec_len );
            case 341:  return makeRegisterExpression(amdgpu_gfx908::v85, output_vec_len );
            case 342:  return makeRegisterExpression(amdgpu_gfx908::v86, output_vec_len );
            case 343:  return makeRegisterExpression(amdgpu_gfx908::v87, output_vec_len );
            case 344:  return makeRegisterExpression(amdgpu_gfx908::v88, output_vec_len );
            case 345:  return makeRegisterExpression(amdgpu_gfx908::v89, output_vec_len );
            case 346:  return makeRegisterExpression(amdgpu_gfx908::v90, output_vec_len );
            case 347:  return makeRegisterExpression(amdgpu_gfx908::v91, output_vec_len );
            case 348:  return makeRegisterExpression(amdgpu_gfx908::v92, output_vec_len );
            case 349:  return makeRegisterExpression(amdgpu_gfx908::v93, output_vec_len );
            case 350:  return makeRegisterExpression(amdgpu_gfx908::v94, output_vec_len );
            case 351:  return makeRegisterExpression(amdgpu_gfx908::v95, output_vec_len );
            case 352:  return makeRegisterExpression(amdgpu_gfx908::v96, output_vec_len );
            case 353:  return makeRegisterExpression(amdgpu_gfx908::v97, output_vec_len );
            case 354:  return makeRegisterExpression(amdgpu_gfx908::v98, output_vec_len );
            case 355:  return makeRegisterExpression(amdgpu_gfx908::v99, output_vec_len );
            case 356:  return makeRegisterExpression(amdgpu_gfx908::v100, output_vec_len );
            case 357:  return makeRegisterExpression(amdgpu_gfx908::v101, output_vec_len );
            case 358:  return makeRegisterExpression(amdgpu_gfx908::v102, output_vec_len );
            case 359:  return makeRegisterExpression(amdgpu_gfx908::v103, output_vec_len );
            case 360:  return makeRegisterExpression(amdgpu_gfx908::v104, output_vec_len );
            case 361:  return makeRegisterExpression(amdgpu_gfx908::v105, output_vec_len );
            case 362:  return makeRegisterExpression(amdgpu_gfx908::v106, output_vec_len );
            case 363:  return makeRegisterExpression(amdgpu_gfx908::v107, output_vec_len );
            case 364:  return makeRegisterExpression(amdgpu_gfx908::v108, output_vec_len );
            case 365:  return makeRegisterExpression(amdgpu_gfx908::v109, output_vec_len );
            case 366:  return makeRegisterExpression(amdgpu_gfx908::v110, output_vec_len );
            case 367:  return makeRegisterExpression(amdgpu_gfx908::v111, output_vec_len );
            case 368:  return makeRegisterExpression(amdgpu_gfx908::v112, output_vec_len );
            case 369:  return makeRegisterExpression(amdgpu_gfx908::v113, output_vec_len );
            case 370:  return makeRegisterExpression(amdgpu_gfx908::v114, output_vec_len );
            case 371:  return makeRegisterExpression(amdgpu_gfx908::v115, output_vec_len );
            case 372:  return makeRegisterExpression(amdgpu_gfx908::v116, output_vec_len );
            case 373:  return makeRegisterExpression(amdgpu_gfx908::v117, output_vec_len );
            case 374:  return makeRegisterExpression(amdgpu_gfx908::v118, output_vec_len );
            case 375:  return makeRegisterExpression(amdgpu_gfx908::v119, output_vec_len );
            case 376:  return makeRegisterExpression(amdgpu_gfx908::v120, output_vec_len );
            case 377:  return makeRegisterExpression(amdgpu_gfx908::v121, output_vec_len );
            case 378:  return makeRegisterExpression(amdgpu_gfx908::v122, output_vec_len );
            case 379:  return makeRegisterExpression(amdgpu_gfx908::v123, output_vec_len );
            case 380:  return makeRegisterExpression(amdgpu_gfx908::v124, output_vec_len );
            case 381:  return makeRegisterExpression(amdgpu_gfx908::v125, output_vec_len );
            case 382:  return makeRegisterExpression(amdgpu_gfx908::v126, output_vec_len );
            case 383:  return makeRegisterExpression(amdgpu_gfx908::v127, output_vec_len );
            case 384:  return makeRegisterExpression(amdgpu_gfx908::v128, output_vec_len );
            case 385:  return makeRegisterExpression(amdgpu_gfx908::v129, output_vec_len );
            case 386:  return makeRegisterExpression(amdgpu_gfx908::v130, output_vec_len );
            case 387:  return makeRegisterExpression(amdgpu_gfx908::v131, output_vec_len );
            case 388:  return makeRegisterExpression(amdgpu_gfx908::v132, output_vec_len );
            case 389:  return makeRegisterExpression(amdgpu_gfx908::v133, output_vec_len );
            case 390:  return makeRegisterExpression(amdgpu_gfx908::v134, output_vec_len );
            case 391:  return makeRegisterExpression(amdgpu_gfx908::v135, output_vec_len );
            case 392:  return makeRegisterExpression(amdgpu_gfx908::v136, output_vec_len );
            case 393:  return makeRegisterExpression(amdgpu_gfx908::v137, output_vec_len );
            case 394:  return makeRegisterExpression(amdgpu_gfx908::v138, output_vec_len );
            case 395:  return makeRegisterExpression(amdgpu_gfx908::v139, output_vec_len );
            case 396:  return makeRegisterExpression(amdgpu_gfx908::v140, output_vec_len );
            case 397:  return makeRegisterExpression(amdgpu_gfx908::v141, output_vec_len );
            case 398:  return makeRegisterExpression(amdgpu_gfx908::v142, output_vec_len );
            case 399:  return makeRegisterExpression(amdgpu_gfx908::v143, output_vec_len );
            case 400:  return makeRegisterExpression(amdgpu_gfx908::v144, output_vec_len );
            case 401:  return makeRegisterExpression(amdgpu_gfx908::v145, output_vec_len );
            case 402:  return makeRegisterExpression(amdgpu_gfx908::v146, output_vec_len );
            case 403:  return makeRegisterExpression(amdgpu_gfx908::v147, output_vec_len );
            case 404:  return makeRegisterExpression(amdgpu_gfx908::v148, output_vec_len );
            case 405:  return makeRegisterExpression(amdgpu_gfx908::v149, output_vec_len );
            case 406:  return makeRegisterExpression(amdgpu_gfx908::v150, output_vec_len );
            case 407:  return makeRegisterExpression(amdgpu_gfx908::v151, output_vec_len );
            case 408:  return makeRegisterExpression(amdgpu_gfx908::v152, output_vec_len );
            case 409:  return makeRegisterExpression(amdgpu_gfx908::v153, output_vec_len );
            case 410:  return makeRegisterExpression(amdgpu_gfx908::v154, output_vec_len );
            case 411:  return makeRegisterExpression(amdgpu_gfx908::v155, output_vec_len );
            case 412:  return makeRegisterExpression(amdgpu_gfx908::v156, output_vec_len );
            case 413:  return makeRegisterExpression(amdgpu_gfx908::v157, output_vec_len );
            case 414:  return makeRegisterExpression(amdgpu_gfx908::v158, output_vec_len );
            case 415:  return makeRegisterExpression(amdgpu_gfx908::v159, output_vec_len );
            case 416:  return makeRegisterExpression(amdgpu_gfx908::v160, output_vec_len );
            case 417:  return makeRegisterExpression(amdgpu_gfx908::v161, output_vec_len );
            case 418:  return makeRegisterExpression(amdgpu_gfx908::v162, output_vec_len );
            case 419:  return makeRegisterExpression(amdgpu_gfx908::v163, output_vec_len );
            case 420:  return makeRegisterExpression(amdgpu_gfx908::v164, output_vec_len );
            case 421:  return makeRegisterExpression(amdgpu_gfx908::v165, output_vec_len );
            case 422:  return makeRegisterExpression(amdgpu_gfx908::v166, output_vec_len );
            case 423:  return makeRegisterExpression(amdgpu_gfx908::v167, output_vec_len );
            case 424:  return makeRegisterExpression(amdgpu_gfx908::v168, output_vec_len );
            case 425:  return makeRegisterExpression(amdgpu_gfx908::v169, output_vec_len );
            case 426:  return makeRegisterExpression(amdgpu_gfx908::v170, output_vec_len );
            case 427:  return makeRegisterExpression(amdgpu_gfx908::v171, output_vec_len );
            case 428:  return makeRegisterExpression(amdgpu_gfx908::v172, output_vec_len );
            case 429:  return makeRegisterExpression(amdgpu_gfx908::v173, output_vec_len );
            case 430:  return makeRegisterExpression(amdgpu_gfx908::v174, output_vec_len );
            case 431:  return makeRegisterExpression(amdgpu_gfx908::v175, output_vec_len );
            case 432:  return makeRegisterExpression(amdgpu_gfx908::v176, output_vec_len );
            case 433:  return makeRegisterExpression(amdgpu_gfx908::v177, output_vec_len );
            case 434:  return makeRegisterExpression(amdgpu_gfx908::v178, output_vec_len );
            case 435:  return makeRegisterExpression(amdgpu_gfx908::v179, output_vec_len );
            case 436:  return makeRegisterExpression(amdgpu_gfx908::v180, output_vec_len );
            case 437:  return makeRegisterExpression(amdgpu_gfx908::v181, output_vec_len );
            case 438:  return makeRegisterExpression(amdgpu_gfx908::v182, output_vec_len );
            case 439:  return makeRegisterExpression(amdgpu_gfx908::v183, output_vec_len );
            case 440:  return makeRegisterExpression(amdgpu_gfx908::v184, output_vec_len );
            case 441:  return makeRegisterExpression(amdgpu_gfx908::v185, output_vec_len );
            case 442:  return makeRegisterExpression(amdgpu_gfx908::v186, output_vec_len );
            case 443:  return makeRegisterExpression(amdgpu_gfx908::v187, output_vec_len );
            case 444:  return makeRegisterExpression(amdgpu_gfx908::v188, output_vec_len );
            case 445:  return makeRegisterExpression(amdgpu_gfx908::v189, output_vec_len );
            case 446:  return makeRegisterExpression(amdgpu_gfx908::v190, output_vec_len );
            case 447:  return makeRegisterExpression(amdgpu_gfx908::v191, output_vec_len );
            case 448:  return makeRegisterExpression(amdgpu_gfx908::v192, output_vec_len );
            case 449:  return makeRegisterExpression(amdgpu_gfx908::v193, output_vec_len );
            case 450:  return makeRegisterExpression(amdgpu_gfx908::v194, output_vec_len );
            case 451:  return makeRegisterExpression(amdgpu_gfx908::v195, output_vec_len );
            case 452:  return makeRegisterExpression(amdgpu_gfx908::v196, output_vec_len );
            case 453:  return makeRegisterExpression(amdgpu_gfx908::v197, output_vec_len );
            case 454:  return makeRegisterExpression(amdgpu_gfx908::v198, output_vec_len );
            case 455:  return makeRegisterExpression(amdgpu_gfx908::v199, output_vec_len );
            case 456:  return makeRegisterExpression(amdgpu_gfx908::v200, output_vec_len );
            case 457:  return makeRegisterExpression(amdgpu_gfx908::v201, output_vec_len );
            case 458:  return makeRegisterExpression(amdgpu_gfx908::v202, output_vec_len );
            case 459:  return makeRegisterExpression(amdgpu_gfx908::v203, output_vec_len );
            case 460:  return makeRegisterExpression(amdgpu_gfx908::v204, output_vec_len );
            case 461:  return makeRegisterExpression(amdgpu_gfx908::v205, output_vec_len );
            case 462:  return makeRegisterExpression(amdgpu_gfx908::v206, output_vec_len );
            case 463:  return makeRegisterExpression(amdgpu_gfx908::v207, output_vec_len );
            case 464:  return makeRegisterExpression(amdgpu_gfx908::v208, output_vec_len );
            case 465:  return makeRegisterExpression(amdgpu_gfx908::v209, output_vec_len );
            case 466:  return makeRegisterExpression(amdgpu_gfx908::v210, output_vec_len );
            case 467:  return makeRegisterExpression(amdgpu_gfx908::v211, output_vec_len );
            case 468:  return makeRegisterExpression(amdgpu_gfx908::v212, output_vec_len );
            case 469:  return makeRegisterExpression(amdgpu_gfx908::v213, output_vec_len );
            case 470:  return makeRegisterExpression(amdgpu_gfx908::v214, output_vec_len );
            case 471:  return makeRegisterExpression(amdgpu_gfx908::v215, output_vec_len );
            case 472:  return makeRegisterExpression(amdgpu_gfx908::v216, output_vec_len );
            case 473:  return makeRegisterExpression(amdgpu_gfx908::v217, output_vec_len );
            case 474:  return makeRegisterExpression(amdgpu_gfx908::v218, output_vec_len );
            case 475:  return makeRegisterExpression(amdgpu_gfx908::v219, output_vec_len );
            case 476:  return makeRegisterExpression(amdgpu_gfx908::v220, output_vec_len );
            case 477:  return makeRegisterExpression(amdgpu_gfx908::v221, output_vec_len );
            case 478:  return makeRegisterExpression(amdgpu_gfx908::v222, output_vec_len );
            case 479:  return makeRegisterExpression(amdgpu_gfx908::v223, output_vec_len );
            case 480:  return makeRegisterExpression(amdgpu_gfx908::v224, output_vec_len );
            case 481:  return makeRegisterExpression(amdgpu_gfx908::v225, output_vec_len );
            case 482:  return makeRegisterExpression(amdgpu_gfx908::v226, output_vec_len );
            case 483:  return makeRegisterExpression(amdgpu_gfx908::v227, output_vec_len );
            case 484:  return makeRegisterExpression(amdgpu_gfx908::v228, output_vec_len );
            case 485:  return makeRegisterExpression(amdgpu_gfx908::v229, output_vec_len );
            case 486:  return makeRegisterExpression(amdgpu_gfx908::v230, output_vec_len );
            case 487:  return makeRegisterExpression(amdgpu_gfx908::v231, output_vec_len );
            case 488:  return makeRegisterExpression(amdgpu_gfx908::v232, output_vec_len );
            case 489:  return makeRegisterExpression(amdgpu_gfx908::v233, output_vec_len );
            case 490:  return makeRegisterExpression(amdgpu_gfx908::v234, output_vec_len );
            case 491:  return makeRegisterExpression(amdgpu_gfx908::v235, output_vec_len );
            case 492:  return makeRegisterExpression(amdgpu_gfx908::v236, output_vec_len );
            case 493:  return makeRegisterExpression(amdgpu_gfx908::v237, output_vec_len );
            case 494:  return makeRegisterExpression(amdgpu_gfx908::v238, output_vec_len );
            case 495:  return makeRegisterExpression(amdgpu_gfx908::v239, output_vec_len );
            case 496:  return makeRegisterExpression(amdgpu_gfx908::v240, output_vec_len );
            case 497:  return makeRegisterExpression(amdgpu_gfx908::v241, output_vec_len );
            case 498:  return makeRegisterExpression(amdgpu_gfx908::v242, output_vec_len );
            case 499:  return makeRegisterExpression(amdgpu_gfx908::v243, output_vec_len );
            case 500:  return makeRegisterExpression(amdgpu_gfx908::v244, output_vec_len );
            case 501:  return makeRegisterExpression(amdgpu_gfx908::v245, output_vec_len );
            case 502:  return makeRegisterExpression(amdgpu_gfx908::v246, output_vec_len );
            case 503:  return makeRegisterExpression(amdgpu_gfx908::v247, output_vec_len );
            case 504:  return makeRegisterExpression(amdgpu_gfx908::v248, output_vec_len );
            case 505:  return makeRegisterExpression(amdgpu_gfx908::v249, output_vec_len );
            case 506:  return makeRegisterExpression(amdgpu_gfx908::v250, output_vec_len );
            case 507:  return makeRegisterExpression(amdgpu_gfx908::v251, output_vec_len );
            case 508:  return makeRegisterExpression(amdgpu_gfx908::v252, output_vec_len );
            case 509:  return makeRegisterExpression(amdgpu_gfx908::v253, output_vec_len );
            case 510:  return makeRegisterExpression(amdgpu_gfx908::v254, output_vec_len );
            case 511:  return makeRegisterExpression(amdgpu_gfx908::v255, output_vec_len );
            case 254:  return makeRegisterExpression(amdgpu_gfx908::src_lds_direct, output_vec_len );
            default: return makeRegisterExpression(amdgpu_gfx908::invalid);
        }
    }

    Expression::Ptr InstructionDecoder_amdgpu_gfx908::decodeOPR_SRC_SIMPLE(uint64_t input, uint32_t output_vec_len)
    {
        switch (input)  {
            case 0:  return makeRegisterExpression(amdgpu_gfx908::s0, output_vec_len );
            case 1:  return makeRegisterExpression(amdgpu_gfx908::s1, output_vec_len );
            case 2:  return makeRegisterExpression(amdgpu_gfx908::s2, output_vec_len );
            case 3:  return makeRegisterExpression(amdgpu_gfx908::s3, output_vec_len );
            case 4:  return makeRegisterExpression(amdgpu_gfx908::s4, output_vec_len );
            case 5:  return makeRegisterExpression(amdgpu_gfx908::s5, output_vec_len );
            case 6:  return makeRegisterExpression(amdgpu_gfx908::s6, output_vec_len );
            case 7:  return makeRegisterExpression(amdgpu_gfx908::s7, output_vec_len );
            case 8:  return makeRegisterExpression(amdgpu_gfx908::s8, output_vec_len );
            case 9:  return makeRegisterExpression(amdgpu_gfx908::s9, output_vec_len );
            case 10:  return makeRegisterExpression(amdgpu_gfx908::s10, output_vec_len );
            case 11:  return makeRegisterExpression(amdgpu_gfx908::s11, output_vec_len );
            case 12:  return makeRegisterExpression(amdgpu_gfx908::s12, output_vec_len );
            case 13:  return makeRegisterExpression(amdgpu_gfx908::s13, output_vec_len );
            case 14:  return makeRegisterExpression(amdgpu_gfx908::s14, output_vec_len );
            case 15:  return makeRegisterExpression(amdgpu_gfx908::s15, output_vec_len );
            case 16:  return makeRegisterExpression(amdgpu_gfx908::s16, output_vec_len );
            case 17:  return makeRegisterExpression(amdgpu_gfx908::s17, output_vec_len );
            case 18:  return makeRegisterExpression(amdgpu_gfx908::s18, output_vec_len );
            case 19:  return makeRegisterExpression(amdgpu_gfx908::s19, output_vec_len );
            case 20:  return makeRegisterExpression(amdgpu_gfx908::s20, output_vec_len );
            case 21:  return makeRegisterExpression(amdgpu_gfx908::s21, output_vec_len );
            case 22:  return makeRegisterExpression(amdgpu_gfx908::s22, output_vec_len );
            case 23:  return makeRegisterExpression(amdgpu_gfx908::s23, output_vec_len );
            case 24:  return makeRegisterExpression(amdgpu_gfx908::s24, output_vec_len );
            case 25:  return makeRegisterExpression(amdgpu_gfx908::s25, output_vec_len );
            case 26:  return makeRegisterExpression(amdgpu_gfx908::s26, output_vec_len );
            case 27:  return makeRegisterExpression(amdgpu_gfx908::s27, output_vec_len );
            case 28:  return makeRegisterExpression(amdgpu_gfx908::s28, output_vec_len );
            case 29:  return makeRegisterExpression(amdgpu_gfx908::s29, output_vec_len );
            case 30:  return makeRegisterExpression(amdgpu_gfx908::s30, output_vec_len );
            case 31:  return makeRegisterExpression(amdgpu_gfx908::s31, output_vec_len );
            case 32:  return makeRegisterExpression(amdgpu_gfx908::s32, output_vec_len );
            case 33:  return makeRegisterExpression(amdgpu_gfx908::s33, output_vec_len );
            case 34:  return makeRegisterExpression(amdgpu_gfx908::s34, output_vec_len );
            case 35:  return makeRegisterExpression(amdgpu_gfx908::s35, output_vec_len );
            case 36:  return makeRegisterExpression(amdgpu_gfx908::s36, output_vec_len );
            case 37:  return makeRegisterExpression(amdgpu_gfx908::s37, output_vec_len );
            case 38:  return makeRegisterExpression(amdgpu_gfx908::s38, output_vec_len );
            case 39:  return makeRegisterExpression(amdgpu_gfx908::s39, output_vec_len );
            case 40:  return makeRegisterExpression(amdgpu_gfx908::s40, output_vec_len );
            case 41:  return makeRegisterExpression(amdgpu_gfx908::s41, output_vec_len );
            case 42:  return makeRegisterExpression(amdgpu_gfx908::s42, output_vec_len );
            case 43:  return makeRegisterExpression(amdgpu_gfx908::s43, output_vec_len );
            case 44:  return makeRegisterExpression(amdgpu_gfx908::s44, output_vec_len );
            case 45:  return makeRegisterExpression(amdgpu_gfx908::s45, output_vec_len );
            case 46:  return makeRegisterExpression(amdgpu_gfx908::s46, output_vec_len );
            case 47:  return makeRegisterExpression(amdgpu_gfx908::s47, output_vec_len );
            case 48:  return makeRegisterExpression(amdgpu_gfx908::s48, output_vec_len );
            case 49:  return makeRegisterExpression(amdgpu_gfx908::s49, output_vec_len );
            case 50:  return makeRegisterExpression(amdgpu_gfx908::s50, output_vec_len );
            case 51:  return makeRegisterExpression(amdgpu_gfx908::s51, output_vec_len );
            case 52:  return makeRegisterExpression(amdgpu_gfx908::s52, output_vec_len );
            case 53:  return makeRegisterExpression(amdgpu_gfx908::s53, output_vec_len );
            case 54:  return makeRegisterExpression(amdgpu_gfx908::s54, output_vec_len );
            case 55:  return makeRegisterExpression(amdgpu_gfx908::s55, output_vec_len );
            case 56:  return makeRegisterExpression(amdgpu_gfx908::s56, output_vec_len );
            case 57:  return makeRegisterExpression(amdgpu_gfx908::s57, output_vec_len );
            case 58:  return makeRegisterExpression(amdgpu_gfx908::s58, output_vec_len );
            case 59:  return makeRegisterExpression(amdgpu_gfx908::s59, output_vec_len );
            case 60:  return makeRegisterExpression(amdgpu_gfx908::s60, output_vec_len );
            case 61:  return makeRegisterExpression(amdgpu_gfx908::s61, output_vec_len );
            case 62:  return makeRegisterExpression(amdgpu_gfx908::s62, output_vec_len );
            case 63:  return makeRegisterExpression(amdgpu_gfx908::s63, output_vec_len );
            case 64:  return makeRegisterExpression(amdgpu_gfx908::s64, output_vec_len );
            case 65:  return makeRegisterExpression(amdgpu_gfx908::s65, output_vec_len );
            case 66:  return makeRegisterExpression(amdgpu_gfx908::s66, output_vec_len );
            case 67:  return makeRegisterExpression(amdgpu_gfx908::s67, output_vec_len );
            case 68:  return makeRegisterExpression(amdgpu_gfx908::s68, output_vec_len );
            case 69:  return makeRegisterExpression(amdgpu_gfx908::s69, output_vec_len );
            case 70:  return makeRegisterExpression(amdgpu_gfx908::s70, output_vec_len );
            case 71:  return makeRegisterExpression(amdgpu_gfx908::s71, output_vec_len );
            case 72:  return makeRegisterExpression(amdgpu_gfx908::s72, output_vec_len );
            case 73:  return makeRegisterExpression(amdgpu_gfx908::s73, output_vec_len );
            case 74:  return makeRegisterExpression(amdgpu_gfx908::s74, output_vec_len );
            case 75:  return makeRegisterExpression(amdgpu_gfx908::s75, output_vec_len );
            case 76:  return makeRegisterExpression(amdgpu_gfx908::s76, output_vec_len );
            case 77:  return makeRegisterExpression(amdgpu_gfx908::s77, output_vec_len );
            case 78:  return makeRegisterExpression(amdgpu_gfx908::s78, output_vec_len );
            case 79:  return makeRegisterExpression(amdgpu_gfx908::s79, output_vec_len );
            case 80:  return makeRegisterExpression(amdgpu_gfx908::s80, output_vec_len );
            case 81:  return makeRegisterExpression(amdgpu_gfx908::s81, output_vec_len );
            case 82:  return makeRegisterExpression(amdgpu_gfx908::s82, output_vec_len );
            case 83:  return makeRegisterExpression(amdgpu_gfx908::s83, output_vec_len );
            case 84:  return makeRegisterExpression(amdgpu_gfx908::s84, output_vec_len );
            case 85:  return makeRegisterExpression(amdgpu_gfx908::s85, output_vec_len );
            case 86:  return makeRegisterExpression(amdgpu_gfx908::s86, output_vec_len );
            case 87:  return makeRegisterExpression(amdgpu_gfx908::s87, output_vec_len );
            case 88:  return makeRegisterExpression(amdgpu_gfx908::s88, output_vec_len );
            case 89:  return makeRegisterExpression(amdgpu_gfx908::s89, output_vec_len );
            case 90:  return makeRegisterExpression(amdgpu_gfx908::s90, output_vec_len );
            case 91:  return makeRegisterExpression(amdgpu_gfx908::s91, output_vec_len );
            case 92:  return makeRegisterExpression(amdgpu_gfx908::s92, output_vec_len );
            case 93:  return makeRegisterExpression(amdgpu_gfx908::s93, output_vec_len );
            case 94:  return makeRegisterExpression(amdgpu_gfx908::s94, output_vec_len );
            case 95:  return makeRegisterExpression(amdgpu_gfx908::s95, output_vec_len );
            case 96:  return makeRegisterExpression(amdgpu_gfx908::s96, output_vec_len );
            case 97:  return makeRegisterExpression(amdgpu_gfx908::s97, output_vec_len );
            case 98:  return makeRegisterExpression(amdgpu_gfx908::s98, output_vec_len );
            case 99:  return makeRegisterExpression(amdgpu_gfx908::s99, output_vec_len );
            case 100:  return makeRegisterExpression(amdgpu_gfx908::s100, output_vec_len );
            case 101:  return makeRegisterExpression(amdgpu_gfx908::s101, output_vec_len );
            case 104:  return makeRegisterExpression(amdgpu_gfx908::xnack_mask_lo, output_vec_len );
            case 105:  return makeRegisterExpression(amdgpu_gfx908::xnack_mask_hi, output_vec_len );
            case 102:  return makeRegisterExpression(amdgpu_gfx908::flat_scratch_lo, output_vec_len );
            case 103:  return makeRegisterExpression(amdgpu_gfx908::flat_scratch_hi, output_vec_len );
            case 108:  return makeRegisterExpression(amdgpu_gfx908::ttmp0, output_vec_len );
            case 109:  return makeRegisterExpression(amdgpu_gfx908::ttmp1, output_vec_len );
            case 110:  return makeRegisterExpression(amdgpu_gfx908::ttmp2, output_vec_len );
            case 111:  return makeRegisterExpression(amdgpu_gfx908::ttmp3, output_vec_len );
            case 112:  return makeRegisterExpression(amdgpu_gfx908::ttmp4, output_vec_len );
            case 113:  return makeRegisterExpression(amdgpu_gfx908::ttmp5, output_vec_len );
            case 114:  return makeRegisterExpression(amdgpu_gfx908::ttmp6, output_vec_len );
            case 115:  return makeRegisterExpression(amdgpu_gfx908::ttmp7, output_vec_len );
            case 116:  return makeRegisterExpression(amdgpu_gfx908::ttmp8, output_vec_len );
            case 117:  return makeRegisterExpression(amdgpu_gfx908::ttmp9, output_vec_len );
            case 118:  return makeRegisterExpression(amdgpu_gfx908::ttmp10, output_vec_len );
            case 119:  return makeRegisterExpression(amdgpu_gfx908::ttmp11, output_vec_len );
            case 120:  return makeRegisterExpression(amdgpu_gfx908::ttmp12, output_vec_len );
            case 121:  return makeRegisterExpression(amdgpu_gfx908::ttmp13, output_vec_len );
            case 122:  return makeRegisterExpression(amdgpu_gfx908::ttmp14, output_vec_len );
            case 123:  return makeRegisterExpression(amdgpu_gfx908::ttmp15, output_vec_len );
            case 106:  return makeRegisterExpression(amdgpu_gfx908::vcc_lo, output_vec_len );
            case 107:  return makeRegisterExpression(amdgpu_gfx908::vcc_hi, output_vec_len );
            case 124:  return makeRegisterExpression(amdgpu_gfx908::m0, output_vec_len );
            case 126:  return makeRegisterExpression(amdgpu_gfx908::exec_lo, output_vec_len );
            case 127:  return makeRegisterExpression(amdgpu_gfx908::exec_hi, output_vec_len );
            case 128:  return Immediate::makeImmediate(Result(u32, 0));
            case 129:  return Immediate::makeImmediate(Result(u32, 1));
            case 130:  return Immediate::makeImmediate(Result(u32, 2));
            case 131:  return Immediate::makeImmediate(Result(u32, 3));
            case 132:  return Immediate::makeImmediate(Result(u32, 4));
            case 133:  return Immediate::makeImmediate(Result(u32, 5));
            case 134:  return Immediate::makeImmediate(Result(u32, 6));
            case 135:  return Immediate::makeImmediate(Result(u32, 7));
            case 136:  return Immediate::makeImmediate(Result(u32, 8));
            case 137:  return Immediate::makeImmediate(Result(u32, 9));
            case 138:  return Immediate::makeImmediate(Result(u32, 10));
            case 139:  return Immediate::makeImmediate(Result(u32, 11));
            case 140:  return Immediate::makeImmediate(Result(u32, 12));
            case 141:  return Immediate::makeImmediate(Result(u32, 13));
            case 142:  return Immediate::makeImmediate(Result(u32, 14));
            case 143:  return Immediate::makeImmediate(Result(u32, 15));
            case 144:  return Immediate::makeImmediate(Result(u32, 16));
            case 145:  return Immediate::makeImmediate(Result(u32, 17));
            case 146:  return Immediate::makeImmediate(Result(u32, 18));
            case 147:  return Immediate::makeImmediate(Result(u32, 19));
            case 148:  return Immediate::makeImmediate(Result(u32, 20));
            case 149:  return Immediate::makeImmediate(Result(u32, 21));
            case 150:  return Immediate::makeImmediate(Result(u32, 22));
            case 151:  return Immediate::makeImmediate(Result(u32, 23));
            case 152:  return Immediate::makeImmediate(Result(u32, 24));
            case 153:  return Immediate::makeImmediate(Result(u32, 25));
            case 154:  return Immediate::makeImmediate(Result(u32, 26));
            case 155:  return Immediate::makeImmediate(Result(u32, 27));
            case 156:  return Immediate::makeImmediate(Result(u32, 28));
            case 157:  return Immediate::makeImmediate(Result(u32, 29));
            case 158:  return Immediate::makeImmediate(Result(u32, 30));
            case 159:  return Immediate::makeImmediate(Result(u32, 31));
            case 160:  return Immediate::makeImmediate(Result(u32, 32));
            case 161:  return Immediate::makeImmediate(Result(u32, 33));
            case 162:  return Immediate::makeImmediate(Result(u32, 34));
            case 163:  return Immediate::makeImmediate(Result(u32, 35));
            case 164:  return Immediate::makeImmediate(Result(u32, 36));
            case 165:  return Immediate::makeImmediate(Result(u32, 37));
            case 166:  return Immediate::makeImmediate(Result(u32, 38));
            case 167:  return Immediate::makeImmediate(Result(u32, 39));
            case 168:  return Immediate::makeImmediate(Result(u32, 40));
            case 169:  return Immediate::makeImmediate(Result(u32, 41));
            case 170:  return Immediate::makeImmediate(Result(u32, 42));
            case 171:  return Immediate::makeImmediate(Result(u32, 43));
            case 172:  return Immediate::makeImmediate(Result(u32, 44));
            case 173:  return Immediate::makeImmediate(Result(u32, 45));
            case 174:  return Immediate::makeImmediate(Result(u32, 46));
            case 175:  return Immediate::makeImmediate(Result(u32, 47));
            case 176:  return Immediate::makeImmediate(Result(u32, 48));
            case 177:  return Immediate::makeImmediate(Result(u32, 49));
            case 178:  return Immediate::makeImmediate(Result(u32, 50));
            case 179:  return Immediate::makeImmediate(Result(u32, 51));
            case 180:  return Immediate::makeImmediate(Result(u32, 52));
            case 181:  return Immediate::makeImmediate(Result(u32, 53));
            case 182:  return Immediate::makeImmediate(Result(u32, 54));
            case 183:  return Immediate::makeImmediate(Result(u32, 55));
            case 184:  return Immediate::makeImmediate(Result(u32, 56));
            case 185:  return Immediate::makeImmediate(Result(u32, 57));
            case 186:  return Immediate::makeImmediate(Result(u32, 58));
            case 187:  return Immediate::makeImmediate(Result(u32, 59));
            case 188:  return Immediate::makeImmediate(Result(u32, 60));
            case 189:  return Immediate::makeImmediate(Result(u32, 61));
            case 190:  return Immediate::makeImmediate(Result(u32, 62));
            case 191:  return Immediate::makeImmediate(Result(u32, 63));
            case 192:  return Immediate::makeImmediate(Result(u32, 64));
            case 193:  return Immediate::makeImmediate(Result(u32, -1));
            case 194:  return Immediate::makeImmediate(Result(u32, -2));
            case 195:  return Immediate::makeImmediate(Result(u32, -3));
            case 196:  return Immediate::makeImmediate(Result(u32, -4));
            case 197:  return Immediate::makeImmediate(Result(u32, -5));
            case 198:  return Immediate::makeImmediate(Result(u32, -6));
            case 199:  return Immediate::makeImmediate(Result(u32, -7));
            case 200:  return Immediate::makeImmediate(Result(u32, -8));
            case 201:  return Immediate::makeImmediate(Result(u32, -9));
            case 202:  return Immediate::makeImmediate(Result(u32, -10));
            case 203:  return Immediate::makeImmediate(Result(u32, -11));
            case 204:  return Immediate::makeImmediate(Result(u32, -12));
            case 205:  return Immediate::makeImmediate(Result(u32, -13));
            case 206:  return Immediate::makeImmediate(Result(u32, -14));
            case 207:  return Immediate::makeImmediate(Result(u32, -15));
            case 208:  return Immediate::makeImmediate(Result(u32, -16));
            case 240:  return Immediate::makeImmediate(Result(sp_float, 0.5));
            case 241:  return Immediate::makeImmediate(Result(sp_float, -0.5));
            case 242:  return Immediate::makeImmediate(Result(sp_float, 1.0));
            case 243:  return Immediate::makeImmediate(Result(sp_float, -1.0));
            case 244:  return Immediate::makeImmediate(Result(sp_float, 2.0));
            case 245:  return Immediate::makeImmediate(Result(sp_float, -2.0));
            case 246:  return Immediate::makeImmediate(Result(sp_float, 4.0));
            case 247:  return Immediate::makeImmediate(Result(sp_float, -4.0));
            case 248:  return Immediate::makeImmediate(Result(sp_float, 0.15915494));
            case 251:  return makeRegisterExpression(amdgpu_gfx908::src_vccz, output_vec_len );
            case 252:  return makeRegisterExpression(amdgpu_gfx908::src_execz, output_vec_len );
            case 253:  return makeRegisterExpression(amdgpu_gfx908::src_scc, output_vec_len );
            case 235:  return makeRegisterExpression(amdgpu_gfx908::src_shared_base, output_vec_len );
            case 236:  return makeRegisterExpression(amdgpu_gfx908::src_shared_limit, output_vec_len );
            case 237:  return makeRegisterExpression(amdgpu_gfx908::src_private_base, output_vec_len );
            case 238:  return makeRegisterExpression(amdgpu_gfx908::src_private_limit, output_vec_len );
            case 239:  return makeRegisterExpression(amdgpu_gfx908::src_pops_exiting_wave_id, output_vec_len );
            case 256:  return makeRegisterExpression(amdgpu_gfx908::v0, output_vec_len );
            case 257:  return makeRegisterExpression(amdgpu_gfx908::v1, output_vec_len );
            case 258:  return makeRegisterExpression(amdgpu_gfx908::v2, output_vec_len );
            case 259:  return makeRegisterExpression(amdgpu_gfx908::v3, output_vec_len );
            case 260:  return makeRegisterExpression(amdgpu_gfx908::v4, output_vec_len );
            case 261:  return makeRegisterExpression(amdgpu_gfx908::v5, output_vec_len );
            case 262:  return makeRegisterExpression(amdgpu_gfx908::v6, output_vec_len );
            case 263:  return makeRegisterExpression(amdgpu_gfx908::v7, output_vec_len );
            case 264:  return makeRegisterExpression(amdgpu_gfx908::v8, output_vec_len );
            case 265:  return makeRegisterExpression(amdgpu_gfx908::v9, output_vec_len );
            case 266:  return makeRegisterExpression(amdgpu_gfx908::v10, output_vec_len );
            case 267:  return makeRegisterExpression(amdgpu_gfx908::v11, output_vec_len );
            case 268:  return makeRegisterExpression(amdgpu_gfx908::v12, output_vec_len );
            case 269:  return makeRegisterExpression(amdgpu_gfx908::v13, output_vec_len );
            case 270:  return makeRegisterExpression(amdgpu_gfx908::v14, output_vec_len );
            case 271:  return makeRegisterExpression(amdgpu_gfx908::v15, output_vec_len );
            case 272:  return makeRegisterExpression(amdgpu_gfx908::v16, output_vec_len );
            case 273:  return makeRegisterExpression(amdgpu_gfx908::v17, output_vec_len );
            case 274:  return makeRegisterExpression(amdgpu_gfx908::v18, output_vec_len );
            case 275:  return makeRegisterExpression(amdgpu_gfx908::v19, output_vec_len );
            case 276:  return makeRegisterExpression(amdgpu_gfx908::v20, output_vec_len );
            case 277:  return makeRegisterExpression(amdgpu_gfx908::v21, output_vec_len );
            case 278:  return makeRegisterExpression(amdgpu_gfx908::v22, output_vec_len );
            case 279:  return makeRegisterExpression(amdgpu_gfx908::v23, output_vec_len );
            case 280:  return makeRegisterExpression(amdgpu_gfx908::v24, output_vec_len );
            case 281:  return makeRegisterExpression(amdgpu_gfx908::v25, output_vec_len );
            case 282:  return makeRegisterExpression(amdgpu_gfx908::v26, output_vec_len );
            case 283:  return makeRegisterExpression(amdgpu_gfx908::v27, output_vec_len );
            case 284:  return makeRegisterExpression(amdgpu_gfx908::v28, output_vec_len );
            case 285:  return makeRegisterExpression(amdgpu_gfx908::v29, output_vec_len );
            case 286:  return makeRegisterExpression(amdgpu_gfx908::v30, output_vec_len );
            case 287:  return makeRegisterExpression(amdgpu_gfx908::v31, output_vec_len );
            case 288:  return makeRegisterExpression(amdgpu_gfx908::v32, output_vec_len );
            case 289:  return makeRegisterExpression(amdgpu_gfx908::v33, output_vec_len );
            case 290:  return makeRegisterExpression(amdgpu_gfx908::v34, output_vec_len );
            case 291:  return makeRegisterExpression(amdgpu_gfx908::v35, output_vec_len );
            case 292:  return makeRegisterExpression(amdgpu_gfx908::v36, output_vec_len );
            case 293:  return makeRegisterExpression(amdgpu_gfx908::v37, output_vec_len );
            case 294:  return makeRegisterExpression(amdgpu_gfx908::v38, output_vec_len );
            case 295:  return makeRegisterExpression(amdgpu_gfx908::v39, output_vec_len );
            case 296:  return makeRegisterExpression(amdgpu_gfx908::v40, output_vec_len );
            case 297:  return makeRegisterExpression(amdgpu_gfx908::v41, output_vec_len );
            case 298:  return makeRegisterExpression(amdgpu_gfx908::v42, output_vec_len );
            case 299:  return makeRegisterExpression(amdgpu_gfx908::v43, output_vec_len );
            case 300:  return makeRegisterExpression(amdgpu_gfx908::v44, output_vec_len );
            case 301:  return makeRegisterExpression(amdgpu_gfx908::v45, output_vec_len );
            case 302:  return makeRegisterExpression(amdgpu_gfx908::v46, output_vec_len );
            case 303:  return makeRegisterExpression(amdgpu_gfx908::v47, output_vec_len );
            case 304:  return makeRegisterExpression(amdgpu_gfx908::v48, output_vec_len );
            case 305:  return makeRegisterExpression(amdgpu_gfx908::v49, output_vec_len );
            case 306:  return makeRegisterExpression(amdgpu_gfx908::v50, output_vec_len );
            case 307:  return makeRegisterExpression(amdgpu_gfx908::v51, output_vec_len );
            case 308:  return makeRegisterExpression(amdgpu_gfx908::v52, output_vec_len );
            case 309:  return makeRegisterExpression(amdgpu_gfx908::v53, output_vec_len );
            case 310:  return makeRegisterExpression(amdgpu_gfx908::v54, output_vec_len );
            case 311:  return makeRegisterExpression(amdgpu_gfx908::v55, output_vec_len );
            case 312:  return makeRegisterExpression(amdgpu_gfx908::v56, output_vec_len );
            case 313:  return makeRegisterExpression(amdgpu_gfx908::v57, output_vec_len );
            case 314:  return makeRegisterExpression(amdgpu_gfx908::v58, output_vec_len );
            case 315:  return makeRegisterExpression(amdgpu_gfx908::v59, output_vec_len );
            case 316:  return makeRegisterExpression(amdgpu_gfx908::v60, output_vec_len );
            case 317:  return makeRegisterExpression(amdgpu_gfx908::v61, output_vec_len );
            case 318:  return makeRegisterExpression(amdgpu_gfx908::v62, output_vec_len );
            case 319:  return makeRegisterExpression(amdgpu_gfx908::v63, output_vec_len );
            case 320:  return makeRegisterExpression(amdgpu_gfx908::v64, output_vec_len );
            case 321:  return makeRegisterExpression(amdgpu_gfx908::v65, output_vec_len );
            case 322:  return makeRegisterExpression(amdgpu_gfx908::v66, output_vec_len );
            case 323:  return makeRegisterExpression(amdgpu_gfx908::v67, output_vec_len );
            case 324:  return makeRegisterExpression(amdgpu_gfx908::v68, output_vec_len );
            case 325:  return makeRegisterExpression(amdgpu_gfx908::v69, output_vec_len );
            case 326:  return makeRegisterExpression(amdgpu_gfx908::v70, output_vec_len );
            case 327:  return makeRegisterExpression(amdgpu_gfx908::v71, output_vec_len );
            case 328:  return makeRegisterExpression(amdgpu_gfx908::v72, output_vec_len );
            case 329:  return makeRegisterExpression(amdgpu_gfx908::v73, output_vec_len );
            case 330:  return makeRegisterExpression(amdgpu_gfx908::v74, output_vec_len );
            case 331:  return makeRegisterExpression(amdgpu_gfx908::v75, output_vec_len );
            case 332:  return makeRegisterExpression(amdgpu_gfx908::v76, output_vec_len );
            case 333:  return makeRegisterExpression(amdgpu_gfx908::v77, output_vec_len );
            case 334:  return makeRegisterExpression(amdgpu_gfx908::v78, output_vec_len );
            case 335:  return makeRegisterExpression(amdgpu_gfx908::v79, output_vec_len );
            case 336:  return makeRegisterExpression(amdgpu_gfx908::v80, output_vec_len );
            case 337:  return makeRegisterExpression(amdgpu_gfx908::v81, output_vec_len );
            case 338:  return makeRegisterExpression(amdgpu_gfx908::v82, output_vec_len );
            case 339:  return makeRegisterExpression(amdgpu_gfx908::v83, output_vec_len );
            case 340:  return makeRegisterExpression(amdgpu_gfx908::v84, output_vec_len );
            case 341:  return makeRegisterExpression(amdgpu_gfx908::v85, output_vec_len );
            case 342:  return makeRegisterExpression(amdgpu_gfx908::v86, output_vec_len );
            case 343:  return makeRegisterExpression(amdgpu_gfx908::v87, output_vec_len );
            case 344:  return makeRegisterExpression(amdgpu_gfx908::v88, output_vec_len );
            case 345:  return makeRegisterExpression(amdgpu_gfx908::v89, output_vec_len );
            case 346:  return makeRegisterExpression(amdgpu_gfx908::v90, output_vec_len );
            case 347:  return makeRegisterExpression(amdgpu_gfx908::v91, output_vec_len );
            case 348:  return makeRegisterExpression(amdgpu_gfx908::v92, output_vec_len );
            case 349:  return makeRegisterExpression(amdgpu_gfx908::v93, output_vec_len );
            case 350:  return makeRegisterExpression(amdgpu_gfx908::v94, output_vec_len );
            case 351:  return makeRegisterExpression(amdgpu_gfx908::v95, output_vec_len );
            case 352:  return makeRegisterExpression(amdgpu_gfx908::v96, output_vec_len );
            case 353:  return makeRegisterExpression(amdgpu_gfx908::v97, output_vec_len );
            case 354:  return makeRegisterExpression(amdgpu_gfx908::v98, output_vec_len );
            case 355:  return makeRegisterExpression(amdgpu_gfx908::v99, output_vec_len );
            case 356:  return makeRegisterExpression(amdgpu_gfx908::v100, output_vec_len );
            case 357:  return makeRegisterExpression(amdgpu_gfx908::v101, output_vec_len );
            case 358:  return makeRegisterExpression(amdgpu_gfx908::v102, output_vec_len );
            case 359:  return makeRegisterExpression(amdgpu_gfx908::v103, output_vec_len );
            case 360:  return makeRegisterExpression(amdgpu_gfx908::v104, output_vec_len );
            case 361:  return makeRegisterExpression(amdgpu_gfx908::v105, output_vec_len );
            case 362:  return makeRegisterExpression(amdgpu_gfx908::v106, output_vec_len );
            case 363:  return makeRegisterExpression(amdgpu_gfx908::v107, output_vec_len );
            case 364:  return makeRegisterExpression(amdgpu_gfx908::v108, output_vec_len );
            case 365:  return makeRegisterExpression(amdgpu_gfx908::v109, output_vec_len );
            case 366:  return makeRegisterExpression(amdgpu_gfx908::v110, output_vec_len );
            case 367:  return makeRegisterExpression(amdgpu_gfx908::v111, output_vec_len );
            case 368:  return makeRegisterExpression(amdgpu_gfx908::v112, output_vec_len );
            case 369:  return makeRegisterExpression(amdgpu_gfx908::v113, output_vec_len );
            case 370:  return makeRegisterExpression(amdgpu_gfx908::v114, output_vec_len );
            case 371:  return makeRegisterExpression(amdgpu_gfx908::v115, output_vec_len );
            case 372:  return makeRegisterExpression(amdgpu_gfx908::v116, output_vec_len );
            case 373:  return makeRegisterExpression(amdgpu_gfx908::v117, output_vec_len );
            case 374:  return makeRegisterExpression(amdgpu_gfx908::v118, output_vec_len );
            case 375:  return makeRegisterExpression(amdgpu_gfx908::v119, output_vec_len );
            case 376:  return makeRegisterExpression(amdgpu_gfx908::v120, output_vec_len );
            case 377:  return makeRegisterExpression(amdgpu_gfx908::v121, output_vec_len );
            case 378:  return makeRegisterExpression(amdgpu_gfx908::v122, output_vec_len );
            case 379:  return makeRegisterExpression(amdgpu_gfx908::v123, output_vec_len );
            case 380:  return makeRegisterExpression(amdgpu_gfx908::v124, output_vec_len );
            case 381:  return makeRegisterExpression(amdgpu_gfx908::v125, output_vec_len );
            case 382:  return makeRegisterExpression(amdgpu_gfx908::v126, output_vec_len );
            case 383:  return makeRegisterExpression(amdgpu_gfx908::v127, output_vec_len );
            case 384:  return makeRegisterExpression(amdgpu_gfx908::v128, output_vec_len );
            case 385:  return makeRegisterExpression(amdgpu_gfx908::v129, output_vec_len );
            case 386:  return makeRegisterExpression(amdgpu_gfx908::v130, output_vec_len );
            case 387:  return makeRegisterExpression(amdgpu_gfx908::v131, output_vec_len );
            case 388:  return makeRegisterExpression(amdgpu_gfx908::v132, output_vec_len );
            case 389:  return makeRegisterExpression(amdgpu_gfx908::v133, output_vec_len );
            case 390:  return makeRegisterExpression(amdgpu_gfx908::v134, output_vec_len );
            case 391:  return makeRegisterExpression(amdgpu_gfx908::v135, output_vec_len );
            case 392:  return makeRegisterExpression(amdgpu_gfx908::v136, output_vec_len );
            case 393:  return makeRegisterExpression(amdgpu_gfx908::v137, output_vec_len );
            case 394:  return makeRegisterExpression(amdgpu_gfx908::v138, output_vec_len );
            case 395:  return makeRegisterExpression(amdgpu_gfx908::v139, output_vec_len );
            case 396:  return makeRegisterExpression(amdgpu_gfx908::v140, output_vec_len );
            case 397:  return makeRegisterExpression(amdgpu_gfx908::v141, output_vec_len );
            case 398:  return makeRegisterExpression(amdgpu_gfx908::v142, output_vec_len );
            case 399:  return makeRegisterExpression(amdgpu_gfx908::v143, output_vec_len );
            case 400:  return makeRegisterExpression(amdgpu_gfx908::v144, output_vec_len );
            case 401:  return makeRegisterExpression(amdgpu_gfx908::v145, output_vec_len );
            case 402:  return makeRegisterExpression(amdgpu_gfx908::v146, output_vec_len );
            case 403:  return makeRegisterExpression(amdgpu_gfx908::v147, output_vec_len );
            case 404:  return makeRegisterExpression(amdgpu_gfx908::v148, output_vec_len );
            case 405:  return makeRegisterExpression(amdgpu_gfx908::v149, output_vec_len );
            case 406:  return makeRegisterExpression(amdgpu_gfx908::v150, output_vec_len );
            case 407:  return makeRegisterExpression(amdgpu_gfx908::v151, output_vec_len );
            case 408:  return makeRegisterExpression(amdgpu_gfx908::v152, output_vec_len );
            case 409:  return makeRegisterExpression(amdgpu_gfx908::v153, output_vec_len );
            case 410:  return makeRegisterExpression(amdgpu_gfx908::v154, output_vec_len );
            case 411:  return makeRegisterExpression(amdgpu_gfx908::v155, output_vec_len );
            case 412:  return makeRegisterExpression(amdgpu_gfx908::v156, output_vec_len );
            case 413:  return makeRegisterExpression(amdgpu_gfx908::v157, output_vec_len );
            case 414:  return makeRegisterExpression(amdgpu_gfx908::v158, output_vec_len );
            case 415:  return makeRegisterExpression(amdgpu_gfx908::v159, output_vec_len );
            case 416:  return makeRegisterExpression(amdgpu_gfx908::v160, output_vec_len );
            case 417:  return makeRegisterExpression(amdgpu_gfx908::v161, output_vec_len );
            case 418:  return makeRegisterExpression(amdgpu_gfx908::v162, output_vec_len );
            case 419:  return makeRegisterExpression(amdgpu_gfx908::v163, output_vec_len );
            case 420:  return makeRegisterExpression(amdgpu_gfx908::v164, output_vec_len );
            case 421:  return makeRegisterExpression(amdgpu_gfx908::v165, output_vec_len );
            case 422:  return makeRegisterExpression(amdgpu_gfx908::v166, output_vec_len );
            case 423:  return makeRegisterExpression(amdgpu_gfx908::v167, output_vec_len );
            case 424:  return makeRegisterExpression(amdgpu_gfx908::v168, output_vec_len );
            case 425:  return makeRegisterExpression(amdgpu_gfx908::v169, output_vec_len );
            case 426:  return makeRegisterExpression(amdgpu_gfx908::v170, output_vec_len );
            case 427:  return makeRegisterExpression(amdgpu_gfx908::v171, output_vec_len );
            case 428:  return makeRegisterExpression(amdgpu_gfx908::v172, output_vec_len );
            case 429:  return makeRegisterExpression(amdgpu_gfx908::v173, output_vec_len );
            case 430:  return makeRegisterExpression(amdgpu_gfx908::v174, output_vec_len );
            case 431:  return makeRegisterExpression(amdgpu_gfx908::v175, output_vec_len );
            case 432:  return makeRegisterExpression(amdgpu_gfx908::v176, output_vec_len );
            case 433:  return makeRegisterExpression(amdgpu_gfx908::v177, output_vec_len );
            case 434:  return makeRegisterExpression(amdgpu_gfx908::v178, output_vec_len );
            case 435:  return makeRegisterExpression(amdgpu_gfx908::v179, output_vec_len );
            case 436:  return makeRegisterExpression(amdgpu_gfx908::v180, output_vec_len );
            case 437:  return makeRegisterExpression(amdgpu_gfx908::v181, output_vec_len );
            case 438:  return makeRegisterExpression(amdgpu_gfx908::v182, output_vec_len );
            case 439:  return makeRegisterExpression(amdgpu_gfx908::v183, output_vec_len );
            case 440:  return makeRegisterExpression(amdgpu_gfx908::v184, output_vec_len );
            case 441:  return makeRegisterExpression(amdgpu_gfx908::v185, output_vec_len );
            case 442:  return makeRegisterExpression(amdgpu_gfx908::v186, output_vec_len );
            case 443:  return makeRegisterExpression(amdgpu_gfx908::v187, output_vec_len );
            case 444:  return makeRegisterExpression(amdgpu_gfx908::v188, output_vec_len );
            case 445:  return makeRegisterExpression(amdgpu_gfx908::v189, output_vec_len );
            case 446:  return makeRegisterExpression(amdgpu_gfx908::v190, output_vec_len );
            case 447:  return makeRegisterExpression(amdgpu_gfx908::v191, output_vec_len );
            case 448:  return makeRegisterExpression(amdgpu_gfx908::v192, output_vec_len );
            case 449:  return makeRegisterExpression(amdgpu_gfx908::v193, output_vec_len );
            case 450:  return makeRegisterExpression(amdgpu_gfx908::v194, output_vec_len );
            case 451:  return makeRegisterExpression(amdgpu_gfx908::v195, output_vec_len );
            case 452:  return makeRegisterExpression(amdgpu_gfx908::v196, output_vec_len );
            case 453:  return makeRegisterExpression(amdgpu_gfx908::v197, output_vec_len );
            case 454:  return makeRegisterExpression(amdgpu_gfx908::v198, output_vec_len );
            case 455:  return makeRegisterExpression(amdgpu_gfx908::v199, output_vec_len );
            case 456:  return makeRegisterExpression(amdgpu_gfx908::v200, output_vec_len );
            case 457:  return makeRegisterExpression(amdgpu_gfx908::v201, output_vec_len );
            case 458:  return makeRegisterExpression(amdgpu_gfx908::v202, output_vec_len );
            case 459:  return makeRegisterExpression(amdgpu_gfx908::v203, output_vec_len );
            case 460:  return makeRegisterExpression(amdgpu_gfx908::v204, output_vec_len );
            case 461:  return makeRegisterExpression(amdgpu_gfx908::v205, output_vec_len );
            case 462:  return makeRegisterExpression(amdgpu_gfx908::v206, output_vec_len );
            case 463:  return makeRegisterExpression(amdgpu_gfx908::v207, output_vec_len );
            case 464:  return makeRegisterExpression(amdgpu_gfx908::v208, output_vec_len );
            case 465:  return makeRegisterExpression(amdgpu_gfx908::v209, output_vec_len );
            case 466:  return makeRegisterExpression(amdgpu_gfx908::v210, output_vec_len );
            case 467:  return makeRegisterExpression(amdgpu_gfx908::v211, output_vec_len );
            case 468:  return makeRegisterExpression(amdgpu_gfx908::v212, output_vec_len );
            case 469:  return makeRegisterExpression(amdgpu_gfx908::v213, output_vec_len );
            case 470:  return makeRegisterExpression(amdgpu_gfx908::v214, output_vec_len );
            case 471:  return makeRegisterExpression(amdgpu_gfx908::v215, output_vec_len );
            case 472:  return makeRegisterExpression(amdgpu_gfx908::v216, output_vec_len );
            case 473:  return makeRegisterExpression(amdgpu_gfx908::v217, output_vec_len );
            case 474:  return makeRegisterExpression(amdgpu_gfx908::v218, output_vec_len );
            case 475:  return makeRegisterExpression(amdgpu_gfx908::v219, output_vec_len );
            case 476:  return makeRegisterExpression(amdgpu_gfx908::v220, output_vec_len );
            case 477:  return makeRegisterExpression(amdgpu_gfx908::v221, output_vec_len );
            case 478:  return makeRegisterExpression(amdgpu_gfx908::v222, output_vec_len );
            case 479:  return makeRegisterExpression(amdgpu_gfx908::v223, output_vec_len );
            case 480:  return makeRegisterExpression(amdgpu_gfx908::v224, output_vec_len );
            case 481:  return makeRegisterExpression(amdgpu_gfx908::v225, output_vec_len );
            case 482:  return makeRegisterExpression(amdgpu_gfx908::v226, output_vec_len );
            case 483:  return makeRegisterExpression(amdgpu_gfx908::v227, output_vec_len );
            case 484:  return makeRegisterExpression(amdgpu_gfx908::v228, output_vec_len );
            case 485:  return makeRegisterExpression(amdgpu_gfx908::v229, output_vec_len );
            case 486:  return makeRegisterExpression(amdgpu_gfx908::v230, output_vec_len );
            case 487:  return makeRegisterExpression(amdgpu_gfx908::v231, output_vec_len );
            case 488:  return makeRegisterExpression(amdgpu_gfx908::v232, output_vec_len );
            case 489:  return makeRegisterExpression(amdgpu_gfx908::v233, output_vec_len );
            case 490:  return makeRegisterExpression(amdgpu_gfx908::v234, output_vec_len );
            case 491:  return makeRegisterExpression(amdgpu_gfx908::v235, output_vec_len );
            case 492:  return makeRegisterExpression(amdgpu_gfx908::v236, output_vec_len );
            case 493:  return makeRegisterExpression(amdgpu_gfx908::v237, output_vec_len );
            case 494:  return makeRegisterExpression(amdgpu_gfx908::v238, output_vec_len );
            case 495:  return makeRegisterExpression(amdgpu_gfx908::v239, output_vec_len );
            case 496:  return makeRegisterExpression(amdgpu_gfx908::v240, output_vec_len );
            case 497:  return makeRegisterExpression(amdgpu_gfx908::v241, output_vec_len );
            case 498:  return makeRegisterExpression(amdgpu_gfx908::v242, output_vec_len );
            case 499:  return makeRegisterExpression(amdgpu_gfx908::v243, output_vec_len );
            case 500:  return makeRegisterExpression(amdgpu_gfx908::v244, output_vec_len );
            case 501:  return makeRegisterExpression(amdgpu_gfx908::v245, output_vec_len );
            case 502:  return makeRegisterExpression(amdgpu_gfx908::v246, output_vec_len );
            case 503:  return makeRegisterExpression(amdgpu_gfx908::v247, output_vec_len );
            case 504:  return makeRegisterExpression(amdgpu_gfx908::v248, output_vec_len );
            case 505:  return makeRegisterExpression(amdgpu_gfx908::v249, output_vec_len );
            case 506:  return makeRegisterExpression(amdgpu_gfx908::v250, output_vec_len );
            case 507:  return makeRegisterExpression(amdgpu_gfx908::v251, output_vec_len );
            case 508:  return makeRegisterExpression(amdgpu_gfx908::v252, output_vec_len );
            case 509:  return makeRegisterExpression(amdgpu_gfx908::v253, output_vec_len );
            case 510:  return makeRegisterExpression(amdgpu_gfx908::v254, output_vec_len );
            case 511:  return makeRegisterExpression(amdgpu_gfx908::v255, output_vec_len );
            default: return makeRegisterExpression(amdgpu_gfx908::invalid);
        }
    }

    Expression::Ptr InstructionDecoder_amdgpu_gfx908::decodeOPR_SRC_VGPR(uint64_t input, uint32_t output_vec_len)
    {
        switch (input)  {
            case 256:  return makeRegisterExpression(amdgpu_gfx908::v0, output_vec_len );
            case 257:  return makeRegisterExpression(amdgpu_gfx908::v1, output_vec_len );
            case 258:  return makeRegisterExpression(amdgpu_gfx908::v2, output_vec_len );
            case 259:  return makeRegisterExpression(amdgpu_gfx908::v3, output_vec_len );
            case 260:  return makeRegisterExpression(amdgpu_gfx908::v4, output_vec_len );
            case 261:  return makeRegisterExpression(amdgpu_gfx908::v5, output_vec_len );
            case 262:  return makeRegisterExpression(amdgpu_gfx908::v6, output_vec_len );
            case 263:  return makeRegisterExpression(amdgpu_gfx908::v7, output_vec_len );
            case 264:  return makeRegisterExpression(amdgpu_gfx908::v8, output_vec_len );
            case 265:  return makeRegisterExpression(amdgpu_gfx908::v9, output_vec_len );
            case 266:  return makeRegisterExpression(amdgpu_gfx908::v10, output_vec_len );
            case 267:  return makeRegisterExpression(amdgpu_gfx908::v11, output_vec_len );
            case 268:  return makeRegisterExpression(amdgpu_gfx908::v12, output_vec_len );
            case 269:  return makeRegisterExpression(amdgpu_gfx908::v13, output_vec_len );
            case 270:  return makeRegisterExpression(amdgpu_gfx908::v14, output_vec_len );
            case 271:  return makeRegisterExpression(amdgpu_gfx908::v15, output_vec_len );
            case 272:  return makeRegisterExpression(amdgpu_gfx908::v16, output_vec_len );
            case 273:  return makeRegisterExpression(amdgpu_gfx908::v17, output_vec_len );
            case 274:  return makeRegisterExpression(amdgpu_gfx908::v18, output_vec_len );
            case 275:  return makeRegisterExpression(amdgpu_gfx908::v19, output_vec_len );
            case 276:  return makeRegisterExpression(amdgpu_gfx908::v20, output_vec_len );
            case 277:  return makeRegisterExpression(amdgpu_gfx908::v21, output_vec_len );
            case 278:  return makeRegisterExpression(amdgpu_gfx908::v22, output_vec_len );
            case 279:  return makeRegisterExpression(amdgpu_gfx908::v23, output_vec_len );
            case 280:  return makeRegisterExpression(amdgpu_gfx908::v24, output_vec_len );
            case 281:  return makeRegisterExpression(amdgpu_gfx908::v25, output_vec_len );
            case 282:  return makeRegisterExpression(amdgpu_gfx908::v26, output_vec_len );
            case 283:  return makeRegisterExpression(amdgpu_gfx908::v27, output_vec_len );
            case 284:  return makeRegisterExpression(amdgpu_gfx908::v28, output_vec_len );
            case 285:  return makeRegisterExpression(amdgpu_gfx908::v29, output_vec_len );
            case 286:  return makeRegisterExpression(amdgpu_gfx908::v30, output_vec_len );
            case 287:  return makeRegisterExpression(amdgpu_gfx908::v31, output_vec_len );
            case 288:  return makeRegisterExpression(amdgpu_gfx908::v32, output_vec_len );
            case 289:  return makeRegisterExpression(amdgpu_gfx908::v33, output_vec_len );
            case 290:  return makeRegisterExpression(amdgpu_gfx908::v34, output_vec_len );
            case 291:  return makeRegisterExpression(amdgpu_gfx908::v35, output_vec_len );
            case 292:  return makeRegisterExpression(amdgpu_gfx908::v36, output_vec_len );
            case 293:  return makeRegisterExpression(amdgpu_gfx908::v37, output_vec_len );
            case 294:  return makeRegisterExpression(amdgpu_gfx908::v38, output_vec_len );
            case 295:  return makeRegisterExpression(amdgpu_gfx908::v39, output_vec_len );
            case 296:  return makeRegisterExpression(amdgpu_gfx908::v40, output_vec_len );
            case 297:  return makeRegisterExpression(amdgpu_gfx908::v41, output_vec_len );
            case 298:  return makeRegisterExpression(amdgpu_gfx908::v42, output_vec_len );
            case 299:  return makeRegisterExpression(amdgpu_gfx908::v43, output_vec_len );
            case 300:  return makeRegisterExpression(amdgpu_gfx908::v44, output_vec_len );
            case 301:  return makeRegisterExpression(amdgpu_gfx908::v45, output_vec_len );
            case 302:  return makeRegisterExpression(amdgpu_gfx908::v46, output_vec_len );
            case 303:  return makeRegisterExpression(amdgpu_gfx908::v47, output_vec_len );
            case 304:  return makeRegisterExpression(amdgpu_gfx908::v48, output_vec_len );
            case 305:  return makeRegisterExpression(amdgpu_gfx908::v49, output_vec_len );
            case 306:  return makeRegisterExpression(amdgpu_gfx908::v50, output_vec_len );
            case 307:  return makeRegisterExpression(amdgpu_gfx908::v51, output_vec_len );
            case 308:  return makeRegisterExpression(amdgpu_gfx908::v52, output_vec_len );
            case 309:  return makeRegisterExpression(amdgpu_gfx908::v53, output_vec_len );
            case 310:  return makeRegisterExpression(amdgpu_gfx908::v54, output_vec_len );
            case 311:  return makeRegisterExpression(amdgpu_gfx908::v55, output_vec_len );
            case 312:  return makeRegisterExpression(amdgpu_gfx908::v56, output_vec_len );
            case 313:  return makeRegisterExpression(amdgpu_gfx908::v57, output_vec_len );
            case 314:  return makeRegisterExpression(amdgpu_gfx908::v58, output_vec_len );
            case 315:  return makeRegisterExpression(amdgpu_gfx908::v59, output_vec_len );
            case 316:  return makeRegisterExpression(amdgpu_gfx908::v60, output_vec_len );
            case 317:  return makeRegisterExpression(amdgpu_gfx908::v61, output_vec_len );
            case 318:  return makeRegisterExpression(amdgpu_gfx908::v62, output_vec_len );
            case 319:  return makeRegisterExpression(amdgpu_gfx908::v63, output_vec_len );
            case 320:  return makeRegisterExpression(amdgpu_gfx908::v64, output_vec_len );
            case 321:  return makeRegisterExpression(amdgpu_gfx908::v65, output_vec_len );
            case 322:  return makeRegisterExpression(amdgpu_gfx908::v66, output_vec_len );
            case 323:  return makeRegisterExpression(amdgpu_gfx908::v67, output_vec_len );
            case 324:  return makeRegisterExpression(amdgpu_gfx908::v68, output_vec_len );
            case 325:  return makeRegisterExpression(amdgpu_gfx908::v69, output_vec_len );
            case 326:  return makeRegisterExpression(amdgpu_gfx908::v70, output_vec_len );
            case 327:  return makeRegisterExpression(amdgpu_gfx908::v71, output_vec_len );
            case 328:  return makeRegisterExpression(amdgpu_gfx908::v72, output_vec_len );
            case 329:  return makeRegisterExpression(amdgpu_gfx908::v73, output_vec_len );
            case 330:  return makeRegisterExpression(amdgpu_gfx908::v74, output_vec_len );
            case 331:  return makeRegisterExpression(amdgpu_gfx908::v75, output_vec_len );
            case 332:  return makeRegisterExpression(amdgpu_gfx908::v76, output_vec_len );
            case 333:  return makeRegisterExpression(amdgpu_gfx908::v77, output_vec_len );
            case 334:  return makeRegisterExpression(amdgpu_gfx908::v78, output_vec_len );
            case 335:  return makeRegisterExpression(amdgpu_gfx908::v79, output_vec_len );
            case 336:  return makeRegisterExpression(amdgpu_gfx908::v80, output_vec_len );
            case 337:  return makeRegisterExpression(amdgpu_gfx908::v81, output_vec_len );
            case 338:  return makeRegisterExpression(amdgpu_gfx908::v82, output_vec_len );
            case 339:  return makeRegisterExpression(amdgpu_gfx908::v83, output_vec_len );
            case 340:  return makeRegisterExpression(amdgpu_gfx908::v84, output_vec_len );
            case 341:  return makeRegisterExpression(amdgpu_gfx908::v85, output_vec_len );
            case 342:  return makeRegisterExpression(amdgpu_gfx908::v86, output_vec_len );
            case 343:  return makeRegisterExpression(amdgpu_gfx908::v87, output_vec_len );
            case 344:  return makeRegisterExpression(amdgpu_gfx908::v88, output_vec_len );
            case 345:  return makeRegisterExpression(amdgpu_gfx908::v89, output_vec_len );
            case 346:  return makeRegisterExpression(amdgpu_gfx908::v90, output_vec_len );
            case 347:  return makeRegisterExpression(amdgpu_gfx908::v91, output_vec_len );
            case 348:  return makeRegisterExpression(amdgpu_gfx908::v92, output_vec_len );
            case 349:  return makeRegisterExpression(amdgpu_gfx908::v93, output_vec_len );
            case 350:  return makeRegisterExpression(amdgpu_gfx908::v94, output_vec_len );
            case 351:  return makeRegisterExpression(amdgpu_gfx908::v95, output_vec_len );
            case 352:  return makeRegisterExpression(amdgpu_gfx908::v96, output_vec_len );
            case 353:  return makeRegisterExpression(amdgpu_gfx908::v97, output_vec_len );
            case 354:  return makeRegisterExpression(amdgpu_gfx908::v98, output_vec_len );
            case 355:  return makeRegisterExpression(amdgpu_gfx908::v99, output_vec_len );
            case 356:  return makeRegisterExpression(amdgpu_gfx908::v100, output_vec_len );
            case 357:  return makeRegisterExpression(amdgpu_gfx908::v101, output_vec_len );
            case 358:  return makeRegisterExpression(amdgpu_gfx908::v102, output_vec_len );
            case 359:  return makeRegisterExpression(amdgpu_gfx908::v103, output_vec_len );
            case 360:  return makeRegisterExpression(amdgpu_gfx908::v104, output_vec_len );
            case 361:  return makeRegisterExpression(amdgpu_gfx908::v105, output_vec_len );
            case 362:  return makeRegisterExpression(amdgpu_gfx908::v106, output_vec_len );
            case 363:  return makeRegisterExpression(amdgpu_gfx908::v107, output_vec_len );
            case 364:  return makeRegisterExpression(amdgpu_gfx908::v108, output_vec_len );
            case 365:  return makeRegisterExpression(amdgpu_gfx908::v109, output_vec_len );
            case 366:  return makeRegisterExpression(amdgpu_gfx908::v110, output_vec_len );
            case 367:  return makeRegisterExpression(amdgpu_gfx908::v111, output_vec_len );
            case 368:  return makeRegisterExpression(amdgpu_gfx908::v112, output_vec_len );
            case 369:  return makeRegisterExpression(amdgpu_gfx908::v113, output_vec_len );
            case 370:  return makeRegisterExpression(amdgpu_gfx908::v114, output_vec_len );
            case 371:  return makeRegisterExpression(amdgpu_gfx908::v115, output_vec_len );
            case 372:  return makeRegisterExpression(amdgpu_gfx908::v116, output_vec_len );
            case 373:  return makeRegisterExpression(amdgpu_gfx908::v117, output_vec_len );
            case 374:  return makeRegisterExpression(amdgpu_gfx908::v118, output_vec_len );
            case 375:  return makeRegisterExpression(amdgpu_gfx908::v119, output_vec_len );
            case 376:  return makeRegisterExpression(amdgpu_gfx908::v120, output_vec_len );
            case 377:  return makeRegisterExpression(amdgpu_gfx908::v121, output_vec_len );
            case 378:  return makeRegisterExpression(amdgpu_gfx908::v122, output_vec_len );
            case 379:  return makeRegisterExpression(amdgpu_gfx908::v123, output_vec_len );
            case 380:  return makeRegisterExpression(amdgpu_gfx908::v124, output_vec_len );
            case 381:  return makeRegisterExpression(amdgpu_gfx908::v125, output_vec_len );
            case 382:  return makeRegisterExpression(amdgpu_gfx908::v126, output_vec_len );
            case 383:  return makeRegisterExpression(amdgpu_gfx908::v127, output_vec_len );
            case 384:  return makeRegisterExpression(amdgpu_gfx908::v128, output_vec_len );
            case 385:  return makeRegisterExpression(amdgpu_gfx908::v129, output_vec_len );
            case 386:  return makeRegisterExpression(amdgpu_gfx908::v130, output_vec_len );
            case 387:  return makeRegisterExpression(amdgpu_gfx908::v131, output_vec_len );
            case 388:  return makeRegisterExpression(amdgpu_gfx908::v132, output_vec_len );
            case 389:  return makeRegisterExpression(amdgpu_gfx908::v133, output_vec_len );
            case 390:  return makeRegisterExpression(amdgpu_gfx908::v134, output_vec_len );
            case 391:  return makeRegisterExpression(amdgpu_gfx908::v135, output_vec_len );
            case 392:  return makeRegisterExpression(amdgpu_gfx908::v136, output_vec_len );
            case 393:  return makeRegisterExpression(amdgpu_gfx908::v137, output_vec_len );
            case 394:  return makeRegisterExpression(amdgpu_gfx908::v138, output_vec_len );
            case 395:  return makeRegisterExpression(amdgpu_gfx908::v139, output_vec_len );
            case 396:  return makeRegisterExpression(amdgpu_gfx908::v140, output_vec_len );
            case 397:  return makeRegisterExpression(amdgpu_gfx908::v141, output_vec_len );
            case 398:  return makeRegisterExpression(amdgpu_gfx908::v142, output_vec_len );
            case 399:  return makeRegisterExpression(amdgpu_gfx908::v143, output_vec_len );
            case 400:  return makeRegisterExpression(amdgpu_gfx908::v144, output_vec_len );
            case 401:  return makeRegisterExpression(amdgpu_gfx908::v145, output_vec_len );
            case 402:  return makeRegisterExpression(amdgpu_gfx908::v146, output_vec_len );
            case 403:  return makeRegisterExpression(amdgpu_gfx908::v147, output_vec_len );
            case 404:  return makeRegisterExpression(amdgpu_gfx908::v148, output_vec_len );
            case 405:  return makeRegisterExpression(amdgpu_gfx908::v149, output_vec_len );
            case 406:  return makeRegisterExpression(amdgpu_gfx908::v150, output_vec_len );
            case 407:  return makeRegisterExpression(amdgpu_gfx908::v151, output_vec_len );
            case 408:  return makeRegisterExpression(amdgpu_gfx908::v152, output_vec_len );
            case 409:  return makeRegisterExpression(amdgpu_gfx908::v153, output_vec_len );
            case 410:  return makeRegisterExpression(amdgpu_gfx908::v154, output_vec_len );
            case 411:  return makeRegisterExpression(amdgpu_gfx908::v155, output_vec_len );
            case 412:  return makeRegisterExpression(amdgpu_gfx908::v156, output_vec_len );
            case 413:  return makeRegisterExpression(amdgpu_gfx908::v157, output_vec_len );
            case 414:  return makeRegisterExpression(amdgpu_gfx908::v158, output_vec_len );
            case 415:  return makeRegisterExpression(amdgpu_gfx908::v159, output_vec_len );
            case 416:  return makeRegisterExpression(amdgpu_gfx908::v160, output_vec_len );
            case 417:  return makeRegisterExpression(amdgpu_gfx908::v161, output_vec_len );
            case 418:  return makeRegisterExpression(amdgpu_gfx908::v162, output_vec_len );
            case 419:  return makeRegisterExpression(amdgpu_gfx908::v163, output_vec_len );
            case 420:  return makeRegisterExpression(amdgpu_gfx908::v164, output_vec_len );
            case 421:  return makeRegisterExpression(amdgpu_gfx908::v165, output_vec_len );
            case 422:  return makeRegisterExpression(amdgpu_gfx908::v166, output_vec_len );
            case 423:  return makeRegisterExpression(amdgpu_gfx908::v167, output_vec_len );
            case 424:  return makeRegisterExpression(amdgpu_gfx908::v168, output_vec_len );
            case 425:  return makeRegisterExpression(amdgpu_gfx908::v169, output_vec_len );
            case 426:  return makeRegisterExpression(amdgpu_gfx908::v170, output_vec_len );
            case 427:  return makeRegisterExpression(amdgpu_gfx908::v171, output_vec_len );
            case 428:  return makeRegisterExpression(amdgpu_gfx908::v172, output_vec_len );
            case 429:  return makeRegisterExpression(amdgpu_gfx908::v173, output_vec_len );
            case 430:  return makeRegisterExpression(amdgpu_gfx908::v174, output_vec_len );
            case 431:  return makeRegisterExpression(amdgpu_gfx908::v175, output_vec_len );
            case 432:  return makeRegisterExpression(amdgpu_gfx908::v176, output_vec_len );
            case 433:  return makeRegisterExpression(amdgpu_gfx908::v177, output_vec_len );
            case 434:  return makeRegisterExpression(amdgpu_gfx908::v178, output_vec_len );
            case 435:  return makeRegisterExpression(amdgpu_gfx908::v179, output_vec_len );
            case 436:  return makeRegisterExpression(amdgpu_gfx908::v180, output_vec_len );
            case 437:  return makeRegisterExpression(amdgpu_gfx908::v181, output_vec_len );
            case 438:  return makeRegisterExpression(amdgpu_gfx908::v182, output_vec_len );
            case 439:  return makeRegisterExpression(amdgpu_gfx908::v183, output_vec_len );
            case 440:  return makeRegisterExpression(amdgpu_gfx908::v184, output_vec_len );
            case 441:  return makeRegisterExpression(amdgpu_gfx908::v185, output_vec_len );
            case 442:  return makeRegisterExpression(amdgpu_gfx908::v186, output_vec_len );
            case 443:  return makeRegisterExpression(amdgpu_gfx908::v187, output_vec_len );
            case 444:  return makeRegisterExpression(amdgpu_gfx908::v188, output_vec_len );
            case 445:  return makeRegisterExpression(amdgpu_gfx908::v189, output_vec_len );
            case 446:  return makeRegisterExpression(amdgpu_gfx908::v190, output_vec_len );
            case 447:  return makeRegisterExpression(amdgpu_gfx908::v191, output_vec_len );
            case 448:  return makeRegisterExpression(amdgpu_gfx908::v192, output_vec_len );
            case 449:  return makeRegisterExpression(amdgpu_gfx908::v193, output_vec_len );
            case 450:  return makeRegisterExpression(amdgpu_gfx908::v194, output_vec_len );
            case 451:  return makeRegisterExpression(amdgpu_gfx908::v195, output_vec_len );
            case 452:  return makeRegisterExpression(amdgpu_gfx908::v196, output_vec_len );
            case 453:  return makeRegisterExpression(amdgpu_gfx908::v197, output_vec_len );
            case 454:  return makeRegisterExpression(amdgpu_gfx908::v198, output_vec_len );
            case 455:  return makeRegisterExpression(amdgpu_gfx908::v199, output_vec_len );
            case 456:  return makeRegisterExpression(amdgpu_gfx908::v200, output_vec_len );
            case 457:  return makeRegisterExpression(amdgpu_gfx908::v201, output_vec_len );
            case 458:  return makeRegisterExpression(amdgpu_gfx908::v202, output_vec_len );
            case 459:  return makeRegisterExpression(amdgpu_gfx908::v203, output_vec_len );
            case 460:  return makeRegisterExpression(amdgpu_gfx908::v204, output_vec_len );
            case 461:  return makeRegisterExpression(amdgpu_gfx908::v205, output_vec_len );
            case 462:  return makeRegisterExpression(amdgpu_gfx908::v206, output_vec_len );
            case 463:  return makeRegisterExpression(amdgpu_gfx908::v207, output_vec_len );
            case 464:  return makeRegisterExpression(amdgpu_gfx908::v208, output_vec_len );
            case 465:  return makeRegisterExpression(amdgpu_gfx908::v209, output_vec_len );
            case 466:  return makeRegisterExpression(amdgpu_gfx908::v210, output_vec_len );
            case 467:  return makeRegisterExpression(amdgpu_gfx908::v211, output_vec_len );
            case 468:  return makeRegisterExpression(amdgpu_gfx908::v212, output_vec_len );
            case 469:  return makeRegisterExpression(amdgpu_gfx908::v213, output_vec_len );
            case 470:  return makeRegisterExpression(amdgpu_gfx908::v214, output_vec_len );
            case 471:  return makeRegisterExpression(amdgpu_gfx908::v215, output_vec_len );
            case 472:  return makeRegisterExpression(amdgpu_gfx908::v216, output_vec_len );
            case 473:  return makeRegisterExpression(amdgpu_gfx908::v217, output_vec_len );
            case 474:  return makeRegisterExpression(amdgpu_gfx908::v218, output_vec_len );
            case 475:  return makeRegisterExpression(amdgpu_gfx908::v219, output_vec_len );
            case 476:  return makeRegisterExpression(amdgpu_gfx908::v220, output_vec_len );
            case 477:  return makeRegisterExpression(amdgpu_gfx908::v221, output_vec_len );
            case 478:  return makeRegisterExpression(amdgpu_gfx908::v222, output_vec_len );
            case 479:  return makeRegisterExpression(amdgpu_gfx908::v223, output_vec_len );
            case 480:  return makeRegisterExpression(amdgpu_gfx908::v224, output_vec_len );
            case 481:  return makeRegisterExpression(amdgpu_gfx908::v225, output_vec_len );
            case 482:  return makeRegisterExpression(amdgpu_gfx908::v226, output_vec_len );
            case 483:  return makeRegisterExpression(amdgpu_gfx908::v227, output_vec_len );
            case 484:  return makeRegisterExpression(amdgpu_gfx908::v228, output_vec_len );
            case 485:  return makeRegisterExpression(amdgpu_gfx908::v229, output_vec_len );
            case 486:  return makeRegisterExpression(amdgpu_gfx908::v230, output_vec_len );
            case 487:  return makeRegisterExpression(amdgpu_gfx908::v231, output_vec_len );
            case 488:  return makeRegisterExpression(amdgpu_gfx908::v232, output_vec_len );
            case 489:  return makeRegisterExpression(amdgpu_gfx908::v233, output_vec_len );
            case 490:  return makeRegisterExpression(amdgpu_gfx908::v234, output_vec_len );
            case 491:  return makeRegisterExpression(amdgpu_gfx908::v235, output_vec_len );
            case 492:  return makeRegisterExpression(amdgpu_gfx908::v236, output_vec_len );
            case 493:  return makeRegisterExpression(amdgpu_gfx908::v237, output_vec_len );
            case 494:  return makeRegisterExpression(amdgpu_gfx908::v238, output_vec_len );
            case 495:  return makeRegisterExpression(amdgpu_gfx908::v239, output_vec_len );
            case 496:  return makeRegisterExpression(amdgpu_gfx908::v240, output_vec_len );
            case 497:  return makeRegisterExpression(amdgpu_gfx908::v241, output_vec_len );
            case 498:  return makeRegisterExpression(amdgpu_gfx908::v242, output_vec_len );
            case 499:  return makeRegisterExpression(amdgpu_gfx908::v243, output_vec_len );
            case 500:  return makeRegisterExpression(amdgpu_gfx908::v244, output_vec_len );
            case 501:  return makeRegisterExpression(amdgpu_gfx908::v245, output_vec_len );
            case 502:  return makeRegisterExpression(amdgpu_gfx908::v246, output_vec_len );
            case 503:  return makeRegisterExpression(amdgpu_gfx908::v247, output_vec_len );
            case 504:  return makeRegisterExpression(amdgpu_gfx908::v248, output_vec_len );
            case 505:  return makeRegisterExpression(amdgpu_gfx908::v249, output_vec_len );
            case 506:  return makeRegisterExpression(amdgpu_gfx908::v250, output_vec_len );
            case 507:  return makeRegisterExpression(amdgpu_gfx908::v251, output_vec_len );
            case 508:  return makeRegisterExpression(amdgpu_gfx908::v252, output_vec_len );
            case 509:  return makeRegisterExpression(amdgpu_gfx908::v253, output_vec_len );
            case 510:  return makeRegisterExpression(amdgpu_gfx908::v254, output_vec_len );
            case 511:  return makeRegisterExpression(amdgpu_gfx908::v255, output_vec_len );
            default: return makeRegisterExpression(amdgpu_gfx908::invalid);
        }
    }

    Expression::Ptr InstructionDecoder_amdgpu_gfx908::decodeOPR_SRC_VGPR_OR_ACCVGPR(uint64_t input, uint32_t output_vec_len)
    {
        switch (input)  {
            case 256:  return makeRegisterExpression(amdgpu_gfx908::v0, output_vec_len );
            case 257:  return makeRegisterExpression(amdgpu_gfx908::v1, output_vec_len );
            case 258:  return makeRegisterExpression(amdgpu_gfx908::v2, output_vec_len );
            case 259:  return makeRegisterExpression(amdgpu_gfx908::v3, output_vec_len );
            case 260:  return makeRegisterExpression(amdgpu_gfx908::v4, output_vec_len );
            case 261:  return makeRegisterExpression(amdgpu_gfx908::v5, output_vec_len );
            case 262:  return makeRegisterExpression(amdgpu_gfx908::v6, output_vec_len );
            case 263:  return makeRegisterExpression(amdgpu_gfx908::v7, output_vec_len );
            case 264:  return makeRegisterExpression(amdgpu_gfx908::v8, output_vec_len );
            case 265:  return makeRegisterExpression(amdgpu_gfx908::v9, output_vec_len );
            case 266:  return makeRegisterExpression(amdgpu_gfx908::v10, output_vec_len );
            case 267:  return makeRegisterExpression(amdgpu_gfx908::v11, output_vec_len );
            case 268:  return makeRegisterExpression(amdgpu_gfx908::v12, output_vec_len );
            case 269:  return makeRegisterExpression(amdgpu_gfx908::v13, output_vec_len );
            case 270:  return makeRegisterExpression(amdgpu_gfx908::v14, output_vec_len );
            case 271:  return makeRegisterExpression(amdgpu_gfx908::v15, output_vec_len );
            case 272:  return makeRegisterExpression(amdgpu_gfx908::v16, output_vec_len );
            case 273:  return makeRegisterExpression(amdgpu_gfx908::v17, output_vec_len );
            case 274:  return makeRegisterExpression(amdgpu_gfx908::v18, output_vec_len );
            case 275:  return makeRegisterExpression(amdgpu_gfx908::v19, output_vec_len );
            case 276:  return makeRegisterExpression(amdgpu_gfx908::v20, output_vec_len );
            case 277:  return makeRegisterExpression(amdgpu_gfx908::v21, output_vec_len );
            case 278:  return makeRegisterExpression(amdgpu_gfx908::v22, output_vec_len );
            case 279:  return makeRegisterExpression(amdgpu_gfx908::v23, output_vec_len );
            case 280:  return makeRegisterExpression(amdgpu_gfx908::v24, output_vec_len );
            case 281:  return makeRegisterExpression(amdgpu_gfx908::v25, output_vec_len );
            case 282:  return makeRegisterExpression(amdgpu_gfx908::v26, output_vec_len );
            case 283:  return makeRegisterExpression(amdgpu_gfx908::v27, output_vec_len );
            case 284:  return makeRegisterExpression(amdgpu_gfx908::v28, output_vec_len );
            case 285:  return makeRegisterExpression(amdgpu_gfx908::v29, output_vec_len );
            case 286:  return makeRegisterExpression(amdgpu_gfx908::v30, output_vec_len );
            case 287:  return makeRegisterExpression(amdgpu_gfx908::v31, output_vec_len );
            case 288:  return makeRegisterExpression(amdgpu_gfx908::v32, output_vec_len );
            case 289:  return makeRegisterExpression(amdgpu_gfx908::v33, output_vec_len );
            case 290:  return makeRegisterExpression(amdgpu_gfx908::v34, output_vec_len );
            case 291:  return makeRegisterExpression(amdgpu_gfx908::v35, output_vec_len );
            case 292:  return makeRegisterExpression(amdgpu_gfx908::v36, output_vec_len );
            case 293:  return makeRegisterExpression(amdgpu_gfx908::v37, output_vec_len );
            case 294:  return makeRegisterExpression(amdgpu_gfx908::v38, output_vec_len );
            case 295:  return makeRegisterExpression(amdgpu_gfx908::v39, output_vec_len );
            case 296:  return makeRegisterExpression(amdgpu_gfx908::v40, output_vec_len );
            case 297:  return makeRegisterExpression(amdgpu_gfx908::v41, output_vec_len );
            case 298:  return makeRegisterExpression(amdgpu_gfx908::v42, output_vec_len );
            case 299:  return makeRegisterExpression(amdgpu_gfx908::v43, output_vec_len );
            case 300:  return makeRegisterExpression(amdgpu_gfx908::v44, output_vec_len );
            case 301:  return makeRegisterExpression(amdgpu_gfx908::v45, output_vec_len );
            case 302:  return makeRegisterExpression(amdgpu_gfx908::v46, output_vec_len );
            case 303:  return makeRegisterExpression(amdgpu_gfx908::v47, output_vec_len );
            case 304:  return makeRegisterExpression(amdgpu_gfx908::v48, output_vec_len );
            case 305:  return makeRegisterExpression(amdgpu_gfx908::v49, output_vec_len );
            case 306:  return makeRegisterExpression(amdgpu_gfx908::v50, output_vec_len );
            case 307:  return makeRegisterExpression(amdgpu_gfx908::v51, output_vec_len );
            case 308:  return makeRegisterExpression(amdgpu_gfx908::v52, output_vec_len );
            case 309:  return makeRegisterExpression(amdgpu_gfx908::v53, output_vec_len );
            case 310:  return makeRegisterExpression(amdgpu_gfx908::v54, output_vec_len );
            case 311:  return makeRegisterExpression(amdgpu_gfx908::v55, output_vec_len );
            case 312:  return makeRegisterExpression(amdgpu_gfx908::v56, output_vec_len );
            case 313:  return makeRegisterExpression(amdgpu_gfx908::v57, output_vec_len );
            case 314:  return makeRegisterExpression(amdgpu_gfx908::v58, output_vec_len );
            case 315:  return makeRegisterExpression(amdgpu_gfx908::v59, output_vec_len );
            case 316:  return makeRegisterExpression(amdgpu_gfx908::v60, output_vec_len );
            case 317:  return makeRegisterExpression(amdgpu_gfx908::v61, output_vec_len );
            case 318:  return makeRegisterExpression(amdgpu_gfx908::v62, output_vec_len );
            case 319:  return makeRegisterExpression(amdgpu_gfx908::v63, output_vec_len );
            case 320:  return makeRegisterExpression(amdgpu_gfx908::v64, output_vec_len );
            case 321:  return makeRegisterExpression(amdgpu_gfx908::v65, output_vec_len );
            case 322:  return makeRegisterExpression(amdgpu_gfx908::v66, output_vec_len );
            case 323:  return makeRegisterExpression(amdgpu_gfx908::v67, output_vec_len );
            case 324:  return makeRegisterExpression(amdgpu_gfx908::v68, output_vec_len );
            case 325:  return makeRegisterExpression(amdgpu_gfx908::v69, output_vec_len );
            case 326:  return makeRegisterExpression(amdgpu_gfx908::v70, output_vec_len );
            case 327:  return makeRegisterExpression(amdgpu_gfx908::v71, output_vec_len );
            case 328:  return makeRegisterExpression(amdgpu_gfx908::v72, output_vec_len );
            case 329:  return makeRegisterExpression(amdgpu_gfx908::v73, output_vec_len );
            case 330:  return makeRegisterExpression(amdgpu_gfx908::v74, output_vec_len );
            case 331:  return makeRegisterExpression(amdgpu_gfx908::v75, output_vec_len );
            case 332:  return makeRegisterExpression(amdgpu_gfx908::v76, output_vec_len );
            case 333:  return makeRegisterExpression(amdgpu_gfx908::v77, output_vec_len );
            case 334:  return makeRegisterExpression(amdgpu_gfx908::v78, output_vec_len );
            case 335:  return makeRegisterExpression(amdgpu_gfx908::v79, output_vec_len );
            case 336:  return makeRegisterExpression(amdgpu_gfx908::v80, output_vec_len );
            case 337:  return makeRegisterExpression(amdgpu_gfx908::v81, output_vec_len );
            case 338:  return makeRegisterExpression(amdgpu_gfx908::v82, output_vec_len );
            case 339:  return makeRegisterExpression(amdgpu_gfx908::v83, output_vec_len );
            case 340:  return makeRegisterExpression(amdgpu_gfx908::v84, output_vec_len );
            case 341:  return makeRegisterExpression(amdgpu_gfx908::v85, output_vec_len );
            case 342:  return makeRegisterExpression(amdgpu_gfx908::v86, output_vec_len );
            case 343:  return makeRegisterExpression(amdgpu_gfx908::v87, output_vec_len );
            case 344:  return makeRegisterExpression(amdgpu_gfx908::v88, output_vec_len );
            case 345:  return makeRegisterExpression(amdgpu_gfx908::v89, output_vec_len );
            case 346:  return makeRegisterExpression(amdgpu_gfx908::v90, output_vec_len );
            case 347:  return makeRegisterExpression(amdgpu_gfx908::v91, output_vec_len );
            case 348:  return makeRegisterExpression(amdgpu_gfx908::v92, output_vec_len );
            case 349:  return makeRegisterExpression(amdgpu_gfx908::v93, output_vec_len );
            case 350:  return makeRegisterExpression(amdgpu_gfx908::v94, output_vec_len );
            case 351:  return makeRegisterExpression(amdgpu_gfx908::v95, output_vec_len );
            case 352:  return makeRegisterExpression(amdgpu_gfx908::v96, output_vec_len );
            case 353:  return makeRegisterExpression(amdgpu_gfx908::v97, output_vec_len );
            case 354:  return makeRegisterExpression(amdgpu_gfx908::v98, output_vec_len );
            case 355:  return makeRegisterExpression(amdgpu_gfx908::v99, output_vec_len );
            case 356:  return makeRegisterExpression(amdgpu_gfx908::v100, output_vec_len );
            case 357:  return makeRegisterExpression(amdgpu_gfx908::v101, output_vec_len );
            case 358:  return makeRegisterExpression(amdgpu_gfx908::v102, output_vec_len );
            case 359:  return makeRegisterExpression(amdgpu_gfx908::v103, output_vec_len );
            case 360:  return makeRegisterExpression(amdgpu_gfx908::v104, output_vec_len );
            case 361:  return makeRegisterExpression(amdgpu_gfx908::v105, output_vec_len );
            case 362:  return makeRegisterExpression(amdgpu_gfx908::v106, output_vec_len );
            case 363:  return makeRegisterExpression(amdgpu_gfx908::v107, output_vec_len );
            case 364:  return makeRegisterExpression(amdgpu_gfx908::v108, output_vec_len );
            case 365:  return makeRegisterExpression(amdgpu_gfx908::v109, output_vec_len );
            case 366:  return makeRegisterExpression(amdgpu_gfx908::v110, output_vec_len );
            case 367:  return makeRegisterExpression(amdgpu_gfx908::v111, output_vec_len );
            case 368:  return makeRegisterExpression(amdgpu_gfx908::v112, output_vec_len );
            case 369:  return makeRegisterExpression(amdgpu_gfx908::v113, output_vec_len );
            case 370:  return makeRegisterExpression(amdgpu_gfx908::v114, output_vec_len );
            case 371:  return makeRegisterExpression(amdgpu_gfx908::v115, output_vec_len );
            case 372:  return makeRegisterExpression(amdgpu_gfx908::v116, output_vec_len );
            case 373:  return makeRegisterExpression(amdgpu_gfx908::v117, output_vec_len );
            case 374:  return makeRegisterExpression(amdgpu_gfx908::v118, output_vec_len );
            case 375:  return makeRegisterExpression(amdgpu_gfx908::v119, output_vec_len );
            case 376:  return makeRegisterExpression(amdgpu_gfx908::v120, output_vec_len );
            case 377:  return makeRegisterExpression(amdgpu_gfx908::v121, output_vec_len );
            case 378:  return makeRegisterExpression(amdgpu_gfx908::v122, output_vec_len );
            case 379:  return makeRegisterExpression(amdgpu_gfx908::v123, output_vec_len );
            case 380:  return makeRegisterExpression(amdgpu_gfx908::v124, output_vec_len );
            case 381:  return makeRegisterExpression(amdgpu_gfx908::v125, output_vec_len );
            case 382:  return makeRegisterExpression(amdgpu_gfx908::v126, output_vec_len );
            case 383:  return makeRegisterExpression(amdgpu_gfx908::v127, output_vec_len );
            case 384:  return makeRegisterExpression(amdgpu_gfx908::v128, output_vec_len );
            case 385:  return makeRegisterExpression(amdgpu_gfx908::v129, output_vec_len );
            case 386:  return makeRegisterExpression(amdgpu_gfx908::v130, output_vec_len );
            case 387:  return makeRegisterExpression(amdgpu_gfx908::v131, output_vec_len );
            case 388:  return makeRegisterExpression(amdgpu_gfx908::v132, output_vec_len );
            case 389:  return makeRegisterExpression(amdgpu_gfx908::v133, output_vec_len );
            case 390:  return makeRegisterExpression(amdgpu_gfx908::v134, output_vec_len );
            case 391:  return makeRegisterExpression(amdgpu_gfx908::v135, output_vec_len );
            case 392:  return makeRegisterExpression(amdgpu_gfx908::v136, output_vec_len );
            case 393:  return makeRegisterExpression(amdgpu_gfx908::v137, output_vec_len );
            case 394:  return makeRegisterExpression(amdgpu_gfx908::v138, output_vec_len );
            case 395:  return makeRegisterExpression(amdgpu_gfx908::v139, output_vec_len );
            case 396:  return makeRegisterExpression(amdgpu_gfx908::v140, output_vec_len );
            case 397:  return makeRegisterExpression(amdgpu_gfx908::v141, output_vec_len );
            case 398:  return makeRegisterExpression(amdgpu_gfx908::v142, output_vec_len );
            case 399:  return makeRegisterExpression(amdgpu_gfx908::v143, output_vec_len );
            case 400:  return makeRegisterExpression(amdgpu_gfx908::v144, output_vec_len );
            case 401:  return makeRegisterExpression(amdgpu_gfx908::v145, output_vec_len );
            case 402:  return makeRegisterExpression(amdgpu_gfx908::v146, output_vec_len );
            case 403:  return makeRegisterExpression(amdgpu_gfx908::v147, output_vec_len );
            case 404:  return makeRegisterExpression(amdgpu_gfx908::v148, output_vec_len );
            case 405:  return makeRegisterExpression(amdgpu_gfx908::v149, output_vec_len );
            case 406:  return makeRegisterExpression(amdgpu_gfx908::v150, output_vec_len );
            case 407:  return makeRegisterExpression(amdgpu_gfx908::v151, output_vec_len );
            case 408:  return makeRegisterExpression(amdgpu_gfx908::v152, output_vec_len );
            case 409:  return makeRegisterExpression(amdgpu_gfx908::v153, output_vec_len );
            case 410:  return makeRegisterExpression(amdgpu_gfx908::v154, output_vec_len );
            case 411:  return makeRegisterExpression(amdgpu_gfx908::v155, output_vec_len );
            case 412:  return makeRegisterExpression(amdgpu_gfx908::v156, output_vec_len );
            case 413:  return makeRegisterExpression(amdgpu_gfx908::v157, output_vec_len );
            case 414:  return makeRegisterExpression(amdgpu_gfx908::v158, output_vec_len );
            case 415:  return makeRegisterExpression(amdgpu_gfx908::v159, output_vec_len );
            case 416:  return makeRegisterExpression(amdgpu_gfx908::v160, output_vec_len );
            case 417:  return makeRegisterExpression(amdgpu_gfx908::v161, output_vec_len );
            case 418:  return makeRegisterExpression(amdgpu_gfx908::v162, output_vec_len );
            case 419:  return makeRegisterExpression(amdgpu_gfx908::v163, output_vec_len );
            case 420:  return makeRegisterExpression(amdgpu_gfx908::v164, output_vec_len );
            case 421:  return makeRegisterExpression(amdgpu_gfx908::v165, output_vec_len );
            case 422:  return makeRegisterExpression(amdgpu_gfx908::v166, output_vec_len );
            case 423:  return makeRegisterExpression(amdgpu_gfx908::v167, output_vec_len );
            case 424:  return makeRegisterExpression(amdgpu_gfx908::v168, output_vec_len );
            case 425:  return makeRegisterExpression(amdgpu_gfx908::v169, output_vec_len );
            case 426:  return makeRegisterExpression(amdgpu_gfx908::v170, output_vec_len );
            case 427:  return makeRegisterExpression(amdgpu_gfx908::v171, output_vec_len );
            case 428:  return makeRegisterExpression(amdgpu_gfx908::v172, output_vec_len );
            case 429:  return makeRegisterExpression(amdgpu_gfx908::v173, output_vec_len );
            case 430:  return makeRegisterExpression(amdgpu_gfx908::v174, output_vec_len );
            case 431:  return makeRegisterExpression(amdgpu_gfx908::v175, output_vec_len );
            case 432:  return makeRegisterExpression(amdgpu_gfx908::v176, output_vec_len );
            case 433:  return makeRegisterExpression(amdgpu_gfx908::v177, output_vec_len );
            case 434:  return makeRegisterExpression(amdgpu_gfx908::v178, output_vec_len );
            case 435:  return makeRegisterExpression(amdgpu_gfx908::v179, output_vec_len );
            case 436:  return makeRegisterExpression(amdgpu_gfx908::v180, output_vec_len );
            case 437:  return makeRegisterExpression(amdgpu_gfx908::v181, output_vec_len );
            case 438:  return makeRegisterExpression(amdgpu_gfx908::v182, output_vec_len );
            case 439:  return makeRegisterExpression(amdgpu_gfx908::v183, output_vec_len );
            case 440:  return makeRegisterExpression(amdgpu_gfx908::v184, output_vec_len );
            case 441:  return makeRegisterExpression(amdgpu_gfx908::v185, output_vec_len );
            case 442:  return makeRegisterExpression(amdgpu_gfx908::v186, output_vec_len );
            case 443:  return makeRegisterExpression(amdgpu_gfx908::v187, output_vec_len );
            case 444:  return makeRegisterExpression(amdgpu_gfx908::v188, output_vec_len );
            case 445:  return makeRegisterExpression(amdgpu_gfx908::v189, output_vec_len );
            case 446:  return makeRegisterExpression(amdgpu_gfx908::v190, output_vec_len );
            case 447:  return makeRegisterExpression(amdgpu_gfx908::v191, output_vec_len );
            case 448:  return makeRegisterExpression(amdgpu_gfx908::v192, output_vec_len );
            case 449:  return makeRegisterExpression(amdgpu_gfx908::v193, output_vec_len );
            case 450:  return makeRegisterExpression(amdgpu_gfx908::v194, output_vec_len );
            case 451:  return makeRegisterExpression(amdgpu_gfx908::v195, output_vec_len );
            case 452:  return makeRegisterExpression(amdgpu_gfx908::v196, output_vec_len );
            case 453:  return makeRegisterExpression(amdgpu_gfx908::v197, output_vec_len );
            case 454:  return makeRegisterExpression(amdgpu_gfx908::v198, output_vec_len );
            case 455:  return makeRegisterExpression(amdgpu_gfx908::v199, output_vec_len );
            case 456:  return makeRegisterExpression(amdgpu_gfx908::v200, output_vec_len );
            case 457:  return makeRegisterExpression(amdgpu_gfx908::v201, output_vec_len );
            case 458:  return makeRegisterExpression(amdgpu_gfx908::v202, output_vec_len );
            case 459:  return makeRegisterExpression(amdgpu_gfx908::v203, output_vec_len );
            case 460:  return makeRegisterExpression(amdgpu_gfx908::v204, output_vec_len );
            case 461:  return makeRegisterExpression(amdgpu_gfx908::v205, output_vec_len );
            case 462:  return makeRegisterExpression(amdgpu_gfx908::v206, output_vec_len );
            case 463:  return makeRegisterExpression(amdgpu_gfx908::v207, output_vec_len );
            case 464:  return makeRegisterExpression(amdgpu_gfx908::v208, output_vec_len );
            case 465:  return makeRegisterExpression(amdgpu_gfx908::v209, output_vec_len );
            case 466:  return makeRegisterExpression(amdgpu_gfx908::v210, output_vec_len );
            case 467:  return makeRegisterExpression(amdgpu_gfx908::v211, output_vec_len );
            case 468:  return makeRegisterExpression(amdgpu_gfx908::v212, output_vec_len );
            case 469:  return makeRegisterExpression(amdgpu_gfx908::v213, output_vec_len );
            case 470:  return makeRegisterExpression(amdgpu_gfx908::v214, output_vec_len );
            case 471:  return makeRegisterExpression(amdgpu_gfx908::v215, output_vec_len );
            case 472:  return makeRegisterExpression(amdgpu_gfx908::v216, output_vec_len );
            case 473:  return makeRegisterExpression(amdgpu_gfx908::v217, output_vec_len );
            case 474:  return makeRegisterExpression(amdgpu_gfx908::v218, output_vec_len );
            case 475:  return makeRegisterExpression(amdgpu_gfx908::v219, output_vec_len );
            case 476:  return makeRegisterExpression(amdgpu_gfx908::v220, output_vec_len );
            case 477:  return makeRegisterExpression(amdgpu_gfx908::v221, output_vec_len );
            case 478:  return makeRegisterExpression(amdgpu_gfx908::v222, output_vec_len );
            case 479:  return makeRegisterExpression(amdgpu_gfx908::v223, output_vec_len );
            case 480:  return makeRegisterExpression(amdgpu_gfx908::v224, output_vec_len );
            case 481:  return makeRegisterExpression(amdgpu_gfx908::v225, output_vec_len );
            case 482:  return makeRegisterExpression(amdgpu_gfx908::v226, output_vec_len );
            case 483:  return makeRegisterExpression(amdgpu_gfx908::v227, output_vec_len );
            case 484:  return makeRegisterExpression(amdgpu_gfx908::v228, output_vec_len );
            case 485:  return makeRegisterExpression(amdgpu_gfx908::v229, output_vec_len );
            case 486:  return makeRegisterExpression(amdgpu_gfx908::v230, output_vec_len );
            case 487:  return makeRegisterExpression(amdgpu_gfx908::v231, output_vec_len );
            case 488:  return makeRegisterExpression(amdgpu_gfx908::v232, output_vec_len );
            case 489:  return makeRegisterExpression(amdgpu_gfx908::v233, output_vec_len );
            case 490:  return makeRegisterExpression(amdgpu_gfx908::v234, output_vec_len );
            case 491:  return makeRegisterExpression(amdgpu_gfx908::v235, output_vec_len );
            case 492:  return makeRegisterExpression(amdgpu_gfx908::v236, output_vec_len );
            case 493:  return makeRegisterExpression(amdgpu_gfx908::v237, output_vec_len );
            case 494:  return makeRegisterExpression(amdgpu_gfx908::v238, output_vec_len );
            case 495:  return makeRegisterExpression(amdgpu_gfx908::v239, output_vec_len );
            case 496:  return makeRegisterExpression(amdgpu_gfx908::v240, output_vec_len );
            case 497:  return makeRegisterExpression(amdgpu_gfx908::v241, output_vec_len );
            case 498:  return makeRegisterExpression(amdgpu_gfx908::v242, output_vec_len );
            case 499:  return makeRegisterExpression(amdgpu_gfx908::v243, output_vec_len );
            case 500:  return makeRegisterExpression(amdgpu_gfx908::v244, output_vec_len );
            case 501:  return makeRegisterExpression(amdgpu_gfx908::v245, output_vec_len );
            case 502:  return makeRegisterExpression(amdgpu_gfx908::v246, output_vec_len );
            case 503:  return makeRegisterExpression(amdgpu_gfx908::v247, output_vec_len );
            case 504:  return makeRegisterExpression(amdgpu_gfx908::v248, output_vec_len );
            case 505:  return makeRegisterExpression(amdgpu_gfx908::v249, output_vec_len );
            case 506:  return makeRegisterExpression(amdgpu_gfx908::v250, output_vec_len );
            case 507:  return makeRegisterExpression(amdgpu_gfx908::v251, output_vec_len );
            case 508:  return makeRegisterExpression(amdgpu_gfx908::v252, output_vec_len );
            case 509:  return makeRegisterExpression(amdgpu_gfx908::v253, output_vec_len );
            case 510:  return makeRegisterExpression(amdgpu_gfx908::v254, output_vec_len );
            case 511:  return makeRegisterExpression(amdgpu_gfx908::v255, output_vec_len );
            case 768:  return makeRegisterExpression(amdgpu_gfx908::acc0, output_vec_len );
            case 769:  return makeRegisterExpression(amdgpu_gfx908::acc1, output_vec_len );
            case 770:  return makeRegisterExpression(amdgpu_gfx908::acc2, output_vec_len );
            case 771:  return makeRegisterExpression(amdgpu_gfx908::acc3, output_vec_len );
            case 772:  return makeRegisterExpression(amdgpu_gfx908::acc4, output_vec_len );
            case 773:  return makeRegisterExpression(amdgpu_gfx908::acc5, output_vec_len );
            case 774:  return makeRegisterExpression(amdgpu_gfx908::acc6, output_vec_len );
            case 775:  return makeRegisterExpression(amdgpu_gfx908::acc7, output_vec_len );
            case 776:  return makeRegisterExpression(amdgpu_gfx908::acc8, output_vec_len );
            case 777:  return makeRegisterExpression(amdgpu_gfx908::acc9, output_vec_len );
            case 778:  return makeRegisterExpression(amdgpu_gfx908::acc10, output_vec_len );
            case 779:  return makeRegisterExpression(amdgpu_gfx908::acc11, output_vec_len );
            case 780:  return makeRegisterExpression(amdgpu_gfx908::acc12, output_vec_len );
            case 781:  return makeRegisterExpression(amdgpu_gfx908::acc13, output_vec_len );
            case 782:  return makeRegisterExpression(amdgpu_gfx908::acc14, output_vec_len );
            case 783:  return makeRegisterExpression(amdgpu_gfx908::acc15, output_vec_len );
            case 784:  return makeRegisterExpression(amdgpu_gfx908::acc16, output_vec_len );
            case 785:  return makeRegisterExpression(amdgpu_gfx908::acc17, output_vec_len );
            case 786:  return makeRegisterExpression(amdgpu_gfx908::acc18, output_vec_len );
            case 787:  return makeRegisterExpression(amdgpu_gfx908::acc19, output_vec_len );
            case 788:  return makeRegisterExpression(amdgpu_gfx908::acc20, output_vec_len );
            case 789:  return makeRegisterExpression(amdgpu_gfx908::acc21, output_vec_len );
            case 790:  return makeRegisterExpression(amdgpu_gfx908::acc22, output_vec_len );
            case 791:  return makeRegisterExpression(amdgpu_gfx908::acc23, output_vec_len );
            case 792:  return makeRegisterExpression(amdgpu_gfx908::acc24, output_vec_len );
            case 793:  return makeRegisterExpression(amdgpu_gfx908::acc25, output_vec_len );
            case 794:  return makeRegisterExpression(amdgpu_gfx908::acc26, output_vec_len );
            case 795:  return makeRegisterExpression(amdgpu_gfx908::acc27, output_vec_len );
            case 796:  return makeRegisterExpression(amdgpu_gfx908::acc28, output_vec_len );
            case 797:  return makeRegisterExpression(amdgpu_gfx908::acc29, output_vec_len );
            case 798:  return makeRegisterExpression(amdgpu_gfx908::acc30, output_vec_len );
            case 799:  return makeRegisterExpression(amdgpu_gfx908::acc31, output_vec_len );
            case 800:  return makeRegisterExpression(amdgpu_gfx908::acc32, output_vec_len );
            case 801:  return makeRegisterExpression(amdgpu_gfx908::acc33, output_vec_len );
            case 802:  return makeRegisterExpression(amdgpu_gfx908::acc34, output_vec_len );
            case 803:  return makeRegisterExpression(amdgpu_gfx908::acc35, output_vec_len );
            case 804:  return makeRegisterExpression(amdgpu_gfx908::acc36, output_vec_len );
            case 805:  return makeRegisterExpression(amdgpu_gfx908::acc37, output_vec_len );
            case 806:  return makeRegisterExpression(amdgpu_gfx908::acc38, output_vec_len );
            case 807:  return makeRegisterExpression(amdgpu_gfx908::acc39, output_vec_len );
            case 808:  return makeRegisterExpression(amdgpu_gfx908::acc40, output_vec_len );
            case 809:  return makeRegisterExpression(amdgpu_gfx908::acc41, output_vec_len );
            case 810:  return makeRegisterExpression(amdgpu_gfx908::acc42, output_vec_len );
            case 811:  return makeRegisterExpression(amdgpu_gfx908::acc43, output_vec_len );
            case 812:  return makeRegisterExpression(amdgpu_gfx908::acc44, output_vec_len );
            case 813:  return makeRegisterExpression(amdgpu_gfx908::acc45, output_vec_len );
            case 814:  return makeRegisterExpression(amdgpu_gfx908::acc46, output_vec_len );
            case 815:  return makeRegisterExpression(amdgpu_gfx908::acc47, output_vec_len );
            case 816:  return makeRegisterExpression(amdgpu_gfx908::acc48, output_vec_len );
            case 817:  return makeRegisterExpression(amdgpu_gfx908::acc49, output_vec_len );
            case 818:  return makeRegisterExpression(amdgpu_gfx908::acc50, output_vec_len );
            case 819:  return makeRegisterExpression(amdgpu_gfx908::acc51, output_vec_len );
            case 820:  return makeRegisterExpression(amdgpu_gfx908::acc52, output_vec_len );
            case 821:  return makeRegisterExpression(amdgpu_gfx908::acc53, output_vec_len );
            case 822:  return makeRegisterExpression(amdgpu_gfx908::acc54, output_vec_len );
            case 823:  return makeRegisterExpression(amdgpu_gfx908::acc55, output_vec_len );
            case 824:  return makeRegisterExpression(amdgpu_gfx908::acc56, output_vec_len );
            case 825:  return makeRegisterExpression(amdgpu_gfx908::acc57, output_vec_len );
            case 826:  return makeRegisterExpression(amdgpu_gfx908::acc58, output_vec_len );
            case 827:  return makeRegisterExpression(amdgpu_gfx908::acc59, output_vec_len );
            case 828:  return makeRegisterExpression(amdgpu_gfx908::acc60, output_vec_len );
            case 829:  return makeRegisterExpression(amdgpu_gfx908::acc61, output_vec_len );
            case 830:  return makeRegisterExpression(amdgpu_gfx908::acc62, output_vec_len );
            case 831:  return makeRegisterExpression(amdgpu_gfx908::acc63, output_vec_len );
            case 832:  return makeRegisterExpression(amdgpu_gfx908::acc64, output_vec_len );
            case 833:  return makeRegisterExpression(amdgpu_gfx908::acc65, output_vec_len );
            case 834:  return makeRegisterExpression(amdgpu_gfx908::acc66, output_vec_len );
            case 835:  return makeRegisterExpression(amdgpu_gfx908::acc67, output_vec_len );
            case 836:  return makeRegisterExpression(amdgpu_gfx908::acc68, output_vec_len );
            case 837:  return makeRegisterExpression(amdgpu_gfx908::acc69, output_vec_len );
            case 838:  return makeRegisterExpression(amdgpu_gfx908::acc70, output_vec_len );
            case 839:  return makeRegisterExpression(amdgpu_gfx908::acc71, output_vec_len );
            case 840:  return makeRegisterExpression(amdgpu_gfx908::acc72, output_vec_len );
            case 841:  return makeRegisterExpression(amdgpu_gfx908::acc73, output_vec_len );
            case 842:  return makeRegisterExpression(amdgpu_gfx908::acc74, output_vec_len );
            case 843:  return makeRegisterExpression(amdgpu_gfx908::acc75, output_vec_len );
            case 844:  return makeRegisterExpression(amdgpu_gfx908::acc76, output_vec_len );
            case 845:  return makeRegisterExpression(amdgpu_gfx908::acc77, output_vec_len );
            case 846:  return makeRegisterExpression(amdgpu_gfx908::acc78, output_vec_len );
            case 847:  return makeRegisterExpression(amdgpu_gfx908::acc79, output_vec_len );
            case 848:  return makeRegisterExpression(amdgpu_gfx908::acc80, output_vec_len );
            case 849:  return makeRegisterExpression(amdgpu_gfx908::acc81, output_vec_len );
            case 850:  return makeRegisterExpression(amdgpu_gfx908::acc82, output_vec_len );
            case 851:  return makeRegisterExpression(amdgpu_gfx908::acc83, output_vec_len );
            case 852:  return makeRegisterExpression(amdgpu_gfx908::acc84, output_vec_len );
            case 853:  return makeRegisterExpression(amdgpu_gfx908::acc85, output_vec_len );
            case 854:  return makeRegisterExpression(amdgpu_gfx908::acc86, output_vec_len );
            case 855:  return makeRegisterExpression(amdgpu_gfx908::acc87, output_vec_len );
            case 856:  return makeRegisterExpression(amdgpu_gfx908::acc88, output_vec_len );
            case 857:  return makeRegisterExpression(amdgpu_gfx908::acc89, output_vec_len );
            case 858:  return makeRegisterExpression(amdgpu_gfx908::acc90, output_vec_len );
            case 859:  return makeRegisterExpression(amdgpu_gfx908::acc91, output_vec_len );
            case 860:  return makeRegisterExpression(amdgpu_gfx908::acc92, output_vec_len );
            case 861:  return makeRegisterExpression(amdgpu_gfx908::acc93, output_vec_len );
            case 862:  return makeRegisterExpression(amdgpu_gfx908::acc94, output_vec_len );
            case 863:  return makeRegisterExpression(amdgpu_gfx908::acc95, output_vec_len );
            case 864:  return makeRegisterExpression(amdgpu_gfx908::acc96, output_vec_len );
            case 865:  return makeRegisterExpression(amdgpu_gfx908::acc97, output_vec_len );
            case 866:  return makeRegisterExpression(amdgpu_gfx908::acc98, output_vec_len );
            case 867:  return makeRegisterExpression(amdgpu_gfx908::acc99, output_vec_len );
            case 868:  return makeRegisterExpression(amdgpu_gfx908::acc100, output_vec_len );
            case 869:  return makeRegisterExpression(amdgpu_gfx908::acc101, output_vec_len );
            case 870:  return makeRegisterExpression(amdgpu_gfx908::acc102, output_vec_len );
            case 871:  return makeRegisterExpression(amdgpu_gfx908::acc103, output_vec_len );
            case 872:  return makeRegisterExpression(amdgpu_gfx908::acc104, output_vec_len );
            case 873:  return makeRegisterExpression(amdgpu_gfx908::acc105, output_vec_len );
            case 874:  return makeRegisterExpression(amdgpu_gfx908::acc106, output_vec_len );
            case 875:  return makeRegisterExpression(amdgpu_gfx908::acc107, output_vec_len );
            case 876:  return makeRegisterExpression(amdgpu_gfx908::acc108, output_vec_len );
            case 877:  return makeRegisterExpression(amdgpu_gfx908::acc109, output_vec_len );
            case 878:  return makeRegisterExpression(amdgpu_gfx908::acc110, output_vec_len );
            case 879:  return makeRegisterExpression(amdgpu_gfx908::acc111, output_vec_len );
            case 880:  return makeRegisterExpression(amdgpu_gfx908::acc112, output_vec_len );
            case 881:  return makeRegisterExpression(amdgpu_gfx908::acc113, output_vec_len );
            case 882:  return makeRegisterExpression(amdgpu_gfx908::acc114, output_vec_len );
            case 883:  return makeRegisterExpression(amdgpu_gfx908::acc115, output_vec_len );
            case 884:  return makeRegisterExpression(amdgpu_gfx908::acc116, output_vec_len );
            case 885:  return makeRegisterExpression(amdgpu_gfx908::acc117, output_vec_len );
            case 886:  return makeRegisterExpression(amdgpu_gfx908::acc118, output_vec_len );
            case 887:  return makeRegisterExpression(amdgpu_gfx908::acc119, output_vec_len );
            case 888:  return makeRegisterExpression(amdgpu_gfx908::acc120, output_vec_len );
            case 889:  return makeRegisterExpression(amdgpu_gfx908::acc121, output_vec_len );
            case 890:  return makeRegisterExpression(amdgpu_gfx908::acc122, output_vec_len );
            case 891:  return makeRegisterExpression(amdgpu_gfx908::acc123, output_vec_len );
            case 892:  return makeRegisterExpression(amdgpu_gfx908::acc124, output_vec_len );
            case 893:  return makeRegisterExpression(amdgpu_gfx908::acc125, output_vec_len );
            case 894:  return makeRegisterExpression(amdgpu_gfx908::acc126, output_vec_len );
            case 895:  return makeRegisterExpression(amdgpu_gfx908::acc127, output_vec_len );
            case 896:  return makeRegisterExpression(amdgpu_gfx908::acc128, output_vec_len );
            case 897:  return makeRegisterExpression(amdgpu_gfx908::acc129, output_vec_len );
            case 898:  return makeRegisterExpression(amdgpu_gfx908::acc130, output_vec_len );
            case 899:  return makeRegisterExpression(amdgpu_gfx908::acc131, output_vec_len );
            case 900:  return makeRegisterExpression(amdgpu_gfx908::acc132, output_vec_len );
            case 901:  return makeRegisterExpression(amdgpu_gfx908::acc133, output_vec_len );
            case 902:  return makeRegisterExpression(amdgpu_gfx908::acc134, output_vec_len );
            case 903:  return makeRegisterExpression(amdgpu_gfx908::acc135, output_vec_len );
            case 904:  return makeRegisterExpression(amdgpu_gfx908::acc136, output_vec_len );
            case 905:  return makeRegisterExpression(amdgpu_gfx908::acc137, output_vec_len );
            case 906:  return makeRegisterExpression(amdgpu_gfx908::acc138, output_vec_len );
            case 907:  return makeRegisterExpression(amdgpu_gfx908::acc139, output_vec_len );
            case 908:  return makeRegisterExpression(amdgpu_gfx908::acc140, output_vec_len );
            case 909:  return makeRegisterExpression(amdgpu_gfx908::acc141, output_vec_len );
            case 910:  return makeRegisterExpression(amdgpu_gfx908::acc142, output_vec_len );
            case 911:  return makeRegisterExpression(amdgpu_gfx908::acc143, output_vec_len );
            case 912:  return makeRegisterExpression(amdgpu_gfx908::acc144, output_vec_len );
            case 913:  return makeRegisterExpression(amdgpu_gfx908::acc145, output_vec_len );
            case 914:  return makeRegisterExpression(amdgpu_gfx908::acc146, output_vec_len );
            case 915:  return makeRegisterExpression(amdgpu_gfx908::acc147, output_vec_len );
            case 916:  return makeRegisterExpression(amdgpu_gfx908::acc148, output_vec_len );
            case 917:  return makeRegisterExpression(amdgpu_gfx908::acc149, output_vec_len );
            case 918:  return makeRegisterExpression(amdgpu_gfx908::acc150, output_vec_len );
            case 919:  return makeRegisterExpression(amdgpu_gfx908::acc151, output_vec_len );
            case 920:  return makeRegisterExpression(amdgpu_gfx908::acc152, output_vec_len );
            case 921:  return makeRegisterExpression(amdgpu_gfx908::acc153, output_vec_len );
            case 922:  return makeRegisterExpression(amdgpu_gfx908::acc154, output_vec_len );
            case 923:  return makeRegisterExpression(amdgpu_gfx908::acc155, output_vec_len );
            case 924:  return makeRegisterExpression(amdgpu_gfx908::acc156, output_vec_len );
            case 925:  return makeRegisterExpression(amdgpu_gfx908::acc157, output_vec_len );
            case 926:  return makeRegisterExpression(amdgpu_gfx908::acc158, output_vec_len );
            case 927:  return makeRegisterExpression(amdgpu_gfx908::acc159, output_vec_len );
            case 928:  return makeRegisterExpression(amdgpu_gfx908::acc160, output_vec_len );
            case 929:  return makeRegisterExpression(amdgpu_gfx908::acc161, output_vec_len );
            case 930:  return makeRegisterExpression(amdgpu_gfx908::acc162, output_vec_len );
            case 931:  return makeRegisterExpression(amdgpu_gfx908::acc163, output_vec_len );
            case 932:  return makeRegisterExpression(amdgpu_gfx908::acc164, output_vec_len );
            case 933:  return makeRegisterExpression(amdgpu_gfx908::acc165, output_vec_len );
            case 934:  return makeRegisterExpression(amdgpu_gfx908::acc166, output_vec_len );
            case 935:  return makeRegisterExpression(amdgpu_gfx908::acc167, output_vec_len );
            case 936:  return makeRegisterExpression(amdgpu_gfx908::acc168, output_vec_len );
            case 937:  return makeRegisterExpression(amdgpu_gfx908::acc169, output_vec_len );
            case 938:  return makeRegisterExpression(amdgpu_gfx908::acc170, output_vec_len );
            case 939:  return makeRegisterExpression(amdgpu_gfx908::acc171, output_vec_len );
            case 940:  return makeRegisterExpression(amdgpu_gfx908::acc172, output_vec_len );
            case 941:  return makeRegisterExpression(amdgpu_gfx908::acc173, output_vec_len );
            case 942:  return makeRegisterExpression(amdgpu_gfx908::acc174, output_vec_len );
            case 943:  return makeRegisterExpression(amdgpu_gfx908::acc175, output_vec_len );
            case 944:  return makeRegisterExpression(amdgpu_gfx908::acc176, output_vec_len );
            case 945:  return makeRegisterExpression(amdgpu_gfx908::acc177, output_vec_len );
            case 946:  return makeRegisterExpression(amdgpu_gfx908::acc178, output_vec_len );
            case 947:  return makeRegisterExpression(amdgpu_gfx908::acc179, output_vec_len );
            case 948:  return makeRegisterExpression(amdgpu_gfx908::acc180, output_vec_len );
            case 949:  return makeRegisterExpression(amdgpu_gfx908::acc181, output_vec_len );
            case 950:  return makeRegisterExpression(amdgpu_gfx908::acc182, output_vec_len );
            case 951:  return makeRegisterExpression(amdgpu_gfx908::acc183, output_vec_len );
            case 952:  return makeRegisterExpression(amdgpu_gfx908::acc184, output_vec_len );
            case 953:  return makeRegisterExpression(amdgpu_gfx908::acc185, output_vec_len );
            case 954:  return makeRegisterExpression(amdgpu_gfx908::acc186, output_vec_len );
            case 955:  return makeRegisterExpression(amdgpu_gfx908::acc187, output_vec_len );
            case 956:  return makeRegisterExpression(amdgpu_gfx908::acc188, output_vec_len );
            case 957:  return makeRegisterExpression(amdgpu_gfx908::acc189, output_vec_len );
            case 958:  return makeRegisterExpression(amdgpu_gfx908::acc190, output_vec_len );
            case 959:  return makeRegisterExpression(amdgpu_gfx908::acc191, output_vec_len );
            case 960:  return makeRegisterExpression(amdgpu_gfx908::acc192, output_vec_len );
            case 961:  return makeRegisterExpression(amdgpu_gfx908::acc193, output_vec_len );
            case 962:  return makeRegisterExpression(amdgpu_gfx908::acc194, output_vec_len );
            case 963:  return makeRegisterExpression(amdgpu_gfx908::acc195, output_vec_len );
            case 964:  return makeRegisterExpression(amdgpu_gfx908::acc196, output_vec_len );
            case 965:  return makeRegisterExpression(amdgpu_gfx908::acc197, output_vec_len );
            case 966:  return makeRegisterExpression(amdgpu_gfx908::acc198, output_vec_len );
            case 967:  return makeRegisterExpression(amdgpu_gfx908::acc199, output_vec_len );
            case 968:  return makeRegisterExpression(amdgpu_gfx908::acc200, output_vec_len );
            case 969:  return makeRegisterExpression(amdgpu_gfx908::acc201, output_vec_len );
            case 970:  return makeRegisterExpression(amdgpu_gfx908::acc202, output_vec_len );
            case 971:  return makeRegisterExpression(amdgpu_gfx908::acc203, output_vec_len );
            case 972:  return makeRegisterExpression(amdgpu_gfx908::acc204, output_vec_len );
            case 973:  return makeRegisterExpression(amdgpu_gfx908::acc205, output_vec_len );
            case 974:  return makeRegisterExpression(amdgpu_gfx908::acc206, output_vec_len );
            case 975:  return makeRegisterExpression(amdgpu_gfx908::acc207, output_vec_len );
            case 976:  return makeRegisterExpression(amdgpu_gfx908::acc208, output_vec_len );
            case 977:  return makeRegisterExpression(amdgpu_gfx908::acc209, output_vec_len );
            case 978:  return makeRegisterExpression(amdgpu_gfx908::acc210, output_vec_len );
            case 979:  return makeRegisterExpression(amdgpu_gfx908::acc211, output_vec_len );
            case 980:  return makeRegisterExpression(amdgpu_gfx908::acc212, output_vec_len );
            case 981:  return makeRegisterExpression(amdgpu_gfx908::acc213, output_vec_len );
            case 982:  return makeRegisterExpression(amdgpu_gfx908::acc214, output_vec_len );
            case 983:  return makeRegisterExpression(amdgpu_gfx908::acc215, output_vec_len );
            case 984:  return makeRegisterExpression(amdgpu_gfx908::acc216, output_vec_len );
            case 985:  return makeRegisterExpression(amdgpu_gfx908::acc217, output_vec_len );
            case 986:  return makeRegisterExpression(amdgpu_gfx908::acc218, output_vec_len );
            case 987:  return makeRegisterExpression(amdgpu_gfx908::acc219, output_vec_len );
            case 988:  return makeRegisterExpression(amdgpu_gfx908::acc220, output_vec_len );
            case 989:  return makeRegisterExpression(amdgpu_gfx908::acc221, output_vec_len );
            case 990:  return makeRegisterExpression(amdgpu_gfx908::acc222, output_vec_len );
            case 991:  return makeRegisterExpression(amdgpu_gfx908::acc223, output_vec_len );
            case 992:  return makeRegisterExpression(amdgpu_gfx908::acc224, output_vec_len );
            case 993:  return makeRegisterExpression(amdgpu_gfx908::acc225, output_vec_len );
            case 994:  return makeRegisterExpression(amdgpu_gfx908::acc226, output_vec_len );
            case 995:  return makeRegisterExpression(amdgpu_gfx908::acc227, output_vec_len );
            case 996:  return makeRegisterExpression(amdgpu_gfx908::acc228, output_vec_len );
            case 997:  return makeRegisterExpression(amdgpu_gfx908::acc229, output_vec_len );
            case 998:  return makeRegisterExpression(amdgpu_gfx908::acc230, output_vec_len );
            case 999:  return makeRegisterExpression(amdgpu_gfx908::acc231, output_vec_len );
            case 1000:  return makeRegisterExpression(amdgpu_gfx908::acc232, output_vec_len );
            case 1001:  return makeRegisterExpression(amdgpu_gfx908::acc233, output_vec_len );
            case 1002:  return makeRegisterExpression(amdgpu_gfx908::acc234, output_vec_len );
            case 1003:  return makeRegisterExpression(amdgpu_gfx908::acc235, output_vec_len );
            case 1004:  return makeRegisterExpression(amdgpu_gfx908::acc236, output_vec_len );
            case 1005:  return makeRegisterExpression(amdgpu_gfx908::acc237, output_vec_len );
            case 1006:  return makeRegisterExpression(amdgpu_gfx908::acc238, output_vec_len );
            case 1007:  return makeRegisterExpression(amdgpu_gfx908::acc239, output_vec_len );
            case 1008:  return makeRegisterExpression(amdgpu_gfx908::acc240, output_vec_len );
            case 1009:  return makeRegisterExpression(amdgpu_gfx908::acc241, output_vec_len );
            case 1010:  return makeRegisterExpression(amdgpu_gfx908::acc242, output_vec_len );
            case 1011:  return makeRegisterExpression(amdgpu_gfx908::acc243, output_vec_len );
            case 1012:  return makeRegisterExpression(amdgpu_gfx908::acc244, output_vec_len );
            case 1013:  return makeRegisterExpression(amdgpu_gfx908::acc245, output_vec_len );
            case 1014:  return makeRegisterExpression(amdgpu_gfx908::acc246, output_vec_len );
            case 1015:  return makeRegisterExpression(amdgpu_gfx908::acc247, output_vec_len );
            case 1016:  return makeRegisterExpression(amdgpu_gfx908::acc248, output_vec_len );
            case 1017:  return makeRegisterExpression(amdgpu_gfx908::acc249, output_vec_len );
            case 1018:  return makeRegisterExpression(amdgpu_gfx908::acc250, output_vec_len );
            case 1019:  return makeRegisterExpression(amdgpu_gfx908::acc251, output_vec_len );
            case 1020:  return makeRegisterExpression(amdgpu_gfx908::acc252, output_vec_len );
            case 1021:  return makeRegisterExpression(amdgpu_gfx908::acc253, output_vec_len );
            case 1022:  return makeRegisterExpression(amdgpu_gfx908::acc254, output_vec_len );
            case 1023:  return makeRegisterExpression(amdgpu_gfx908::acc255, output_vec_len );
            default: return makeRegisterExpression(amdgpu_gfx908::invalid);
        }
    }

    Expression::Ptr InstructionDecoder_amdgpu_gfx908::decodeOPR_SREG(uint64_t input, uint32_t output_vec_len)
    {
        switch (input)  {
            case 0:  return makeRegisterExpression(amdgpu_gfx908::s0, output_vec_len );
            case 1:  return makeRegisterExpression(amdgpu_gfx908::s1, output_vec_len );
            case 2:  return makeRegisterExpression(amdgpu_gfx908::s2, output_vec_len );
            case 3:  return makeRegisterExpression(amdgpu_gfx908::s3, output_vec_len );
            case 4:  return makeRegisterExpression(amdgpu_gfx908::s4, output_vec_len );
            case 5:  return makeRegisterExpression(amdgpu_gfx908::s5, output_vec_len );
            case 6:  return makeRegisterExpression(amdgpu_gfx908::s6, output_vec_len );
            case 7:  return makeRegisterExpression(amdgpu_gfx908::s7, output_vec_len );
            case 8:  return makeRegisterExpression(amdgpu_gfx908::s8, output_vec_len );
            case 9:  return makeRegisterExpression(amdgpu_gfx908::s9, output_vec_len );
            case 10:  return makeRegisterExpression(amdgpu_gfx908::s10, output_vec_len );
            case 11:  return makeRegisterExpression(amdgpu_gfx908::s11, output_vec_len );
            case 12:  return makeRegisterExpression(amdgpu_gfx908::s12, output_vec_len );
            case 13:  return makeRegisterExpression(amdgpu_gfx908::s13, output_vec_len );
            case 14:  return makeRegisterExpression(amdgpu_gfx908::s14, output_vec_len );
            case 15:  return makeRegisterExpression(amdgpu_gfx908::s15, output_vec_len );
            case 16:  return makeRegisterExpression(amdgpu_gfx908::s16, output_vec_len );
            case 17:  return makeRegisterExpression(amdgpu_gfx908::s17, output_vec_len );
            case 18:  return makeRegisterExpression(amdgpu_gfx908::s18, output_vec_len );
            case 19:  return makeRegisterExpression(amdgpu_gfx908::s19, output_vec_len );
            case 20:  return makeRegisterExpression(amdgpu_gfx908::s20, output_vec_len );
            case 21:  return makeRegisterExpression(amdgpu_gfx908::s21, output_vec_len );
            case 22:  return makeRegisterExpression(amdgpu_gfx908::s22, output_vec_len );
            case 23:  return makeRegisterExpression(amdgpu_gfx908::s23, output_vec_len );
            case 24:  return makeRegisterExpression(amdgpu_gfx908::s24, output_vec_len );
            case 25:  return makeRegisterExpression(amdgpu_gfx908::s25, output_vec_len );
            case 26:  return makeRegisterExpression(amdgpu_gfx908::s26, output_vec_len );
            case 27:  return makeRegisterExpression(amdgpu_gfx908::s27, output_vec_len );
            case 28:  return makeRegisterExpression(amdgpu_gfx908::s28, output_vec_len );
            case 29:  return makeRegisterExpression(amdgpu_gfx908::s29, output_vec_len );
            case 30:  return makeRegisterExpression(amdgpu_gfx908::s30, output_vec_len );
            case 31:  return makeRegisterExpression(amdgpu_gfx908::s31, output_vec_len );
            case 32:  return makeRegisterExpression(amdgpu_gfx908::s32, output_vec_len );
            case 33:  return makeRegisterExpression(amdgpu_gfx908::s33, output_vec_len );
            case 34:  return makeRegisterExpression(amdgpu_gfx908::s34, output_vec_len );
            case 35:  return makeRegisterExpression(amdgpu_gfx908::s35, output_vec_len );
            case 36:  return makeRegisterExpression(amdgpu_gfx908::s36, output_vec_len );
            case 37:  return makeRegisterExpression(amdgpu_gfx908::s37, output_vec_len );
            case 38:  return makeRegisterExpression(amdgpu_gfx908::s38, output_vec_len );
            case 39:  return makeRegisterExpression(amdgpu_gfx908::s39, output_vec_len );
            case 40:  return makeRegisterExpression(amdgpu_gfx908::s40, output_vec_len );
            case 41:  return makeRegisterExpression(amdgpu_gfx908::s41, output_vec_len );
            case 42:  return makeRegisterExpression(amdgpu_gfx908::s42, output_vec_len );
            case 43:  return makeRegisterExpression(amdgpu_gfx908::s43, output_vec_len );
            case 44:  return makeRegisterExpression(amdgpu_gfx908::s44, output_vec_len );
            case 45:  return makeRegisterExpression(amdgpu_gfx908::s45, output_vec_len );
            case 46:  return makeRegisterExpression(amdgpu_gfx908::s46, output_vec_len );
            case 47:  return makeRegisterExpression(amdgpu_gfx908::s47, output_vec_len );
            case 48:  return makeRegisterExpression(amdgpu_gfx908::s48, output_vec_len );
            case 49:  return makeRegisterExpression(amdgpu_gfx908::s49, output_vec_len );
            case 50:  return makeRegisterExpression(amdgpu_gfx908::s50, output_vec_len );
            case 51:  return makeRegisterExpression(amdgpu_gfx908::s51, output_vec_len );
            case 52:  return makeRegisterExpression(amdgpu_gfx908::s52, output_vec_len );
            case 53:  return makeRegisterExpression(amdgpu_gfx908::s53, output_vec_len );
            case 54:  return makeRegisterExpression(amdgpu_gfx908::s54, output_vec_len );
            case 55:  return makeRegisterExpression(amdgpu_gfx908::s55, output_vec_len );
            case 56:  return makeRegisterExpression(amdgpu_gfx908::s56, output_vec_len );
            case 57:  return makeRegisterExpression(amdgpu_gfx908::s57, output_vec_len );
            case 58:  return makeRegisterExpression(amdgpu_gfx908::s58, output_vec_len );
            case 59:  return makeRegisterExpression(amdgpu_gfx908::s59, output_vec_len );
            case 60:  return makeRegisterExpression(amdgpu_gfx908::s60, output_vec_len );
            case 61:  return makeRegisterExpression(amdgpu_gfx908::s61, output_vec_len );
            case 62:  return makeRegisterExpression(amdgpu_gfx908::s62, output_vec_len );
            case 63:  return makeRegisterExpression(amdgpu_gfx908::s63, output_vec_len );
            case 64:  return makeRegisterExpression(amdgpu_gfx908::s64, output_vec_len );
            case 65:  return makeRegisterExpression(amdgpu_gfx908::s65, output_vec_len );
            case 66:  return makeRegisterExpression(amdgpu_gfx908::s66, output_vec_len );
            case 67:  return makeRegisterExpression(amdgpu_gfx908::s67, output_vec_len );
            case 68:  return makeRegisterExpression(amdgpu_gfx908::s68, output_vec_len );
            case 69:  return makeRegisterExpression(amdgpu_gfx908::s69, output_vec_len );
            case 70:  return makeRegisterExpression(amdgpu_gfx908::s70, output_vec_len );
            case 71:  return makeRegisterExpression(amdgpu_gfx908::s71, output_vec_len );
            case 72:  return makeRegisterExpression(amdgpu_gfx908::s72, output_vec_len );
            case 73:  return makeRegisterExpression(amdgpu_gfx908::s73, output_vec_len );
            case 74:  return makeRegisterExpression(amdgpu_gfx908::s74, output_vec_len );
            case 75:  return makeRegisterExpression(amdgpu_gfx908::s75, output_vec_len );
            case 76:  return makeRegisterExpression(amdgpu_gfx908::s76, output_vec_len );
            case 77:  return makeRegisterExpression(amdgpu_gfx908::s77, output_vec_len );
            case 78:  return makeRegisterExpression(amdgpu_gfx908::s78, output_vec_len );
            case 79:  return makeRegisterExpression(amdgpu_gfx908::s79, output_vec_len );
            case 80:  return makeRegisterExpression(amdgpu_gfx908::s80, output_vec_len );
            case 81:  return makeRegisterExpression(amdgpu_gfx908::s81, output_vec_len );
            case 82:  return makeRegisterExpression(amdgpu_gfx908::s82, output_vec_len );
            case 83:  return makeRegisterExpression(amdgpu_gfx908::s83, output_vec_len );
            case 84:  return makeRegisterExpression(amdgpu_gfx908::s84, output_vec_len );
            case 85:  return makeRegisterExpression(amdgpu_gfx908::s85, output_vec_len );
            case 86:  return makeRegisterExpression(amdgpu_gfx908::s86, output_vec_len );
            case 87:  return makeRegisterExpression(amdgpu_gfx908::s87, output_vec_len );
            case 88:  return makeRegisterExpression(amdgpu_gfx908::s88, output_vec_len );
            case 89:  return makeRegisterExpression(amdgpu_gfx908::s89, output_vec_len );
            case 90:  return makeRegisterExpression(amdgpu_gfx908::s90, output_vec_len );
            case 91:  return makeRegisterExpression(amdgpu_gfx908::s91, output_vec_len );
            case 92:  return makeRegisterExpression(amdgpu_gfx908::s92, output_vec_len );
            case 93:  return makeRegisterExpression(amdgpu_gfx908::s93, output_vec_len );
            case 94:  return makeRegisterExpression(amdgpu_gfx908::s94, output_vec_len );
            case 95:  return makeRegisterExpression(amdgpu_gfx908::s95, output_vec_len );
            case 96:  return makeRegisterExpression(amdgpu_gfx908::s96, output_vec_len );
            case 97:  return makeRegisterExpression(amdgpu_gfx908::s97, output_vec_len );
            case 98:  return makeRegisterExpression(amdgpu_gfx908::s98, output_vec_len );
            case 99:  return makeRegisterExpression(amdgpu_gfx908::s99, output_vec_len );
            case 100:  return makeRegisterExpression(amdgpu_gfx908::s100, output_vec_len );
            case 101:  return makeRegisterExpression(amdgpu_gfx908::s101, output_vec_len );
            case 104:  return makeRegisterExpression(amdgpu_gfx908::xnack_mask_lo, output_vec_len );
            case 105:  return makeRegisterExpression(amdgpu_gfx908::xnack_mask_hi, output_vec_len );
            case 102:  return makeRegisterExpression(amdgpu_gfx908::flat_scratch_lo, output_vec_len );
            case 103:  return makeRegisterExpression(amdgpu_gfx908::flat_scratch_hi, output_vec_len );
            case 108:  return makeRegisterExpression(amdgpu_gfx908::ttmp0, output_vec_len );
            case 109:  return makeRegisterExpression(amdgpu_gfx908::ttmp1, output_vec_len );
            case 110:  return makeRegisterExpression(amdgpu_gfx908::ttmp2, output_vec_len );
            case 111:  return makeRegisterExpression(amdgpu_gfx908::ttmp3, output_vec_len );
            case 112:  return makeRegisterExpression(amdgpu_gfx908::ttmp4, output_vec_len );
            case 113:  return makeRegisterExpression(amdgpu_gfx908::ttmp5, output_vec_len );
            case 114:  return makeRegisterExpression(amdgpu_gfx908::ttmp6, output_vec_len );
            case 115:  return makeRegisterExpression(amdgpu_gfx908::ttmp7, output_vec_len );
            case 116:  return makeRegisterExpression(amdgpu_gfx908::ttmp8, output_vec_len );
            case 117:  return makeRegisterExpression(amdgpu_gfx908::ttmp9, output_vec_len );
            case 118:  return makeRegisterExpression(amdgpu_gfx908::ttmp10, output_vec_len );
            case 119:  return makeRegisterExpression(amdgpu_gfx908::ttmp11, output_vec_len );
            case 120:  return makeRegisterExpression(amdgpu_gfx908::ttmp12, output_vec_len );
            case 121:  return makeRegisterExpression(amdgpu_gfx908::ttmp13, output_vec_len );
            case 122:  return makeRegisterExpression(amdgpu_gfx908::ttmp14, output_vec_len );
            case 123:  return makeRegisterExpression(amdgpu_gfx908::ttmp15, output_vec_len );
            case 106:  return makeRegisterExpression(amdgpu_gfx908::vcc_lo, output_vec_len );
            case 107:  return makeRegisterExpression(amdgpu_gfx908::vcc_hi, output_vec_len );
            default: return makeRegisterExpression(amdgpu_gfx908::invalid);
        }
    }

    Expression::Ptr InstructionDecoder_amdgpu_gfx908::decodeOPR_SREG_NOVCC(uint64_t input, uint32_t output_vec_len)
    {
        switch (input)  {
            case 0:  return makeRegisterExpression(amdgpu_gfx908::s0, output_vec_len );
            case 1:  return makeRegisterExpression(amdgpu_gfx908::s1, output_vec_len );
            case 2:  return makeRegisterExpression(amdgpu_gfx908::s2, output_vec_len );
            case 3:  return makeRegisterExpression(amdgpu_gfx908::s3, output_vec_len );
            case 4:  return makeRegisterExpression(amdgpu_gfx908::s4, output_vec_len );
            case 5:  return makeRegisterExpression(amdgpu_gfx908::s5, output_vec_len );
            case 6:  return makeRegisterExpression(amdgpu_gfx908::s6, output_vec_len );
            case 7:  return makeRegisterExpression(amdgpu_gfx908::s7, output_vec_len );
            case 8:  return makeRegisterExpression(amdgpu_gfx908::s8, output_vec_len );
            case 9:  return makeRegisterExpression(amdgpu_gfx908::s9, output_vec_len );
            case 10:  return makeRegisterExpression(amdgpu_gfx908::s10, output_vec_len );
            case 11:  return makeRegisterExpression(amdgpu_gfx908::s11, output_vec_len );
            case 12:  return makeRegisterExpression(amdgpu_gfx908::s12, output_vec_len );
            case 13:  return makeRegisterExpression(amdgpu_gfx908::s13, output_vec_len );
            case 14:  return makeRegisterExpression(amdgpu_gfx908::s14, output_vec_len );
            case 15:  return makeRegisterExpression(amdgpu_gfx908::s15, output_vec_len );
            case 16:  return makeRegisterExpression(amdgpu_gfx908::s16, output_vec_len );
            case 17:  return makeRegisterExpression(amdgpu_gfx908::s17, output_vec_len );
            case 18:  return makeRegisterExpression(amdgpu_gfx908::s18, output_vec_len );
            case 19:  return makeRegisterExpression(amdgpu_gfx908::s19, output_vec_len );
            case 20:  return makeRegisterExpression(amdgpu_gfx908::s20, output_vec_len );
            case 21:  return makeRegisterExpression(amdgpu_gfx908::s21, output_vec_len );
            case 22:  return makeRegisterExpression(amdgpu_gfx908::s22, output_vec_len );
            case 23:  return makeRegisterExpression(amdgpu_gfx908::s23, output_vec_len );
            case 24:  return makeRegisterExpression(amdgpu_gfx908::s24, output_vec_len );
            case 25:  return makeRegisterExpression(amdgpu_gfx908::s25, output_vec_len );
            case 26:  return makeRegisterExpression(amdgpu_gfx908::s26, output_vec_len );
            case 27:  return makeRegisterExpression(amdgpu_gfx908::s27, output_vec_len );
            case 28:  return makeRegisterExpression(amdgpu_gfx908::s28, output_vec_len );
            case 29:  return makeRegisterExpression(amdgpu_gfx908::s29, output_vec_len );
            case 30:  return makeRegisterExpression(amdgpu_gfx908::s30, output_vec_len );
            case 31:  return makeRegisterExpression(amdgpu_gfx908::s31, output_vec_len );
            case 32:  return makeRegisterExpression(amdgpu_gfx908::s32, output_vec_len );
            case 33:  return makeRegisterExpression(amdgpu_gfx908::s33, output_vec_len );
            case 34:  return makeRegisterExpression(amdgpu_gfx908::s34, output_vec_len );
            case 35:  return makeRegisterExpression(amdgpu_gfx908::s35, output_vec_len );
            case 36:  return makeRegisterExpression(amdgpu_gfx908::s36, output_vec_len );
            case 37:  return makeRegisterExpression(amdgpu_gfx908::s37, output_vec_len );
            case 38:  return makeRegisterExpression(amdgpu_gfx908::s38, output_vec_len );
            case 39:  return makeRegisterExpression(amdgpu_gfx908::s39, output_vec_len );
            case 40:  return makeRegisterExpression(amdgpu_gfx908::s40, output_vec_len );
            case 41:  return makeRegisterExpression(amdgpu_gfx908::s41, output_vec_len );
            case 42:  return makeRegisterExpression(amdgpu_gfx908::s42, output_vec_len );
            case 43:  return makeRegisterExpression(amdgpu_gfx908::s43, output_vec_len );
            case 44:  return makeRegisterExpression(amdgpu_gfx908::s44, output_vec_len );
            case 45:  return makeRegisterExpression(amdgpu_gfx908::s45, output_vec_len );
            case 46:  return makeRegisterExpression(amdgpu_gfx908::s46, output_vec_len );
            case 47:  return makeRegisterExpression(amdgpu_gfx908::s47, output_vec_len );
            case 48:  return makeRegisterExpression(amdgpu_gfx908::s48, output_vec_len );
            case 49:  return makeRegisterExpression(amdgpu_gfx908::s49, output_vec_len );
            case 50:  return makeRegisterExpression(amdgpu_gfx908::s50, output_vec_len );
            case 51:  return makeRegisterExpression(amdgpu_gfx908::s51, output_vec_len );
            case 52:  return makeRegisterExpression(amdgpu_gfx908::s52, output_vec_len );
            case 53:  return makeRegisterExpression(amdgpu_gfx908::s53, output_vec_len );
            case 54:  return makeRegisterExpression(amdgpu_gfx908::s54, output_vec_len );
            case 55:  return makeRegisterExpression(amdgpu_gfx908::s55, output_vec_len );
            case 56:  return makeRegisterExpression(amdgpu_gfx908::s56, output_vec_len );
            case 57:  return makeRegisterExpression(amdgpu_gfx908::s57, output_vec_len );
            case 58:  return makeRegisterExpression(amdgpu_gfx908::s58, output_vec_len );
            case 59:  return makeRegisterExpression(amdgpu_gfx908::s59, output_vec_len );
            case 60:  return makeRegisterExpression(amdgpu_gfx908::s60, output_vec_len );
            case 61:  return makeRegisterExpression(amdgpu_gfx908::s61, output_vec_len );
            case 62:  return makeRegisterExpression(amdgpu_gfx908::s62, output_vec_len );
            case 63:  return makeRegisterExpression(amdgpu_gfx908::s63, output_vec_len );
            case 64:  return makeRegisterExpression(amdgpu_gfx908::s64, output_vec_len );
            case 65:  return makeRegisterExpression(amdgpu_gfx908::s65, output_vec_len );
            case 66:  return makeRegisterExpression(amdgpu_gfx908::s66, output_vec_len );
            case 67:  return makeRegisterExpression(amdgpu_gfx908::s67, output_vec_len );
            case 68:  return makeRegisterExpression(amdgpu_gfx908::s68, output_vec_len );
            case 69:  return makeRegisterExpression(amdgpu_gfx908::s69, output_vec_len );
            case 70:  return makeRegisterExpression(amdgpu_gfx908::s70, output_vec_len );
            case 71:  return makeRegisterExpression(amdgpu_gfx908::s71, output_vec_len );
            case 72:  return makeRegisterExpression(amdgpu_gfx908::s72, output_vec_len );
            case 73:  return makeRegisterExpression(amdgpu_gfx908::s73, output_vec_len );
            case 74:  return makeRegisterExpression(amdgpu_gfx908::s74, output_vec_len );
            case 75:  return makeRegisterExpression(amdgpu_gfx908::s75, output_vec_len );
            case 76:  return makeRegisterExpression(amdgpu_gfx908::s76, output_vec_len );
            case 77:  return makeRegisterExpression(amdgpu_gfx908::s77, output_vec_len );
            case 78:  return makeRegisterExpression(amdgpu_gfx908::s78, output_vec_len );
            case 79:  return makeRegisterExpression(amdgpu_gfx908::s79, output_vec_len );
            case 80:  return makeRegisterExpression(amdgpu_gfx908::s80, output_vec_len );
            case 81:  return makeRegisterExpression(amdgpu_gfx908::s81, output_vec_len );
            case 82:  return makeRegisterExpression(amdgpu_gfx908::s82, output_vec_len );
            case 83:  return makeRegisterExpression(amdgpu_gfx908::s83, output_vec_len );
            case 84:  return makeRegisterExpression(amdgpu_gfx908::s84, output_vec_len );
            case 85:  return makeRegisterExpression(amdgpu_gfx908::s85, output_vec_len );
            case 86:  return makeRegisterExpression(amdgpu_gfx908::s86, output_vec_len );
            case 87:  return makeRegisterExpression(amdgpu_gfx908::s87, output_vec_len );
            case 88:  return makeRegisterExpression(amdgpu_gfx908::s88, output_vec_len );
            case 89:  return makeRegisterExpression(amdgpu_gfx908::s89, output_vec_len );
            case 90:  return makeRegisterExpression(amdgpu_gfx908::s90, output_vec_len );
            case 91:  return makeRegisterExpression(amdgpu_gfx908::s91, output_vec_len );
            case 92:  return makeRegisterExpression(amdgpu_gfx908::s92, output_vec_len );
            case 93:  return makeRegisterExpression(amdgpu_gfx908::s93, output_vec_len );
            case 94:  return makeRegisterExpression(amdgpu_gfx908::s94, output_vec_len );
            case 95:  return makeRegisterExpression(amdgpu_gfx908::s95, output_vec_len );
            case 96:  return makeRegisterExpression(amdgpu_gfx908::s96, output_vec_len );
            case 97:  return makeRegisterExpression(amdgpu_gfx908::s97, output_vec_len );
            case 98:  return makeRegisterExpression(amdgpu_gfx908::s98, output_vec_len );
            case 99:  return makeRegisterExpression(amdgpu_gfx908::s99, output_vec_len );
            case 100:  return makeRegisterExpression(amdgpu_gfx908::s100, output_vec_len );
            case 101:  return makeRegisterExpression(amdgpu_gfx908::s101, output_vec_len );
            case 104:  return makeRegisterExpression(amdgpu_gfx908::xnack_mask_lo, output_vec_len );
            case 105:  return makeRegisterExpression(amdgpu_gfx908::xnack_mask_hi, output_vec_len );
            case 102:  return makeRegisterExpression(amdgpu_gfx908::flat_scratch_lo, output_vec_len );
            case 103:  return makeRegisterExpression(amdgpu_gfx908::flat_scratch_hi, output_vec_len );
            case 108:  return makeRegisterExpression(amdgpu_gfx908::ttmp0, output_vec_len );
            case 109:  return makeRegisterExpression(amdgpu_gfx908::ttmp1, output_vec_len );
            case 110:  return makeRegisterExpression(amdgpu_gfx908::ttmp2, output_vec_len );
            case 111:  return makeRegisterExpression(amdgpu_gfx908::ttmp3, output_vec_len );
            case 112:  return makeRegisterExpression(amdgpu_gfx908::ttmp4, output_vec_len );
            case 113:  return makeRegisterExpression(amdgpu_gfx908::ttmp5, output_vec_len );
            case 114:  return makeRegisterExpression(amdgpu_gfx908::ttmp6, output_vec_len );
            case 115:  return makeRegisterExpression(amdgpu_gfx908::ttmp7, output_vec_len );
            case 116:  return makeRegisterExpression(amdgpu_gfx908::ttmp8, output_vec_len );
            case 117:  return makeRegisterExpression(amdgpu_gfx908::ttmp9, output_vec_len );
            case 118:  return makeRegisterExpression(amdgpu_gfx908::ttmp10, output_vec_len );
            case 119:  return makeRegisterExpression(amdgpu_gfx908::ttmp11, output_vec_len );
            case 120:  return makeRegisterExpression(amdgpu_gfx908::ttmp12, output_vec_len );
            case 121:  return makeRegisterExpression(amdgpu_gfx908::ttmp13, output_vec_len );
            case 122:  return makeRegisterExpression(amdgpu_gfx908::ttmp14, output_vec_len );
            case 123:  return makeRegisterExpression(amdgpu_gfx908::ttmp15, output_vec_len );
            default: return makeRegisterExpression(amdgpu_gfx908::invalid);
        }
    }

    Expression::Ptr InstructionDecoder_amdgpu_gfx908::decodeOPR_SSRC(uint64_t input, uint32_t output_vec_len)
    {
        switch (input)  {
            case 0:  return makeRegisterExpression(amdgpu_gfx908::s0, output_vec_len );
            case 1:  return makeRegisterExpression(amdgpu_gfx908::s1, output_vec_len );
            case 2:  return makeRegisterExpression(amdgpu_gfx908::s2, output_vec_len );
            case 3:  return makeRegisterExpression(amdgpu_gfx908::s3, output_vec_len );
            case 4:  return makeRegisterExpression(amdgpu_gfx908::s4, output_vec_len );
            case 5:  return makeRegisterExpression(amdgpu_gfx908::s5, output_vec_len );
            case 6:  return makeRegisterExpression(amdgpu_gfx908::s6, output_vec_len );
            case 7:  return makeRegisterExpression(amdgpu_gfx908::s7, output_vec_len );
            case 8:  return makeRegisterExpression(amdgpu_gfx908::s8, output_vec_len );
            case 9:  return makeRegisterExpression(amdgpu_gfx908::s9, output_vec_len );
            case 10:  return makeRegisterExpression(amdgpu_gfx908::s10, output_vec_len );
            case 11:  return makeRegisterExpression(amdgpu_gfx908::s11, output_vec_len );
            case 12:  return makeRegisterExpression(amdgpu_gfx908::s12, output_vec_len );
            case 13:  return makeRegisterExpression(amdgpu_gfx908::s13, output_vec_len );
            case 14:  return makeRegisterExpression(amdgpu_gfx908::s14, output_vec_len );
            case 15:  return makeRegisterExpression(amdgpu_gfx908::s15, output_vec_len );
            case 16:  return makeRegisterExpression(amdgpu_gfx908::s16, output_vec_len );
            case 17:  return makeRegisterExpression(amdgpu_gfx908::s17, output_vec_len );
            case 18:  return makeRegisterExpression(amdgpu_gfx908::s18, output_vec_len );
            case 19:  return makeRegisterExpression(amdgpu_gfx908::s19, output_vec_len );
            case 20:  return makeRegisterExpression(amdgpu_gfx908::s20, output_vec_len );
            case 21:  return makeRegisterExpression(amdgpu_gfx908::s21, output_vec_len );
            case 22:  return makeRegisterExpression(amdgpu_gfx908::s22, output_vec_len );
            case 23:  return makeRegisterExpression(amdgpu_gfx908::s23, output_vec_len );
            case 24:  return makeRegisterExpression(amdgpu_gfx908::s24, output_vec_len );
            case 25:  return makeRegisterExpression(amdgpu_gfx908::s25, output_vec_len );
            case 26:  return makeRegisterExpression(amdgpu_gfx908::s26, output_vec_len );
            case 27:  return makeRegisterExpression(amdgpu_gfx908::s27, output_vec_len );
            case 28:  return makeRegisterExpression(amdgpu_gfx908::s28, output_vec_len );
            case 29:  return makeRegisterExpression(amdgpu_gfx908::s29, output_vec_len );
            case 30:  return makeRegisterExpression(amdgpu_gfx908::s30, output_vec_len );
            case 31:  return makeRegisterExpression(amdgpu_gfx908::s31, output_vec_len );
            case 32:  return makeRegisterExpression(amdgpu_gfx908::s32, output_vec_len );
            case 33:  return makeRegisterExpression(amdgpu_gfx908::s33, output_vec_len );
            case 34:  return makeRegisterExpression(amdgpu_gfx908::s34, output_vec_len );
            case 35:  return makeRegisterExpression(amdgpu_gfx908::s35, output_vec_len );
            case 36:  return makeRegisterExpression(amdgpu_gfx908::s36, output_vec_len );
            case 37:  return makeRegisterExpression(amdgpu_gfx908::s37, output_vec_len );
            case 38:  return makeRegisterExpression(amdgpu_gfx908::s38, output_vec_len );
            case 39:  return makeRegisterExpression(amdgpu_gfx908::s39, output_vec_len );
            case 40:  return makeRegisterExpression(amdgpu_gfx908::s40, output_vec_len );
            case 41:  return makeRegisterExpression(amdgpu_gfx908::s41, output_vec_len );
            case 42:  return makeRegisterExpression(amdgpu_gfx908::s42, output_vec_len );
            case 43:  return makeRegisterExpression(amdgpu_gfx908::s43, output_vec_len );
            case 44:  return makeRegisterExpression(amdgpu_gfx908::s44, output_vec_len );
            case 45:  return makeRegisterExpression(amdgpu_gfx908::s45, output_vec_len );
            case 46:  return makeRegisterExpression(amdgpu_gfx908::s46, output_vec_len );
            case 47:  return makeRegisterExpression(amdgpu_gfx908::s47, output_vec_len );
            case 48:  return makeRegisterExpression(amdgpu_gfx908::s48, output_vec_len );
            case 49:  return makeRegisterExpression(amdgpu_gfx908::s49, output_vec_len );
            case 50:  return makeRegisterExpression(amdgpu_gfx908::s50, output_vec_len );
            case 51:  return makeRegisterExpression(amdgpu_gfx908::s51, output_vec_len );
            case 52:  return makeRegisterExpression(amdgpu_gfx908::s52, output_vec_len );
            case 53:  return makeRegisterExpression(amdgpu_gfx908::s53, output_vec_len );
            case 54:  return makeRegisterExpression(amdgpu_gfx908::s54, output_vec_len );
            case 55:  return makeRegisterExpression(amdgpu_gfx908::s55, output_vec_len );
            case 56:  return makeRegisterExpression(amdgpu_gfx908::s56, output_vec_len );
            case 57:  return makeRegisterExpression(amdgpu_gfx908::s57, output_vec_len );
            case 58:  return makeRegisterExpression(amdgpu_gfx908::s58, output_vec_len );
            case 59:  return makeRegisterExpression(amdgpu_gfx908::s59, output_vec_len );
            case 60:  return makeRegisterExpression(amdgpu_gfx908::s60, output_vec_len );
            case 61:  return makeRegisterExpression(amdgpu_gfx908::s61, output_vec_len );
            case 62:  return makeRegisterExpression(amdgpu_gfx908::s62, output_vec_len );
            case 63:  return makeRegisterExpression(amdgpu_gfx908::s63, output_vec_len );
            case 64:  return makeRegisterExpression(amdgpu_gfx908::s64, output_vec_len );
            case 65:  return makeRegisterExpression(amdgpu_gfx908::s65, output_vec_len );
            case 66:  return makeRegisterExpression(amdgpu_gfx908::s66, output_vec_len );
            case 67:  return makeRegisterExpression(amdgpu_gfx908::s67, output_vec_len );
            case 68:  return makeRegisterExpression(amdgpu_gfx908::s68, output_vec_len );
            case 69:  return makeRegisterExpression(amdgpu_gfx908::s69, output_vec_len );
            case 70:  return makeRegisterExpression(amdgpu_gfx908::s70, output_vec_len );
            case 71:  return makeRegisterExpression(amdgpu_gfx908::s71, output_vec_len );
            case 72:  return makeRegisterExpression(amdgpu_gfx908::s72, output_vec_len );
            case 73:  return makeRegisterExpression(amdgpu_gfx908::s73, output_vec_len );
            case 74:  return makeRegisterExpression(amdgpu_gfx908::s74, output_vec_len );
            case 75:  return makeRegisterExpression(amdgpu_gfx908::s75, output_vec_len );
            case 76:  return makeRegisterExpression(amdgpu_gfx908::s76, output_vec_len );
            case 77:  return makeRegisterExpression(amdgpu_gfx908::s77, output_vec_len );
            case 78:  return makeRegisterExpression(amdgpu_gfx908::s78, output_vec_len );
            case 79:  return makeRegisterExpression(amdgpu_gfx908::s79, output_vec_len );
            case 80:  return makeRegisterExpression(amdgpu_gfx908::s80, output_vec_len );
            case 81:  return makeRegisterExpression(amdgpu_gfx908::s81, output_vec_len );
            case 82:  return makeRegisterExpression(amdgpu_gfx908::s82, output_vec_len );
            case 83:  return makeRegisterExpression(amdgpu_gfx908::s83, output_vec_len );
            case 84:  return makeRegisterExpression(amdgpu_gfx908::s84, output_vec_len );
            case 85:  return makeRegisterExpression(amdgpu_gfx908::s85, output_vec_len );
            case 86:  return makeRegisterExpression(amdgpu_gfx908::s86, output_vec_len );
            case 87:  return makeRegisterExpression(amdgpu_gfx908::s87, output_vec_len );
            case 88:  return makeRegisterExpression(amdgpu_gfx908::s88, output_vec_len );
            case 89:  return makeRegisterExpression(amdgpu_gfx908::s89, output_vec_len );
            case 90:  return makeRegisterExpression(amdgpu_gfx908::s90, output_vec_len );
            case 91:  return makeRegisterExpression(amdgpu_gfx908::s91, output_vec_len );
            case 92:  return makeRegisterExpression(amdgpu_gfx908::s92, output_vec_len );
            case 93:  return makeRegisterExpression(amdgpu_gfx908::s93, output_vec_len );
            case 94:  return makeRegisterExpression(amdgpu_gfx908::s94, output_vec_len );
            case 95:  return makeRegisterExpression(amdgpu_gfx908::s95, output_vec_len );
            case 96:  return makeRegisterExpression(amdgpu_gfx908::s96, output_vec_len );
            case 97:  return makeRegisterExpression(amdgpu_gfx908::s97, output_vec_len );
            case 98:  return makeRegisterExpression(amdgpu_gfx908::s98, output_vec_len );
            case 99:  return makeRegisterExpression(amdgpu_gfx908::s99, output_vec_len );
            case 100:  return makeRegisterExpression(amdgpu_gfx908::s100, output_vec_len );
            case 101:  return makeRegisterExpression(amdgpu_gfx908::s101, output_vec_len );
            case 104:  return makeRegisterExpression(amdgpu_gfx908::xnack_mask_lo, output_vec_len );
            case 105:  return makeRegisterExpression(amdgpu_gfx908::xnack_mask_hi, output_vec_len );
            case 102:  return makeRegisterExpression(amdgpu_gfx908::flat_scratch_lo, output_vec_len );
            case 103:  return makeRegisterExpression(amdgpu_gfx908::flat_scratch_hi, output_vec_len );
            case 108:  return makeRegisterExpression(amdgpu_gfx908::ttmp0, output_vec_len );
            case 109:  return makeRegisterExpression(amdgpu_gfx908::ttmp1, output_vec_len );
            case 110:  return makeRegisterExpression(amdgpu_gfx908::ttmp2, output_vec_len );
            case 111:  return makeRegisterExpression(amdgpu_gfx908::ttmp3, output_vec_len );
            case 112:  return makeRegisterExpression(amdgpu_gfx908::ttmp4, output_vec_len );
            case 113:  return makeRegisterExpression(amdgpu_gfx908::ttmp5, output_vec_len );
            case 114:  return makeRegisterExpression(amdgpu_gfx908::ttmp6, output_vec_len );
            case 115:  return makeRegisterExpression(amdgpu_gfx908::ttmp7, output_vec_len );
            case 116:  return makeRegisterExpression(amdgpu_gfx908::ttmp8, output_vec_len );
            case 117:  return makeRegisterExpression(amdgpu_gfx908::ttmp9, output_vec_len );
            case 118:  return makeRegisterExpression(amdgpu_gfx908::ttmp10, output_vec_len );
            case 119:  return makeRegisterExpression(amdgpu_gfx908::ttmp11, output_vec_len );
            case 120:  return makeRegisterExpression(amdgpu_gfx908::ttmp12, output_vec_len );
            case 121:  return makeRegisterExpression(amdgpu_gfx908::ttmp13, output_vec_len );
            case 122:  return makeRegisterExpression(amdgpu_gfx908::ttmp14, output_vec_len );
            case 123:  return makeRegisterExpression(amdgpu_gfx908::ttmp15, output_vec_len );
            case 106:  return makeRegisterExpression(amdgpu_gfx908::vcc_lo, output_vec_len );
            case 107:  return makeRegisterExpression(amdgpu_gfx908::vcc_hi, output_vec_len );
            case 124:  return makeRegisterExpression(amdgpu_gfx908::m0, output_vec_len );
            case 126:  return makeRegisterExpression(amdgpu_gfx908::exec_lo, output_vec_len );
            case 127:  return makeRegisterExpression(amdgpu_gfx908::exec_hi, output_vec_len );
            case 128:  return Immediate::makeImmediate(Result(u32, 0));
            case 129:  return Immediate::makeImmediate(Result(u32, 1));
            case 130:  return Immediate::makeImmediate(Result(u32, 2));
            case 131:  return Immediate::makeImmediate(Result(u32, 3));
            case 132:  return Immediate::makeImmediate(Result(u32, 4));
            case 133:  return Immediate::makeImmediate(Result(u32, 5));
            case 134:  return Immediate::makeImmediate(Result(u32, 6));
            case 135:  return Immediate::makeImmediate(Result(u32, 7));
            case 136:  return Immediate::makeImmediate(Result(u32, 8));
            case 137:  return Immediate::makeImmediate(Result(u32, 9));
            case 138:  return Immediate::makeImmediate(Result(u32, 10));
            case 139:  return Immediate::makeImmediate(Result(u32, 11));
            case 140:  return Immediate::makeImmediate(Result(u32, 12));
            case 141:  return Immediate::makeImmediate(Result(u32, 13));
            case 142:  return Immediate::makeImmediate(Result(u32, 14));
            case 143:  return Immediate::makeImmediate(Result(u32, 15));
            case 144:  return Immediate::makeImmediate(Result(u32, 16));
            case 145:  return Immediate::makeImmediate(Result(u32, 17));
            case 146:  return Immediate::makeImmediate(Result(u32, 18));
            case 147:  return Immediate::makeImmediate(Result(u32, 19));
            case 148:  return Immediate::makeImmediate(Result(u32, 20));
            case 149:  return Immediate::makeImmediate(Result(u32, 21));
            case 150:  return Immediate::makeImmediate(Result(u32, 22));
            case 151:  return Immediate::makeImmediate(Result(u32, 23));
            case 152:  return Immediate::makeImmediate(Result(u32, 24));
            case 153:  return Immediate::makeImmediate(Result(u32, 25));
            case 154:  return Immediate::makeImmediate(Result(u32, 26));
            case 155:  return Immediate::makeImmediate(Result(u32, 27));
            case 156:  return Immediate::makeImmediate(Result(u32, 28));
            case 157:  return Immediate::makeImmediate(Result(u32, 29));
            case 158:  return Immediate::makeImmediate(Result(u32, 30));
            case 159:  return Immediate::makeImmediate(Result(u32, 31));
            case 160:  return Immediate::makeImmediate(Result(u32, 32));
            case 161:  return Immediate::makeImmediate(Result(u32, 33));
            case 162:  return Immediate::makeImmediate(Result(u32, 34));
            case 163:  return Immediate::makeImmediate(Result(u32, 35));
            case 164:  return Immediate::makeImmediate(Result(u32, 36));
            case 165:  return Immediate::makeImmediate(Result(u32, 37));
            case 166:  return Immediate::makeImmediate(Result(u32, 38));
            case 167:  return Immediate::makeImmediate(Result(u32, 39));
            case 168:  return Immediate::makeImmediate(Result(u32, 40));
            case 169:  return Immediate::makeImmediate(Result(u32, 41));
            case 170:  return Immediate::makeImmediate(Result(u32, 42));
            case 171:  return Immediate::makeImmediate(Result(u32, 43));
            case 172:  return Immediate::makeImmediate(Result(u32, 44));
            case 173:  return Immediate::makeImmediate(Result(u32, 45));
            case 174:  return Immediate::makeImmediate(Result(u32, 46));
            case 175:  return Immediate::makeImmediate(Result(u32, 47));
            case 176:  return Immediate::makeImmediate(Result(u32, 48));
            case 177:  return Immediate::makeImmediate(Result(u32, 49));
            case 178:  return Immediate::makeImmediate(Result(u32, 50));
            case 179:  return Immediate::makeImmediate(Result(u32, 51));
            case 180:  return Immediate::makeImmediate(Result(u32, 52));
            case 181:  return Immediate::makeImmediate(Result(u32, 53));
            case 182:  return Immediate::makeImmediate(Result(u32, 54));
            case 183:  return Immediate::makeImmediate(Result(u32, 55));
            case 184:  return Immediate::makeImmediate(Result(u32, 56));
            case 185:  return Immediate::makeImmediate(Result(u32, 57));
            case 186:  return Immediate::makeImmediate(Result(u32, 58));
            case 187:  return Immediate::makeImmediate(Result(u32, 59));
            case 188:  return Immediate::makeImmediate(Result(u32, 60));
            case 189:  return Immediate::makeImmediate(Result(u32, 61));
            case 190:  return Immediate::makeImmediate(Result(u32, 62));
            case 191:  return Immediate::makeImmediate(Result(u32, 63));
            case 192:  return Immediate::makeImmediate(Result(u32, 64));
            case 193:  return Immediate::makeImmediate(Result(u32, -1));
            case 194:  return Immediate::makeImmediate(Result(u32, -2));
            case 195:  return Immediate::makeImmediate(Result(u32, -3));
            case 196:  return Immediate::makeImmediate(Result(u32, -4));
            case 197:  return Immediate::makeImmediate(Result(u32, -5));
            case 198:  return Immediate::makeImmediate(Result(u32, -6));
            case 199:  return Immediate::makeImmediate(Result(u32, -7));
            case 200:  return Immediate::makeImmediate(Result(u32, -8));
            case 201:  return Immediate::makeImmediate(Result(u32, -9));
            case 202:  return Immediate::makeImmediate(Result(u32, -10));
            case 203:  return Immediate::makeImmediate(Result(u32, -11));
            case 204:  return Immediate::makeImmediate(Result(u32, -12));
            case 205:  return Immediate::makeImmediate(Result(u32, -13));
            case 206:  return Immediate::makeImmediate(Result(u32, -14));
            case 207:  return Immediate::makeImmediate(Result(u32, -15));
            case 208:  return Immediate::makeImmediate(Result(u32, -16));
            case 240:  return Immediate::makeImmediate(Result(sp_float, 0.5));
            case 241:  return Immediate::makeImmediate(Result(sp_float, -0.5));
            case 242:  return Immediate::makeImmediate(Result(sp_float, 1.0));
            case 243:  return Immediate::makeImmediate(Result(sp_float, -1.0));
            case 244:  return Immediate::makeImmediate(Result(sp_float, 2.0));
            case 245:  return Immediate::makeImmediate(Result(sp_float, -2.0));
            case 246:  return Immediate::makeImmediate(Result(sp_float, 4.0));
            case 247:  return Immediate::makeImmediate(Result(sp_float, -4.0));
            case 248:  return Immediate::makeImmediate(Result(sp_float, 0.15915494));
            case 251:  return makeRegisterExpression(amdgpu_gfx908::src_vccz, output_vec_len );
            case 252:  return makeRegisterExpression(amdgpu_gfx908::src_execz, output_vec_len );
            case 253:  return makeRegisterExpression(amdgpu_gfx908::src_scc, output_vec_len );
            case 235:  return makeRegisterExpression(amdgpu_gfx908::src_shared_base, output_vec_len );
            case 236:  return makeRegisterExpression(amdgpu_gfx908::src_shared_limit, output_vec_len );
            case 237:  return makeRegisterExpression(amdgpu_gfx908::src_private_base, output_vec_len );
            case 238:  return makeRegisterExpression(amdgpu_gfx908::src_private_limit, output_vec_len );
            case 239:  return makeRegisterExpression(amdgpu_gfx908::src_pops_exiting_wave_id, output_vec_len );
            case 255:  return Immediate::makeImmediate(Result(u32,decodeOPR_LITERAL()));
            case 249 :  return decodeOPR_SDWA();
            default: return makeRegisterExpression(amdgpu_gfx908::invalid);
        }
    }

    Expression::Ptr InstructionDecoder_amdgpu_gfx908::decodeOPR_SSRC_LANESEL(uint64_t input, uint32_t output_vec_len)
    {
        switch (input)  {
            case 0:  return makeRegisterExpression(amdgpu_gfx908::s0, output_vec_len );
            case 1:  return makeRegisterExpression(amdgpu_gfx908::s1, output_vec_len );
            case 2:  return makeRegisterExpression(amdgpu_gfx908::s2, output_vec_len );
            case 3:  return makeRegisterExpression(amdgpu_gfx908::s3, output_vec_len );
            case 4:  return makeRegisterExpression(amdgpu_gfx908::s4, output_vec_len );
            case 5:  return makeRegisterExpression(amdgpu_gfx908::s5, output_vec_len );
            case 6:  return makeRegisterExpression(amdgpu_gfx908::s6, output_vec_len );
            case 7:  return makeRegisterExpression(amdgpu_gfx908::s7, output_vec_len );
            case 8:  return makeRegisterExpression(amdgpu_gfx908::s8, output_vec_len );
            case 9:  return makeRegisterExpression(amdgpu_gfx908::s9, output_vec_len );
            case 10:  return makeRegisterExpression(amdgpu_gfx908::s10, output_vec_len );
            case 11:  return makeRegisterExpression(amdgpu_gfx908::s11, output_vec_len );
            case 12:  return makeRegisterExpression(amdgpu_gfx908::s12, output_vec_len );
            case 13:  return makeRegisterExpression(amdgpu_gfx908::s13, output_vec_len );
            case 14:  return makeRegisterExpression(amdgpu_gfx908::s14, output_vec_len );
            case 15:  return makeRegisterExpression(amdgpu_gfx908::s15, output_vec_len );
            case 16:  return makeRegisterExpression(amdgpu_gfx908::s16, output_vec_len );
            case 17:  return makeRegisterExpression(amdgpu_gfx908::s17, output_vec_len );
            case 18:  return makeRegisterExpression(amdgpu_gfx908::s18, output_vec_len );
            case 19:  return makeRegisterExpression(amdgpu_gfx908::s19, output_vec_len );
            case 20:  return makeRegisterExpression(amdgpu_gfx908::s20, output_vec_len );
            case 21:  return makeRegisterExpression(amdgpu_gfx908::s21, output_vec_len );
            case 22:  return makeRegisterExpression(amdgpu_gfx908::s22, output_vec_len );
            case 23:  return makeRegisterExpression(amdgpu_gfx908::s23, output_vec_len );
            case 24:  return makeRegisterExpression(amdgpu_gfx908::s24, output_vec_len );
            case 25:  return makeRegisterExpression(amdgpu_gfx908::s25, output_vec_len );
            case 26:  return makeRegisterExpression(amdgpu_gfx908::s26, output_vec_len );
            case 27:  return makeRegisterExpression(amdgpu_gfx908::s27, output_vec_len );
            case 28:  return makeRegisterExpression(amdgpu_gfx908::s28, output_vec_len );
            case 29:  return makeRegisterExpression(amdgpu_gfx908::s29, output_vec_len );
            case 30:  return makeRegisterExpression(amdgpu_gfx908::s30, output_vec_len );
            case 31:  return makeRegisterExpression(amdgpu_gfx908::s31, output_vec_len );
            case 32:  return makeRegisterExpression(amdgpu_gfx908::s32, output_vec_len );
            case 33:  return makeRegisterExpression(amdgpu_gfx908::s33, output_vec_len );
            case 34:  return makeRegisterExpression(amdgpu_gfx908::s34, output_vec_len );
            case 35:  return makeRegisterExpression(amdgpu_gfx908::s35, output_vec_len );
            case 36:  return makeRegisterExpression(amdgpu_gfx908::s36, output_vec_len );
            case 37:  return makeRegisterExpression(amdgpu_gfx908::s37, output_vec_len );
            case 38:  return makeRegisterExpression(amdgpu_gfx908::s38, output_vec_len );
            case 39:  return makeRegisterExpression(amdgpu_gfx908::s39, output_vec_len );
            case 40:  return makeRegisterExpression(amdgpu_gfx908::s40, output_vec_len );
            case 41:  return makeRegisterExpression(amdgpu_gfx908::s41, output_vec_len );
            case 42:  return makeRegisterExpression(amdgpu_gfx908::s42, output_vec_len );
            case 43:  return makeRegisterExpression(amdgpu_gfx908::s43, output_vec_len );
            case 44:  return makeRegisterExpression(amdgpu_gfx908::s44, output_vec_len );
            case 45:  return makeRegisterExpression(amdgpu_gfx908::s45, output_vec_len );
            case 46:  return makeRegisterExpression(amdgpu_gfx908::s46, output_vec_len );
            case 47:  return makeRegisterExpression(amdgpu_gfx908::s47, output_vec_len );
            case 48:  return makeRegisterExpression(amdgpu_gfx908::s48, output_vec_len );
            case 49:  return makeRegisterExpression(amdgpu_gfx908::s49, output_vec_len );
            case 50:  return makeRegisterExpression(amdgpu_gfx908::s50, output_vec_len );
            case 51:  return makeRegisterExpression(amdgpu_gfx908::s51, output_vec_len );
            case 52:  return makeRegisterExpression(amdgpu_gfx908::s52, output_vec_len );
            case 53:  return makeRegisterExpression(amdgpu_gfx908::s53, output_vec_len );
            case 54:  return makeRegisterExpression(amdgpu_gfx908::s54, output_vec_len );
            case 55:  return makeRegisterExpression(amdgpu_gfx908::s55, output_vec_len );
            case 56:  return makeRegisterExpression(amdgpu_gfx908::s56, output_vec_len );
            case 57:  return makeRegisterExpression(amdgpu_gfx908::s57, output_vec_len );
            case 58:  return makeRegisterExpression(amdgpu_gfx908::s58, output_vec_len );
            case 59:  return makeRegisterExpression(amdgpu_gfx908::s59, output_vec_len );
            case 60:  return makeRegisterExpression(amdgpu_gfx908::s60, output_vec_len );
            case 61:  return makeRegisterExpression(amdgpu_gfx908::s61, output_vec_len );
            case 62:  return makeRegisterExpression(amdgpu_gfx908::s62, output_vec_len );
            case 63:  return makeRegisterExpression(amdgpu_gfx908::s63, output_vec_len );
            case 64:  return makeRegisterExpression(amdgpu_gfx908::s64, output_vec_len );
            case 65:  return makeRegisterExpression(amdgpu_gfx908::s65, output_vec_len );
            case 66:  return makeRegisterExpression(amdgpu_gfx908::s66, output_vec_len );
            case 67:  return makeRegisterExpression(amdgpu_gfx908::s67, output_vec_len );
            case 68:  return makeRegisterExpression(amdgpu_gfx908::s68, output_vec_len );
            case 69:  return makeRegisterExpression(amdgpu_gfx908::s69, output_vec_len );
            case 70:  return makeRegisterExpression(amdgpu_gfx908::s70, output_vec_len );
            case 71:  return makeRegisterExpression(amdgpu_gfx908::s71, output_vec_len );
            case 72:  return makeRegisterExpression(amdgpu_gfx908::s72, output_vec_len );
            case 73:  return makeRegisterExpression(amdgpu_gfx908::s73, output_vec_len );
            case 74:  return makeRegisterExpression(amdgpu_gfx908::s74, output_vec_len );
            case 75:  return makeRegisterExpression(amdgpu_gfx908::s75, output_vec_len );
            case 76:  return makeRegisterExpression(amdgpu_gfx908::s76, output_vec_len );
            case 77:  return makeRegisterExpression(amdgpu_gfx908::s77, output_vec_len );
            case 78:  return makeRegisterExpression(amdgpu_gfx908::s78, output_vec_len );
            case 79:  return makeRegisterExpression(amdgpu_gfx908::s79, output_vec_len );
            case 80:  return makeRegisterExpression(amdgpu_gfx908::s80, output_vec_len );
            case 81:  return makeRegisterExpression(amdgpu_gfx908::s81, output_vec_len );
            case 82:  return makeRegisterExpression(amdgpu_gfx908::s82, output_vec_len );
            case 83:  return makeRegisterExpression(amdgpu_gfx908::s83, output_vec_len );
            case 84:  return makeRegisterExpression(amdgpu_gfx908::s84, output_vec_len );
            case 85:  return makeRegisterExpression(amdgpu_gfx908::s85, output_vec_len );
            case 86:  return makeRegisterExpression(amdgpu_gfx908::s86, output_vec_len );
            case 87:  return makeRegisterExpression(amdgpu_gfx908::s87, output_vec_len );
            case 88:  return makeRegisterExpression(amdgpu_gfx908::s88, output_vec_len );
            case 89:  return makeRegisterExpression(amdgpu_gfx908::s89, output_vec_len );
            case 90:  return makeRegisterExpression(amdgpu_gfx908::s90, output_vec_len );
            case 91:  return makeRegisterExpression(amdgpu_gfx908::s91, output_vec_len );
            case 92:  return makeRegisterExpression(amdgpu_gfx908::s92, output_vec_len );
            case 93:  return makeRegisterExpression(amdgpu_gfx908::s93, output_vec_len );
            case 94:  return makeRegisterExpression(amdgpu_gfx908::s94, output_vec_len );
            case 95:  return makeRegisterExpression(amdgpu_gfx908::s95, output_vec_len );
            case 96:  return makeRegisterExpression(amdgpu_gfx908::s96, output_vec_len );
            case 97:  return makeRegisterExpression(amdgpu_gfx908::s97, output_vec_len );
            case 98:  return makeRegisterExpression(amdgpu_gfx908::s98, output_vec_len );
            case 99:  return makeRegisterExpression(amdgpu_gfx908::s99, output_vec_len );
            case 100:  return makeRegisterExpression(amdgpu_gfx908::s100, output_vec_len );
            case 101:  return makeRegisterExpression(amdgpu_gfx908::s101, output_vec_len );
            case 104:  return makeRegisterExpression(amdgpu_gfx908::xnack_mask_lo, output_vec_len );
            case 105:  return makeRegisterExpression(amdgpu_gfx908::xnack_mask_hi, output_vec_len );
            case 102:  return makeRegisterExpression(amdgpu_gfx908::flat_scratch_lo, output_vec_len );
            case 103:  return makeRegisterExpression(amdgpu_gfx908::flat_scratch_hi, output_vec_len );
            case 108:  return makeRegisterExpression(amdgpu_gfx908::ttmp0, output_vec_len );
            case 109:  return makeRegisterExpression(amdgpu_gfx908::ttmp1, output_vec_len );
            case 110:  return makeRegisterExpression(amdgpu_gfx908::ttmp2, output_vec_len );
            case 111:  return makeRegisterExpression(amdgpu_gfx908::ttmp3, output_vec_len );
            case 112:  return makeRegisterExpression(amdgpu_gfx908::ttmp4, output_vec_len );
            case 113:  return makeRegisterExpression(amdgpu_gfx908::ttmp5, output_vec_len );
            case 114:  return makeRegisterExpression(amdgpu_gfx908::ttmp6, output_vec_len );
            case 115:  return makeRegisterExpression(amdgpu_gfx908::ttmp7, output_vec_len );
            case 116:  return makeRegisterExpression(amdgpu_gfx908::ttmp8, output_vec_len );
            case 117:  return makeRegisterExpression(amdgpu_gfx908::ttmp9, output_vec_len );
            case 118:  return makeRegisterExpression(amdgpu_gfx908::ttmp10, output_vec_len );
            case 119:  return makeRegisterExpression(amdgpu_gfx908::ttmp11, output_vec_len );
            case 120:  return makeRegisterExpression(amdgpu_gfx908::ttmp12, output_vec_len );
            case 121:  return makeRegisterExpression(amdgpu_gfx908::ttmp13, output_vec_len );
            case 122:  return makeRegisterExpression(amdgpu_gfx908::ttmp14, output_vec_len );
            case 123:  return makeRegisterExpression(amdgpu_gfx908::ttmp15, output_vec_len );
            case 106:  return makeRegisterExpression(amdgpu_gfx908::vcc_lo, output_vec_len );
            case 107:  return makeRegisterExpression(amdgpu_gfx908::vcc_hi, output_vec_len );
            case 124:  return makeRegisterExpression(amdgpu_gfx908::m0, output_vec_len );
            case 128:  return Immediate::makeImmediate(Result(u32, 0));
            case 129:  return Immediate::makeImmediate(Result(u32, 1));
            case 130:  return Immediate::makeImmediate(Result(u32, 2));
            case 131:  return Immediate::makeImmediate(Result(u32, 3));
            case 132:  return Immediate::makeImmediate(Result(u32, 4));
            case 133:  return Immediate::makeImmediate(Result(u32, 5));
            case 134:  return Immediate::makeImmediate(Result(u32, 6));
            case 135:  return Immediate::makeImmediate(Result(u32, 7));
            case 136:  return Immediate::makeImmediate(Result(u32, 8));
            case 137:  return Immediate::makeImmediate(Result(u32, 9));
            case 138:  return Immediate::makeImmediate(Result(u32, 10));
            case 139:  return Immediate::makeImmediate(Result(u32, 11));
            case 140:  return Immediate::makeImmediate(Result(u32, 12));
            case 141:  return Immediate::makeImmediate(Result(u32, 13));
            case 142:  return Immediate::makeImmediate(Result(u32, 14));
            case 143:  return Immediate::makeImmediate(Result(u32, 15));
            case 144:  return Immediate::makeImmediate(Result(u32, 16));
            case 145:  return Immediate::makeImmediate(Result(u32, 17));
            case 146:  return Immediate::makeImmediate(Result(u32, 18));
            case 147:  return Immediate::makeImmediate(Result(u32, 19));
            case 148:  return Immediate::makeImmediate(Result(u32, 20));
            case 149:  return Immediate::makeImmediate(Result(u32, 21));
            case 150:  return Immediate::makeImmediate(Result(u32, 22));
            case 151:  return Immediate::makeImmediate(Result(u32, 23));
            case 152:  return Immediate::makeImmediate(Result(u32, 24));
            case 153:  return Immediate::makeImmediate(Result(u32, 25));
            case 154:  return Immediate::makeImmediate(Result(u32, 26));
            case 155:  return Immediate::makeImmediate(Result(u32, 27));
            case 156:  return Immediate::makeImmediate(Result(u32, 28));
            case 157:  return Immediate::makeImmediate(Result(u32, 29));
            case 158:  return Immediate::makeImmediate(Result(u32, 30));
            case 159:  return Immediate::makeImmediate(Result(u32, 31));
            case 160:  return Immediate::makeImmediate(Result(u32, 32));
            case 161:  return Immediate::makeImmediate(Result(u32, 33));
            case 162:  return Immediate::makeImmediate(Result(u32, 34));
            case 163:  return Immediate::makeImmediate(Result(u32, 35));
            case 164:  return Immediate::makeImmediate(Result(u32, 36));
            case 165:  return Immediate::makeImmediate(Result(u32, 37));
            case 166:  return Immediate::makeImmediate(Result(u32, 38));
            case 167:  return Immediate::makeImmediate(Result(u32, 39));
            case 168:  return Immediate::makeImmediate(Result(u32, 40));
            case 169:  return Immediate::makeImmediate(Result(u32, 41));
            case 170:  return Immediate::makeImmediate(Result(u32, 42));
            case 171:  return Immediate::makeImmediate(Result(u32, 43));
            case 172:  return Immediate::makeImmediate(Result(u32, 44));
            case 173:  return Immediate::makeImmediate(Result(u32, 45));
            case 174:  return Immediate::makeImmediate(Result(u32, 46));
            case 175:  return Immediate::makeImmediate(Result(u32, 47));
            case 176:  return Immediate::makeImmediate(Result(u32, 48));
            case 177:  return Immediate::makeImmediate(Result(u32, 49));
            case 178:  return Immediate::makeImmediate(Result(u32, 50));
            case 179:  return Immediate::makeImmediate(Result(u32, 51));
            case 180:  return Immediate::makeImmediate(Result(u32, 52));
            case 181:  return Immediate::makeImmediate(Result(u32, 53));
            case 182:  return Immediate::makeImmediate(Result(u32, 54));
            case 183:  return Immediate::makeImmediate(Result(u32, 55));
            case 184:  return Immediate::makeImmediate(Result(u32, 56));
            case 185:  return Immediate::makeImmediate(Result(u32, 57));
            case 186:  return Immediate::makeImmediate(Result(u32, 58));
            case 187:  return Immediate::makeImmediate(Result(u32, 59));
            case 188:  return Immediate::makeImmediate(Result(u32, 60));
            case 189:  return Immediate::makeImmediate(Result(u32, 61));
            case 190:  return Immediate::makeImmediate(Result(u32, 62));
            case 191:  return Immediate::makeImmediate(Result(u32, 63));
            default: return makeRegisterExpression(amdgpu_gfx908::invalid);
        }
    }

    Expression::Ptr InstructionDecoder_amdgpu_gfx908::decodeOPR_SSRC_NOLIT(uint64_t input, uint32_t output_vec_len)
    {
        switch (input)  {
            case 0:  return makeRegisterExpression(amdgpu_gfx908::s0, output_vec_len );
            case 1:  return makeRegisterExpression(amdgpu_gfx908::s1, output_vec_len );
            case 2:  return makeRegisterExpression(amdgpu_gfx908::s2, output_vec_len );
            case 3:  return makeRegisterExpression(amdgpu_gfx908::s3, output_vec_len );
            case 4:  return makeRegisterExpression(amdgpu_gfx908::s4, output_vec_len );
            case 5:  return makeRegisterExpression(amdgpu_gfx908::s5, output_vec_len );
            case 6:  return makeRegisterExpression(amdgpu_gfx908::s6, output_vec_len );
            case 7:  return makeRegisterExpression(amdgpu_gfx908::s7, output_vec_len );
            case 8:  return makeRegisterExpression(amdgpu_gfx908::s8, output_vec_len );
            case 9:  return makeRegisterExpression(amdgpu_gfx908::s9, output_vec_len );
            case 10:  return makeRegisterExpression(amdgpu_gfx908::s10, output_vec_len );
            case 11:  return makeRegisterExpression(amdgpu_gfx908::s11, output_vec_len );
            case 12:  return makeRegisterExpression(amdgpu_gfx908::s12, output_vec_len );
            case 13:  return makeRegisterExpression(amdgpu_gfx908::s13, output_vec_len );
            case 14:  return makeRegisterExpression(amdgpu_gfx908::s14, output_vec_len );
            case 15:  return makeRegisterExpression(amdgpu_gfx908::s15, output_vec_len );
            case 16:  return makeRegisterExpression(amdgpu_gfx908::s16, output_vec_len );
            case 17:  return makeRegisterExpression(amdgpu_gfx908::s17, output_vec_len );
            case 18:  return makeRegisterExpression(amdgpu_gfx908::s18, output_vec_len );
            case 19:  return makeRegisterExpression(amdgpu_gfx908::s19, output_vec_len );
            case 20:  return makeRegisterExpression(amdgpu_gfx908::s20, output_vec_len );
            case 21:  return makeRegisterExpression(amdgpu_gfx908::s21, output_vec_len );
            case 22:  return makeRegisterExpression(amdgpu_gfx908::s22, output_vec_len );
            case 23:  return makeRegisterExpression(amdgpu_gfx908::s23, output_vec_len );
            case 24:  return makeRegisterExpression(amdgpu_gfx908::s24, output_vec_len );
            case 25:  return makeRegisterExpression(amdgpu_gfx908::s25, output_vec_len );
            case 26:  return makeRegisterExpression(amdgpu_gfx908::s26, output_vec_len );
            case 27:  return makeRegisterExpression(amdgpu_gfx908::s27, output_vec_len );
            case 28:  return makeRegisterExpression(amdgpu_gfx908::s28, output_vec_len );
            case 29:  return makeRegisterExpression(amdgpu_gfx908::s29, output_vec_len );
            case 30:  return makeRegisterExpression(amdgpu_gfx908::s30, output_vec_len );
            case 31:  return makeRegisterExpression(amdgpu_gfx908::s31, output_vec_len );
            case 32:  return makeRegisterExpression(amdgpu_gfx908::s32, output_vec_len );
            case 33:  return makeRegisterExpression(amdgpu_gfx908::s33, output_vec_len );
            case 34:  return makeRegisterExpression(amdgpu_gfx908::s34, output_vec_len );
            case 35:  return makeRegisterExpression(amdgpu_gfx908::s35, output_vec_len );
            case 36:  return makeRegisterExpression(amdgpu_gfx908::s36, output_vec_len );
            case 37:  return makeRegisterExpression(amdgpu_gfx908::s37, output_vec_len );
            case 38:  return makeRegisterExpression(amdgpu_gfx908::s38, output_vec_len );
            case 39:  return makeRegisterExpression(amdgpu_gfx908::s39, output_vec_len );
            case 40:  return makeRegisterExpression(amdgpu_gfx908::s40, output_vec_len );
            case 41:  return makeRegisterExpression(amdgpu_gfx908::s41, output_vec_len );
            case 42:  return makeRegisterExpression(amdgpu_gfx908::s42, output_vec_len );
            case 43:  return makeRegisterExpression(amdgpu_gfx908::s43, output_vec_len );
            case 44:  return makeRegisterExpression(amdgpu_gfx908::s44, output_vec_len );
            case 45:  return makeRegisterExpression(amdgpu_gfx908::s45, output_vec_len );
            case 46:  return makeRegisterExpression(amdgpu_gfx908::s46, output_vec_len );
            case 47:  return makeRegisterExpression(amdgpu_gfx908::s47, output_vec_len );
            case 48:  return makeRegisterExpression(amdgpu_gfx908::s48, output_vec_len );
            case 49:  return makeRegisterExpression(amdgpu_gfx908::s49, output_vec_len );
            case 50:  return makeRegisterExpression(amdgpu_gfx908::s50, output_vec_len );
            case 51:  return makeRegisterExpression(amdgpu_gfx908::s51, output_vec_len );
            case 52:  return makeRegisterExpression(amdgpu_gfx908::s52, output_vec_len );
            case 53:  return makeRegisterExpression(amdgpu_gfx908::s53, output_vec_len );
            case 54:  return makeRegisterExpression(amdgpu_gfx908::s54, output_vec_len );
            case 55:  return makeRegisterExpression(amdgpu_gfx908::s55, output_vec_len );
            case 56:  return makeRegisterExpression(amdgpu_gfx908::s56, output_vec_len );
            case 57:  return makeRegisterExpression(amdgpu_gfx908::s57, output_vec_len );
            case 58:  return makeRegisterExpression(amdgpu_gfx908::s58, output_vec_len );
            case 59:  return makeRegisterExpression(amdgpu_gfx908::s59, output_vec_len );
            case 60:  return makeRegisterExpression(amdgpu_gfx908::s60, output_vec_len );
            case 61:  return makeRegisterExpression(amdgpu_gfx908::s61, output_vec_len );
            case 62:  return makeRegisterExpression(amdgpu_gfx908::s62, output_vec_len );
            case 63:  return makeRegisterExpression(amdgpu_gfx908::s63, output_vec_len );
            case 64:  return makeRegisterExpression(amdgpu_gfx908::s64, output_vec_len );
            case 65:  return makeRegisterExpression(amdgpu_gfx908::s65, output_vec_len );
            case 66:  return makeRegisterExpression(amdgpu_gfx908::s66, output_vec_len );
            case 67:  return makeRegisterExpression(amdgpu_gfx908::s67, output_vec_len );
            case 68:  return makeRegisterExpression(amdgpu_gfx908::s68, output_vec_len );
            case 69:  return makeRegisterExpression(amdgpu_gfx908::s69, output_vec_len );
            case 70:  return makeRegisterExpression(amdgpu_gfx908::s70, output_vec_len );
            case 71:  return makeRegisterExpression(amdgpu_gfx908::s71, output_vec_len );
            case 72:  return makeRegisterExpression(amdgpu_gfx908::s72, output_vec_len );
            case 73:  return makeRegisterExpression(amdgpu_gfx908::s73, output_vec_len );
            case 74:  return makeRegisterExpression(amdgpu_gfx908::s74, output_vec_len );
            case 75:  return makeRegisterExpression(amdgpu_gfx908::s75, output_vec_len );
            case 76:  return makeRegisterExpression(amdgpu_gfx908::s76, output_vec_len );
            case 77:  return makeRegisterExpression(amdgpu_gfx908::s77, output_vec_len );
            case 78:  return makeRegisterExpression(amdgpu_gfx908::s78, output_vec_len );
            case 79:  return makeRegisterExpression(amdgpu_gfx908::s79, output_vec_len );
            case 80:  return makeRegisterExpression(amdgpu_gfx908::s80, output_vec_len );
            case 81:  return makeRegisterExpression(amdgpu_gfx908::s81, output_vec_len );
            case 82:  return makeRegisterExpression(amdgpu_gfx908::s82, output_vec_len );
            case 83:  return makeRegisterExpression(amdgpu_gfx908::s83, output_vec_len );
            case 84:  return makeRegisterExpression(amdgpu_gfx908::s84, output_vec_len );
            case 85:  return makeRegisterExpression(amdgpu_gfx908::s85, output_vec_len );
            case 86:  return makeRegisterExpression(amdgpu_gfx908::s86, output_vec_len );
            case 87:  return makeRegisterExpression(amdgpu_gfx908::s87, output_vec_len );
            case 88:  return makeRegisterExpression(amdgpu_gfx908::s88, output_vec_len );
            case 89:  return makeRegisterExpression(amdgpu_gfx908::s89, output_vec_len );
            case 90:  return makeRegisterExpression(amdgpu_gfx908::s90, output_vec_len );
            case 91:  return makeRegisterExpression(amdgpu_gfx908::s91, output_vec_len );
            case 92:  return makeRegisterExpression(amdgpu_gfx908::s92, output_vec_len );
            case 93:  return makeRegisterExpression(amdgpu_gfx908::s93, output_vec_len );
            case 94:  return makeRegisterExpression(amdgpu_gfx908::s94, output_vec_len );
            case 95:  return makeRegisterExpression(amdgpu_gfx908::s95, output_vec_len );
            case 96:  return makeRegisterExpression(amdgpu_gfx908::s96, output_vec_len );
            case 97:  return makeRegisterExpression(amdgpu_gfx908::s97, output_vec_len );
            case 98:  return makeRegisterExpression(amdgpu_gfx908::s98, output_vec_len );
            case 99:  return makeRegisterExpression(amdgpu_gfx908::s99, output_vec_len );
            case 100:  return makeRegisterExpression(amdgpu_gfx908::s100, output_vec_len );
            case 101:  return makeRegisterExpression(amdgpu_gfx908::s101, output_vec_len );
            case 104:  return makeRegisterExpression(amdgpu_gfx908::xnack_mask_lo, output_vec_len );
            case 105:  return makeRegisterExpression(amdgpu_gfx908::xnack_mask_hi, output_vec_len );
            case 102:  return makeRegisterExpression(amdgpu_gfx908::flat_scratch_lo, output_vec_len );
            case 103:  return makeRegisterExpression(amdgpu_gfx908::flat_scratch_hi, output_vec_len );
            case 108:  return makeRegisterExpression(amdgpu_gfx908::ttmp0, output_vec_len );
            case 109:  return makeRegisterExpression(amdgpu_gfx908::ttmp1, output_vec_len );
            case 110:  return makeRegisterExpression(amdgpu_gfx908::ttmp2, output_vec_len );
            case 111:  return makeRegisterExpression(amdgpu_gfx908::ttmp3, output_vec_len );
            case 112:  return makeRegisterExpression(amdgpu_gfx908::ttmp4, output_vec_len );
            case 113:  return makeRegisterExpression(amdgpu_gfx908::ttmp5, output_vec_len );
            case 114:  return makeRegisterExpression(amdgpu_gfx908::ttmp6, output_vec_len );
            case 115:  return makeRegisterExpression(amdgpu_gfx908::ttmp7, output_vec_len );
            case 116:  return makeRegisterExpression(amdgpu_gfx908::ttmp8, output_vec_len );
            case 117:  return makeRegisterExpression(amdgpu_gfx908::ttmp9, output_vec_len );
            case 118:  return makeRegisterExpression(amdgpu_gfx908::ttmp10, output_vec_len );
            case 119:  return makeRegisterExpression(amdgpu_gfx908::ttmp11, output_vec_len );
            case 120:  return makeRegisterExpression(amdgpu_gfx908::ttmp12, output_vec_len );
            case 121:  return makeRegisterExpression(amdgpu_gfx908::ttmp13, output_vec_len );
            case 122:  return makeRegisterExpression(amdgpu_gfx908::ttmp14, output_vec_len );
            case 123:  return makeRegisterExpression(amdgpu_gfx908::ttmp15, output_vec_len );
            case 106:  return makeRegisterExpression(amdgpu_gfx908::vcc_lo, output_vec_len );
            case 107:  return makeRegisterExpression(amdgpu_gfx908::vcc_hi, output_vec_len );
            case 124:  return makeRegisterExpression(amdgpu_gfx908::m0, output_vec_len );
            case 126:  return makeRegisterExpression(amdgpu_gfx908::exec_lo, output_vec_len );
            case 127:  return makeRegisterExpression(amdgpu_gfx908::exec_hi, output_vec_len );
            case 128:  return Immediate::makeImmediate(Result(u32, 0));
            case 129:  return Immediate::makeImmediate(Result(u32, 1));
            case 130:  return Immediate::makeImmediate(Result(u32, 2));
            case 131:  return Immediate::makeImmediate(Result(u32, 3));
            case 132:  return Immediate::makeImmediate(Result(u32, 4));
            case 133:  return Immediate::makeImmediate(Result(u32, 5));
            case 134:  return Immediate::makeImmediate(Result(u32, 6));
            case 135:  return Immediate::makeImmediate(Result(u32, 7));
            case 136:  return Immediate::makeImmediate(Result(u32, 8));
            case 137:  return Immediate::makeImmediate(Result(u32, 9));
            case 138:  return Immediate::makeImmediate(Result(u32, 10));
            case 139:  return Immediate::makeImmediate(Result(u32, 11));
            case 140:  return Immediate::makeImmediate(Result(u32, 12));
            case 141:  return Immediate::makeImmediate(Result(u32, 13));
            case 142:  return Immediate::makeImmediate(Result(u32, 14));
            case 143:  return Immediate::makeImmediate(Result(u32, 15));
            case 144:  return Immediate::makeImmediate(Result(u32, 16));
            case 145:  return Immediate::makeImmediate(Result(u32, 17));
            case 146:  return Immediate::makeImmediate(Result(u32, 18));
            case 147:  return Immediate::makeImmediate(Result(u32, 19));
            case 148:  return Immediate::makeImmediate(Result(u32, 20));
            case 149:  return Immediate::makeImmediate(Result(u32, 21));
            case 150:  return Immediate::makeImmediate(Result(u32, 22));
            case 151:  return Immediate::makeImmediate(Result(u32, 23));
            case 152:  return Immediate::makeImmediate(Result(u32, 24));
            case 153:  return Immediate::makeImmediate(Result(u32, 25));
            case 154:  return Immediate::makeImmediate(Result(u32, 26));
            case 155:  return Immediate::makeImmediate(Result(u32, 27));
            case 156:  return Immediate::makeImmediate(Result(u32, 28));
            case 157:  return Immediate::makeImmediate(Result(u32, 29));
            case 158:  return Immediate::makeImmediate(Result(u32, 30));
            case 159:  return Immediate::makeImmediate(Result(u32, 31));
            case 160:  return Immediate::makeImmediate(Result(u32, 32));
            case 161:  return Immediate::makeImmediate(Result(u32, 33));
            case 162:  return Immediate::makeImmediate(Result(u32, 34));
            case 163:  return Immediate::makeImmediate(Result(u32, 35));
            case 164:  return Immediate::makeImmediate(Result(u32, 36));
            case 165:  return Immediate::makeImmediate(Result(u32, 37));
            case 166:  return Immediate::makeImmediate(Result(u32, 38));
            case 167:  return Immediate::makeImmediate(Result(u32, 39));
            case 168:  return Immediate::makeImmediate(Result(u32, 40));
            case 169:  return Immediate::makeImmediate(Result(u32, 41));
            case 170:  return Immediate::makeImmediate(Result(u32, 42));
            case 171:  return Immediate::makeImmediate(Result(u32, 43));
            case 172:  return Immediate::makeImmediate(Result(u32, 44));
            case 173:  return Immediate::makeImmediate(Result(u32, 45));
            case 174:  return Immediate::makeImmediate(Result(u32, 46));
            case 175:  return Immediate::makeImmediate(Result(u32, 47));
            case 176:  return Immediate::makeImmediate(Result(u32, 48));
            case 177:  return Immediate::makeImmediate(Result(u32, 49));
            case 178:  return Immediate::makeImmediate(Result(u32, 50));
            case 179:  return Immediate::makeImmediate(Result(u32, 51));
            case 180:  return Immediate::makeImmediate(Result(u32, 52));
            case 181:  return Immediate::makeImmediate(Result(u32, 53));
            case 182:  return Immediate::makeImmediate(Result(u32, 54));
            case 183:  return Immediate::makeImmediate(Result(u32, 55));
            case 184:  return Immediate::makeImmediate(Result(u32, 56));
            case 185:  return Immediate::makeImmediate(Result(u32, 57));
            case 186:  return Immediate::makeImmediate(Result(u32, 58));
            case 187:  return Immediate::makeImmediate(Result(u32, 59));
            case 188:  return Immediate::makeImmediate(Result(u32, 60));
            case 189:  return Immediate::makeImmediate(Result(u32, 61));
            case 190:  return Immediate::makeImmediate(Result(u32, 62));
            case 191:  return Immediate::makeImmediate(Result(u32, 63));
            case 192:  return Immediate::makeImmediate(Result(u32, 64));
            case 193:  return Immediate::makeImmediate(Result(u32, -1));
            case 194:  return Immediate::makeImmediate(Result(u32, -2));
            case 195:  return Immediate::makeImmediate(Result(u32, -3));
            case 196:  return Immediate::makeImmediate(Result(u32, -4));
            case 197:  return Immediate::makeImmediate(Result(u32, -5));
            case 198:  return Immediate::makeImmediate(Result(u32, -6));
            case 199:  return Immediate::makeImmediate(Result(u32, -7));
            case 200:  return Immediate::makeImmediate(Result(u32, -8));
            case 201:  return Immediate::makeImmediate(Result(u32, -9));
            case 202:  return Immediate::makeImmediate(Result(u32, -10));
            case 203:  return Immediate::makeImmediate(Result(u32, -11));
            case 204:  return Immediate::makeImmediate(Result(u32, -12));
            case 205:  return Immediate::makeImmediate(Result(u32, -13));
            case 206:  return Immediate::makeImmediate(Result(u32, -14));
            case 207:  return Immediate::makeImmediate(Result(u32, -15));
            case 208:  return Immediate::makeImmediate(Result(u32, -16));
            case 240:  return Immediate::makeImmediate(Result(sp_float, 0.5));
            case 241:  return Immediate::makeImmediate(Result(sp_float, -0.5));
            case 242:  return Immediate::makeImmediate(Result(sp_float, 1.0));
            case 243:  return Immediate::makeImmediate(Result(sp_float, -1.0));
            case 244:  return Immediate::makeImmediate(Result(sp_float, 2.0));
            case 245:  return Immediate::makeImmediate(Result(sp_float, -2.0));
            case 246:  return Immediate::makeImmediate(Result(sp_float, 4.0));
            case 247:  return Immediate::makeImmediate(Result(sp_float, -4.0));
            case 248:  return Immediate::makeImmediate(Result(sp_float, 0.15915494));
            case 251:  return makeRegisterExpression(amdgpu_gfx908::src_vccz, output_vec_len );
            case 252:  return makeRegisterExpression(amdgpu_gfx908::src_execz, output_vec_len );
            case 253:  return makeRegisterExpression(amdgpu_gfx908::src_scc, output_vec_len );
            case 235:  return makeRegisterExpression(amdgpu_gfx908::src_shared_base, output_vec_len );
            case 236:  return makeRegisterExpression(amdgpu_gfx908::src_shared_limit, output_vec_len );
            case 237:  return makeRegisterExpression(amdgpu_gfx908::src_private_base, output_vec_len );
            case 238:  return makeRegisterExpression(amdgpu_gfx908::src_private_limit, output_vec_len );
            case 239:  return makeRegisterExpression(amdgpu_gfx908::src_pops_exiting_wave_id, output_vec_len );
            default: return makeRegisterExpression(amdgpu_gfx908::invalid);
        }
    }

    Expression::Ptr InstructionDecoder_amdgpu_gfx908::decodeOPR_SSRC_SPECIAL_SCC(uint64_t input, uint32_t output_vec_len)
    {
        switch (input)  {
            case 253:  return makeRegisterExpression(amdgpu_gfx908::src_scc, output_vec_len );
            default: return makeRegisterExpression(amdgpu_gfx908::invalid);
        }
    }

    Expression::Ptr InstructionDecoder_amdgpu_gfx908::decodeOPR_TGT(uint64_t input, uint32_t output_vec_len)
    {
        switch (input)  {
            case 0:  return makeRegisterExpression(amdgpu_gfx908::mrt0, output_vec_len );
            case 1:  return makeRegisterExpression(amdgpu_gfx908::mrt1, output_vec_len );
            case 2:  return makeRegisterExpression(amdgpu_gfx908::mrt2, output_vec_len );
            case 3:  return makeRegisterExpression(amdgpu_gfx908::mrt3, output_vec_len );
            case 4:  return makeRegisterExpression(amdgpu_gfx908::mrt4, output_vec_len );
            case 5:  return makeRegisterExpression(amdgpu_gfx908::mrt5, output_vec_len );
            case 6:  return makeRegisterExpression(amdgpu_gfx908::mrt6, output_vec_len );
            case 7:  return makeRegisterExpression(amdgpu_gfx908::mrt7, output_vec_len );
            case 8:  return makeRegisterExpression(amdgpu_gfx908::mrtz, output_vec_len );
            case 9:  return makeRegisterExpression(amdgpu_gfx908::null, output_vec_len );
            case 12:  return makeRegisterExpression(amdgpu_gfx908::pos0, output_vec_len );
            case 13:  return makeRegisterExpression(amdgpu_gfx908::pos1, output_vec_len );
            case 14:  return makeRegisterExpression(amdgpu_gfx908::pos2, output_vec_len );
            case 15:  return makeRegisterExpression(amdgpu_gfx908::pos3, output_vec_len );
            case 32:  return makeRegisterExpression(amdgpu_gfx908::param0, output_vec_len );
            case 33:  return makeRegisterExpression(amdgpu_gfx908::param1, output_vec_len );
            case 34:  return makeRegisterExpression(amdgpu_gfx908::param2, output_vec_len );
            case 35:  return makeRegisterExpression(amdgpu_gfx908::param3, output_vec_len );
            case 36:  return makeRegisterExpression(amdgpu_gfx908::param4, output_vec_len );
            case 37:  return makeRegisterExpression(amdgpu_gfx908::param5, output_vec_len );
            case 38:  return makeRegisterExpression(amdgpu_gfx908::param6, output_vec_len );
            case 39:  return makeRegisterExpression(amdgpu_gfx908::param7, output_vec_len );
            case 40:  return makeRegisterExpression(amdgpu_gfx908::param8, output_vec_len );
            case 41:  return makeRegisterExpression(amdgpu_gfx908::param9, output_vec_len );
            case 42:  return makeRegisterExpression(amdgpu_gfx908::param10, output_vec_len );
            case 43:  return makeRegisterExpression(amdgpu_gfx908::param11, output_vec_len );
            case 44:  return makeRegisterExpression(amdgpu_gfx908::param12, output_vec_len );
            case 45:  return makeRegisterExpression(amdgpu_gfx908::param13, output_vec_len );
            case 46:  return makeRegisterExpression(amdgpu_gfx908::param14, output_vec_len );
            case 47:  return makeRegisterExpression(amdgpu_gfx908::param15, output_vec_len );
            case 48:  return makeRegisterExpression(amdgpu_gfx908::param16, output_vec_len );
            case 49:  return makeRegisterExpression(amdgpu_gfx908::param17, output_vec_len );
            case 50:  return makeRegisterExpression(amdgpu_gfx908::param18, output_vec_len );
            case 51:  return makeRegisterExpression(amdgpu_gfx908::param19, output_vec_len );
            case 52:  return makeRegisterExpression(amdgpu_gfx908::param20, output_vec_len );
            case 53:  return makeRegisterExpression(amdgpu_gfx908::param21, output_vec_len );
            case 54:  return makeRegisterExpression(amdgpu_gfx908::param22, output_vec_len );
            case 55:  return makeRegisterExpression(amdgpu_gfx908::param23, output_vec_len );
            case 56:  return makeRegisterExpression(amdgpu_gfx908::param24, output_vec_len );
            case 57:  return makeRegisterExpression(amdgpu_gfx908::param25, output_vec_len );
            case 58:  return makeRegisterExpression(amdgpu_gfx908::param26, output_vec_len );
            case 59:  return makeRegisterExpression(amdgpu_gfx908::param27, output_vec_len );
            case 60:  return makeRegisterExpression(amdgpu_gfx908::param28, output_vec_len );
            case 61:  return makeRegisterExpression(amdgpu_gfx908::param29, output_vec_len );
            case 62:  return makeRegisterExpression(amdgpu_gfx908::param30, output_vec_len );
            case 63:  return makeRegisterExpression(amdgpu_gfx908::param31, output_vec_len );
            default: return makeRegisterExpression(amdgpu_gfx908::invalid);
        }
    }

    Expression::Ptr InstructionDecoder_amdgpu_gfx908::decodeOPR_VCC(uint64_t input, uint32_t )
    {
        switch (input)  {
            case 0:  return makeRegisterExpression(amdgpu_gfx908::vcc);
            default: return makeRegisterExpression(amdgpu_gfx908::invalid);
        }
    }

    Expression::Ptr InstructionDecoder_amdgpu_gfx908::decodeOPR_VGPR(uint64_t input, uint32_t output_vec_len)
    {
        switch (input)  {
            case 0:  return makeRegisterExpression(amdgpu_gfx908::v0, output_vec_len );
            case 1:  return makeRegisterExpression(amdgpu_gfx908::v1, output_vec_len );
            case 2:  return makeRegisterExpression(amdgpu_gfx908::v2, output_vec_len );
            case 3:  return makeRegisterExpression(amdgpu_gfx908::v3, output_vec_len );
            case 4:  return makeRegisterExpression(amdgpu_gfx908::v4, output_vec_len );
            case 5:  return makeRegisterExpression(amdgpu_gfx908::v5, output_vec_len );
            case 6:  return makeRegisterExpression(amdgpu_gfx908::v6, output_vec_len );
            case 7:  return makeRegisterExpression(amdgpu_gfx908::v7, output_vec_len );
            case 8:  return makeRegisterExpression(amdgpu_gfx908::v8, output_vec_len );
            case 9:  return makeRegisterExpression(amdgpu_gfx908::v9, output_vec_len );
            case 10:  return makeRegisterExpression(amdgpu_gfx908::v10, output_vec_len );
            case 11:  return makeRegisterExpression(amdgpu_gfx908::v11, output_vec_len );
            case 12:  return makeRegisterExpression(amdgpu_gfx908::v12, output_vec_len );
            case 13:  return makeRegisterExpression(amdgpu_gfx908::v13, output_vec_len );
            case 14:  return makeRegisterExpression(amdgpu_gfx908::v14, output_vec_len );
            case 15:  return makeRegisterExpression(amdgpu_gfx908::v15, output_vec_len );
            case 16:  return makeRegisterExpression(amdgpu_gfx908::v16, output_vec_len );
            case 17:  return makeRegisterExpression(amdgpu_gfx908::v17, output_vec_len );
            case 18:  return makeRegisterExpression(amdgpu_gfx908::v18, output_vec_len );
            case 19:  return makeRegisterExpression(amdgpu_gfx908::v19, output_vec_len );
            case 20:  return makeRegisterExpression(amdgpu_gfx908::v20, output_vec_len );
            case 21:  return makeRegisterExpression(amdgpu_gfx908::v21, output_vec_len );
            case 22:  return makeRegisterExpression(amdgpu_gfx908::v22, output_vec_len );
            case 23:  return makeRegisterExpression(amdgpu_gfx908::v23, output_vec_len );
            case 24:  return makeRegisterExpression(amdgpu_gfx908::v24, output_vec_len );
            case 25:  return makeRegisterExpression(amdgpu_gfx908::v25, output_vec_len );
            case 26:  return makeRegisterExpression(amdgpu_gfx908::v26, output_vec_len );
            case 27:  return makeRegisterExpression(amdgpu_gfx908::v27, output_vec_len );
            case 28:  return makeRegisterExpression(amdgpu_gfx908::v28, output_vec_len );
            case 29:  return makeRegisterExpression(amdgpu_gfx908::v29, output_vec_len );
            case 30:  return makeRegisterExpression(amdgpu_gfx908::v30, output_vec_len );
            case 31:  return makeRegisterExpression(amdgpu_gfx908::v31, output_vec_len );
            case 32:  return makeRegisterExpression(amdgpu_gfx908::v32, output_vec_len );
            case 33:  return makeRegisterExpression(amdgpu_gfx908::v33, output_vec_len );
            case 34:  return makeRegisterExpression(amdgpu_gfx908::v34, output_vec_len );
            case 35:  return makeRegisterExpression(amdgpu_gfx908::v35, output_vec_len );
            case 36:  return makeRegisterExpression(amdgpu_gfx908::v36, output_vec_len );
            case 37:  return makeRegisterExpression(amdgpu_gfx908::v37, output_vec_len );
            case 38:  return makeRegisterExpression(amdgpu_gfx908::v38, output_vec_len );
            case 39:  return makeRegisterExpression(amdgpu_gfx908::v39, output_vec_len );
            case 40:  return makeRegisterExpression(amdgpu_gfx908::v40, output_vec_len );
            case 41:  return makeRegisterExpression(amdgpu_gfx908::v41, output_vec_len );
            case 42:  return makeRegisterExpression(amdgpu_gfx908::v42, output_vec_len );
            case 43:  return makeRegisterExpression(amdgpu_gfx908::v43, output_vec_len );
            case 44:  return makeRegisterExpression(amdgpu_gfx908::v44, output_vec_len );
            case 45:  return makeRegisterExpression(amdgpu_gfx908::v45, output_vec_len );
            case 46:  return makeRegisterExpression(amdgpu_gfx908::v46, output_vec_len );
            case 47:  return makeRegisterExpression(amdgpu_gfx908::v47, output_vec_len );
            case 48:  return makeRegisterExpression(amdgpu_gfx908::v48, output_vec_len );
            case 49:  return makeRegisterExpression(amdgpu_gfx908::v49, output_vec_len );
            case 50:  return makeRegisterExpression(amdgpu_gfx908::v50, output_vec_len );
            case 51:  return makeRegisterExpression(amdgpu_gfx908::v51, output_vec_len );
            case 52:  return makeRegisterExpression(amdgpu_gfx908::v52, output_vec_len );
            case 53:  return makeRegisterExpression(amdgpu_gfx908::v53, output_vec_len );
            case 54:  return makeRegisterExpression(amdgpu_gfx908::v54, output_vec_len );
            case 55:  return makeRegisterExpression(amdgpu_gfx908::v55, output_vec_len );
            case 56:  return makeRegisterExpression(amdgpu_gfx908::v56, output_vec_len );
            case 57:  return makeRegisterExpression(amdgpu_gfx908::v57, output_vec_len );
            case 58:  return makeRegisterExpression(amdgpu_gfx908::v58, output_vec_len );
            case 59:  return makeRegisterExpression(amdgpu_gfx908::v59, output_vec_len );
            case 60:  return makeRegisterExpression(amdgpu_gfx908::v60, output_vec_len );
            case 61:  return makeRegisterExpression(amdgpu_gfx908::v61, output_vec_len );
            case 62:  return makeRegisterExpression(amdgpu_gfx908::v62, output_vec_len );
            case 63:  return makeRegisterExpression(amdgpu_gfx908::v63, output_vec_len );
            case 64:  return makeRegisterExpression(amdgpu_gfx908::v64, output_vec_len );
            case 65:  return makeRegisterExpression(amdgpu_gfx908::v65, output_vec_len );
            case 66:  return makeRegisterExpression(amdgpu_gfx908::v66, output_vec_len );
            case 67:  return makeRegisterExpression(amdgpu_gfx908::v67, output_vec_len );
            case 68:  return makeRegisterExpression(amdgpu_gfx908::v68, output_vec_len );
            case 69:  return makeRegisterExpression(amdgpu_gfx908::v69, output_vec_len );
            case 70:  return makeRegisterExpression(amdgpu_gfx908::v70, output_vec_len );
            case 71:  return makeRegisterExpression(amdgpu_gfx908::v71, output_vec_len );
            case 72:  return makeRegisterExpression(amdgpu_gfx908::v72, output_vec_len );
            case 73:  return makeRegisterExpression(amdgpu_gfx908::v73, output_vec_len );
            case 74:  return makeRegisterExpression(amdgpu_gfx908::v74, output_vec_len );
            case 75:  return makeRegisterExpression(amdgpu_gfx908::v75, output_vec_len );
            case 76:  return makeRegisterExpression(amdgpu_gfx908::v76, output_vec_len );
            case 77:  return makeRegisterExpression(amdgpu_gfx908::v77, output_vec_len );
            case 78:  return makeRegisterExpression(amdgpu_gfx908::v78, output_vec_len );
            case 79:  return makeRegisterExpression(amdgpu_gfx908::v79, output_vec_len );
            case 80:  return makeRegisterExpression(amdgpu_gfx908::v80, output_vec_len );
            case 81:  return makeRegisterExpression(amdgpu_gfx908::v81, output_vec_len );
            case 82:  return makeRegisterExpression(amdgpu_gfx908::v82, output_vec_len );
            case 83:  return makeRegisterExpression(amdgpu_gfx908::v83, output_vec_len );
            case 84:  return makeRegisterExpression(amdgpu_gfx908::v84, output_vec_len );
            case 85:  return makeRegisterExpression(amdgpu_gfx908::v85, output_vec_len );
            case 86:  return makeRegisterExpression(amdgpu_gfx908::v86, output_vec_len );
            case 87:  return makeRegisterExpression(amdgpu_gfx908::v87, output_vec_len );
            case 88:  return makeRegisterExpression(amdgpu_gfx908::v88, output_vec_len );
            case 89:  return makeRegisterExpression(amdgpu_gfx908::v89, output_vec_len );
            case 90:  return makeRegisterExpression(amdgpu_gfx908::v90, output_vec_len );
            case 91:  return makeRegisterExpression(amdgpu_gfx908::v91, output_vec_len );
            case 92:  return makeRegisterExpression(amdgpu_gfx908::v92, output_vec_len );
            case 93:  return makeRegisterExpression(amdgpu_gfx908::v93, output_vec_len );
            case 94:  return makeRegisterExpression(amdgpu_gfx908::v94, output_vec_len );
            case 95:  return makeRegisterExpression(amdgpu_gfx908::v95, output_vec_len );
            case 96:  return makeRegisterExpression(amdgpu_gfx908::v96, output_vec_len );
            case 97:  return makeRegisterExpression(amdgpu_gfx908::v97, output_vec_len );
            case 98:  return makeRegisterExpression(amdgpu_gfx908::v98, output_vec_len );
            case 99:  return makeRegisterExpression(amdgpu_gfx908::v99, output_vec_len );
            case 100:  return makeRegisterExpression(amdgpu_gfx908::v100, output_vec_len );
            case 101:  return makeRegisterExpression(amdgpu_gfx908::v101, output_vec_len );
            case 102:  return makeRegisterExpression(amdgpu_gfx908::v102, output_vec_len );
            case 103:  return makeRegisterExpression(amdgpu_gfx908::v103, output_vec_len );
            case 104:  return makeRegisterExpression(amdgpu_gfx908::v104, output_vec_len );
            case 105:  return makeRegisterExpression(amdgpu_gfx908::v105, output_vec_len );
            case 106:  return makeRegisterExpression(amdgpu_gfx908::v106, output_vec_len );
            case 107:  return makeRegisterExpression(amdgpu_gfx908::v107, output_vec_len );
            case 108:  return makeRegisterExpression(amdgpu_gfx908::v108, output_vec_len );
            case 109:  return makeRegisterExpression(amdgpu_gfx908::v109, output_vec_len );
            case 110:  return makeRegisterExpression(amdgpu_gfx908::v110, output_vec_len );
            case 111:  return makeRegisterExpression(amdgpu_gfx908::v111, output_vec_len );
            case 112:  return makeRegisterExpression(amdgpu_gfx908::v112, output_vec_len );
            case 113:  return makeRegisterExpression(amdgpu_gfx908::v113, output_vec_len );
            case 114:  return makeRegisterExpression(amdgpu_gfx908::v114, output_vec_len );
            case 115:  return makeRegisterExpression(amdgpu_gfx908::v115, output_vec_len );
            case 116:  return makeRegisterExpression(amdgpu_gfx908::v116, output_vec_len );
            case 117:  return makeRegisterExpression(amdgpu_gfx908::v117, output_vec_len );
            case 118:  return makeRegisterExpression(amdgpu_gfx908::v118, output_vec_len );
            case 119:  return makeRegisterExpression(amdgpu_gfx908::v119, output_vec_len );
            case 120:  return makeRegisterExpression(amdgpu_gfx908::v120, output_vec_len );
            case 121:  return makeRegisterExpression(amdgpu_gfx908::v121, output_vec_len );
            case 122:  return makeRegisterExpression(amdgpu_gfx908::v122, output_vec_len );
            case 123:  return makeRegisterExpression(amdgpu_gfx908::v123, output_vec_len );
            case 124:  return makeRegisterExpression(amdgpu_gfx908::v124, output_vec_len );
            case 125:  return makeRegisterExpression(amdgpu_gfx908::v125, output_vec_len );
            case 126:  return makeRegisterExpression(amdgpu_gfx908::v126, output_vec_len );
            case 127:  return makeRegisterExpression(amdgpu_gfx908::v127, output_vec_len );
            case 128:  return makeRegisterExpression(amdgpu_gfx908::v128, output_vec_len );
            case 129:  return makeRegisterExpression(amdgpu_gfx908::v129, output_vec_len );
            case 130:  return makeRegisterExpression(amdgpu_gfx908::v130, output_vec_len );
            case 131:  return makeRegisterExpression(amdgpu_gfx908::v131, output_vec_len );
            case 132:  return makeRegisterExpression(amdgpu_gfx908::v132, output_vec_len );
            case 133:  return makeRegisterExpression(amdgpu_gfx908::v133, output_vec_len );
            case 134:  return makeRegisterExpression(amdgpu_gfx908::v134, output_vec_len );
            case 135:  return makeRegisterExpression(amdgpu_gfx908::v135, output_vec_len );
            case 136:  return makeRegisterExpression(amdgpu_gfx908::v136, output_vec_len );
            case 137:  return makeRegisterExpression(amdgpu_gfx908::v137, output_vec_len );
            case 138:  return makeRegisterExpression(amdgpu_gfx908::v138, output_vec_len );
            case 139:  return makeRegisterExpression(amdgpu_gfx908::v139, output_vec_len );
            case 140:  return makeRegisterExpression(amdgpu_gfx908::v140, output_vec_len );
            case 141:  return makeRegisterExpression(amdgpu_gfx908::v141, output_vec_len );
            case 142:  return makeRegisterExpression(amdgpu_gfx908::v142, output_vec_len );
            case 143:  return makeRegisterExpression(amdgpu_gfx908::v143, output_vec_len );
            case 144:  return makeRegisterExpression(amdgpu_gfx908::v144, output_vec_len );
            case 145:  return makeRegisterExpression(amdgpu_gfx908::v145, output_vec_len );
            case 146:  return makeRegisterExpression(amdgpu_gfx908::v146, output_vec_len );
            case 147:  return makeRegisterExpression(amdgpu_gfx908::v147, output_vec_len );
            case 148:  return makeRegisterExpression(amdgpu_gfx908::v148, output_vec_len );
            case 149:  return makeRegisterExpression(amdgpu_gfx908::v149, output_vec_len );
            case 150:  return makeRegisterExpression(amdgpu_gfx908::v150, output_vec_len );
            case 151:  return makeRegisterExpression(amdgpu_gfx908::v151, output_vec_len );
            case 152:  return makeRegisterExpression(amdgpu_gfx908::v152, output_vec_len );
            case 153:  return makeRegisterExpression(amdgpu_gfx908::v153, output_vec_len );
            case 154:  return makeRegisterExpression(amdgpu_gfx908::v154, output_vec_len );
            case 155:  return makeRegisterExpression(amdgpu_gfx908::v155, output_vec_len );
            case 156:  return makeRegisterExpression(amdgpu_gfx908::v156, output_vec_len );
            case 157:  return makeRegisterExpression(amdgpu_gfx908::v157, output_vec_len );
            case 158:  return makeRegisterExpression(amdgpu_gfx908::v158, output_vec_len );
            case 159:  return makeRegisterExpression(amdgpu_gfx908::v159, output_vec_len );
            case 160:  return makeRegisterExpression(amdgpu_gfx908::v160, output_vec_len );
            case 161:  return makeRegisterExpression(amdgpu_gfx908::v161, output_vec_len );
            case 162:  return makeRegisterExpression(amdgpu_gfx908::v162, output_vec_len );
            case 163:  return makeRegisterExpression(amdgpu_gfx908::v163, output_vec_len );
            case 164:  return makeRegisterExpression(amdgpu_gfx908::v164, output_vec_len );
            case 165:  return makeRegisterExpression(amdgpu_gfx908::v165, output_vec_len );
            case 166:  return makeRegisterExpression(amdgpu_gfx908::v166, output_vec_len );
            case 167:  return makeRegisterExpression(amdgpu_gfx908::v167, output_vec_len );
            case 168:  return makeRegisterExpression(amdgpu_gfx908::v168, output_vec_len );
            case 169:  return makeRegisterExpression(amdgpu_gfx908::v169, output_vec_len );
            case 170:  return makeRegisterExpression(amdgpu_gfx908::v170, output_vec_len );
            case 171:  return makeRegisterExpression(amdgpu_gfx908::v171, output_vec_len );
            case 172:  return makeRegisterExpression(amdgpu_gfx908::v172, output_vec_len );
            case 173:  return makeRegisterExpression(amdgpu_gfx908::v173, output_vec_len );
            case 174:  return makeRegisterExpression(amdgpu_gfx908::v174, output_vec_len );
            case 175:  return makeRegisterExpression(amdgpu_gfx908::v175, output_vec_len );
            case 176:  return makeRegisterExpression(amdgpu_gfx908::v176, output_vec_len );
            case 177:  return makeRegisterExpression(amdgpu_gfx908::v177, output_vec_len );
            case 178:  return makeRegisterExpression(amdgpu_gfx908::v178, output_vec_len );
            case 179:  return makeRegisterExpression(amdgpu_gfx908::v179, output_vec_len );
            case 180:  return makeRegisterExpression(amdgpu_gfx908::v180, output_vec_len );
            case 181:  return makeRegisterExpression(amdgpu_gfx908::v181, output_vec_len );
            case 182:  return makeRegisterExpression(amdgpu_gfx908::v182, output_vec_len );
            case 183:  return makeRegisterExpression(amdgpu_gfx908::v183, output_vec_len );
            case 184:  return makeRegisterExpression(amdgpu_gfx908::v184, output_vec_len );
            case 185:  return makeRegisterExpression(amdgpu_gfx908::v185, output_vec_len );
            case 186:  return makeRegisterExpression(amdgpu_gfx908::v186, output_vec_len );
            case 187:  return makeRegisterExpression(amdgpu_gfx908::v187, output_vec_len );
            case 188:  return makeRegisterExpression(amdgpu_gfx908::v188, output_vec_len );
            case 189:  return makeRegisterExpression(amdgpu_gfx908::v189, output_vec_len );
            case 190:  return makeRegisterExpression(amdgpu_gfx908::v190, output_vec_len );
            case 191:  return makeRegisterExpression(amdgpu_gfx908::v191, output_vec_len );
            case 192:  return makeRegisterExpression(amdgpu_gfx908::v192, output_vec_len );
            case 193:  return makeRegisterExpression(amdgpu_gfx908::v193, output_vec_len );
            case 194:  return makeRegisterExpression(amdgpu_gfx908::v194, output_vec_len );
            case 195:  return makeRegisterExpression(amdgpu_gfx908::v195, output_vec_len );
            case 196:  return makeRegisterExpression(amdgpu_gfx908::v196, output_vec_len );
            case 197:  return makeRegisterExpression(amdgpu_gfx908::v197, output_vec_len );
            case 198:  return makeRegisterExpression(amdgpu_gfx908::v198, output_vec_len );
            case 199:  return makeRegisterExpression(amdgpu_gfx908::v199, output_vec_len );
            case 200:  return makeRegisterExpression(amdgpu_gfx908::v200, output_vec_len );
            case 201:  return makeRegisterExpression(amdgpu_gfx908::v201, output_vec_len );
            case 202:  return makeRegisterExpression(amdgpu_gfx908::v202, output_vec_len );
            case 203:  return makeRegisterExpression(amdgpu_gfx908::v203, output_vec_len );
            case 204:  return makeRegisterExpression(amdgpu_gfx908::v204, output_vec_len );
            case 205:  return makeRegisterExpression(amdgpu_gfx908::v205, output_vec_len );
            case 206:  return makeRegisterExpression(amdgpu_gfx908::v206, output_vec_len );
            case 207:  return makeRegisterExpression(amdgpu_gfx908::v207, output_vec_len );
            case 208:  return makeRegisterExpression(amdgpu_gfx908::v208, output_vec_len );
            case 209:  return makeRegisterExpression(amdgpu_gfx908::v209, output_vec_len );
            case 210:  return makeRegisterExpression(amdgpu_gfx908::v210, output_vec_len );
            case 211:  return makeRegisterExpression(amdgpu_gfx908::v211, output_vec_len );
            case 212:  return makeRegisterExpression(amdgpu_gfx908::v212, output_vec_len );
            case 213:  return makeRegisterExpression(amdgpu_gfx908::v213, output_vec_len );
            case 214:  return makeRegisterExpression(amdgpu_gfx908::v214, output_vec_len );
            case 215:  return makeRegisterExpression(amdgpu_gfx908::v215, output_vec_len );
            case 216:  return makeRegisterExpression(amdgpu_gfx908::v216, output_vec_len );
            case 217:  return makeRegisterExpression(amdgpu_gfx908::v217, output_vec_len );
            case 218:  return makeRegisterExpression(amdgpu_gfx908::v218, output_vec_len );
            case 219:  return makeRegisterExpression(amdgpu_gfx908::v219, output_vec_len );
            case 220:  return makeRegisterExpression(amdgpu_gfx908::v220, output_vec_len );
            case 221:  return makeRegisterExpression(amdgpu_gfx908::v221, output_vec_len );
            case 222:  return makeRegisterExpression(amdgpu_gfx908::v222, output_vec_len );
            case 223:  return makeRegisterExpression(amdgpu_gfx908::v223, output_vec_len );
            case 224:  return makeRegisterExpression(amdgpu_gfx908::v224, output_vec_len );
            case 225:  return makeRegisterExpression(amdgpu_gfx908::v225, output_vec_len );
            case 226:  return makeRegisterExpression(amdgpu_gfx908::v226, output_vec_len );
            case 227:  return makeRegisterExpression(amdgpu_gfx908::v227, output_vec_len );
            case 228:  return makeRegisterExpression(amdgpu_gfx908::v228, output_vec_len );
            case 229:  return makeRegisterExpression(amdgpu_gfx908::v229, output_vec_len );
            case 230:  return makeRegisterExpression(amdgpu_gfx908::v230, output_vec_len );
            case 231:  return makeRegisterExpression(amdgpu_gfx908::v231, output_vec_len );
            case 232:  return makeRegisterExpression(amdgpu_gfx908::v232, output_vec_len );
            case 233:  return makeRegisterExpression(amdgpu_gfx908::v233, output_vec_len );
            case 234:  return makeRegisterExpression(amdgpu_gfx908::v234, output_vec_len );
            case 235:  return makeRegisterExpression(amdgpu_gfx908::v235, output_vec_len );
            case 236:  return makeRegisterExpression(amdgpu_gfx908::v236, output_vec_len );
            case 237:  return makeRegisterExpression(amdgpu_gfx908::v237, output_vec_len );
            case 238:  return makeRegisterExpression(amdgpu_gfx908::v238, output_vec_len );
            case 239:  return makeRegisterExpression(amdgpu_gfx908::v239, output_vec_len );
            case 240:  return makeRegisterExpression(amdgpu_gfx908::v240, output_vec_len );
            case 241:  return makeRegisterExpression(amdgpu_gfx908::v241, output_vec_len );
            case 242:  return makeRegisterExpression(amdgpu_gfx908::v242, output_vec_len );
            case 243:  return makeRegisterExpression(amdgpu_gfx908::v243, output_vec_len );
            case 244:  return makeRegisterExpression(amdgpu_gfx908::v244, output_vec_len );
            case 245:  return makeRegisterExpression(amdgpu_gfx908::v245, output_vec_len );
            case 246:  return makeRegisterExpression(amdgpu_gfx908::v246, output_vec_len );
            case 247:  return makeRegisterExpression(amdgpu_gfx908::v247, output_vec_len );
            case 248:  return makeRegisterExpression(amdgpu_gfx908::v248, output_vec_len );
            case 249:  return makeRegisterExpression(amdgpu_gfx908::v249, output_vec_len );
            case 250:  return makeRegisterExpression(amdgpu_gfx908::v250, output_vec_len );
            case 251:  return makeRegisterExpression(amdgpu_gfx908::v251, output_vec_len );
            case 252:  return makeRegisterExpression(amdgpu_gfx908::v252, output_vec_len );
            case 253:  return makeRegisterExpression(amdgpu_gfx908::v253, output_vec_len );
            case 254:  return makeRegisterExpression(amdgpu_gfx908::v254, output_vec_len );
            case 255:  return makeRegisterExpression(amdgpu_gfx908::v255, output_vec_len );
            default: return makeRegisterExpression(amdgpu_gfx908::invalid);
        }
    }

    Expression::Ptr InstructionDecoder_amdgpu_gfx908::decodeOPR_VGPR_OR_LDS(uint64_t input, uint32_t output_vec_len)
    {
        switch (input)  {
            case 254:  return makeRegisterExpression(amdgpu_gfx908::src_lds_direct, output_vec_len );
            case 256:  return makeRegisterExpression(amdgpu_gfx908::v0, output_vec_len );
            case 257:  return makeRegisterExpression(amdgpu_gfx908::v1, output_vec_len );
            case 258:  return makeRegisterExpression(amdgpu_gfx908::v2, output_vec_len );
            case 259:  return makeRegisterExpression(amdgpu_gfx908::v3, output_vec_len );
            case 260:  return makeRegisterExpression(amdgpu_gfx908::v4, output_vec_len );
            case 261:  return makeRegisterExpression(amdgpu_gfx908::v5, output_vec_len );
            case 262:  return makeRegisterExpression(amdgpu_gfx908::v6, output_vec_len );
            case 263:  return makeRegisterExpression(amdgpu_gfx908::v7, output_vec_len );
            case 264:  return makeRegisterExpression(amdgpu_gfx908::v8, output_vec_len );
            case 265:  return makeRegisterExpression(amdgpu_gfx908::v9, output_vec_len );
            case 266:  return makeRegisterExpression(amdgpu_gfx908::v10, output_vec_len );
            case 267:  return makeRegisterExpression(amdgpu_gfx908::v11, output_vec_len );
            case 268:  return makeRegisterExpression(amdgpu_gfx908::v12, output_vec_len );
            case 269:  return makeRegisterExpression(amdgpu_gfx908::v13, output_vec_len );
            case 270:  return makeRegisterExpression(amdgpu_gfx908::v14, output_vec_len );
            case 271:  return makeRegisterExpression(amdgpu_gfx908::v15, output_vec_len );
            case 272:  return makeRegisterExpression(amdgpu_gfx908::v16, output_vec_len );
            case 273:  return makeRegisterExpression(amdgpu_gfx908::v17, output_vec_len );
            case 274:  return makeRegisterExpression(amdgpu_gfx908::v18, output_vec_len );
            case 275:  return makeRegisterExpression(amdgpu_gfx908::v19, output_vec_len );
            case 276:  return makeRegisterExpression(amdgpu_gfx908::v20, output_vec_len );
            case 277:  return makeRegisterExpression(amdgpu_gfx908::v21, output_vec_len );
            case 278:  return makeRegisterExpression(amdgpu_gfx908::v22, output_vec_len );
            case 279:  return makeRegisterExpression(amdgpu_gfx908::v23, output_vec_len );
            case 280:  return makeRegisterExpression(amdgpu_gfx908::v24, output_vec_len );
            case 281:  return makeRegisterExpression(amdgpu_gfx908::v25, output_vec_len );
            case 282:  return makeRegisterExpression(amdgpu_gfx908::v26, output_vec_len );
            case 283:  return makeRegisterExpression(amdgpu_gfx908::v27, output_vec_len );
            case 284:  return makeRegisterExpression(amdgpu_gfx908::v28, output_vec_len );
            case 285:  return makeRegisterExpression(amdgpu_gfx908::v29, output_vec_len );
            case 286:  return makeRegisterExpression(amdgpu_gfx908::v30, output_vec_len );
            case 287:  return makeRegisterExpression(amdgpu_gfx908::v31, output_vec_len );
            case 288:  return makeRegisterExpression(amdgpu_gfx908::v32, output_vec_len );
            case 289:  return makeRegisterExpression(amdgpu_gfx908::v33, output_vec_len );
            case 290:  return makeRegisterExpression(amdgpu_gfx908::v34, output_vec_len );
            case 291:  return makeRegisterExpression(amdgpu_gfx908::v35, output_vec_len );
            case 292:  return makeRegisterExpression(amdgpu_gfx908::v36, output_vec_len );
            case 293:  return makeRegisterExpression(amdgpu_gfx908::v37, output_vec_len );
            case 294:  return makeRegisterExpression(amdgpu_gfx908::v38, output_vec_len );
            case 295:  return makeRegisterExpression(amdgpu_gfx908::v39, output_vec_len );
            case 296:  return makeRegisterExpression(amdgpu_gfx908::v40, output_vec_len );
            case 297:  return makeRegisterExpression(amdgpu_gfx908::v41, output_vec_len );
            case 298:  return makeRegisterExpression(amdgpu_gfx908::v42, output_vec_len );
            case 299:  return makeRegisterExpression(amdgpu_gfx908::v43, output_vec_len );
            case 300:  return makeRegisterExpression(amdgpu_gfx908::v44, output_vec_len );
            case 301:  return makeRegisterExpression(amdgpu_gfx908::v45, output_vec_len );
            case 302:  return makeRegisterExpression(amdgpu_gfx908::v46, output_vec_len );
            case 303:  return makeRegisterExpression(amdgpu_gfx908::v47, output_vec_len );
            case 304:  return makeRegisterExpression(amdgpu_gfx908::v48, output_vec_len );
            case 305:  return makeRegisterExpression(amdgpu_gfx908::v49, output_vec_len );
            case 306:  return makeRegisterExpression(amdgpu_gfx908::v50, output_vec_len );
            case 307:  return makeRegisterExpression(amdgpu_gfx908::v51, output_vec_len );
            case 308:  return makeRegisterExpression(amdgpu_gfx908::v52, output_vec_len );
            case 309:  return makeRegisterExpression(amdgpu_gfx908::v53, output_vec_len );
            case 310:  return makeRegisterExpression(amdgpu_gfx908::v54, output_vec_len );
            case 311:  return makeRegisterExpression(amdgpu_gfx908::v55, output_vec_len );
            case 312:  return makeRegisterExpression(amdgpu_gfx908::v56, output_vec_len );
            case 313:  return makeRegisterExpression(amdgpu_gfx908::v57, output_vec_len );
            case 314:  return makeRegisterExpression(amdgpu_gfx908::v58, output_vec_len );
            case 315:  return makeRegisterExpression(amdgpu_gfx908::v59, output_vec_len );
            case 316:  return makeRegisterExpression(amdgpu_gfx908::v60, output_vec_len );
            case 317:  return makeRegisterExpression(amdgpu_gfx908::v61, output_vec_len );
            case 318:  return makeRegisterExpression(amdgpu_gfx908::v62, output_vec_len );
            case 319:  return makeRegisterExpression(amdgpu_gfx908::v63, output_vec_len );
            case 320:  return makeRegisterExpression(amdgpu_gfx908::v64, output_vec_len );
            case 321:  return makeRegisterExpression(amdgpu_gfx908::v65, output_vec_len );
            case 322:  return makeRegisterExpression(amdgpu_gfx908::v66, output_vec_len );
            case 323:  return makeRegisterExpression(amdgpu_gfx908::v67, output_vec_len );
            case 324:  return makeRegisterExpression(amdgpu_gfx908::v68, output_vec_len );
            case 325:  return makeRegisterExpression(amdgpu_gfx908::v69, output_vec_len );
            case 326:  return makeRegisterExpression(amdgpu_gfx908::v70, output_vec_len );
            case 327:  return makeRegisterExpression(amdgpu_gfx908::v71, output_vec_len );
            case 328:  return makeRegisterExpression(amdgpu_gfx908::v72, output_vec_len );
            case 329:  return makeRegisterExpression(amdgpu_gfx908::v73, output_vec_len );
            case 330:  return makeRegisterExpression(amdgpu_gfx908::v74, output_vec_len );
            case 331:  return makeRegisterExpression(amdgpu_gfx908::v75, output_vec_len );
            case 332:  return makeRegisterExpression(amdgpu_gfx908::v76, output_vec_len );
            case 333:  return makeRegisterExpression(amdgpu_gfx908::v77, output_vec_len );
            case 334:  return makeRegisterExpression(amdgpu_gfx908::v78, output_vec_len );
            case 335:  return makeRegisterExpression(amdgpu_gfx908::v79, output_vec_len );
            case 336:  return makeRegisterExpression(amdgpu_gfx908::v80, output_vec_len );
            case 337:  return makeRegisterExpression(amdgpu_gfx908::v81, output_vec_len );
            case 338:  return makeRegisterExpression(amdgpu_gfx908::v82, output_vec_len );
            case 339:  return makeRegisterExpression(amdgpu_gfx908::v83, output_vec_len );
            case 340:  return makeRegisterExpression(amdgpu_gfx908::v84, output_vec_len );
            case 341:  return makeRegisterExpression(amdgpu_gfx908::v85, output_vec_len );
            case 342:  return makeRegisterExpression(amdgpu_gfx908::v86, output_vec_len );
            case 343:  return makeRegisterExpression(amdgpu_gfx908::v87, output_vec_len );
            case 344:  return makeRegisterExpression(amdgpu_gfx908::v88, output_vec_len );
            case 345:  return makeRegisterExpression(amdgpu_gfx908::v89, output_vec_len );
            case 346:  return makeRegisterExpression(amdgpu_gfx908::v90, output_vec_len );
            case 347:  return makeRegisterExpression(amdgpu_gfx908::v91, output_vec_len );
            case 348:  return makeRegisterExpression(amdgpu_gfx908::v92, output_vec_len );
            case 349:  return makeRegisterExpression(amdgpu_gfx908::v93, output_vec_len );
            case 350:  return makeRegisterExpression(amdgpu_gfx908::v94, output_vec_len );
            case 351:  return makeRegisterExpression(amdgpu_gfx908::v95, output_vec_len );
            case 352:  return makeRegisterExpression(amdgpu_gfx908::v96, output_vec_len );
            case 353:  return makeRegisterExpression(amdgpu_gfx908::v97, output_vec_len );
            case 354:  return makeRegisterExpression(amdgpu_gfx908::v98, output_vec_len );
            case 355:  return makeRegisterExpression(amdgpu_gfx908::v99, output_vec_len );
            case 356:  return makeRegisterExpression(amdgpu_gfx908::v100, output_vec_len );
            case 357:  return makeRegisterExpression(amdgpu_gfx908::v101, output_vec_len );
            case 358:  return makeRegisterExpression(amdgpu_gfx908::v102, output_vec_len );
            case 359:  return makeRegisterExpression(amdgpu_gfx908::v103, output_vec_len );
            case 360:  return makeRegisterExpression(amdgpu_gfx908::v104, output_vec_len );
            case 361:  return makeRegisterExpression(amdgpu_gfx908::v105, output_vec_len );
            case 362:  return makeRegisterExpression(amdgpu_gfx908::v106, output_vec_len );
            case 363:  return makeRegisterExpression(amdgpu_gfx908::v107, output_vec_len );
            case 364:  return makeRegisterExpression(amdgpu_gfx908::v108, output_vec_len );
            case 365:  return makeRegisterExpression(amdgpu_gfx908::v109, output_vec_len );
            case 366:  return makeRegisterExpression(amdgpu_gfx908::v110, output_vec_len );
            case 367:  return makeRegisterExpression(amdgpu_gfx908::v111, output_vec_len );
            case 368:  return makeRegisterExpression(amdgpu_gfx908::v112, output_vec_len );
            case 369:  return makeRegisterExpression(amdgpu_gfx908::v113, output_vec_len );
            case 370:  return makeRegisterExpression(amdgpu_gfx908::v114, output_vec_len );
            case 371:  return makeRegisterExpression(amdgpu_gfx908::v115, output_vec_len );
            case 372:  return makeRegisterExpression(amdgpu_gfx908::v116, output_vec_len );
            case 373:  return makeRegisterExpression(amdgpu_gfx908::v117, output_vec_len );
            case 374:  return makeRegisterExpression(amdgpu_gfx908::v118, output_vec_len );
            case 375:  return makeRegisterExpression(amdgpu_gfx908::v119, output_vec_len );
            case 376:  return makeRegisterExpression(amdgpu_gfx908::v120, output_vec_len );
            case 377:  return makeRegisterExpression(amdgpu_gfx908::v121, output_vec_len );
            case 378:  return makeRegisterExpression(amdgpu_gfx908::v122, output_vec_len );
            case 379:  return makeRegisterExpression(amdgpu_gfx908::v123, output_vec_len );
            case 380:  return makeRegisterExpression(amdgpu_gfx908::v124, output_vec_len );
            case 381:  return makeRegisterExpression(amdgpu_gfx908::v125, output_vec_len );
            case 382:  return makeRegisterExpression(amdgpu_gfx908::v126, output_vec_len );
            case 383:  return makeRegisterExpression(amdgpu_gfx908::v127, output_vec_len );
            case 384:  return makeRegisterExpression(amdgpu_gfx908::v128, output_vec_len );
            case 385:  return makeRegisterExpression(amdgpu_gfx908::v129, output_vec_len );
            case 386:  return makeRegisterExpression(amdgpu_gfx908::v130, output_vec_len );
            case 387:  return makeRegisterExpression(amdgpu_gfx908::v131, output_vec_len );
            case 388:  return makeRegisterExpression(amdgpu_gfx908::v132, output_vec_len );
            case 389:  return makeRegisterExpression(amdgpu_gfx908::v133, output_vec_len );
            case 390:  return makeRegisterExpression(amdgpu_gfx908::v134, output_vec_len );
            case 391:  return makeRegisterExpression(amdgpu_gfx908::v135, output_vec_len );
            case 392:  return makeRegisterExpression(amdgpu_gfx908::v136, output_vec_len );
            case 393:  return makeRegisterExpression(amdgpu_gfx908::v137, output_vec_len );
            case 394:  return makeRegisterExpression(amdgpu_gfx908::v138, output_vec_len );
            case 395:  return makeRegisterExpression(amdgpu_gfx908::v139, output_vec_len );
            case 396:  return makeRegisterExpression(amdgpu_gfx908::v140, output_vec_len );
            case 397:  return makeRegisterExpression(amdgpu_gfx908::v141, output_vec_len );
            case 398:  return makeRegisterExpression(amdgpu_gfx908::v142, output_vec_len );
            case 399:  return makeRegisterExpression(amdgpu_gfx908::v143, output_vec_len );
            case 400:  return makeRegisterExpression(amdgpu_gfx908::v144, output_vec_len );
            case 401:  return makeRegisterExpression(amdgpu_gfx908::v145, output_vec_len );
            case 402:  return makeRegisterExpression(amdgpu_gfx908::v146, output_vec_len );
            case 403:  return makeRegisterExpression(amdgpu_gfx908::v147, output_vec_len );
            case 404:  return makeRegisterExpression(amdgpu_gfx908::v148, output_vec_len );
            case 405:  return makeRegisterExpression(amdgpu_gfx908::v149, output_vec_len );
            case 406:  return makeRegisterExpression(amdgpu_gfx908::v150, output_vec_len );
            case 407:  return makeRegisterExpression(amdgpu_gfx908::v151, output_vec_len );
            case 408:  return makeRegisterExpression(amdgpu_gfx908::v152, output_vec_len );
            case 409:  return makeRegisterExpression(amdgpu_gfx908::v153, output_vec_len );
            case 410:  return makeRegisterExpression(amdgpu_gfx908::v154, output_vec_len );
            case 411:  return makeRegisterExpression(amdgpu_gfx908::v155, output_vec_len );
            case 412:  return makeRegisterExpression(amdgpu_gfx908::v156, output_vec_len );
            case 413:  return makeRegisterExpression(amdgpu_gfx908::v157, output_vec_len );
            case 414:  return makeRegisterExpression(amdgpu_gfx908::v158, output_vec_len );
            case 415:  return makeRegisterExpression(amdgpu_gfx908::v159, output_vec_len );
            case 416:  return makeRegisterExpression(amdgpu_gfx908::v160, output_vec_len );
            case 417:  return makeRegisterExpression(amdgpu_gfx908::v161, output_vec_len );
            case 418:  return makeRegisterExpression(amdgpu_gfx908::v162, output_vec_len );
            case 419:  return makeRegisterExpression(amdgpu_gfx908::v163, output_vec_len );
            case 420:  return makeRegisterExpression(amdgpu_gfx908::v164, output_vec_len );
            case 421:  return makeRegisterExpression(amdgpu_gfx908::v165, output_vec_len );
            case 422:  return makeRegisterExpression(amdgpu_gfx908::v166, output_vec_len );
            case 423:  return makeRegisterExpression(amdgpu_gfx908::v167, output_vec_len );
            case 424:  return makeRegisterExpression(amdgpu_gfx908::v168, output_vec_len );
            case 425:  return makeRegisterExpression(amdgpu_gfx908::v169, output_vec_len );
            case 426:  return makeRegisterExpression(amdgpu_gfx908::v170, output_vec_len );
            case 427:  return makeRegisterExpression(amdgpu_gfx908::v171, output_vec_len );
            case 428:  return makeRegisterExpression(amdgpu_gfx908::v172, output_vec_len );
            case 429:  return makeRegisterExpression(amdgpu_gfx908::v173, output_vec_len );
            case 430:  return makeRegisterExpression(amdgpu_gfx908::v174, output_vec_len );
            case 431:  return makeRegisterExpression(amdgpu_gfx908::v175, output_vec_len );
            case 432:  return makeRegisterExpression(amdgpu_gfx908::v176, output_vec_len );
            case 433:  return makeRegisterExpression(amdgpu_gfx908::v177, output_vec_len );
            case 434:  return makeRegisterExpression(amdgpu_gfx908::v178, output_vec_len );
            case 435:  return makeRegisterExpression(amdgpu_gfx908::v179, output_vec_len );
            case 436:  return makeRegisterExpression(amdgpu_gfx908::v180, output_vec_len );
            case 437:  return makeRegisterExpression(amdgpu_gfx908::v181, output_vec_len );
            case 438:  return makeRegisterExpression(amdgpu_gfx908::v182, output_vec_len );
            case 439:  return makeRegisterExpression(amdgpu_gfx908::v183, output_vec_len );
            case 440:  return makeRegisterExpression(amdgpu_gfx908::v184, output_vec_len );
            case 441:  return makeRegisterExpression(amdgpu_gfx908::v185, output_vec_len );
            case 442:  return makeRegisterExpression(amdgpu_gfx908::v186, output_vec_len );
            case 443:  return makeRegisterExpression(amdgpu_gfx908::v187, output_vec_len );
            case 444:  return makeRegisterExpression(amdgpu_gfx908::v188, output_vec_len );
            case 445:  return makeRegisterExpression(amdgpu_gfx908::v189, output_vec_len );
            case 446:  return makeRegisterExpression(amdgpu_gfx908::v190, output_vec_len );
            case 447:  return makeRegisterExpression(amdgpu_gfx908::v191, output_vec_len );
            case 448:  return makeRegisterExpression(amdgpu_gfx908::v192, output_vec_len );
            case 449:  return makeRegisterExpression(amdgpu_gfx908::v193, output_vec_len );
            case 450:  return makeRegisterExpression(amdgpu_gfx908::v194, output_vec_len );
            case 451:  return makeRegisterExpression(amdgpu_gfx908::v195, output_vec_len );
            case 452:  return makeRegisterExpression(amdgpu_gfx908::v196, output_vec_len );
            case 453:  return makeRegisterExpression(amdgpu_gfx908::v197, output_vec_len );
            case 454:  return makeRegisterExpression(amdgpu_gfx908::v198, output_vec_len );
            case 455:  return makeRegisterExpression(amdgpu_gfx908::v199, output_vec_len );
            case 456:  return makeRegisterExpression(amdgpu_gfx908::v200, output_vec_len );
            case 457:  return makeRegisterExpression(amdgpu_gfx908::v201, output_vec_len );
            case 458:  return makeRegisterExpression(amdgpu_gfx908::v202, output_vec_len );
            case 459:  return makeRegisterExpression(amdgpu_gfx908::v203, output_vec_len );
            case 460:  return makeRegisterExpression(amdgpu_gfx908::v204, output_vec_len );
            case 461:  return makeRegisterExpression(amdgpu_gfx908::v205, output_vec_len );
            case 462:  return makeRegisterExpression(amdgpu_gfx908::v206, output_vec_len );
            case 463:  return makeRegisterExpression(amdgpu_gfx908::v207, output_vec_len );
            case 464:  return makeRegisterExpression(amdgpu_gfx908::v208, output_vec_len );
            case 465:  return makeRegisterExpression(amdgpu_gfx908::v209, output_vec_len );
            case 466:  return makeRegisterExpression(amdgpu_gfx908::v210, output_vec_len );
            case 467:  return makeRegisterExpression(amdgpu_gfx908::v211, output_vec_len );
            case 468:  return makeRegisterExpression(amdgpu_gfx908::v212, output_vec_len );
            case 469:  return makeRegisterExpression(amdgpu_gfx908::v213, output_vec_len );
            case 470:  return makeRegisterExpression(amdgpu_gfx908::v214, output_vec_len );
            case 471:  return makeRegisterExpression(amdgpu_gfx908::v215, output_vec_len );
            case 472:  return makeRegisterExpression(amdgpu_gfx908::v216, output_vec_len );
            case 473:  return makeRegisterExpression(amdgpu_gfx908::v217, output_vec_len );
            case 474:  return makeRegisterExpression(amdgpu_gfx908::v218, output_vec_len );
            case 475:  return makeRegisterExpression(amdgpu_gfx908::v219, output_vec_len );
            case 476:  return makeRegisterExpression(amdgpu_gfx908::v220, output_vec_len );
            case 477:  return makeRegisterExpression(amdgpu_gfx908::v221, output_vec_len );
            case 478:  return makeRegisterExpression(amdgpu_gfx908::v222, output_vec_len );
            case 479:  return makeRegisterExpression(amdgpu_gfx908::v223, output_vec_len );
            case 480:  return makeRegisterExpression(amdgpu_gfx908::v224, output_vec_len );
            case 481:  return makeRegisterExpression(amdgpu_gfx908::v225, output_vec_len );
            case 482:  return makeRegisterExpression(amdgpu_gfx908::v226, output_vec_len );
            case 483:  return makeRegisterExpression(amdgpu_gfx908::v227, output_vec_len );
            case 484:  return makeRegisterExpression(amdgpu_gfx908::v228, output_vec_len );
            case 485:  return makeRegisterExpression(amdgpu_gfx908::v229, output_vec_len );
            case 486:  return makeRegisterExpression(amdgpu_gfx908::v230, output_vec_len );
            case 487:  return makeRegisterExpression(amdgpu_gfx908::v231, output_vec_len );
            case 488:  return makeRegisterExpression(amdgpu_gfx908::v232, output_vec_len );
            case 489:  return makeRegisterExpression(amdgpu_gfx908::v233, output_vec_len );
            case 490:  return makeRegisterExpression(amdgpu_gfx908::v234, output_vec_len );
            case 491:  return makeRegisterExpression(amdgpu_gfx908::v235, output_vec_len );
            case 492:  return makeRegisterExpression(amdgpu_gfx908::v236, output_vec_len );
            case 493:  return makeRegisterExpression(amdgpu_gfx908::v237, output_vec_len );
            case 494:  return makeRegisterExpression(amdgpu_gfx908::v238, output_vec_len );
            case 495:  return makeRegisterExpression(amdgpu_gfx908::v239, output_vec_len );
            case 496:  return makeRegisterExpression(amdgpu_gfx908::v240, output_vec_len );
            case 497:  return makeRegisterExpression(amdgpu_gfx908::v241, output_vec_len );
            case 498:  return makeRegisterExpression(amdgpu_gfx908::v242, output_vec_len );
            case 499:  return makeRegisterExpression(amdgpu_gfx908::v243, output_vec_len );
            case 500:  return makeRegisterExpression(amdgpu_gfx908::v244, output_vec_len );
            case 501:  return makeRegisterExpression(amdgpu_gfx908::v245, output_vec_len );
            case 502:  return makeRegisterExpression(amdgpu_gfx908::v246, output_vec_len );
            case 503:  return makeRegisterExpression(amdgpu_gfx908::v247, output_vec_len );
            case 504:  return makeRegisterExpression(amdgpu_gfx908::v248, output_vec_len );
            case 505:  return makeRegisterExpression(amdgpu_gfx908::v249, output_vec_len );
            case 506:  return makeRegisterExpression(amdgpu_gfx908::v250, output_vec_len );
            case 507:  return makeRegisterExpression(amdgpu_gfx908::v251, output_vec_len );
            case 508:  return makeRegisterExpression(amdgpu_gfx908::v252, output_vec_len );
            case 509:  return makeRegisterExpression(amdgpu_gfx908::v253, output_vec_len );
            case 510:  return makeRegisterExpression(amdgpu_gfx908::v254, output_vec_len );
            case 511:  return makeRegisterExpression(amdgpu_gfx908::v255, output_vec_len );
            default: return makeRegisterExpression(amdgpu_gfx908::invalid);
        }
    }

}
}
