#include "registers/AMDGPU/amdgpu_gfx90a_regs.h"
#include "InstructionDecoder-amdgpu-gfx90a.h"

namespace Dyninst {
namespace InstructionAPI {
    Expression::Ptr InstructionDecoder_amdgpu_gfx90a::decodeOPR_ACCVGPR(uint64_t input, uint32_t output_vec_len)
    {
        switch (input)  {
            case 0:  return makeRegisterExpression(amdgpu_gfx90a::acc0, output_vec_len );
            case 1:  return makeRegisterExpression(amdgpu_gfx90a::acc1, output_vec_len );
            case 2:  return makeRegisterExpression(amdgpu_gfx90a::acc2, output_vec_len );
            case 3:  return makeRegisterExpression(amdgpu_gfx90a::acc3, output_vec_len );
            case 4:  return makeRegisterExpression(amdgpu_gfx90a::acc4, output_vec_len );
            case 5:  return makeRegisterExpression(amdgpu_gfx90a::acc5, output_vec_len );
            case 6:  return makeRegisterExpression(amdgpu_gfx90a::acc6, output_vec_len );
            case 7:  return makeRegisterExpression(amdgpu_gfx90a::acc7, output_vec_len );
            case 8:  return makeRegisterExpression(amdgpu_gfx90a::acc8, output_vec_len );
            case 9:  return makeRegisterExpression(amdgpu_gfx90a::acc9, output_vec_len );
            case 10:  return makeRegisterExpression(amdgpu_gfx90a::acc10, output_vec_len );
            case 11:  return makeRegisterExpression(amdgpu_gfx90a::acc11, output_vec_len );
            case 12:  return makeRegisterExpression(amdgpu_gfx90a::acc12, output_vec_len );
            case 13:  return makeRegisterExpression(amdgpu_gfx90a::acc13, output_vec_len );
            case 14:  return makeRegisterExpression(amdgpu_gfx90a::acc14, output_vec_len );
            case 15:  return makeRegisterExpression(amdgpu_gfx90a::acc15, output_vec_len );
            case 16:  return makeRegisterExpression(amdgpu_gfx90a::acc16, output_vec_len );
            case 17:  return makeRegisterExpression(amdgpu_gfx90a::acc17, output_vec_len );
            case 18:  return makeRegisterExpression(amdgpu_gfx90a::acc18, output_vec_len );
            case 19:  return makeRegisterExpression(amdgpu_gfx90a::acc19, output_vec_len );
            case 20:  return makeRegisterExpression(amdgpu_gfx90a::acc20, output_vec_len );
            case 21:  return makeRegisterExpression(amdgpu_gfx90a::acc21, output_vec_len );
            case 22:  return makeRegisterExpression(amdgpu_gfx90a::acc22, output_vec_len );
            case 23:  return makeRegisterExpression(amdgpu_gfx90a::acc23, output_vec_len );
            case 24:  return makeRegisterExpression(amdgpu_gfx90a::acc24, output_vec_len );
            case 25:  return makeRegisterExpression(amdgpu_gfx90a::acc25, output_vec_len );
            case 26:  return makeRegisterExpression(amdgpu_gfx90a::acc26, output_vec_len );
            case 27:  return makeRegisterExpression(amdgpu_gfx90a::acc27, output_vec_len );
            case 28:  return makeRegisterExpression(amdgpu_gfx90a::acc28, output_vec_len );
            case 29:  return makeRegisterExpression(amdgpu_gfx90a::acc29, output_vec_len );
            case 30:  return makeRegisterExpression(amdgpu_gfx90a::acc30, output_vec_len );
            case 31:  return makeRegisterExpression(amdgpu_gfx90a::acc31, output_vec_len );
            case 32:  return makeRegisterExpression(amdgpu_gfx90a::acc32, output_vec_len );
            case 33:  return makeRegisterExpression(amdgpu_gfx90a::acc33, output_vec_len );
            case 34:  return makeRegisterExpression(amdgpu_gfx90a::acc34, output_vec_len );
            case 35:  return makeRegisterExpression(amdgpu_gfx90a::acc35, output_vec_len );
            case 36:  return makeRegisterExpression(amdgpu_gfx90a::acc36, output_vec_len );
            case 37:  return makeRegisterExpression(amdgpu_gfx90a::acc37, output_vec_len );
            case 38:  return makeRegisterExpression(amdgpu_gfx90a::acc38, output_vec_len );
            case 39:  return makeRegisterExpression(amdgpu_gfx90a::acc39, output_vec_len );
            case 40:  return makeRegisterExpression(amdgpu_gfx90a::acc40, output_vec_len );
            case 41:  return makeRegisterExpression(amdgpu_gfx90a::acc41, output_vec_len );
            case 42:  return makeRegisterExpression(amdgpu_gfx90a::acc42, output_vec_len );
            case 43:  return makeRegisterExpression(amdgpu_gfx90a::acc43, output_vec_len );
            case 44:  return makeRegisterExpression(amdgpu_gfx90a::acc44, output_vec_len );
            case 45:  return makeRegisterExpression(amdgpu_gfx90a::acc45, output_vec_len );
            case 46:  return makeRegisterExpression(amdgpu_gfx90a::acc46, output_vec_len );
            case 47:  return makeRegisterExpression(amdgpu_gfx90a::acc47, output_vec_len );
            case 48:  return makeRegisterExpression(amdgpu_gfx90a::acc48, output_vec_len );
            case 49:  return makeRegisterExpression(amdgpu_gfx90a::acc49, output_vec_len );
            case 50:  return makeRegisterExpression(amdgpu_gfx90a::acc50, output_vec_len );
            case 51:  return makeRegisterExpression(amdgpu_gfx90a::acc51, output_vec_len );
            case 52:  return makeRegisterExpression(amdgpu_gfx90a::acc52, output_vec_len );
            case 53:  return makeRegisterExpression(amdgpu_gfx90a::acc53, output_vec_len );
            case 54:  return makeRegisterExpression(amdgpu_gfx90a::acc54, output_vec_len );
            case 55:  return makeRegisterExpression(amdgpu_gfx90a::acc55, output_vec_len );
            case 56:  return makeRegisterExpression(amdgpu_gfx90a::acc56, output_vec_len );
            case 57:  return makeRegisterExpression(amdgpu_gfx90a::acc57, output_vec_len );
            case 58:  return makeRegisterExpression(amdgpu_gfx90a::acc58, output_vec_len );
            case 59:  return makeRegisterExpression(amdgpu_gfx90a::acc59, output_vec_len );
            case 60:  return makeRegisterExpression(amdgpu_gfx90a::acc60, output_vec_len );
            case 61:  return makeRegisterExpression(amdgpu_gfx90a::acc61, output_vec_len );
            case 62:  return makeRegisterExpression(amdgpu_gfx90a::acc62, output_vec_len );
            case 63:  return makeRegisterExpression(amdgpu_gfx90a::acc63, output_vec_len );
            case 64:  return makeRegisterExpression(amdgpu_gfx90a::acc64, output_vec_len );
            case 65:  return makeRegisterExpression(amdgpu_gfx90a::acc65, output_vec_len );
            case 66:  return makeRegisterExpression(amdgpu_gfx90a::acc66, output_vec_len );
            case 67:  return makeRegisterExpression(amdgpu_gfx90a::acc67, output_vec_len );
            case 68:  return makeRegisterExpression(amdgpu_gfx90a::acc68, output_vec_len );
            case 69:  return makeRegisterExpression(amdgpu_gfx90a::acc69, output_vec_len );
            case 70:  return makeRegisterExpression(amdgpu_gfx90a::acc70, output_vec_len );
            case 71:  return makeRegisterExpression(amdgpu_gfx90a::acc71, output_vec_len );
            case 72:  return makeRegisterExpression(amdgpu_gfx90a::acc72, output_vec_len );
            case 73:  return makeRegisterExpression(amdgpu_gfx90a::acc73, output_vec_len );
            case 74:  return makeRegisterExpression(amdgpu_gfx90a::acc74, output_vec_len );
            case 75:  return makeRegisterExpression(amdgpu_gfx90a::acc75, output_vec_len );
            case 76:  return makeRegisterExpression(amdgpu_gfx90a::acc76, output_vec_len );
            case 77:  return makeRegisterExpression(amdgpu_gfx90a::acc77, output_vec_len );
            case 78:  return makeRegisterExpression(amdgpu_gfx90a::acc78, output_vec_len );
            case 79:  return makeRegisterExpression(amdgpu_gfx90a::acc79, output_vec_len );
            case 80:  return makeRegisterExpression(amdgpu_gfx90a::acc80, output_vec_len );
            case 81:  return makeRegisterExpression(amdgpu_gfx90a::acc81, output_vec_len );
            case 82:  return makeRegisterExpression(amdgpu_gfx90a::acc82, output_vec_len );
            case 83:  return makeRegisterExpression(amdgpu_gfx90a::acc83, output_vec_len );
            case 84:  return makeRegisterExpression(amdgpu_gfx90a::acc84, output_vec_len );
            case 85:  return makeRegisterExpression(amdgpu_gfx90a::acc85, output_vec_len );
            case 86:  return makeRegisterExpression(amdgpu_gfx90a::acc86, output_vec_len );
            case 87:  return makeRegisterExpression(amdgpu_gfx90a::acc87, output_vec_len );
            case 88:  return makeRegisterExpression(amdgpu_gfx90a::acc88, output_vec_len );
            case 89:  return makeRegisterExpression(amdgpu_gfx90a::acc89, output_vec_len );
            case 90:  return makeRegisterExpression(amdgpu_gfx90a::acc90, output_vec_len );
            case 91:  return makeRegisterExpression(amdgpu_gfx90a::acc91, output_vec_len );
            case 92:  return makeRegisterExpression(amdgpu_gfx90a::acc92, output_vec_len );
            case 93:  return makeRegisterExpression(amdgpu_gfx90a::acc93, output_vec_len );
            case 94:  return makeRegisterExpression(amdgpu_gfx90a::acc94, output_vec_len );
            case 95:  return makeRegisterExpression(amdgpu_gfx90a::acc95, output_vec_len );
            case 96:  return makeRegisterExpression(amdgpu_gfx90a::acc96, output_vec_len );
            case 97:  return makeRegisterExpression(amdgpu_gfx90a::acc97, output_vec_len );
            case 98:  return makeRegisterExpression(amdgpu_gfx90a::acc98, output_vec_len );
            case 99:  return makeRegisterExpression(amdgpu_gfx90a::acc99, output_vec_len );
            case 100:  return makeRegisterExpression(amdgpu_gfx90a::acc100, output_vec_len );
            case 101:  return makeRegisterExpression(amdgpu_gfx90a::acc101, output_vec_len );
            case 102:  return makeRegisterExpression(amdgpu_gfx90a::acc102, output_vec_len );
            case 103:  return makeRegisterExpression(amdgpu_gfx90a::acc103, output_vec_len );
            case 104:  return makeRegisterExpression(amdgpu_gfx90a::acc104, output_vec_len );
            case 105:  return makeRegisterExpression(amdgpu_gfx90a::acc105, output_vec_len );
            case 106:  return makeRegisterExpression(amdgpu_gfx90a::acc106, output_vec_len );
            case 107:  return makeRegisterExpression(amdgpu_gfx90a::acc107, output_vec_len );
            case 108:  return makeRegisterExpression(amdgpu_gfx90a::acc108, output_vec_len );
            case 109:  return makeRegisterExpression(amdgpu_gfx90a::acc109, output_vec_len );
            case 110:  return makeRegisterExpression(amdgpu_gfx90a::acc110, output_vec_len );
            case 111:  return makeRegisterExpression(amdgpu_gfx90a::acc111, output_vec_len );
            case 112:  return makeRegisterExpression(amdgpu_gfx90a::acc112, output_vec_len );
            case 113:  return makeRegisterExpression(amdgpu_gfx90a::acc113, output_vec_len );
            case 114:  return makeRegisterExpression(amdgpu_gfx90a::acc114, output_vec_len );
            case 115:  return makeRegisterExpression(amdgpu_gfx90a::acc115, output_vec_len );
            case 116:  return makeRegisterExpression(amdgpu_gfx90a::acc116, output_vec_len );
            case 117:  return makeRegisterExpression(amdgpu_gfx90a::acc117, output_vec_len );
            case 118:  return makeRegisterExpression(amdgpu_gfx90a::acc118, output_vec_len );
            case 119:  return makeRegisterExpression(amdgpu_gfx90a::acc119, output_vec_len );
            case 120:  return makeRegisterExpression(amdgpu_gfx90a::acc120, output_vec_len );
            case 121:  return makeRegisterExpression(amdgpu_gfx90a::acc121, output_vec_len );
            case 122:  return makeRegisterExpression(amdgpu_gfx90a::acc122, output_vec_len );
            case 123:  return makeRegisterExpression(amdgpu_gfx90a::acc123, output_vec_len );
            case 124:  return makeRegisterExpression(amdgpu_gfx90a::acc124, output_vec_len );
            case 125:  return makeRegisterExpression(amdgpu_gfx90a::acc125, output_vec_len );
            case 126:  return makeRegisterExpression(amdgpu_gfx90a::acc126, output_vec_len );
            case 127:  return makeRegisterExpression(amdgpu_gfx90a::acc127, output_vec_len );
            case 128:  return makeRegisterExpression(amdgpu_gfx90a::acc128, output_vec_len );
            case 129:  return makeRegisterExpression(amdgpu_gfx90a::acc129, output_vec_len );
            case 130:  return makeRegisterExpression(amdgpu_gfx90a::acc130, output_vec_len );
            case 131:  return makeRegisterExpression(amdgpu_gfx90a::acc131, output_vec_len );
            case 132:  return makeRegisterExpression(amdgpu_gfx90a::acc132, output_vec_len );
            case 133:  return makeRegisterExpression(amdgpu_gfx90a::acc133, output_vec_len );
            case 134:  return makeRegisterExpression(amdgpu_gfx90a::acc134, output_vec_len );
            case 135:  return makeRegisterExpression(amdgpu_gfx90a::acc135, output_vec_len );
            case 136:  return makeRegisterExpression(amdgpu_gfx90a::acc136, output_vec_len );
            case 137:  return makeRegisterExpression(amdgpu_gfx90a::acc137, output_vec_len );
            case 138:  return makeRegisterExpression(amdgpu_gfx90a::acc138, output_vec_len );
            case 139:  return makeRegisterExpression(amdgpu_gfx90a::acc139, output_vec_len );
            case 140:  return makeRegisterExpression(amdgpu_gfx90a::acc140, output_vec_len );
            case 141:  return makeRegisterExpression(amdgpu_gfx90a::acc141, output_vec_len );
            case 142:  return makeRegisterExpression(amdgpu_gfx90a::acc142, output_vec_len );
            case 143:  return makeRegisterExpression(amdgpu_gfx90a::acc143, output_vec_len );
            case 144:  return makeRegisterExpression(amdgpu_gfx90a::acc144, output_vec_len );
            case 145:  return makeRegisterExpression(amdgpu_gfx90a::acc145, output_vec_len );
            case 146:  return makeRegisterExpression(amdgpu_gfx90a::acc146, output_vec_len );
            case 147:  return makeRegisterExpression(amdgpu_gfx90a::acc147, output_vec_len );
            case 148:  return makeRegisterExpression(amdgpu_gfx90a::acc148, output_vec_len );
            case 149:  return makeRegisterExpression(amdgpu_gfx90a::acc149, output_vec_len );
            case 150:  return makeRegisterExpression(amdgpu_gfx90a::acc150, output_vec_len );
            case 151:  return makeRegisterExpression(amdgpu_gfx90a::acc151, output_vec_len );
            case 152:  return makeRegisterExpression(amdgpu_gfx90a::acc152, output_vec_len );
            case 153:  return makeRegisterExpression(amdgpu_gfx90a::acc153, output_vec_len );
            case 154:  return makeRegisterExpression(amdgpu_gfx90a::acc154, output_vec_len );
            case 155:  return makeRegisterExpression(amdgpu_gfx90a::acc155, output_vec_len );
            case 156:  return makeRegisterExpression(amdgpu_gfx90a::acc156, output_vec_len );
            case 157:  return makeRegisterExpression(amdgpu_gfx90a::acc157, output_vec_len );
            case 158:  return makeRegisterExpression(amdgpu_gfx90a::acc158, output_vec_len );
            case 159:  return makeRegisterExpression(amdgpu_gfx90a::acc159, output_vec_len );
            case 160:  return makeRegisterExpression(amdgpu_gfx90a::acc160, output_vec_len );
            case 161:  return makeRegisterExpression(amdgpu_gfx90a::acc161, output_vec_len );
            case 162:  return makeRegisterExpression(amdgpu_gfx90a::acc162, output_vec_len );
            case 163:  return makeRegisterExpression(amdgpu_gfx90a::acc163, output_vec_len );
            case 164:  return makeRegisterExpression(amdgpu_gfx90a::acc164, output_vec_len );
            case 165:  return makeRegisterExpression(amdgpu_gfx90a::acc165, output_vec_len );
            case 166:  return makeRegisterExpression(amdgpu_gfx90a::acc166, output_vec_len );
            case 167:  return makeRegisterExpression(amdgpu_gfx90a::acc167, output_vec_len );
            case 168:  return makeRegisterExpression(amdgpu_gfx90a::acc168, output_vec_len );
            case 169:  return makeRegisterExpression(amdgpu_gfx90a::acc169, output_vec_len );
            case 170:  return makeRegisterExpression(amdgpu_gfx90a::acc170, output_vec_len );
            case 171:  return makeRegisterExpression(amdgpu_gfx90a::acc171, output_vec_len );
            case 172:  return makeRegisterExpression(amdgpu_gfx90a::acc172, output_vec_len );
            case 173:  return makeRegisterExpression(amdgpu_gfx90a::acc173, output_vec_len );
            case 174:  return makeRegisterExpression(amdgpu_gfx90a::acc174, output_vec_len );
            case 175:  return makeRegisterExpression(amdgpu_gfx90a::acc175, output_vec_len );
            case 176:  return makeRegisterExpression(amdgpu_gfx90a::acc176, output_vec_len );
            case 177:  return makeRegisterExpression(amdgpu_gfx90a::acc177, output_vec_len );
            case 178:  return makeRegisterExpression(amdgpu_gfx90a::acc178, output_vec_len );
            case 179:  return makeRegisterExpression(amdgpu_gfx90a::acc179, output_vec_len );
            case 180:  return makeRegisterExpression(amdgpu_gfx90a::acc180, output_vec_len );
            case 181:  return makeRegisterExpression(amdgpu_gfx90a::acc181, output_vec_len );
            case 182:  return makeRegisterExpression(amdgpu_gfx90a::acc182, output_vec_len );
            case 183:  return makeRegisterExpression(amdgpu_gfx90a::acc183, output_vec_len );
            case 184:  return makeRegisterExpression(amdgpu_gfx90a::acc184, output_vec_len );
            case 185:  return makeRegisterExpression(amdgpu_gfx90a::acc185, output_vec_len );
            case 186:  return makeRegisterExpression(amdgpu_gfx90a::acc186, output_vec_len );
            case 187:  return makeRegisterExpression(amdgpu_gfx90a::acc187, output_vec_len );
            case 188:  return makeRegisterExpression(amdgpu_gfx90a::acc188, output_vec_len );
            case 189:  return makeRegisterExpression(amdgpu_gfx90a::acc189, output_vec_len );
            case 190:  return makeRegisterExpression(amdgpu_gfx90a::acc190, output_vec_len );
            case 191:  return makeRegisterExpression(amdgpu_gfx90a::acc191, output_vec_len );
            case 192:  return makeRegisterExpression(amdgpu_gfx90a::acc192, output_vec_len );
            case 193:  return makeRegisterExpression(amdgpu_gfx90a::acc193, output_vec_len );
            case 194:  return makeRegisterExpression(amdgpu_gfx90a::acc194, output_vec_len );
            case 195:  return makeRegisterExpression(amdgpu_gfx90a::acc195, output_vec_len );
            case 196:  return makeRegisterExpression(amdgpu_gfx90a::acc196, output_vec_len );
            case 197:  return makeRegisterExpression(amdgpu_gfx90a::acc197, output_vec_len );
            case 198:  return makeRegisterExpression(amdgpu_gfx90a::acc198, output_vec_len );
            case 199:  return makeRegisterExpression(amdgpu_gfx90a::acc199, output_vec_len );
            case 200:  return makeRegisterExpression(amdgpu_gfx90a::acc200, output_vec_len );
            case 201:  return makeRegisterExpression(amdgpu_gfx90a::acc201, output_vec_len );
            case 202:  return makeRegisterExpression(amdgpu_gfx90a::acc202, output_vec_len );
            case 203:  return makeRegisterExpression(amdgpu_gfx90a::acc203, output_vec_len );
            case 204:  return makeRegisterExpression(amdgpu_gfx90a::acc204, output_vec_len );
            case 205:  return makeRegisterExpression(amdgpu_gfx90a::acc205, output_vec_len );
            case 206:  return makeRegisterExpression(amdgpu_gfx90a::acc206, output_vec_len );
            case 207:  return makeRegisterExpression(amdgpu_gfx90a::acc207, output_vec_len );
            case 208:  return makeRegisterExpression(amdgpu_gfx90a::acc208, output_vec_len );
            case 209:  return makeRegisterExpression(amdgpu_gfx90a::acc209, output_vec_len );
            case 210:  return makeRegisterExpression(amdgpu_gfx90a::acc210, output_vec_len );
            case 211:  return makeRegisterExpression(amdgpu_gfx90a::acc211, output_vec_len );
            case 212:  return makeRegisterExpression(amdgpu_gfx90a::acc212, output_vec_len );
            case 213:  return makeRegisterExpression(amdgpu_gfx90a::acc213, output_vec_len );
            case 214:  return makeRegisterExpression(amdgpu_gfx90a::acc214, output_vec_len );
            case 215:  return makeRegisterExpression(amdgpu_gfx90a::acc215, output_vec_len );
            case 216:  return makeRegisterExpression(amdgpu_gfx90a::acc216, output_vec_len );
            case 217:  return makeRegisterExpression(amdgpu_gfx90a::acc217, output_vec_len );
            case 218:  return makeRegisterExpression(amdgpu_gfx90a::acc218, output_vec_len );
            case 219:  return makeRegisterExpression(amdgpu_gfx90a::acc219, output_vec_len );
            case 220:  return makeRegisterExpression(amdgpu_gfx90a::acc220, output_vec_len );
            case 221:  return makeRegisterExpression(amdgpu_gfx90a::acc221, output_vec_len );
            case 222:  return makeRegisterExpression(amdgpu_gfx90a::acc222, output_vec_len );
            case 223:  return makeRegisterExpression(amdgpu_gfx90a::acc223, output_vec_len );
            case 224:  return makeRegisterExpression(amdgpu_gfx90a::acc224, output_vec_len );
            case 225:  return makeRegisterExpression(amdgpu_gfx90a::acc225, output_vec_len );
            case 226:  return makeRegisterExpression(amdgpu_gfx90a::acc226, output_vec_len );
            case 227:  return makeRegisterExpression(amdgpu_gfx90a::acc227, output_vec_len );
            case 228:  return makeRegisterExpression(amdgpu_gfx90a::acc228, output_vec_len );
            case 229:  return makeRegisterExpression(amdgpu_gfx90a::acc229, output_vec_len );
            case 230:  return makeRegisterExpression(amdgpu_gfx90a::acc230, output_vec_len );
            case 231:  return makeRegisterExpression(amdgpu_gfx90a::acc231, output_vec_len );
            case 232:  return makeRegisterExpression(amdgpu_gfx90a::acc232, output_vec_len );
            case 233:  return makeRegisterExpression(amdgpu_gfx90a::acc233, output_vec_len );
            case 234:  return makeRegisterExpression(amdgpu_gfx90a::acc234, output_vec_len );
            case 235:  return makeRegisterExpression(amdgpu_gfx90a::acc235, output_vec_len );
            case 236:  return makeRegisterExpression(amdgpu_gfx90a::acc236, output_vec_len );
            case 237:  return makeRegisterExpression(amdgpu_gfx90a::acc237, output_vec_len );
            case 238:  return makeRegisterExpression(amdgpu_gfx90a::acc238, output_vec_len );
            case 239:  return makeRegisterExpression(amdgpu_gfx90a::acc239, output_vec_len );
            case 240:  return makeRegisterExpression(amdgpu_gfx90a::acc240, output_vec_len );
            case 241:  return makeRegisterExpression(amdgpu_gfx90a::acc241, output_vec_len );
            case 242:  return makeRegisterExpression(amdgpu_gfx90a::acc242, output_vec_len );
            case 243:  return makeRegisterExpression(amdgpu_gfx90a::acc243, output_vec_len );
            case 244:  return makeRegisterExpression(amdgpu_gfx90a::acc244, output_vec_len );
            case 245:  return makeRegisterExpression(amdgpu_gfx90a::acc245, output_vec_len );
            case 246:  return makeRegisterExpression(amdgpu_gfx90a::acc246, output_vec_len );
            case 247:  return makeRegisterExpression(amdgpu_gfx90a::acc247, output_vec_len );
            case 248:  return makeRegisterExpression(amdgpu_gfx90a::acc248, output_vec_len );
            case 249:  return makeRegisterExpression(amdgpu_gfx90a::acc249, output_vec_len );
            case 250:  return makeRegisterExpression(amdgpu_gfx90a::acc250, output_vec_len );
            case 251:  return makeRegisterExpression(amdgpu_gfx90a::acc251, output_vec_len );
            case 252:  return makeRegisterExpression(amdgpu_gfx90a::acc252, output_vec_len );
            case 253:  return makeRegisterExpression(amdgpu_gfx90a::acc253, output_vec_len );
            case 254:  return makeRegisterExpression(amdgpu_gfx90a::acc254, output_vec_len );
            case 255:  return makeRegisterExpression(amdgpu_gfx90a::acc255, output_vec_len );
            case 512:  return makeRegisterExpression(amdgpu_gfx90a::acc0, output_vec_len );
            case 513:  return makeRegisterExpression(amdgpu_gfx90a::acc1, output_vec_len );
            case 514:  return makeRegisterExpression(amdgpu_gfx90a::acc2, output_vec_len );
            case 515:  return makeRegisterExpression(amdgpu_gfx90a::acc3, output_vec_len );
            case 516:  return makeRegisterExpression(amdgpu_gfx90a::acc4, output_vec_len );
            case 517:  return makeRegisterExpression(amdgpu_gfx90a::acc5, output_vec_len );
            case 518:  return makeRegisterExpression(amdgpu_gfx90a::acc6, output_vec_len );
            case 519:  return makeRegisterExpression(amdgpu_gfx90a::acc7, output_vec_len );
            case 520:  return makeRegisterExpression(amdgpu_gfx90a::acc8, output_vec_len );
            case 521:  return makeRegisterExpression(amdgpu_gfx90a::acc9, output_vec_len );
            case 522:  return makeRegisterExpression(amdgpu_gfx90a::acc10, output_vec_len );
            case 523:  return makeRegisterExpression(amdgpu_gfx90a::acc11, output_vec_len );
            case 524:  return makeRegisterExpression(amdgpu_gfx90a::acc12, output_vec_len );
            case 525:  return makeRegisterExpression(amdgpu_gfx90a::acc13, output_vec_len );
            case 526:  return makeRegisterExpression(amdgpu_gfx90a::acc14, output_vec_len );
            case 527:  return makeRegisterExpression(amdgpu_gfx90a::acc15, output_vec_len );
            case 528:  return makeRegisterExpression(amdgpu_gfx90a::acc16, output_vec_len );
            case 529:  return makeRegisterExpression(amdgpu_gfx90a::acc17, output_vec_len );
            case 530:  return makeRegisterExpression(amdgpu_gfx90a::acc18, output_vec_len );
            case 531:  return makeRegisterExpression(amdgpu_gfx90a::acc19, output_vec_len );
            case 532:  return makeRegisterExpression(amdgpu_gfx90a::acc20, output_vec_len );
            case 533:  return makeRegisterExpression(amdgpu_gfx90a::acc21, output_vec_len );
            case 534:  return makeRegisterExpression(amdgpu_gfx90a::acc22, output_vec_len );
            case 535:  return makeRegisterExpression(amdgpu_gfx90a::acc23, output_vec_len );
            case 536:  return makeRegisterExpression(amdgpu_gfx90a::acc24, output_vec_len );
            case 537:  return makeRegisterExpression(amdgpu_gfx90a::acc25, output_vec_len );
            case 538:  return makeRegisterExpression(amdgpu_gfx90a::acc26, output_vec_len );
            case 539:  return makeRegisterExpression(amdgpu_gfx90a::acc27, output_vec_len );
            case 540:  return makeRegisterExpression(amdgpu_gfx90a::acc28, output_vec_len );
            case 541:  return makeRegisterExpression(amdgpu_gfx90a::acc29, output_vec_len );
            case 542:  return makeRegisterExpression(amdgpu_gfx90a::acc30, output_vec_len );
            case 543:  return makeRegisterExpression(amdgpu_gfx90a::acc31, output_vec_len );
            case 544:  return makeRegisterExpression(amdgpu_gfx90a::acc32, output_vec_len );
            case 545:  return makeRegisterExpression(amdgpu_gfx90a::acc33, output_vec_len );
            case 546:  return makeRegisterExpression(amdgpu_gfx90a::acc34, output_vec_len );
            case 547:  return makeRegisterExpression(amdgpu_gfx90a::acc35, output_vec_len );
            case 548:  return makeRegisterExpression(amdgpu_gfx90a::acc36, output_vec_len );
            case 549:  return makeRegisterExpression(amdgpu_gfx90a::acc37, output_vec_len );
            case 550:  return makeRegisterExpression(amdgpu_gfx90a::acc38, output_vec_len );
            case 551:  return makeRegisterExpression(amdgpu_gfx90a::acc39, output_vec_len );
            case 552:  return makeRegisterExpression(amdgpu_gfx90a::acc40, output_vec_len );
            case 553:  return makeRegisterExpression(amdgpu_gfx90a::acc41, output_vec_len );
            case 554:  return makeRegisterExpression(amdgpu_gfx90a::acc42, output_vec_len );
            case 555:  return makeRegisterExpression(amdgpu_gfx90a::acc43, output_vec_len );
            case 556:  return makeRegisterExpression(amdgpu_gfx90a::acc44, output_vec_len );
            case 557:  return makeRegisterExpression(amdgpu_gfx90a::acc45, output_vec_len );
            case 558:  return makeRegisterExpression(amdgpu_gfx90a::acc46, output_vec_len );
            case 559:  return makeRegisterExpression(amdgpu_gfx90a::acc47, output_vec_len );
            case 560:  return makeRegisterExpression(amdgpu_gfx90a::acc48, output_vec_len );
            case 561:  return makeRegisterExpression(amdgpu_gfx90a::acc49, output_vec_len );
            case 562:  return makeRegisterExpression(amdgpu_gfx90a::acc50, output_vec_len );
            case 563:  return makeRegisterExpression(amdgpu_gfx90a::acc51, output_vec_len );
            case 564:  return makeRegisterExpression(amdgpu_gfx90a::acc52, output_vec_len );
            case 565:  return makeRegisterExpression(amdgpu_gfx90a::acc53, output_vec_len );
            case 566:  return makeRegisterExpression(amdgpu_gfx90a::acc54, output_vec_len );
            case 567:  return makeRegisterExpression(amdgpu_gfx90a::acc55, output_vec_len );
            case 568:  return makeRegisterExpression(amdgpu_gfx90a::acc56, output_vec_len );
            case 569:  return makeRegisterExpression(amdgpu_gfx90a::acc57, output_vec_len );
            case 570:  return makeRegisterExpression(amdgpu_gfx90a::acc58, output_vec_len );
            case 571:  return makeRegisterExpression(amdgpu_gfx90a::acc59, output_vec_len );
            case 572:  return makeRegisterExpression(amdgpu_gfx90a::acc60, output_vec_len );
            case 573:  return makeRegisterExpression(amdgpu_gfx90a::acc61, output_vec_len );
            case 574:  return makeRegisterExpression(amdgpu_gfx90a::acc62, output_vec_len );
            case 575:  return makeRegisterExpression(amdgpu_gfx90a::acc63, output_vec_len );
            case 576:  return makeRegisterExpression(amdgpu_gfx90a::acc64, output_vec_len );
            case 577:  return makeRegisterExpression(amdgpu_gfx90a::acc65, output_vec_len );
            case 578:  return makeRegisterExpression(amdgpu_gfx90a::acc66, output_vec_len );
            case 579:  return makeRegisterExpression(amdgpu_gfx90a::acc67, output_vec_len );
            case 580:  return makeRegisterExpression(amdgpu_gfx90a::acc68, output_vec_len );
            case 581:  return makeRegisterExpression(amdgpu_gfx90a::acc69, output_vec_len );
            case 582:  return makeRegisterExpression(amdgpu_gfx90a::acc70, output_vec_len );
            case 583:  return makeRegisterExpression(amdgpu_gfx90a::acc71, output_vec_len );
            case 584:  return makeRegisterExpression(amdgpu_gfx90a::acc72, output_vec_len );
            case 585:  return makeRegisterExpression(amdgpu_gfx90a::acc73, output_vec_len );
            case 586:  return makeRegisterExpression(amdgpu_gfx90a::acc74, output_vec_len );
            case 587:  return makeRegisterExpression(amdgpu_gfx90a::acc75, output_vec_len );
            case 588:  return makeRegisterExpression(amdgpu_gfx90a::acc76, output_vec_len );
            case 589:  return makeRegisterExpression(amdgpu_gfx90a::acc77, output_vec_len );
            case 590:  return makeRegisterExpression(amdgpu_gfx90a::acc78, output_vec_len );
            case 591:  return makeRegisterExpression(amdgpu_gfx90a::acc79, output_vec_len );
            case 592:  return makeRegisterExpression(amdgpu_gfx90a::acc80, output_vec_len );
            case 593:  return makeRegisterExpression(amdgpu_gfx90a::acc81, output_vec_len );
            case 594:  return makeRegisterExpression(amdgpu_gfx90a::acc82, output_vec_len );
            case 595:  return makeRegisterExpression(amdgpu_gfx90a::acc83, output_vec_len );
            case 596:  return makeRegisterExpression(amdgpu_gfx90a::acc84, output_vec_len );
            case 597:  return makeRegisterExpression(amdgpu_gfx90a::acc85, output_vec_len );
            case 598:  return makeRegisterExpression(amdgpu_gfx90a::acc86, output_vec_len );
            case 599:  return makeRegisterExpression(amdgpu_gfx90a::acc87, output_vec_len );
            case 600:  return makeRegisterExpression(amdgpu_gfx90a::acc88, output_vec_len );
            case 601:  return makeRegisterExpression(amdgpu_gfx90a::acc89, output_vec_len );
            case 602:  return makeRegisterExpression(amdgpu_gfx90a::acc90, output_vec_len );
            case 603:  return makeRegisterExpression(amdgpu_gfx90a::acc91, output_vec_len );
            case 604:  return makeRegisterExpression(amdgpu_gfx90a::acc92, output_vec_len );
            case 605:  return makeRegisterExpression(amdgpu_gfx90a::acc93, output_vec_len );
            case 606:  return makeRegisterExpression(amdgpu_gfx90a::acc94, output_vec_len );
            case 607:  return makeRegisterExpression(amdgpu_gfx90a::acc95, output_vec_len );
            case 608:  return makeRegisterExpression(amdgpu_gfx90a::acc96, output_vec_len );
            case 609:  return makeRegisterExpression(amdgpu_gfx90a::acc97, output_vec_len );
            case 610:  return makeRegisterExpression(amdgpu_gfx90a::acc98, output_vec_len );
            case 611:  return makeRegisterExpression(amdgpu_gfx90a::acc99, output_vec_len );
            case 612:  return makeRegisterExpression(amdgpu_gfx90a::acc100, output_vec_len );
            case 613:  return makeRegisterExpression(amdgpu_gfx90a::acc101, output_vec_len );
            case 614:  return makeRegisterExpression(amdgpu_gfx90a::acc102, output_vec_len );
            case 615:  return makeRegisterExpression(amdgpu_gfx90a::acc103, output_vec_len );
            case 616:  return makeRegisterExpression(amdgpu_gfx90a::acc104, output_vec_len );
            case 617:  return makeRegisterExpression(amdgpu_gfx90a::acc105, output_vec_len );
            case 618:  return makeRegisterExpression(amdgpu_gfx90a::acc106, output_vec_len );
            case 619:  return makeRegisterExpression(amdgpu_gfx90a::acc107, output_vec_len );
            case 620:  return makeRegisterExpression(amdgpu_gfx90a::acc108, output_vec_len );
            case 621:  return makeRegisterExpression(amdgpu_gfx90a::acc109, output_vec_len );
            case 622:  return makeRegisterExpression(amdgpu_gfx90a::acc110, output_vec_len );
            case 623:  return makeRegisterExpression(amdgpu_gfx90a::acc111, output_vec_len );
            case 624:  return makeRegisterExpression(amdgpu_gfx90a::acc112, output_vec_len );
            case 625:  return makeRegisterExpression(amdgpu_gfx90a::acc113, output_vec_len );
            case 626:  return makeRegisterExpression(amdgpu_gfx90a::acc114, output_vec_len );
            case 627:  return makeRegisterExpression(amdgpu_gfx90a::acc115, output_vec_len );
            case 628:  return makeRegisterExpression(amdgpu_gfx90a::acc116, output_vec_len );
            case 629:  return makeRegisterExpression(amdgpu_gfx90a::acc117, output_vec_len );
            case 630:  return makeRegisterExpression(amdgpu_gfx90a::acc118, output_vec_len );
            case 631:  return makeRegisterExpression(amdgpu_gfx90a::acc119, output_vec_len );
            case 632:  return makeRegisterExpression(amdgpu_gfx90a::acc120, output_vec_len );
            case 633:  return makeRegisterExpression(amdgpu_gfx90a::acc121, output_vec_len );
            case 634:  return makeRegisterExpression(amdgpu_gfx90a::acc122, output_vec_len );
            case 635:  return makeRegisterExpression(amdgpu_gfx90a::acc123, output_vec_len );
            case 636:  return makeRegisterExpression(amdgpu_gfx90a::acc124, output_vec_len );
            case 637:  return makeRegisterExpression(amdgpu_gfx90a::acc125, output_vec_len );
            case 638:  return makeRegisterExpression(amdgpu_gfx90a::acc126, output_vec_len );
            case 639:  return makeRegisterExpression(amdgpu_gfx90a::acc127, output_vec_len );
            case 640:  return makeRegisterExpression(amdgpu_gfx90a::acc128, output_vec_len );
            case 641:  return makeRegisterExpression(amdgpu_gfx90a::acc129, output_vec_len );
            case 642:  return makeRegisterExpression(amdgpu_gfx90a::acc130, output_vec_len );
            case 643:  return makeRegisterExpression(amdgpu_gfx90a::acc131, output_vec_len );
            case 644:  return makeRegisterExpression(amdgpu_gfx90a::acc132, output_vec_len );
            case 645:  return makeRegisterExpression(amdgpu_gfx90a::acc133, output_vec_len );
            case 646:  return makeRegisterExpression(amdgpu_gfx90a::acc134, output_vec_len );
            case 647:  return makeRegisterExpression(amdgpu_gfx90a::acc135, output_vec_len );
            case 648:  return makeRegisterExpression(amdgpu_gfx90a::acc136, output_vec_len );
            case 649:  return makeRegisterExpression(amdgpu_gfx90a::acc137, output_vec_len );
            case 650:  return makeRegisterExpression(amdgpu_gfx90a::acc138, output_vec_len );
            case 651:  return makeRegisterExpression(amdgpu_gfx90a::acc139, output_vec_len );
            case 652:  return makeRegisterExpression(amdgpu_gfx90a::acc140, output_vec_len );
            case 653:  return makeRegisterExpression(amdgpu_gfx90a::acc141, output_vec_len );
            case 654:  return makeRegisterExpression(amdgpu_gfx90a::acc142, output_vec_len );
            case 655:  return makeRegisterExpression(amdgpu_gfx90a::acc143, output_vec_len );
            case 656:  return makeRegisterExpression(amdgpu_gfx90a::acc144, output_vec_len );
            case 657:  return makeRegisterExpression(amdgpu_gfx90a::acc145, output_vec_len );
            case 658:  return makeRegisterExpression(amdgpu_gfx90a::acc146, output_vec_len );
            case 659:  return makeRegisterExpression(amdgpu_gfx90a::acc147, output_vec_len );
            case 660:  return makeRegisterExpression(amdgpu_gfx90a::acc148, output_vec_len );
            case 661:  return makeRegisterExpression(amdgpu_gfx90a::acc149, output_vec_len );
            case 662:  return makeRegisterExpression(amdgpu_gfx90a::acc150, output_vec_len );
            case 663:  return makeRegisterExpression(amdgpu_gfx90a::acc151, output_vec_len );
            case 664:  return makeRegisterExpression(amdgpu_gfx90a::acc152, output_vec_len );
            case 665:  return makeRegisterExpression(amdgpu_gfx90a::acc153, output_vec_len );
            case 666:  return makeRegisterExpression(amdgpu_gfx90a::acc154, output_vec_len );
            case 667:  return makeRegisterExpression(amdgpu_gfx90a::acc155, output_vec_len );
            case 668:  return makeRegisterExpression(amdgpu_gfx90a::acc156, output_vec_len );
            case 669:  return makeRegisterExpression(amdgpu_gfx90a::acc157, output_vec_len );
            case 670:  return makeRegisterExpression(amdgpu_gfx90a::acc158, output_vec_len );
            case 671:  return makeRegisterExpression(amdgpu_gfx90a::acc159, output_vec_len );
            case 672:  return makeRegisterExpression(amdgpu_gfx90a::acc160, output_vec_len );
            case 673:  return makeRegisterExpression(amdgpu_gfx90a::acc161, output_vec_len );
            case 674:  return makeRegisterExpression(amdgpu_gfx90a::acc162, output_vec_len );
            case 675:  return makeRegisterExpression(amdgpu_gfx90a::acc163, output_vec_len );
            case 676:  return makeRegisterExpression(amdgpu_gfx90a::acc164, output_vec_len );
            case 677:  return makeRegisterExpression(amdgpu_gfx90a::acc165, output_vec_len );
            case 678:  return makeRegisterExpression(amdgpu_gfx90a::acc166, output_vec_len );
            case 679:  return makeRegisterExpression(amdgpu_gfx90a::acc167, output_vec_len );
            case 680:  return makeRegisterExpression(amdgpu_gfx90a::acc168, output_vec_len );
            case 681:  return makeRegisterExpression(amdgpu_gfx90a::acc169, output_vec_len );
            case 682:  return makeRegisterExpression(amdgpu_gfx90a::acc170, output_vec_len );
            case 683:  return makeRegisterExpression(amdgpu_gfx90a::acc171, output_vec_len );
            case 684:  return makeRegisterExpression(amdgpu_gfx90a::acc172, output_vec_len );
            case 685:  return makeRegisterExpression(amdgpu_gfx90a::acc173, output_vec_len );
            case 686:  return makeRegisterExpression(amdgpu_gfx90a::acc174, output_vec_len );
            case 687:  return makeRegisterExpression(amdgpu_gfx90a::acc175, output_vec_len );
            case 688:  return makeRegisterExpression(amdgpu_gfx90a::acc176, output_vec_len );
            case 689:  return makeRegisterExpression(amdgpu_gfx90a::acc177, output_vec_len );
            case 690:  return makeRegisterExpression(amdgpu_gfx90a::acc178, output_vec_len );
            case 691:  return makeRegisterExpression(amdgpu_gfx90a::acc179, output_vec_len );
            case 692:  return makeRegisterExpression(amdgpu_gfx90a::acc180, output_vec_len );
            case 693:  return makeRegisterExpression(amdgpu_gfx90a::acc181, output_vec_len );
            case 694:  return makeRegisterExpression(amdgpu_gfx90a::acc182, output_vec_len );
            case 695:  return makeRegisterExpression(amdgpu_gfx90a::acc183, output_vec_len );
            case 696:  return makeRegisterExpression(amdgpu_gfx90a::acc184, output_vec_len );
            case 697:  return makeRegisterExpression(amdgpu_gfx90a::acc185, output_vec_len );
            case 698:  return makeRegisterExpression(amdgpu_gfx90a::acc186, output_vec_len );
            case 699:  return makeRegisterExpression(amdgpu_gfx90a::acc187, output_vec_len );
            case 700:  return makeRegisterExpression(amdgpu_gfx90a::acc188, output_vec_len );
            case 701:  return makeRegisterExpression(amdgpu_gfx90a::acc189, output_vec_len );
            case 702:  return makeRegisterExpression(amdgpu_gfx90a::acc190, output_vec_len );
            case 703:  return makeRegisterExpression(amdgpu_gfx90a::acc191, output_vec_len );
            case 704:  return makeRegisterExpression(amdgpu_gfx90a::acc192, output_vec_len );
            case 705:  return makeRegisterExpression(amdgpu_gfx90a::acc193, output_vec_len );
            case 706:  return makeRegisterExpression(amdgpu_gfx90a::acc194, output_vec_len );
            case 707:  return makeRegisterExpression(amdgpu_gfx90a::acc195, output_vec_len );
            case 708:  return makeRegisterExpression(amdgpu_gfx90a::acc196, output_vec_len );
            case 709:  return makeRegisterExpression(amdgpu_gfx90a::acc197, output_vec_len );
            case 710:  return makeRegisterExpression(amdgpu_gfx90a::acc198, output_vec_len );
            case 711:  return makeRegisterExpression(amdgpu_gfx90a::acc199, output_vec_len );
            case 712:  return makeRegisterExpression(amdgpu_gfx90a::acc200, output_vec_len );
            case 713:  return makeRegisterExpression(amdgpu_gfx90a::acc201, output_vec_len );
            case 714:  return makeRegisterExpression(amdgpu_gfx90a::acc202, output_vec_len );
            case 715:  return makeRegisterExpression(amdgpu_gfx90a::acc203, output_vec_len );
            case 716:  return makeRegisterExpression(amdgpu_gfx90a::acc204, output_vec_len );
            case 717:  return makeRegisterExpression(amdgpu_gfx90a::acc205, output_vec_len );
            case 718:  return makeRegisterExpression(amdgpu_gfx90a::acc206, output_vec_len );
            case 719:  return makeRegisterExpression(amdgpu_gfx90a::acc207, output_vec_len );
            case 720:  return makeRegisterExpression(amdgpu_gfx90a::acc208, output_vec_len );
            case 721:  return makeRegisterExpression(amdgpu_gfx90a::acc209, output_vec_len );
            case 722:  return makeRegisterExpression(amdgpu_gfx90a::acc210, output_vec_len );
            case 723:  return makeRegisterExpression(amdgpu_gfx90a::acc211, output_vec_len );
            case 724:  return makeRegisterExpression(amdgpu_gfx90a::acc212, output_vec_len );
            case 725:  return makeRegisterExpression(amdgpu_gfx90a::acc213, output_vec_len );
            case 726:  return makeRegisterExpression(amdgpu_gfx90a::acc214, output_vec_len );
            case 727:  return makeRegisterExpression(amdgpu_gfx90a::acc215, output_vec_len );
            case 728:  return makeRegisterExpression(amdgpu_gfx90a::acc216, output_vec_len );
            case 729:  return makeRegisterExpression(amdgpu_gfx90a::acc217, output_vec_len );
            case 730:  return makeRegisterExpression(amdgpu_gfx90a::acc218, output_vec_len );
            case 731:  return makeRegisterExpression(amdgpu_gfx90a::acc219, output_vec_len );
            case 732:  return makeRegisterExpression(amdgpu_gfx90a::acc220, output_vec_len );
            case 733:  return makeRegisterExpression(amdgpu_gfx90a::acc221, output_vec_len );
            case 734:  return makeRegisterExpression(amdgpu_gfx90a::acc222, output_vec_len );
            case 735:  return makeRegisterExpression(amdgpu_gfx90a::acc223, output_vec_len );
            case 736:  return makeRegisterExpression(amdgpu_gfx90a::acc224, output_vec_len );
            case 737:  return makeRegisterExpression(amdgpu_gfx90a::acc225, output_vec_len );
            case 738:  return makeRegisterExpression(amdgpu_gfx90a::acc226, output_vec_len );
            case 739:  return makeRegisterExpression(amdgpu_gfx90a::acc227, output_vec_len );
            case 740:  return makeRegisterExpression(amdgpu_gfx90a::acc228, output_vec_len );
            case 741:  return makeRegisterExpression(amdgpu_gfx90a::acc229, output_vec_len );
            case 742:  return makeRegisterExpression(amdgpu_gfx90a::acc230, output_vec_len );
            case 743:  return makeRegisterExpression(amdgpu_gfx90a::acc231, output_vec_len );
            case 744:  return makeRegisterExpression(amdgpu_gfx90a::acc232, output_vec_len );
            case 745:  return makeRegisterExpression(amdgpu_gfx90a::acc233, output_vec_len );
            case 746:  return makeRegisterExpression(amdgpu_gfx90a::acc234, output_vec_len );
            case 747:  return makeRegisterExpression(amdgpu_gfx90a::acc235, output_vec_len );
            case 748:  return makeRegisterExpression(amdgpu_gfx90a::acc236, output_vec_len );
            case 749:  return makeRegisterExpression(amdgpu_gfx90a::acc237, output_vec_len );
            case 750:  return makeRegisterExpression(amdgpu_gfx90a::acc238, output_vec_len );
            case 751:  return makeRegisterExpression(amdgpu_gfx90a::acc239, output_vec_len );
            case 752:  return makeRegisterExpression(amdgpu_gfx90a::acc240, output_vec_len );
            case 753:  return makeRegisterExpression(amdgpu_gfx90a::acc241, output_vec_len );
            case 754:  return makeRegisterExpression(amdgpu_gfx90a::acc242, output_vec_len );
            case 755:  return makeRegisterExpression(amdgpu_gfx90a::acc243, output_vec_len );
            case 756:  return makeRegisterExpression(amdgpu_gfx90a::acc244, output_vec_len );
            case 757:  return makeRegisterExpression(amdgpu_gfx90a::acc245, output_vec_len );
            case 758:  return makeRegisterExpression(amdgpu_gfx90a::acc246, output_vec_len );
            case 759:  return makeRegisterExpression(amdgpu_gfx90a::acc247, output_vec_len );
            case 760:  return makeRegisterExpression(amdgpu_gfx90a::acc248, output_vec_len );
            case 761:  return makeRegisterExpression(amdgpu_gfx90a::acc249, output_vec_len );
            case 762:  return makeRegisterExpression(amdgpu_gfx90a::acc250, output_vec_len );
            case 763:  return makeRegisterExpression(amdgpu_gfx90a::acc251, output_vec_len );
            case 764:  return makeRegisterExpression(amdgpu_gfx90a::acc252, output_vec_len );
            case 765:  return makeRegisterExpression(amdgpu_gfx90a::acc253, output_vec_len );
            case 766:  return makeRegisterExpression(amdgpu_gfx90a::acc254, output_vec_len );
            case 767:  return makeRegisterExpression(amdgpu_gfx90a::acc255, output_vec_len );
            default: return makeRegisterExpression(amdgpu_gfx90a::invalid);
        }
    }

    Expression::Ptr InstructionDecoder_amdgpu_gfx90a::decodeOPR_DSMEM(uint64_t input, uint32_t output_vec_len)
    {
        switch (input)  {
            case 0:  return makeRegisterExpression(amdgpu_gfx90a::dsmem, output_vec_len );
            default: return makeRegisterExpression(amdgpu_gfx90a::invalid);
        }
    }

    Expression::Ptr InstructionDecoder_amdgpu_gfx90a::decodeOPR_FLAT_SCRATCH(uint64_t input, uint32_t output_vec_len)
    {
        switch (input)  {
            case 0:  return makeRegisterExpression(amdgpu_gfx90a::flat_scratch_all, output_vec_len );
            default: return makeRegisterExpression(amdgpu_gfx90a::invalid);
        }
    }

    Expression::Ptr InstructionDecoder_amdgpu_gfx90a::decodeOPR_PC(uint64_t input, uint32_t )
    {
        switch (input)  {
            case 0:  return makeRegisterExpression(amdgpu_gfx90a::pc_all);
            default: return makeRegisterExpression(amdgpu_gfx90a::invalid);
        }
    }

    Expression::Ptr InstructionDecoder_amdgpu_gfx90a::decodeOPR_SDST(uint64_t input, uint32_t output_vec_len)
    {
        switch (input)  {
            case 0:  return makeRegisterExpression(amdgpu_gfx90a::s0, output_vec_len );
            case 1:  return makeRegisterExpression(amdgpu_gfx90a::s1, output_vec_len );
            case 2:  return makeRegisterExpression(amdgpu_gfx90a::s2, output_vec_len );
            case 3:  return makeRegisterExpression(amdgpu_gfx90a::s3, output_vec_len );
            case 4:  return makeRegisterExpression(amdgpu_gfx90a::s4, output_vec_len );
            case 5:  return makeRegisterExpression(amdgpu_gfx90a::s5, output_vec_len );
            case 6:  return makeRegisterExpression(amdgpu_gfx90a::s6, output_vec_len );
            case 7:  return makeRegisterExpression(amdgpu_gfx90a::s7, output_vec_len );
            case 8:  return makeRegisterExpression(amdgpu_gfx90a::s8, output_vec_len );
            case 9:  return makeRegisterExpression(amdgpu_gfx90a::s9, output_vec_len );
            case 10:  return makeRegisterExpression(amdgpu_gfx90a::s10, output_vec_len );
            case 11:  return makeRegisterExpression(amdgpu_gfx90a::s11, output_vec_len );
            case 12:  return makeRegisterExpression(amdgpu_gfx90a::s12, output_vec_len );
            case 13:  return makeRegisterExpression(amdgpu_gfx90a::s13, output_vec_len );
            case 14:  return makeRegisterExpression(amdgpu_gfx90a::s14, output_vec_len );
            case 15:  return makeRegisterExpression(amdgpu_gfx90a::s15, output_vec_len );
            case 16:  return makeRegisterExpression(amdgpu_gfx90a::s16, output_vec_len );
            case 17:  return makeRegisterExpression(amdgpu_gfx90a::s17, output_vec_len );
            case 18:  return makeRegisterExpression(amdgpu_gfx90a::s18, output_vec_len );
            case 19:  return makeRegisterExpression(amdgpu_gfx90a::s19, output_vec_len );
            case 20:  return makeRegisterExpression(amdgpu_gfx90a::s20, output_vec_len );
            case 21:  return makeRegisterExpression(amdgpu_gfx90a::s21, output_vec_len );
            case 22:  return makeRegisterExpression(amdgpu_gfx90a::s22, output_vec_len );
            case 23:  return makeRegisterExpression(amdgpu_gfx90a::s23, output_vec_len );
            case 24:  return makeRegisterExpression(amdgpu_gfx90a::s24, output_vec_len );
            case 25:  return makeRegisterExpression(amdgpu_gfx90a::s25, output_vec_len );
            case 26:  return makeRegisterExpression(amdgpu_gfx90a::s26, output_vec_len );
            case 27:  return makeRegisterExpression(amdgpu_gfx90a::s27, output_vec_len );
            case 28:  return makeRegisterExpression(amdgpu_gfx90a::s28, output_vec_len );
            case 29:  return makeRegisterExpression(amdgpu_gfx90a::s29, output_vec_len );
            case 30:  return makeRegisterExpression(amdgpu_gfx90a::s30, output_vec_len );
            case 31:  return makeRegisterExpression(amdgpu_gfx90a::s31, output_vec_len );
            case 32:  return makeRegisterExpression(amdgpu_gfx90a::s32, output_vec_len );
            case 33:  return makeRegisterExpression(amdgpu_gfx90a::s33, output_vec_len );
            case 34:  return makeRegisterExpression(amdgpu_gfx90a::s34, output_vec_len );
            case 35:  return makeRegisterExpression(amdgpu_gfx90a::s35, output_vec_len );
            case 36:  return makeRegisterExpression(amdgpu_gfx90a::s36, output_vec_len );
            case 37:  return makeRegisterExpression(amdgpu_gfx90a::s37, output_vec_len );
            case 38:  return makeRegisterExpression(amdgpu_gfx90a::s38, output_vec_len );
            case 39:  return makeRegisterExpression(amdgpu_gfx90a::s39, output_vec_len );
            case 40:  return makeRegisterExpression(amdgpu_gfx90a::s40, output_vec_len );
            case 41:  return makeRegisterExpression(amdgpu_gfx90a::s41, output_vec_len );
            case 42:  return makeRegisterExpression(amdgpu_gfx90a::s42, output_vec_len );
            case 43:  return makeRegisterExpression(amdgpu_gfx90a::s43, output_vec_len );
            case 44:  return makeRegisterExpression(amdgpu_gfx90a::s44, output_vec_len );
            case 45:  return makeRegisterExpression(amdgpu_gfx90a::s45, output_vec_len );
            case 46:  return makeRegisterExpression(amdgpu_gfx90a::s46, output_vec_len );
            case 47:  return makeRegisterExpression(amdgpu_gfx90a::s47, output_vec_len );
            case 48:  return makeRegisterExpression(amdgpu_gfx90a::s48, output_vec_len );
            case 49:  return makeRegisterExpression(amdgpu_gfx90a::s49, output_vec_len );
            case 50:  return makeRegisterExpression(amdgpu_gfx90a::s50, output_vec_len );
            case 51:  return makeRegisterExpression(amdgpu_gfx90a::s51, output_vec_len );
            case 52:  return makeRegisterExpression(amdgpu_gfx90a::s52, output_vec_len );
            case 53:  return makeRegisterExpression(amdgpu_gfx90a::s53, output_vec_len );
            case 54:  return makeRegisterExpression(amdgpu_gfx90a::s54, output_vec_len );
            case 55:  return makeRegisterExpression(amdgpu_gfx90a::s55, output_vec_len );
            case 56:  return makeRegisterExpression(amdgpu_gfx90a::s56, output_vec_len );
            case 57:  return makeRegisterExpression(amdgpu_gfx90a::s57, output_vec_len );
            case 58:  return makeRegisterExpression(amdgpu_gfx90a::s58, output_vec_len );
            case 59:  return makeRegisterExpression(amdgpu_gfx90a::s59, output_vec_len );
            case 60:  return makeRegisterExpression(amdgpu_gfx90a::s60, output_vec_len );
            case 61:  return makeRegisterExpression(amdgpu_gfx90a::s61, output_vec_len );
            case 62:  return makeRegisterExpression(amdgpu_gfx90a::s62, output_vec_len );
            case 63:  return makeRegisterExpression(amdgpu_gfx90a::s63, output_vec_len );
            case 64:  return makeRegisterExpression(amdgpu_gfx90a::s64, output_vec_len );
            case 65:  return makeRegisterExpression(amdgpu_gfx90a::s65, output_vec_len );
            case 66:  return makeRegisterExpression(amdgpu_gfx90a::s66, output_vec_len );
            case 67:  return makeRegisterExpression(amdgpu_gfx90a::s67, output_vec_len );
            case 68:  return makeRegisterExpression(amdgpu_gfx90a::s68, output_vec_len );
            case 69:  return makeRegisterExpression(amdgpu_gfx90a::s69, output_vec_len );
            case 70:  return makeRegisterExpression(amdgpu_gfx90a::s70, output_vec_len );
            case 71:  return makeRegisterExpression(amdgpu_gfx90a::s71, output_vec_len );
            case 72:  return makeRegisterExpression(amdgpu_gfx90a::s72, output_vec_len );
            case 73:  return makeRegisterExpression(amdgpu_gfx90a::s73, output_vec_len );
            case 74:  return makeRegisterExpression(amdgpu_gfx90a::s74, output_vec_len );
            case 75:  return makeRegisterExpression(amdgpu_gfx90a::s75, output_vec_len );
            case 76:  return makeRegisterExpression(amdgpu_gfx90a::s76, output_vec_len );
            case 77:  return makeRegisterExpression(amdgpu_gfx90a::s77, output_vec_len );
            case 78:  return makeRegisterExpression(amdgpu_gfx90a::s78, output_vec_len );
            case 79:  return makeRegisterExpression(amdgpu_gfx90a::s79, output_vec_len );
            case 80:  return makeRegisterExpression(amdgpu_gfx90a::s80, output_vec_len );
            case 81:  return makeRegisterExpression(amdgpu_gfx90a::s81, output_vec_len );
            case 82:  return makeRegisterExpression(amdgpu_gfx90a::s82, output_vec_len );
            case 83:  return makeRegisterExpression(amdgpu_gfx90a::s83, output_vec_len );
            case 84:  return makeRegisterExpression(amdgpu_gfx90a::s84, output_vec_len );
            case 85:  return makeRegisterExpression(amdgpu_gfx90a::s85, output_vec_len );
            case 86:  return makeRegisterExpression(amdgpu_gfx90a::s86, output_vec_len );
            case 87:  return makeRegisterExpression(amdgpu_gfx90a::s87, output_vec_len );
            case 88:  return makeRegisterExpression(amdgpu_gfx90a::s88, output_vec_len );
            case 89:  return makeRegisterExpression(amdgpu_gfx90a::s89, output_vec_len );
            case 90:  return makeRegisterExpression(amdgpu_gfx90a::s90, output_vec_len );
            case 91:  return makeRegisterExpression(amdgpu_gfx90a::s91, output_vec_len );
            case 92:  return makeRegisterExpression(amdgpu_gfx90a::s92, output_vec_len );
            case 93:  return makeRegisterExpression(amdgpu_gfx90a::s93, output_vec_len );
            case 94:  return makeRegisterExpression(amdgpu_gfx90a::s94, output_vec_len );
            case 95:  return makeRegisterExpression(amdgpu_gfx90a::s95, output_vec_len );
            case 96:  return makeRegisterExpression(amdgpu_gfx90a::s96, output_vec_len );
            case 97:  return makeRegisterExpression(amdgpu_gfx90a::s97, output_vec_len );
            case 98:  return makeRegisterExpression(amdgpu_gfx90a::s98, output_vec_len );
            case 99:  return makeRegisterExpression(amdgpu_gfx90a::s99, output_vec_len );
            case 100:  return makeRegisterExpression(amdgpu_gfx90a::s100, output_vec_len );
            case 101:  return makeRegisterExpression(amdgpu_gfx90a::s101, output_vec_len );
            case 104:  return makeRegisterExpression(amdgpu_gfx90a::xnack_mask_lo, output_vec_len );
            case 105:  return makeRegisterExpression(amdgpu_gfx90a::xnack_mask_hi, output_vec_len );
            case 102:  return makeRegisterExpression(amdgpu_gfx90a::flat_scratch_lo, output_vec_len );
            case 103:  return makeRegisterExpression(amdgpu_gfx90a::flat_scratch_hi, output_vec_len );
            case 108:  return makeRegisterExpression(amdgpu_gfx90a::ttmp0, output_vec_len );
            case 109:  return makeRegisterExpression(amdgpu_gfx90a::ttmp1, output_vec_len );
            case 110:  return makeRegisterExpression(amdgpu_gfx90a::ttmp2, output_vec_len );
            case 111:  return makeRegisterExpression(amdgpu_gfx90a::ttmp3, output_vec_len );
            case 112:  return makeRegisterExpression(amdgpu_gfx90a::ttmp4, output_vec_len );
            case 113:  return makeRegisterExpression(amdgpu_gfx90a::ttmp5, output_vec_len );
            case 114:  return makeRegisterExpression(amdgpu_gfx90a::ttmp6, output_vec_len );
            case 115:  return makeRegisterExpression(amdgpu_gfx90a::ttmp7, output_vec_len );
            case 116:  return makeRegisterExpression(amdgpu_gfx90a::ttmp8, output_vec_len );
            case 117:  return makeRegisterExpression(amdgpu_gfx90a::ttmp9, output_vec_len );
            case 118:  return makeRegisterExpression(amdgpu_gfx90a::ttmp10, output_vec_len );
            case 119:  return makeRegisterExpression(amdgpu_gfx90a::ttmp11, output_vec_len );
            case 120:  return makeRegisterExpression(amdgpu_gfx90a::ttmp12, output_vec_len );
            case 121:  return makeRegisterExpression(amdgpu_gfx90a::ttmp13, output_vec_len );
            case 122:  return makeRegisterExpression(amdgpu_gfx90a::ttmp14, output_vec_len );
            case 123:  return makeRegisterExpression(amdgpu_gfx90a::ttmp15, output_vec_len );
            case 106:  return makeRegisterExpression(amdgpu_gfx90a::vcc_lo, output_vec_len );
            case 107:  return makeRegisterExpression(amdgpu_gfx90a::vcc_hi, output_vec_len );
            case 124:  return makeRegisterExpression(amdgpu_gfx90a::m0, output_vec_len );
            case 126:  return makeRegisterExpression(amdgpu_gfx90a::exec_lo, output_vec_len );
            case 127:  return makeRegisterExpression(amdgpu_gfx90a::exec_hi, output_vec_len );
            default: return makeRegisterExpression(amdgpu_gfx90a::invalid);
        }
    }

    Expression::Ptr InstructionDecoder_amdgpu_gfx90a::decodeOPR_SDST_EXEC(uint64_t input, uint32_t output_vec_len)
    {
        switch (input)  {
            case 126:  return makeRegisterExpression(amdgpu_gfx90a::exec_lo, output_vec_len );
            case 127:  return makeRegisterExpression(amdgpu_gfx90a::exec_hi, output_vec_len );
            default: return makeRegisterExpression(amdgpu_gfx90a::invalid);
        }
    }

    Expression::Ptr InstructionDecoder_amdgpu_gfx90a::decodeOPR_SDST_M0(uint64_t input, uint32_t output_vec_len)
    {
        switch (input)  {
            case 124:  return makeRegisterExpression(amdgpu_gfx90a::m0, output_vec_len );
            default: return makeRegisterExpression(amdgpu_gfx90a::invalid);
        }
    }

    Expression::Ptr InstructionDecoder_amdgpu_gfx90a::decodeOPR_SRC(uint64_t input, uint32_t output_vec_len)
    {
        switch (input)  {
            case 0:  return makeRegisterExpression(amdgpu_gfx90a::s0, output_vec_len );
            case 1:  return makeRegisterExpression(amdgpu_gfx90a::s1, output_vec_len );
            case 2:  return makeRegisterExpression(amdgpu_gfx90a::s2, output_vec_len );
            case 3:  return makeRegisterExpression(amdgpu_gfx90a::s3, output_vec_len );
            case 4:  return makeRegisterExpression(amdgpu_gfx90a::s4, output_vec_len );
            case 5:  return makeRegisterExpression(amdgpu_gfx90a::s5, output_vec_len );
            case 6:  return makeRegisterExpression(amdgpu_gfx90a::s6, output_vec_len );
            case 7:  return makeRegisterExpression(amdgpu_gfx90a::s7, output_vec_len );
            case 8:  return makeRegisterExpression(amdgpu_gfx90a::s8, output_vec_len );
            case 9:  return makeRegisterExpression(amdgpu_gfx90a::s9, output_vec_len );
            case 10:  return makeRegisterExpression(amdgpu_gfx90a::s10, output_vec_len );
            case 11:  return makeRegisterExpression(amdgpu_gfx90a::s11, output_vec_len );
            case 12:  return makeRegisterExpression(amdgpu_gfx90a::s12, output_vec_len );
            case 13:  return makeRegisterExpression(amdgpu_gfx90a::s13, output_vec_len );
            case 14:  return makeRegisterExpression(amdgpu_gfx90a::s14, output_vec_len );
            case 15:  return makeRegisterExpression(amdgpu_gfx90a::s15, output_vec_len );
            case 16:  return makeRegisterExpression(amdgpu_gfx90a::s16, output_vec_len );
            case 17:  return makeRegisterExpression(amdgpu_gfx90a::s17, output_vec_len );
            case 18:  return makeRegisterExpression(amdgpu_gfx90a::s18, output_vec_len );
            case 19:  return makeRegisterExpression(amdgpu_gfx90a::s19, output_vec_len );
            case 20:  return makeRegisterExpression(amdgpu_gfx90a::s20, output_vec_len );
            case 21:  return makeRegisterExpression(amdgpu_gfx90a::s21, output_vec_len );
            case 22:  return makeRegisterExpression(amdgpu_gfx90a::s22, output_vec_len );
            case 23:  return makeRegisterExpression(amdgpu_gfx90a::s23, output_vec_len );
            case 24:  return makeRegisterExpression(amdgpu_gfx90a::s24, output_vec_len );
            case 25:  return makeRegisterExpression(amdgpu_gfx90a::s25, output_vec_len );
            case 26:  return makeRegisterExpression(amdgpu_gfx90a::s26, output_vec_len );
            case 27:  return makeRegisterExpression(amdgpu_gfx90a::s27, output_vec_len );
            case 28:  return makeRegisterExpression(amdgpu_gfx90a::s28, output_vec_len );
            case 29:  return makeRegisterExpression(amdgpu_gfx90a::s29, output_vec_len );
            case 30:  return makeRegisterExpression(amdgpu_gfx90a::s30, output_vec_len );
            case 31:  return makeRegisterExpression(amdgpu_gfx90a::s31, output_vec_len );
            case 32:  return makeRegisterExpression(amdgpu_gfx90a::s32, output_vec_len );
            case 33:  return makeRegisterExpression(amdgpu_gfx90a::s33, output_vec_len );
            case 34:  return makeRegisterExpression(amdgpu_gfx90a::s34, output_vec_len );
            case 35:  return makeRegisterExpression(amdgpu_gfx90a::s35, output_vec_len );
            case 36:  return makeRegisterExpression(amdgpu_gfx90a::s36, output_vec_len );
            case 37:  return makeRegisterExpression(amdgpu_gfx90a::s37, output_vec_len );
            case 38:  return makeRegisterExpression(amdgpu_gfx90a::s38, output_vec_len );
            case 39:  return makeRegisterExpression(amdgpu_gfx90a::s39, output_vec_len );
            case 40:  return makeRegisterExpression(amdgpu_gfx90a::s40, output_vec_len );
            case 41:  return makeRegisterExpression(amdgpu_gfx90a::s41, output_vec_len );
            case 42:  return makeRegisterExpression(amdgpu_gfx90a::s42, output_vec_len );
            case 43:  return makeRegisterExpression(amdgpu_gfx90a::s43, output_vec_len );
            case 44:  return makeRegisterExpression(amdgpu_gfx90a::s44, output_vec_len );
            case 45:  return makeRegisterExpression(amdgpu_gfx90a::s45, output_vec_len );
            case 46:  return makeRegisterExpression(amdgpu_gfx90a::s46, output_vec_len );
            case 47:  return makeRegisterExpression(amdgpu_gfx90a::s47, output_vec_len );
            case 48:  return makeRegisterExpression(amdgpu_gfx90a::s48, output_vec_len );
            case 49:  return makeRegisterExpression(amdgpu_gfx90a::s49, output_vec_len );
            case 50:  return makeRegisterExpression(amdgpu_gfx90a::s50, output_vec_len );
            case 51:  return makeRegisterExpression(amdgpu_gfx90a::s51, output_vec_len );
            case 52:  return makeRegisterExpression(amdgpu_gfx90a::s52, output_vec_len );
            case 53:  return makeRegisterExpression(amdgpu_gfx90a::s53, output_vec_len );
            case 54:  return makeRegisterExpression(amdgpu_gfx90a::s54, output_vec_len );
            case 55:  return makeRegisterExpression(amdgpu_gfx90a::s55, output_vec_len );
            case 56:  return makeRegisterExpression(amdgpu_gfx90a::s56, output_vec_len );
            case 57:  return makeRegisterExpression(amdgpu_gfx90a::s57, output_vec_len );
            case 58:  return makeRegisterExpression(amdgpu_gfx90a::s58, output_vec_len );
            case 59:  return makeRegisterExpression(amdgpu_gfx90a::s59, output_vec_len );
            case 60:  return makeRegisterExpression(amdgpu_gfx90a::s60, output_vec_len );
            case 61:  return makeRegisterExpression(amdgpu_gfx90a::s61, output_vec_len );
            case 62:  return makeRegisterExpression(amdgpu_gfx90a::s62, output_vec_len );
            case 63:  return makeRegisterExpression(amdgpu_gfx90a::s63, output_vec_len );
            case 64:  return makeRegisterExpression(amdgpu_gfx90a::s64, output_vec_len );
            case 65:  return makeRegisterExpression(amdgpu_gfx90a::s65, output_vec_len );
            case 66:  return makeRegisterExpression(amdgpu_gfx90a::s66, output_vec_len );
            case 67:  return makeRegisterExpression(amdgpu_gfx90a::s67, output_vec_len );
            case 68:  return makeRegisterExpression(amdgpu_gfx90a::s68, output_vec_len );
            case 69:  return makeRegisterExpression(amdgpu_gfx90a::s69, output_vec_len );
            case 70:  return makeRegisterExpression(amdgpu_gfx90a::s70, output_vec_len );
            case 71:  return makeRegisterExpression(amdgpu_gfx90a::s71, output_vec_len );
            case 72:  return makeRegisterExpression(amdgpu_gfx90a::s72, output_vec_len );
            case 73:  return makeRegisterExpression(amdgpu_gfx90a::s73, output_vec_len );
            case 74:  return makeRegisterExpression(amdgpu_gfx90a::s74, output_vec_len );
            case 75:  return makeRegisterExpression(amdgpu_gfx90a::s75, output_vec_len );
            case 76:  return makeRegisterExpression(amdgpu_gfx90a::s76, output_vec_len );
            case 77:  return makeRegisterExpression(amdgpu_gfx90a::s77, output_vec_len );
            case 78:  return makeRegisterExpression(amdgpu_gfx90a::s78, output_vec_len );
            case 79:  return makeRegisterExpression(amdgpu_gfx90a::s79, output_vec_len );
            case 80:  return makeRegisterExpression(amdgpu_gfx90a::s80, output_vec_len );
            case 81:  return makeRegisterExpression(amdgpu_gfx90a::s81, output_vec_len );
            case 82:  return makeRegisterExpression(amdgpu_gfx90a::s82, output_vec_len );
            case 83:  return makeRegisterExpression(amdgpu_gfx90a::s83, output_vec_len );
            case 84:  return makeRegisterExpression(amdgpu_gfx90a::s84, output_vec_len );
            case 85:  return makeRegisterExpression(amdgpu_gfx90a::s85, output_vec_len );
            case 86:  return makeRegisterExpression(amdgpu_gfx90a::s86, output_vec_len );
            case 87:  return makeRegisterExpression(amdgpu_gfx90a::s87, output_vec_len );
            case 88:  return makeRegisterExpression(amdgpu_gfx90a::s88, output_vec_len );
            case 89:  return makeRegisterExpression(amdgpu_gfx90a::s89, output_vec_len );
            case 90:  return makeRegisterExpression(amdgpu_gfx90a::s90, output_vec_len );
            case 91:  return makeRegisterExpression(amdgpu_gfx90a::s91, output_vec_len );
            case 92:  return makeRegisterExpression(amdgpu_gfx90a::s92, output_vec_len );
            case 93:  return makeRegisterExpression(amdgpu_gfx90a::s93, output_vec_len );
            case 94:  return makeRegisterExpression(amdgpu_gfx90a::s94, output_vec_len );
            case 95:  return makeRegisterExpression(amdgpu_gfx90a::s95, output_vec_len );
            case 96:  return makeRegisterExpression(amdgpu_gfx90a::s96, output_vec_len );
            case 97:  return makeRegisterExpression(amdgpu_gfx90a::s97, output_vec_len );
            case 98:  return makeRegisterExpression(amdgpu_gfx90a::s98, output_vec_len );
            case 99:  return makeRegisterExpression(amdgpu_gfx90a::s99, output_vec_len );
            case 100:  return makeRegisterExpression(amdgpu_gfx90a::s100, output_vec_len );
            case 101:  return makeRegisterExpression(amdgpu_gfx90a::s101, output_vec_len );
            case 104:  return makeRegisterExpression(amdgpu_gfx90a::xnack_mask_lo, output_vec_len );
            case 105:  return makeRegisterExpression(amdgpu_gfx90a::xnack_mask_hi, output_vec_len );
            case 102:  return makeRegisterExpression(amdgpu_gfx90a::flat_scratch_lo, output_vec_len );
            case 103:  return makeRegisterExpression(amdgpu_gfx90a::flat_scratch_hi, output_vec_len );
            case 108:  return makeRegisterExpression(amdgpu_gfx90a::ttmp0, output_vec_len );
            case 109:  return makeRegisterExpression(amdgpu_gfx90a::ttmp1, output_vec_len );
            case 110:  return makeRegisterExpression(amdgpu_gfx90a::ttmp2, output_vec_len );
            case 111:  return makeRegisterExpression(amdgpu_gfx90a::ttmp3, output_vec_len );
            case 112:  return makeRegisterExpression(amdgpu_gfx90a::ttmp4, output_vec_len );
            case 113:  return makeRegisterExpression(amdgpu_gfx90a::ttmp5, output_vec_len );
            case 114:  return makeRegisterExpression(amdgpu_gfx90a::ttmp6, output_vec_len );
            case 115:  return makeRegisterExpression(amdgpu_gfx90a::ttmp7, output_vec_len );
            case 116:  return makeRegisterExpression(amdgpu_gfx90a::ttmp8, output_vec_len );
            case 117:  return makeRegisterExpression(amdgpu_gfx90a::ttmp9, output_vec_len );
            case 118:  return makeRegisterExpression(amdgpu_gfx90a::ttmp10, output_vec_len );
            case 119:  return makeRegisterExpression(amdgpu_gfx90a::ttmp11, output_vec_len );
            case 120:  return makeRegisterExpression(amdgpu_gfx90a::ttmp12, output_vec_len );
            case 121:  return makeRegisterExpression(amdgpu_gfx90a::ttmp13, output_vec_len );
            case 122:  return makeRegisterExpression(amdgpu_gfx90a::ttmp14, output_vec_len );
            case 123:  return makeRegisterExpression(amdgpu_gfx90a::ttmp15, output_vec_len );
            case 106:  return makeRegisterExpression(amdgpu_gfx90a::vcc_lo, output_vec_len );
            case 107:  return makeRegisterExpression(amdgpu_gfx90a::vcc_hi, output_vec_len );
            case 124:  return makeRegisterExpression(amdgpu_gfx90a::m0, output_vec_len );
            case 126:  return makeRegisterExpression(amdgpu_gfx90a::exec_lo, output_vec_len );
            case 127:  return makeRegisterExpression(amdgpu_gfx90a::exec_hi, output_vec_len );
            case 128:  return Immediate::makeImmediate(Result(u32, 0));
            case 129:  return Immediate::makeImmediate(Result(u32, 1));
            case 130:  return Immediate::makeImmediate(Result(u32, 2));
            case 131:  return Immediate::makeImmediate(Result(u32, 3));
            case 132:  return Immediate::makeImmediate(Result(u32, 4));
            case 133:  return Immediate::makeImmediate(Result(u32, 5));
            case 134:  return Immediate::makeImmediate(Result(u32, 6));
            case 135:  return Immediate::makeImmediate(Result(u32, 7));
            case 136:  return Immediate::makeImmediate(Result(u32, 8));
            case 137:  return Immediate::makeImmediate(Result(u32, 9));
            case 138:  return Immediate::makeImmediate(Result(u32, 10));
            case 139:  return Immediate::makeImmediate(Result(u32, 11));
            case 140:  return Immediate::makeImmediate(Result(u32, 12));
            case 141:  return Immediate::makeImmediate(Result(u32, 13));
            case 142:  return Immediate::makeImmediate(Result(u32, 14));
            case 143:  return Immediate::makeImmediate(Result(u32, 15));
            case 144:  return Immediate::makeImmediate(Result(u32, 16));
            case 145:  return Immediate::makeImmediate(Result(u32, 17));
            case 146:  return Immediate::makeImmediate(Result(u32, 18));
            case 147:  return Immediate::makeImmediate(Result(u32, 19));
            case 148:  return Immediate::makeImmediate(Result(u32, 20));
            case 149:  return Immediate::makeImmediate(Result(u32, 21));
            case 150:  return Immediate::makeImmediate(Result(u32, 22));
            case 151:  return Immediate::makeImmediate(Result(u32, 23));
            case 152:  return Immediate::makeImmediate(Result(u32, 24));
            case 153:  return Immediate::makeImmediate(Result(u32, 25));
            case 154:  return Immediate::makeImmediate(Result(u32, 26));
            case 155:  return Immediate::makeImmediate(Result(u32, 27));
            case 156:  return Immediate::makeImmediate(Result(u32, 28));
            case 157:  return Immediate::makeImmediate(Result(u32, 29));
            case 158:  return Immediate::makeImmediate(Result(u32, 30));
            case 159:  return Immediate::makeImmediate(Result(u32, 31));
            case 160:  return Immediate::makeImmediate(Result(u32, 32));
            case 161:  return Immediate::makeImmediate(Result(u32, 33));
            case 162:  return Immediate::makeImmediate(Result(u32, 34));
            case 163:  return Immediate::makeImmediate(Result(u32, 35));
            case 164:  return Immediate::makeImmediate(Result(u32, 36));
            case 165:  return Immediate::makeImmediate(Result(u32, 37));
            case 166:  return Immediate::makeImmediate(Result(u32, 38));
            case 167:  return Immediate::makeImmediate(Result(u32, 39));
            case 168:  return Immediate::makeImmediate(Result(u32, 40));
            case 169:  return Immediate::makeImmediate(Result(u32, 41));
            case 170:  return Immediate::makeImmediate(Result(u32, 42));
            case 171:  return Immediate::makeImmediate(Result(u32, 43));
            case 172:  return Immediate::makeImmediate(Result(u32, 44));
            case 173:  return Immediate::makeImmediate(Result(u32, 45));
            case 174:  return Immediate::makeImmediate(Result(u32, 46));
            case 175:  return Immediate::makeImmediate(Result(u32, 47));
            case 176:  return Immediate::makeImmediate(Result(u32, 48));
            case 177:  return Immediate::makeImmediate(Result(u32, 49));
            case 178:  return Immediate::makeImmediate(Result(u32, 50));
            case 179:  return Immediate::makeImmediate(Result(u32, 51));
            case 180:  return Immediate::makeImmediate(Result(u32, 52));
            case 181:  return Immediate::makeImmediate(Result(u32, 53));
            case 182:  return Immediate::makeImmediate(Result(u32, 54));
            case 183:  return Immediate::makeImmediate(Result(u32, 55));
            case 184:  return Immediate::makeImmediate(Result(u32, 56));
            case 185:  return Immediate::makeImmediate(Result(u32, 57));
            case 186:  return Immediate::makeImmediate(Result(u32, 58));
            case 187:  return Immediate::makeImmediate(Result(u32, 59));
            case 188:  return Immediate::makeImmediate(Result(u32, 60));
            case 189:  return Immediate::makeImmediate(Result(u32, 61));
            case 190:  return Immediate::makeImmediate(Result(u32, 62));
            case 191:  return Immediate::makeImmediate(Result(u32, 63));
            case 192:  return Immediate::makeImmediate(Result(u32, 64));
            case 193:  return Immediate::makeImmediate(Result(u32, -1));
            case 194:  return Immediate::makeImmediate(Result(u32, -2));
            case 195:  return Immediate::makeImmediate(Result(u32, -3));
            case 196:  return Immediate::makeImmediate(Result(u32, -4));
            case 197:  return Immediate::makeImmediate(Result(u32, -5));
            case 198:  return Immediate::makeImmediate(Result(u32, -6));
            case 199:  return Immediate::makeImmediate(Result(u32, -7));
            case 200:  return Immediate::makeImmediate(Result(u32, -8));
            case 201:  return Immediate::makeImmediate(Result(u32, -9));
            case 202:  return Immediate::makeImmediate(Result(u32, -10));
            case 203:  return Immediate::makeImmediate(Result(u32, -11));
            case 204:  return Immediate::makeImmediate(Result(u32, -12));
            case 205:  return Immediate::makeImmediate(Result(u32, -13));
            case 206:  return Immediate::makeImmediate(Result(u32, -14));
            case 207:  return Immediate::makeImmediate(Result(u32, -15));
            case 208:  return Immediate::makeImmediate(Result(u32, -16));
            case 240:  return Immediate::makeImmediate(Result(sp_float, 0.5));
            case 241:  return Immediate::makeImmediate(Result(sp_float, -0.5));
            case 242:  return Immediate::makeImmediate(Result(sp_float, 1.0));
            case 243:  return Immediate::makeImmediate(Result(sp_float, -1.0));
            case 244:  return Immediate::makeImmediate(Result(sp_float, 2.0));
            case 245:  return Immediate::makeImmediate(Result(sp_float, -2.0));
            case 246:  return Immediate::makeImmediate(Result(sp_float, 4.0));
            case 247:  return Immediate::makeImmediate(Result(sp_float, -4.0));
            case 248:  return Immediate::makeImmediate(Result(sp_float, 0.15915494));
            case 251:  return makeRegisterExpression(amdgpu_gfx90a::src_vccz, output_vec_len );
            case 252:  return makeRegisterExpression(amdgpu_gfx90a::src_execz, output_vec_len );
            case 253:  return makeRegisterExpression(amdgpu_gfx90a::src_scc, output_vec_len );
            case 235:  return makeRegisterExpression(amdgpu_gfx90a::src_shared_base, output_vec_len );
            case 236:  return makeRegisterExpression(amdgpu_gfx90a::src_shared_limit, output_vec_len );
            case 237:  return makeRegisterExpression(amdgpu_gfx90a::src_private_base, output_vec_len );
            case 238:  return makeRegisterExpression(amdgpu_gfx90a::src_private_limit, output_vec_len );
            case 239:  return makeRegisterExpression(amdgpu_gfx90a::src_pops_exiting_wave_id, output_vec_len );
            case 256:  return makeRegisterExpression(amdgpu_gfx90a::v0, output_vec_len );
            case 257:  return makeRegisterExpression(amdgpu_gfx90a::v1, output_vec_len );
            case 258:  return makeRegisterExpression(amdgpu_gfx90a::v2, output_vec_len );
            case 259:  return makeRegisterExpression(amdgpu_gfx90a::v3, output_vec_len );
            case 260:  return makeRegisterExpression(amdgpu_gfx90a::v4, output_vec_len );
            case 261:  return makeRegisterExpression(amdgpu_gfx90a::v5, output_vec_len );
            case 262:  return makeRegisterExpression(amdgpu_gfx90a::v6, output_vec_len );
            case 263:  return makeRegisterExpression(amdgpu_gfx90a::v7, output_vec_len );
            case 264:  return makeRegisterExpression(amdgpu_gfx90a::v8, output_vec_len );
            case 265:  return makeRegisterExpression(amdgpu_gfx90a::v9, output_vec_len );
            case 266:  return makeRegisterExpression(amdgpu_gfx90a::v10, output_vec_len );
            case 267:  return makeRegisterExpression(amdgpu_gfx90a::v11, output_vec_len );
            case 268:  return makeRegisterExpression(amdgpu_gfx90a::v12, output_vec_len );
            case 269:  return makeRegisterExpression(amdgpu_gfx90a::v13, output_vec_len );
            case 270:  return makeRegisterExpression(amdgpu_gfx90a::v14, output_vec_len );
            case 271:  return makeRegisterExpression(amdgpu_gfx90a::v15, output_vec_len );
            case 272:  return makeRegisterExpression(amdgpu_gfx90a::v16, output_vec_len );
            case 273:  return makeRegisterExpression(amdgpu_gfx90a::v17, output_vec_len );
            case 274:  return makeRegisterExpression(amdgpu_gfx90a::v18, output_vec_len );
            case 275:  return makeRegisterExpression(amdgpu_gfx90a::v19, output_vec_len );
            case 276:  return makeRegisterExpression(amdgpu_gfx90a::v20, output_vec_len );
            case 277:  return makeRegisterExpression(amdgpu_gfx90a::v21, output_vec_len );
            case 278:  return makeRegisterExpression(amdgpu_gfx90a::v22, output_vec_len );
            case 279:  return makeRegisterExpression(amdgpu_gfx90a::v23, output_vec_len );
            case 280:  return makeRegisterExpression(amdgpu_gfx90a::v24, output_vec_len );
            case 281:  return makeRegisterExpression(amdgpu_gfx90a::v25, output_vec_len );
            case 282:  return makeRegisterExpression(amdgpu_gfx90a::v26, output_vec_len );
            case 283:  return makeRegisterExpression(amdgpu_gfx90a::v27, output_vec_len );
            case 284:  return makeRegisterExpression(amdgpu_gfx90a::v28, output_vec_len );
            case 285:  return makeRegisterExpression(amdgpu_gfx90a::v29, output_vec_len );
            case 286:  return makeRegisterExpression(amdgpu_gfx90a::v30, output_vec_len );
            case 287:  return makeRegisterExpression(amdgpu_gfx90a::v31, output_vec_len );
            case 288:  return makeRegisterExpression(amdgpu_gfx90a::v32, output_vec_len );
            case 289:  return makeRegisterExpression(amdgpu_gfx90a::v33, output_vec_len );
            case 290:  return makeRegisterExpression(amdgpu_gfx90a::v34, output_vec_len );
            case 291:  return makeRegisterExpression(amdgpu_gfx90a::v35, output_vec_len );
            case 292:  return makeRegisterExpression(amdgpu_gfx90a::v36, output_vec_len );
            case 293:  return makeRegisterExpression(amdgpu_gfx90a::v37, output_vec_len );
            case 294:  return makeRegisterExpression(amdgpu_gfx90a::v38, output_vec_len );
            case 295:  return makeRegisterExpression(amdgpu_gfx90a::v39, output_vec_len );
            case 296:  return makeRegisterExpression(amdgpu_gfx90a::v40, output_vec_len );
            case 297:  return makeRegisterExpression(amdgpu_gfx90a::v41, output_vec_len );
            case 298:  return makeRegisterExpression(amdgpu_gfx90a::v42, output_vec_len );
            case 299:  return makeRegisterExpression(amdgpu_gfx90a::v43, output_vec_len );
            case 300:  return makeRegisterExpression(amdgpu_gfx90a::v44, output_vec_len );
            case 301:  return makeRegisterExpression(amdgpu_gfx90a::v45, output_vec_len );
            case 302:  return makeRegisterExpression(amdgpu_gfx90a::v46, output_vec_len );
            case 303:  return makeRegisterExpression(amdgpu_gfx90a::v47, output_vec_len );
            case 304:  return makeRegisterExpression(amdgpu_gfx90a::v48, output_vec_len );
            case 305:  return makeRegisterExpression(amdgpu_gfx90a::v49, output_vec_len );
            case 306:  return makeRegisterExpression(amdgpu_gfx90a::v50, output_vec_len );
            case 307:  return makeRegisterExpression(amdgpu_gfx90a::v51, output_vec_len );
            case 308:  return makeRegisterExpression(amdgpu_gfx90a::v52, output_vec_len );
            case 309:  return makeRegisterExpression(amdgpu_gfx90a::v53, output_vec_len );
            case 310:  return makeRegisterExpression(amdgpu_gfx90a::v54, output_vec_len );
            case 311:  return makeRegisterExpression(amdgpu_gfx90a::v55, output_vec_len );
            case 312:  return makeRegisterExpression(amdgpu_gfx90a::v56, output_vec_len );
            case 313:  return makeRegisterExpression(amdgpu_gfx90a::v57, output_vec_len );
            case 314:  return makeRegisterExpression(amdgpu_gfx90a::v58, output_vec_len );
            case 315:  return makeRegisterExpression(amdgpu_gfx90a::v59, output_vec_len );
            case 316:  return makeRegisterExpression(amdgpu_gfx90a::v60, output_vec_len );
            case 317:  return makeRegisterExpression(amdgpu_gfx90a::v61, output_vec_len );
            case 318:  return makeRegisterExpression(amdgpu_gfx90a::v62, output_vec_len );
            case 319:  return makeRegisterExpression(amdgpu_gfx90a::v63, output_vec_len );
            case 320:  return makeRegisterExpression(amdgpu_gfx90a::v64, output_vec_len );
            case 321:  return makeRegisterExpression(amdgpu_gfx90a::v65, output_vec_len );
            case 322:  return makeRegisterExpression(amdgpu_gfx90a::v66, output_vec_len );
            case 323:  return makeRegisterExpression(amdgpu_gfx90a::v67, output_vec_len );
            case 324:  return makeRegisterExpression(amdgpu_gfx90a::v68, output_vec_len );
            case 325:  return makeRegisterExpression(amdgpu_gfx90a::v69, output_vec_len );
            case 326:  return makeRegisterExpression(amdgpu_gfx90a::v70, output_vec_len );
            case 327:  return makeRegisterExpression(amdgpu_gfx90a::v71, output_vec_len );
            case 328:  return makeRegisterExpression(amdgpu_gfx90a::v72, output_vec_len );
            case 329:  return makeRegisterExpression(amdgpu_gfx90a::v73, output_vec_len );
            case 330:  return makeRegisterExpression(amdgpu_gfx90a::v74, output_vec_len );
            case 331:  return makeRegisterExpression(amdgpu_gfx90a::v75, output_vec_len );
            case 332:  return makeRegisterExpression(amdgpu_gfx90a::v76, output_vec_len );
            case 333:  return makeRegisterExpression(amdgpu_gfx90a::v77, output_vec_len );
            case 334:  return makeRegisterExpression(amdgpu_gfx90a::v78, output_vec_len );
            case 335:  return makeRegisterExpression(amdgpu_gfx90a::v79, output_vec_len );
            case 336:  return makeRegisterExpression(amdgpu_gfx90a::v80, output_vec_len );
            case 337:  return makeRegisterExpression(amdgpu_gfx90a::v81, output_vec_len );
            case 338:  return makeRegisterExpression(amdgpu_gfx90a::v82, output_vec_len );
            case 339:  return makeRegisterExpression(amdgpu_gfx90a::v83, output_vec_len );
            case 340:  return makeRegisterExpression(amdgpu_gfx90a::v84, output_vec_len );
            case 341:  return makeRegisterExpression(amdgpu_gfx90a::v85, output_vec_len );
            case 342:  return makeRegisterExpression(amdgpu_gfx90a::v86, output_vec_len );
            case 343:  return makeRegisterExpression(amdgpu_gfx90a::v87, output_vec_len );
            case 344:  return makeRegisterExpression(amdgpu_gfx90a::v88, output_vec_len );
            case 345:  return makeRegisterExpression(amdgpu_gfx90a::v89, output_vec_len );
            case 346:  return makeRegisterExpression(amdgpu_gfx90a::v90, output_vec_len );
            case 347:  return makeRegisterExpression(amdgpu_gfx90a::v91, output_vec_len );
            case 348:  return makeRegisterExpression(amdgpu_gfx90a::v92, output_vec_len );
            case 349:  return makeRegisterExpression(amdgpu_gfx90a::v93, output_vec_len );
            case 350:  return makeRegisterExpression(amdgpu_gfx90a::v94, output_vec_len );
            case 351:  return makeRegisterExpression(amdgpu_gfx90a::v95, output_vec_len );
            case 352:  return makeRegisterExpression(amdgpu_gfx90a::v96, output_vec_len );
            case 353:  return makeRegisterExpression(amdgpu_gfx90a::v97, output_vec_len );
            case 354:  return makeRegisterExpression(amdgpu_gfx90a::v98, output_vec_len );
            case 355:  return makeRegisterExpression(amdgpu_gfx90a::v99, output_vec_len );
            case 356:  return makeRegisterExpression(amdgpu_gfx90a::v100, output_vec_len );
            case 357:  return makeRegisterExpression(amdgpu_gfx90a::v101, output_vec_len );
            case 358:  return makeRegisterExpression(amdgpu_gfx90a::v102, output_vec_len );
            case 359:  return makeRegisterExpression(amdgpu_gfx90a::v103, output_vec_len );
            case 360:  return makeRegisterExpression(amdgpu_gfx90a::v104, output_vec_len );
            case 361:  return makeRegisterExpression(amdgpu_gfx90a::v105, output_vec_len );
            case 362:  return makeRegisterExpression(amdgpu_gfx90a::v106, output_vec_len );
            case 363:  return makeRegisterExpression(amdgpu_gfx90a::v107, output_vec_len );
            case 364:  return makeRegisterExpression(amdgpu_gfx90a::v108, output_vec_len );
            case 365:  return makeRegisterExpression(amdgpu_gfx90a::v109, output_vec_len );
            case 366:  return makeRegisterExpression(amdgpu_gfx90a::v110, output_vec_len );
            case 367:  return makeRegisterExpression(amdgpu_gfx90a::v111, output_vec_len );
            case 368:  return makeRegisterExpression(amdgpu_gfx90a::v112, output_vec_len );
            case 369:  return makeRegisterExpression(amdgpu_gfx90a::v113, output_vec_len );
            case 370:  return makeRegisterExpression(amdgpu_gfx90a::v114, output_vec_len );
            case 371:  return makeRegisterExpression(amdgpu_gfx90a::v115, output_vec_len );
            case 372:  return makeRegisterExpression(amdgpu_gfx90a::v116, output_vec_len );
            case 373:  return makeRegisterExpression(amdgpu_gfx90a::v117, output_vec_len );
            case 374:  return makeRegisterExpression(amdgpu_gfx90a::v118, output_vec_len );
            case 375:  return makeRegisterExpression(amdgpu_gfx90a::v119, output_vec_len );
            case 376:  return makeRegisterExpression(amdgpu_gfx90a::v120, output_vec_len );
            case 377:  return makeRegisterExpression(amdgpu_gfx90a::v121, output_vec_len );
            case 378:  return makeRegisterExpression(amdgpu_gfx90a::v122, output_vec_len );
            case 379:  return makeRegisterExpression(amdgpu_gfx90a::v123, output_vec_len );
            case 380:  return makeRegisterExpression(amdgpu_gfx90a::v124, output_vec_len );
            case 381:  return makeRegisterExpression(amdgpu_gfx90a::v125, output_vec_len );
            case 382:  return makeRegisterExpression(amdgpu_gfx90a::v126, output_vec_len );
            case 383:  return makeRegisterExpression(amdgpu_gfx90a::v127, output_vec_len );
            case 384:  return makeRegisterExpression(amdgpu_gfx90a::v128, output_vec_len );
            case 385:  return makeRegisterExpression(amdgpu_gfx90a::v129, output_vec_len );
            case 386:  return makeRegisterExpression(amdgpu_gfx90a::v130, output_vec_len );
            case 387:  return makeRegisterExpression(amdgpu_gfx90a::v131, output_vec_len );
            case 388:  return makeRegisterExpression(amdgpu_gfx90a::v132, output_vec_len );
            case 389:  return makeRegisterExpression(amdgpu_gfx90a::v133, output_vec_len );
            case 390:  return makeRegisterExpression(amdgpu_gfx90a::v134, output_vec_len );
            case 391:  return makeRegisterExpression(amdgpu_gfx90a::v135, output_vec_len );
            case 392:  return makeRegisterExpression(amdgpu_gfx90a::v136, output_vec_len );
            case 393:  return makeRegisterExpression(amdgpu_gfx90a::v137, output_vec_len );
            case 394:  return makeRegisterExpression(amdgpu_gfx90a::v138, output_vec_len );
            case 395:  return makeRegisterExpression(amdgpu_gfx90a::v139, output_vec_len );
            case 396:  return makeRegisterExpression(amdgpu_gfx90a::v140, output_vec_len );
            case 397:  return makeRegisterExpression(amdgpu_gfx90a::v141, output_vec_len );
            case 398:  return makeRegisterExpression(amdgpu_gfx90a::v142, output_vec_len );
            case 399:  return makeRegisterExpression(amdgpu_gfx90a::v143, output_vec_len );
            case 400:  return makeRegisterExpression(amdgpu_gfx90a::v144, output_vec_len );
            case 401:  return makeRegisterExpression(amdgpu_gfx90a::v145, output_vec_len );
            case 402:  return makeRegisterExpression(amdgpu_gfx90a::v146, output_vec_len );
            case 403:  return makeRegisterExpression(amdgpu_gfx90a::v147, output_vec_len );
            case 404:  return makeRegisterExpression(amdgpu_gfx90a::v148, output_vec_len );
            case 405:  return makeRegisterExpression(amdgpu_gfx90a::v149, output_vec_len );
            case 406:  return makeRegisterExpression(amdgpu_gfx90a::v150, output_vec_len );
            case 407:  return makeRegisterExpression(amdgpu_gfx90a::v151, output_vec_len );
            case 408:  return makeRegisterExpression(amdgpu_gfx90a::v152, output_vec_len );
            case 409:  return makeRegisterExpression(amdgpu_gfx90a::v153, output_vec_len );
            case 410:  return makeRegisterExpression(amdgpu_gfx90a::v154, output_vec_len );
            case 411:  return makeRegisterExpression(amdgpu_gfx90a::v155, output_vec_len );
            case 412:  return makeRegisterExpression(amdgpu_gfx90a::v156, output_vec_len );
            case 413:  return makeRegisterExpression(amdgpu_gfx90a::v157, output_vec_len );
            case 414:  return makeRegisterExpression(amdgpu_gfx90a::v158, output_vec_len );
            case 415:  return makeRegisterExpression(amdgpu_gfx90a::v159, output_vec_len );
            case 416:  return makeRegisterExpression(amdgpu_gfx90a::v160, output_vec_len );
            case 417:  return makeRegisterExpression(amdgpu_gfx90a::v161, output_vec_len );
            case 418:  return makeRegisterExpression(amdgpu_gfx90a::v162, output_vec_len );
            case 419:  return makeRegisterExpression(amdgpu_gfx90a::v163, output_vec_len );
            case 420:  return makeRegisterExpression(amdgpu_gfx90a::v164, output_vec_len );
            case 421:  return makeRegisterExpression(amdgpu_gfx90a::v165, output_vec_len );
            case 422:  return makeRegisterExpression(amdgpu_gfx90a::v166, output_vec_len );
            case 423:  return makeRegisterExpression(amdgpu_gfx90a::v167, output_vec_len );
            case 424:  return makeRegisterExpression(amdgpu_gfx90a::v168, output_vec_len );
            case 425:  return makeRegisterExpression(amdgpu_gfx90a::v169, output_vec_len );
            case 426:  return makeRegisterExpression(amdgpu_gfx90a::v170, output_vec_len );
            case 427:  return makeRegisterExpression(amdgpu_gfx90a::v171, output_vec_len );
            case 428:  return makeRegisterExpression(amdgpu_gfx90a::v172, output_vec_len );
            case 429:  return makeRegisterExpression(amdgpu_gfx90a::v173, output_vec_len );
            case 430:  return makeRegisterExpression(amdgpu_gfx90a::v174, output_vec_len );
            case 431:  return makeRegisterExpression(amdgpu_gfx90a::v175, output_vec_len );
            case 432:  return makeRegisterExpression(amdgpu_gfx90a::v176, output_vec_len );
            case 433:  return makeRegisterExpression(amdgpu_gfx90a::v177, output_vec_len );
            case 434:  return makeRegisterExpression(amdgpu_gfx90a::v178, output_vec_len );
            case 435:  return makeRegisterExpression(amdgpu_gfx90a::v179, output_vec_len );
            case 436:  return makeRegisterExpression(amdgpu_gfx90a::v180, output_vec_len );
            case 437:  return makeRegisterExpression(amdgpu_gfx90a::v181, output_vec_len );
            case 438:  return makeRegisterExpression(amdgpu_gfx90a::v182, output_vec_len );
            case 439:  return makeRegisterExpression(amdgpu_gfx90a::v183, output_vec_len );
            case 440:  return makeRegisterExpression(amdgpu_gfx90a::v184, output_vec_len );
            case 441:  return makeRegisterExpression(amdgpu_gfx90a::v185, output_vec_len );
            case 442:  return makeRegisterExpression(amdgpu_gfx90a::v186, output_vec_len );
            case 443:  return makeRegisterExpression(amdgpu_gfx90a::v187, output_vec_len );
            case 444:  return makeRegisterExpression(amdgpu_gfx90a::v188, output_vec_len );
            case 445:  return makeRegisterExpression(amdgpu_gfx90a::v189, output_vec_len );
            case 446:  return makeRegisterExpression(amdgpu_gfx90a::v190, output_vec_len );
            case 447:  return makeRegisterExpression(amdgpu_gfx90a::v191, output_vec_len );
            case 448:  return makeRegisterExpression(amdgpu_gfx90a::v192, output_vec_len );
            case 449:  return makeRegisterExpression(amdgpu_gfx90a::v193, output_vec_len );
            case 450:  return makeRegisterExpression(amdgpu_gfx90a::v194, output_vec_len );
            case 451:  return makeRegisterExpression(amdgpu_gfx90a::v195, output_vec_len );
            case 452:  return makeRegisterExpression(amdgpu_gfx90a::v196, output_vec_len );
            case 453:  return makeRegisterExpression(amdgpu_gfx90a::v197, output_vec_len );
            case 454:  return makeRegisterExpression(amdgpu_gfx90a::v198, output_vec_len );
            case 455:  return makeRegisterExpression(amdgpu_gfx90a::v199, output_vec_len );
            case 456:  return makeRegisterExpression(amdgpu_gfx90a::v200, output_vec_len );
            case 457:  return makeRegisterExpression(amdgpu_gfx90a::v201, output_vec_len );
            case 458:  return makeRegisterExpression(amdgpu_gfx90a::v202, output_vec_len );
            case 459:  return makeRegisterExpression(amdgpu_gfx90a::v203, output_vec_len );
            case 460:  return makeRegisterExpression(amdgpu_gfx90a::v204, output_vec_len );
            case 461:  return makeRegisterExpression(amdgpu_gfx90a::v205, output_vec_len );
            case 462:  return makeRegisterExpression(amdgpu_gfx90a::v206, output_vec_len );
            case 463:  return makeRegisterExpression(amdgpu_gfx90a::v207, output_vec_len );
            case 464:  return makeRegisterExpression(amdgpu_gfx90a::v208, output_vec_len );
            case 465:  return makeRegisterExpression(amdgpu_gfx90a::v209, output_vec_len );
            case 466:  return makeRegisterExpression(amdgpu_gfx90a::v210, output_vec_len );
            case 467:  return makeRegisterExpression(amdgpu_gfx90a::v211, output_vec_len );
            case 468:  return makeRegisterExpression(amdgpu_gfx90a::v212, output_vec_len );
            case 469:  return makeRegisterExpression(amdgpu_gfx90a::v213, output_vec_len );
            case 470:  return makeRegisterExpression(amdgpu_gfx90a::v214, output_vec_len );
            case 471:  return makeRegisterExpression(amdgpu_gfx90a::v215, output_vec_len );
            case 472:  return makeRegisterExpression(amdgpu_gfx90a::v216, output_vec_len );
            case 473:  return makeRegisterExpression(amdgpu_gfx90a::v217, output_vec_len );
            case 474:  return makeRegisterExpression(amdgpu_gfx90a::v218, output_vec_len );
            case 475:  return makeRegisterExpression(amdgpu_gfx90a::v219, output_vec_len );
            case 476:  return makeRegisterExpression(amdgpu_gfx90a::v220, output_vec_len );
            case 477:  return makeRegisterExpression(amdgpu_gfx90a::v221, output_vec_len );
            case 478:  return makeRegisterExpression(amdgpu_gfx90a::v222, output_vec_len );
            case 479:  return makeRegisterExpression(amdgpu_gfx90a::v223, output_vec_len );
            case 480:  return makeRegisterExpression(amdgpu_gfx90a::v224, output_vec_len );
            case 481:  return makeRegisterExpression(amdgpu_gfx90a::v225, output_vec_len );
            case 482:  return makeRegisterExpression(amdgpu_gfx90a::v226, output_vec_len );
            case 483:  return makeRegisterExpression(amdgpu_gfx90a::v227, output_vec_len );
            case 484:  return makeRegisterExpression(amdgpu_gfx90a::v228, output_vec_len );
            case 485:  return makeRegisterExpression(amdgpu_gfx90a::v229, output_vec_len );
            case 486:  return makeRegisterExpression(amdgpu_gfx90a::v230, output_vec_len );
            case 487:  return makeRegisterExpression(amdgpu_gfx90a::v231, output_vec_len );
            case 488:  return makeRegisterExpression(amdgpu_gfx90a::v232, output_vec_len );
            case 489:  return makeRegisterExpression(amdgpu_gfx90a::v233, output_vec_len );
            case 490:  return makeRegisterExpression(amdgpu_gfx90a::v234, output_vec_len );
            case 491:  return makeRegisterExpression(amdgpu_gfx90a::v235, output_vec_len );
            case 492:  return makeRegisterExpression(amdgpu_gfx90a::v236, output_vec_len );
            case 493:  return makeRegisterExpression(amdgpu_gfx90a::v237, output_vec_len );
            case 494:  return makeRegisterExpression(amdgpu_gfx90a::v238, output_vec_len );
            case 495:  return makeRegisterExpression(amdgpu_gfx90a::v239, output_vec_len );
            case 496:  return makeRegisterExpression(amdgpu_gfx90a::v240, output_vec_len );
            case 497:  return makeRegisterExpression(amdgpu_gfx90a::v241, output_vec_len );
            case 498:  return makeRegisterExpression(amdgpu_gfx90a::v242, output_vec_len );
            case 499:  return makeRegisterExpression(amdgpu_gfx90a::v243, output_vec_len );
            case 500:  return makeRegisterExpression(amdgpu_gfx90a::v244, output_vec_len );
            case 501:  return makeRegisterExpression(amdgpu_gfx90a::v245, output_vec_len );
            case 502:  return makeRegisterExpression(amdgpu_gfx90a::v246, output_vec_len );
            case 503:  return makeRegisterExpression(amdgpu_gfx90a::v247, output_vec_len );
            case 504:  return makeRegisterExpression(amdgpu_gfx90a::v248, output_vec_len );
            case 505:  return makeRegisterExpression(amdgpu_gfx90a::v249, output_vec_len );
            case 506:  return makeRegisterExpression(amdgpu_gfx90a::v250, output_vec_len );
            case 507:  return makeRegisterExpression(amdgpu_gfx90a::v251, output_vec_len );
            case 508:  return makeRegisterExpression(amdgpu_gfx90a::v252, output_vec_len );
            case 509:  return makeRegisterExpression(amdgpu_gfx90a::v253, output_vec_len );
            case 510:  return makeRegisterExpression(amdgpu_gfx90a::v254, output_vec_len );
            case 511:  return makeRegisterExpression(amdgpu_gfx90a::v255, output_vec_len );
            case 255:  return Immediate::makeImmediate(Result(u32,decodeOPR_LITERAL()));
            case 249 :  return decodeOPR_SDWA();
            default: return makeRegisterExpression(amdgpu_gfx90a::invalid);
        }
    }

    Expression::Ptr InstructionDecoder_amdgpu_gfx90a::decodeOPR_SRC_ACCVGPR(uint64_t input, uint32_t output_vec_len)
    {
        switch (input)  {
            case 256:  return makeRegisterExpression(amdgpu_gfx90a::acc0, output_vec_len );
            case 257:  return makeRegisterExpression(amdgpu_gfx90a::acc1, output_vec_len );
            case 258:  return makeRegisterExpression(amdgpu_gfx90a::acc2, output_vec_len );
            case 259:  return makeRegisterExpression(amdgpu_gfx90a::acc3, output_vec_len );
            case 260:  return makeRegisterExpression(amdgpu_gfx90a::acc4, output_vec_len );
            case 261:  return makeRegisterExpression(amdgpu_gfx90a::acc5, output_vec_len );
            case 262:  return makeRegisterExpression(amdgpu_gfx90a::acc6, output_vec_len );
            case 263:  return makeRegisterExpression(amdgpu_gfx90a::acc7, output_vec_len );
            case 264:  return makeRegisterExpression(amdgpu_gfx90a::acc8, output_vec_len );
            case 265:  return makeRegisterExpression(amdgpu_gfx90a::acc9, output_vec_len );
            case 266:  return makeRegisterExpression(amdgpu_gfx90a::acc10, output_vec_len );
            case 267:  return makeRegisterExpression(amdgpu_gfx90a::acc11, output_vec_len );
            case 268:  return makeRegisterExpression(amdgpu_gfx90a::acc12, output_vec_len );
            case 269:  return makeRegisterExpression(amdgpu_gfx90a::acc13, output_vec_len );
            case 270:  return makeRegisterExpression(amdgpu_gfx90a::acc14, output_vec_len );
            case 271:  return makeRegisterExpression(amdgpu_gfx90a::acc15, output_vec_len );
            case 272:  return makeRegisterExpression(amdgpu_gfx90a::acc16, output_vec_len );
            case 273:  return makeRegisterExpression(amdgpu_gfx90a::acc17, output_vec_len );
            case 274:  return makeRegisterExpression(amdgpu_gfx90a::acc18, output_vec_len );
            case 275:  return makeRegisterExpression(amdgpu_gfx90a::acc19, output_vec_len );
            case 276:  return makeRegisterExpression(amdgpu_gfx90a::acc20, output_vec_len );
            case 277:  return makeRegisterExpression(amdgpu_gfx90a::acc21, output_vec_len );
            case 278:  return makeRegisterExpression(amdgpu_gfx90a::acc22, output_vec_len );
            case 279:  return makeRegisterExpression(amdgpu_gfx90a::acc23, output_vec_len );
            case 280:  return makeRegisterExpression(amdgpu_gfx90a::acc24, output_vec_len );
            case 281:  return makeRegisterExpression(amdgpu_gfx90a::acc25, output_vec_len );
            case 282:  return makeRegisterExpression(amdgpu_gfx90a::acc26, output_vec_len );
            case 283:  return makeRegisterExpression(amdgpu_gfx90a::acc27, output_vec_len );
            case 284:  return makeRegisterExpression(amdgpu_gfx90a::acc28, output_vec_len );
            case 285:  return makeRegisterExpression(amdgpu_gfx90a::acc29, output_vec_len );
            case 286:  return makeRegisterExpression(amdgpu_gfx90a::acc30, output_vec_len );
            case 287:  return makeRegisterExpression(amdgpu_gfx90a::acc31, output_vec_len );
            case 288:  return makeRegisterExpression(amdgpu_gfx90a::acc32, output_vec_len );
            case 289:  return makeRegisterExpression(amdgpu_gfx90a::acc33, output_vec_len );
            case 290:  return makeRegisterExpression(amdgpu_gfx90a::acc34, output_vec_len );
            case 291:  return makeRegisterExpression(amdgpu_gfx90a::acc35, output_vec_len );
            case 292:  return makeRegisterExpression(amdgpu_gfx90a::acc36, output_vec_len );
            case 293:  return makeRegisterExpression(amdgpu_gfx90a::acc37, output_vec_len );
            case 294:  return makeRegisterExpression(amdgpu_gfx90a::acc38, output_vec_len );
            case 295:  return makeRegisterExpression(amdgpu_gfx90a::acc39, output_vec_len );
            case 296:  return makeRegisterExpression(amdgpu_gfx90a::acc40, output_vec_len );
            case 297:  return makeRegisterExpression(amdgpu_gfx90a::acc41, output_vec_len );
            case 298:  return makeRegisterExpression(amdgpu_gfx90a::acc42, output_vec_len );
            case 299:  return makeRegisterExpression(amdgpu_gfx90a::acc43, output_vec_len );
            case 300:  return makeRegisterExpression(amdgpu_gfx90a::acc44, output_vec_len );
            case 301:  return makeRegisterExpression(amdgpu_gfx90a::acc45, output_vec_len );
            case 302:  return makeRegisterExpression(amdgpu_gfx90a::acc46, output_vec_len );
            case 303:  return makeRegisterExpression(amdgpu_gfx90a::acc47, output_vec_len );
            case 304:  return makeRegisterExpression(amdgpu_gfx90a::acc48, output_vec_len );
            case 305:  return makeRegisterExpression(amdgpu_gfx90a::acc49, output_vec_len );
            case 306:  return makeRegisterExpression(amdgpu_gfx90a::acc50, output_vec_len );
            case 307:  return makeRegisterExpression(amdgpu_gfx90a::acc51, output_vec_len );
            case 308:  return makeRegisterExpression(amdgpu_gfx90a::acc52, output_vec_len );
            case 309:  return makeRegisterExpression(amdgpu_gfx90a::acc53, output_vec_len );
            case 310:  return makeRegisterExpression(amdgpu_gfx90a::acc54, output_vec_len );
            case 311:  return makeRegisterExpression(amdgpu_gfx90a::acc55, output_vec_len );
            case 312:  return makeRegisterExpression(amdgpu_gfx90a::acc56, output_vec_len );
            case 313:  return makeRegisterExpression(amdgpu_gfx90a::acc57, output_vec_len );
            case 314:  return makeRegisterExpression(amdgpu_gfx90a::acc58, output_vec_len );
            case 315:  return makeRegisterExpression(amdgpu_gfx90a::acc59, output_vec_len );
            case 316:  return makeRegisterExpression(amdgpu_gfx90a::acc60, output_vec_len );
            case 317:  return makeRegisterExpression(amdgpu_gfx90a::acc61, output_vec_len );
            case 318:  return makeRegisterExpression(amdgpu_gfx90a::acc62, output_vec_len );
            case 319:  return makeRegisterExpression(amdgpu_gfx90a::acc63, output_vec_len );
            case 320:  return makeRegisterExpression(amdgpu_gfx90a::acc64, output_vec_len );
            case 321:  return makeRegisterExpression(amdgpu_gfx90a::acc65, output_vec_len );
            case 322:  return makeRegisterExpression(amdgpu_gfx90a::acc66, output_vec_len );
            case 323:  return makeRegisterExpression(amdgpu_gfx90a::acc67, output_vec_len );
            case 324:  return makeRegisterExpression(amdgpu_gfx90a::acc68, output_vec_len );
            case 325:  return makeRegisterExpression(amdgpu_gfx90a::acc69, output_vec_len );
            case 326:  return makeRegisterExpression(amdgpu_gfx90a::acc70, output_vec_len );
            case 327:  return makeRegisterExpression(amdgpu_gfx90a::acc71, output_vec_len );
            case 328:  return makeRegisterExpression(amdgpu_gfx90a::acc72, output_vec_len );
            case 329:  return makeRegisterExpression(amdgpu_gfx90a::acc73, output_vec_len );
            case 330:  return makeRegisterExpression(amdgpu_gfx90a::acc74, output_vec_len );
            case 331:  return makeRegisterExpression(amdgpu_gfx90a::acc75, output_vec_len );
            case 332:  return makeRegisterExpression(amdgpu_gfx90a::acc76, output_vec_len );
            case 333:  return makeRegisterExpression(amdgpu_gfx90a::acc77, output_vec_len );
            case 334:  return makeRegisterExpression(amdgpu_gfx90a::acc78, output_vec_len );
            case 335:  return makeRegisterExpression(amdgpu_gfx90a::acc79, output_vec_len );
            case 336:  return makeRegisterExpression(amdgpu_gfx90a::acc80, output_vec_len );
            case 337:  return makeRegisterExpression(amdgpu_gfx90a::acc81, output_vec_len );
            case 338:  return makeRegisterExpression(amdgpu_gfx90a::acc82, output_vec_len );
            case 339:  return makeRegisterExpression(amdgpu_gfx90a::acc83, output_vec_len );
            case 340:  return makeRegisterExpression(amdgpu_gfx90a::acc84, output_vec_len );
            case 341:  return makeRegisterExpression(amdgpu_gfx90a::acc85, output_vec_len );
            case 342:  return makeRegisterExpression(amdgpu_gfx90a::acc86, output_vec_len );
            case 343:  return makeRegisterExpression(amdgpu_gfx90a::acc87, output_vec_len );
            case 344:  return makeRegisterExpression(amdgpu_gfx90a::acc88, output_vec_len );
            case 345:  return makeRegisterExpression(amdgpu_gfx90a::acc89, output_vec_len );
            case 346:  return makeRegisterExpression(amdgpu_gfx90a::acc90, output_vec_len );
            case 347:  return makeRegisterExpression(amdgpu_gfx90a::acc91, output_vec_len );
            case 348:  return makeRegisterExpression(amdgpu_gfx90a::acc92, output_vec_len );
            case 349:  return makeRegisterExpression(amdgpu_gfx90a::acc93, output_vec_len );
            case 350:  return makeRegisterExpression(amdgpu_gfx90a::acc94, output_vec_len );
            case 351:  return makeRegisterExpression(amdgpu_gfx90a::acc95, output_vec_len );
            case 352:  return makeRegisterExpression(amdgpu_gfx90a::acc96, output_vec_len );
            case 353:  return makeRegisterExpression(amdgpu_gfx90a::acc97, output_vec_len );
            case 354:  return makeRegisterExpression(amdgpu_gfx90a::acc98, output_vec_len );
            case 355:  return makeRegisterExpression(amdgpu_gfx90a::acc99, output_vec_len );
            case 356:  return makeRegisterExpression(amdgpu_gfx90a::acc100, output_vec_len );
            case 357:  return makeRegisterExpression(amdgpu_gfx90a::acc101, output_vec_len );
            case 358:  return makeRegisterExpression(amdgpu_gfx90a::acc102, output_vec_len );
            case 359:  return makeRegisterExpression(amdgpu_gfx90a::acc103, output_vec_len );
            case 360:  return makeRegisterExpression(amdgpu_gfx90a::acc104, output_vec_len );
            case 361:  return makeRegisterExpression(amdgpu_gfx90a::acc105, output_vec_len );
            case 362:  return makeRegisterExpression(amdgpu_gfx90a::acc106, output_vec_len );
            case 363:  return makeRegisterExpression(amdgpu_gfx90a::acc107, output_vec_len );
            case 364:  return makeRegisterExpression(amdgpu_gfx90a::acc108, output_vec_len );
            case 365:  return makeRegisterExpression(amdgpu_gfx90a::acc109, output_vec_len );
            case 366:  return makeRegisterExpression(amdgpu_gfx90a::acc110, output_vec_len );
            case 367:  return makeRegisterExpression(amdgpu_gfx90a::acc111, output_vec_len );
            case 368:  return makeRegisterExpression(amdgpu_gfx90a::acc112, output_vec_len );
            case 369:  return makeRegisterExpression(amdgpu_gfx90a::acc113, output_vec_len );
            case 370:  return makeRegisterExpression(amdgpu_gfx90a::acc114, output_vec_len );
            case 371:  return makeRegisterExpression(amdgpu_gfx90a::acc115, output_vec_len );
            case 372:  return makeRegisterExpression(amdgpu_gfx90a::acc116, output_vec_len );
            case 373:  return makeRegisterExpression(amdgpu_gfx90a::acc117, output_vec_len );
            case 374:  return makeRegisterExpression(amdgpu_gfx90a::acc118, output_vec_len );
            case 375:  return makeRegisterExpression(amdgpu_gfx90a::acc119, output_vec_len );
            case 376:  return makeRegisterExpression(amdgpu_gfx90a::acc120, output_vec_len );
            case 377:  return makeRegisterExpression(amdgpu_gfx90a::acc121, output_vec_len );
            case 378:  return makeRegisterExpression(amdgpu_gfx90a::acc122, output_vec_len );
            case 379:  return makeRegisterExpression(amdgpu_gfx90a::acc123, output_vec_len );
            case 380:  return makeRegisterExpression(amdgpu_gfx90a::acc124, output_vec_len );
            case 381:  return makeRegisterExpression(amdgpu_gfx90a::acc125, output_vec_len );
            case 382:  return makeRegisterExpression(amdgpu_gfx90a::acc126, output_vec_len );
            case 383:  return makeRegisterExpression(amdgpu_gfx90a::acc127, output_vec_len );
            case 384:  return makeRegisterExpression(amdgpu_gfx90a::acc128, output_vec_len );
            case 385:  return makeRegisterExpression(amdgpu_gfx90a::acc129, output_vec_len );
            case 386:  return makeRegisterExpression(amdgpu_gfx90a::acc130, output_vec_len );
            case 387:  return makeRegisterExpression(amdgpu_gfx90a::acc131, output_vec_len );
            case 388:  return makeRegisterExpression(amdgpu_gfx90a::acc132, output_vec_len );
            case 389:  return makeRegisterExpression(amdgpu_gfx90a::acc133, output_vec_len );
            case 390:  return makeRegisterExpression(amdgpu_gfx90a::acc134, output_vec_len );
            case 391:  return makeRegisterExpression(amdgpu_gfx90a::acc135, output_vec_len );
            case 392:  return makeRegisterExpression(amdgpu_gfx90a::acc136, output_vec_len );
            case 393:  return makeRegisterExpression(amdgpu_gfx90a::acc137, output_vec_len );
            case 394:  return makeRegisterExpression(amdgpu_gfx90a::acc138, output_vec_len );
            case 395:  return makeRegisterExpression(amdgpu_gfx90a::acc139, output_vec_len );
            case 396:  return makeRegisterExpression(amdgpu_gfx90a::acc140, output_vec_len );
            case 397:  return makeRegisterExpression(amdgpu_gfx90a::acc141, output_vec_len );
            case 398:  return makeRegisterExpression(amdgpu_gfx90a::acc142, output_vec_len );
            case 399:  return makeRegisterExpression(amdgpu_gfx90a::acc143, output_vec_len );
            case 400:  return makeRegisterExpression(amdgpu_gfx90a::acc144, output_vec_len );
            case 401:  return makeRegisterExpression(amdgpu_gfx90a::acc145, output_vec_len );
            case 402:  return makeRegisterExpression(amdgpu_gfx90a::acc146, output_vec_len );
            case 403:  return makeRegisterExpression(amdgpu_gfx90a::acc147, output_vec_len );
            case 404:  return makeRegisterExpression(amdgpu_gfx90a::acc148, output_vec_len );
            case 405:  return makeRegisterExpression(amdgpu_gfx90a::acc149, output_vec_len );
            case 406:  return makeRegisterExpression(amdgpu_gfx90a::acc150, output_vec_len );
            case 407:  return makeRegisterExpression(amdgpu_gfx90a::acc151, output_vec_len );
            case 408:  return makeRegisterExpression(amdgpu_gfx90a::acc152, output_vec_len );
            case 409:  return makeRegisterExpression(amdgpu_gfx90a::acc153, output_vec_len );
            case 410:  return makeRegisterExpression(amdgpu_gfx90a::acc154, output_vec_len );
            case 411:  return makeRegisterExpression(amdgpu_gfx90a::acc155, output_vec_len );
            case 412:  return makeRegisterExpression(amdgpu_gfx90a::acc156, output_vec_len );
            case 413:  return makeRegisterExpression(amdgpu_gfx90a::acc157, output_vec_len );
            case 414:  return makeRegisterExpression(amdgpu_gfx90a::acc158, output_vec_len );
            case 415:  return makeRegisterExpression(amdgpu_gfx90a::acc159, output_vec_len );
            case 416:  return makeRegisterExpression(amdgpu_gfx90a::acc160, output_vec_len );
            case 417:  return makeRegisterExpression(amdgpu_gfx90a::acc161, output_vec_len );
            case 418:  return makeRegisterExpression(amdgpu_gfx90a::acc162, output_vec_len );
            case 419:  return makeRegisterExpression(amdgpu_gfx90a::acc163, output_vec_len );
            case 420:  return makeRegisterExpression(amdgpu_gfx90a::acc164, output_vec_len );
            case 421:  return makeRegisterExpression(amdgpu_gfx90a::acc165, output_vec_len );
            case 422:  return makeRegisterExpression(amdgpu_gfx90a::acc166, output_vec_len );
            case 423:  return makeRegisterExpression(amdgpu_gfx90a::acc167, output_vec_len );
            case 424:  return makeRegisterExpression(amdgpu_gfx90a::acc168, output_vec_len );
            case 425:  return makeRegisterExpression(amdgpu_gfx90a::acc169, output_vec_len );
            case 426:  return makeRegisterExpression(amdgpu_gfx90a::acc170, output_vec_len );
            case 427:  return makeRegisterExpression(amdgpu_gfx90a::acc171, output_vec_len );
            case 428:  return makeRegisterExpression(amdgpu_gfx90a::acc172, output_vec_len );
            case 429:  return makeRegisterExpression(amdgpu_gfx90a::acc173, output_vec_len );
            case 430:  return makeRegisterExpression(amdgpu_gfx90a::acc174, output_vec_len );
            case 431:  return makeRegisterExpression(amdgpu_gfx90a::acc175, output_vec_len );
            case 432:  return makeRegisterExpression(amdgpu_gfx90a::acc176, output_vec_len );
            case 433:  return makeRegisterExpression(amdgpu_gfx90a::acc177, output_vec_len );
            case 434:  return makeRegisterExpression(amdgpu_gfx90a::acc178, output_vec_len );
            case 435:  return makeRegisterExpression(amdgpu_gfx90a::acc179, output_vec_len );
            case 436:  return makeRegisterExpression(amdgpu_gfx90a::acc180, output_vec_len );
            case 437:  return makeRegisterExpression(amdgpu_gfx90a::acc181, output_vec_len );
            case 438:  return makeRegisterExpression(amdgpu_gfx90a::acc182, output_vec_len );
            case 439:  return makeRegisterExpression(amdgpu_gfx90a::acc183, output_vec_len );
            case 440:  return makeRegisterExpression(amdgpu_gfx90a::acc184, output_vec_len );
            case 441:  return makeRegisterExpression(amdgpu_gfx90a::acc185, output_vec_len );
            case 442:  return makeRegisterExpression(amdgpu_gfx90a::acc186, output_vec_len );
            case 443:  return makeRegisterExpression(amdgpu_gfx90a::acc187, output_vec_len );
            case 444:  return makeRegisterExpression(amdgpu_gfx90a::acc188, output_vec_len );
            case 445:  return makeRegisterExpression(amdgpu_gfx90a::acc189, output_vec_len );
            case 446:  return makeRegisterExpression(amdgpu_gfx90a::acc190, output_vec_len );
            case 447:  return makeRegisterExpression(amdgpu_gfx90a::acc191, output_vec_len );
            case 448:  return makeRegisterExpression(amdgpu_gfx90a::acc192, output_vec_len );
            case 449:  return makeRegisterExpression(amdgpu_gfx90a::acc193, output_vec_len );
            case 450:  return makeRegisterExpression(amdgpu_gfx90a::acc194, output_vec_len );
            case 451:  return makeRegisterExpression(amdgpu_gfx90a::acc195, output_vec_len );
            case 452:  return makeRegisterExpression(amdgpu_gfx90a::acc196, output_vec_len );
            case 453:  return makeRegisterExpression(amdgpu_gfx90a::acc197, output_vec_len );
            case 454:  return makeRegisterExpression(amdgpu_gfx90a::acc198, output_vec_len );
            case 455:  return makeRegisterExpression(amdgpu_gfx90a::acc199, output_vec_len );
            case 456:  return makeRegisterExpression(amdgpu_gfx90a::acc200, output_vec_len );
            case 457:  return makeRegisterExpression(amdgpu_gfx90a::acc201, output_vec_len );
            case 458:  return makeRegisterExpression(amdgpu_gfx90a::acc202, output_vec_len );
            case 459:  return makeRegisterExpression(amdgpu_gfx90a::acc203, output_vec_len );
            case 460:  return makeRegisterExpression(amdgpu_gfx90a::acc204, output_vec_len );
            case 461:  return makeRegisterExpression(amdgpu_gfx90a::acc205, output_vec_len );
            case 462:  return makeRegisterExpression(amdgpu_gfx90a::acc206, output_vec_len );
            case 463:  return makeRegisterExpression(amdgpu_gfx90a::acc207, output_vec_len );
            case 464:  return makeRegisterExpression(amdgpu_gfx90a::acc208, output_vec_len );
            case 465:  return makeRegisterExpression(amdgpu_gfx90a::acc209, output_vec_len );
            case 466:  return makeRegisterExpression(amdgpu_gfx90a::acc210, output_vec_len );
            case 467:  return makeRegisterExpression(amdgpu_gfx90a::acc211, output_vec_len );
            case 468:  return makeRegisterExpression(amdgpu_gfx90a::acc212, output_vec_len );
            case 469:  return makeRegisterExpression(amdgpu_gfx90a::acc213, output_vec_len );
            case 470:  return makeRegisterExpression(amdgpu_gfx90a::acc214, output_vec_len );
            case 471:  return makeRegisterExpression(amdgpu_gfx90a::acc215, output_vec_len );
            case 472:  return makeRegisterExpression(amdgpu_gfx90a::acc216, output_vec_len );
            case 473:  return makeRegisterExpression(amdgpu_gfx90a::acc217, output_vec_len );
            case 474:  return makeRegisterExpression(amdgpu_gfx90a::acc218, output_vec_len );
            case 475:  return makeRegisterExpression(amdgpu_gfx90a::acc219, output_vec_len );
            case 476:  return makeRegisterExpression(amdgpu_gfx90a::acc220, output_vec_len );
            case 477:  return makeRegisterExpression(amdgpu_gfx90a::acc221, output_vec_len );
            case 478:  return makeRegisterExpression(amdgpu_gfx90a::acc222, output_vec_len );
            case 479:  return makeRegisterExpression(amdgpu_gfx90a::acc223, output_vec_len );
            case 480:  return makeRegisterExpression(amdgpu_gfx90a::acc224, output_vec_len );
            case 481:  return makeRegisterExpression(amdgpu_gfx90a::acc225, output_vec_len );
            case 482:  return makeRegisterExpression(amdgpu_gfx90a::acc226, output_vec_len );
            case 483:  return makeRegisterExpression(amdgpu_gfx90a::acc227, output_vec_len );
            case 484:  return makeRegisterExpression(amdgpu_gfx90a::acc228, output_vec_len );
            case 485:  return makeRegisterExpression(amdgpu_gfx90a::acc229, output_vec_len );
            case 486:  return makeRegisterExpression(amdgpu_gfx90a::acc230, output_vec_len );
            case 487:  return makeRegisterExpression(amdgpu_gfx90a::acc231, output_vec_len );
            case 488:  return makeRegisterExpression(amdgpu_gfx90a::acc232, output_vec_len );
            case 489:  return makeRegisterExpression(amdgpu_gfx90a::acc233, output_vec_len );
            case 490:  return makeRegisterExpression(amdgpu_gfx90a::acc234, output_vec_len );
            case 491:  return makeRegisterExpression(amdgpu_gfx90a::acc235, output_vec_len );
            case 492:  return makeRegisterExpression(amdgpu_gfx90a::acc236, output_vec_len );
            case 493:  return makeRegisterExpression(amdgpu_gfx90a::acc237, output_vec_len );
            case 494:  return makeRegisterExpression(amdgpu_gfx90a::acc238, output_vec_len );
            case 495:  return makeRegisterExpression(amdgpu_gfx90a::acc239, output_vec_len );
            case 496:  return makeRegisterExpression(amdgpu_gfx90a::acc240, output_vec_len );
            case 497:  return makeRegisterExpression(amdgpu_gfx90a::acc241, output_vec_len );
            case 498:  return makeRegisterExpression(amdgpu_gfx90a::acc242, output_vec_len );
            case 499:  return makeRegisterExpression(amdgpu_gfx90a::acc243, output_vec_len );
            case 500:  return makeRegisterExpression(amdgpu_gfx90a::acc244, output_vec_len );
            case 501:  return makeRegisterExpression(amdgpu_gfx90a::acc245, output_vec_len );
            case 502:  return makeRegisterExpression(amdgpu_gfx90a::acc246, output_vec_len );
            case 503:  return makeRegisterExpression(amdgpu_gfx90a::acc247, output_vec_len );
            case 504:  return makeRegisterExpression(amdgpu_gfx90a::acc248, output_vec_len );
            case 505:  return makeRegisterExpression(amdgpu_gfx90a::acc249, output_vec_len );
            case 506:  return makeRegisterExpression(amdgpu_gfx90a::acc250, output_vec_len );
            case 507:  return makeRegisterExpression(amdgpu_gfx90a::acc251, output_vec_len );
            case 508:  return makeRegisterExpression(amdgpu_gfx90a::acc252, output_vec_len );
            case 509:  return makeRegisterExpression(amdgpu_gfx90a::acc253, output_vec_len );
            case 510:  return makeRegisterExpression(amdgpu_gfx90a::acc254, output_vec_len );
            case 511:  return makeRegisterExpression(amdgpu_gfx90a::acc255, output_vec_len );
            case 768:  return makeRegisterExpression(amdgpu_gfx90a::acc0, output_vec_len );
            case 769:  return makeRegisterExpression(amdgpu_gfx90a::acc1, output_vec_len );
            case 770:  return makeRegisterExpression(amdgpu_gfx90a::acc2, output_vec_len );
            case 771:  return makeRegisterExpression(amdgpu_gfx90a::acc3, output_vec_len );
            case 772:  return makeRegisterExpression(amdgpu_gfx90a::acc4, output_vec_len );
            case 773:  return makeRegisterExpression(amdgpu_gfx90a::acc5, output_vec_len );
            case 774:  return makeRegisterExpression(amdgpu_gfx90a::acc6, output_vec_len );
            case 775:  return makeRegisterExpression(amdgpu_gfx90a::acc7, output_vec_len );
            case 776:  return makeRegisterExpression(amdgpu_gfx90a::acc8, output_vec_len );
            case 777:  return makeRegisterExpression(amdgpu_gfx90a::acc9, output_vec_len );
            case 778:  return makeRegisterExpression(amdgpu_gfx90a::acc10, output_vec_len );
            case 779:  return makeRegisterExpression(amdgpu_gfx90a::acc11, output_vec_len );
            case 780:  return makeRegisterExpression(amdgpu_gfx90a::acc12, output_vec_len );
            case 781:  return makeRegisterExpression(amdgpu_gfx90a::acc13, output_vec_len );
            case 782:  return makeRegisterExpression(amdgpu_gfx90a::acc14, output_vec_len );
            case 783:  return makeRegisterExpression(amdgpu_gfx90a::acc15, output_vec_len );
            case 784:  return makeRegisterExpression(amdgpu_gfx90a::acc16, output_vec_len );
            case 785:  return makeRegisterExpression(amdgpu_gfx90a::acc17, output_vec_len );
            case 786:  return makeRegisterExpression(amdgpu_gfx90a::acc18, output_vec_len );
            case 787:  return makeRegisterExpression(amdgpu_gfx90a::acc19, output_vec_len );
            case 788:  return makeRegisterExpression(amdgpu_gfx90a::acc20, output_vec_len );
            case 789:  return makeRegisterExpression(amdgpu_gfx90a::acc21, output_vec_len );
            case 790:  return makeRegisterExpression(amdgpu_gfx90a::acc22, output_vec_len );
            case 791:  return makeRegisterExpression(amdgpu_gfx90a::acc23, output_vec_len );
            case 792:  return makeRegisterExpression(amdgpu_gfx90a::acc24, output_vec_len );
            case 793:  return makeRegisterExpression(amdgpu_gfx90a::acc25, output_vec_len );
            case 794:  return makeRegisterExpression(amdgpu_gfx90a::acc26, output_vec_len );
            case 795:  return makeRegisterExpression(amdgpu_gfx90a::acc27, output_vec_len );
            case 796:  return makeRegisterExpression(amdgpu_gfx90a::acc28, output_vec_len );
            case 797:  return makeRegisterExpression(amdgpu_gfx90a::acc29, output_vec_len );
            case 798:  return makeRegisterExpression(amdgpu_gfx90a::acc30, output_vec_len );
            case 799:  return makeRegisterExpression(amdgpu_gfx90a::acc31, output_vec_len );
            case 800:  return makeRegisterExpression(amdgpu_gfx90a::acc32, output_vec_len );
            case 801:  return makeRegisterExpression(amdgpu_gfx90a::acc33, output_vec_len );
            case 802:  return makeRegisterExpression(amdgpu_gfx90a::acc34, output_vec_len );
            case 803:  return makeRegisterExpression(amdgpu_gfx90a::acc35, output_vec_len );
            case 804:  return makeRegisterExpression(amdgpu_gfx90a::acc36, output_vec_len );
            case 805:  return makeRegisterExpression(amdgpu_gfx90a::acc37, output_vec_len );
            case 806:  return makeRegisterExpression(amdgpu_gfx90a::acc38, output_vec_len );
            case 807:  return makeRegisterExpression(amdgpu_gfx90a::acc39, output_vec_len );
            case 808:  return makeRegisterExpression(amdgpu_gfx90a::acc40, output_vec_len );
            case 809:  return makeRegisterExpression(amdgpu_gfx90a::acc41, output_vec_len );
            case 810:  return makeRegisterExpression(amdgpu_gfx90a::acc42, output_vec_len );
            case 811:  return makeRegisterExpression(amdgpu_gfx90a::acc43, output_vec_len );
            case 812:  return makeRegisterExpression(amdgpu_gfx90a::acc44, output_vec_len );
            case 813:  return makeRegisterExpression(amdgpu_gfx90a::acc45, output_vec_len );
            case 814:  return makeRegisterExpression(amdgpu_gfx90a::acc46, output_vec_len );
            case 815:  return makeRegisterExpression(amdgpu_gfx90a::acc47, output_vec_len );
            case 816:  return makeRegisterExpression(amdgpu_gfx90a::acc48, output_vec_len );
            case 817:  return makeRegisterExpression(amdgpu_gfx90a::acc49, output_vec_len );
            case 818:  return makeRegisterExpression(amdgpu_gfx90a::acc50, output_vec_len );
            case 819:  return makeRegisterExpression(amdgpu_gfx90a::acc51, output_vec_len );
            case 820:  return makeRegisterExpression(amdgpu_gfx90a::acc52, output_vec_len );
            case 821:  return makeRegisterExpression(amdgpu_gfx90a::acc53, output_vec_len );
            case 822:  return makeRegisterExpression(amdgpu_gfx90a::acc54, output_vec_len );
            case 823:  return makeRegisterExpression(amdgpu_gfx90a::acc55, output_vec_len );
            case 824:  return makeRegisterExpression(amdgpu_gfx90a::acc56, output_vec_len );
            case 825:  return makeRegisterExpression(amdgpu_gfx90a::acc57, output_vec_len );
            case 826:  return makeRegisterExpression(amdgpu_gfx90a::acc58, output_vec_len );
            case 827:  return makeRegisterExpression(amdgpu_gfx90a::acc59, output_vec_len );
            case 828:  return makeRegisterExpression(amdgpu_gfx90a::acc60, output_vec_len );
            case 829:  return makeRegisterExpression(amdgpu_gfx90a::acc61, output_vec_len );
            case 830:  return makeRegisterExpression(amdgpu_gfx90a::acc62, output_vec_len );
            case 831:  return makeRegisterExpression(amdgpu_gfx90a::acc63, output_vec_len );
            case 832:  return makeRegisterExpression(amdgpu_gfx90a::acc64, output_vec_len );
            case 833:  return makeRegisterExpression(amdgpu_gfx90a::acc65, output_vec_len );
            case 834:  return makeRegisterExpression(amdgpu_gfx90a::acc66, output_vec_len );
            case 835:  return makeRegisterExpression(amdgpu_gfx90a::acc67, output_vec_len );
            case 836:  return makeRegisterExpression(amdgpu_gfx90a::acc68, output_vec_len );
            case 837:  return makeRegisterExpression(amdgpu_gfx90a::acc69, output_vec_len );
            case 838:  return makeRegisterExpression(amdgpu_gfx90a::acc70, output_vec_len );
            case 839:  return makeRegisterExpression(amdgpu_gfx90a::acc71, output_vec_len );
            case 840:  return makeRegisterExpression(amdgpu_gfx90a::acc72, output_vec_len );
            case 841:  return makeRegisterExpression(amdgpu_gfx90a::acc73, output_vec_len );
            case 842:  return makeRegisterExpression(amdgpu_gfx90a::acc74, output_vec_len );
            case 843:  return makeRegisterExpression(amdgpu_gfx90a::acc75, output_vec_len );
            case 844:  return makeRegisterExpression(amdgpu_gfx90a::acc76, output_vec_len );
            case 845:  return makeRegisterExpression(amdgpu_gfx90a::acc77, output_vec_len );
            case 846:  return makeRegisterExpression(amdgpu_gfx90a::acc78, output_vec_len );
            case 847:  return makeRegisterExpression(amdgpu_gfx90a::acc79, output_vec_len );
            case 848:  return makeRegisterExpression(amdgpu_gfx90a::acc80, output_vec_len );
            case 849:  return makeRegisterExpression(amdgpu_gfx90a::acc81, output_vec_len );
            case 850:  return makeRegisterExpression(amdgpu_gfx90a::acc82, output_vec_len );
            case 851:  return makeRegisterExpression(amdgpu_gfx90a::acc83, output_vec_len );
            case 852:  return makeRegisterExpression(amdgpu_gfx90a::acc84, output_vec_len );
            case 853:  return makeRegisterExpression(amdgpu_gfx90a::acc85, output_vec_len );
            case 854:  return makeRegisterExpression(amdgpu_gfx90a::acc86, output_vec_len );
            case 855:  return makeRegisterExpression(amdgpu_gfx90a::acc87, output_vec_len );
            case 856:  return makeRegisterExpression(amdgpu_gfx90a::acc88, output_vec_len );
            case 857:  return makeRegisterExpression(amdgpu_gfx90a::acc89, output_vec_len );
            case 858:  return makeRegisterExpression(amdgpu_gfx90a::acc90, output_vec_len );
            case 859:  return makeRegisterExpression(amdgpu_gfx90a::acc91, output_vec_len );
            case 860:  return makeRegisterExpression(amdgpu_gfx90a::acc92, output_vec_len );
            case 861:  return makeRegisterExpression(amdgpu_gfx90a::acc93, output_vec_len );
            case 862:  return makeRegisterExpression(amdgpu_gfx90a::acc94, output_vec_len );
            case 863:  return makeRegisterExpression(amdgpu_gfx90a::acc95, output_vec_len );
            case 864:  return makeRegisterExpression(amdgpu_gfx90a::acc96, output_vec_len );
            case 865:  return makeRegisterExpression(amdgpu_gfx90a::acc97, output_vec_len );
            case 866:  return makeRegisterExpression(amdgpu_gfx90a::acc98, output_vec_len );
            case 867:  return makeRegisterExpression(amdgpu_gfx90a::acc99, output_vec_len );
            case 868:  return makeRegisterExpression(amdgpu_gfx90a::acc100, output_vec_len );
            case 869:  return makeRegisterExpression(amdgpu_gfx90a::acc101, output_vec_len );
            case 870:  return makeRegisterExpression(amdgpu_gfx90a::acc102, output_vec_len );
            case 871:  return makeRegisterExpression(amdgpu_gfx90a::acc103, output_vec_len );
            case 872:  return makeRegisterExpression(amdgpu_gfx90a::acc104, output_vec_len );
            case 873:  return makeRegisterExpression(amdgpu_gfx90a::acc105, output_vec_len );
            case 874:  return makeRegisterExpression(amdgpu_gfx90a::acc106, output_vec_len );
            case 875:  return makeRegisterExpression(amdgpu_gfx90a::acc107, output_vec_len );
            case 876:  return makeRegisterExpression(amdgpu_gfx90a::acc108, output_vec_len );
            case 877:  return makeRegisterExpression(amdgpu_gfx90a::acc109, output_vec_len );
            case 878:  return makeRegisterExpression(amdgpu_gfx90a::acc110, output_vec_len );
            case 879:  return makeRegisterExpression(amdgpu_gfx90a::acc111, output_vec_len );
            case 880:  return makeRegisterExpression(amdgpu_gfx90a::acc112, output_vec_len );
            case 881:  return makeRegisterExpression(amdgpu_gfx90a::acc113, output_vec_len );
            case 882:  return makeRegisterExpression(amdgpu_gfx90a::acc114, output_vec_len );
            case 883:  return makeRegisterExpression(amdgpu_gfx90a::acc115, output_vec_len );
            case 884:  return makeRegisterExpression(amdgpu_gfx90a::acc116, output_vec_len );
            case 885:  return makeRegisterExpression(amdgpu_gfx90a::acc117, output_vec_len );
            case 886:  return makeRegisterExpression(amdgpu_gfx90a::acc118, output_vec_len );
            case 887:  return makeRegisterExpression(amdgpu_gfx90a::acc119, output_vec_len );
            case 888:  return makeRegisterExpression(amdgpu_gfx90a::acc120, output_vec_len );
            case 889:  return makeRegisterExpression(amdgpu_gfx90a::acc121, output_vec_len );
            case 890:  return makeRegisterExpression(amdgpu_gfx90a::acc122, output_vec_len );
            case 891:  return makeRegisterExpression(amdgpu_gfx90a::acc123, output_vec_len );
            case 892:  return makeRegisterExpression(amdgpu_gfx90a::acc124, output_vec_len );
            case 893:  return makeRegisterExpression(amdgpu_gfx90a::acc125, output_vec_len );
            case 894:  return makeRegisterExpression(amdgpu_gfx90a::acc126, output_vec_len );
            case 895:  return makeRegisterExpression(amdgpu_gfx90a::acc127, output_vec_len );
            case 896:  return makeRegisterExpression(amdgpu_gfx90a::acc128, output_vec_len );
            case 897:  return makeRegisterExpression(amdgpu_gfx90a::acc129, output_vec_len );
            case 898:  return makeRegisterExpression(amdgpu_gfx90a::acc130, output_vec_len );
            case 899:  return makeRegisterExpression(amdgpu_gfx90a::acc131, output_vec_len );
            case 900:  return makeRegisterExpression(amdgpu_gfx90a::acc132, output_vec_len );
            case 901:  return makeRegisterExpression(amdgpu_gfx90a::acc133, output_vec_len );
            case 902:  return makeRegisterExpression(amdgpu_gfx90a::acc134, output_vec_len );
            case 903:  return makeRegisterExpression(amdgpu_gfx90a::acc135, output_vec_len );
            case 904:  return makeRegisterExpression(amdgpu_gfx90a::acc136, output_vec_len );
            case 905:  return makeRegisterExpression(amdgpu_gfx90a::acc137, output_vec_len );
            case 906:  return makeRegisterExpression(amdgpu_gfx90a::acc138, output_vec_len );
            case 907:  return makeRegisterExpression(amdgpu_gfx90a::acc139, output_vec_len );
            case 908:  return makeRegisterExpression(amdgpu_gfx90a::acc140, output_vec_len );
            case 909:  return makeRegisterExpression(amdgpu_gfx90a::acc141, output_vec_len );
            case 910:  return makeRegisterExpression(amdgpu_gfx90a::acc142, output_vec_len );
            case 911:  return makeRegisterExpression(amdgpu_gfx90a::acc143, output_vec_len );
            case 912:  return makeRegisterExpression(amdgpu_gfx90a::acc144, output_vec_len );
            case 913:  return makeRegisterExpression(amdgpu_gfx90a::acc145, output_vec_len );
            case 914:  return makeRegisterExpression(amdgpu_gfx90a::acc146, output_vec_len );
            case 915:  return makeRegisterExpression(amdgpu_gfx90a::acc147, output_vec_len );
            case 916:  return makeRegisterExpression(amdgpu_gfx90a::acc148, output_vec_len );
            case 917:  return makeRegisterExpression(amdgpu_gfx90a::acc149, output_vec_len );
            case 918:  return makeRegisterExpression(amdgpu_gfx90a::acc150, output_vec_len );
            case 919:  return makeRegisterExpression(amdgpu_gfx90a::acc151, output_vec_len );
            case 920:  return makeRegisterExpression(amdgpu_gfx90a::acc152, output_vec_len );
            case 921:  return makeRegisterExpression(amdgpu_gfx90a::acc153, output_vec_len );
            case 922:  return makeRegisterExpression(amdgpu_gfx90a::acc154, output_vec_len );
            case 923:  return makeRegisterExpression(amdgpu_gfx90a::acc155, output_vec_len );
            case 924:  return makeRegisterExpression(amdgpu_gfx90a::acc156, output_vec_len );
            case 925:  return makeRegisterExpression(amdgpu_gfx90a::acc157, output_vec_len );
            case 926:  return makeRegisterExpression(amdgpu_gfx90a::acc158, output_vec_len );
            case 927:  return makeRegisterExpression(amdgpu_gfx90a::acc159, output_vec_len );
            case 928:  return makeRegisterExpression(amdgpu_gfx90a::acc160, output_vec_len );
            case 929:  return makeRegisterExpression(amdgpu_gfx90a::acc161, output_vec_len );
            case 930:  return makeRegisterExpression(amdgpu_gfx90a::acc162, output_vec_len );
            case 931:  return makeRegisterExpression(amdgpu_gfx90a::acc163, output_vec_len );
            case 932:  return makeRegisterExpression(amdgpu_gfx90a::acc164, output_vec_len );
            case 933:  return makeRegisterExpression(amdgpu_gfx90a::acc165, output_vec_len );
            case 934:  return makeRegisterExpression(amdgpu_gfx90a::acc166, output_vec_len );
            case 935:  return makeRegisterExpression(amdgpu_gfx90a::acc167, output_vec_len );
            case 936:  return makeRegisterExpression(amdgpu_gfx90a::acc168, output_vec_len );
            case 937:  return makeRegisterExpression(amdgpu_gfx90a::acc169, output_vec_len );
            case 938:  return makeRegisterExpression(amdgpu_gfx90a::acc170, output_vec_len );
            case 939:  return makeRegisterExpression(amdgpu_gfx90a::acc171, output_vec_len );
            case 940:  return makeRegisterExpression(amdgpu_gfx90a::acc172, output_vec_len );
            case 941:  return makeRegisterExpression(amdgpu_gfx90a::acc173, output_vec_len );
            case 942:  return makeRegisterExpression(amdgpu_gfx90a::acc174, output_vec_len );
            case 943:  return makeRegisterExpression(amdgpu_gfx90a::acc175, output_vec_len );
            case 944:  return makeRegisterExpression(amdgpu_gfx90a::acc176, output_vec_len );
            case 945:  return makeRegisterExpression(amdgpu_gfx90a::acc177, output_vec_len );
            case 946:  return makeRegisterExpression(amdgpu_gfx90a::acc178, output_vec_len );
            case 947:  return makeRegisterExpression(amdgpu_gfx90a::acc179, output_vec_len );
            case 948:  return makeRegisterExpression(amdgpu_gfx90a::acc180, output_vec_len );
            case 949:  return makeRegisterExpression(amdgpu_gfx90a::acc181, output_vec_len );
            case 950:  return makeRegisterExpression(amdgpu_gfx90a::acc182, output_vec_len );
            case 951:  return makeRegisterExpression(amdgpu_gfx90a::acc183, output_vec_len );
            case 952:  return makeRegisterExpression(amdgpu_gfx90a::acc184, output_vec_len );
            case 953:  return makeRegisterExpression(amdgpu_gfx90a::acc185, output_vec_len );
            case 954:  return makeRegisterExpression(amdgpu_gfx90a::acc186, output_vec_len );
            case 955:  return makeRegisterExpression(amdgpu_gfx90a::acc187, output_vec_len );
            case 956:  return makeRegisterExpression(amdgpu_gfx90a::acc188, output_vec_len );
            case 957:  return makeRegisterExpression(amdgpu_gfx90a::acc189, output_vec_len );
            case 958:  return makeRegisterExpression(amdgpu_gfx90a::acc190, output_vec_len );
            case 959:  return makeRegisterExpression(amdgpu_gfx90a::acc191, output_vec_len );
            case 960:  return makeRegisterExpression(amdgpu_gfx90a::acc192, output_vec_len );
            case 961:  return makeRegisterExpression(amdgpu_gfx90a::acc193, output_vec_len );
            case 962:  return makeRegisterExpression(amdgpu_gfx90a::acc194, output_vec_len );
            case 963:  return makeRegisterExpression(amdgpu_gfx90a::acc195, output_vec_len );
            case 964:  return makeRegisterExpression(amdgpu_gfx90a::acc196, output_vec_len );
            case 965:  return makeRegisterExpression(amdgpu_gfx90a::acc197, output_vec_len );
            case 966:  return makeRegisterExpression(amdgpu_gfx90a::acc198, output_vec_len );
            case 967:  return makeRegisterExpression(amdgpu_gfx90a::acc199, output_vec_len );
            case 968:  return makeRegisterExpression(amdgpu_gfx90a::acc200, output_vec_len );
            case 969:  return makeRegisterExpression(amdgpu_gfx90a::acc201, output_vec_len );
            case 970:  return makeRegisterExpression(amdgpu_gfx90a::acc202, output_vec_len );
            case 971:  return makeRegisterExpression(amdgpu_gfx90a::acc203, output_vec_len );
            case 972:  return makeRegisterExpression(amdgpu_gfx90a::acc204, output_vec_len );
            case 973:  return makeRegisterExpression(amdgpu_gfx90a::acc205, output_vec_len );
            case 974:  return makeRegisterExpression(amdgpu_gfx90a::acc206, output_vec_len );
            case 975:  return makeRegisterExpression(amdgpu_gfx90a::acc207, output_vec_len );
            case 976:  return makeRegisterExpression(amdgpu_gfx90a::acc208, output_vec_len );
            case 977:  return makeRegisterExpression(amdgpu_gfx90a::acc209, output_vec_len );
            case 978:  return makeRegisterExpression(amdgpu_gfx90a::acc210, output_vec_len );
            case 979:  return makeRegisterExpression(amdgpu_gfx90a::acc211, output_vec_len );
            case 980:  return makeRegisterExpression(amdgpu_gfx90a::acc212, output_vec_len );
            case 981:  return makeRegisterExpression(amdgpu_gfx90a::acc213, output_vec_len );
            case 982:  return makeRegisterExpression(amdgpu_gfx90a::acc214, output_vec_len );
            case 983:  return makeRegisterExpression(amdgpu_gfx90a::acc215, output_vec_len );
            case 984:  return makeRegisterExpression(amdgpu_gfx90a::acc216, output_vec_len );
            case 985:  return makeRegisterExpression(amdgpu_gfx90a::acc217, output_vec_len );
            case 986:  return makeRegisterExpression(amdgpu_gfx90a::acc218, output_vec_len );
            case 987:  return makeRegisterExpression(amdgpu_gfx90a::acc219, output_vec_len );
            case 988:  return makeRegisterExpression(amdgpu_gfx90a::acc220, output_vec_len );
            case 989:  return makeRegisterExpression(amdgpu_gfx90a::acc221, output_vec_len );
            case 990:  return makeRegisterExpression(amdgpu_gfx90a::acc222, output_vec_len );
            case 991:  return makeRegisterExpression(amdgpu_gfx90a::acc223, output_vec_len );
            case 992:  return makeRegisterExpression(amdgpu_gfx90a::acc224, output_vec_len );
            case 993:  return makeRegisterExpression(amdgpu_gfx90a::acc225, output_vec_len );
            case 994:  return makeRegisterExpression(amdgpu_gfx90a::acc226, output_vec_len );
            case 995:  return makeRegisterExpression(amdgpu_gfx90a::acc227, output_vec_len );
            case 996:  return makeRegisterExpression(amdgpu_gfx90a::acc228, output_vec_len );
            case 997:  return makeRegisterExpression(amdgpu_gfx90a::acc229, output_vec_len );
            case 998:  return makeRegisterExpression(amdgpu_gfx90a::acc230, output_vec_len );
            case 999:  return makeRegisterExpression(amdgpu_gfx90a::acc231, output_vec_len );
            case 1000:  return makeRegisterExpression(amdgpu_gfx90a::acc232, output_vec_len );
            case 1001:  return makeRegisterExpression(amdgpu_gfx90a::acc233, output_vec_len );
            case 1002:  return makeRegisterExpression(amdgpu_gfx90a::acc234, output_vec_len );
            case 1003:  return makeRegisterExpression(amdgpu_gfx90a::acc235, output_vec_len );
            case 1004:  return makeRegisterExpression(amdgpu_gfx90a::acc236, output_vec_len );
            case 1005:  return makeRegisterExpression(amdgpu_gfx90a::acc237, output_vec_len );
            case 1006:  return makeRegisterExpression(amdgpu_gfx90a::acc238, output_vec_len );
            case 1007:  return makeRegisterExpression(amdgpu_gfx90a::acc239, output_vec_len );
            case 1008:  return makeRegisterExpression(amdgpu_gfx90a::acc240, output_vec_len );
            case 1009:  return makeRegisterExpression(amdgpu_gfx90a::acc241, output_vec_len );
            case 1010:  return makeRegisterExpression(amdgpu_gfx90a::acc242, output_vec_len );
            case 1011:  return makeRegisterExpression(amdgpu_gfx90a::acc243, output_vec_len );
            case 1012:  return makeRegisterExpression(amdgpu_gfx90a::acc244, output_vec_len );
            case 1013:  return makeRegisterExpression(amdgpu_gfx90a::acc245, output_vec_len );
            case 1014:  return makeRegisterExpression(amdgpu_gfx90a::acc246, output_vec_len );
            case 1015:  return makeRegisterExpression(amdgpu_gfx90a::acc247, output_vec_len );
            case 1016:  return makeRegisterExpression(amdgpu_gfx90a::acc248, output_vec_len );
            case 1017:  return makeRegisterExpression(amdgpu_gfx90a::acc249, output_vec_len );
            case 1018:  return makeRegisterExpression(amdgpu_gfx90a::acc250, output_vec_len );
            case 1019:  return makeRegisterExpression(amdgpu_gfx90a::acc251, output_vec_len );
            case 1020:  return makeRegisterExpression(amdgpu_gfx90a::acc252, output_vec_len );
            case 1021:  return makeRegisterExpression(amdgpu_gfx90a::acc253, output_vec_len );
            case 1022:  return makeRegisterExpression(amdgpu_gfx90a::acc254, output_vec_len );
            case 1023:  return makeRegisterExpression(amdgpu_gfx90a::acc255, output_vec_len );
            default: return makeRegisterExpression(amdgpu_gfx90a::invalid);
        }
    }

    Expression::Ptr InstructionDecoder_amdgpu_gfx90a::decodeOPR_SRC_NOLDS(uint64_t input, uint32_t output_vec_len)
    {
        switch (input)  {
            case 0:  return makeRegisterExpression(amdgpu_gfx90a::s0, output_vec_len );
            case 1:  return makeRegisterExpression(amdgpu_gfx90a::s1, output_vec_len );
            case 2:  return makeRegisterExpression(amdgpu_gfx90a::s2, output_vec_len );
            case 3:  return makeRegisterExpression(amdgpu_gfx90a::s3, output_vec_len );
            case 4:  return makeRegisterExpression(amdgpu_gfx90a::s4, output_vec_len );
            case 5:  return makeRegisterExpression(amdgpu_gfx90a::s5, output_vec_len );
            case 6:  return makeRegisterExpression(amdgpu_gfx90a::s6, output_vec_len );
            case 7:  return makeRegisterExpression(amdgpu_gfx90a::s7, output_vec_len );
            case 8:  return makeRegisterExpression(amdgpu_gfx90a::s8, output_vec_len );
            case 9:  return makeRegisterExpression(amdgpu_gfx90a::s9, output_vec_len );
            case 10:  return makeRegisterExpression(amdgpu_gfx90a::s10, output_vec_len );
            case 11:  return makeRegisterExpression(amdgpu_gfx90a::s11, output_vec_len );
            case 12:  return makeRegisterExpression(amdgpu_gfx90a::s12, output_vec_len );
            case 13:  return makeRegisterExpression(amdgpu_gfx90a::s13, output_vec_len );
            case 14:  return makeRegisterExpression(amdgpu_gfx90a::s14, output_vec_len );
            case 15:  return makeRegisterExpression(amdgpu_gfx90a::s15, output_vec_len );
            case 16:  return makeRegisterExpression(amdgpu_gfx90a::s16, output_vec_len );
            case 17:  return makeRegisterExpression(amdgpu_gfx90a::s17, output_vec_len );
            case 18:  return makeRegisterExpression(amdgpu_gfx90a::s18, output_vec_len );
            case 19:  return makeRegisterExpression(amdgpu_gfx90a::s19, output_vec_len );
            case 20:  return makeRegisterExpression(amdgpu_gfx90a::s20, output_vec_len );
            case 21:  return makeRegisterExpression(amdgpu_gfx90a::s21, output_vec_len );
            case 22:  return makeRegisterExpression(amdgpu_gfx90a::s22, output_vec_len );
            case 23:  return makeRegisterExpression(amdgpu_gfx90a::s23, output_vec_len );
            case 24:  return makeRegisterExpression(amdgpu_gfx90a::s24, output_vec_len );
            case 25:  return makeRegisterExpression(amdgpu_gfx90a::s25, output_vec_len );
            case 26:  return makeRegisterExpression(amdgpu_gfx90a::s26, output_vec_len );
            case 27:  return makeRegisterExpression(amdgpu_gfx90a::s27, output_vec_len );
            case 28:  return makeRegisterExpression(amdgpu_gfx90a::s28, output_vec_len );
            case 29:  return makeRegisterExpression(amdgpu_gfx90a::s29, output_vec_len );
            case 30:  return makeRegisterExpression(amdgpu_gfx90a::s30, output_vec_len );
            case 31:  return makeRegisterExpression(amdgpu_gfx90a::s31, output_vec_len );
            case 32:  return makeRegisterExpression(amdgpu_gfx90a::s32, output_vec_len );
            case 33:  return makeRegisterExpression(amdgpu_gfx90a::s33, output_vec_len );
            case 34:  return makeRegisterExpression(amdgpu_gfx90a::s34, output_vec_len );
            case 35:  return makeRegisterExpression(amdgpu_gfx90a::s35, output_vec_len );
            case 36:  return makeRegisterExpression(amdgpu_gfx90a::s36, output_vec_len );
            case 37:  return makeRegisterExpression(amdgpu_gfx90a::s37, output_vec_len );
            case 38:  return makeRegisterExpression(amdgpu_gfx90a::s38, output_vec_len );
            case 39:  return makeRegisterExpression(amdgpu_gfx90a::s39, output_vec_len );
            case 40:  return makeRegisterExpression(amdgpu_gfx90a::s40, output_vec_len );
            case 41:  return makeRegisterExpression(amdgpu_gfx90a::s41, output_vec_len );
            case 42:  return makeRegisterExpression(amdgpu_gfx90a::s42, output_vec_len );
            case 43:  return makeRegisterExpression(amdgpu_gfx90a::s43, output_vec_len );
            case 44:  return makeRegisterExpression(amdgpu_gfx90a::s44, output_vec_len );
            case 45:  return makeRegisterExpression(amdgpu_gfx90a::s45, output_vec_len );
            case 46:  return makeRegisterExpression(amdgpu_gfx90a::s46, output_vec_len );
            case 47:  return makeRegisterExpression(amdgpu_gfx90a::s47, output_vec_len );
            case 48:  return makeRegisterExpression(amdgpu_gfx90a::s48, output_vec_len );
            case 49:  return makeRegisterExpression(amdgpu_gfx90a::s49, output_vec_len );
            case 50:  return makeRegisterExpression(amdgpu_gfx90a::s50, output_vec_len );
            case 51:  return makeRegisterExpression(amdgpu_gfx90a::s51, output_vec_len );
            case 52:  return makeRegisterExpression(amdgpu_gfx90a::s52, output_vec_len );
            case 53:  return makeRegisterExpression(amdgpu_gfx90a::s53, output_vec_len );
            case 54:  return makeRegisterExpression(amdgpu_gfx90a::s54, output_vec_len );
            case 55:  return makeRegisterExpression(amdgpu_gfx90a::s55, output_vec_len );
            case 56:  return makeRegisterExpression(amdgpu_gfx90a::s56, output_vec_len );
            case 57:  return makeRegisterExpression(amdgpu_gfx90a::s57, output_vec_len );
            case 58:  return makeRegisterExpression(amdgpu_gfx90a::s58, output_vec_len );
            case 59:  return makeRegisterExpression(amdgpu_gfx90a::s59, output_vec_len );
            case 60:  return makeRegisterExpression(amdgpu_gfx90a::s60, output_vec_len );
            case 61:  return makeRegisterExpression(amdgpu_gfx90a::s61, output_vec_len );
            case 62:  return makeRegisterExpression(amdgpu_gfx90a::s62, output_vec_len );
            case 63:  return makeRegisterExpression(amdgpu_gfx90a::s63, output_vec_len );
            case 64:  return makeRegisterExpression(amdgpu_gfx90a::s64, output_vec_len );
            case 65:  return makeRegisterExpression(amdgpu_gfx90a::s65, output_vec_len );
            case 66:  return makeRegisterExpression(amdgpu_gfx90a::s66, output_vec_len );
            case 67:  return makeRegisterExpression(amdgpu_gfx90a::s67, output_vec_len );
            case 68:  return makeRegisterExpression(amdgpu_gfx90a::s68, output_vec_len );
            case 69:  return makeRegisterExpression(amdgpu_gfx90a::s69, output_vec_len );
            case 70:  return makeRegisterExpression(amdgpu_gfx90a::s70, output_vec_len );
            case 71:  return makeRegisterExpression(amdgpu_gfx90a::s71, output_vec_len );
            case 72:  return makeRegisterExpression(amdgpu_gfx90a::s72, output_vec_len );
            case 73:  return makeRegisterExpression(amdgpu_gfx90a::s73, output_vec_len );
            case 74:  return makeRegisterExpression(amdgpu_gfx90a::s74, output_vec_len );
            case 75:  return makeRegisterExpression(amdgpu_gfx90a::s75, output_vec_len );
            case 76:  return makeRegisterExpression(amdgpu_gfx90a::s76, output_vec_len );
            case 77:  return makeRegisterExpression(amdgpu_gfx90a::s77, output_vec_len );
            case 78:  return makeRegisterExpression(amdgpu_gfx90a::s78, output_vec_len );
            case 79:  return makeRegisterExpression(amdgpu_gfx90a::s79, output_vec_len );
            case 80:  return makeRegisterExpression(amdgpu_gfx90a::s80, output_vec_len );
            case 81:  return makeRegisterExpression(amdgpu_gfx90a::s81, output_vec_len );
            case 82:  return makeRegisterExpression(amdgpu_gfx90a::s82, output_vec_len );
            case 83:  return makeRegisterExpression(amdgpu_gfx90a::s83, output_vec_len );
            case 84:  return makeRegisterExpression(amdgpu_gfx90a::s84, output_vec_len );
            case 85:  return makeRegisterExpression(amdgpu_gfx90a::s85, output_vec_len );
            case 86:  return makeRegisterExpression(amdgpu_gfx90a::s86, output_vec_len );
            case 87:  return makeRegisterExpression(amdgpu_gfx90a::s87, output_vec_len );
            case 88:  return makeRegisterExpression(amdgpu_gfx90a::s88, output_vec_len );
            case 89:  return makeRegisterExpression(amdgpu_gfx90a::s89, output_vec_len );
            case 90:  return makeRegisterExpression(amdgpu_gfx90a::s90, output_vec_len );
            case 91:  return makeRegisterExpression(amdgpu_gfx90a::s91, output_vec_len );
            case 92:  return makeRegisterExpression(amdgpu_gfx90a::s92, output_vec_len );
            case 93:  return makeRegisterExpression(amdgpu_gfx90a::s93, output_vec_len );
            case 94:  return makeRegisterExpression(amdgpu_gfx90a::s94, output_vec_len );
            case 95:  return makeRegisterExpression(amdgpu_gfx90a::s95, output_vec_len );
            case 96:  return makeRegisterExpression(amdgpu_gfx90a::s96, output_vec_len );
            case 97:  return makeRegisterExpression(amdgpu_gfx90a::s97, output_vec_len );
            case 98:  return makeRegisterExpression(amdgpu_gfx90a::s98, output_vec_len );
            case 99:  return makeRegisterExpression(amdgpu_gfx90a::s99, output_vec_len );
            case 100:  return makeRegisterExpression(amdgpu_gfx90a::s100, output_vec_len );
            case 101:  return makeRegisterExpression(amdgpu_gfx90a::s101, output_vec_len );
            case 104:  return makeRegisterExpression(amdgpu_gfx90a::xnack_mask_lo, output_vec_len );
            case 105:  return makeRegisterExpression(amdgpu_gfx90a::xnack_mask_hi, output_vec_len );
            case 102:  return makeRegisterExpression(amdgpu_gfx90a::flat_scratch_lo, output_vec_len );
            case 103:  return makeRegisterExpression(amdgpu_gfx90a::flat_scratch_hi, output_vec_len );
            case 108:  return makeRegisterExpression(amdgpu_gfx90a::ttmp0, output_vec_len );
            case 109:  return makeRegisterExpression(amdgpu_gfx90a::ttmp1, output_vec_len );
            case 110:  return makeRegisterExpression(amdgpu_gfx90a::ttmp2, output_vec_len );
            case 111:  return makeRegisterExpression(amdgpu_gfx90a::ttmp3, output_vec_len );
            case 112:  return makeRegisterExpression(amdgpu_gfx90a::ttmp4, output_vec_len );
            case 113:  return makeRegisterExpression(amdgpu_gfx90a::ttmp5, output_vec_len );
            case 114:  return makeRegisterExpression(amdgpu_gfx90a::ttmp6, output_vec_len );
            case 115:  return makeRegisterExpression(amdgpu_gfx90a::ttmp7, output_vec_len );
            case 116:  return makeRegisterExpression(amdgpu_gfx90a::ttmp8, output_vec_len );
            case 117:  return makeRegisterExpression(amdgpu_gfx90a::ttmp9, output_vec_len );
            case 118:  return makeRegisterExpression(amdgpu_gfx90a::ttmp10, output_vec_len );
            case 119:  return makeRegisterExpression(amdgpu_gfx90a::ttmp11, output_vec_len );
            case 120:  return makeRegisterExpression(amdgpu_gfx90a::ttmp12, output_vec_len );
            case 121:  return makeRegisterExpression(amdgpu_gfx90a::ttmp13, output_vec_len );
            case 122:  return makeRegisterExpression(amdgpu_gfx90a::ttmp14, output_vec_len );
            case 123:  return makeRegisterExpression(amdgpu_gfx90a::ttmp15, output_vec_len );
            case 106:  return makeRegisterExpression(amdgpu_gfx90a::vcc_lo, output_vec_len );
            case 107:  return makeRegisterExpression(amdgpu_gfx90a::vcc_hi, output_vec_len );
            case 124:  return makeRegisterExpression(amdgpu_gfx90a::m0, output_vec_len );
            case 126:  return makeRegisterExpression(amdgpu_gfx90a::exec_lo, output_vec_len );
            case 127:  return makeRegisterExpression(amdgpu_gfx90a::exec_hi, output_vec_len );
            case 128:  return Immediate::makeImmediate(Result(u32, 0));
            case 129:  return Immediate::makeImmediate(Result(u32, 1));
            case 130:  return Immediate::makeImmediate(Result(u32, 2));
            case 131:  return Immediate::makeImmediate(Result(u32, 3));
            case 132:  return Immediate::makeImmediate(Result(u32, 4));
            case 133:  return Immediate::makeImmediate(Result(u32, 5));
            case 134:  return Immediate::makeImmediate(Result(u32, 6));
            case 135:  return Immediate::makeImmediate(Result(u32, 7));
            case 136:  return Immediate::makeImmediate(Result(u32, 8));
            case 137:  return Immediate::makeImmediate(Result(u32, 9));
            case 138:  return Immediate::makeImmediate(Result(u32, 10));
            case 139:  return Immediate::makeImmediate(Result(u32, 11));
            case 140:  return Immediate::makeImmediate(Result(u32, 12));
            case 141:  return Immediate::makeImmediate(Result(u32, 13));
            case 142:  return Immediate::makeImmediate(Result(u32, 14));
            case 143:  return Immediate::makeImmediate(Result(u32, 15));
            case 144:  return Immediate::makeImmediate(Result(u32, 16));
            case 145:  return Immediate::makeImmediate(Result(u32, 17));
            case 146:  return Immediate::makeImmediate(Result(u32, 18));
            case 147:  return Immediate::makeImmediate(Result(u32, 19));
            case 148:  return Immediate::makeImmediate(Result(u32, 20));
            case 149:  return Immediate::makeImmediate(Result(u32, 21));
            case 150:  return Immediate::makeImmediate(Result(u32, 22));
            case 151:  return Immediate::makeImmediate(Result(u32, 23));
            case 152:  return Immediate::makeImmediate(Result(u32, 24));
            case 153:  return Immediate::makeImmediate(Result(u32, 25));
            case 154:  return Immediate::makeImmediate(Result(u32, 26));
            case 155:  return Immediate::makeImmediate(Result(u32, 27));
            case 156:  return Immediate::makeImmediate(Result(u32, 28));
            case 157:  return Immediate::makeImmediate(Result(u32, 29));
            case 158:  return Immediate::makeImmediate(Result(u32, 30));
            case 159:  return Immediate::makeImmediate(Result(u32, 31));
            case 160:  return Immediate::makeImmediate(Result(u32, 32));
            case 161:  return Immediate::makeImmediate(Result(u32, 33));
            case 162:  return Immediate::makeImmediate(Result(u32, 34));
            case 163:  return Immediate::makeImmediate(Result(u32, 35));
            case 164:  return Immediate::makeImmediate(Result(u32, 36));
            case 165:  return Immediate::makeImmediate(Result(u32, 37));
            case 166:  return Immediate::makeImmediate(Result(u32, 38));
            case 167:  return Immediate::makeImmediate(Result(u32, 39));
            case 168:  return Immediate::makeImmediate(Result(u32, 40));
            case 169:  return Immediate::makeImmediate(Result(u32, 41));
            case 170:  return Immediate::makeImmediate(Result(u32, 42));
            case 171:  return Immediate::makeImmediate(Result(u32, 43));
            case 172:  return Immediate::makeImmediate(Result(u32, 44));
            case 173:  return Immediate::makeImmediate(Result(u32, 45));
            case 174:  return Immediate::makeImmediate(Result(u32, 46));
            case 175:  return Immediate::makeImmediate(Result(u32, 47));
            case 176:  return Immediate::makeImmediate(Result(u32, 48));
            case 177:  return Immediate::makeImmediate(Result(u32, 49));
            case 178:  return Immediate::makeImmediate(Result(u32, 50));
            case 179:  return Immediate::makeImmediate(Result(u32, 51));
            case 180:  return Immediate::makeImmediate(Result(u32, 52));
            case 181:  return Immediate::makeImmediate(Result(u32, 53));
            case 182:  return Immediate::makeImmediate(Result(u32, 54));
            case 183:  return Immediate::makeImmediate(Result(u32, 55));
            case 184:  return Immediate::makeImmediate(Result(u32, 56));
            case 185:  return Immediate::makeImmediate(Result(u32, 57));
            case 186:  return Immediate::makeImmediate(Result(u32, 58));
            case 187:  return Immediate::makeImmediate(Result(u32, 59));
            case 188:  return Immediate::makeImmediate(Result(u32, 60));
            case 189:  return Immediate::makeImmediate(Result(u32, 61));
            case 190:  return Immediate::makeImmediate(Result(u32, 62));
            case 191:  return Immediate::makeImmediate(Result(u32, 63));
            case 192:  return Immediate::makeImmediate(Result(u32, 64));
            case 193:  return Immediate::makeImmediate(Result(u32, -1));
            case 194:  return Immediate::makeImmediate(Result(u32, -2));
            case 195:  return Immediate::makeImmediate(Result(u32, -3));
            case 196:  return Immediate::makeImmediate(Result(u32, -4));
            case 197:  return Immediate::makeImmediate(Result(u32, -5));
            case 198:  return Immediate::makeImmediate(Result(u32, -6));
            case 199:  return Immediate::makeImmediate(Result(u32, -7));
            case 200:  return Immediate::makeImmediate(Result(u32, -8));
            case 201:  return Immediate::makeImmediate(Result(u32, -9));
            case 202:  return Immediate::makeImmediate(Result(u32, -10));
            case 203:  return Immediate::makeImmediate(Result(u32, -11));
            case 204:  return Immediate::makeImmediate(Result(u32, -12));
            case 205:  return Immediate::makeImmediate(Result(u32, -13));
            case 206:  return Immediate::makeImmediate(Result(u32, -14));
            case 207:  return Immediate::makeImmediate(Result(u32, -15));
            case 208:  return Immediate::makeImmediate(Result(u32, -16));
            case 240:  return Immediate::makeImmediate(Result(sp_float, 0.5));
            case 241:  return Immediate::makeImmediate(Result(sp_float, -0.5));
            case 242:  return Immediate::makeImmediate(Result(sp_float, 1.0));
            case 243:  return Immediate::makeImmediate(Result(sp_float, -1.0));
            case 244:  return Immediate::makeImmediate(Result(sp_float, 2.0));
            case 245:  return Immediate::makeImmediate(Result(sp_float, -2.0));
            case 246:  return Immediate::makeImmediate(Result(sp_float, 4.0));
            case 247:  return Immediate::makeImmediate(Result(sp_float, -4.0));
            case 248:  return Immediate::makeImmediate(Result(sp_float, 0.15915494));
            case 251:  return makeRegisterExpression(amdgpu_gfx90a::src_vccz, output_vec_len );
            case 252:  return makeRegisterExpression(amdgpu_gfx90a::src_execz, output_vec_len );
            case 253:  return makeRegisterExpression(amdgpu_gfx90a::src_scc, output_vec_len );
            case 235:  return makeRegisterExpression(amdgpu_gfx90a::src_shared_base, output_vec_len );
            case 236:  return makeRegisterExpression(amdgpu_gfx90a::src_shared_limit, output_vec_len );
            case 237:  return makeRegisterExpression(amdgpu_gfx90a::src_private_base, output_vec_len );
            case 238:  return makeRegisterExpression(amdgpu_gfx90a::src_private_limit, output_vec_len );
            case 239:  return makeRegisterExpression(amdgpu_gfx90a::src_pops_exiting_wave_id, output_vec_len );
            case 256:  return makeRegisterExpression(amdgpu_gfx90a::v0, output_vec_len );
            case 257:  return makeRegisterExpression(amdgpu_gfx90a::v1, output_vec_len );
            case 258:  return makeRegisterExpression(amdgpu_gfx90a::v2, output_vec_len );
            case 259:  return makeRegisterExpression(amdgpu_gfx90a::v3, output_vec_len );
            case 260:  return makeRegisterExpression(amdgpu_gfx90a::v4, output_vec_len );
            case 261:  return makeRegisterExpression(amdgpu_gfx90a::v5, output_vec_len );
            case 262:  return makeRegisterExpression(amdgpu_gfx90a::v6, output_vec_len );
            case 263:  return makeRegisterExpression(amdgpu_gfx90a::v7, output_vec_len );
            case 264:  return makeRegisterExpression(amdgpu_gfx90a::v8, output_vec_len );
            case 265:  return makeRegisterExpression(amdgpu_gfx90a::v9, output_vec_len );
            case 266:  return makeRegisterExpression(amdgpu_gfx90a::v10, output_vec_len );
            case 267:  return makeRegisterExpression(amdgpu_gfx90a::v11, output_vec_len );
            case 268:  return makeRegisterExpression(amdgpu_gfx90a::v12, output_vec_len );
            case 269:  return makeRegisterExpression(amdgpu_gfx90a::v13, output_vec_len );
            case 270:  return makeRegisterExpression(amdgpu_gfx90a::v14, output_vec_len );
            case 271:  return makeRegisterExpression(amdgpu_gfx90a::v15, output_vec_len );
            case 272:  return makeRegisterExpression(amdgpu_gfx90a::v16, output_vec_len );
            case 273:  return makeRegisterExpression(amdgpu_gfx90a::v17, output_vec_len );
            case 274:  return makeRegisterExpression(amdgpu_gfx90a::v18, output_vec_len );
            case 275:  return makeRegisterExpression(amdgpu_gfx90a::v19, output_vec_len );
            case 276:  return makeRegisterExpression(amdgpu_gfx90a::v20, output_vec_len );
            case 277:  return makeRegisterExpression(amdgpu_gfx90a::v21, output_vec_len );
            case 278:  return makeRegisterExpression(amdgpu_gfx90a::v22, output_vec_len );
            case 279:  return makeRegisterExpression(amdgpu_gfx90a::v23, output_vec_len );
            case 280:  return makeRegisterExpression(amdgpu_gfx90a::v24, output_vec_len );
            case 281:  return makeRegisterExpression(amdgpu_gfx90a::v25, output_vec_len );
            case 282:  return makeRegisterExpression(amdgpu_gfx90a::v26, output_vec_len );
            case 283:  return makeRegisterExpression(amdgpu_gfx90a::v27, output_vec_len );
            case 284:  return makeRegisterExpression(amdgpu_gfx90a::v28, output_vec_len );
            case 285:  return makeRegisterExpression(amdgpu_gfx90a::v29, output_vec_len );
            case 286:  return makeRegisterExpression(amdgpu_gfx90a::v30, output_vec_len );
            case 287:  return makeRegisterExpression(amdgpu_gfx90a::v31, output_vec_len );
            case 288:  return makeRegisterExpression(amdgpu_gfx90a::v32, output_vec_len );
            case 289:  return makeRegisterExpression(amdgpu_gfx90a::v33, output_vec_len );
            case 290:  return makeRegisterExpression(amdgpu_gfx90a::v34, output_vec_len );
            case 291:  return makeRegisterExpression(amdgpu_gfx90a::v35, output_vec_len );
            case 292:  return makeRegisterExpression(amdgpu_gfx90a::v36, output_vec_len );
            case 293:  return makeRegisterExpression(amdgpu_gfx90a::v37, output_vec_len );
            case 294:  return makeRegisterExpression(amdgpu_gfx90a::v38, output_vec_len );
            case 295:  return makeRegisterExpression(amdgpu_gfx90a::v39, output_vec_len );
            case 296:  return makeRegisterExpression(amdgpu_gfx90a::v40, output_vec_len );
            case 297:  return makeRegisterExpression(amdgpu_gfx90a::v41, output_vec_len );
            case 298:  return makeRegisterExpression(amdgpu_gfx90a::v42, output_vec_len );
            case 299:  return makeRegisterExpression(amdgpu_gfx90a::v43, output_vec_len );
            case 300:  return makeRegisterExpression(amdgpu_gfx90a::v44, output_vec_len );
            case 301:  return makeRegisterExpression(amdgpu_gfx90a::v45, output_vec_len );
            case 302:  return makeRegisterExpression(amdgpu_gfx90a::v46, output_vec_len );
            case 303:  return makeRegisterExpression(amdgpu_gfx90a::v47, output_vec_len );
            case 304:  return makeRegisterExpression(amdgpu_gfx90a::v48, output_vec_len );
            case 305:  return makeRegisterExpression(amdgpu_gfx90a::v49, output_vec_len );
            case 306:  return makeRegisterExpression(amdgpu_gfx90a::v50, output_vec_len );
            case 307:  return makeRegisterExpression(amdgpu_gfx90a::v51, output_vec_len );
            case 308:  return makeRegisterExpression(amdgpu_gfx90a::v52, output_vec_len );
            case 309:  return makeRegisterExpression(amdgpu_gfx90a::v53, output_vec_len );
            case 310:  return makeRegisterExpression(amdgpu_gfx90a::v54, output_vec_len );
            case 311:  return makeRegisterExpression(amdgpu_gfx90a::v55, output_vec_len );
            case 312:  return makeRegisterExpression(amdgpu_gfx90a::v56, output_vec_len );
            case 313:  return makeRegisterExpression(amdgpu_gfx90a::v57, output_vec_len );
            case 314:  return makeRegisterExpression(amdgpu_gfx90a::v58, output_vec_len );
            case 315:  return makeRegisterExpression(amdgpu_gfx90a::v59, output_vec_len );
            case 316:  return makeRegisterExpression(amdgpu_gfx90a::v60, output_vec_len );
            case 317:  return makeRegisterExpression(amdgpu_gfx90a::v61, output_vec_len );
            case 318:  return makeRegisterExpression(amdgpu_gfx90a::v62, output_vec_len );
            case 319:  return makeRegisterExpression(amdgpu_gfx90a::v63, output_vec_len );
            case 320:  return makeRegisterExpression(amdgpu_gfx90a::v64, output_vec_len );
            case 321:  return makeRegisterExpression(amdgpu_gfx90a::v65, output_vec_len );
            case 322:  return makeRegisterExpression(amdgpu_gfx90a::v66, output_vec_len );
            case 323:  return makeRegisterExpression(amdgpu_gfx90a::v67, output_vec_len );
            case 324:  return makeRegisterExpression(amdgpu_gfx90a::v68, output_vec_len );
            case 325:  return makeRegisterExpression(amdgpu_gfx90a::v69, output_vec_len );
            case 326:  return makeRegisterExpression(amdgpu_gfx90a::v70, output_vec_len );
            case 327:  return makeRegisterExpression(amdgpu_gfx90a::v71, output_vec_len );
            case 328:  return makeRegisterExpression(amdgpu_gfx90a::v72, output_vec_len );
            case 329:  return makeRegisterExpression(amdgpu_gfx90a::v73, output_vec_len );
            case 330:  return makeRegisterExpression(amdgpu_gfx90a::v74, output_vec_len );
            case 331:  return makeRegisterExpression(amdgpu_gfx90a::v75, output_vec_len );
            case 332:  return makeRegisterExpression(amdgpu_gfx90a::v76, output_vec_len );
            case 333:  return makeRegisterExpression(amdgpu_gfx90a::v77, output_vec_len );
            case 334:  return makeRegisterExpression(amdgpu_gfx90a::v78, output_vec_len );
            case 335:  return makeRegisterExpression(amdgpu_gfx90a::v79, output_vec_len );
            case 336:  return makeRegisterExpression(amdgpu_gfx90a::v80, output_vec_len );
            case 337:  return makeRegisterExpression(amdgpu_gfx90a::v81, output_vec_len );
            case 338:  return makeRegisterExpression(amdgpu_gfx90a::v82, output_vec_len );
            case 339:  return makeRegisterExpression(amdgpu_gfx90a::v83, output_vec_len );
            case 340:  return makeRegisterExpression(amdgpu_gfx90a::v84, output_vec_len );
            case 341:  return makeRegisterExpression(amdgpu_gfx90a::v85, output_vec_len );
            case 342:  return makeRegisterExpression(amdgpu_gfx90a::v86, output_vec_len );
            case 343:  return makeRegisterExpression(amdgpu_gfx90a::v87, output_vec_len );
            case 344:  return makeRegisterExpression(amdgpu_gfx90a::v88, output_vec_len );
            case 345:  return makeRegisterExpression(amdgpu_gfx90a::v89, output_vec_len );
            case 346:  return makeRegisterExpression(amdgpu_gfx90a::v90, output_vec_len );
            case 347:  return makeRegisterExpression(amdgpu_gfx90a::v91, output_vec_len );
            case 348:  return makeRegisterExpression(amdgpu_gfx90a::v92, output_vec_len );
            case 349:  return makeRegisterExpression(amdgpu_gfx90a::v93, output_vec_len );
            case 350:  return makeRegisterExpression(amdgpu_gfx90a::v94, output_vec_len );
            case 351:  return makeRegisterExpression(amdgpu_gfx90a::v95, output_vec_len );
            case 352:  return makeRegisterExpression(amdgpu_gfx90a::v96, output_vec_len );
            case 353:  return makeRegisterExpression(amdgpu_gfx90a::v97, output_vec_len );
            case 354:  return makeRegisterExpression(amdgpu_gfx90a::v98, output_vec_len );
            case 355:  return makeRegisterExpression(amdgpu_gfx90a::v99, output_vec_len );
            case 356:  return makeRegisterExpression(amdgpu_gfx90a::v100, output_vec_len );
            case 357:  return makeRegisterExpression(amdgpu_gfx90a::v101, output_vec_len );
            case 358:  return makeRegisterExpression(amdgpu_gfx90a::v102, output_vec_len );
            case 359:  return makeRegisterExpression(amdgpu_gfx90a::v103, output_vec_len );
            case 360:  return makeRegisterExpression(amdgpu_gfx90a::v104, output_vec_len );
            case 361:  return makeRegisterExpression(amdgpu_gfx90a::v105, output_vec_len );
            case 362:  return makeRegisterExpression(amdgpu_gfx90a::v106, output_vec_len );
            case 363:  return makeRegisterExpression(amdgpu_gfx90a::v107, output_vec_len );
            case 364:  return makeRegisterExpression(amdgpu_gfx90a::v108, output_vec_len );
            case 365:  return makeRegisterExpression(amdgpu_gfx90a::v109, output_vec_len );
            case 366:  return makeRegisterExpression(amdgpu_gfx90a::v110, output_vec_len );
            case 367:  return makeRegisterExpression(amdgpu_gfx90a::v111, output_vec_len );
            case 368:  return makeRegisterExpression(amdgpu_gfx90a::v112, output_vec_len );
            case 369:  return makeRegisterExpression(amdgpu_gfx90a::v113, output_vec_len );
            case 370:  return makeRegisterExpression(amdgpu_gfx90a::v114, output_vec_len );
            case 371:  return makeRegisterExpression(amdgpu_gfx90a::v115, output_vec_len );
            case 372:  return makeRegisterExpression(amdgpu_gfx90a::v116, output_vec_len );
            case 373:  return makeRegisterExpression(amdgpu_gfx90a::v117, output_vec_len );
            case 374:  return makeRegisterExpression(amdgpu_gfx90a::v118, output_vec_len );
            case 375:  return makeRegisterExpression(amdgpu_gfx90a::v119, output_vec_len );
            case 376:  return makeRegisterExpression(amdgpu_gfx90a::v120, output_vec_len );
            case 377:  return makeRegisterExpression(amdgpu_gfx90a::v121, output_vec_len );
            case 378:  return makeRegisterExpression(amdgpu_gfx90a::v122, output_vec_len );
            case 379:  return makeRegisterExpression(amdgpu_gfx90a::v123, output_vec_len );
            case 380:  return makeRegisterExpression(amdgpu_gfx90a::v124, output_vec_len );
            case 381:  return makeRegisterExpression(amdgpu_gfx90a::v125, output_vec_len );
            case 382:  return makeRegisterExpression(amdgpu_gfx90a::v126, output_vec_len );
            case 383:  return makeRegisterExpression(amdgpu_gfx90a::v127, output_vec_len );
            case 384:  return makeRegisterExpression(amdgpu_gfx90a::v128, output_vec_len );
            case 385:  return makeRegisterExpression(amdgpu_gfx90a::v129, output_vec_len );
            case 386:  return makeRegisterExpression(amdgpu_gfx90a::v130, output_vec_len );
            case 387:  return makeRegisterExpression(amdgpu_gfx90a::v131, output_vec_len );
            case 388:  return makeRegisterExpression(amdgpu_gfx90a::v132, output_vec_len );
            case 389:  return makeRegisterExpression(amdgpu_gfx90a::v133, output_vec_len );
            case 390:  return makeRegisterExpression(amdgpu_gfx90a::v134, output_vec_len );
            case 391:  return makeRegisterExpression(amdgpu_gfx90a::v135, output_vec_len );
            case 392:  return makeRegisterExpression(amdgpu_gfx90a::v136, output_vec_len );
            case 393:  return makeRegisterExpression(amdgpu_gfx90a::v137, output_vec_len );
            case 394:  return makeRegisterExpression(amdgpu_gfx90a::v138, output_vec_len );
            case 395:  return makeRegisterExpression(amdgpu_gfx90a::v139, output_vec_len );
            case 396:  return makeRegisterExpression(amdgpu_gfx90a::v140, output_vec_len );
            case 397:  return makeRegisterExpression(amdgpu_gfx90a::v141, output_vec_len );
            case 398:  return makeRegisterExpression(amdgpu_gfx90a::v142, output_vec_len );
            case 399:  return makeRegisterExpression(amdgpu_gfx90a::v143, output_vec_len );
            case 400:  return makeRegisterExpression(amdgpu_gfx90a::v144, output_vec_len );
            case 401:  return makeRegisterExpression(amdgpu_gfx90a::v145, output_vec_len );
            case 402:  return makeRegisterExpression(amdgpu_gfx90a::v146, output_vec_len );
            case 403:  return makeRegisterExpression(amdgpu_gfx90a::v147, output_vec_len );
            case 404:  return makeRegisterExpression(amdgpu_gfx90a::v148, output_vec_len );
            case 405:  return makeRegisterExpression(amdgpu_gfx90a::v149, output_vec_len );
            case 406:  return makeRegisterExpression(amdgpu_gfx90a::v150, output_vec_len );
            case 407:  return makeRegisterExpression(amdgpu_gfx90a::v151, output_vec_len );
            case 408:  return makeRegisterExpression(amdgpu_gfx90a::v152, output_vec_len );
            case 409:  return makeRegisterExpression(amdgpu_gfx90a::v153, output_vec_len );
            case 410:  return makeRegisterExpression(amdgpu_gfx90a::v154, output_vec_len );
            case 411:  return makeRegisterExpression(amdgpu_gfx90a::v155, output_vec_len );
            case 412:  return makeRegisterExpression(amdgpu_gfx90a::v156, output_vec_len );
            case 413:  return makeRegisterExpression(amdgpu_gfx90a::v157, output_vec_len );
            case 414:  return makeRegisterExpression(amdgpu_gfx90a::v158, output_vec_len );
            case 415:  return makeRegisterExpression(amdgpu_gfx90a::v159, output_vec_len );
            case 416:  return makeRegisterExpression(amdgpu_gfx90a::v160, output_vec_len );
            case 417:  return makeRegisterExpression(amdgpu_gfx90a::v161, output_vec_len );
            case 418:  return makeRegisterExpression(amdgpu_gfx90a::v162, output_vec_len );
            case 419:  return makeRegisterExpression(amdgpu_gfx90a::v163, output_vec_len );
            case 420:  return makeRegisterExpression(amdgpu_gfx90a::v164, output_vec_len );
            case 421:  return makeRegisterExpression(amdgpu_gfx90a::v165, output_vec_len );
            case 422:  return makeRegisterExpression(amdgpu_gfx90a::v166, output_vec_len );
            case 423:  return makeRegisterExpression(amdgpu_gfx90a::v167, output_vec_len );
            case 424:  return makeRegisterExpression(amdgpu_gfx90a::v168, output_vec_len );
            case 425:  return makeRegisterExpression(amdgpu_gfx90a::v169, output_vec_len );
            case 426:  return makeRegisterExpression(amdgpu_gfx90a::v170, output_vec_len );
            case 427:  return makeRegisterExpression(amdgpu_gfx90a::v171, output_vec_len );
            case 428:  return makeRegisterExpression(amdgpu_gfx90a::v172, output_vec_len );
            case 429:  return makeRegisterExpression(amdgpu_gfx90a::v173, output_vec_len );
            case 430:  return makeRegisterExpression(amdgpu_gfx90a::v174, output_vec_len );
            case 431:  return makeRegisterExpression(amdgpu_gfx90a::v175, output_vec_len );
            case 432:  return makeRegisterExpression(amdgpu_gfx90a::v176, output_vec_len );
            case 433:  return makeRegisterExpression(amdgpu_gfx90a::v177, output_vec_len );
            case 434:  return makeRegisterExpression(amdgpu_gfx90a::v178, output_vec_len );
            case 435:  return makeRegisterExpression(amdgpu_gfx90a::v179, output_vec_len );
            case 436:  return makeRegisterExpression(amdgpu_gfx90a::v180, output_vec_len );
            case 437:  return makeRegisterExpression(amdgpu_gfx90a::v181, output_vec_len );
            case 438:  return makeRegisterExpression(amdgpu_gfx90a::v182, output_vec_len );
            case 439:  return makeRegisterExpression(amdgpu_gfx90a::v183, output_vec_len );
            case 440:  return makeRegisterExpression(amdgpu_gfx90a::v184, output_vec_len );
            case 441:  return makeRegisterExpression(amdgpu_gfx90a::v185, output_vec_len );
            case 442:  return makeRegisterExpression(amdgpu_gfx90a::v186, output_vec_len );
            case 443:  return makeRegisterExpression(amdgpu_gfx90a::v187, output_vec_len );
            case 444:  return makeRegisterExpression(amdgpu_gfx90a::v188, output_vec_len );
            case 445:  return makeRegisterExpression(amdgpu_gfx90a::v189, output_vec_len );
            case 446:  return makeRegisterExpression(amdgpu_gfx90a::v190, output_vec_len );
            case 447:  return makeRegisterExpression(amdgpu_gfx90a::v191, output_vec_len );
            case 448:  return makeRegisterExpression(amdgpu_gfx90a::v192, output_vec_len );
            case 449:  return makeRegisterExpression(amdgpu_gfx90a::v193, output_vec_len );
            case 450:  return makeRegisterExpression(amdgpu_gfx90a::v194, output_vec_len );
            case 451:  return makeRegisterExpression(amdgpu_gfx90a::v195, output_vec_len );
            case 452:  return makeRegisterExpression(amdgpu_gfx90a::v196, output_vec_len );
            case 453:  return makeRegisterExpression(amdgpu_gfx90a::v197, output_vec_len );
            case 454:  return makeRegisterExpression(amdgpu_gfx90a::v198, output_vec_len );
            case 455:  return makeRegisterExpression(amdgpu_gfx90a::v199, output_vec_len );
            case 456:  return makeRegisterExpression(amdgpu_gfx90a::v200, output_vec_len );
            case 457:  return makeRegisterExpression(amdgpu_gfx90a::v201, output_vec_len );
            case 458:  return makeRegisterExpression(amdgpu_gfx90a::v202, output_vec_len );
            case 459:  return makeRegisterExpression(amdgpu_gfx90a::v203, output_vec_len );
            case 460:  return makeRegisterExpression(amdgpu_gfx90a::v204, output_vec_len );
            case 461:  return makeRegisterExpression(amdgpu_gfx90a::v205, output_vec_len );
            case 462:  return makeRegisterExpression(amdgpu_gfx90a::v206, output_vec_len );
            case 463:  return makeRegisterExpression(amdgpu_gfx90a::v207, output_vec_len );
            case 464:  return makeRegisterExpression(amdgpu_gfx90a::v208, output_vec_len );
            case 465:  return makeRegisterExpression(amdgpu_gfx90a::v209, output_vec_len );
            case 466:  return makeRegisterExpression(amdgpu_gfx90a::v210, output_vec_len );
            case 467:  return makeRegisterExpression(amdgpu_gfx90a::v211, output_vec_len );
            case 468:  return makeRegisterExpression(amdgpu_gfx90a::v212, output_vec_len );
            case 469:  return makeRegisterExpression(amdgpu_gfx90a::v213, output_vec_len );
            case 470:  return makeRegisterExpression(amdgpu_gfx90a::v214, output_vec_len );
            case 471:  return makeRegisterExpression(amdgpu_gfx90a::v215, output_vec_len );
            case 472:  return makeRegisterExpression(amdgpu_gfx90a::v216, output_vec_len );
            case 473:  return makeRegisterExpression(amdgpu_gfx90a::v217, output_vec_len );
            case 474:  return makeRegisterExpression(amdgpu_gfx90a::v218, output_vec_len );
            case 475:  return makeRegisterExpression(amdgpu_gfx90a::v219, output_vec_len );
            case 476:  return makeRegisterExpression(amdgpu_gfx90a::v220, output_vec_len );
            case 477:  return makeRegisterExpression(amdgpu_gfx90a::v221, output_vec_len );
            case 478:  return makeRegisterExpression(amdgpu_gfx90a::v222, output_vec_len );
            case 479:  return makeRegisterExpression(amdgpu_gfx90a::v223, output_vec_len );
            case 480:  return makeRegisterExpression(amdgpu_gfx90a::v224, output_vec_len );
            case 481:  return makeRegisterExpression(amdgpu_gfx90a::v225, output_vec_len );
            case 482:  return makeRegisterExpression(amdgpu_gfx90a::v226, output_vec_len );
            case 483:  return makeRegisterExpression(amdgpu_gfx90a::v227, output_vec_len );
            case 484:  return makeRegisterExpression(amdgpu_gfx90a::v228, output_vec_len );
            case 485:  return makeRegisterExpression(amdgpu_gfx90a::v229, output_vec_len );
            case 486:  return makeRegisterExpression(amdgpu_gfx90a::v230, output_vec_len );
            case 487:  return makeRegisterExpression(amdgpu_gfx90a::v231, output_vec_len );
            case 488:  return makeRegisterExpression(amdgpu_gfx90a::v232, output_vec_len );
            case 489:  return makeRegisterExpression(amdgpu_gfx90a::v233, output_vec_len );
            case 490:  return makeRegisterExpression(amdgpu_gfx90a::v234, output_vec_len );
            case 491:  return makeRegisterExpression(amdgpu_gfx90a::v235, output_vec_len );
            case 492:  return makeRegisterExpression(amdgpu_gfx90a::v236, output_vec_len );
            case 493:  return makeRegisterExpression(amdgpu_gfx90a::v237, output_vec_len );
            case 494:  return makeRegisterExpression(amdgpu_gfx90a::v238, output_vec_len );
            case 495:  return makeRegisterExpression(amdgpu_gfx90a::v239, output_vec_len );
            case 496:  return makeRegisterExpression(amdgpu_gfx90a::v240, output_vec_len );
            case 497:  return makeRegisterExpression(amdgpu_gfx90a::v241, output_vec_len );
            case 498:  return makeRegisterExpression(amdgpu_gfx90a::v242, output_vec_len );
            case 499:  return makeRegisterExpression(amdgpu_gfx90a::v243, output_vec_len );
            case 500:  return makeRegisterExpression(amdgpu_gfx90a::v244, output_vec_len );
            case 501:  return makeRegisterExpression(amdgpu_gfx90a::v245, output_vec_len );
            case 502:  return makeRegisterExpression(amdgpu_gfx90a::v246, output_vec_len );
            case 503:  return makeRegisterExpression(amdgpu_gfx90a::v247, output_vec_len );
            case 504:  return makeRegisterExpression(amdgpu_gfx90a::v248, output_vec_len );
            case 505:  return makeRegisterExpression(amdgpu_gfx90a::v249, output_vec_len );
            case 506:  return makeRegisterExpression(amdgpu_gfx90a::v250, output_vec_len );
            case 507:  return makeRegisterExpression(amdgpu_gfx90a::v251, output_vec_len );
            case 508:  return makeRegisterExpression(amdgpu_gfx90a::v252, output_vec_len );
            case 509:  return makeRegisterExpression(amdgpu_gfx90a::v253, output_vec_len );
            case 510:  return makeRegisterExpression(amdgpu_gfx90a::v254, output_vec_len );
            case 511:  return makeRegisterExpression(amdgpu_gfx90a::v255, output_vec_len );
            case 255:  return Immediate::makeImmediate(Result(u32,decodeOPR_LITERAL()));
            case 249 :  return decodeOPR_SDWA();
            default: return makeRegisterExpression(amdgpu_gfx90a::invalid);
        }
    }

    Expression::Ptr InstructionDecoder_amdgpu_gfx90a::decodeOPR_SRC_NOLIT(uint64_t input, uint32_t output_vec_len)
    {
        switch (input)  {
            case 0:  return makeRegisterExpression(amdgpu_gfx90a::s0, output_vec_len );
            case 1:  return makeRegisterExpression(amdgpu_gfx90a::s1, output_vec_len );
            case 2:  return makeRegisterExpression(amdgpu_gfx90a::s2, output_vec_len );
            case 3:  return makeRegisterExpression(amdgpu_gfx90a::s3, output_vec_len );
            case 4:  return makeRegisterExpression(amdgpu_gfx90a::s4, output_vec_len );
            case 5:  return makeRegisterExpression(amdgpu_gfx90a::s5, output_vec_len );
            case 6:  return makeRegisterExpression(amdgpu_gfx90a::s6, output_vec_len );
            case 7:  return makeRegisterExpression(amdgpu_gfx90a::s7, output_vec_len );
            case 8:  return makeRegisterExpression(amdgpu_gfx90a::s8, output_vec_len );
            case 9:  return makeRegisterExpression(amdgpu_gfx90a::s9, output_vec_len );
            case 10:  return makeRegisterExpression(amdgpu_gfx90a::s10, output_vec_len );
            case 11:  return makeRegisterExpression(amdgpu_gfx90a::s11, output_vec_len );
            case 12:  return makeRegisterExpression(amdgpu_gfx90a::s12, output_vec_len );
            case 13:  return makeRegisterExpression(amdgpu_gfx90a::s13, output_vec_len );
            case 14:  return makeRegisterExpression(amdgpu_gfx90a::s14, output_vec_len );
            case 15:  return makeRegisterExpression(amdgpu_gfx90a::s15, output_vec_len );
            case 16:  return makeRegisterExpression(amdgpu_gfx90a::s16, output_vec_len );
            case 17:  return makeRegisterExpression(amdgpu_gfx90a::s17, output_vec_len );
            case 18:  return makeRegisterExpression(amdgpu_gfx90a::s18, output_vec_len );
            case 19:  return makeRegisterExpression(amdgpu_gfx90a::s19, output_vec_len );
            case 20:  return makeRegisterExpression(amdgpu_gfx90a::s20, output_vec_len );
            case 21:  return makeRegisterExpression(amdgpu_gfx90a::s21, output_vec_len );
            case 22:  return makeRegisterExpression(amdgpu_gfx90a::s22, output_vec_len );
            case 23:  return makeRegisterExpression(amdgpu_gfx90a::s23, output_vec_len );
            case 24:  return makeRegisterExpression(amdgpu_gfx90a::s24, output_vec_len );
            case 25:  return makeRegisterExpression(amdgpu_gfx90a::s25, output_vec_len );
            case 26:  return makeRegisterExpression(amdgpu_gfx90a::s26, output_vec_len );
            case 27:  return makeRegisterExpression(amdgpu_gfx90a::s27, output_vec_len );
            case 28:  return makeRegisterExpression(amdgpu_gfx90a::s28, output_vec_len );
            case 29:  return makeRegisterExpression(amdgpu_gfx90a::s29, output_vec_len );
            case 30:  return makeRegisterExpression(amdgpu_gfx90a::s30, output_vec_len );
            case 31:  return makeRegisterExpression(amdgpu_gfx90a::s31, output_vec_len );
            case 32:  return makeRegisterExpression(amdgpu_gfx90a::s32, output_vec_len );
            case 33:  return makeRegisterExpression(amdgpu_gfx90a::s33, output_vec_len );
            case 34:  return makeRegisterExpression(amdgpu_gfx90a::s34, output_vec_len );
            case 35:  return makeRegisterExpression(amdgpu_gfx90a::s35, output_vec_len );
            case 36:  return makeRegisterExpression(amdgpu_gfx90a::s36, output_vec_len );
            case 37:  return makeRegisterExpression(amdgpu_gfx90a::s37, output_vec_len );
            case 38:  return makeRegisterExpression(amdgpu_gfx90a::s38, output_vec_len );
            case 39:  return makeRegisterExpression(amdgpu_gfx90a::s39, output_vec_len );
            case 40:  return makeRegisterExpression(amdgpu_gfx90a::s40, output_vec_len );
            case 41:  return makeRegisterExpression(amdgpu_gfx90a::s41, output_vec_len );
            case 42:  return makeRegisterExpression(amdgpu_gfx90a::s42, output_vec_len );
            case 43:  return makeRegisterExpression(amdgpu_gfx90a::s43, output_vec_len );
            case 44:  return makeRegisterExpression(amdgpu_gfx90a::s44, output_vec_len );
            case 45:  return makeRegisterExpression(amdgpu_gfx90a::s45, output_vec_len );
            case 46:  return makeRegisterExpression(amdgpu_gfx90a::s46, output_vec_len );
            case 47:  return makeRegisterExpression(amdgpu_gfx90a::s47, output_vec_len );
            case 48:  return makeRegisterExpression(amdgpu_gfx90a::s48, output_vec_len );
            case 49:  return makeRegisterExpression(amdgpu_gfx90a::s49, output_vec_len );
            case 50:  return makeRegisterExpression(amdgpu_gfx90a::s50, output_vec_len );
            case 51:  return makeRegisterExpression(amdgpu_gfx90a::s51, output_vec_len );
            case 52:  return makeRegisterExpression(amdgpu_gfx90a::s52, output_vec_len );
            case 53:  return makeRegisterExpression(amdgpu_gfx90a::s53, output_vec_len );
            case 54:  return makeRegisterExpression(amdgpu_gfx90a::s54, output_vec_len );
            case 55:  return makeRegisterExpression(amdgpu_gfx90a::s55, output_vec_len );
            case 56:  return makeRegisterExpression(amdgpu_gfx90a::s56, output_vec_len );
            case 57:  return makeRegisterExpression(amdgpu_gfx90a::s57, output_vec_len );
            case 58:  return makeRegisterExpression(amdgpu_gfx90a::s58, output_vec_len );
            case 59:  return makeRegisterExpression(amdgpu_gfx90a::s59, output_vec_len );
            case 60:  return makeRegisterExpression(amdgpu_gfx90a::s60, output_vec_len );
            case 61:  return makeRegisterExpression(amdgpu_gfx90a::s61, output_vec_len );
            case 62:  return makeRegisterExpression(amdgpu_gfx90a::s62, output_vec_len );
            case 63:  return makeRegisterExpression(amdgpu_gfx90a::s63, output_vec_len );
            case 64:  return makeRegisterExpression(amdgpu_gfx90a::s64, output_vec_len );
            case 65:  return makeRegisterExpression(amdgpu_gfx90a::s65, output_vec_len );
            case 66:  return makeRegisterExpression(amdgpu_gfx90a::s66, output_vec_len );
            case 67:  return makeRegisterExpression(amdgpu_gfx90a::s67, output_vec_len );
            case 68:  return makeRegisterExpression(amdgpu_gfx90a::s68, output_vec_len );
            case 69:  return makeRegisterExpression(amdgpu_gfx90a::s69, output_vec_len );
            case 70:  return makeRegisterExpression(amdgpu_gfx90a::s70, output_vec_len );
            case 71:  return makeRegisterExpression(amdgpu_gfx90a::s71, output_vec_len );
            case 72:  return makeRegisterExpression(amdgpu_gfx90a::s72, output_vec_len );
            case 73:  return makeRegisterExpression(amdgpu_gfx90a::s73, output_vec_len );
            case 74:  return makeRegisterExpression(amdgpu_gfx90a::s74, output_vec_len );
            case 75:  return makeRegisterExpression(amdgpu_gfx90a::s75, output_vec_len );
            case 76:  return makeRegisterExpression(amdgpu_gfx90a::s76, output_vec_len );
            case 77:  return makeRegisterExpression(amdgpu_gfx90a::s77, output_vec_len );
            case 78:  return makeRegisterExpression(amdgpu_gfx90a::s78, output_vec_len );
            case 79:  return makeRegisterExpression(amdgpu_gfx90a::s79, output_vec_len );
            case 80:  return makeRegisterExpression(amdgpu_gfx90a::s80, output_vec_len );
            case 81:  return makeRegisterExpression(amdgpu_gfx90a::s81, output_vec_len );
            case 82:  return makeRegisterExpression(amdgpu_gfx90a::s82, output_vec_len );
            case 83:  return makeRegisterExpression(amdgpu_gfx90a::s83, output_vec_len );
            case 84:  return makeRegisterExpression(amdgpu_gfx90a::s84, output_vec_len );
            case 85:  return makeRegisterExpression(amdgpu_gfx90a::s85, output_vec_len );
            case 86:  return makeRegisterExpression(amdgpu_gfx90a::s86, output_vec_len );
            case 87:  return makeRegisterExpression(amdgpu_gfx90a::s87, output_vec_len );
            case 88:  return makeRegisterExpression(amdgpu_gfx90a::s88, output_vec_len );
            case 89:  return makeRegisterExpression(amdgpu_gfx90a::s89, output_vec_len );
            case 90:  return makeRegisterExpression(amdgpu_gfx90a::s90, output_vec_len );
            case 91:  return makeRegisterExpression(amdgpu_gfx90a::s91, output_vec_len );
            case 92:  return makeRegisterExpression(amdgpu_gfx90a::s92, output_vec_len );
            case 93:  return makeRegisterExpression(amdgpu_gfx90a::s93, output_vec_len );
            case 94:  return makeRegisterExpression(amdgpu_gfx90a::s94, output_vec_len );
            case 95:  return makeRegisterExpression(amdgpu_gfx90a::s95, output_vec_len );
            case 96:  return makeRegisterExpression(amdgpu_gfx90a::s96, output_vec_len );
            case 97:  return makeRegisterExpression(amdgpu_gfx90a::s97, output_vec_len );
            case 98:  return makeRegisterExpression(amdgpu_gfx90a::s98, output_vec_len );
            case 99:  return makeRegisterExpression(amdgpu_gfx90a::s99, output_vec_len );
            case 100:  return makeRegisterExpression(amdgpu_gfx90a::s100, output_vec_len );
            case 101:  return makeRegisterExpression(amdgpu_gfx90a::s101, output_vec_len );
            case 104:  return makeRegisterExpression(amdgpu_gfx90a::xnack_mask_lo, output_vec_len );
            case 105:  return makeRegisterExpression(amdgpu_gfx90a::xnack_mask_hi, output_vec_len );
            case 102:  return makeRegisterExpression(amdgpu_gfx90a::flat_scratch_lo, output_vec_len );
            case 103:  return makeRegisterExpression(amdgpu_gfx90a::flat_scratch_hi, output_vec_len );
            case 108:  return makeRegisterExpression(amdgpu_gfx90a::ttmp0, output_vec_len );
            case 109:  return makeRegisterExpression(amdgpu_gfx90a::ttmp1, output_vec_len );
            case 110:  return makeRegisterExpression(amdgpu_gfx90a::ttmp2, output_vec_len );
            case 111:  return makeRegisterExpression(amdgpu_gfx90a::ttmp3, output_vec_len );
            case 112:  return makeRegisterExpression(amdgpu_gfx90a::ttmp4, output_vec_len );
            case 113:  return makeRegisterExpression(amdgpu_gfx90a::ttmp5, output_vec_len );
            case 114:  return makeRegisterExpression(amdgpu_gfx90a::ttmp6, output_vec_len );
            case 115:  return makeRegisterExpression(amdgpu_gfx90a::ttmp7, output_vec_len );
            case 116:  return makeRegisterExpression(amdgpu_gfx90a::ttmp8, output_vec_len );
            case 117:  return makeRegisterExpression(amdgpu_gfx90a::ttmp9, output_vec_len );
            case 118:  return makeRegisterExpression(amdgpu_gfx90a::ttmp10, output_vec_len );
            case 119:  return makeRegisterExpression(amdgpu_gfx90a::ttmp11, output_vec_len );
            case 120:  return makeRegisterExpression(amdgpu_gfx90a::ttmp12, output_vec_len );
            case 121:  return makeRegisterExpression(amdgpu_gfx90a::ttmp13, output_vec_len );
            case 122:  return makeRegisterExpression(amdgpu_gfx90a::ttmp14, output_vec_len );
            case 123:  return makeRegisterExpression(amdgpu_gfx90a::ttmp15, output_vec_len );
            case 106:  return makeRegisterExpression(amdgpu_gfx90a::vcc_lo, output_vec_len );
            case 107:  return makeRegisterExpression(amdgpu_gfx90a::vcc_hi, output_vec_len );
            case 124:  return makeRegisterExpression(amdgpu_gfx90a::m0, output_vec_len );
            case 126:  return makeRegisterExpression(amdgpu_gfx90a::exec_lo, output_vec_len );
            case 127:  return makeRegisterExpression(amdgpu_gfx90a::exec_hi, output_vec_len );
            case 128:  return Immediate::makeImmediate(Result(u32, 0));
            case 129:  return Immediate::makeImmediate(Result(u32, 1));
            case 130:  return Immediate::makeImmediate(Result(u32, 2));
            case 131:  return Immediate::makeImmediate(Result(u32, 3));
            case 132:  return Immediate::makeImmediate(Result(u32, 4));
            case 133:  return Immediate::makeImmediate(Result(u32, 5));
            case 134:  return Immediate::makeImmediate(Result(u32, 6));
            case 135:  return Immediate::makeImmediate(Result(u32, 7));
            case 136:  return Immediate::makeImmediate(Result(u32, 8));
            case 137:  return Immediate::makeImmediate(Result(u32, 9));
            case 138:  return Immediate::makeImmediate(Result(u32, 10));
            case 139:  return Immediate::makeImmediate(Result(u32, 11));
            case 140:  return Immediate::makeImmediate(Result(u32, 12));
            case 141:  return Immediate::makeImmediate(Result(u32, 13));
            case 142:  return Immediate::makeImmediate(Result(u32, 14));
            case 143:  return Immediate::makeImmediate(Result(u32, 15));
            case 144:  return Immediate::makeImmediate(Result(u32, 16));
            case 145:  return Immediate::makeImmediate(Result(u32, 17));
            case 146:  return Immediate::makeImmediate(Result(u32, 18));
            case 147:  return Immediate::makeImmediate(Result(u32, 19));
            case 148:  return Immediate::makeImmediate(Result(u32, 20));
            case 149:  return Immediate::makeImmediate(Result(u32, 21));
            case 150:  return Immediate::makeImmediate(Result(u32, 22));
            case 151:  return Immediate::makeImmediate(Result(u32, 23));
            case 152:  return Immediate::makeImmediate(Result(u32, 24));
            case 153:  return Immediate::makeImmediate(Result(u32, 25));
            case 154:  return Immediate::makeImmediate(Result(u32, 26));
            case 155:  return Immediate::makeImmediate(Result(u32, 27));
            case 156:  return Immediate::makeImmediate(Result(u32, 28));
            case 157:  return Immediate::makeImmediate(Result(u32, 29));
            case 158:  return Immediate::makeImmediate(Result(u32, 30));
            case 159:  return Immediate::makeImmediate(Result(u32, 31));
            case 160:  return Immediate::makeImmediate(Result(u32, 32));
            case 161:  return Immediate::makeImmediate(Result(u32, 33));
            case 162:  return Immediate::makeImmediate(Result(u32, 34));
            case 163:  return Immediate::makeImmediate(Result(u32, 35));
            case 164:  return Immediate::makeImmediate(Result(u32, 36));
            case 165:  return Immediate::makeImmediate(Result(u32, 37));
            case 166:  return Immediate::makeImmediate(Result(u32, 38));
            case 167:  return Immediate::makeImmediate(Result(u32, 39));
            case 168:  return Immediate::makeImmediate(Result(u32, 40));
            case 169:  return Immediate::makeImmediate(Result(u32, 41));
            case 170:  return Immediate::makeImmediate(Result(u32, 42));
            case 171:  return Immediate::makeImmediate(Result(u32, 43));
            case 172:  return Immediate::makeImmediate(Result(u32, 44));
            case 173:  return Immediate::makeImmediate(Result(u32, 45));
            case 174:  return Immediate::makeImmediate(Result(u32, 46));
            case 175:  return Immediate::makeImmediate(Result(u32, 47));
            case 176:  return Immediate::makeImmediate(Result(u32, 48));
            case 177:  return Immediate::makeImmediate(Result(u32, 49));
            case 178:  return Immediate::makeImmediate(Result(u32, 50));
            case 179:  return Immediate::makeImmediate(Result(u32, 51));
            case 180:  return Immediate::makeImmediate(Result(u32, 52));
            case 181:  return Immediate::makeImmediate(Result(u32, 53));
            case 182:  return Immediate::makeImmediate(Result(u32, 54));
            case 183:  return Immediate::makeImmediate(Result(u32, 55));
            case 184:  return Immediate::makeImmediate(Result(u32, 56));
            case 185:  return Immediate::makeImmediate(Result(u32, 57));
            case 186:  return Immediate::makeImmediate(Result(u32, 58));
            case 187:  return Immediate::makeImmediate(Result(u32, 59));
            case 188:  return Immediate::makeImmediate(Result(u32, 60));
            case 189:  return Immediate::makeImmediate(Result(u32, 61));
            case 190:  return Immediate::makeImmediate(Result(u32, 62));
            case 191:  return Immediate::makeImmediate(Result(u32, 63));
            case 192:  return Immediate::makeImmediate(Result(u32, 64));
            case 193:  return Immediate::makeImmediate(Result(u32, -1));
            case 194:  return Immediate::makeImmediate(Result(u32, -2));
            case 195:  return Immediate::makeImmediate(Result(u32, -3));
            case 196:  return Immediate::makeImmediate(Result(u32, -4));
            case 197:  return Immediate::makeImmediate(Result(u32, -5));
            case 198:  return Immediate::makeImmediate(Result(u32, -6));
            case 199:  return Immediate::makeImmediate(Result(u32, -7));
            case 200:  return Immediate::makeImmediate(Result(u32, -8));
            case 201:  return Immediate::makeImmediate(Result(u32, -9));
            case 202:  return Immediate::makeImmediate(Result(u32, -10));
            case 203:  return Immediate::makeImmediate(Result(u32, -11));
            case 204:  return Immediate::makeImmediate(Result(u32, -12));
            case 205:  return Immediate::makeImmediate(Result(u32, -13));
            case 206:  return Immediate::makeImmediate(Result(u32, -14));
            case 207:  return Immediate::makeImmediate(Result(u32, -15));
            case 208:  return Immediate::makeImmediate(Result(u32, -16));
            case 240:  return Immediate::makeImmediate(Result(sp_float, 0.5));
            case 241:  return Immediate::makeImmediate(Result(sp_float, -0.5));
            case 242:  return Immediate::makeImmediate(Result(sp_float, 1.0));
            case 243:  return Immediate::makeImmediate(Result(sp_float, -1.0));
            case 244:  return Immediate::makeImmediate(Result(sp_float, 2.0));
            case 245:  return Immediate::makeImmediate(Result(sp_float, -2.0));
            case 246:  return Immediate::makeImmediate(Result(sp_float, 4.0));
            case 247:  return Immediate::makeImmediate(Result(sp_float, -4.0));
            case 248:  return Immediate::makeImmediate(Result(sp_float, 0.15915494));
            case 251:  return makeRegisterExpression(amdgpu_gfx90a::src_vccz, output_vec_len );
            case 252:  return makeRegisterExpression(amdgpu_gfx90a::src_execz, output_vec_len );
            case 253:  return makeRegisterExpression(amdgpu_gfx90a::src_scc, output_vec_len );
            case 235:  return makeRegisterExpression(amdgpu_gfx90a::src_shared_base, output_vec_len );
            case 236:  return makeRegisterExpression(amdgpu_gfx90a::src_shared_limit, output_vec_len );
            case 237:  return makeRegisterExpression(amdgpu_gfx90a::src_private_base, output_vec_len );
            case 238:  return makeRegisterExpression(amdgpu_gfx90a::src_private_limit, output_vec_len );
            case 239:  return makeRegisterExpression(amdgpu_gfx90a::src_pops_exiting_wave_id, output_vec_len );
            case 256:  return makeRegisterExpression(amdgpu_gfx90a::v0, output_vec_len );
            case 257:  return makeRegisterExpression(amdgpu_gfx90a::v1, output_vec_len );
            case 258:  return makeRegisterExpression(amdgpu_gfx90a::v2, output_vec_len );
            case 259:  return makeRegisterExpression(amdgpu_gfx90a::v3, output_vec_len );
            case 260:  return makeRegisterExpression(amdgpu_gfx90a::v4, output_vec_len );
            case 261:  return makeRegisterExpression(amdgpu_gfx90a::v5, output_vec_len );
            case 262:  return makeRegisterExpression(amdgpu_gfx90a::v6, output_vec_len );
            case 263:  return makeRegisterExpression(amdgpu_gfx90a::v7, output_vec_len );
            case 264:  return makeRegisterExpression(amdgpu_gfx90a::v8, output_vec_len );
            case 265:  return makeRegisterExpression(amdgpu_gfx90a::v9, output_vec_len );
            case 266:  return makeRegisterExpression(amdgpu_gfx90a::v10, output_vec_len );
            case 267:  return makeRegisterExpression(amdgpu_gfx90a::v11, output_vec_len );
            case 268:  return makeRegisterExpression(amdgpu_gfx90a::v12, output_vec_len );
            case 269:  return makeRegisterExpression(amdgpu_gfx90a::v13, output_vec_len );
            case 270:  return makeRegisterExpression(amdgpu_gfx90a::v14, output_vec_len );
            case 271:  return makeRegisterExpression(amdgpu_gfx90a::v15, output_vec_len );
            case 272:  return makeRegisterExpression(amdgpu_gfx90a::v16, output_vec_len );
            case 273:  return makeRegisterExpression(amdgpu_gfx90a::v17, output_vec_len );
            case 274:  return makeRegisterExpression(amdgpu_gfx90a::v18, output_vec_len );
            case 275:  return makeRegisterExpression(amdgpu_gfx90a::v19, output_vec_len );
            case 276:  return makeRegisterExpression(amdgpu_gfx90a::v20, output_vec_len );
            case 277:  return makeRegisterExpression(amdgpu_gfx90a::v21, output_vec_len );
            case 278:  return makeRegisterExpression(amdgpu_gfx90a::v22, output_vec_len );
            case 279:  return makeRegisterExpression(amdgpu_gfx90a::v23, output_vec_len );
            case 280:  return makeRegisterExpression(amdgpu_gfx90a::v24, output_vec_len );
            case 281:  return makeRegisterExpression(amdgpu_gfx90a::v25, output_vec_len );
            case 282:  return makeRegisterExpression(amdgpu_gfx90a::v26, output_vec_len );
            case 283:  return makeRegisterExpression(amdgpu_gfx90a::v27, output_vec_len );
            case 284:  return makeRegisterExpression(amdgpu_gfx90a::v28, output_vec_len );
            case 285:  return makeRegisterExpression(amdgpu_gfx90a::v29, output_vec_len );
            case 286:  return makeRegisterExpression(amdgpu_gfx90a::v30, output_vec_len );
            case 287:  return makeRegisterExpression(amdgpu_gfx90a::v31, output_vec_len );
            case 288:  return makeRegisterExpression(amdgpu_gfx90a::v32, output_vec_len );
            case 289:  return makeRegisterExpression(amdgpu_gfx90a::v33, output_vec_len );
            case 290:  return makeRegisterExpression(amdgpu_gfx90a::v34, output_vec_len );
            case 291:  return makeRegisterExpression(amdgpu_gfx90a::v35, output_vec_len );
            case 292:  return makeRegisterExpression(amdgpu_gfx90a::v36, output_vec_len );
            case 293:  return makeRegisterExpression(amdgpu_gfx90a::v37, output_vec_len );
            case 294:  return makeRegisterExpression(amdgpu_gfx90a::v38, output_vec_len );
            case 295:  return makeRegisterExpression(amdgpu_gfx90a::v39, output_vec_len );
            case 296:  return makeRegisterExpression(amdgpu_gfx90a::v40, output_vec_len );
            case 297:  return makeRegisterExpression(amdgpu_gfx90a::v41, output_vec_len );
            case 298:  return makeRegisterExpression(amdgpu_gfx90a::v42, output_vec_len );
            case 299:  return makeRegisterExpression(amdgpu_gfx90a::v43, output_vec_len );
            case 300:  return makeRegisterExpression(amdgpu_gfx90a::v44, output_vec_len );
            case 301:  return makeRegisterExpression(amdgpu_gfx90a::v45, output_vec_len );
            case 302:  return makeRegisterExpression(amdgpu_gfx90a::v46, output_vec_len );
            case 303:  return makeRegisterExpression(amdgpu_gfx90a::v47, output_vec_len );
            case 304:  return makeRegisterExpression(amdgpu_gfx90a::v48, output_vec_len );
            case 305:  return makeRegisterExpression(amdgpu_gfx90a::v49, output_vec_len );
            case 306:  return makeRegisterExpression(amdgpu_gfx90a::v50, output_vec_len );
            case 307:  return makeRegisterExpression(amdgpu_gfx90a::v51, output_vec_len );
            case 308:  return makeRegisterExpression(amdgpu_gfx90a::v52, output_vec_len );
            case 309:  return makeRegisterExpression(amdgpu_gfx90a::v53, output_vec_len );
            case 310:  return makeRegisterExpression(amdgpu_gfx90a::v54, output_vec_len );
            case 311:  return makeRegisterExpression(amdgpu_gfx90a::v55, output_vec_len );
            case 312:  return makeRegisterExpression(amdgpu_gfx90a::v56, output_vec_len );
            case 313:  return makeRegisterExpression(amdgpu_gfx90a::v57, output_vec_len );
            case 314:  return makeRegisterExpression(amdgpu_gfx90a::v58, output_vec_len );
            case 315:  return makeRegisterExpression(amdgpu_gfx90a::v59, output_vec_len );
            case 316:  return makeRegisterExpression(amdgpu_gfx90a::v60, output_vec_len );
            case 317:  return makeRegisterExpression(amdgpu_gfx90a::v61, output_vec_len );
            case 318:  return makeRegisterExpression(amdgpu_gfx90a::v62, output_vec_len );
            case 319:  return makeRegisterExpression(amdgpu_gfx90a::v63, output_vec_len );
            case 320:  return makeRegisterExpression(amdgpu_gfx90a::v64, output_vec_len );
            case 321:  return makeRegisterExpression(amdgpu_gfx90a::v65, output_vec_len );
            case 322:  return makeRegisterExpression(amdgpu_gfx90a::v66, output_vec_len );
            case 323:  return makeRegisterExpression(amdgpu_gfx90a::v67, output_vec_len );
            case 324:  return makeRegisterExpression(amdgpu_gfx90a::v68, output_vec_len );
            case 325:  return makeRegisterExpression(amdgpu_gfx90a::v69, output_vec_len );
            case 326:  return makeRegisterExpression(amdgpu_gfx90a::v70, output_vec_len );
            case 327:  return makeRegisterExpression(amdgpu_gfx90a::v71, output_vec_len );
            case 328:  return makeRegisterExpression(amdgpu_gfx90a::v72, output_vec_len );
            case 329:  return makeRegisterExpression(amdgpu_gfx90a::v73, output_vec_len );
            case 330:  return makeRegisterExpression(amdgpu_gfx90a::v74, output_vec_len );
            case 331:  return makeRegisterExpression(amdgpu_gfx90a::v75, output_vec_len );
            case 332:  return makeRegisterExpression(amdgpu_gfx90a::v76, output_vec_len );
            case 333:  return makeRegisterExpression(amdgpu_gfx90a::v77, output_vec_len );
            case 334:  return makeRegisterExpression(amdgpu_gfx90a::v78, output_vec_len );
            case 335:  return makeRegisterExpression(amdgpu_gfx90a::v79, output_vec_len );
            case 336:  return makeRegisterExpression(amdgpu_gfx90a::v80, output_vec_len );
            case 337:  return makeRegisterExpression(amdgpu_gfx90a::v81, output_vec_len );
            case 338:  return makeRegisterExpression(amdgpu_gfx90a::v82, output_vec_len );
            case 339:  return makeRegisterExpression(amdgpu_gfx90a::v83, output_vec_len );
            case 340:  return makeRegisterExpression(amdgpu_gfx90a::v84, output_vec_len );
            case 341:  return makeRegisterExpression(amdgpu_gfx90a::v85, output_vec_len );
            case 342:  return makeRegisterExpression(amdgpu_gfx90a::v86, output_vec_len );
            case 343:  return makeRegisterExpression(amdgpu_gfx90a::v87, output_vec_len );
            case 344:  return makeRegisterExpression(amdgpu_gfx90a::v88, output_vec_len );
            case 345:  return makeRegisterExpression(amdgpu_gfx90a::v89, output_vec_len );
            case 346:  return makeRegisterExpression(amdgpu_gfx90a::v90, output_vec_len );
            case 347:  return makeRegisterExpression(amdgpu_gfx90a::v91, output_vec_len );
            case 348:  return makeRegisterExpression(amdgpu_gfx90a::v92, output_vec_len );
            case 349:  return makeRegisterExpression(amdgpu_gfx90a::v93, output_vec_len );
            case 350:  return makeRegisterExpression(amdgpu_gfx90a::v94, output_vec_len );
            case 351:  return makeRegisterExpression(amdgpu_gfx90a::v95, output_vec_len );
            case 352:  return makeRegisterExpression(amdgpu_gfx90a::v96, output_vec_len );
            case 353:  return makeRegisterExpression(amdgpu_gfx90a::v97, output_vec_len );
            case 354:  return makeRegisterExpression(amdgpu_gfx90a::v98, output_vec_len );
            case 355:  return makeRegisterExpression(amdgpu_gfx90a::v99, output_vec_len );
            case 356:  return makeRegisterExpression(amdgpu_gfx90a::v100, output_vec_len );
            case 357:  return makeRegisterExpression(amdgpu_gfx90a::v101, output_vec_len );
            case 358:  return makeRegisterExpression(amdgpu_gfx90a::v102, output_vec_len );
            case 359:  return makeRegisterExpression(amdgpu_gfx90a::v103, output_vec_len );
            case 360:  return makeRegisterExpression(amdgpu_gfx90a::v104, output_vec_len );
            case 361:  return makeRegisterExpression(amdgpu_gfx90a::v105, output_vec_len );
            case 362:  return makeRegisterExpression(amdgpu_gfx90a::v106, output_vec_len );
            case 363:  return makeRegisterExpression(amdgpu_gfx90a::v107, output_vec_len );
            case 364:  return makeRegisterExpression(amdgpu_gfx90a::v108, output_vec_len );
            case 365:  return makeRegisterExpression(amdgpu_gfx90a::v109, output_vec_len );
            case 366:  return makeRegisterExpression(amdgpu_gfx90a::v110, output_vec_len );
            case 367:  return makeRegisterExpression(amdgpu_gfx90a::v111, output_vec_len );
            case 368:  return makeRegisterExpression(amdgpu_gfx90a::v112, output_vec_len );
            case 369:  return makeRegisterExpression(amdgpu_gfx90a::v113, output_vec_len );
            case 370:  return makeRegisterExpression(amdgpu_gfx90a::v114, output_vec_len );
            case 371:  return makeRegisterExpression(amdgpu_gfx90a::v115, output_vec_len );
            case 372:  return makeRegisterExpression(amdgpu_gfx90a::v116, output_vec_len );
            case 373:  return makeRegisterExpression(amdgpu_gfx90a::v117, output_vec_len );
            case 374:  return makeRegisterExpression(amdgpu_gfx90a::v118, output_vec_len );
            case 375:  return makeRegisterExpression(amdgpu_gfx90a::v119, output_vec_len );
            case 376:  return makeRegisterExpression(amdgpu_gfx90a::v120, output_vec_len );
            case 377:  return makeRegisterExpression(amdgpu_gfx90a::v121, output_vec_len );
            case 378:  return makeRegisterExpression(amdgpu_gfx90a::v122, output_vec_len );
            case 379:  return makeRegisterExpression(amdgpu_gfx90a::v123, output_vec_len );
            case 380:  return makeRegisterExpression(amdgpu_gfx90a::v124, output_vec_len );
            case 381:  return makeRegisterExpression(amdgpu_gfx90a::v125, output_vec_len );
            case 382:  return makeRegisterExpression(amdgpu_gfx90a::v126, output_vec_len );
            case 383:  return makeRegisterExpression(amdgpu_gfx90a::v127, output_vec_len );
            case 384:  return makeRegisterExpression(amdgpu_gfx90a::v128, output_vec_len );
            case 385:  return makeRegisterExpression(amdgpu_gfx90a::v129, output_vec_len );
            case 386:  return makeRegisterExpression(amdgpu_gfx90a::v130, output_vec_len );
            case 387:  return makeRegisterExpression(amdgpu_gfx90a::v131, output_vec_len );
            case 388:  return makeRegisterExpression(amdgpu_gfx90a::v132, output_vec_len );
            case 389:  return makeRegisterExpression(amdgpu_gfx90a::v133, output_vec_len );
            case 390:  return makeRegisterExpression(amdgpu_gfx90a::v134, output_vec_len );
            case 391:  return makeRegisterExpression(amdgpu_gfx90a::v135, output_vec_len );
            case 392:  return makeRegisterExpression(amdgpu_gfx90a::v136, output_vec_len );
            case 393:  return makeRegisterExpression(amdgpu_gfx90a::v137, output_vec_len );
            case 394:  return makeRegisterExpression(amdgpu_gfx90a::v138, output_vec_len );
            case 395:  return makeRegisterExpression(amdgpu_gfx90a::v139, output_vec_len );
            case 396:  return makeRegisterExpression(amdgpu_gfx90a::v140, output_vec_len );
            case 397:  return makeRegisterExpression(amdgpu_gfx90a::v141, output_vec_len );
            case 398:  return makeRegisterExpression(amdgpu_gfx90a::v142, output_vec_len );
            case 399:  return makeRegisterExpression(amdgpu_gfx90a::v143, output_vec_len );
            case 400:  return makeRegisterExpression(amdgpu_gfx90a::v144, output_vec_len );
            case 401:  return makeRegisterExpression(amdgpu_gfx90a::v145, output_vec_len );
            case 402:  return makeRegisterExpression(amdgpu_gfx90a::v146, output_vec_len );
            case 403:  return makeRegisterExpression(amdgpu_gfx90a::v147, output_vec_len );
            case 404:  return makeRegisterExpression(amdgpu_gfx90a::v148, output_vec_len );
            case 405:  return makeRegisterExpression(amdgpu_gfx90a::v149, output_vec_len );
            case 406:  return makeRegisterExpression(amdgpu_gfx90a::v150, output_vec_len );
            case 407:  return makeRegisterExpression(amdgpu_gfx90a::v151, output_vec_len );
            case 408:  return makeRegisterExpression(amdgpu_gfx90a::v152, output_vec_len );
            case 409:  return makeRegisterExpression(amdgpu_gfx90a::v153, output_vec_len );
            case 410:  return makeRegisterExpression(amdgpu_gfx90a::v154, output_vec_len );
            case 411:  return makeRegisterExpression(amdgpu_gfx90a::v155, output_vec_len );
            case 412:  return makeRegisterExpression(amdgpu_gfx90a::v156, output_vec_len );
            case 413:  return makeRegisterExpression(amdgpu_gfx90a::v157, output_vec_len );
            case 414:  return makeRegisterExpression(amdgpu_gfx90a::v158, output_vec_len );
            case 415:  return makeRegisterExpression(amdgpu_gfx90a::v159, output_vec_len );
            case 416:  return makeRegisterExpression(amdgpu_gfx90a::v160, output_vec_len );
            case 417:  return makeRegisterExpression(amdgpu_gfx90a::v161, output_vec_len );
            case 418:  return makeRegisterExpression(amdgpu_gfx90a::v162, output_vec_len );
            case 419:  return makeRegisterExpression(amdgpu_gfx90a::v163, output_vec_len );
            case 420:  return makeRegisterExpression(amdgpu_gfx90a::v164, output_vec_len );
            case 421:  return makeRegisterExpression(amdgpu_gfx90a::v165, output_vec_len );
            case 422:  return makeRegisterExpression(amdgpu_gfx90a::v166, output_vec_len );
            case 423:  return makeRegisterExpression(amdgpu_gfx90a::v167, output_vec_len );
            case 424:  return makeRegisterExpression(amdgpu_gfx90a::v168, output_vec_len );
            case 425:  return makeRegisterExpression(amdgpu_gfx90a::v169, output_vec_len );
            case 426:  return makeRegisterExpression(amdgpu_gfx90a::v170, output_vec_len );
            case 427:  return makeRegisterExpression(amdgpu_gfx90a::v171, output_vec_len );
            case 428:  return makeRegisterExpression(amdgpu_gfx90a::v172, output_vec_len );
            case 429:  return makeRegisterExpression(amdgpu_gfx90a::v173, output_vec_len );
            case 430:  return makeRegisterExpression(amdgpu_gfx90a::v174, output_vec_len );
            case 431:  return makeRegisterExpression(amdgpu_gfx90a::v175, output_vec_len );
            case 432:  return makeRegisterExpression(amdgpu_gfx90a::v176, output_vec_len );
            case 433:  return makeRegisterExpression(amdgpu_gfx90a::v177, output_vec_len );
            case 434:  return makeRegisterExpression(amdgpu_gfx90a::v178, output_vec_len );
            case 435:  return makeRegisterExpression(amdgpu_gfx90a::v179, output_vec_len );
            case 436:  return makeRegisterExpression(amdgpu_gfx90a::v180, output_vec_len );
            case 437:  return makeRegisterExpression(amdgpu_gfx90a::v181, output_vec_len );
            case 438:  return makeRegisterExpression(amdgpu_gfx90a::v182, output_vec_len );
            case 439:  return makeRegisterExpression(amdgpu_gfx90a::v183, output_vec_len );
            case 440:  return makeRegisterExpression(amdgpu_gfx90a::v184, output_vec_len );
            case 441:  return makeRegisterExpression(amdgpu_gfx90a::v185, output_vec_len );
            case 442:  return makeRegisterExpression(amdgpu_gfx90a::v186, output_vec_len );
            case 443:  return makeRegisterExpression(amdgpu_gfx90a::v187, output_vec_len );
            case 444:  return makeRegisterExpression(amdgpu_gfx90a::v188, output_vec_len );
            case 445:  return makeRegisterExpression(amdgpu_gfx90a::v189, output_vec_len );
            case 446:  return makeRegisterExpression(amdgpu_gfx90a::v190, output_vec_len );
            case 447:  return makeRegisterExpression(amdgpu_gfx90a::v191, output_vec_len );
            case 448:  return makeRegisterExpression(amdgpu_gfx90a::v192, output_vec_len );
            case 449:  return makeRegisterExpression(amdgpu_gfx90a::v193, output_vec_len );
            case 450:  return makeRegisterExpression(amdgpu_gfx90a::v194, output_vec_len );
            case 451:  return makeRegisterExpression(amdgpu_gfx90a::v195, output_vec_len );
            case 452:  return makeRegisterExpression(amdgpu_gfx90a::v196, output_vec_len );
            case 453:  return makeRegisterExpression(amdgpu_gfx90a::v197, output_vec_len );
            case 454:  return makeRegisterExpression(amdgpu_gfx90a::v198, output_vec_len );
            case 455:  return makeRegisterExpression(amdgpu_gfx90a::v199, output_vec_len );
            case 456:  return makeRegisterExpression(amdgpu_gfx90a::v200, output_vec_len );
            case 457:  return makeRegisterExpression(amdgpu_gfx90a::v201, output_vec_len );
            case 458:  return makeRegisterExpression(amdgpu_gfx90a::v202, output_vec_len );
            case 459:  return makeRegisterExpression(amdgpu_gfx90a::v203, output_vec_len );
            case 460:  return makeRegisterExpression(amdgpu_gfx90a::v204, output_vec_len );
            case 461:  return makeRegisterExpression(amdgpu_gfx90a::v205, output_vec_len );
            case 462:  return makeRegisterExpression(amdgpu_gfx90a::v206, output_vec_len );
            case 463:  return makeRegisterExpression(amdgpu_gfx90a::v207, output_vec_len );
            case 464:  return makeRegisterExpression(amdgpu_gfx90a::v208, output_vec_len );
            case 465:  return makeRegisterExpression(amdgpu_gfx90a::v209, output_vec_len );
            case 466:  return makeRegisterExpression(amdgpu_gfx90a::v210, output_vec_len );
            case 467:  return makeRegisterExpression(amdgpu_gfx90a::v211, output_vec_len );
            case 468:  return makeRegisterExpression(amdgpu_gfx90a::v212, output_vec_len );
            case 469:  return makeRegisterExpression(amdgpu_gfx90a::v213, output_vec_len );
            case 470:  return makeRegisterExpression(amdgpu_gfx90a::v214, output_vec_len );
            case 471:  return makeRegisterExpression(amdgpu_gfx90a::v215, output_vec_len );
            case 472:  return makeRegisterExpression(amdgpu_gfx90a::v216, output_vec_len );
            case 473:  return makeRegisterExpression(amdgpu_gfx90a::v217, output_vec_len );
            case 474:  return makeRegisterExpression(amdgpu_gfx90a::v218, output_vec_len );
            case 475:  return makeRegisterExpression(amdgpu_gfx90a::v219, output_vec_len );
            case 476:  return makeRegisterExpression(amdgpu_gfx90a::v220, output_vec_len );
            case 477:  return makeRegisterExpression(amdgpu_gfx90a::v221, output_vec_len );
            case 478:  return makeRegisterExpression(amdgpu_gfx90a::v222, output_vec_len );
            case 479:  return makeRegisterExpression(amdgpu_gfx90a::v223, output_vec_len );
            case 480:  return makeRegisterExpression(amdgpu_gfx90a::v224, output_vec_len );
            case 481:  return makeRegisterExpression(amdgpu_gfx90a::v225, output_vec_len );
            case 482:  return makeRegisterExpression(amdgpu_gfx90a::v226, output_vec_len );
            case 483:  return makeRegisterExpression(amdgpu_gfx90a::v227, output_vec_len );
            case 484:  return makeRegisterExpression(amdgpu_gfx90a::v228, output_vec_len );
            case 485:  return makeRegisterExpression(amdgpu_gfx90a::v229, output_vec_len );
            case 486:  return makeRegisterExpression(amdgpu_gfx90a::v230, output_vec_len );
            case 487:  return makeRegisterExpression(amdgpu_gfx90a::v231, output_vec_len );
            case 488:  return makeRegisterExpression(amdgpu_gfx90a::v232, output_vec_len );
            case 489:  return makeRegisterExpression(amdgpu_gfx90a::v233, output_vec_len );
            case 490:  return makeRegisterExpression(amdgpu_gfx90a::v234, output_vec_len );
            case 491:  return makeRegisterExpression(amdgpu_gfx90a::v235, output_vec_len );
            case 492:  return makeRegisterExpression(amdgpu_gfx90a::v236, output_vec_len );
            case 493:  return makeRegisterExpression(amdgpu_gfx90a::v237, output_vec_len );
            case 494:  return makeRegisterExpression(amdgpu_gfx90a::v238, output_vec_len );
            case 495:  return makeRegisterExpression(amdgpu_gfx90a::v239, output_vec_len );
            case 496:  return makeRegisterExpression(amdgpu_gfx90a::v240, output_vec_len );
            case 497:  return makeRegisterExpression(amdgpu_gfx90a::v241, output_vec_len );
            case 498:  return makeRegisterExpression(amdgpu_gfx90a::v242, output_vec_len );
            case 499:  return makeRegisterExpression(amdgpu_gfx90a::v243, output_vec_len );
            case 500:  return makeRegisterExpression(amdgpu_gfx90a::v244, output_vec_len );
            case 501:  return makeRegisterExpression(amdgpu_gfx90a::v245, output_vec_len );
            case 502:  return makeRegisterExpression(amdgpu_gfx90a::v246, output_vec_len );
            case 503:  return makeRegisterExpression(amdgpu_gfx90a::v247, output_vec_len );
            case 504:  return makeRegisterExpression(amdgpu_gfx90a::v248, output_vec_len );
            case 505:  return makeRegisterExpression(amdgpu_gfx90a::v249, output_vec_len );
            case 506:  return makeRegisterExpression(amdgpu_gfx90a::v250, output_vec_len );
            case 507:  return makeRegisterExpression(amdgpu_gfx90a::v251, output_vec_len );
            case 508:  return makeRegisterExpression(amdgpu_gfx90a::v252, output_vec_len );
            case 509:  return makeRegisterExpression(amdgpu_gfx90a::v253, output_vec_len );
            case 510:  return makeRegisterExpression(amdgpu_gfx90a::v254, output_vec_len );
            case 511:  return makeRegisterExpression(amdgpu_gfx90a::v255, output_vec_len );
            default: return makeRegisterExpression(amdgpu_gfx90a::invalid);
        }
    }

    Expression::Ptr InstructionDecoder_amdgpu_gfx90a::decodeOPR_SRC_SIMPLE(uint64_t input, uint32_t output_vec_len)
    {
        switch (input)  {
            case 0:  return makeRegisterExpression(amdgpu_gfx90a::s0, output_vec_len );
            case 1:  return makeRegisterExpression(amdgpu_gfx90a::s1, output_vec_len );
            case 2:  return makeRegisterExpression(amdgpu_gfx90a::s2, output_vec_len );
            case 3:  return makeRegisterExpression(amdgpu_gfx90a::s3, output_vec_len );
            case 4:  return makeRegisterExpression(amdgpu_gfx90a::s4, output_vec_len );
            case 5:  return makeRegisterExpression(amdgpu_gfx90a::s5, output_vec_len );
            case 6:  return makeRegisterExpression(amdgpu_gfx90a::s6, output_vec_len );
            case 7:  return makeRegisterExpression(amdgpu_gfx90a::s7, output_vec_len );
            case 8:  return makeRegisterExpression(amdgpu_gfx90a::s8, output_vec_len );
            case 9:  return makeRegisterExpression(amdgpu_gfx90a::s9, output_vec_len );
            case 10:  return makeRegisterExpression(amdgpu_gfx90a::s10, output_vec_len );
            case 11:  return makeRegisterExpression(amdgpu_gfx90a::s11, output_vec_len );
            case 12:  return makeRegisterExpression(amdgpu_gfx90a::s12, output_vec_len );
            case 13:  return makeRegisterExpression(amdgpu_gfx90a::s13, output_vec_len );
            case 14:  return makeRegisterExpression(amdgpu_gfx90a::s14, output_vec_len );
            case 15:  return makeRegisterExpression(amdgpu_gfx90a::s15, output_vec_len );
            case 16:  return makeRegisterExpression(amdgpu_gfx90a::s16, output_vec_len );
            case 17:  return makeRegisterExpression(amdgpu_gfx90a::s17, output_vec_len );
            case 18:  return makeRegisterExpression(amdgpu_gfx90a::s18, output_vec_len );
            case 19:  return makeRegisterExpression(amdgpu_gfx90a::s19, output_vec_len );
            case 20:  return makeRegisterExpression(amdgpu_gfx90a::s20, output_vec_len );
            case 21:  return makeRegisterExpression(amdgpu_gfx90a::s21, output_vec_len );
            case 22:  return makeRegisterExpression(amdgpu_gfx90a::s22, output_vec_len );
            case 23:  return makeRegisterExpression(amdgpu_gfx90a::s23, output_vec_len );
            case 24:  return makeRegisterExpression(amdgpu_gfx90a::s24, output_vec_len );
            case 25:  return makeRegisterExpression(amdgpu_gfx90a::s25, output_vec_len );
            case 26:  return makeRegisterExpression(amdgpu_gfx90a::s26, output_vec_len );
            case 27:  return makeRegisterExpression(amdgpu_gfx90a::s27, output_vec_len );
            case 28:  return makeRegisterExpression(amdgpu_gfx90a::s28, output_vec_len );
            case 29:  return makeRegisterExpression(amdgpu_gfx90a::s29, output_vec_len );
            case 30:  return makeRegisterExpression(amdgpu_gfx90a::s30, output_vec_len );
            case 31:  return makeRegisterExpression(amdgpu_gfx90a::s31, output_vec_len );
            case 32:  return makeRegisterExpression(amdgpu_gfx90a::s32, output_vec_len );
            case 33:  return makeRegisterExpression(amdgpu_gfx90a::s33, output_vec_len );
            case 34:  return makeRegisterExpression(amdgpu_gfx90a::s34, output_vec_len );
            case 35:  return makeRegisterExpression(amdgpu_gfx90a::s35, output_vec_len );
            case 36:  return makeRegisterExpression(amdgpu_gfx90a::s36, output_vec_len );
            case 37:  return makeRegisterExpression(amdgpu_gfx90a::s37, output_vec_len );
            case 38:  return makeRegisterExpression(amdgpu_gfx90a::s38, output_vec_len );
            case 39:  return makeRegisterExpression(amdgpu_gfx90a::s39, output_vec_len );
            case 40:  return makeRegisterExpression(amdgpu_gfx90a::s40, output_vec_len );
            case 41:  return makeRegisterExpression(amdgpu_gfx90a::s41, output_vec_len );
            case 42:  return makeRegisterExpression(amdgpu_gfx90a::s42, output_vec_len );
            case 43:  return makeRegisterExpression(amdgpu_gfx90a::s43, output_vec_len );
            case 44:  return makeRegisterExpression(amdgpu_gfx90a::s44, output_vec_len );
            case 45:  return makeRegisterExpression(amdgpu_gfx90a::s45, output_vec_len );
            case 46:  return makeRegisterExpression(amdgpu_gfx90a::s46, output_vec_len );
            case 47:  return makeRegisterExpression(amdgpu_gfx90a::s47, output_vec_len );
            case 48:  return makeRegisterExpression(amdgpu_gfx90a::s48, output_vec_len );
            case 49:  return makeRegisterExpression(amdgpu_gfx90a::s49, output_vec_len );
            case 50:  return makeRegisterExpression(amdgpu_gfx90a::s50, output_vec_len );
            case 51:  return makeRegisterExpression(amdgpu_gfx90a::s51, output_vec_len );
            case 52:  return makeRegisterExpression(amdgpu_gfx90a::s52, output_vec_len );
            case 53:  return makeRegisterExpression(amdgpu_gfx90a::s53, output_vec_len );
            case 54:  return makeRegisterExpression(amdgpu_gfx90a::s54, output_vec_len );
            case 55:  return makeRegisterExpression(amdgpu_gfx90a::s55, output_vec_len );
            case 56:  return makeRegisterExpression(amdgpu_gfx90a::s56, output_vec_len );
            case 57:  return makeRegisterExpression(amdgpu_gfx90a::s57, output_vec_len );
            case 58:  return makeRegisterExpression(amdgpu_gfx90a::s58, output_vec_len );
            case 59:  return makeRegisterExpression(amdgpu_gfx90a::s59, output_vec_len );
            case 60:  return makeRegisterExpression(amdgpu_gfx90a::s60, output_vec_len );
            case 61:  return makeRegisterExpression(amdgpu_gfx90a::s61, output_vec_len );
            case 62:  return makeRegisterExpression(amdgpu_gfx90a::s62, output_vec_len );
            case 63:  return makeRegisterExpression(amdgpu_gfx90a::s63, output_vec_len );
            case 64:  return makeRegisterExpression(amdgpu_gfx90a::s64, output_vec_len );
            case 65:  return makeRegisterExpression(amdgpu_gfx90a::s65, output_vec_len );
            case 66:  return makeRegisterExpression(amdgpu_gfx90a::s66, output_vec_len );
            case 67:  return makeRegisterExpression(amdgpu_gfx90a::s67, output_vec_len );
            case 68:  return makeRegisterExpression(amdgpu_gfx90a::s68, output_vec_len );
            case 69:  return makeRegisterExpression(amdgpu_gfx90a::s69, output_vec_len );
            case 70:  return makeRegisterExpression(amdgpu_gfx90a::s70, output_vec_len );
            case 71:  return makeRegisterExpression(amdgpu_gfx90a::s71, output_vec_len );
            case 72:  return makeRegisterExpression(amdgpu_gfx90a::s72, output_vec_len );
            case 73:  return makeRegisterExpression(amdgpu_gfx90a::s73, output_vec_len );
            case 74:  return makeRegisterExpression(amdgpu_gfx90a::s74, output_vec_len );
            case 75:  return makeRegisterExpression(amdgpu_gfx90a::s75, output_vec_len );
            case 76:  return makeRegisterExpression(amdgpu_gfx90a::s76, output_vec_len );
            case 77:  return makeRegisterExpression(amdgpu_gfx90a::s77, output_vec_len );
            case 78:  return makeRegisterExpression(amdgpu_gfx90a::s78, output_vec_len );
            case 79:  return makeRegisterExpression(amdgpu_gfx90a::s79, output_vec_len );
            case 80:  return makeRegisterExpression(amdgpu_gfx90a::s80, output_vec_len );
            case 81:  return makeRegisterExpression(amdgpu_gfx90a::s81, output_vec_len );
            case 82:  return makeRegisterExpression(amdgpu_gfx90a::s82, output_vec_len );
            case 83:  return makeRegisterExpression(amdgpu_gfx90a::s83, output_vec_len );
            case 84:  return makeRegisterExpression(amdgpu_gfx90a::s84, output_vec_len );
            case 85:  return makeRegisterExpression(amdgpu_gfx90a::s85, output_vec_len );
            case 86:  return makeRegisterExpression(amdgpu_gfx90a::s86, output_vec_len );
            case 87:  return makeRegisterExpression(amdgpu_gfx90a::s87, output_vec_len );
            case 88:  return makeRegisterExpression(amdgpu_gfx90a::s88, output_vec_len );
            case 89:  return makeRegisterExpression(amdgpu_gfx90a::s89, output_vec_len );
            case 90:  return makeRegisterExpression(amdgpu_gfx90a::s90, output_vec_len );
            case 91:  return makeRegisterExpression(amdgpu_gfx90a::s91, output_vec_len );
            case 92:  return makeRegisterExpression(amdgpu_gfx90a::s92, output_vec_len );
            case 93:  return makeRegisterExpression(amdgpu_gfx90a::s93, output_vec_len );
            case 94:  return makeRegisterExpression(amdgpu_gfx90a::s94, output_vec_len );
            case 95:  return makeRegisterExpression(amdgpu_gfx90a::s95, output_vec_len );
            case 96:  return makeRegisterExpression(amdgpu_gfx90a::s96, output_vec_len );
            case 97:  return makeRegisterExpression(amdgpu_gfx90a::s97, output_vec_len );
            case 98:  return makeRegisterExpression(amdgpu_gfx90a::s98, output_vec_len );
            case 99:  return makeRegisterExpression(amdgpu_gfx90a::s99, output_vec_len );
            case 100:  return makeRegisterExpression(amdgpu_gfx90a::s100, output_vec_len );
            case 101:  return makeRegisterExpression(amdgpu_gfx90a::s101, output_vec_len );
            case 104:  return makeRegisterExpression(amdgpu_gfx90a::xnack_mask_lo, output_vec_len );
            case 105:  return makeRegisterExpression(amdgpu_gfx90a::xnack_mask_hi, output_vec_len );
            case 102:  return makeRegisterExpression(amdgpu_gfx90a::flat_scratch_lo, output_vec_len );
            case 103:  return makeRegisterExpression(amdgpu_gfx90a::flat_scratch_hi, output_vec_len );
            case 108:  return makeRegisterExpression(amdgpu_gfx90a::ttmp0, output_vec_len );
            case 109:  return makeRegisterExpression(amdgpu_gfx90a::ttmp1, output_vec_len );
            case 110:  return makeRegisterExpression(amdgpu_gfx90a::ttmp2, output_vec_len );
            case 111:  return makeRegisterExpression(amdgpu_gfx90a::ttmp3, output_vec_len );
            case 112:  return makeRegisterExpression(amdgpu_gfx90a::ttmp4, output_vec_len );
            case 113:  return makeRegisterExpression(amdgpu_gfx90a::ttmp5, output_vec_len );
            case 114:  return makeRegisterExpression(amdgpu_gfx90a::ttmp6, output_vec_len );
            case 115:  return makeRegisterExpression(amdgpu_gfx90a::ttmp7, output_vec_len );
            case 116:  return makeRegisterExpression(amdgpu_gfx90a::ttmp8, output_vec_len );
            case 117:  return makeRegisterExpression(amdgpu_gfx90a::ttmp9, output_vec_len );
            case 118:  return makeRegisterExpression(amdgpu_gfx90a::ttmp10, output_vec_len );
            case 119:  return makeRegisterExpression(amdgpu_gfx90a::ttmp11, output_vec_len );
            case 120:  return makeRegisterExpression(amdgpu_gfx90a::ttmp12, output_vec_len );
            case 121:  return makeRegisterExpression(amdgpu_gfx90a::ttmp13, output_vec_len );
            case 122:  return makeRegisterExpression(amdgpu_gfx90a::ttmp14, output_vec_len );
            case 123:  return makeRegisterExpression(amdgpu_gfx90a::ttmp15, output_vec_len );
            case 106:  return makeRegisterExpression(amdgpu_gfx90a::vcc_lo, output_vec_len );
            case 107:  return makeRegisterExpression(amdgpu_gfx90a::vcc_hi, output_vec_len );
            case 124:  return makeRegisterExpression(amdgpu_gfx90a::m0, output_vec_len );
            case 126:  return makeRegisterExpression(amdgpu_gfx90a::exec_lo, output_vec_len );
            case 127:  return makeRegisterExpression(amdgpu_gfx90a::exec_hi, output_vec_len );
            case 128:  return Immediate::makeImmediate(Result(u32, 0));
            case 129:  return Immediate::makeImmediate(Result(u32, 1));
            case 130:  return Immediate::makeImmediate(Result(u32, 2));
            case 131:  return Immediate::makeImmediate(Result(u32, 3));
            case 132:  return Immediate::makeImmediate(Result(u32, 4));
            case 133:  return Immediate::makeImmediate(Result(u32, 5));
            case 134:  return Immediate::makeImmediate(Result(u32, 6));
            case 135:  return Immediate::makeImmediate(Result(u32, 7));
            case 136:  return Immediate::makeImmediate(Result(u32, 8));
            case 137:  return Immediate::makeImmediate(Result(u32, 9));
            case 138:  return Immediate::makeImmediate(Result(u32, 10));
            case 139:  return Immediate::makeImmediate(Result(u32, 11));
            case 140:  return Immediate::makeImmediate(Result(u32, 12));
            case 141:  return Immediate::makeImmediate(Result(u32, 13));
            case 142:  return Immediate::makeImmediate(Result(u32, 14));
            case 143:  return Immediate::makeImmediate(Result(u32, 15));
            case 144:  return Immediate::makeImmediate(Result(u32, 16));
            case 145:  return Immediate::makeImmediate(Result(u32, 17));
            case 146:  return Immediate::makeImmediate(Result(u32, 18));
            case 147:  return Immediate::makeImmediate(Result(u32, 19));
            case 148:  return Immediate::makeImmediate(Result(u32, 20));
            case 149:  return Immediate::makeImmediate(Result(u32, 21));
            case 150:  return Immediate::makeImmediate(Result(u32, 22));
            case 151:  return Immediate::makeImmediate(Result(u32, 23));
            case 152:  return Immediate::makeImmediate(Result(u32, 24));
            case 153:  return Immediate::makeImmediate(Result(u32, 25));
            case 154:  return Immediate::makeImmediate(Result(u32, 26));
            case 155:  return Immediate::makeImmediate(Result(u32, 27));
            case 156:  return Immediate::makeImmediate(Result(u32, 28));
            case 157:  return Immediate::makeImmediate(Result(u32, 29));
            case 158:  return Immediate::makeImmediate(Result(u32, 30));
            case 159:  return Immediate::makeImmediate(Result(u32, 31));
            case 160:  return Immediate::makeImmediate(Result(u32, 32));
            case 161:  return Immediate::makeImmediate(Result(u32, 33));
            case 162:  return Immediate::makeImmediate(Result(u32, 34));
            case 163:  return Immediate::makeImmediate(Result(u32, 35));
            case 164:  return Immediate::makeImmediate(Result(u32, 36));
            case 165:  return Immediate::makeImmediate(Result(u32, 37));
            case 166:  return Immediate::makeImmediate(Result(u32, 38));
            case 167:  return Immediate::makeImmediate(Result(u32, 39));
            case 168:  return Immediate::makeImmediate(Result(u32, 40));
            case 169:  return Immediate::makeImmediate(Result(u32, 41));
            case 170:  return Immediate::makeImmediate(Result(u32, 42));
            case 171:  return Immediate::makeImmediate(Result(u32, 43));
            case 172:  return Immediate::makeImmediate(Result(u32, 44));
            case 173:  return Immediate::makeImmediate(Result(u32, 45));
            case 174:  return Immediate::makeImmediate(Result(u32, 46));
            case 175:  return Immediate::makeImmediate(Result(u32, 47));
            case 176:  return Immediate::makeImmediate(Result(u32, 48));
            case 177:  return Immediate::makeImmediate(Result(u32, 49));
            case 178:  return Immediate::makeImmediate(Result(u32, 50));
            case 179:  return Immediate::makeImmediate(Result(u32, 51));
            case 180:  return Immediate::makeImmediate(Result(u32, 52));
            case 181:  return Immediate::makeImmediate(Result(u32, 53));
            case 182:  return Immediate::makeImmediate(Result(u32, 54));
            case 183:  return Immediate::makeImmediate(Result(u32, 55));
            case 184:  return Immediate::makeImmediate(Result(u32, 56));
            case 185:  return Immediate::makeImmediate(Result(u32, 57));
            case 186:  return Immediate::makeImmediate(Result(u32, 58));
            case 187:  return Immediate::makeImmediate(Result(u32, 59));
            case 188:  return Immediate::makeImmediate(Result(u32, 60));
            case 189:  return Immediate::makeImmediate(Result(u32, 61));
            case 190:  return Immediate::makeImmediate(Result(u32, 62));
            case 191:  return Immediate::makeImmediate(Result(u32, 63));
            case 192:  return Immediate::makeImmediate(Result(u32, 64));
            case 193:  return Immediate::makeImmediate(Result(u32, -1));
            case 194:  return Immediate::makeImmediate(Result(u32, -2));
            case 195:  return Immediate::makeImmediate(Result(u32, -3));
            case 196:  return Immediate::makeImmediate(Result(u32, -4));
            case 197:  return Immediate::makeImmediate(Result(u32, -5));
            case 198:  return Immediate::makeImmediate(Result(u32, -6));
            case 199:  return Immediate::makeImmediate(Result(u32, -7));
            case 200:  return Immediate::makeImmediate(Result(u32, -8));
            case 201:  return Immediate::makeImmediate(Result(u32, -9));
            case 202:  return Immediate::makeImmediate(Result(u32, -10));
            case 203:  return Immediate::makeImmediate(Result(u32, -11));
            case 204:  return Immediate::makeImmediate(Result(u32, -12));
            case 205:  return Immediate::makeImmediate(Result(u32, -13));
            case 206:  return Immediate::makeImmediate(Result(u32, -14));
            case 207:  return Immediate::makeImmediate(Result(u32, -15));
            case 208:  return Immediate::makeImmediate(Result(u32, -16));
            case 240:  return Immediate::makeImmediate(Result(sp_float, 0.5));
            case 241:  return Immediate::makeImmediate(Result(sp_float, -0.5));
            case 242:  return Immediate::makeImmediate(Result(sp_float, 1.0));
            case 243:  return Immediate::makeImmediate(Result(sp_float, -1.0));
            case 244:  return Immediate::makeImmediate(Result(sp_float, 2.0));
            case 245:  return Immediate::makeImmediate(Result(sp_float, -2.0));
            case 246:  return Immediate::makeImmediate(Result(sp_float, 4.0));
            case 247:  return Immediate::makeImmediate(Result(sp_float, -4.0));
            case 248:  return Immediate::makeImmediate(Result(sp_float, 0.15915494));
            case 251:  return makeRegisterExpression(amdgpu_gfx90a::src_vccz, output_vec_len );
            case 252:  return makeRegisterExpression(amdgpu_gfx90a::src_execz, output_vec_len );
            case 253:  return makeRegisterExpression(amdgpu_gfx90a::src_scc, output_vec_len );
            case 235:  return makeRegisterExpression(amdgpu_gfx90a::src_shared_base, output_vec_len );
            case 236:  return makeRegisterExpression(amdgpu_gfx90a::src_shared_limit, output_vec_len );
            case 237:  return makeRegisterExpression(amdgpu_gfx90a::src_private_base, output_vec_len );
            case 238:  return makeRegisterExpression(amdgpu_gfx90a::src_private_limit, output_vec_len );
            case 239:  return makeRegisterExpression(amdgpu_gfx90a::src_pops_exiting_wave_id, output_vec_len );
            case 256:  return makeRegisterExpression(amdgpu_gfx90a::v0, output_vec_len );
            case 257:  return makeRegisterExpression(amdgpu_gfx90a::v1, output_vec_len );
            case 258:  return makeRegisterExpression(amdgpu_gfx90a::v2, output_vec_len );
            case 259:  return makeRegisterExpression(amdgpu_gfx90a::v3, output_vec_len );
            case 260:  return makeRegisterExpression(amdgpu_gfx90a::v4, output_vec_len );
            case 261:  return makeRegisterExpression(amdgpu_gfx90a::v5, output_vec_len );
            case 262:  return makeRegisterExpression(amdgpu_gfx90a::v6, output_vec_len );
            case 263:  return makeRegisterExpression(amdgpu_gfx90a::v7, output_vec_len );
            case 264:  return makeRegisterExpression(amdgpu_gfx90a::v8, output_vec_len );
            case 265:  return makeRegisterExpression(amdgpu_gfx90a::v9, output_vec_len );
            case 266:  return makeRegisterExpression(amdgpu_gfx90a::v10, output_vec_len );
            case 267:  return makeRegisterExpression(amdgpu_gfx90a::v11, output_vec_len );
            case 268:  return makeRegisterExpression(amdgpu_gfx90a::v12, output_vec_len );
            case 269:  return makeRegisterExpression(amdgpu_gfx90a::v13, output_vec_len );
            case 270:  return makeRegisterExpression(amdgpu_gfx90a::v14, output_vec_len );
            case 271:  return makeRegisterExpression(amdgpu_gfx90a::v15, output_vec_len );
            case 272:  return makeRegisterExpression(amdgpu_gfx90a::v16, output_vec_len );
            case 273:  return makeRegisterExpression(amdgpu_gfx90a::v17, output_vec_len );
            case 274:  return makeRegisterExpression(amdgpu_gfx90a::v18, output_vec_len );
            case 275:  return makeRegisterExpression(amdgpu_gfx90a::v19, output_vec_len );
            case 276:  return makeRegisterExpression(amdgpu_gfx90a::v20, output_vec_len );
            case 277:  return makeRegisterExpression(amdgpu_gfx90a::v21, output_vec_len );
            case 278:  return makeRegisterExpression(amdgpu_gfx90a::v22, output_vec_len );
            case 279:  return makeRegisterExpression(amdgpu_gfx90a::v23, output_vec_len );
            case 280:  return makeRegisterExpression(amdgpu_gfx90a::v24, output_vec_len );
            case 281:  return makeRegisterExpression(amdgpu_gfx90a::v25, output_vec_len );
            case 282:  return makeRegisterExpression(amdgpu_gfx90a::v26, output_vec_len );
            case 283:  return makeRegisterExpression(amdgpu_gfx90a::v27, output_vec_len );
            case 284:  return makeRegisterExpression(amdgpu_gfx90a::v28, output_vec_len );
            case 285:  return makeRegisterExpression(amdgpu_gfx90a::v29, output_vec_len );
            case 286:  return makeRegisterExpression(amdgpu_gfx90a::v30, output_vec_len );
            case 287:  return makeRegisterExpression(amdgpu_gfx90a::v31, output_vec_len );
            case 288:  return makeRegisterExpression(amdgpu_gfx90a::v32, output_vec_len );
            case 289:  return makeRegisterExpression(amdgpu_gfx90a::v33, output_vec_len );
            case 290:  return makeRegisterExpression(amdgpu_gfx90a::v34, output_vec_len );
            case 291:  return makeRegisterExpression(amdgpu_gfx90a::v35, output_vec_len );
            case 292:  return makeRegisterExpression(amdgpu_gfx90a::v36, output_vec_len );
            case 293:  return makeRegisterExpression(amdgpu_gfx90a::v37, output_vec_len );
            case 294:  return makeRegisterExpression(amdgpu_gfx90a::v38, output_vec_len );
            case 295:  return makeRegisterExpression(amdgpu_gfx90a::v39, output_vec_len );
            case 296:  return makeRegisterExpression(amdgpu_gfx90a::v40, output_vec_len );
            case 297:  return makeRegisterExpression(amdgpu_gfx90a::v41, output_vec_len );
            case 298:  return makeRegisterExpression(amdgpu_gfx90a::v42, output_vec_len );
            case 299:  return makeRegisterExpression(amdgpu_gfx90a::v43, output_vec_len );
            case 300:  return makeRegisterExpression(amdgpu_gfx90a::v44, output_vec_len );
            case 301:  return makeRegisterExpression(amdgpu_gfx90a::v45, output_vec_len );
            case 302:  return makeRegisterExpression(amdgpu_gfx90a::v46, output_vec_len );
            case 303:  return makeRegisterExpression(amdgpu_gfx90a::v47, output_vec_len );
            case 304:  return makeRegisterExpression(amdgpu_gfx90a::v48, output_vec_len );
            case 305:  return makeRegisterExpression(amdgpu_gfx90a::v49, output_vec_len );
            case 306:  return makeRegisterExpression(amdgpu_gfx90a::v50, output_vec_len );
            case 307:  return makeRegisterExpression(amdgpu_gfx90a::v51, output_vec_len );
            case 308:  return makeRegisterExpression(amdgpu_gfx90a::v52, output_vec_len );
            case 309:  return makeRegisterExpression(amdgpu_gfx90a::v53, output_vec_len );
            case 310:  return makeRegisterExpression(amdgpu_gfx90a::v54, output_vec_len );
            case 311:  return makeRegisterExpression(amdgpu_gfx90a::v55, output_vec_len );
            case 312:  return makeRegisterExpression(amdgpu_gfx90a::v56, output_vec_len );
            case 313:  return makeRegisterExpression(amdgpu_gfx90a::v57, output_vec_len );
            case 314:  return makeRegisterExpression(amdgpu_gfx90a::v58, output_vec_len );
            case 315:  return makeRegisterExpression(amdgpu_gfx90a::v59, output_vec_len );
            case 316:  return makeRegisterExpression(amdgpu_gfx90a::v60, output_vec_len );
            case 317:  return makeRegisterExpression(amdgpu_gfx90a::v61, output_vec_len );
            case 318:  return makeRegisterExpression(amdgpu_gfx90a::v62, output_vec_len );
            case 319:  return makeRegisterExpression(amdgpu_gfx90a::v63, output_vec_len );
            case 320:  return makeRegisterExpression(amdgpu_gfx90a::v64, output_vec_len );
            case 321:  return makeRegisterExpression(amdgpu_gfx90a::v65, output_vec_len );
            case 322:  return makeRegisterExpression(amdgpu_gfx90a::v66, output_vec_len );
            case 323:  return makeRegisterExpression(amdgpu_gfx90a::v67, output_vec_len );
            case 324:  return makeRegisterExpression(amdgpu_gfx90a::v68, output_vec_len );
            case 325:  return makeRegisterExpression(amdgpu_gfx90a::v69, output_vec_len );
            case 326:  return makeRegisterExpression(amdgpu_gfx90a::v70, output_vec_len );
            case 327:  return makeRegisterExpression(amdgpu_gfx90a::v71, output_vec_len );
            case 328:  return makeRegisterExpression(amdgpu_gfx90a::v72, output_vec_len );
            case 329:  return makeRegisterExpression(amdgpu_gfx90a::v73, output_vec_len );
            case 330:  return makeRegisterExpression(amdgpu_gfx90a::v74, output_vec_len );
            case 331:  return makeRegisterExpression(amdgpu_gfx90a::v75, output_vec_len );
            case 332:  return makeRegisterExpression(amdgpu_gfx90a::v76, output_vec_len );
            case 333:  return makeRegisterExpression(amdgpu_gfx90a::v77, output_vec_len );
            case 334:  return makeRegisterExpression(amdgpu_gfx90a::v78, output_vec_len );
            case 335:  return makeRegisterExpression(amdgpu_gfx90a::v79, output_vec_len );
            case 336:  return makeRegisterExpression(amdgpu_gfx90a::v80, output_vec_len );
            case 337:  return makeRegisterExpression(amdgpu_gfx90a::v81, output_vec_len );
            case 338:  return makeRegisterExpression(amdgpu_gfx90a::v82, output_vec_len );
            case 339:  return makeRegisterExpression(amdgpu_gfx90a::v83, output_vec_len );
            case 340:  return makeRegisterExpression(amdgpu_gfx90a::v84, output_vec_len );
            case 341:  return makeRegisterExpression(amdgpu_gfx90a::v85, output_vec_len );
            case 342:  return makeRegisterExpression(amdgpu_gfx90a::v86, output_vec_len );
            case 343:  return makeRegisterExpression(amdgpu_gfx90a::v87, output_vec_len );
            case 344:  return makeRegisterExpression(amdgpu_gfx90a::v88, output_vec_len );
            case 345:  return makeRegisterExpression(amdgpu_gfx90a::v89, output_vec_len );
            case 346:  return makeRegisterExpression(amdgpu_gfx90a::v90, output_vec_len );
            case 347:  return makeRegisterExpression(amdgpu_gfx90a::v91, output_vec_len );
            case 348:  return makeRegisterExpression(amdgpu_gfx90a::v92, output_vec_len );
            case 349:  return makeRegisterExpression(amdgpu_gfx90a::v93, output_vec_len );
            case 350:  return makeRegisterExpression(amdgpu_gfx90a::v94, output_vec_len );
            case 351:  return makeRegisterExpression(amdgpu_gfx90a::v95, output_vec_len );
            case 352:  return makeRegisterExpression(amdgpu_gfx90a::v96, output_vec_len );
            case 353:  return makeRegisterExpression(amdgpu_gfx90a::v97, output_vec_len );
            case 354:  return makeRegisterExpression(amdgpu_gfx90a::v98, output_vec_len );
            case 355:  return makeRegisterExpression(amdgpu_gfx90a::v99, output_vec_len );
            case 356:  return makeRegisterExpression(amdgpu_gfx90a::v100, output_vec_len );
            case 357:  return makeRegisterExpression(amdgpu_gfx90a::v101, output_vec_len );
            case 358:  return makeRegisterExpression(amdgpu_gfx90a::v102, output_vec_len );
            case 359:  return makeRegisterExpression(amdgpu_gfx90a::v103, output_vec_len );
            case 360:  return makeRegisterExpression(amdgpu_gfx90a::v104, output_vec_len );
            case 361:  return makeRegisterExpression(amdgpu_gfx90a::v105, output_vec_len );
            case 362:  return makeRegisterExpression(amdgpu_gfx90a::v106, output_vec_len );
            case 363:  return makeRegisterExpression(amdgpu_gfx90a::v107, output_vec_len );
            case 364:  return makeRegisterExpression(amdgpu_gfx90a::v108, output_vec_len );
            case 365:  return makeRegisterExpression(amdgpu_gfx90a::v109, output_vec_len );
            case 366:  return makeRegisterExpression(amdgpu_gfx90a::v110, output_vec_len );
            case 367:  return makeRegisterExpression(amdgpu_gfx90a::v111, output_vec_len );
            case 368:  return makeRegisterExpression(amdgpu_gfx90a::v112, output_vec_len );
            case 369:  return makeRegisterExpression(amdgpu_gfx90a::v113, output_vec_len );
            case 370:  return makeRegisterExpression(amdgpu_gfx90a::v114, output_vec_len );
            case 371:  return makeRegisterExpression(amdgpu_gfx90a::v115, output_vec_len );
            case 372:  return makeRegisterExpression(amdgpu_gfx90a::v116, output_vec_len );
            case 373:  return makeRegisterExpression(amdgpu_gfx90a::v117, output_vec_len );
            case 374:  return makeRegisterExpression(amdgpu_gfx90a::v118, output_vec_len );
            case 375:  return makeRegisterExpression(amdgpu_gfx90a::v119, output_vec_len );
            case 376:  return makeRegisterExpression(amdgpu_gfx90a::v120, output_vec_len );
            case 377:  return makeRegisterExpression(amdgpu_gfx90a::v121, output_vec_len );
            case 378:  return makeRegisterExpression(amdgpu_gfx90a::v122, output_vec_len );
            case 379:  return makeRegisterExpression(amdgpu_gfx90a::v123, output_vec_len );
            case 380:  return makeRegisterExpression(amdgpu_gfx90a::v124, output_vec_len );
            case 381:  return makeRegisterExpression(amdgpu_gfx90a::v125, output_vec_len );
            case 382:  return makeRegisterExpression(amdgpu_gfx90a::v126, output_vec_len );
            case 383:  return makeRegisterExpression(amdgpu_gfx90a::v127, output_vec_len );
            case 384:  return makeRegisterExpression(amdgpu_gfx90a::v128, output_vec_len );
            case 385:  return makeRegisterExpression(amdgpu_gfx90a::v129, output_vec_len );
            case 386:  return makeRegisterExpression(amdgpu_gfx90a::v130, output_vec_len );
            case 387:  return makeRegisterExpression(amdgpu_gfx90a::v131, output_vec_len );
            case 388:  return makeRegisterExpression(amdgpu_gfx90a::v132, output_vec_len );
            case 389:  return makeRegisterExpression(amdgpu_gfx90a::v133, output_vec_len );
            case 390:  return makeRegisterExpression(amdgpu_gfx90a::v134, output_vec_len );
            case 391:  return makeRegisterExpression(amdgpu_gfx90a::v135, output_vec_len );
            case 392:  return makeRegisterExpression(amdgpu_gfx90a::v136, output_vec_len );
            case 393:  return makeRegisterExpression(amdgpu_gfx90a::v137, output_vec_len );
            case 394:  return makeRegisterExpression(amdgpu_gfx90a::v138, output_vec_len );
            case 395:  return makeRegisterExpression(amdgpu_gfx90a::v139, output_vec_len );
            case 396:  return makeRegisterExpression(amdgpu_gfx90a::v140, output_vec_len );
            case 397:  return makeRegisterExpression(amdgpu_gfx90a::v141, output_vec_len );
            case 398:  return makeRegisterExpression(amdgpu_gfx90a::v142, output_vec_len );
            case 399:  return makeRegisterExpression(amdgpu_gfx90a::v143, output_vec_len );
            case 400:  return makeRegisterExpression(amdgpu_gfx90a::v144, output_vec_len );
            case 401:  return makeRegisterExpression(amdgpu_gfx90a::v145, output_vec_len );
            case 402:  return makeRegisterExpression(amdgpu_gfx90a::v146, output_vec_len );
            case 403:  return makeRegisterExpression(amdgpu_gfx90a::v147, output_vec_len );
            case 404:  return makeRegisterExpression(amdgpu_gfx90a::v148, output_vec_len );
            case 405:  return makeRegisterExpression(amdgpu_gfx90a::v149, output_vec_len );
            case 406:  return makeRegisterExpression(amdgpu_gfx90a::v150, output_vec_len );
            case 407:  return makeRegisterExpression(amdgpu_gfx90a::v151, output_vec_len );
            case 408:  return makeRegisterExpression(amdgpu_gfx90a::v152, output_vec_len );
            case 409:  return makeRegisterExpression(amdgpu_gfx90a::v153, output_vec_len );
            case 410:  return makeRegisterExpression(amdgpu_gfx90a::v154, output_vec_len );
            case 411:  return makeRegisterExpression(amdgpu_gfx90a::v155, output_vec_len );
            case 412:  return makeRegisterExpression(amdgpu_gfx90a::v156, output_vec_len );
            case 413:  return makeRegisterExpression(amdgpu_gfx90a::v157, output_vec_len );
            case 414:  return makeRegisterExpression(amdgpu_gfx90a::v158, output_vec_len );
            case 415:  return makeRegisterExpression(amdgpu_gfx90a::v159, output_vec_len );
            case 416:  return makeRegisterExpression(amdgpu_gfx90a::v160, output_vec_len );
            case 417:  return makeRegisterExpression(amdgpu_gfx90a::v161, output_vec_len );
            case 418:  return makeRegisterExpression(amdgpu_gfx90a::v162, output_vec_len );
            case 419:  return makeRegisterExpression(amdgpu_gfx90a::v163, output_vec_len );
            case 420:  return makeRegisterExpression(amdgpu_gfx90a::v164, output_vec_len );
            case 421:  return makeRegisterExpression(amdgpu_gfx90a::v165, output_vec_len );
            case 422:  return makeRegisterExpression(amdgpu_gfx90a::v166, output_vec_len );
            case 423:  return makeRegisterExpression(amdgpu_gfx90a::v167, output_vec_len );
            case 424:  return makeRegisterExpression(amdgpu_gfx90a::v168, output_vec_len );
            case 425:  return makeRegisterExpression(amdgpu_gfx90a::v169, output_vec_len );
            case 426:  return makeRegisterExpression(amdgpu_gfx90a::v170, output_vec_len );
            case 427:  return makeRegisterExpression(amdgpu_gfx90a::v171, output_vec_len );
            case 428:  return makeRegisterExpression(amdgpu_gfx90a::v172, output_vec_len );
            case 429:  return makeRegisterExpression(amdgpu_gfx90a::v173, output_vec_len );
            case 430:  return makeRegisterExpression(amdgpu_gfx90a::v174, output_vec_len );
            case 431:  return makeRegisterExpression(amdgpu_gfx90a::v175, output_vec_len );
            case 432:  return makeRegisterExpression(amdgpu_gfx90a::v176, output_vec_len );
            case 433:  return makeRegisterExpression(amdgpu_gfx90a::v177, output_vec_len );
            case 434:  return makeRegisterExpression(amdgpu_gfx90a::v178, output_vec_len );
            case 435:  return makeRegisterExpression(amdgpu_gfx90a::v179, output_vec_len );
            case 436:  return makeRegisterExpression(amdgpu_gfx90a::v180, output_vec_len );
            case 437:  return makeRegisterExpression(amdgpu_gfx90a::v181, output_vec_len );
            case 438:  return makeRegisterExpression(amdgpu_gfx90a::v182, output_vec_len );
            case 439:  return makeRegisterExpression(amdgpu_gfx90a::v183, output_vec_len );
            case 440:  return makeRegisterExpression(amdgpu_gfx90a::v184, output_vec_len );
            case 441:  return makeRegisterExpression(amdgpu_gfx90a::v185, output_vec_len );
            case 442:  return makeRegisterExpression(amdgpu_gfx90a::v186, output_vec_len );
            case 443:  return makeRegisterExpression(amdgpu_gfx90a::v187, output_vec_len );
            case 444:  return makeRegisterExpression(amdgpu_gfx90a::v188, output_vec_len );
            case 445:  return makeRegisterExpression(amdgpu_gfx90a::v189, output_vec_len );
            case 446:  return makeRegisterExpression(amdgpu_gfx90a::v190, output_vec_len );
            case 447:  return makeRegisterExpression(amdgpu_gfx90a::v191, output_vec_len );
            case 448:  return makeRegisterExpression(amdgpu_gfx90a::v192, output_vec_len );
            case 449:  return makeRegisterExpression(amdgpu_gfx90a::v193, output_vec_len );
            case 450:  return makeRegisterExpression(amdgpu_gfx90a::v194, output_vec_len );
            case 451:  return makeRegisterExpression(amdgpu_gfx90a::v195, output_vec_len );
            case 452:  return makeRegisterExpression(amdgpu_gfx90a::v196, output_vec_len );
            case 453:  return makeRegisterExpression(amdgpu_gfx90a::v197, output_vec_len );
            case 454:  return makeRegisterExpression(amdgpu_gfx90a::v198, output_vec_len );
            case 455:  return makeRegisterExpression(amdgpu_gfx90a::v199, output_vec_len );
            case 456:  return makeRegisterExpression(amdgpu_gfx90a::v200, output_vec_len );
            case 457:  return makeRegisterExpression(amdgpu_gfx90a::v201, output_vec_len );
            case 458:  return makeRegisterExpression(amdgpu_gfx90a::v202, output_vec_len );
            case 459:  return makeRegisterExpression(amdgpu_gfx90a::v203, output_vec_len );
            case 460:  return makeRegisterExpression(amdgpu_gfx90a::v204, output_vec_len );
            case 461:  return makeRegisterExpression(amdgpu_gfx90a::v205, output_vec_len );
            case 462:  return makeRegisterExpression(amdgpu_gfx90a::v206, output_vec_len );
            case 463:  return makeRegisterExpression(amdgpu_gfx90a::v207, output_vec_len );
            case 464:  return makeRegisterExpression(amdgpu_gfx90a::v208, output_vec_len );
            case 465:  return makeRegisterExpression(amdgpu_gfx90a::v209, output_vec_len );
            case 466:  return makeRegisterExpression(amdgpu_gfx90a::v210, output_vec_len );
            case 467:  return makeRegisterExpression(amdgpu_gfx90a::v211, output_vec_len );
            case 468:  return makeRegisterExpression(amdgpu_gfx90a::v212, output_vec_len );
            case 469:  return makeRegisterExpression(amdgpu_gfx90a::v213, output_vec_len );
            case 470:  return makeRegisterExpression(amdgpu_gfx90a::v214, output_vec_len );
            case 471:  return makeRegisterExpression(amdgpu_gfx90a::v215, output_vec_len );
            case 472:  return makeRegisterExpression(amdgpu_gfx90a::v216, output_vec_len );
            case 473:  return makeRegisterExpression(amdgpu_gfx90a::v217, output_vec_len );
            case 474:  return makeRegisterExpression(amdgpu_gfx90a::v218, output_vec_len );
            case 475:  return makeRegisterExpression(amdgpu_gfx90a::v219, output_vec_len );
            case 476:  return makeRegisterExpression(amdgpu_gfx90a::v220, output_vec_len );
            case 477:  return makeRegisterExpression(amdgpu_gfx90a::v221, output_vec_len );
            case 478:  return makeRegisterExpression(amdgpu_gfx90a::v222, output_vec_len );
            case 479:  return makeRegisterExpression(amdgpu_gfx90a::v223, output_vec_len );
            case 480:  return makeRegisterExpression(amdgpu_gfx90a::v224, output_vec_len );
            case 481:  return makeRegisterExpression(amdgpu_gfx90a::v225, output_vec_len );
            case 482:  return makeRegisterExpression(amdgpu_gfx90a::v226, output_vec_len );
            case 483:  return makeRegisterExpression(amdgpu_gfx90a::v227, output_vec_len );
            case 484:  return makeRegisterExpression(amdgpu_gfx90a::v228, output_vec_len );
            case 485:  return makeRegisterExpression(amdgpu_gfx90a::v229, output_vec_len );
            case 486:  return makeRegisterExpression(amdgpu_gfx90a::v230, output_vec_len );
            case 487:  return makeRegisterExpression(amdgpu_gfx90a::v231, output_vec_len );
            case 488:  return makeRegisterExpression(amdgpu_gfx90a::v232, output_vec_len );
            case 489:  return makeRegisterExpression(amdgpu_gfx90a::v233, output_vec_len );
            case 490:  return makeRegisterExpression(amdgpu_gfx90a::v234, output_vec_len );
            case 491:  return makeRegisterExpression(amdgpu_gfx90a::v235, output_vec_len );
            case 492:  return makeRegisterExpression(amdgpu_gfx90a::v236, output_vec_len );
            case 493:  return makeRegisterExpression(amdgpu_gfx90a::v237, output_vec_len );
            case 494:  return makeRegisterExpression(amdgpu_gfx90a::v238, output_vec_len );
            case 495:  return makeRegisterExpression(amdgpu_gfx90a::v239, output_vec_len );
            case 496:  return makeRegisterExpression(amdgpu_gfx90a::v240, output_vec_len );
            case 497:  return makeRegisterExpression(amdgpu_gfx90a::v241, output_vec_len );
            case 498:  return makeRegisterExpression(amdgpu_gfx90a::v242, output_vec_len );
            case 499:  return makeRegisterExpression(amdgpu_gfx90a::v243, output_vec_len );
            case 500:  return makeRegisterExpression(amdgpu_gfx90a::v244, output_vec_len );
            case 501:  return makeRegisterExpression(amdgpu_gfx90a::v245, output_vec_len );
            case 502:  return makeRegisterExpression(amdgpu_gfx90a::v246, output_vec_len );
            case 503:  return makeRegisterExpression(amdgpu_gfx90a::v247, output_vec_len );
            case 504:  return makeRegisterExpression(amdgpu_gfx90a::v248, output_vec_len );
            case 505:  return makeRegisterExpression(amdgpu_gfx90a::v249, output_vec_len );
            case 506:  return makeRegisterExpression(amdgpu_gfx90a::v250, output_vec_len );
            case 507:  return makeRegisterExpression(amdgpu_gfx90a::v251, output_vec_len );
            case 508:  return makeRegisterExpression(amdgpu_gfx90a::v252, output_vec_len );
            case 509:  return makeRegisterExpression(amdgpu_gfx90a::v253, output_vec_len );
            case 510:  return makeRegisterExpression(amdgpu_gfx90a::v254, output_vec_len );
            case 511:  return makeRegisterExpression(amdgpu_gfx90a::v255, output_vec_len );
            default: return makeRegisterExpression(amdgpu_gfx90a::invalid);
        }
    }

    Expression::Ptr InstructionDecoder_amdgpu_gfx90a::decodeOPR_SRC_VGPR(uint64_t input, uint32_t output_vec_len)
    {
        switch (input)  {
            case 256:  return makeRegisterExpression(amdgpu_gfx90a::v0, output_vec_len );
            case 257:  return makeRegisterExpression(amdgpu_gfx90a::v1, output_vec_len );
            case 258:  return makeRegisterExpression(amdgpu_gfx90a::v2, output_vec_len );
            case 259:  return makeRegisterExpression(amdgpu_gfx90a::v3, output_vec_len );
            case 260:  return makeRegisterExpression(amdgpu_gfx90a::v4, output_vec_len );
            case 261:  return makeRegisterExpression(amdgpu_gfx90a::v5, output_vec_len );
            case 262:  return makeRegisterExpression(amdgpu_gfx90a::v6, output_vec_len );
            case 263:  return makeRegisterExpression(amdgpu_gfx90a::v7, output_vec_len );
            case 264:  return makeRegisterExpression(amdgpu_gfx90a::v8, output_vec_len );
            case 265:  return makeRegisterExpression(amdgpu_gfx90a::v9, output_vec_len );
            case 266:  return makeRegisterExpression(amdgpu_gfx90a::v10, output_vec_len );
            case 267:  return makeRegisterExpression(amdgpu_gfx90a::v11, output_vec_len );
            case 268:  return makeRegisterExpression(amdgpu_gfx90a::v12, output_vec_len );
            case 269:  return makeRegisterExpression(amdgpu_gfx90a::v13, output_vec_len );
            case 270:  return makeRegisterExpression(amdgpu_gfx90a::v14, output_vec_len );
            case 271:  return makeRegisterExpression(amdgpu_gfx90a::v15, output_vec_len );
            case 272:  return makeRegisterExpression(amdgpu_gfx90a::v16, output_vec_len );
            case 273:  return makeRegisterExpression(amdgpu_gfx90a::v17, output_vec_len );
            case 274:  return makeRegisterExpression(amdgpu_gfx90a::v18, output_vec_len );
            case 275:  return makeRegisterExpression(amdgpu_gfx90a::v19, output_vec_len );
            case 276:  return makeRegisterExpression(amdgpu_gfx90a::v20, output_vec_len );
            case 277:  return makeRegisterExpression(amdgpu_gfx90a::v21, output_vec_len );
            case 278:  return makeRegisterExpression(amdgpu_gfx90a::v22, output_vec_len );
            case 279:  return makeRegisterExpression(amdgpu_gfx90a::v23, output_vec_len );
            case 280:  return makeRegisterExpression(amdgpu_gfx90a::v24, output_vec_len );
            case 281:  return makeRegisterExpression(amdgpu_gfx90a::v25, output_vec_len );
            case 282:  return makeRegisterExpression(amdgpu_gfx90a::v26, output_vec_len );
            case 283:  return makeRegisterExpression(amdgpu_gfx90a::v27, output_vec_len );
            case 284:  return makeRegisterExpression(amdgpu_gfx90a::v28, output_vec_len );
            case 285:  return makeRegisterExpression(amdgpu_gfx90a::v29, output_vec_len );
            case 286:  return makeRegisterExpression(amdgpu_gfx90a::v30, output_vec_len );
            case 287:  return makeRegisterExpression(amdgpu_gfx90a::v31, output_vec_len );
            case 288:  return makeRegisterExpression(amdgpu_gfx90a::v32, output_vec_len );
            case 289:  return makeRegisterExpression(amdgpu_gfx90a::v33, output_vec_len );
            case 290:  return makeRegisterExpression(amdgpu_gfx90a::v34, output_vec_len );
            case 291:  return makeRegisterExpression(amdgpu_gfx90a::v35, output_vec_len );
            case 292:  return makeRegisterExpression(amdgpu_gfx90a::v36, output_vec_len );
            case 293:  return makeRegisterExpression(amdgpu_gfx90a::v37, output_vec_len );
            case 294:  return makeRegisterExpression(amdgpu_gfx90a::v38, output_vec_len );
            case 295:  return makeRegisterExpression(amdgpu_gfx90a::v39, output_vec_len );
            case 296:  return makeRegisterExpression(amdgpu_gfx90a::v40, output_vec_len );
            case 297:  return makeRegisterExpression(amdgpu_gfx90a::v41, output_vec_len );
            case 298:  return makeRegisterExpression(amdgpu_gfx90a::v42, output_vec_len );
            case 299:  return makeRegisterExpression(amdgpu_gfx90a::v43, output_vec_len );
            case 300:  return makeRegisterExpression(amdgpu_gfx90a::v44, output_vec_len );
            case 301:  return makeRegisterExpression(amdgpu_gfx90a::v45, output_vec_len );
            case 302:  return makeRegisterExpression(amdgpu_gfx90a::v46, output_vec_len );
            case 303:  return makeRegisterExpression(amdgpu_gfx90a::v47, output_vec_len );
            case 304:  return makeRegisterExpression(amdgpu_gfx90a::v48, output_vec_len );
            case 305:  return makeRegisterExpression(amdgpu_gfx90a::v49, output_vec_len );
            case 306:  return makeRegisterExpression(amdgpu_gfx90a::v50, output_vec_len );
            case 307:  return makeRegisterExpression(amdgpu_gfx90a::v51, output_vec_len );
            case 308:  return makeRegisterExpression(amdgpu_gfx90a::v52, output_vec_len );
            case 309:  return makeRegisterExpression(amdgpu_gfx90a::v53, output_vec_len );
            case 310:  return makeRegisterExpression(amdgpu_gfx90a::v54, output_vec_len );
            case 311:  return makeRegisterExpression(amdgpu_gfx90a::v55, output_vec_len );
            case 312:  return makeRegisterExpression(amdgpu_gfx90a::v56, output_vec_len );
            case 313:  return makeRegisterExpression(amdgpu_gfx90a::v57, output_vec_len );
            case 314:  return makeRegisterExpression(amdgpu_gfx90a::v58, output_vec_len );
            case 315:  return makeRegisterExpression(amdgpu_gfx90a::v59, output_vec_len );
            case 316:  return makeRegisterExpression(amdgpu_gfx90a::v60, output_vec_len );
            case 317:  return makeRegisterExpression(amdgpu_gfx90a::v61, output_vec_len );
            case 318:  return makeRegisterExpression(amdgpu_gfx90a::v62, output_vec_len );
            case 319:  return makeRegisterExpression(amdgpu_gfx90a::v63, output_vec_len );
            case 320:  return makeRegisterExpression(amdgpu_gfx90a::v64, output_vec_len );
            case 321:  return makeRegisterExpression(amdgpu_gfx90a::v65, output_vec_len );
            case 322:  return makeRegisterExpression(amdgpu_gfx90a::v66, output_vec_len );
            case 323:  return makeRegisterExpression(amdgpu_gfx90a::v67, output_vec_len );
            case 324:  return makeRegisterExpression(amdgpu_gfx90a::v68, output_vec_len );
            case 325:  return makeRegisterExpression(amdgpu_gfx90a::v69, output_vec_len );
            case 326:  return makeRegisterExpression(amdgpu_gfx90a::v70, output_vec_len );
            case 327:  return makeRegisterExpression(amdgpu_gfx90a::v71, output_vec_len );
            case 328:  return makeRegisterExpression(amdgpu_gfx90a::v72, output_vec_len );
            case 329:  return makeRegisterExpression(amdgpu_gfx90a::v73, output_vec_len );
            case 330:  return makeRegisterExpression(amdgpu_gfx90a::v74, output_vec_len );
            case 331:  return makeRegisterExpression(amdgpu_gfx90a::v75, output_vec_len );
            case 332:  return makeRegisterExpression(amdgpu_gfx90a::v76, output_vec_len );
            case 333:  return makeRegisterExpression(amdgpu_gfx90a::v77, output_vec_len );
            case 334:  return makeRegisterExpression(amdgpu_gfx90a::v78, output_vec_len );
            case 335:  return makeRegisterExpression(amdgpu_gfx90a::v79, output_vec_len );
            case 336:  return makeRegisterExpression(amdgpu_gfx90a::v80, output_vec_len );
            case 337:  return makeRegisterExpression(amdgpu_gfx90a::v81, output_vec_len );
            case 338:  return makeRegisterExpression(amdgpu_gfx90a::v82, output_vec_len );
            case 339:  return makeRegisterExpression(amdgpu_gfx90a::v83, output_vec_len );
            case 340:  return makeRegisterExpression(amdgpu_gfx90a::v84, output_vec_len );
            case 341:  return makeRegisterExpression(amdgpu_gfx90a::v85, output_vec_len );
            case 342:  return makeRegisterExpression(amdgpu_gfx90a::v86, output_vec_len );
            case 343:  return makeRegisterExpression(amdgpu_gfx90a::v87, output_vec_len );
            case 344:  return makeRegisterExpression(amdgpu_gfx90a::v88, output_vec_len );
            case 345:  return makeRegisterExpression(amdgpu_gfx90a::v89, output_vec_len );
            case 346:  return makeRegisterExpression(amdgpu_gfx90a::v90, output_vec_len );
            case 347:  return makeRegisterExpression(amdgpu_gfx90a::v91, output_vec_len );
            case 348:  return makeRegisterExpression(amdgpu_gfx90a::v92, output_vec_len );
            case 349:  return makeRegisterExpression(amdgpu_gfx90a::v93, output_vec_len );
            case 350:  return makeRegisterExpression(amdgpu_gfx90a::v94, output_vec_len );
            case 351:  return makeRegisterExpression(amdgpu_gfx90a::v95, output_vec_len );
            case 352:  return makeRegisterExpression(amdgpu_gfx90a::v96, output_vec_len );
            case 353:  return makeRegisterExpression(amdgpu_gfx90a::v97, output_vec_len );
            case 354:  return makeRegisterExpression(amdgpu_gfx90a::v98, output_vec_len );
            case 355:  return makeRegisterExpression(amdgpu_gfx90a::v99, output_vec_len );
            case 356:  return makeRegisterExpression(amdgpu_gfx90a::v100, output_vec_len );
            case 357:  return makeRegisterExpression(amdgpu_gfx90a::v101, output_vec_len );
            case 358:  return makeRegisterExpression(amdgpu_gfx90a::v102, output_vec_len );
            case 359:  return makeRegisterExpression(amdgpu_gfx90a::v103, output_vec_len );
            case 360:  return makeRegisterExpression(amdgpu_gfx90a::v104, output_vec_len );
            case 361:  return makeRegisterExpression(amdgpu_gfx90a::v105, output_vec_len );
            case 362:  return makeRegisterExpression(amdgpu_gfx90a::v106, output_vec_len );
            case 363:  return makeRegisterExpression(amdgpu_gfx90a::v107, output_vec_len );
            case 364:  return makeRegisterExpression(amdgpu_gfx90a::v108, output_vec_len );
            case 365:  return makeRegisterExpression(amdgpu_gfx90a::v109, output_vec_len );
            case 366:  return makeRegisterExpression(amdgpu_gfx90a::v110, output_vec_len );
            case 367:  return makeRegisterExpression(amdgpu_gfx90a::v111, output_vec_len );
            case 368:  return makeRegisterExpression(amdgpu_gfx90a::v112, output_vec_len );
            case 369:  return makeRegisterExpression(amdgpu_gfx90a::v113, output_vec_len );
            case 370:  return makeRegisterExpression(amdgpu_gfx90a::v114, output_vec_len );
            case 371:  return makeRegisterExpression(amdgpu_gfx90a::v115, output_vec_len );
            case 372:  return makeRegisterExpression(amdgpu_gfx90a::v116, output_vec_len );
            case 373:  return makeRegisterExpression(amdgpu_gfx90a::v117, output_vec_len );
            case 374:  return makeRegisterExpression(amdgpu_gfx90a::v118, output_vec_len );
            case 375:  return makeRegisterExpression(amdgpu_gfx90a::v119, output_vec_len );
            case 376:  return makeRegisterExpression(amdgpu_gfx90a::v120, output_vec_len );
            case 377:  return makeRegisterExpression(amdgpu_gfx90a::v121, output_vec_len );
            case 378:  return makeRegisterExpression(amdgpu_gfx90a::v122, output_vec_len );
            case 379:  return makeRegisterExpression(amdgpu_gfx90a::v123, output_vec_len );
            case 380:  return makeRegisterExpression(amdgpu_gfx90a::v124, output_vec_len );
            case 381:  return makeRegisterExpression(amdgpu_gfx90a::v125, output_vec_len );
            case 382:  return makeRegisterExpression(amdgpu_gfx90a::v126, output_vec_len );
            case 383:  return makeRegisterExpression(amdgpu_gfx90a::v127, output_vec_len );
            case 384:  return makeRegisterExpression(amdgpu_gfx90a::v128, output_vec_len );
            case 385:  return makeRegisterExpression(amdgpu_gfx90a::v129, output_vec_len );
            case 386:  return makeRegisterExpression(amdgpu_gfx90a::v130, output_vec_len );
            case 387:  return makeRegisterExpression(amdgpu_gfx90a::v131, output_vec_len );
            case 388:  return makeRegisterExpression(amdgpu_gfx90a::v132, output_vec_len );
            case 389:  return makeRegisterExpression(amdgpu_gfx90a::v133, output_vec_len );
            case 390:  return makeRegisterExpression(amdgpu_gfx90a::v134, output_vec_len );
            case 391:  return makeRegisterExpression(amdgpu_gfx90a::v135, output_vec_len );
            case 392:  return makeRegisterExpression(amdgpu_gfx90a::v136, output_vec_len );
            case 393:  return makeRegisterExpression(amdgpu_gfx90a::v137, output_vec_len );
            case 394:  return makeRegisterExpression(amdgpu_gfx90a::v138, output_vec_len );
            case 395:  return makeRegisterExpression(amdgpu_gfx90a::v139, output_vec_len );
            case 396:  return makeRegisterExpression(amdgpu_gfx90a::v140, output_vec_len );
            case 397:  return makeRegisterExpression(amdgpu_gfx90a::v141, output_vec_len );
            case 398:  return makeRegisterExpression(amdgpu_gfx90a::v142, output_vec_len );
            case 399:  return makeRegisterExpression(amdgpu_gfx90a::v143, output_vec_len );
            case 400:  return makeRegisterExpression(amdgpu_gfx90a::v144, output_vec_len );
            case 401:  return makeRegisterExpression(amdgpu_gfx90a::v145, output_vec_len );
            case 402:  return makeRegisterExpression(amdgpu_gfx90a::v146, output_vec_len );
            case 403:  return makeRegisterExpression(amdgpu_gfx90a::v147, output_vec_len );
            case 404:  return makeRegisterExpression(amdgpu_gfx90a::v148, output_vec_len );
            case 405:  return makeRegisterExpression(amdgpu_gfx90a::v149, output_vec_len );
            case 406:  return makeRegisterExpression(amdgpu_gfx90a::v150, output_vec_len );
            case 407:  return makeRegisterExpression(amdgpu_gfx90a::v151, output_vec_len );
            case 408:  return makeRegisterExpression(amdgpu_gfx90a::v152, output_vec_len );
            case 409:  return makeRegisterExpression(amdgpu_gfx90a::v153, output_vec_len );
            case 410:  return makeRegisterExpression(amdgpu_gfx90a::v154, output_vec_len );
            case 411:  return makeRegisterExpression(amdgpu_gfx90a::v155, output_vec_len );
            case 412:  return makeRegisterExpression(amdgpu_gfx90a::v156, output_vec_len );
            case 413:  return makeRegisterExpression(amdgpu_gfx90a::v157, output_vec_len );
            case 414:  return makeRegisterExpression(amdgpu_gfx90a::v158, output_vec_len );
            case 415:  return makeRegisterExpression(amdgpu_gfx90a::v159, output_vec_len );
            case 416:  return makeRegisterExpression(amdgpu_gfx90a::v160, output_vec_len );
            case 417:  return makeRegisterExpression(amdgpu_gfx90a::v161, output_vec_len );
            case 418:  return makeRegisterExpression(amdgpu_gfx90a::v162, output_vec_len );
            case 419:  return makeRegisterExpression(amdgpu_gfx90a::v163, output_vec_len );
            case 420:  return makeRegisterExpression(amdgpu_gfx90a::v164, output_vec_len );
            case 421:  return makeRegisterExpression(amdgpu_gfx90a::v165, output_vec_len );
            case 422:  return makeRegisterExpression(amdgpu_gfx90a::v166, output_vec_len );
            case 423:  return makeRegisterExpression(amdgpu_gfx90a::v167, output_vec_len );
            case 424:  return makeRegisterExpression(amdgpu_gfx90a::v168, output_vec_len );
            case 425:  return makeRegisterExpression(amdgpu_gfx90a::v169, output_vec_len );
            case 426:  return makeRegisterExpression(amdgpu_gfx90a::v170, output_vec_len );
            case 427:  return makeRegisterExpression(amdgpu_gfx90a::v171, output_vec_len );
            case 428:  return makeRegisterExpression(amdgpu_gfx90a::v172, output_vec_len );
            case 429:  return makeRegisterExpression(amdgpu_gfx90a::v173, output_vec_len );
            case 430:  return makeRegisterExpression(amdgpu_gfx90a::v174, output_vec_len );
            case 431:  return makeRegisterExpression(amdgpu_gfx90a::v175, output_vec_len );
            case 432:  return makeRegisterExpression(amdgpu_gfx90a::v176, output_vec_len );
            case 433:  return makeRegisterExpression(amdgpu_gfx90a::v177, output_vec_len );
            case 434:  return makeRegisterExpression(amdgpu_gfx90a::v178, output_vec_len );
            case 435:  return makeRegisterExpression(amdgpu_gfx90a::v179, output_vec_len );
            case 436:  return makeRegisterExpression(amdgpu_gfx90a::v180, output_vec_len );
            case 437:  return makeRegisterExpression(amdgpu_gfx90a::v181, output_vec_len );
            case 438:  return makeRegisterExpression(amdgpu_gfx90a::v182, output_vec_len );
            case 439:  return makeRegisterExpression(amdgpu_gfx90a::v183, output_vec_len );
            case 440:  return makeRegisterExpression(amdgpu_gfx90a::v184, output_vec_len );
            case 441:  return makeRegisterExpression(amdgpu_gfx90a::v185, output_vec_len );
            case 442:  return makeRegisterExpression(amdgpu_gfx90a::v186, output_vec_len );
            case 443:  return makeRegisterExpression(amdgpu_gfx90a::v187, output_vec_len );
            case 444:  return makeRegisterExpression(amdgpu_gfx90a::v188, output_vec_len );
            case 445:  return makeRegisterExpression(amdgpu_gfx90a::v189, output_vec_len );
            case 446:  return makeRegisterExpression(amdgpu_gfx90a::v190, output_vec_len );
            case 447:  return makeRegisterExpression(amdgpu_gfx90a::v191, output_vec_len );
            case 448:  return makeRegisterExpression(amdgpu_gfx90a::v192, output_vec_len );
            case 449:  return makeRegisterExpression(amdgpu_gfx90a::v193, output_vec_len );
            case 450:  return makeRegisterExpression(amdgpu_gfx90a::v194, output_vec_len );
            case 451:  return makeRegisterExpression(amdgpu_gfx90a::v195, output_vec_len );
            case 452:  return makeRegisterExpression(amdgpu_gfx90a::v196, output_vec_len );
            case 453:  return makeRegisterExpression(amdgpu_gfx90a::v197, output_vec_len );
            case 454:  return makeRegisterExpression(amdgpu_gfx90a::v198, output_vec_len );
            case 455:  return makeRegisterExpression(amdgpu_gfx90a::v199, output_vec_len );
            case 456:  return makeRegisterExpression(amdgpu_gfx90a::v200, output_vec_len );
            case 457:  return makeRegisterExpression(amdgpu_gfx90a::v201, output_vec_len );
            case 458:  return makeRegisterExpression(amdgpu_gfx90a::v202, output_vec_len );
            case 459:  return makeRegisterExpression(amdgpu_gfx90a::v203, output_vec_len );
            case 460:  return makeRegisterExpression(amdgpu_gfx90a::v204, output_vec_len );
            case 461:  return makeRegisterExpression(amdgpu_gfx90a::v205, output_vec_len );
            case 462:  return makeRegisterExpression(amdgpu_gfx90a::v206, output_vec_len );
            case 463:  return makeRegisterExpression(amdgpu_gfx90a::v207, output_vec_len );
            case 464:  return makeRegisterExpression(amdgpu_gfx90a::v208, output_vec_len );
            case 465:  return makeRegisterExpression(amdgpu_gfx90a::v209, output_vec_len );
            case 466:  return makeRegisterExpression(amdgpu_gfx90a::v210, output_vec_len );
            case 467:  return makeRegisterExpression(amdgpu_gfx90a::v211, output_vec_len );
            case 468:  return makeRegisterExpression(amdgpu_gfx90a::v212, output_vec_len );
            case 469:  return makeRegisterExpression(amdgpu_gfx90a::v213, output_vec_len );
            case 470:  return makeRegisterExpression(amdgpu_gfx90a::v214, output_vec_len );
            case 471:  return makeRegisterExpression(amdgpu_gfx90a::v215, output_vec_len );
            case 472:  return makeRegisterExpression(amdgpu_gfx90a::v216, output_vec_len );
            case 473:  return makeRegisterExpression(amdgpu_gfx90a::v217, output_vec_len );
            case 474:  return makeRegisterExpression(amdgpu_gfx90a::v218, output_vec_len );
            case 475:  return makeRegisterExpression(amdgpu_gfx90a::v219, output_vec_len );
            case 476:  return makeRegisterExpression(amdgpu_gfx90a::v220, output_vec_len );
            case 477:  return makeRegisterExpression(amdgpu_gfx90a::v221, output_vec_len );
            case 478:  return makeRegisterExpression(amdgpu_gfx90a::v222, output_vec_len );
            case 479:  return makeRegisterExpression(amdgpu_gfx90a::v223, output_vec_len );
            case 480:  return makeRegisterExpression(amdgpu_gfx90a::v224, output_vec_len );
            case 481:  return makeRegisterExpression(amdgpu_gfx90a::v225, output_vec_len );
            case 482:  return makeRegisterExpression(amdgpu_gfx90a::v226, output_vec_len );
            case 483:  return makeRegisterExpression(amdgpu_gfx90a::v227, output_vec_len );
            case 484:  return makeRegisterExpression(amdgpu_gfx90a::v228, output_vec_len );
            case 485:  return makeRegisterExpression(amdgpu_gfx90a::v229, output_vec_len );
            case 486:  return makeRegisterExpression(amdgpu_gfx90a::v230, output_vec_len );
            case 487:  return makeRegisterExpression(amdgpu_gfx90a::v231, output_vec_len );
            case 488:  return makeRegisterExpression(amdgpu_gfx90a::v232, output_vec_len );
            case 489:  return makeRegisterExpression(amdgpu_gfx90a::v233, output_vec_len );
            case 490:  return makeRegisterExpression(amdgpu_gfx90a::v234, output_vec_len );
            case 491:  return makeRegisterExpression(amdgpu_gfx90a::v235, output_vec_len );
            case 492:  return makeRegisterExpression(amdgpu_gfx90a::v236, output_vec_len );
            case 493:  return makeRegisterExpression(amdgpu_gfx90a::v237, output_vec_len );
            case 494:  return makeRegisterExpression(amdgpu_gfx90a::v238, output_vec_len );
            case 495:  return makeRegisterExpression(amdgpu_gfx90a::v239, output_vec_len );
            case 496:  return makeRegisterExpression(amdgpu_gfx90a::v240, output_vec_len );
            case 497:  return makeRegisterExpression(amdgpu_gfx90a::v241, output_vec_len );
            case 498:  return makeRegisterExpression(amdgpu_gfx90a::v242, output_vec_len );
            case 499:  return makeRegisterExpression(amdgpu_gfx90a::v243, output_vec_len );
            case 500:  return makeRegisterExpression(amdgpu_gfx90a::v244, output_vec_len );
            case 501:  return makeRegisterExpression(amdgpu_gfx90a::v245, output_vec_len );
            case 502:  return makeRegisterExpression(amdgpu_gfx90a::v246, output_vec_len );
            case 503:  return makeRegisterExpression(amdgpu_gfx90a::v247, output_vec_len );
            case 504:  return makeRegisterExpression(amdgpu_gfx90a::v248, output_vec_len );
            case 505:  return makeRegisterExpression(amdgpu_gfx90a::v249, output_vec_len );
            case 506:  return makeRegisterExpression(amdgpu_gfx90a::v250, output_vec_len );
            case 507:  return makeRegisterExpression(amdgpu_gfx90a::v251, output_vec_len );
            case 508:  return makeRegisterExpression(amdgpu_gfx90a::v252, output_vec_len );
            case 509:  return makeRegisterExpression(amdgpu_gfx90a::v253, output_vec_len );
            case 510:  return makeRegisterExpression(amdgpu_gfx90a::v254, output_vec_len );
            case 511:  return makeRegisterExpression(amdgpu_gfx90a::v255, output_vec_len );
            default: return makeRegisterExpression(amdgpu_gfx90a::invalid);
        }
    }

    Expression::Ptr InstructionDecoder_amdgpu_gfx90a::decodeOPR_SRC_VGPR_OR_ACCVGPR(uint64_t input, uint32_t output_vec_len)
    {
        switch (input)  {
            case 256:  return makeRegisterExpression(amdgpu_gfx90a::v0, output_vec_len );
            case 257:  return makeRegisterExpression(amdgpu_gfx90a::v1, output_vec_len );
            case 258:  return makeRegisterExpression(amdgpu_gfx90a::v2, output_vec_len );
            case 259:  return makeRegisterExpression(amdgpu_gfx90a::v3, output_vec_len );
            case 260:  return makeRegisterExpression(amdgpu_gfx90a::v4, output_vec_len );
            case 261:  return makeRegisterExpression(amdgpu_gfx90a::v5, output_vec_len );
            case 262:  return makeRegisterExpression(amdgpu_gfx90a::v6, output_vec_len );
            case 263:  return makeRegisterExpression(amdgpu_gfx90a::v7, output_vec_len );
            case 264:  return makeRegisterExpression(amdgpu_gfx90a::v8, output_vec_len );
            case 265:  return makeRegisterExpression(amdgpu_gfx90a::v9, output_vec_len );
            case 266:  return makeRegisterExpression(amdgpu_gfx90a::v10, output_vec_len );
            case 267:  return makeRegisterExpression(amdgpu_gfx90a::v11, output_vec_len );
            case 268:  return makeRegisterExpression(amdgpu_gfx90a::v12, output_vec_len );
            case 269:  return makeRegisterExpression(amdgpu_gfx90a::v13, output_vec_len );
            case 270:  return makeRegisterExpression(amdgpu_gfx90a::v14, output_vec_len );
            case 271:  return makeRegisterExpression(amdgpu_gfx90a::v15, output_vec_len );
            case 272:  return makeRegisterExpression(amdgpu_gfx90a::v16, output_vec_len );
            case 273:  return makeRegisterExpression(amdgpu_gfx90a::v17, output_vec_len );
            case 274:  return makeRegisterExpression(amdgpu_gfx90a::v18, output_vec_len );
            case 275:  return makeRegisterExpression(amdgpu_gfx90a::v19, output_vec_len );
            case 276:  return makeRegisterExpression(amdgpu_gfx90a::v20, output_vec_len );
            case 277:  return makeRegisterExpression(amdgpu_gfx90a::v21, output_vec_len );
            case 278:  return makeRegisterExpression(amdgpu_gfx90a::v22, output_vec_len );
            case 279:  return makeRegisterExpression(amdgpu_gfx90a::v23, output_vec_len );
            case 280:  return makeRegisterExpression(amdgpu_gfx90a::v24, output_vec_len );
            case 281:  return makeRegisterExpression(amdgpu_gfx90a::v25, output_vec_len );
            case 282:  return makeRegisterExpression(amdgpu_gfx90a::v26, output_vec_len );
            case 283:  return makeRegisterExpression(amdgpu_gfx90a::v27, output_vec_len );
            case 284:  return makeRegisterExpression(amdgpu_gfx90a::v28, output_vec_len );
            case 285:  return makeRegisterExpression(amdgpu_gfx90a::v29, output_vec_len );
            case 286:  return makeRegisterExpression(amdgpu_gfx90a::v30, output_vec_len );
            case 287:  return makeRegisterExpression(amdgpu_gfx90a::v31, output_vec_len );
            case 288:  return makeRegisterExpression(amdgpu_gfx90a::v32, output_vec_len );
            case 289:  return makeRegisterExpression(amdgpu_gfx90a::v33, output_vec_len );
            case 290:  return makeRegisterExpression(amdgpu_gfx90a::v34, output_vec_len );
            case 291:  return makeRegisterExpression(amdgpu_gfx90a::v35, output_vec_len );
            case 292:  return makeRegisterExpression(amdgpu_gfx90a::v36, output_vec_len );
            case 293:  return makeRegisterExpression(amdgpu_gfx90a::v37, output_vec_len );
            case 294:  return makeRegisterExpression(amdgpu_gfx90a::v38, output_vec_len );
            case 295:  return makeRegisterExpression(amdgpu_gfx90a::v39, output_vec_len );
            case 296:  return makeRegisterExpression(amdgpu_gfx90a::v40, output_vec_len );
            case 297:  return makeRegisterExpression(amdgpu_gfx90a::v41, output_vec_len );
            case 298:  return makeRegisterExpression(amdgpu_gfx90a::v42, output_vec_len );
            case 299:  return makeRegisterExpression(amdgpu_gfx90a::v43, output_vec_len );
            case 300:  return makeRegisterExpression(amdgpu_gfx90a::v44, output_vec_len );
            case 301:  return makeRegisterExpression(amdgpu_gfx90a::v45, output_vec_len );
            case 302:  return makeRegisterExpression(amdgpu_gfx90a::v46, output_vec_len );
            case 303:  return makeRegisterExpression(amdgpu_gfx90a::v47, output_vec_len );
            case 304:  return makeRegisterExpression(amdgpu_gfx90a::v48, output_vec_len );
            case 305:  return makeRegisterExpression(amdgpu_gfx90a::v49, output_vec_len );
            case 306:  return makeRegisterExpression(amdgpu_gfx90a::v50, output_vec_len );
            case 307:  return makeRegisterExpression(amdgpu_gfx90a::v51, output_vec_len );
            case 308:  return makeRegisterExpression(amdgpu_gfx90a::v52, output_vec_len );
            case 309:  return makeRegisterExpression(amdgpu_gfx90a::v53, output_vec_len );
            case 310:  return makeRegisterExpression(amdgpu_gfx90a::v54, output_vec_len );
            case 311:  return makeRegisterExpression(amdgpu_gfx90a::v55, output_vec_len );
            case 312:  return makeRegisterExpression(amdgpu_gfx90a::v56, output_vec_len );
            case 313:  return makeRegisterExpression(amdgpu_gfx90a::v57, output_vec_len );
            case 314:  return makeRegisterExpression(amdgpu_gfx90a::v58, output_vec_len );
            case 315:  return makeRegisterExpression(amdgpu_gfx90a::v59, output_vec_len );
            case 316:  return makeRegisterExpression(amdgpu_gfx90a::v60, output_vec_len );
            case 317:  return makeRegisterExpression(amdgpu_gfx90a::v61, output_vec_len );
            case 318:  return makeRegisterExpression(amdgpu_gfx90a::v62, output_vec_len );
            case 319:  return makeRegisterExpression(amdgpu_gfx90a::v63, output_vec_len );
            case 320:  return makeRegisterExpression(amdgpu_gfx90a::v64, output_vec_len );
            case 321:  return makeRegisterExpression(amdgpu_gfx90a::v65, output_vec_len );
            case 322:  return makeRegisterExpression(amdgpu_gfx90a::v66, output_vec_len );
            case 323:  return makeRegisterExpression(amdgpu_gfx90a::v67, output_vec_len );
            case 324:  return makeRegisterExpression(amdgpu_gfx90a::v68, output_vec_len );
            case 325:  return makeRegisterExpression(amdgpu_gfx90a::v69, output_vec_len );
            case 326:  return makeRegisterExpression(amdgpu_gfx90a::v70, output_vec_len );
            case 327:  return makeRegisterExpression(amdgpu_gfx90a::v71, output_vec_len );
            case 328:  return makeRegisterExpression(amdgpu_gfx90a::v72, output_vec_len );
            case 329:  return makeRegisterExpression(amdgpu_gfx90a::v73, output_vec_len );
            case 330:  return makeRegisterExpression(amdgpu_gfx90a::v74, output_vec_len );
            case 331:  return makeRegisterExpression(amdgpu_gfx90a::v75, output_vec_len );
            case 332:  return makeRegisterExpression(amdgpu_gfx90a::v76, output_vec_len );
            case 333:  return makeRegisterExpression(amdgpu_gfx90a::v77, output_vec_len );
            case 334:  return makeRegisterExpression(amdgpu_gfx90a::v78, output_vec_len );
            case 335:  return makeRegisterExpression(amdgpu_gfx90a::v79, output_vec_len );
            case 336:  return makeRegisterExpression(amdgpu_gfx90a::v80, output_vec_len );
            case 337:  return makeRegisterExpression(amdgpu_gfx90a::v81, output_vec_len );
            case 338:  return makeRegisterExpression(amdgpu_gfx90a::v82, output_vec_len );
            case 339:  return makeRegisterExpression(amdgpu_gfx90a::v83, output_vec_len );
            case 340:  return makeRegisterExpression(amdgpu_gfx90a::v84, output_vec_len );
            case 341:  return makeRegisterExpression(amdgpu_gfx90a::v85, output_vec_len );
            case 342:  return makeRegisterExpression(amdgpu_gfx90a::v86, output_vec_len );
            case 343:  return makeRegisterExpression(amdgpu_gfx90a::v87, output_vec_len );
            case 344:  return makeRegisterExpression(amdgpu_gfx90a::v88, output_vec_len );
            case 345:  return makeRegisterExpression(amdgpu_gfx90a::v89, output_vec_len );
            case 346:  return makeRegisterExpression(amdgpu_gfx90a::v90, output_vec_len );
            case 347:  return makeRegisterExpression(amdgpu_gfx90a::v91, output_vec_len );
            case 348:  return makeRegisterExpression(amdgpu_gfx90a::v92, output_vec_len );
            case 349:  return makeRegisterExpression(amdgpu_gfx90a::v93, output_vec_len );
            case 350:  return makeRegisterExpression(amdgpu_gfx90a::v94, output_vec_len );
            case 351:  return makeRegisterExpression(amdgpu_gfx90a::v95, output_vec_len );
            case 352:  return makeRegisterExpression(amdgpu_gfx90a::v96, output_vec_len );
            case 353:  return makeRegisterExpression(amdgpu_gfx90a::v97, output_vec_len );
            case 354:  return makeRegisterExpression(amdgpu_gfx90a::v98, output_vec_len );
            case 355:  return makeRegisterExpression(amdgpu_gfx90a::v99, output_vec_len );
            case 356:  return makeRegisterExpression(amdgpu_gfx90a::v100, output_vec_len );
            case 357:  return makeRegisterExpression(amdgpu_gfx90a::v101, output_vec_len );
            case 358:  return makeRegisterExpression(amdgpu_gfx90a::v102, output_vec_len );
            case 359:  return makeRegisterExpression(amdgpu_gfx90a::v103, output_vec_len );
            case 360:  return makeRegisterExpression(amdgpu_gfx90a::v104, output_vec_len );
            case 361:  return makeRegisterExpression(amdgpu_gfx90a::v105, output_vec_len );
            case 362:  return makeRegisterExpression(amdgpu_gfx90a::v106, output_vec_len );
            case 363:  return makeRegisterExpression(amdgpu_gfx90a::v107, output_vec_len );
            case 364:  return makeRegisterExpression(amdgpu_gfx90a::v108, output_vec_len );
            case 365:  return makeRegisterExpression(amdgpu_gfx90a::v109, output_vec_len );
            case 366:  return makeRegisterExpression(amdgpu_gfx90a::v110, output_vec_len );
            case 367:  return makeRegisterExpression(amdgpu_gfx90a::v111, output_vec_len );
            case 368:  return makeRegisterExpression(amdgpu_gfx90a::v112, output_vec_len );
            case 369:  return makeRegisterExpression(amdgpu_gfx90a::v113, output_vec_len );
            case 370:  return makeRegisterExpression(amdgpu_gfx90a::v114, output_vec_len );
            case 371:  return makeRegisterExpression(amdgpu_gfx90a::v115, output_vec_len );
            case 372:  return makeRegisterExpression(amdgpu_gfx90a::v116, output_vec_len );
            case 373:  return makeRegisterExpression(amdgpu_gfx90a::v117, output_vec_len );
            case 374:  return makeRegisterExpression(amdgpu_gfx90a::v118, output_vec_len );
            case 375:  return makeRegisterExpression(amdgpu_gfx90a::v119, output_vec_len );
            case 376:  return makeRegisterExpression(amdgpu_gfx90a::v120, output_vec_len );
            case 377:  return makeRegisterExpression(amdgpu_gfx90a::v121, output_vec_len );
            case 378:  return makeRegisterExpression(amdgpu_gfx90a::v122, output_vec_len );
            case 379:  return makeRegisterExpression(amdgpu_gfx90a::v123, output_vec_len );
            case 380:  return makeRegisterExpression(amdgpu_gfx90a::v124, output_vec_len );
            case 381:  return makeRegisterExpression(amdgpu_gfx90a::v125, output_vec_len );
            case 382:  return makeRegisterExpression(amdgpu_gfx90a::v126, output_vec_len );
            case 383:  return makeRegisterExpression(amdgpu_gfx90a::v127, output_vec_len );
            case 384:  return makeRegisterExpression(amdgpu_gfx90a::v128, output_vec_len );
            case 385:  return makeRegisterExpression(amdgpu_gfx90a::v129, output_vec_len );
            case 386:  return makeRegisterExpression(amdgpu_gfx90a::v130, output_vec_len );
            case 387:  return makeRegisterExpression(amdgpu_gfx90a::v131, output_vec_len );
            case 388:  return makeRegisterExpression(amdgpu_gfx90a::v132, output_vec_len );
            case 389:  return makeRegisterExpression(amdgpu_gfx90a::v133, output_vec_len );
            case 390:  return makeRegisterExpression(amdgpu_gfx90a::v134, output_vec_len );
            case 391:  return makeRegisterExpression(amdgpu_gfx90a::v135, output_vec_len );
            case 392:  return makeRegisterExpression(amdgpu_gfx90a::v136, output_vec_len );
            case 393:  return makeRegisterExpression(amdgpu_gfx90a::v137, output_vec_len );
            case 394:  return makeRegisterExpression(amdgpu_gfx90a::v138, output_vec_len );
            case 395:  return makeRegisterExpression(amdgpu_gfx90a::v139, output_vec_len );
            case 396:  return makeRegisterExpression(amdgpu_gfx90a::v140, output_vec_len );
            case 397:  return makeRegisterExpression(amdgpu_gfx90a::v141, output_vec_len );
            case 398:  return makeRegisterExpression(amdgpu_gfx90a::v142, output_vec_len );
            case 399:  return makeRegisterExpression(amdgpu_gfx90a::v143, output_vec_len );
            case 400:  return makeRegisterExpression(amdgpu_gfx90a::v144, output_vec_len );
            case 401:  return makeRegisterExpression(amdgpu_gfx90a::v145, output_vec_len );
            case 402:  return makeRegisterExpression(amdgpu_gfx90a::v146, output_vec_len );
            case 403:  return makeRegisterExpression(amdgpu_gfx90a::v147, output_vec_len );
            case 404:  return makeRegisterExpression(amdgpu_gfx90a::v148, output_vec_len );
            case 405:  return makeRegisterExpression(amdgpu_gfx90a::v149, output_vec_len );
            case 406:  return makeRegisterExpression(amdgpu_gfx90a::v150, output_vec_len );
            case 407:  return makeRegisterExpression(amdgpu_gfx90a::v151, output_vec_len );
            case 408:  return makeRegisterExpression(amdgpu_gfx90a::v152, output_vec_len );
            case 409:  return makeRegisterExpression(amdgpu_gfx90a::v153, output_vec_len );
            case 410:  return makeRegisterExpression(amdgpu_gfx90a::v154, output_vec_len );
            case 411:  return makeRegisterExpression(amdgpu_gfx90a::v155, output_vec_len );
            case 412:  return makeRegisterExpression(amdgpu_gfx90a::v156, output_vec_len );
            case 413:  return makeRegisterExpression(amdgpu_gfx90a::v157, output_vec_len );
            case 414:  return makeRegisterExpression(amdgpu_gfx90a::v158, output_vec_len );
            case 415:  return makeRegisterExpression(amdgpu_gfx90a::v159, output_vec_len );
            case 416:  return makeRegisterExpression(amdgpu_gfx90a::v160, output_vec_len );
            case 417:  return makeRegisterExpression(amdgpu_gfx90a::v161, output_vec_len );
            case 418:  return makeRegisterExpression(amdgpu_gfx90a::v162, output_vec_len );
            case 419:  return makeRegisterExpression(amdgpu_gfx90a::v163, output_vec_len );
            case 420:  return makeRegisterExpression(amdgpu_gfx90a::v164, output_vec_len );
            case 421:  return makeRegisterExpression(amdgpu_gfx90a::v165, output_vec_len );
            case 422:  return makeRegisterExpression(amdgpu_gfx90a::v166, output_vec_len );
            case 423:  return makeRegisterExpression(amdgpu_gfx90a::v167, output_vec_len );
            case 424:  return makeRegisterExpression(amdgpu_gfx90a::v168, output_vec_len );
            case 425:  return makeRegisterExpression(amdgpu_gfx90a::v169, output_vec_len );
            case 426:  return makeRegisterExpression(amdgpu_gfx90a::v170, output_vec_len );
            case 427:  return makeRegisterExpression(amdgpu_gfx90a::v171, output_vec_len );
            case 428:  return makeRegisterExpression(amdgpu_gfx90a::v172, output_vec_len );
            case 429:  return makeRegisterExpression(amdgpu_gfx90a::v173, output_vec_len );
            case 430:  return makeRegisterExpression(amdgpu_gfx90a::v174, output_vec_len );
            case 431:  return makeRegisterExpression(amdgpu_gfx90a::v175, output_vec_len );
            case 432:  return makeRegisterExpression(amdgpu_gfx90a::v176, output_vec_len );
            case 433:  return makeRegisterExpression(amdgpu_gfx90a::v177, output_vec_len );
            case 434:  return makeRegisterExpression(amdgpu_gfx90a::v178, output_vec_len );
            case 435:  return makeRegisterExpression(amdgpu_gfx90a::v179, output_vec_len );
            case 436:  return makeRegisterExpression(amdgpu_gfx90a::v180, output_vec_len );
            case 437:  return makeRegisterExpression(amdgpu_gfx90a::v181, output_vec_len );
            case 438:  return makeRegisterExpression(amdgpu_gfx90a::v182, output_vec_len );
            case 439:  return makeRegisterExpression(amdgpu_gfx90a::v183, output_vec_len );
            case 440:  return makeRegisterExpression(amdgpu_gfx90a::v184, output_vec_len );
            case 441:  return makeRegisterExpression(amdgpu_gfx90a::v185, output_vec_len );
            case 442:  return makeRegisterExpression(amdgpu_gfx90a::v186, output_vec_len );
            case 443:  return makeRegisterExpression(amdgpu_gfx90a::v187, output_vec_len );
            case 444:  return makeRegisterExpression(amdgpu_gfx90a::v188, output_vec_len );
            case 445:  return makeRegisterExpression(amdgpu_gfx90a::v189, output_vec_len );
            case 446:  return makeRegisterExpression(amdgpu_gfx90a::v190, output_vec_len );
            case 447:  return makeRegisterExpression(amdgpu_gfx90a::v191, output_vec_len );
            case 448:  return makeRegisterExpression(amdgpu_gfx90a::v192, output_vec_len );
            case 449:  return makeRegisterExpression(amdgpu_gfx90a::v193, output_vec_len );
            case 450:  return makeRegisterExpression(amdgpu_gfx90a::v194, output_vec_len );
            case 451:  return makeRegisterExpression(amdgpu_gfx90a::v195, output_vec_len );
            case 452:  return makeRegisterExpression(amdgpu_gfx90a::v196, output_vec_len );
            case 453:  return makeRegisterExpression(amdgpu_gfx90a::v197, output_vec_len );
            case 454:  return makeRegisterExpression(amdgpu_gfx90a::v198, output_vec_len );
            case 455:  return makeRegisterExpression(amdgpu_gfx90a::v199, output_vec_len );
            case 456:  return makeRegisterExpression(amdgpu_gfx90a::v200, output_vec_len );
            case 457:  return makeRegisterExpression(amdgpu_gfx90a::v201, output_vec_len );
            case 458:  return makeRegisterExpression(amdgpu_gfx90a::v202, output_vec_len );
            case 459:  return makeRegisterExpression(amdgpu_gfx90a::v203, output_vec_len );
            case 460:  return makeRegisterExpression(amdgpu_gfx90a::v204, output_vec_len );
            case 461:  return makeRegisterExpression(amdgpu_gfx90a::v205, output_vec_len );
            case 462:  return makeRegisterExpression(amdgpu_gfx90a::v206, output_vec_len );
            case 463:  return makeRegisterExpression(amdgpu_gfx90a::v207, output_vec_len );
            case 464:  return makeRegisterExpression(amdgpu_gfx90a::v208, output_vec_len );
            case 465:  return makeRegisterExpression(amdgpu_gfx90a::v209, output_vec_len );
            case 466:  return makeRegisterExpression(amdgpu_gfx90a::v210, output_vec_len );
            case 467:  return makeRegisterExpression(amdgpu_gfx90a::v211, output_vec_len );
            case 468:  return makeRegisterExpression(amdgpu_gfx90a::v212, output_vec_len );
            case 469:  return makeRegisterExpression(amdgpu_gfx90a::v213, output_vec_len );
            case 470:  return makeRegisterExpression(amdgpu_gfx90a::v214, output_vec_len );
            case 471:  return makeRegisterExpression(amdgpu_gfx90a::v215, output_vec_len );
            case 472:  return makeRegisterExpression(amdgpu_gfx90a::v216, output_vec_len );
            case 473:  return makeRegisterExpression(amdgpu_gfx90a::v217, output_vec_len );
            case 474:  return makeRegisterExpression(amdgpu_gfx90a::v218, output_vec_len );
            case 475:  return makeRegisterExpression(amdgpu_gfx90a::v219, output_vec_len );
            case 476:  return makeRegisterExpression(amdgpu_gfx90a::v220, output_vec_len );
            case 477:  return makeRegisterExpression(amdgpu_gfx90a::v221, output_vec_len );
            case 478:  return makeRegisterExpression(amdgpu_gfx90a::v222, output_vec_len );
            case 479:  return makeRegisterExpression(amdgpu_gfx90a::v223, output_vec_len );
            case 480:  return makeRegisterExpression(amdgpu_gfx90a::v224, output_vec_len );
            case 481:  return makeRegisterExpression(amdgpu_gfx90a::v225, output_vec_len );
            case 482:  return makeRegisterExpression(amdgpu_gfx90a::v226, output_vec_len );
            case 483:  return makeRegisterExpression(amdgpu_gfx90a::v227, output_vec_len );
            case 484:  return makeRegisterExpression(amdgpu_gfx90a::v228, output_vec_len );
            case 485:  return makeRegisterExpression(amdgpu_gfx90a::v229, output_vec_len );
            case 486:  return makeRegisterExpression(amdgpu_gfx90a::v230, output_vec_len );
            case 487:  return makeRegisterExpression(amdgpu_gfx90a::v231, output_vec_len );
            case 488:  return makeRegisterExpression(amdgpu_gfx90a::v232, output_vec_len );
            case 489:  return makeRegisterExpression(amdgpu_gfx90a::v233, output_vec_len );
            case 490:  return makeRegisterExpression(amdgpu_gfx90a::v234, output_vec_len );
            case 491:  return makeRegisterExpression(amdgpu_gfx90a::v235, output_vec_len );
            case 492:  return makeRegisterExpression(amdgpu_gfx90a::v236, output_vec_len );
            case 493:  return makeRegisterExpression(amdgpu_gfx90a::v237, output_vec_len );
            case 494:  return makeRegisterExpression(amdgpu_gfx90a::v238, output_vec_len );
            case 495:  return makeRegisterExpression(amdgpu_gfx90a::v239, output_vec_len );
            case 496:  return makeRegisterExpression(amdgpu_gfx90a::v240, output_vec_len );
            case 497:  return makeRegisterExpression(amdgpu_gfx90a::v241, output_vec_len );
            case 498:  return makeRegisterExpression(amdgpu_gfx90a::v242, output_vec_len );
            case 499:  return makeRegisterExpression(amdgpu_gfx90a::v243, output_vec_len );
            case 500:  return makeRegisterExpression(amdgpu_gfx90a::v244, output_vec_len );
            case 501:  return makeRegisterExpression(amdgpu_gfx90a::v245, output_vec_len );
            case 502:  return makeRegisterExpression(amdgpu_gfx90a::v246, output_vec_len );
            case 503:  return makeRegisterExpression(amdgpu_gfx90a::v247, output_vec_len );
            case 504:  return makeRegisterExpression(amdgpu_gfx90a::v248, output_vec_len );
            case 505:  return makeRegisterExpression(amdgpu_gfx90a::v249, output_vec_len );
            case 506:  return makeRegisterExpression(amdgpu_gfx90a::v250, output_vec_len );
            case 507:  return makeRegisterExpression(amdgpu_gfx90a::v251, output_vec_len );
            case 508:  return makeRegisterExpression(amdgpu_gfx90a::v252, output_vec_len );
            case 509:  return makeRegisterExpression(amdgpu_gfx90a::v253, output_vec_len );
            case 510:  return makeRegisterExpression(amdgpu_gfx90a::v254, output_vec_len );
            case 511:  return makeRegisterExpression(amdgpu_gfx90a::v255, output_vec_len );
            case 768:  return makeRegisterExpression(amdgpu_gfx90a::acc0, output_vec_len );
            case 769:  return makeRegisterExpression(amdgpu_gfx90a::acc1, output_vec_len );
            case 770:  return makeRegisterExpression(amdgpu_gfx90a::acc2, output_vec_len );
            case 771:  return makeRegisterExpression(amdgpu_gfx90a::acc3, output_vec_len );
            case 772:  return makeRegisterExpression(amdgpu_gfx90a::acc4, output_vec_len );
            case 773:  return makeRegisterExpression(amdgpu_gfx90a::acc5, output_vec_len );
            case 774:  return makeRegisterExpression(amdgpu_gfx90a::acc6, output_vec_len );
            case 775:  return makeRegisterExpression(amdgpu_gfx90a::acc7, output_vec_len );
            case 776:  return makeRegisterExpression(amdgpu_gfx90a::acc8, output_vec_len );
            case 777:  return makeRegisterExpression(amdgpu_gfx90a::acc9, output_vec_len );
            case 778:  return makeRegisterExpression(amdgpu_gfx90a::acc10, output_vec_len );
            case 779:  return makeRegisterExpression(amdgpu_gfx90a::acc11, output_vec_len );
            case 780:  return makeRegisterExpression(amdgpu_gfx90a::acc12, output_vec_len );
            case 781:  return makeRegisterExpression(amdgpu_gfx90a::acc13, output_vec_len );
            case 782:  return makeRegisterExpression(amdgpu_gfx90a::acc14, output_vec_len );
            case 783:  return makeRegisterExpression(amdgpu_gfx90a::acc15, output_vec_len );
            case 784:  return makeRegisterExpression(amdgpu_gfx90a::acc16, output_vec_len );
            case 785:  return makeRegisterExpression(amdgpu_gfx90a::acc17, output_vec_len );
            case 786:  return makeRegisterExpression(amdgpu_gfx90a::acc18, output_vec_len );
            case 787:  return makeRegisterExpression(amdgpu_gfx90a::acc19, output_vec_len );
            case 788:  return makeRegisterExpression(amdgpu_gfx90a::acc20, output_vec_len );
            case 789:  return makeRegisterExpression(amdgpu_gfx90a::acc21, output_vec_len );
            case 790:  return makeRegisterExpression(amdgpu_gfx90a::acc22, output_vec_len );
            case 791:  return makeRegisterExpression(amdgpu_gfx90a::acc23, output_vec_len );
            case 792:  return makeRegisterExpression(amdgpu_gfx90a::acc24, output_vec_len );
            case 793:  return makeRegisterExpression(amdgpu_gfx90a::acc25, output_vec_len );
            case 794:  return makeRegisterExpression(amdgpu_gfx90a::acc26, output_vec_len );
            case 795:  return makeRegisterExpression(amdgpu_gfx90a::acc27, output_vec_len );
            case 796:  return makeRegisterExpression(amdgpu_gfx90a::acc28, output_vec_len );
            case 797:  return makeRegisterExpression(amdgpu_gfx90a::acc29, output_vec_len );
            case 798:  return makeRegisterExpression(amdgpu_gfx90a::acc30, output_vec_len );
            case 799:  return makeRegisterExpression(amdgpu_gfx90a::acc31, output_vec_len );
            case 800:  return makeRegisterExpression(amdgpu_gfx90a::acc32, output_vec_len );
            case 801:  return makeRegisterExpression(amdgpu_gfx90a::acc33, output_vec_len );
            case 802:  return makeRegisterExpression(amdgpu_gfx90a::acc34, output_vec_len );
            case 803:  return makeRegisterExpression(amdgpu_gfx90a::acc35, output_vec_len );
            case 804:  return makeRegisterExpression(amdgpu_gfx90a::acc36, output_vec_len );
            case 805:  return makeRegisterExpression(amdgpu_gfx90a::acc37, output_vec_len );
            case 806:  return makeRegisterExpression(amdgpu_gfx90a::acc38, output_vec_len );
            case 807:  return makeRegisterExpression(amdgpu_gfx90a::acc39, output_vec_len );
            case 808:  return makeRegisterExpression(amdgpu_gfx90a::acc40, output_vec_len );
            case 809:  return makeRegisterExpression(amdgpu_gfx90a::acc41, output_vec_len );
            case 810:  return makeRegisterExpression(amdgpu_gfx90a::acc42, output_vec_len );
            case 811:  return makeRegisterExpression(amdgpu_gfx90a::acc43, output_vec_len );
            case 812:  return makeRegisterExpression(amdgpu_gfx90a::acc44, output_vec_len );
            case 813:  return makeRegisterExpression(amdgpu_gfx90a::acc45, output_vec_len );
            case 814:  return makeRegisterExpression(amdgpu_gfx90a::acc46, output_vec_len );
            case 815:  return makeRegisterExpression(amdgpu_gfx90a::acc47, output_vec_len );
            case 816:  return makeRegisterExpression(amdgpu_gfx90a::acc48, output_vec_len );
            case 817:  return makeRegisterExpression(amdgpu_gfx90a::acc49, output_vec_len );
            case 818:  return makeRegisterExpression(amdgpu_gfx90a::acc50, output_vec_len );
            case 819:  return makeRegisterExpression(amdgpu_gfx90a::acc51, output_vec_len );
            case 820:  return makeRegisterExpression(amdgpu_gfx90a::acc52, output_vec_len );
            case 821:  return makeRegisterExpression(amdgpu_gfx90a::acc53, output_vec_len );
            case 822:  return makeRegisterExpression(amdgpu_gfx90a::acc54, output_vec_len );
            case 823:  return makeRegisterExpression(amdgpu_gfx90a::acc55, output_vec_len );
            case 824:  return makeRegisterExpression(amdgpu_gfx90a::acc56, output_vec_len );
            case 825:  return makeRegisterExpression(amdgpu_gfx90a::acc57, output_vec_len );
            case 826:  return makeRegisterExpression(amdgpu_gfx90a::acc58, output_vec_len );
            case 827:  return makeRegisterExpression(amdgpu_gfx90a::acc59, output_vec_len );
            case 828:  return makeRegisterExpression(amdgpu_gfx90a::acc60, output_vec_len );
            case 829:  return makeRegisterExpression(amdgpu_gfx90a::acc61, output_vec_len );
            case 830:  return makeRegisterExpression(amdgpu_gfx90a::acc62, output_vec_len );
            case 831:  return makeRegisterExpression(amdgpu_gfx90a::acc63, output_vec_len );
            case 832:  return makeRegisterExpression(amdgpu_gfx90a::acc64, output_vec_len );
            case 833:  return makeRegisterExpression(amdgpu_gfx90a::acc65, output_vec_len );
            case 834:  return makeRegisterExpression(amdgpu_gfx90a::acc66, output_vec_len );
            case 835:  return makeRegisterExpression(amdgpu_gfx90a::acc67, output_vec_len );
            case 836:  return makeRegisterExpression(amdgpu_gfx90a::acc68, output_vec_len );
            case 837:  return makeRegisterExpression(amdgpu_gfx90a::acc69, output_vec_len );
            case 838:  return makeRegisterExpression(amdgpu_gfx90a::acc70, output_vec_len );
            case 839:  return makeRegisterExpression(amdgpu_gfx90a::acc71, output_vec_len );
            case 840:  return makeRegisterExpression(amdgpu_gfx90a::acc72, output_vec_len );
            case 841:  return makeRegisterExpression(amdgpu_gfx90a::acc73, output_vec_len );
            case 842:  return makeRegisterExpression(amdgpu_gfx90a::acc74, output_vec_len );
            case 843:  return makeRegisterExpression(amdgpu_gfx90a::acc75, output_vec_len );
            case 844:  return makeRegisterExpression(amdgpu_gfx90a::acc76, output_vec_len );
            case 845:  return makeRegisterExpression(amdgpu_gfx90a::acc77, output_vec_len );
            case 846:  return makeRegisterExpression(amdgpu_gfx90a::acc78, output_vec_len );
            case 847:  return makeRegisterExpression(amdgpu_gfx90a::acc79, output_vec_len );
            case 848:  return makeRegisterExpression(amdgpu_gfx90a::acc80, output_vec_len );
            case 849:  return makeRegisterExpression(amdgpu_gfx90a::acc81, output_vec_len );
            case 850:  return makeRegisterExpression(amdgpu_gfx90a::acc82, output_vec_len );
            case 851:  return makeRegisterExpression(amdgpu_gfx90a::acc83, output_vec_len );
            case 852:  return makeRegisterExpression(amdgpu_gfx90a::acc84, output_vec_len );
            case 853:  return makeRegisterExpression(amdgpu_gfx90a::acc85, output_vec_len );
            case 854:  return makeRegisterExpression(amdgpu_gfx90a::acc86, output_vec_len );
            case 855:  return makeRegisterExpression(amdgpu_gfx90a::acc87, output_vec_len );
            case 856:  return makeRegisterExpression(amdgpu_gfx90a::acc88, output_vec_len );
            case 857:  return makeRegisterExpression(amdgpu_gfx90a::acc89, output_vec_len );
            case 858:  return makeRegisterExpression(amdgpu_gfx90a::acc90, output_vec_len );
            case 859:  return makeRegisterExpression(amdgpu_gfx90a::acc91, output_vec_len );
            case 860:  return makeRegisterExpression(amdgpu_gfx90a::acc92, output_vec_len );
            case 861:  return makeRegisterExpression(amdgpu_gfx90a::acc93, output_vec_len );
            case 862:  return makeRegisterExpression(amdgpu_gfx90a::acc94, output_vec_len );
            case 863:  return makeRegisterExpression(amdgpu_gfx90a::acc95, output_vec_len );
            case 864:  return makeRegisterExpression(amdgpu_gfx90a::acc96, output_vec_len );
            case 865:  return makeRegisterExpression(amdgpu_gfx90a::acc97, output_vec_len );
            case 866:  return makeRegisterExpression(amdgpu_gfx90a::acc98, output_vec_len );
            case 867:  return makeRegisterExpression(amdgpu_gfx90a::acc99, output_vec_len );
            case 868:  return makeRegisterExpression(amdgpu_gfx90a::acc100, output_vec_len );
            case 869:  return makeRegisterExpression(amdgpu_gfx90a::acc101, output_vec_len );
            case 870:  return makeRegisterExpression(amdgpu_gfx90a::acc102, output_vec_len );
            case 871:  return makeRegisterExpression(amdgpu_gfx90a::acc103, output_vec_len );
            case 872:  return makeRegisterExpression(amdgpu_gfx90a::acc104, output_vec_len );
            case 873:  return makeRegisterExpression(amdgpu_gfx90a::acc105, output_vec_len );
            case 874:  return makeRegisterExpression(amdgpu_gfx90a::acc106, output_vec_len );
            case 875:  return makeRegisterExpression(amdgpu_gfx90a::acc107, output_vec_len );
            case 876:  return makeRegisterExpression(amdgpu_gfx90a::acc108, output_vec_len );
            case 877:  return makeRegisterExpression(amdgpu_gfx90a::acc109, output_vec_len );
            case 878:  return makeRegisterExpression(amdgpu_gfx90a::acc110, output_vec_len );
            case 879:  return makeRegisterExpression(amdgpu_gfx90a::acc111, output_vec_len );
            case 880:  return makeRegisterExpression(amdgpu_gfx90a::acc112, output_vec_len );
            case 881:  return makeRegisterExpression(amdgpu_gfx90a::acc113, output_vec_len );
            case 882:  return makeRegisterExpression(amdgpu_gfx90a::acc114, output_vec_len );
            case 883:  return makeRegisterExpression(amdgpu_gfx90a::acc115, output_vec_len );
            case 884:  return makeRegisterExpression(amdgpu_gfx90a::acc116, output_vec_len );
            case 885:  return makeRegisterExpression(amdgpu_gfx90a::acc117, output_vec_len );
            case 886:  return makeRegisterExpression(amdgpu_gfx90a::acc118, output_vec_len );
            case 887:  return makeRegisterExpression(amdgpu_gfx90a::acc119, output_vec_len );
            case 888:  return makeRegisterExpression(amdgpu_gfx90a::acc120, output_vec_len );
            case 889:  return makeRegisterExpression(amdgpu_gfx90a::acc121, output_vec_len );
            case 890:  return makeRegisterExpression(amdgpu_gfx90a::acc122, output_vec_len );
            case 891:  return makeRegisterExpression(amdgpu_gfx90a::acc123, output_vec_len );
            case 892:  return makeRegisterExpression(amdgpu_gfx90a::acc124, output_vec_len );
            case 893:  return makeRegisterExpression(amdgpu_gfx90a::acc125, output_vec_len );
            case 894:  return makeRegisterExpression(amdgpu_gfx90a::acc126, output_vec_len );
            case 895:  return makeRegisterExpression(amdgpu_gfx90a::acc127, output_vec_len );
            case 896:  return makeRegisterExpression(amdgpu_gfx90a::acc128, output_vec_len );
            case 897:  return makeRegisterExpression(amdgpu_gfx90a::acc129, output_vec_len );
            case 898:  return makeRegisterExpression(amdgpu_gfx90a::acc130, output_vec_len );
            case 899:  return makeRegisterExpression(amdgpu_gfx90a::acc131, output_vec_len );
            case 900:  return makeRegisterExpression(amdgpu_gfx90a::acc132, output_vec_len );
            case 901:  return makeRegisterExpression(amdgpu_gfx90a::acc133, output_vec_len );
            case 902:  return makeRegisterExpression(amdgpu_gfx90a::acc134, output_vec_len );
            case 903:  return makeRegisterExpression(amdgpu_gfx90a::acc135, output_vec_len );
            case 904:  return makeRegisterExpression(amdgpu_gfx90a::acc136, output_vec_len );
            case 905:  return makeRegisterExpression(amdgpu_gfx90a::acc137, output_vec_len );
            case 906:  return makeRegisterExpression(amdgpu_gfx90a::acc138, output_vec_len );
            case 907:  return makeRegisterExpression(amdgpu_gfx90a::acc139, output_vec_len );
            case 908:  return makeRegisterExpression(amdgpu_gfx90a::acc140, output_vec_len );
            case 909:  return makeRegisterExpression(amdgpu_gfx90a::acc141, output_vec_len );
            case 910:  return makeRegisterExpression(amdgpu_gfx90a::acc142, output_vec_len );
            case 911:  return makeRegisterExpression(amdgpu_gfx90a::acc143, output_vec_len );
            case 912:  return makeRegisterExpression(amdgpu_gfx90a::acc144, output_vec_len );
            case 913:  return makeRegisterExpression(amdgpu_gfx90a::acc145, output_vec_len );
            case 914:  return makeRegisterExpression(amdgpu_gfx90a::acc146, output_vec_len );
            case 915:  return makeRegisterExpression(amdgpu_gfx90a::acc147, output_vec_len );
            case 916:  return makeRegisterExpression(amdgpu_gfx90a::acc148, output_vec_len );
            case 917:  return makeRegisterExpression(amdgpu_gfx90a::acc149, output_vec_len );
            case 918:  return makeRegisterExpression(amdgpu_gfx90a::acc150, output_vec_len );
            case 919:  return makeRegisterExpression(amdgpu_gfx90a::acc151, output_vec_len );
            case 920:  return makeRegisterExpression(amdgpu_gfx90a::acc152, output_vec_len );
            case 921:  return makeRegisterExpression(amdgpu_gfx90a::acc153, output_vec_len );
            case 922:  return makeRegisterExpression(amdgpu_gfx90a::acc154, output_vec_len );
            case 923:  return makeRegisterExpression(amdgpu_gfx90a::acc155, output_vec_len );
            case 924:  return makeRegisterExpression(amdgpu_gfx90a::acc156, output_vec_len );
            case 925:  return makeRegisterExpression(amdgpu_gfx90a::acc157, output_vec_len );
            case 926:  return makeRegisterExpression(amdgpu_gfx90a::acc158, output_vec_len );
            case 927:  return makeRegisterExpression(amdgpu_gfx90a::acc159, output_vec_len );
            case 928:  return makeRegisterExpression(amdgpu_gfx90a::acc160, output_vec_len );
            case 929:  return makeRegisterExpression(amdgpu_gfx90a::acc161, output_vec_len );
            case 930:  return makeRegisterExpression(amdgpu_gfx90a::acc162, output_vec_len );
            case 931:  return makeRegisterExpression(amdgpu_gfx90a::acc163, output_vec_len );
            case 932:  return makeRegisterExpression(amdgpu_gfx90a::acc164, output_vec_len );
            case 933:  return makeRegisterExpression(amdgpu_gfx90a::acc165, output_vec_len );
            case 934:  return makeRegisterExpression(amdgpu_gfx90a::acc166, output_vec_len );
            case 935:  return makeRegisterExpression(amdgpu_gfx90a::acc167, output_vec_len );
            case 936:  return makeRegisterExpression(amdgpu_gfx90a::acc168, output_vec_len );
            case 937:  return makeRegisterExpression(amdgpu_gfx90a::acc169, output_vec_len );
            case 938:  return makeRegisterExpression(amdgpu_gfx90a::acc170, output_vec_len );
            case 939:  return makeRegisterExpression(amdgpu_gfx90a::acc171, output_vec_len );
            case 940:  return makeRegisterExpression(amdgpu_gfx90a::acc172, output_vec_len );
            case 941:  return makeRegisterExpression(amdgpu_gfx90a::acc173, output_vec_len );
            case 942:  return makeRegisterExpression(amdgpu_gfx90a::acc174, output_vec_len );
            case 943:  return makeRegisterExpression(amdgpu_gfx90a::acc175, output_vec_len );
            case 944:  return makeRegisterExpression(amdgpu_gfx90a::acc176, output_vec_len );
            case 945:  return makeRegisterExpression(amdgpu_gfx90a::acc177, output_vec_len );
            case 946:  return makeRegisterExpression(amdgpu_gfx90a::acc178, output_vec_len );
            case 947:  return makeRegisterExpression(amdgpu_gfx90a::acc179, output_vec_len );
            case 948:  return makeRegisterExpression(amdgpu_gfx90a::acc180, output_vec_len );
            case 949:  return makeRegisterExpression(amdgpu_gfx90a::acc181, output_vec_len );
            case 950:  return makeRegisterExpression(amdgpu_gfx90a::acc182, output_vec_len );
            case 951:  return makeRegisterExpression(amdgpu_gfx90a::acc183, output_vec_len );
            case 952:  return makeRegisterExpression(amdgpu_gfx90a::acc184, output_vec_len );
            case 953:  return makeRegisterExpression(amdgpu_gfx90a::acc185, output_vec_len );
            case 954:  return makeRegisterExpression(amdgpu_gfx90a::acc186, output_vec_len );
            case 955:  return makeRegisterExpression(amdgpu_gfx90a::acc187, output_vec_len );
            case 956:  return makeRegisterExpression(amdgpu_gfx90a::acc188, output_vec_len );
            case 957:  return makeRegisterExpression(amdgpu_gfx90a::acc189, output_vec_len );
            case 958:  return makeRegisterExpression(amdgpu_gfx90a::acc190, output_vec_len );
            case 959:  return makeRegisterExpression(amdgpu_gfx90a::acc191, output_vec_len );
            case 960:  return makeRegisterExpression(amdgpu_gfx90a::acc192, output_vec_len );
            case 961:  return makeRegisterExpression(amdgpu_gfx90a::acc193, output_vec_len );
            case 962:  return makeRegisterExpression(amdgpu_gfx90a::acc194, output_vec_len );
            case 963:  return makeRegisterExpression(amdgpu_gfx90a::acc195, output_vec_len );
            case 964:  return makeRegisterExpression(amdgpu_gfx90a::acc196, output_vec_len );
            case 965:  return makeRegisterExpression(amdgpu_gfx90a::acc197, output_vec_len );
            case 966:  return makeRegisterExpression(amdgpu_gfx90a::acc198, output_vec_len );
            case 967:  return makeRegisterExpression(amdgpu_gfx90a::acc199, output_vec_len );
            case 968:  return makeRegisterExpression(amdgpu_gfx90a::acc200, output_vec_len );
            case 969:  return makeRegisterExpression(amdgpu_gfx90a::acc201, output_vec_len );
            case 970:  return makeRegisterExpression(amdgpu_gfx90a::acc202, output_vec_len );
            case 971:  return makeRegisterExpression(amdgpu_gfx90a::acc203, output_vec_len );
            case 972:  return makeRegisterExpression(amdgpu_gfx90a::acc204, output_vec_len );
            case 973:  return makeRegisterExpression(amdgpu_gfx90a::acc205, output_vec_len );
            case 974:  return makeRegisterExpression(amdgpu_gfx90a::acc206, output_vec_len );
            case 975:  return makeRegisterExpression(amdgpu_gfx90a::acc207, output_vec_len );
            case 976:  return makeRegisterExpression(amdgpu_gfx90a::acc208, output_vec_len );
            case 977:  return makeRegisterExpression(amdgpu_gfx90a::acc209, output_vec_len );
            case 978:  return makeRegisterExpression(amdgpu_gfx90a::acc210, output_vec_len );
            case 979:  return makeRegisterExpression(amdgpu_gfx90a::acc211, output_vec_len );
            case 980:  return makeRegisterExpression(amdgpu_gfx90a::acc212, output_vec_len );
            case 981:  return makeRegisterExpression(amdgpu_gfx90a::acc213, output_vec_len );
            case 982:  return makeRegisterExpression(amdgpu_gfx90a::acc214, output_vec_len );
            case 983:  return makeRegisterExpression(amdgpu_gfx90a::acc215, output_vec_len );
            case 984:  return makeRegisterExpression(amdgpu_gfx90a::acc216, output_vec_len );
            case 985:  return makeRegisterExpression(amdgpu_gfx90a::acc217, output_vec_len );
            case 986:  return makeRegisterExpression(amdgpu_gfx90a::acc218, output_vec_len );
            case 987:  return makeRegisterExpression(amdgpu_gfx90a::acc219, output_vec_len );
            case 988:  return makeRegisterExpression(amdgpu_gfx90a::acc220, output_vec_len );
            case 989:  return makeRegisterExpression(amdgpu_gfx90a::acc221, output_vec_len );
            case 990:  return makeRegisterExpression(amdgpu_gfx90a::acc222, output_vec_len );
            case 991:  return makeRegisterExpression(amdgpu_gfx90a::acc223, output_vec_len );
            case 992:  return makeRegisterExpression(amdgpu_gfx90a::acc224, output_vec_len );
            case 993:  return makeRegisterExpression(amdgpu_gfx90a::acc225, output_vec_len );
            case 994:  return makeRegisterExpression(amdgpu_gfx90a::acc226, output_vec_len );
            case 995:  return makeRegisterExpression(amdgpu_gfx90a::acc227, output_vec_len );
            case 996:  return makeRegisterExpression(amdgpu_gfx90a::acc228, output_vec_len );
            case 997:  return makeRegisterExpression(amdgpu_gfx90a::acc229, output_vec_len );
            case 998:  return makeRegisterExpression(amdgpu_gfx90a::acc230, output_vec_len );
            case 999:  return makeRegisterExpression(amdgpu_gfx90a::acc231, output_vec_len );
            case 1000:  return makeRegisterExpression(amdgpu_gfx90a::acc232, output_vec_len );
            case 1001:  return makeRegisterExpression(amdgpu_gfx90a::acc233, output_vec_len );
            case 1002:  return makeRegisterExpression(amdgpu_gfx90a::acc234, output_vec_len );
            case 1003:  return makeRegisterExpression(amdgpu_gfx90a::acc235, output_vec_len );
            case 1004:  return makeRegisterExpression(amdgpu_gfx90a::acc236, output_vec_len );
            case 1005:  return makeRegisterExpression(amdgpu_gfx90a::acc237, output_vec_len );
            case 1006:  return makeRegisterExpression(amdgpu_gfx90a::acc238, output_vec_len );
            case 1007:  return makeRegisterExpression(amdgpu_gfx90a::acc239, output_vec_len );
            case 1008:  return makeRegisterExpression(amdgpu_gfx90a::acc240, output_vec_len );
            case 1009:  return makeRegisterExpression(amdgpu_gfx90a::acc241, output_vec_len );
            case 1010:  return makeRegisterExpression(amdgpu_gfx90a::acc242, output_vec_len );
            case 1011:  return makeRegisterExpression(amdgpu_gfx90a::acc243, output_vec_len );
            case 1012:  return makeRegisterExpression(amdgpu_gfx90a::acc244, output_vec_len );
            case 1013:  return makeRegisterExpression(amdgpu_gfx90a::acc245, output_vec_len );
            case 1014:  return makeRegisterExpression(amdgpu_gfx90a::acc246, output_vec_len );
            case 1015:  return makeRegisterExpression(amdgpu_gfx90a::acc247, output_vec_len );
            case 1016:  return makeRegisterExpression(amdgpu_gfx90a::acc248, output_vec_len );
            case 1017:  return makeRegisterExpression(amdgpu_gfx90a::acc249, output_vec_len );
            case 1018:  return makeRegisterExpression(amdgpu_gfx90a::acc250, output_vec_len );
            case 1019:  return makeRegisterExpression(amdgpu_gfx90a::acc251, output_vec_len );
            case 1020:  return makeRegisterExpression(amdgpu_gfx90a::acc252, output_vec_len );
            case 1021:  return makeRegisterExpression(amdgpu_gfx90a::acc253, output_vec_len );
            case 1022:  return makeRegisterExpression(amdgpu_gfx90a::acc254, output_vec_len );
            case 1023:  return makeRegisterExpression(amdgpu_gfx90a::acc255, output_vec_len );
            default: return makeRegisterExpression(amdgpu_gfx90a::invalid);
        }
    }

    Expression::Ptr InstructionDecoder_amdgpu_gfx90a::decodeOPR_SRC_VGPR_OR_ACCVGPR_OR_CONST(uint64_t input, uint32_t output_vec_len)
    {
        switch (input)  {
            case 256:  return makeRegisterExpression(amdgpu_gfx90a::v0, output_vec_len );
            case 257:  return makeRegisterExpression(amdgpu_gfx90a::v1, output_vec_len );
            case 258:  return makeRegisterExpression(amdgpu_gfx90a::v2, output_vec_len );
            case 259:  return makeRegisterExpression(amdgpu_gfx90a::v3, output_vec_len );
            case 260:  return makeRegisterExpression(amdgpu_gfx90a::v4, output_vec_len );
            case 261:  return makeRegisterExpression(amdgpu_gfx90a::v5, output_vec_len );
            case 262:  return makeRegisterExpression(amdgpu_gfx90a::v6, output_vec_len );
            case 263:  return makeRegisterExpression(amdgpu_gfx90a::v7, output_vec_len );
            case 264:  return makeRegisterExpression(amdgpu_gfx90a::v8, output_vec_len );
            case 265:  return makeRegisterExpression(amdgpu_gfx90a::v9, output_vec_len );
            case 266:  return makeRegisterExpression(amdgpu_gfx90a::v10, output_vec_len );
            case 267:  return makeRegisterExpression(amdgpu_gfx90a::v11, output_vec_len );
            case 268:  return makeRegisterExpression(amdgpu_gfx90a::v12, output_vec_len );
            case 269:  return makeRegisterExpression(amdgpu_gfx90a::v13, output_vec_len );
            case 270:  return makeRegisterExpression(amdgpu_gfx90a::v14, output_vec_len );
            case 271:  return makeRegisterExpression(amdgpu_gfx90a::v15, output_vec_len );
            case 272:  return makeRegisterExpression(amdgpu_gfx90a::v16, output_vec_len );
            case 273:  return makeRegisterExpression(amdgpu_gfx90a::v17, output_vec_len );
            case 274:  return makeRegisterExpression(amdgpu_gfx90a::v18, output_vec_len );
            case 275:  return makeRegisterExpression(amdgpu_gfx90a::v19, output_vec_len );
            case 276:  return makeRegisterExpression(amdgpu_gfx90a::v20, output_vec_len );
            case 277:  return makeRegisterExpression(amdgpu_gfx90a::v21, output_vec_len );
            case 278:  return makeRegisterExpression(amdgpu_gfx90a::v22, output_vec_len );
            case 279:  return makeRegisterExpression(amdgpu_gfx90a::v23, output_vec_len );
            case 280:  return makeRegisterExpression(amdgpu_gfx90a::v24, output_vec_len );
            case 281:  return makeRegisterExpression(amdgpu_gfx90a::v25, output_vec_len );
            case 282:  return makeRegisterExpression(amdgpu_gfx90a::v26, output_vec_len );
            case 283:  return makeRegisterExpression(amdgpu_gfx90a::v27, output_vec_len );
            case 284:  return makeRegisterExpression(amdgpu_gfx90a::v28, output_vec_len );
            case 285:  return makeRegisterExpression(amdgpu_gfx90a::v29, output_vec_len );
            case 286:  return makeRegisterExpression(amdgpu_gfx90a::v30, output_vec_len );
            case 287:  return makeRegisterExpression(amdgpu_gfx90a::v31, output_vec_len );
            case 288:  return makeRegisterExpression(amdgpu_gfx90a::v32, output_vec_len );
            case 289:  return makeRegisterExpression(amdgpu_gfx90a::v33, output_vec_len );
            case 290:  return makeRegisterExpression(amdgpu_gfx90a::v34, output_vec_len );
            case 291:  return makeRegisterExpression(amdgpu_gfx90a::v35, output_vec_len );
            case 292:  return makeRegisterExpression(amdgpu_gfx90a::v36, output_vec_len );
            case 293:  return makeRegisterExpression(amdgpu_gfx90a::v37, output_vec_len );
            case 294:  return makeRegisterExpression(amdgpu_gfx90a::v38, output_vec_len );
            case 295:  return makeRegisterExpression(amdgpu_gfx90a::v39, output_vec_len );
            case 296:  return makeRegisterExpression(amdgpu_gfx90a::v40, output_vec_len );
            case 297:  return makeRegisterExpression(amdgpu_gfx90a::v41, output_vec_len );
            case 298:  return makeRegisterExpression(amdgpu_gfx90a::v42, output_vec_len );
            case 299:  return makeRegisterExpression(amdgpu_gfx90a::v43, output_vec_len );
            case 300:  return makeRegisterExpression(amdgpu_gfx90a::v44, output_vec_len );
            case 301:  return makeRegisterExpression(amdgpu_gfx90a::v45, output_vec_len );
            case 302:  return makeRegisterExpression(amdgpu_gfx90a::v46, output_vec_len );
            case 303:  return makeRegisterExpression(amdgpu_gfx90a::v47, output_vec_len );
            case 304:  return makeRegisterExpression(amdgpu_gfx90a::v48, output_vec_len );
            case 305:  return makeRegisterExpression(amdgpu_gfx90a::v49, output_vec_len );
            case 306:  return makeRegisterExpression(amdgpu_gfx90a::v50, output_vec_len );
            case 307:  return makeRegisterExpression(amdgpu_gfx90a::v51, output_vec_len );
            case 308:  return makeRegisterExpression(amdgpu_gfx90a::v52, output_vec_len );
            case 309:  return makeRegisterExpression(amdgpu_gfx90a::v53, output_vec_len );
            case 310:  return makeRegisterExpression(amdgpu_gfx90a::v54, output_vec_len );
            case 311:  return makeRegisterExpression(amdgpu_gfx90a::v55, output_vec_len );
            case 312:  return makeRegisterExpression(amdgpu_gfx90a::v56, output_vec_len );
            case 313:  return makeRegisterExpression(amdgpu_gfx90a::v57, output_vec_len );
            case 314:  return makeRegisterExpression(amdgpu_gfx90a::v58, output_vec_len );
            case 315:  return makeRegisterExpression(amdgpu_gfx90a::v59, output_vec_len );
            case 316:  return makeRegisterExpression(amdgpu_gfx90a::v60, output_vec_len );
            case 317:  return makeRegisterExpression(amdgpu_gfx90a::v61, output_vec_len );
            case 318:  return makeRegisterExpression(amdgpu_gfx90a::v62, output_vec_len );
            case 319:  return makeRegisterExpression(amdgpu_gfx90a::v63, output_vec_len );
            case 320:  return makeRegisterExpression(amdgpu_gfx90a::v64, output_vec_len );
            case 321:  return makeRegisterExpression(amdgpu_gfx90a::v65, output_vec_len );
            case 322:  return makeRegisterExpression(amdgpu_gfx90a::v66, output_vec_len );
            case 323:  return makeRegisterExpression(amdgpu_gfx90a::v67, output_vec_len );
            case 324:  return makeRegisterExpression(amdgpu_gfx90a::v68, output_vec_len );
            case 325:  return makeRegisterExpression(amdgpu_gfx90a::v69, output_vec_len );
            case 326:  return makeRegisterExpression(amdgpu_gfx90a::v70, output_vec_len );
            case 327:  return makeRegisterExpression(amdgpu_gfx90a::v71, output_vec_len );
            case 328:  return makeRegisterExpression(amdgpu_gfx90a::v72, output_vec_len );
            case 329:  return makeRegisterExpression(amdgpu_gfx90a::v73, output_vec_len );
            case 330:  return makeRegisterExpression(amdgpu_gfx90a::v74, output_vec_len );
            case 331:  return makeRegisterExpression(amdgpu_gfx90a::v75, output_vec_len );
            case 332:  return makeRegisterExpression(amdgpu_gfx90a::v76, output_vec_len );
            case 333:  return makeRegisterExpression(amdgpu_gfx90a::v77, output_vec_len );
            case 334:  return makeRegisterExpression(amdgpu_gfx90a::v78, output_vec_len );
            case 335:  return makeRegisterExpression(amdgpu_gfx90a::v79, output_vec_len );
            case 336:  return makeRegisterExpression(amdgpu_gfx90a::v80, output_vec_len );
            case 337:  return makeRegisterExpression(amdgpu_gfx90a::v81, output_vec_len );
            case 338:  return makeRegisterExpression(amdgpu_gfx90a::v82, output_vec_len );
            case 339:  return makeRegisterExpression(amdgpu_gfx90a::v83, output_vec_len );
            case 340:  return makeRegisterExpression(amdgpu_gfx90a::v84, output_vec_len );
            case 341:  return makeRegisterExpression(amdgpu_gfx90a::v85, output_vec_len );
            case 342:  return makeRegisterExpression(amdgpu_gfx90a::v86, output_vec_len );
            case 343:  return makeRegisterExpression(amdgpu_gfx90a::v87, output_vec_len );
            case 344:  return makeRegisterExpression(amdgpu_gfx90a::v88, output_vec_len );
            case 345:  return makeRegisterExpression(amdgpu_gfx90a::v89, output_vec_len );
            case 346:  return makeRegisterExpression(amdgpu_gfx90a::v90, output_vec_len );
            case 347:  return makeRegisterExpression(amdgpu_gfx90a::v91, output_vec_len );
            case 348:  return makeRegisterExpression(amdgpu_gfx90a::v92, output_vec_len );
            case 349:  return makeRegisterExpression(amdgpu_gfx90a::v93, output_vec_len );
            case 350:  return makeRegisterExpression(amdgpu_gfx90a::v94, output_vec_len );
            case 351:  return makeRegisterExpression(amdgpu_gfx90a::v95, output_vec_len );
            case 352:  return makeRegisterExpression(amdgpu_gfx90a::v96, output_vec_len );
            case 353:  return makeRegisterExpression(amdgpu_gfx90a::v97, output_vec_len );
            case 354:  return makeRegisterExpression(amdgpu_gfx90a::v98, output_vec_len );
            case 355:  return makeRegisterExpression(amdgpu_gfx90a::v99, output_vec_len );
            case 356:  return makeRegisterExpression(amdgpu_gfx90a::v100, output_vec_len );
            case 357:  return makeRegisterExpression(amdgpu_gfx90a::v101, output_vec_len );
            case 358:  return makeRegisterExpression(amdgpu_gfx90a::v102, output_vec_len );
            case 359:  return makeRegisterExpression(amdgpu_gfx90a::v103, output_vec_len );
            case 360:  return makeRegisterExpression(amdgpu_gfx90a::v104, output_vec_len );
            case 361:  return makeRegisterExpression(amdgpu_gfx90a::v105, output_vec_len );
            case 362:  return makeRegisterExpression(amdgpu_gfx90a::v106, output_vec_len );
            case 363:  return makeRegisterExpression(amdgpu_gfx90a::v107, output_vec_len );
            case 364:  return makeRegisterExpression(amdgpu_gfx90a::v108, output_vec_len );
            case 365:  return makeRegisterExpression(amdgpu_gfx90a::v109, output_vec_len );
            case 366:  return makeRegisterExpression(amdgpu_gfx90a::v110, output_vec_len );
            case 367:  return makeRegisterExpression(amdgpu_gfx90a::v111, output_vec_len );
            case 368:  return makeRegisterExpression(amdgpu_gfx90a::v112, output_vec_len );
            case 369:  return makeRegisterExpression(amdgpu_gfx90a::v113, output_vec_len );
            case 370:  return makeRegisterExpression(amdgpu_gfx90a::v114, output_vec_len );
            case 371:  return makeRegisterExpression(amdgpu_gfx90a::v115, output_vec_len );
            case 372:  return makeRegisterExpression(amdgpu_gfx90a::v116, output_vec_len );
            case 373:  return makeRegisterExpression(amdgpu_gfx90a::v117, output_vec_len );
            case 374:  return makeRegisterExpression(amdgpu_gfx90a::v118, output_vec_len );
            case 375:  return makeRegisterExpression(amdgpu_gfx90a::v119, output_vec_len );
            case 376:  return makeRegisterExpression(amdgpu_gfx90a::v120, output_vec_len );
            case 377:  return makeRegisterExpression(amdgpu_gfx90a::v121, output_vec_len );
            case 378:  return makeRegisterExpression(amdgpu_gfx90a::v122, output_vec_len );
            case 379:  return makeRegisterExpression(amdgpu_gfx90a::v123, output_vec_len );
            case 380:  return makeRegisterExpression(amdgpu_gfx90a::v124, output_vec_len );
            case 381:  return makeRegisterExpression(amdgpu_gfx90a::v125, output_vec_len );
            case 382:  return makeRegisterExpression(amdgpu_gfx90a::v126, output_vec_len );
            case 383:  return makeRegisterExpression(amdgpu_gfx90a::v127, output_vec_len );
            case 384:  return makeRegisterExpression(amdgpu_gfx90a::v128, output_vec_len );
            case 385:  return makeRegisterExpression(amdgpu_gfx90a::v129, output_vec_len );
            case 386:  return makeRegisterExpression(amdgpu_gfx90a::v130, output_vec_len );
            case 387:  return makeRegisterExpression(amdgpu_gfx90a::v131, output_vec_len );
            case 388:  return makeRegisterExpression(amdgpu_gfx90a::v132, output_vec_len );
            case 389:  return makeRegisterExpression(amdgpu_gfx90a::v133, output_vec_len );
            case 390:  return makeRegisterExpression(amdgpu_gfx90a::v134, output_vec_len );
            case 391:  return makeRegisterExpression(amdgpu_gfx90a::v135, output_vec_len );
            case 392:  return makeRegisterExpression(amdgpu_gfx90a::v136, output_vec_len );
            case 393:  return makeRegisterExpression(amdgpu_gfx90a::v137, output_vec_len );
            case 394:  return makeRegisterExpression(amdgpu_gfx90a::v138, output_vec_len );
            case 395:  return makeRegisterExpression(amdgpu_gfx90a::v139, output_vec_len );
            case 396:  return makeRegisterExpression(amdgpu_gfx90a::v140, output_vec_len );
            case 397:  return makeRegisterExpression(amdgpu_gfx90a::v141, output_vec_len );
            case 398:  return makeRegisterExpression(amdgpu_gfx90a::v142, output_vec_len );
            case 399:  return makeRegisterExpression(amdgpu_gfx90a::v143, output_vec_len );
            case 400:  return makeRegisterExpression(amdgpu_gfx90a::v144, output_vec_len );
            case 401:  return makeRegisterExpression(amdgpu_gfx90a::v145, output_vec_len );
            case 402:  return makeRegisterExpression(amdgpu_gfx90a::v146, output_vec_len );
            case 403:  return makeRegisterExpression(amdgpu_gfx90a::v147, output_vec_len );
            case 404:  return makeRegisterExpression(amdgpu_gfx90a::v148, output_vec_len );
            case 405:  return makeRegisterExpression(amdgpu_gfx90a::v149, output_vec_len );
            case 406:  return makeRegisterExpression(amdgpu_gfx90a::v150, output_vec_len );
            case 407:  return makeRegisterExpression(amdgpu_gfx90a::v151, output_vec_len );
            case 408:  return makeRegisterExpression(amdgpu_gfx90a::v152, output_vec_len );
            case 409:  return makeRegisterExpression(amdgpu_gfx90a::v153, output_vec_len );
            case 410:  return makeRegisterExpression(amdgpu_gfx90a::v154, output_vec_len );
            case 411:  return makeRegisterExpression(amdgpu_gfx90a::v155, output_vec_len );
            case 412:  return makeRegisterExpression(amdgpu_gfx90a::v156, output_vec_len );
            case 413:  return makeRegisterExpression(amdgpu_gfx90a::v157, output_vec_len );
            case 414:  return makeRegisterExpression(amdgpu_gfx90a::v158, output_vec_len );
            case 415:  return makeRegisterExpression(amdgpu_gfx90a::v159, output_vec_len );
            case 416:  return makeRegisterExpression(amdgpu_gfx90a::v160, output_vec_len );
            case 417:  return makeRegisterExpression(amdgpu_gfx90a::v161, output_vec_len );
            case 418:  return makeRegisterExpression(amdgpu_gfx90a::v162, output_vec_len );
            case 419:  return makeRegisterExpression(amdgpu_gfx90a::v163, output_vec_len );
            case 420:  return makeRegisterExpression(amdgpu_gfx90a::v164, output_vec_len );
            case 421:  return makeRegisterExpression(amdgpu_gfx90a::v165, output_vec_len );
            case 422:  return makeRegisterExpression(amdgpu_gfx90a::v166, output_vec_len );
            case 423:  return makeRegisterExpression(amdgpu_gfx90a::v167, output_vec_len );
            case 424:  return makeRegisterExpression(amdgpu_gfx90a::v168, output_vec_len );
            case 425:  return makeRegisterExpression(amdgpu_gfx90a::v169, output_vec_len );
            case 426:  return makeRegisterExpression(amdgpu_gfx90a::v170, output_vec_len );
            case 427:  return makeRegisterExpression(amdgpu_gfx90a::v171, output_vec_len );
            case 428:  return makeRegisterExpression(amdgpu_gfx90a::v172, output_vec_len );
            case 429:  return makeRegisterExpression(amdgpu_gfx90a::v173, output_vec_len );
            case 430:  return makeRegisterExpression(amdgpu_gfx90a::v174, output_vec_len );
            case 431:  return makeRegisterExpression(amdgpu_gfx90a::v175, output_vec_len );
            case 432:  return makeRegisterExpression(amdgpu_gfx90a::v176, output_vec_len );
            case 433:  return makeRegisterExpression(amdgpu_gfx90a::v177, output_vec_len );
            case 434:  return makeRegisterExpression(amdgpu_gfx90a::v178, output_vec_len );
            case 435:  return makeRegisterExpression(amdgpu_gfx90a::v179, output_vec_len );
            case 436:  return makeRegisterExpression(amdgpu_gfx90a::v180, output_vec_len );
            case 437:  return makeRegisterExpression(amdgpu_gfx90a::v181, output_vec_len );
            case 438:  return makeRegisterExpression(amdgpu_gfx90a::v182, output_vec_len );
            case 439:  return makeRegisterExpression(amdgpu_gfx90a::v183, output_vec_len );
            case 440:  return makeRegisterExpression(amdgpu_gfx90a::v184, output_vec_len );
            case 441:  return makeRegisterExpression(amdgpu_gfx90a::v185, output_vec_len );
            case 442:  return makeRegisterExpression(amdgpu_gfx90a::v186, output_vec_len );
            case 443:  return makeRegisterExpression(amdgpu_gfx90a::v187, output_vec_len );
            case 444:  return makeRegisterExpression(amdgpu_gfx90a::v188, output_vec_len );
            case 445:  return makeRegisterExpression(amdgpu_gfx90a::v189, output_vec_len );
            case 446:  return makeRegisterExpression(amdgpu_gfx90a::v190, output_vec_len );
            case 447:  return makeRegisterExpression(amdgpu_gfx90a::v191, output_vec_len );
            case 448:  return makeRegisterExpression(amdgpu_gfx90a::v192, output_vec_len );
            case 449:  return makeRegisterExpression(amdgpu_gfx90a::v193, output_vec_len );
            case 450:  return makeRegisterExpression(amdgpu_gfx90a::v194, output_vec_len );
            case 451:  return makeRegisterExpression(amdgpu_gfx90a::v195, output_vec_len );
            case 452:  return makeRegisterExpression(amdgpu_gfx90a::v196, output_vec_len );
            case 453:  return makeRegisterExpression(amdgpu_gfx90a::v197, output_vec_len );
            case 454:  return makeRegisterExpression(amdgpu_gfx90a::v198, output_vec_len );
            case 455:  return makeRegisterExpression(amdgpu_gfx90a::v199, output_vec_len );
            case 456:  return makeRegisterExpression(amdgpu_gfx90a::v200, output_vec_len );
            case 457:  return makeRegisterExpression(amdgpu_gfx90a::v201, output_vec_len );
            case 458:  return makeRegisterExpression(amdgpu_gfx90a::v202, output_vec_len );
            case 459:  return makeRegisterExpression(amdgpu_gfx90a::v203, output_vec_len );
            case 460:  return makeRegisterExpression(amdgpu_gfx90a::v204, output_vec_len );
            case 461:  return makeRegisterExpression(amdgpu_gfx90a::v205, output_vec_len );
            case 462:  return makeRegisterExpression(amdgpu_gfx90a::v206, output_vec_len );
            case 463:  return makeRegisterExpression(amdgpu_gfx90a::v207, output_vec_len );
            case 464:  return makeRegisterExpression(amdgpu_gfx90a::v208, output_vec_len );
            case 465:  return makeRegisterExpression(amdgpu_gfx90a::v209, output_vec_len );
            case 466:  return makeRegisterExpression(amdgpu_gfx90a::v210, output_vec_len );
            case 467:  return makeRegisterExpression(amdgpu_gfx90a::v211, output_vec_len );
            case 468:  return makeRegisterExpression(amdgpu_gfx90a::v212, output_vec_len );
            case 469:  return makeRegisterExpression(amdgpu_gfx90a::v213, output_vec_len );
            case 470:  return makeRegisterExpression(amdgpu_gfx90a::v214, output_vec_len );
            case 471:  return makeRegisterExpression(amdgpu_gfx90a::v215, output_vec_len );
            case 472:  return makeRegisterExpression(amdgpu_gfx90a::v216, output_vec_len );
            case 473:  return makeRegisterExpression(amdgpu_gfx90a::v217, output_vec_len );
            case 474:  return makeRegisterExpression(amdgpu_gfx90a::v218, output_vec_len );
            case 475:  return makeRegisterExpression(amdgpu_gfx90a::v219, output_vec_len );
            case 476:  return makeRegisterExpression(amdgpu_gfx90a::v220, output_vec_len );
            case 477:  return makeRegisterExpression(amdgpu_gfx90a::v221, output_vec_len );
            case 478:  return makeRegisterExpression(amdgpu_gfx90a::v222, output_vec_len );
            case 479:  return makeRegisterExpression(amdgpu_gfx90a::v223, output_vec_len );
            case 480:  return makeRegisterExpression(amdgpu_gfx90a::v224, output_vec_len );
            case 481:  return makeRegisterExpression(amdgpu_gfx90a::v225, output_vec_len );
            case 482:  return makeRegisterExpression(amdgpu_gfx90a::v226, output_vec_len );
            case 483:  return makeRegisterExpression(amdgpu_gfx90a::v227, output_vec_len );
            case 484:  return makeRegisterExpression(amdgpu_gfx90a::v228, output_vec_len );
            case 485:  return makeRegisterExpression(amdgpu_gfx90a::v229, output_vec_len );
            case 486:  return makeRegisterExpression(amdgpu_gfx90a::v230, output_vec_len );
            case 487:  return makeRegisterExpression(amdgpu_gfx90a::v231, output_vec_len );
            case 488:  return makeRegisterExpression(amdgpu_gfx90a::v232, output_vec_len );
            case 489:  return makeRegisterExpression(amdgpu_gfx90a::v233, output_vec_len );
            case 490:  return makeRegisterExpression(amdgpu_gfx90a::v234, output_vec_len );
            case 491:  return makeRegisterExpression(amdgpu_gfx90a::v235, output_vec_len );
            case 492:  return makeRegisterExpression(amdgpu_gfx90a::v236, output_vec_len );
            case 493:  return makeRegisterExpression(amdgpu_gfx90a::v237, output_vec_len );
            case 494:  return makeRegisterExpression(amdgpu_gfx90a::v238, output_vec_len );
            case 495:  return makeRegisterExpression(amdgpu_gfx90a::v239, output_vec_len );
            case 496:  return makeRegisterExpression(amdgpu_gfx90a::v240, output_vec_len );
            case 497:  return makeRegisterExpression(amdgpu_gfx90a::v241, output_vec_len );
            case 498:  return makeRegisterExpression(amdgpu_gfx90a::v242, output_vec_len );
            case 499:  return makeRegisterExpression(amdgpu_gfx90a::v243, output_vec_len );
            case 500:  return makeRegisterExpression(amdgpu_gfx90a::v244, output_vec_len );
            case 501:  return makeRegisterExpression(amdgpu_gfx90a::v245, output_vec_len );
            case 502:  return makeRegisterExpression(amdgpu_gfx90a::v246, output_vec_len );
            case 503:  return makeRegisterExpression(amdgpu_gfx90a::v247, output_vec_len );
            case 504:  return makeRegisterExpression(amdgpu_gfx90a::v248, output_vec_len );
            case 505:  return makeRegisterExpression(amdgpu_gfx90a::v249, output_vec_len );
            case 506:  return makeRegisterExpression(amdgpu_gfx90a::v250, output_vec_len );
            case 507:  return makeRegisterExpression(amdgpu_gfx90a::v251, output_vec_len );
            case 508:  return makeRegisterExpression(amdgpu_gfx90a::v252, output_vec_len );
            case 509:  return makeRegisterExpression(amdgpu_gfx90a::v253, output_vec_len );
            case 510:  return makeRegisterExpression(amdgpu_gfx90a::v254, output_vec_len );
            case 511:  return makeRegisterExpression(amdgpu_gfx90a::v255, output_vec_len );
            case 768:  return makeRegisterExpression(amdgpu_gfx90a::acc0, output_vec_len );
            case 769:  return makeRegisterExpression(amdgpu_gfx90a::acc1, output_vec_len );
            case 770:  return makeRegisterExpression(amdgpu_gfx90a::acc2, output_vec_len );
            case 771:  return makeRegisterExpression(amdgpu_gfx90a::acc3, output_vec_len );
            case 772:  return makeRegisterExpression(amdgpu_gfx90a::acc4, output_vec_len );
            case 773:  return makeRegisterExpression(amdgpu_gfx90a::acc5, output_vec_len );
            case 774:  return makeRegisterExpression(amdgpu_gfx90a::acc6, output_vec_len );
            case 775:  return makeRegisterExpression(amdgpu_gfx90a::acc7, output_vec_len );
            case 776:  return makeRegisterExpression(amdgpu_gfx90a::acc8, output_vec_len );
            case 777:  return makeRegisterExpression(amdgpu_gfx90a::acc9, output_vec_len );
            case 778:  return makeRegisterExpression(amdgpu_gfx90a::acc10, output_vec_len );
            case 779:  return makeRegisterExpression(amdgpu_gfx90a::acc11, output_vec_len );
            case 780:  return makeRegisterExpression(amdgpu_gfx90a::acc12, output_vec_len );
            case 781:  return makeRegisterExpression(amdgpu_gfx90a::acc13, output_vec_len );
            case 782:  return makeRegisterExpression(amdgpu_gfx90a::acc14, output_vec_len );
            case 783:  return makeRegisterExpression(amdgpu_gfx90a::acc15, output_vec_len );
            case 784:  return makeRegisterExpression(amdgpu_gfx90a::acc16, output_vec_len );
            case 785:  return makeRegisterExpression(amdgpu_gfx90a::acc17, output_vec_len );
            case 786:  return makeRegisterExpression(amdgpu_gfx90a::acc18, output_vec_len );
            case 787:  return makeRegisterExpression(amdgpu_gfx90a::acc19, output_vec_len );
            case 788:  return makeRegisterExpression(amdgpu_gfx90a::acc20, output_vec_len );
            case 789:  return makeRegisterExpression(amdgpu_gfx90a::acc21, output_vec_len );
            case 790:  return makeRegisterExpression(amdgpu_gfx90a::acc22, output_vec_len );
            case 791:  return makeRegisterExpression(amdgpu_gfx90a::acc23, output_vec_len );
            case 792:  return makeRegisterExpression(amdgpu_gfx90a::acc24, output_vec_len );
            case 793:  return makeRegisterExpression(amdgpu_gfx90a::acc25, output_vec_len );
            case 794:  return makeRegisterExpression(amdgpu_gfx90a::acc26, output_vec_len );
            case 795:  return makeRegisterExpression(amdgpu_gfx90a::acc27, output_vec_len );
            case 796:  return makeRegisterExpression(amdgpu_gfx90a::acc28, output_vec_len );
            case 797:  return makeRegisterExpression(amdgpu_gfx90a::acc29, output_vec_len );
            case 798:  return makeRegisterExpression(amdgpu_gfx90a::acc30, output_vec_len );
            case 799:  return makeRegisterExpression(amdgpu_gfx90a::acc31, output_vec_len );
            case 800:  return makeRegisterExpression(amdgpu_gfx90a::acc32, output_vec_len );
            case 801:  return makeRegisterExpression(amdgpu_gfx90a::acc33, output_vec_len );
            case 802:  return makeRegisterExpression(amdgpu_gfx90a::acc34, output_vec_len );
            case 803:  return makeRegisterExpression(amdgpu_gfx90a::acc35, output_vec_len );
            case 804:  return makeRegisterExpression(amdgpu_gfx90a::acc36, output_vec_len );
            case 805:  return makeRegisterExpression(amdgpu_gfx90a::acc37, output_vec_len );
            case 806:  return makeRegisterExpression(amdgpu_gfx90a::acc38, output_vec_len );
            case 807:  return makeRegisterExpression(amdgpu_gfx90a::acc39, output_vec_len );
            case 808:  return makeRegisterExpression(amdgpu_gfx90a::acc40, output_vec_len );
            case 809:  return makeRegisterExpression(amdgpu_gfx90a::acc41, output_vec_len );
            case 810:  return makeRegisterExpression(amdgpu_gfx90a::acc42, output_vec_len );
            case 811:  return makeRegisterExpression(amdgpu_gfx90a::acc43, output_vec_len );
            case 812:  return makeRegisterExpression(amdgpu_gfx90a::acc44, output_vec_len );
            case 813:  return makeRegisterExpression(amdgpu_gfx90a::acc45, output_vec_len );
            case 814:  return makeRegisterExpression(amdgpu_gfx90a::acc46, output_vec_len );
            case 815:  return makeRegisterExpression(amdgpu_gfx90a::acc47, output_vec_len );
            case 816:  return makeRegisterExpression(amdgpu_gfx90a::acc48, output_vec_len );
            case 817:  return makeRegisterExpression(amdgpu_gfx90a::acc49, output_vec_len );
            case 818:  return makeRegisterExpression(amdgpu_gfx90a::acc50, output_vec_len );
            case 819:  return makeRegisterExpression(amdgpu_gfx90a::acc51, output_vec_len );
            case 820:  return makeRegisterExpression(amdgpu_gfx90a::acc52, output_vec_len );
            case 821:  return makeRegisterExpression(amdgpu_gfx90a::acc53, output_vec_len );
            case 822:  return makeRegisterExpression(amdgpu_gfx90a::acc54, output_vec_len );
            case 823:  return makeRegisterExpression(amdgpu_gfx90a::acc55, output_vec_len );
            case 824:  return makeRegisterExpression(amdgpu_gfx90a::acc56, output_vec_len );
            case 825:  return makeRegisterExpression(amdgpu_gfx90a::acc57, output_vec_len );
            case 826:  return makeRegisterExpression(amdgpu_gfx90a::acc58, output_vec_len );
            case 827:  return makeRegisterExpression(amdgpu_gfx90a::acc59, output_vec_len );
            case 828:  return makeRegisterExpression(amdgpu_gfx90a::acc60, output_vec_len );
            case 829:  return makeRegisterExpression(amdgpu_gfx90a::acc61, output_vec_len );
            case 830:  return makeRegisterExpression(amdgpu_gfx90a::acc62, output_vec_len );
            case 831:  return makeRegisterExpression(amdgpu_gfx90a::acc63, output_vec_len );
            case 832:  return makeRegisterExpression(amdgpu_gfx90a::acc64, output_vec_len );
            case 833:  return makeRegisterExpression(amdgpu_gfx90a::acc65, output_vec_len );
            case 834:  return makeRegisterExpression(amdgpu_gfx90a::acc66, output_vec_len );
            case 835:  return makeRegisterExpression(amdgpu_gfx90a::acc67, output_vec_len );
            case 836:  return makeRegisterExpression(amdgpu_gfx90a::acc68, output_vec_len );
            case 837:  return makeRegisterExpression(amdgpu_gfx90a::acc69, output_vec_len );
            case 838:  return makeRegisterExpression(amdgpu_gfx90a::acc70, output_vec_len );
            case 839:  return makeRegisterExpression(amdgpu_gfx90a::acc71, output_vec_len );
            case 840:  return makeRegisterExpression(amdgpu_gfx90a::acc72, output_vec_len );
            case 841:  return makeRegisterExpression(amdgpu_gfx90a::acc73, output_vec_len );
            case 842:  return makeRegisterExpression(amdgpu_gfx90a::acc74, output_vec_len );
            case 843:  return makeRegisterExpression(amdgpu_gfx90a::acc75, output_vec_len );
            case 844:  return makeRegisterExpression(amdgpu_gfx90a::acc76, output_vec_len );
            case 845:  return makeRegisterExpression(amdgpu_gfx90a::acc77, output_vec_len );
            case 846:  return makeRegisterExpression(amdgpu_gfx90a::acc78, output_vec_len );
            case 847:  return makeRegisterExpression(amdgpu_gfx90a::acc79, output_vec_len );
            case 848:  return makeRegisterExpression(amdgpu_gfx90a::acc80, output_vec_len );
            case 849:  return makeRegisterExpression(amdgpu_gfx90a::acc81, output_vec_len );
            case 850:  return makeRegisterExpression(amdgpu_gfx90a::acc82, output_vec_len );
            case 851:  return makeRegisterExpression(amdgpu_gfx90a::acc83, output_vec_len );
            case 852:  return makeRegisterExpression(amdgpu_gfx90a::acc84, output_vec_len );
            case 853:  return makeRegisterExpression(amdgpu_gfx90a::acc85, output_vec_len );
            case 854:  return makeRegisterExpression(amdgpu_gfx90a::acc86, output_vec_len );
            case 855:  return makeRegisterExpression(amdgpu_gfx90a::acc87, output_vec_len );
            case 856:  return makeRegisterExpression(amdgpu_gfx90a::acc88, output_vec_len );
            case 857:  return makeRegisterExpression(amdgpu_gfx90a::acc89, output_vec_len );
            case 858:  return makeRegisterExpression(amdgpu_gfx90a::acc90, output_vec_len );
            case 859:  return makeRegisterExpression(amdgpu_gfx90a::acc91, output_vec_len );
            case 860:  return makeRegisterExpression(amdgpu_gfx90a::acc92, output_vec_len );
            case 861:  return makeRegisterExpression(amdgpu_gfx90a::acc93, output_vec_len );
            case 862:  return makeRegisterExpression(amdgpu_gfx90a::acc94, output_vec_len );
            case 863:  return makeRegisterExpression(amdgpu_gfx90a::acc95, output_vec_len );
            case 864:  return makeRegisterExpression(amdgpu_gfx90a::acc96, output_vec_len );
            case 865:  return makeRegisterExpression(amdgpu_gfx90a::acc97, output_vec_len );
            case 866:  return makeRegisterExpression(amdgpu_gfx90a::acc98, output_vec_len );
            case 867:  return makeRegisterExpression(amdgpu_gfx90a::acc99, output_vec_len );
            case 868:  return makeRegisterExpression(amdgpu_gfx90a::acc100, output_vec_len );
            case 869:  return makeRegisterExpression(amdgpu_gfx90a::acc101, output_vec_len );
            case 870:  return makeRegisterExpression(amdgpu_gfx90a::acc102, output_vec_len );
            case 871:  return makeRegisterExpression(amdgpu_gfx90a::acc103, output_vec_len );
            case 872:  return makeRegisterExpression(amdgpu_gfx90a::acc104, output_vec_len );
            case 873:  return makeRegisterExpression(amdgpu_gfx90a::acc105, output_vec_len );
            case 874:  return makeRegisterExpression(amdgpu_gfx90a::acc106, output_vec_len );
            case 875:  return makeRegisterExpression(amdgpu_gfx90a::acc107, output_vec_len );
            case 876:  return makeRegisterExpression(amdgpu_gfx90a::acc108, output_vec_len );
            case 877:  return makeRegisterExpression(amdgpu_gfx90a::acc109, output_vec_len );
            case 878:  return makeRegisterExpression(amdgpu_gfx90a::acc110, output_vec_len );
            case 879:  return makeRegisterExpression(amdgpu_gfx90a::acc111, output_vec_len );
            case 880:  return makeRegisterExpression(amdgpu_gfx90a::acc112, output_vec_len );
            case 881:  return makeRegisterExpression(amdgpu_gfx90a::acc113, output_vec_len );
            case 882:  return makeRegisterExpression(amdgpu_gfx90a::acc114, output_vec_len );
            case 883:  return makeRegisterExpression(amdgpu_gfx90a::acc115, output_vec_len );
            case 884:  return makeRegisterExpression(amdgpu_gfx90a::acc116, output_vec_len );
            case 885:  return makeRegisterExpression(amdgpu_gfx90a::acc117, output_vec_len );
            case 886:  return makeRegisterExpression(amdgpu_gfx90a::acc118, output_vec_len );
            case 887:  return makeRegisterExpression(amdgpu_gfx90a::acc119, output_vec_len );
            case 888:  return makeRegisterExpression(amdgpu_gfx90a::acc120, output_vec_len );
            case 889:  return makeRegisterExpression(amdgpu_gfx90a::acc121, output_vec_len );
            case 890:  return makeRegisterExpression(amdgpu_gfx90a::acc122, output_vec_len );
            case 891:  return makeRegisterExpression(amdgpu_gfx90a::acc123, output_vec_len );
            case 892:  return makeRegisterExpression(amdgpu_gfx90a::acc124, output_vec_len );
            case 893:  return makeRegisterExpression(amdgpu_gfx90a::acc125, output_vec_len );
            case 894:  return makeRegisterExpression(amdgpu_gfx90a::acc126, output_vec_len );
            case 895:  return makeRegisterExpression(amdgpu_gfx90a::acc127, output_vec_len );
            case 896:  return makeRegisterExpression(amdgpu_gfx90a::acc128, output_vec_len );
            case 897:  return makeRegisterExpression(amdgpu_gfx90a::acc129, output_vec_len );
            case 898:  return makeRegisterExpression(amdgpu_gfx90a::acc130, output_vec_len );
            case 899:  return makeRegisterExpression(amdgpu_gfx90a::acc131, output_vec_len );
            case 900:  return makeRegisterExpression(amdgpu_gfx90a::acc132, output_vec_len );
            case 901:  return makeRegisterExpression(amdgpu_gfx90a::acc133, output_vec_len );
            case 902:  return makeRegisterExpression(amdgpu_gfx90a::acc134, output_vec_len );
            case 903:  return makeRegisterExpression(amdgpu_gfx90a::acc135, output_vec_len );
            case 904:  return makeRegisterExpression(amdgpu_gfx90a::acc136, output_vec_len );
            case 905:  return makeRegisterExpression(amdgpu_gfx90a::acc137, output_vec_len );
            case 906:  return makeRegisterExpression(amdgpu_gfx90a::acc138, output_vec_len );
            case 907:  return makeRegisterExpression(amdgpu_gfx90a::acc139, output_vec_len );
            case 908:  return makeRegisterExpression(amdgpu_gfx90a::acc140, output_vec_len );
            case 909:  return makeRegisterExpression(amdgpu_gfx90a::acc141, output_vec_len );
            case 910:  return makeRegisterExpression(amdgpu_gfx90a::acc142, output_vec_len );
            case 911:  return makeRegisterExpression(amdgpu_gfx90a::acc143, output_vec_len );
            case 912:  return makeRegisterExpression(amdgpu_gfx90a::acc144, output_vec_len );
            case 913:  return makeRegisterExpression(amdgpu_gfx90a::acc145, output_vec_len );
            case 914:  return makeRegisterExpression(amdgpu_gfx90a::acc146, output_vec_len );
            case 915:  return makeRegisterExpression(amdgpu_gfx90a::acc147, output_vec_len );
            case 916:  return makeRegisterExpression(amdgpu_gfx90a::acc148, output_vec_len );
            case 917:  return makeRegisterExpression(amdgpu_gfx90a::acc149, output_vec_len );
            case 918:  return makeRegisterExpression(amdgpu_gfx90a::acc150, output_vec_len );
            case 919:  return makeRegisterExpression(amdgpu_gfx90a::acc151, output_vec_len );
            case 920:  return makeRegisterExpression(amdgpu_gfx90a::acc152, output_vec_len );
            case 921:  return makeRegisterExpression(amdgpu_gfx90a::acc153, output_vec_len );
            case 922:  return makeRegisterExpression(amdgpu_gfx90a::acc154, output_vec_len );
            case 923:  return makeRegisterExpression(amdgpu_gfx90a::acc155, output_vec_len );
            case 924:  return makeRegisterExpression(amdgpu_gfx90a::acc156, output_vec_len );
            case 925:  return makeRegisterExpression(amdgpu_gfx90a::acc157, output_vec_len );
            case 926:  return makeRegisterExpression(amdgpu_gfx90a::acc158, output_vec_len );
            case 927:  return makeRegisterExpression(amdgpu_gfx90a::acc159, output_vec_len );
            case 928:  return makeRegisterExpression(amdgpu_gfx90a::acc160, output_vec_len );
            case 929:  return makeRegisterExpression(amdgpu_gfx90a::acc161, output_vec_len );
            case 930:  return makeRegisterExpression(amdgpu_gfx90a::acc162, output_vec_len );
            case 931:  return makeRegisterExpression(amdgpu_gfx90a::acc163, output_vec_len );
            case 932:  return makeRegisterExpression(amdgpu_gfx90a::acc164, output_vec_len );
            case 933:  return makeRegisterExpression(amdgpu_gfx90a::acc165, output_vec_len );
            case 934:  return makeRegisterExpression(amdgpu_gfx90a::acc166, output_vec_len );
            case 935:  return makeRegisterExpression(amdgpu_gfx90a::acc167, output_vec_len );
            case 936:  return makeRegisterExpression(amdgpu_gfx90a::acc168, output_vec_len );
            case 937:  return makeRegisterExpression(amdgpu_gfx90a::acc169, output_vec_len );
            case 938:  return makeRegisterExpression(amdgpu_gfx90a::acc170, output_vec_len );
            case 939:  return makeRegisterExpression(amdgpu_gfx90a::acc171, output_vec_len );
            case 940:  return makeRegisterExpression(amdgpu_gfx90a::acc172, output_vec_len );
            case 941:  return makeRegisterExpression(amdgpu_gfx90a::acc173, output_vec_len );
            case 942:  return makeRegisterExpression(amdgpu_gfx90a::acc174, output_vec_len );
            case 943:  return makeRegisterExpression(amdgpu_gfx90a::acc175, output_vec_len );
            case 944:  return makeRegisterExpression(amdgpu_gfx90a::acc176, output_vec_len );
            case 945:  return makeRegisterExpression(amdgpu_gfx90a::acc177, output_vec_len );
            case 946:  return makeRegisterExpression(amdgpu_gfx90a::acc178, output_vec_len );
            case 947:  return makeRegisterExpression(amdgpu_gfx90a::acc179, output_vec_len );
            case 948:  return makeRegisterExpression(amdgpu_gfx90a::acc180, output_vec_len );
            case 949:  return makeRegisterExpression(amdgpu_gfx90a::acc181, output_vec_len );
            case 950:  return makeRegisterExpression(amdgpu_gfx90a::acc182, output_vec_len );
            case 951:  return makeRegisterExpression(amdgpu_gfx90a::acc183, output_vec_len );
            case 952:  return makeRegisterExpression(amdgpu_gfx90a::acc184, output_vec_len );
            case 953:  return makeRegisterExpression(amdgpu_gfx90a::acc185, output_vec_len );
            case 954:  return makeRegisterExpression(amdgpu_gfx90a::acc186, output_vec_len );
            case 955:  return makeRegisterExpression(amdgpu_gfx90a::acc187, output_vec_len );
            case 956:  return makeRegisterExpression(amdgpu_gfx90a::acc188, output_vec_len );
            case 957:  return makeRegisterExpression(amdgpu_gfx90a::acc189, output_vec_len );
            case 958:  return makeRegisterExpression(amdgpu_gfx90a::acc190, output_vec_len );
            case 959:  return makeRegisterExpression(amdgpu_gfx90a::acc191, output_vec_len );
            case 960:  return makeRegisterExpression(amdgpu_gfx90a::acc192, output_vec_len );
            case 961:  return makeRegisterExpression(amdgpu_gfx90a::acc193, output_vec_len );
            case 962:  return makeRegisterExpression(amdgpu_gfx90a::acc194, output_vec_len );
            case 963:  return makeRegisterExpression(amdgpu_gfx90a::acc195, output_vec_len );
            case 964:  return makeRegisterExpression(amdgpu_gfx90a::acc196, output_vec_len );
            case 965:  return makeRegisterExpression(amdgpu_gfx90a::acc197, output_vec_len );
            case 966:  return makeRegisterExpression(amdgpu_gfx90a::acc198, output_vec_len );
            case 967:  return makeRegisterExpression(amdgpu_gfx90a::acc199, output_vec_len );
            case 968:  return makeRegisterExpression(amdgpu_gfx90a::acc200, output_vec_len );
            case 969:  return makeRegisterExpression(amdgpu_gfx90a::acc201, output_vec_len );
            case 970:  return makeRegisterExpression(amdgpu_gfx90a::acc202, output_vec_len );
            case 971:  return makeRegisterExpression(amdgpu_gfx90a::acc203, output_vec_len );
            case 972:  return makeRegisterExpression(amdgpu_gfx90a::acc204, output_vec_len );
            case 973:  return makeRegisterExpression(amdgpu_gfx90a::acc205, output_vec_len );
            case 974:  return makeRegisterExpression(amdgpu_gfx90a::acc206, output_vec_len );
            case 975:  return makeRegisterExpression(amdgpu_gfx90a::acc207, output_vec_len );
            case 976:  return makeRegisterExpression(amdgpu_gfx90a::acc208, output_vec_len );
            case 977:  return makeRegisterExpression(amdgpu_gfx90a::acc209, output_vec_len );
            case 978:  return makeRegisterExpression(amdgpu_gfx90a::acc210, output_vec_len );
            case 979:  return makeRegisterExpression(amdgpu_gfx90a::acc211, output_vec_len );
            case 980:  return makeRegisterExpression(amdgpu_gfx90a::acc212, output_vec_len );
            case 981:  return makeRegisterExpression(amdgpu_gfx90a::acc213, output_vec_len );
            case 982:  return makeRegisterExpression(amdgpu_gfx90a::acc214, output_vec_len );
            case 983:  return makeRegisterExpression(amdgpu_gfx90a::acc215, output_vec_len );
            case 984:  return makeRegisterExpression(amdgpu_gfx90a::acc216, output_vec_len );
            case 985:  return makeRegisterExpression(amdgpu_gfx90a::acc217, output_vec_len );
            case 986:  return makeRegisterExpression(amdgpu_gfx90a::acc218, output_vec_len );
            case 987:  return makeRegisterExpression(amdgpu_gfx90a::acc219, output_vec_len );
            case 988:  return makeRegisterExpression(amdgpu_gfx90a::acc220, output_vec_len );
            case 989:  return makeRegisterExpression(amdgpu_gfx90a::acc221, output_vec_len );
            case 990:  return makeRegisterExpression(amdgpu_gfx90a::acc222, output_vec_len );
            case 991:  return makeRegisterExpression(amdgpu_gfx90a::acc223, output_vec_len );
            case 992:  return makeRegisterExpression(amdgpu_gfx90a::acc224, output_vec_len );
            case 993:  return makeRegisterExpression(amdgpu_gfx90a::acc225, output_vec_len );
            case 994:  return makeRegisterExpression(amdgpu_gfx90a::acc226, output_vec_len );
            case 995:  return makeRegisterExpression(amdgpu_gfx90a::acc227, output_vec_len );
            case 996:  return makeRegisterExpression(amdgpu_gfx90a::acc228, output_vec_len );
            case 997:  return makeRegisterExpression(amdgpu_gfx90a::acc229, output_vec_len );
            case 998:  return makeRegisterExpression(amdgpu_gfx90a::acc230, output_vec_len );
            case 999:  return makeRegisterExpression(amdgpu_gfx90a::acc231, output_vec_len );
            case 1000:  return makeRegisterExpression(amdgpu_gfx90a::acc232, output_vec_len );
            case 1001:  return makeRegisterExpression(amdgpu_gfx90a::acc233, output_vec_len );
            case 1002:  return makeRegisterExpression(amdgpu_gfx90a::acc234, output_vec_len );
            case 1003:  return makeRegisterExpression(amdgpu_gfx90a::acc235, output_vec_len );
            case 1004:  return makeRegisterExpression(amdgpu_gfx90a::acc236, output_vec_len );
            case 1005:  return makeRegisterExpression(amdgpu_gfx90a::acc237, output_vec_len );
            case 1006:  return makeRegisterExpression(amdgpu_gfx90a::acc238, output_vec_len );
            case 1007:  return makeRegisterExpression(amdgpu_gfx90a::acc239, output_vec_len );
            case 1008:  return makeRegisterExpression(amdgpu_gfx90a::acc240, output_vec_len );
            case 1009:  return makeRegisterExpression(amdgpu_gfx90a::acc241, output_vec_len );
            case 1010:  return makeRegisterExpression(amdgpu_gfx90a::acc242, output_vec_len );
            case 1011:  return makeRegisterExpression(amdgpu_gfx90a::acc243, output_vec_len );
            case 1012:  return makeRegisterExpression(amdgpu_gfx90a::acc244, output_vec_len );
            case 1013:  return makeRegisterExpression(amdgpu_gfx90a::acc245, output_vec_len );
            case 1014:  return makeRegisterExpression(amdgpu_gfx90a::acc246, output_vec_len );
            case 1015:  return makeRegisterExpression(amdgpu_gfx90a::acc247, output_vec_len );
            case 1016:  return makeRegisterExpression(amdgpu_gfx90a::acc248, output_vec_len );
            case 1017:  return makeRegisterExpression(amdgpu_gfx90a::acc249, output_vec_len );
            case 1018:  return makeRegisterExpression(amdgpu_gfx90a::acc250, output_vec_len );
            case 1019:  return makeRegisterExpression(amdgpu_gfx90a::acc251, output_vec_len );
            case 1020:  return makeRegisterExpression(amdgpu_gfx90a::acc252, output_vec_len );
            case 1021:  return makeRegisterExpression(amdgpu_gfx90a::acc253, output_vec_len );
            case 1022:  return makeRegisterExpression(amdgpu_gfx90a::acc254, output_vec_len );
            case 1023:  return makeRegisterExpression(amdgpu_gfx90a::acc255, output_vec_len );
            case 128:  return Immediate::makeImmediate(Result(u32, 0));
            case 129:  return Immediate::makeImmediate(Result(u32, 1));
            case 130:  return Immediate::makeImmediate(Result(u32, 2));
            case 131:  return Immediate::makeImmediate(Result(u32, 3));
            case 132:  return Immediate::makeImmediate(Result(u32, 4));
            case 133:  return Immediate::makeImmediate(Result(u32, 5));
            case 134:  return Immediate::makeImmediate(Result(u32, 6));
            case 135:  return Immediate::makeImmediate(Result(u32, 7));
            case 136:  return Immediate::makeImmediate(Result(u32, 8));
            case 137:  return Immediate::makeImmediate(Result(u32, 9));
            case 138:  return Immediate::makeImmediate(Result(u32, 10));
            case 139:  return Immediate::makeImmediate(Result(u32, 11));
            case 140:  return Immediate::makeImmediate(Result(u32, 12));
            case 141:  return Immediate::makeImmediate(Result(u32, 13));
            case 142:  return Immediate::makeImmediate(Result(u32, 14));
            case 143:  return Immediate::makeImmediate(Result(u32, 15));
            case 144:  return Immediate::makeImmediate(Result(u32, 16));
            case 145:  return Immediate::makeImmediate(Result(u32, 17));
            case 146:  return Immediate::makeImmediate(Result(u32, 18));
            case 147:  return Immediate::makeImmediate(Result(u32, 19));
            case 148:  return Immediate::makeImmediate(Result(u32, 20));
            case 149:  return Immediate::makeImmediate(Result(u32, 21));
            case 150:  return Immediate::makeImmediate(Result(u32, 22));
            case 151:  return Immediate::makeImmediate(Result(u32, 23));
            case 152:  return Immediate::makeImmediate(Result(u32, 24));
            case 153:  return Immediate::makeImmediate(Result(u32, 25));
            case 154:  return Immediate::makeImmediate(Result(u32, 26));
            case 155:  return Immediate::makeImmediate(Result(u32, 27));
            case 156:  return Immediate::makeImmediate(Result(u32, 28));
            case 157:  return Immediate::makeImmediate(Result(u32, 29));
            case 158:  return Immediate::makeImmediate(Result(u32, 30));
            case 159:  return Immediate::makeImmediate(Result(u32, 31));
            case 160:  return Immediate::makeImmediate(Result(u32, 32));
            case 161:  return Immediate::makeImmediate(Result(u32, 33));
            case 162:  return Immediate::makeImmediate(Result(u32, 34));
            case 163:  return Immediate::makeImmediate(Result(u32, 35));
            case 164:  return Immediate::makeImmediate(Result(u32, 36));
            case 165:  return Immediate::makeImmediate(Result(u32, 37));
            case 166:  return Immediate::makeImmediate(Result(u32, 38));
            case 167:  return Immediate::makeImmediate(Result(u32, 39));
            case 168:  return Immediate::makeImmediate(Result(u32, 40));
            case 169:  return Immediate::makeImmediate(Result(u32, 41));
            case 170:  return Immediate::makeImmediate(Result(u32, 42));
            case 171:  return Immediate::makeImmediate(Result(u32, 43));
            case 172:  return Immediate::makeImmediate(Result(u32, 44));
            case 173:  return Immediate::makeImmediate(Result(u32, 45));
            case 174:  return Immediate::makeImmediate(Result(u32, 46));
            case 175:  return Immediate::makeImmediate(Result(u32, 47));
            case 176:  return Immediate::makeImmediate(Result(u32, 48));
            case 177:  return Immediate::makeImmediate(Result(u32, 49));
            case 178:  return Immediate::makeImmediate(Result(u32, 50));
            case 179:  return Immediate::makeImmediate(Result(u32, 51));
            case 180:  return Immediate::makeImmediate(Result(u32, 52));
            case 181:  return Immediate::makeImmediate(Result(u32, 53));
            case 182:  return Immediate::makeImmediate(Result(u32, 54));
            case 183:  return Immediate::makeImmediate(Result(u32, 55));
            case 184:  return Immediate::makeImmediate(Result(u32, 56));
            case 185:  return Immediate::makeImmediate(Result(u32, 57));
            case 186:  return Immediate::makeImmediate(Result(u32, 58));
            case 187:  return Immediate::makeImmediate(Result(u32, 59));
            case 188:  return Immediate::makeImmediate(Result(u32, 60));
            case 189:  return Immediate::makeImmediate(Result(u32, 61));
            case 190:  return Immediate::makeImmediate(Result(u32, 62));
            case 191:  return Immediate::makeImmediate(Result(u32, 63));
            case 192:  return Immediate::makeImmediate(Result(u32, 64));
            case 193:  return Immediate::makeImmediate(Result(u32, -1));
            case 194:  return Immediate::makeImmediate(Result(u32, -2));
            case 195:  return Immediate::makeImmediate(Result(u32, -3));
            case 196:  return Immediate::makeImmediate(Result(u32, -4));
            case 197:  return Immediate::makeImmediate(Result(u32, -5));
            case 198:  return Immediate::makeImmediate(Result(u32, -6));
            case 199:  return Immediate::makeImmediate(Result(u32, -7));
            case 200:  return Immediate::makeImmediate(Result(u32, -8));
            case 201:  return Immediate::makeImmediate(Result(u32, -9));
            case 202:  return Immediate::makeImmediate(Result(u32, -10));
            case 203:  return Immediate::makeImmediate(Result(u32, -11));
            case 204:  return Immediate::makeImmediate(Result(u32, -12));
            case 205:  return Immediate::makeImmediate(Result(u32, -13));
            case 206:  return Immediate::makeImmediate(Result(u32, -14));
            case 207:  return Immediate::makeImmediate(Result(u32, -15));
            case 208:  return Immediate::makeImmediate(Result(u32, -16));
            case 240:  return Immediate::makeImmediate(Result(sp_float, 0.5));
            case 241:  return Immediate::makeImmediate(Result(sp_float, -0.5));
            case 242:  return Immediate::makeImmediate(Result(sp_float, 1.0));
            case 243:  return Immediate::makeImmediate(Result(sp_float, -1.0));
            case 244:  return Immediate::makeImmediate(Result(sp_float, 2.0));
            case 245:  return Immediate::makeImmediate(Result(sp_float, -2.0));
            case 246:  return Immediate::makeImmediate(Result(sp_float, 4.0));
            case 247:  return Immediate::makeImmediate(Result(sp_float, -4.0));
            case 248:  return Immediate::makeImmediate(Result(sp_float, 0.15915494));
            default: return makeRegisterExpression(amdgpu_gfx90a::invalid);
        }
    }

    Expression::Ptr InstructionDecoder_amdgpu_gfx90a::decodeOPR_SREG(uint64_t input, uint32_t output_vec_len)
    {
        switch (input)  {
            case 0:  return makeRegisterExpression(amdgpu_gfx90a::s0, output_vec_len );
            case 1:  return makeRegisterExpression(amdgpu_gfx90a::s1, output_vec_len );
            case 2:  return makeRegisterExpression(amdgpu_gfx90a::s2, output_vec_len );
            case 3:  return makeRegisterExpression(amdgpu_gfx90a::s3, output_vec_len );
            case 4:  return makeRegisterExpression(amdgpu_gfx90a::s4, output_vec_len );
            case 5:  return makeRegisterExpression(amdgpu_gfx90a::s5, output_vec_len );
            case 6:  return makeRegisterExpression(amdgpu_gfx90a::s6, output_vec_len );
            case 7:  return makeRegisterExpression(amdgpu_gfx90a::s7, output_vec_len );
            case 8:  return makeRegisterExpression(amdgpu_gfx90a::s8, output_vec_len );
            case 9:  return makeRegisterExpression(amdgpu_gfx90a::s9, output_vec_len );
            case 10:  return makeRegisterExpression(amdgpu_gfx90a::s10, output_vec_len );
            case 11:  return makeRegisterExpression(amdgpu_gfx90a::s11, output_vec_len );
            case 12:  return makeRegisterExpression(amdgpu_gfx90a::s12, output_vec_len );
            case 13:  return makeRegisterExpression(amdgpu_gfx90a::s13, output_vec_len );
            case 14:  return makeRegisterExpression(amdgpu_gfx90a::s14, output_vec_len );
            case 15:  return makeRegisterExpression(amdgpu_gfx90a::s15, output_vec_len );
            case 16:  return makeRegisterExpression(amdgpu_gfx90a::s16, output_vec_len );
            case 17:  return makeRegisterExpression(amdgpu_gfx90a::s17, output_vec_len );
            case 18:  return makeRegisterExpression(amdgpu_gfx90a::s18, output_vec_len );
            case 19:  return makeRegisterExpression(amdgpu_gfx90a::s19, output_vec_len );
            case 20:  return makeRegisterExpression(amdgpu_gfx90a::s20, output_vec_len );
            case 21:  return makeRegisterExpression(amdgpu_gfx90a::s21, output_vec_len );
            case 22:  return makeRegisterExpression(amdgpu_gfx90a::s22, output_vec_len );
            case 23:  return makeRegisterExpression(amdgpu_gfx90a::s23, output_vec_len );
            case 24:  return makeRegisterExpression(amdgpu_gfx90a::s24, output_vec_len );
            case 25:  return makeRegisterExpression(amdgpu_gfx90a::s25, output_vec_len );
            case 26:  return makeRegisterExpression(amdgpu_gfx90a::s26, output_vec_len );
            case 27:  return makeRegisterExpression(amdgpu_gfx90a::s27, output_vec_len );
            case 28:  return makeRegisterExpression(amdgpu_gfx90a::s28, output_vec_len );
            case 29:  return makeRegisterExpression(amdgpu_gfx90a::s29, output_vec_len );
            case 30:  return makeRegisterExpression(amdgpu_gfx90a::s30, output_vec_len );
            case 31:  return makeRegisterExpression(amdgpu_gfx90a::s31, output_vec_len );
            case 32:  return makeRegisterExpression(amdgpu_gfx90a::s32, output_vec_len );
            case 33:  return makeRegisterExpression(amdgpu_gfx90a::s33, output_vec_len );
            case 34:  return makeRegisterExpression(amdgpu_gfx90a::s34, output_vec_len );
            case 35:  return makeRegisterExpression(amdgpu_gfx90a::s35, output_vec_len );
            case 36:  return makeRegisterExpression(amdgpu_gfx90a::s36, output_vec_len );
            case 37:  return makeRegisterExpression(amdgpu_gfx90a::s37, output_vec_len );
            case 38:  return makeRegisterExpression(amdgpu_gfx90a::s38, output_vec_len );
            case 39:  return makeRegisterExpression(amdgpu_gfx90a::s39, output_vec_len );
            case 40:  return makeRegisterExpression(amdgpu_gfx90a::s40, output_vec_len );
            case 41:  return makeRegisterExpression(amdgpu_gfx90a::s41, output_vec_len );
            case 42:  return makeRegisterExpression(amdgpu_gfx90a::s42, output_vec_len );
            case 43:  return makeRegisterExpression(amdgpu_gfx90a::s43, output_vec_len );
            case 44:  return makeRegisterExpression(amdgpu_gfx90a::s44, output_vec_len );
            case 45:  return makeRegisterExpression(amdgpu_gfx90a::s45, output_vec_len );
            case 46:  return makeRegisterExpression(amdgpu_gfx90a::s46, output_vec_len );
            case 47:  return makeRegisterExpression(amdgpu_gfx90a::s47, output_vec_len );
            case 48:  return makeRegisterExpression(amdgpu_gfx90a::s48, output_vec_len );
            case 49:  return makeRegisterExpression(amdgpu_gfx90a::s49, output_vec_len );
            case 50:  return makeRegisterExpression(amdgpu_gfx90a::s50, output_vec_len );
            case 51:  return makeRegisterExpression(amdgpu_gfx90a::s51, output_vec_len );
            case 52:  return makeRegisterExpression(amdgpu_gfx90a::s52, output_vec_len );
            case 53:  return makeRegisterExpression(amdgpu_gfx90a::s53, output_vec_len );
            case 54:  return makeRegisterExpression(amdgpu_gfx90a::s54, output_vec_len );
            case 55:  return makeRegisterExpression(amdgpu_gfx90a::s55, output_vec_len );
            case 56:  return makeRegisterExpression(amdgpu_gfx90a::s56, output_vec_len );
            case 57:  return makeRegisterExpression(amdgpu_gfx90a::s57, output_vec_len );
            case 58:  return makeRegisterExpression(amdgpu_gfx90a::s58, output_vec_len );
            case 59:  return makeRegisterExpression(amdgpu_gfx90a::s59, output_vec_len );
            case 60:  return makeRegisterExpression(amdgpu_gfx90a::s60, output_vec_len );
            case 61:  return makeRegisterExpression(amdgpu_gfx90a::s61, output_vec_len );
            case 62:  return makeRegisterExpression(amdgpu_gfx90a::s62, output_vec_len );
            case 63:  return makeRegisterExpression(amdgpu_gfx90a::s63, output_vec_len );
            case 64:  return makeRegisterExpression(amdgpu_gfx90a::s64, output_vec_len );
            case 65:  return makeRegisterExpression(amdgpu_gfx90a::s65, output_vec_len );
            case 66:  return makeRegisterExpression(amdgpu_gfx90a::s66, output_vec_len );
            case 67:  return makeRegisterExpression(amdgpu_gfx90a::s67, output_vec_len );
            case 68:  return makeRegisterExpression(amdgpu_gfx90a::s68, output_vec_len );
            case 69:  return makeRegisterExpression(amdgpu_gfx90a::s69, output_vec_len );
            case 70:  return makeRegisterExpression(amdgpu_gfx90a::s70, output_vec_len );
            case 71:  return makeRegisterExpression(amdgpu_gfx90a::s71, output_vec_len );
            case 72:  return makeRegisterExpression(amdgpu_gfx90a::s72, output_vec_len );
            case 73:  return makeRegisterExpression(amdgpu_gfx90a::s73, output_vec_len );
            case 74:  return makeRegisterExpression(amdgpu_gfx90a::s74, output_vec_len );
            case 75:  return makeRegisterExpression(amdgpu_gfx90a::s75, output_vec_len );
            case 76:  return makeRegisterExpression(amdgpu_gfx90a::s76, output_vec_len );
            case 77:  return makeRegisterExpression(amdgpu_gfx90a::s77, output_vec_len );
            case 78:  return makeRegisterExpression(amdgpu_gfx90a::s78, output_vec_len );
            case 79:  return makeRegisterExpression(amdgpu_gfx90a::s79, output_vec_len );
            case 80:  return makeRegisterExpression(amdgpu_gfx90a::s80, output_vec_len );
            case 81:  return makeRegisterExpression(amdgpu_gfx90a::s81, output_vec_len );
            case 82:  return makeRegisterExpression(amdgpu_gfx90a::s82, output_vec_len );
            case 83:  return makeRegisterExpression(amdgpu_gfx90a::s83, output_vec_len );
            case 84:  return makeRegisterExpression(amdgpu_gfx90a::s84, output_vec_len );
            case 85:  return makeRegisterExpression(amdgpu_gfx90a::s85, output_vec_len );
            case 86:  return makeRegisterExpression(amdgpu_gfx90a::s86, output_vec_len );
            case 87:  return makeRegisterExpression(amdgpu_gfx90a::s87, output_vec_len );
            case 88:  return makeRegisterExpression(amdgpu_gfx90a::s88, output_vec_len );
            case 89:  return makeRegisterExpression(amdgpu_gfx90a::s89, output_vec_len );
            case 90:  return makeRegisterExpression(amdgpu_gfx90a::s90, output_vec_len );
            case 91:  return makeRegisterExpression(amdgpu_gfx90a::s91, output_vec_len );
            case 92:  return makeRegisterExpression(amdgpu_gfx90a::s92, output_vec_len );
            case 93:  return makeRegisterExpression(amdgpu_gfx90a::s93, output_vec_len );
            case 94:  return makeRegisterExpression(amdgpu_gfx90a::s94, output_vec_len );
            case 95:  return makeRegisterExpression(amdgpu_gfx90a::s95, output_vec_len );
            case 96:  return makeRegisterExpression(amdgpu_gfx90a::s96, output_vec_len );
            case 97:  return makeRegisterExpression(amdgpu_gfx90a::s97, output_vec_len );
            case 98:  return makeRegisterExpression(amdgpu_gfx90a::s98, output_vec_len );
            case 99:  return makeRegisterExpression(amdgpu_gfx90a::s99, output_vec_len );
            case 100:  return makeRegisterExpression(amdgpu_gfx90a::s100, output_vec_len );
            case 101:  return makeRegisterExpression(amdgpu_gfx90a::s101, output_vec_len );
            case 104:  return makeRegisterExpression(amdgpu_gfx90a::xnack_mask_lo, output_vec_len );
            case 105:  return makeRegisterExpression(amdgpu_gfx90a::xnack_mask_hi, output_vec_len );
            case 102:  return makeRegisterExpression(amdgpu_gfx90a::flat_scratch_lo, output_vec_len );
            case 103:  return makeRegisterExpression(amdgpu_gfx90a::flat_scratch_hi, output_vec_len );
            case 108:  return makeRegisterExpression(amdgpu_gfx90a::ttmp0, output_vec_len );
            case 109:  return makeRegisterExpression(amdgpu_gfx90a::ttmp1, output_vec_len );
            case 110:  return makeRegisterExpression(amdgpu_gfx90a::ttmp2, output_vec_len );
            case 111:  return makeRegisterExpression(amdgpu_gfx90a::ttmp3, output_vec_len );
            case 112:  return makeRegisterExpression(amdgpu_gfx90a::ttmp4, output_vec_len );
            case 113:  return makeRegisterExpression(amdgpu_gfx90a::ttmp5, output_vec_len );
            case 114:  return makeRegisterExpression(amdgpu_gfx90a::ttmp6, output_vec_len );
            case 115:  return makeRegisterExpression(amdgpu_gfx90a::ttmp7, output_vec_len );
            case 116:  return makeRegisterExpression(amdgpu_gfx90a::ttmp8, output_vec_len );
            case 117:  return makeRegisterExpression(amdgpu_gfx90a::ttmp9, output_vec_len );
            case 118:  return makeRegisterExpression(amdgpu_gfx90a::ttmp10, output_vec_len );
            case 119:  return makeRegisterExpression(amdgpu_gfx90a::ttmp11, output_vec_len );
            case 120:  return makeRegisterExpression(amdgpu_gfx90a::ttmp12, output_vec_len );
            case 121:  return makeRegisterExpression(amdgpu_gfx90a::ttmp13, output_vec_len );
            case 122:  return makeRegisterExpression(amdgpu_gfx90a::ttmp14, output_vec_len );
            case 123:  return makeRegisterExpression(amdgpu_gfx90a::ttmp15, output_vec_len );
            case 106:  return makeRegisterExpression(amdgpu_gfx90a::vcc_lo, output_vec_len );
            case 107:  return makeRegisterExpression(amdgpu_gfx90a::vcc_hi, output_vec_len );
            default: return makeRegisterExpression(amdgpu_gfx90a::invalid);
        }
    }

    Expression::Ptr InstructionDecoder_amdgpu_gfx90a::decodeOPR_SREG_NOVCC(uint64_t input, uint32_t output_vec_len)
    {
        switch (input)  {
            case 0:  return makeRegisterExpression(amdgpu_gfx90a::s0, output_vec_len );
            case 1:  return makeRegisterExpression(amdgpu_gfx90a::s1, output_vec_len );
            case 2:  return makeRegisterExpression(amdgpu_gfx90a::s2, output_vec_len );
            case 3:  return makeRegisterExpression(amdgpu_gfx90a::s3, output_vec_len );
            case 4:  return makeRegisterExpression(amdgpu_gfx90a::s4, output_vec_len );
            case 5:  return makeRegisterExpression(amdgpu_gfx90a::s5, output_vec_len );
            case 6:  return makeRegisterExpression(amdgpu_gfx90a::s6, output_vec_len );
            case 7:  return makeRegisterExpression(amdgpu_gfx90a::s7, output_vec_len );
            case 8:  return makeRegisterExpression(amdgpu_gfx90a::s8, output_vec_len );
            case 9:  return makeRegisterExpression(amdgpu_gfx90a::s9, output_vec_len );
            case 10:  return makeRegisterExpression(amdgpu_gfx90a::s10, output_vec_len );
            case 11:  return makeRegisterExpression(amdgpu_gfx90a::s11, output_vec_len );
            case 12:  return makeRegisterExpression(amdgpu_gfx90a::s12, output_vec_len );
            case 13:  return makeRegisterExpression(amdgpu_gfx90a::s13, output_vec_len );
            case 14:  return makeRegisterExpression(amdgpu_gfx90a::s14, output_vec_len );
            case 15:  return makeRegisterExpression(amdgpu_gfx90a::s15, output_vec_len );
            case 16:  return makeRegisterExpression(amdgpu_gfx90a::s16, output_vec_len );
            case 17:  return makeRegisterExpression(amdgpu_gfx90a::s17, output_vec_len );
            case 18:  return makeRegisterExpression(amdgpu_gfx90a::s18, output_vec_len );
            case 19:  return makeRegisterExpression(amdgpu_gfx90a::s19, output_vec_len );
            case 20:  return makeRegisterExpression(amdgpu_gfx90a::s20, output_vec_len );
            case 21:  return makeRegisterExpression(amdgpu_gfx90a::s21, output_vec_len );
            case 22:  return makeRegisterExpression(amdgpu_gfx90a::s22, output_vec_len );
            case 23:  return makeRegisterExpression(amdgpu_gfx90a::s23, output_vec_len );
            case 24:  return makeRegisterExpression(amdgpu_gfx90a::s24, output_vec_len );
            case 25:  return makeRegisterExpression(amdgpu_gfx90a::s25, output_vec_len );
            case 26:  return makeRegisterExpression(amdgpu_gfx90a::s26, output_vec_len );
            case 27:  return makeRegisterExpression(amdgpu_gfx90a::s27, output_vec_len );
            case 28:  return makeRegisterExpression(amdgpu_gfx90a::s28, output_vec_len );
            case 29:  return makeRegisterExpression(amdgpu_gfx90a::s29, output_vec_len );
            case 30:  return makeRegisterExpression(amdgpu_gfx90a::s30, output_vec_len );
            case 31:  return makeRegisterExpression(amdgpu_gfx90a::s31, output_vec_len );
            case 32:  return makeRegisterExpression(amdgpu_gfx90a::s32, output_vec_len );
            case 33:  return makeRegisterExpression(amdgpu_gfx90a::s33, output_vec_len );
            case 34:  return makeRegisterExpression(amdgpu_gfx90a::s34, output_vec_len );
            case 35:  return makeRegisterExpression(amdgpu_gfx90a::s35, output_vec_len );
            case 36:  return makeRegisterExpression(amdgpu_gfx90a::s36, output_vec_len );
            case 37:  return makeRegisterExpression(amdgpu_gfx90a::s37, output_vec_len );
            case 38:  return makeRegisterExpression(amdgpu_gfx90a::s38, output_vec_len );
            case 39:  return makeRegisterExpression(amdgpu_gfx90a::s39, output_vec_len );
            case 40:  return makeRegisterExpression(amdgpu_gfx90a::s40, output_vec_len );
            case 41:  return makeRegisterExpression(amdgpu_gfx90a::s41, output_vec_len );
            case 42:  return makeRegisterExpression(amdgpu_gfx90a::s42, output_vec_len );
            case 43:  return makeRegisterExpression(amdgpu_gfx90a::s43, output_vec_len );
            case 44:  return makeRegisterExpression(amdgpu_gfx90a::s44, output_vec_len );
            case 45:  return makeRegisterExpression(amdgpu_gfx90a::s45, output_vec_len );
            case 46:  return makeRegisterExpression(amdgpu_gfx90a::s46, output_vec_len );
            case 47:  return makeRegisterExpression(amdgpu_gfx90a::s47, output_vec_len );
            case 48:  return makeRegisterExpression(amdgpu_gfx90a::s48, output_vec_len );
            case 49:  return makeRegisterExpression(amdgpu_gfx90a::s49, output_vec_len );
            case 50:  return makeRegisterExpression(amdgpu_gfx90a::s50, output_vec_len );
            case 51:  return makeRegisterExpression(amdgpu_gfx90a::s51, output_vec_len );
            case 52:  return makeRegisterExpression(amdgpu_gfx90a::s52, output_vec_len );
            case 53:  return makeRegisterExpression(amdgpu_gfx90a::s53, output_vec_len );
            case 54:  return makeRegisterExpression(amdgpu_gfx90a::s54, output_vec_len );
            case 55:  return makeRegisterExpression(amdgpu_gfx90a::s55, output_vec_len );
            case 56:  return makeRegisterExpression(amdgpu_gfx90a::s56, output_vec_len );
            case 57:  return makeRegisterExpression(amdgpu_gfx90a::s57, output_vec_len );
            case 58:  return makeRegisterExpression(amdgpu_gfx90a::s58, output_vec_len );
            case 59:  return makeRegisterExpression(amdgpu_gfx90a::s59, output_vec_len );
            case 60:  return makeRegisterExpression(amdgpu_gfx90a::s60, output_vec_len );
            case 61:  return makeRegisterExpression(amdgpu_gfx90a::s61, output_vec_len );
            case 62:  return makeRegisterExpression(amdgpu_gfx90a::s62, output_vec_len );
            case 63:  return makeRegisterExpression(amdgpu_gfx90a::s63, output_vec_len );
            case 64:  return makeRegisterExpression(amdgpu_gfx90a::s64, output_vec_len );
            case 65:  return makeRegisterExpression(amdgpu_gfx90a::s65, output_vec_len );
            case 66:  return makeRegisterExpression(amdgpu_gfx90a::s66, output_vec_len );
            case 67:  return makeRegisterExpression(amdgpu_gfx90a::s67, output_vec_len );
            case 68:  return makeRegisterExpression(amdgpu_gfx90a::s68, output_vec_len );
            case 69:  return makeRegisterExpression(amdgpu_gfx90a::s69, output_vec_len );
            case 70:  return makeRegisterExpression(amdgpu_gfx90a::s70, output_vec_len );
            case 71:  return makeRegisterExpression(amdgpu_gfx90a::s71, output_vec_len );
            case 72:  return makeRegisterExpression(amdgpu_gfx90a::s72, output_vec_len );
            case 73:  return makeRegisterExpression(amdgpu_gfx90a::s73, output_vec_len );
            case 74:  return makeRegisterExpression(amdgpu_gfx90a::s74, output_vec_len );
            case 75:  return makeRegisterExpression(amdgpu_gfx90a::s75, output_vec_len );
            case 76:  return makeRegisterExpression(amdgpu_gfx90a::s76, output_vec_len );
            case 77:  return makeRegisterExpression(amdgpu_gfx90a::s77, output_vec_len );
            case 78:  return makeRegisterExpression(amdgpu_gfx90a::s78, output_vec_len );
            case 79:  return makeRegisterExpression(amdgpu_gfx90a::s79, output_vec_len );
            case 80:  return makeRegisterExpression(amdgpu_gfx90a::s80, output_vec_len );
            case 81:  return makeRegisterExpression(amdgpu_gfx90a::s81, output_vec_len );
            case 82:  return makeRegisterExpression(amdgpu_gfx90a::s82, output_vec_len );
            case 83:  return makeRegisterExpression(amdgpu_gfx90a::s83, output_vec_len );
            case 84:  return makeRegisterExpression(amdgpu_gfx90a::s84, output_vec_len );
            case 85:  return makeRegisterExpression(amdgpu_gfx90a::s85, output_vec_len );
            case 86:  return makeRegisterExpression(amdgpu_gfx90a::s86, output_vec_len );
            case 87:  return makeRegisterExpression(amdgpu_gfx90a::s87, output_vec_len );
            case 88:  return makeRegisterExpression(amdgpu_gfx90a::s88, output_vec_len );
            case 89:  return makeRegisterExpression(amdgpu_gfx90a::s89, output_vec_len );
            case 90:  return makeRegisterExpression(amdgpu_gfx90a::s90, output_vec_len );
            case 91:  return makeRegisterExpression(amdgpu_gfx90a::s91, output_vec_len );
            case 92:  return makeRegisterExpression(amdgpu_gfx90a::s92, output_vec_len );
            case 93:  return makeRegisterExpression(amdgpu_gfx90a::s93, output_vec_len );
            case 94:  return makeRegisterExpression(amdgpu_gfx90a::s94, output_vec_len );
            case 95:  return makeRegisterExpression(amdgpu_gfx90a::s95, output_vec_len );
            case 96:  return makeRegisterExpression(amdgpu_gfx90a::s96, output_vec_len );
            case 97:  return makeRegisterExpression(amdgpu_gfx90a::s97, output_vec_len );
            case 98:  return makeRegisterExpression(amdgpu_gfx90a::s98, output_vec_len );
            case 99:  return makeRegisterExpression(amdgpu_gfx90a::s99, output_vec_len );
            case 100:  return makeRegisterExpression(amdgpu_gfx90a::s100, output_vec_len );
            case 101:  return makeRegisterExpression(amdgpu_gfx90a::s101, output_vec_len );
            case 104:  return makeRegisterExpression(amdgpu_gfx90a::xnack_mask_lo, output_vec_len );
            case 105:  return makeRegisterExpression(amdgpu_gfx90a::xnack_mask_hi, output_vec_len );
            case 102:  return makeRegisterExpression(amdgpu_gfx90a::flat_scratch_lo, output_vec_len );
            case 103:  return makeRegisterExpression(amdgpu_gfx90a::flat_scratch_hi, output_vec_len );
            case 108:  return makeRegisterExpression(amdgpu_gfx90a::ttmp0, output_vec_len );
            case 109:  return makeRegisterExpression(amdgpu_gfx90a::ttmp1, output_vec_len );
            case 110:  return makeRegisterExpression(amdgpu_gfx90a::ttmp2, output_vec_len );
            case 111:  return makeRegisterExpression(amdgpu_gfx90a::ttmp3, output_vec_len );
            case 112:  return makeRegisterExpression(amdgpu_gfx90a::ttmp4, output_vec_len );
            case 113:  return makeRegisterExpression(amdgpu_gfx90a::ttmp5, output_vec_len );
            case 114:  return makeRegisterExpression(amdgpu_gfx90a::ttmp6, output_vec_len );
            case 115:  return makeRegisterExpression(amdgpu_gfx90a::ttmp7, output_vec_len );
            case 116:  return makeRegisterExpression(amdgpu_gfx90a::ttmp8, output_vec_len );
            case 117:  return makeRegisterExpression(amdgpu_gfx90a::ttmp9, output_vec_len );
            case 118:  return makeRegisterExpression(amdgpu_gfx90a::ttmp10, output_vec_len );
            case 119:  return makeRegisterExpression(amdgpu_gfx90a::ttmp11, output_vec_len );
            case 120:  return makeRegisterExpression(amdgpu_gfx90a::ttmp12, output_vec_len );
            case 121:  return makeRegisterExpression(amdgpu_gfx90a::ttmp13, output_vec_len );
            case 122:  return makeRegisterExpression(amdgpu_gfx90a::ttmp14, output_vec_len );
            case 123:  return makeRegisterExpression(amdgpu_gfx90a::ttmp15, output_vec_len );
            default: return makeRegisterExpression(amdgpu_gfx90a::invalid);
        }
    }

    Expression::Ptr InstructionDecoder_amdgpu_gfx90a::decodeOPR_SSRC(uint64_t input, uint32_t output_vec_len)
    {
        switch (input)  {
            case 0:  return makeRegisterExpression(amdgpu_gfx90a::s0, output_vec_len );
            case 1:  return makeRegisterExpression(amdgpu_gfx90a::s1, output_vec_len );
            case 2:  return makeRegisterExpression(amdgpu_gfx90a::s2, output_vec_len );
            case 3:  return makeRegisterExpression(amdgpu_gfx90a::s3, output_vec_len );
            case 4:  return makeRegisterExpression(amdgpu_gfx90a::s4, output_vec_len );
            case 5:  return makeRegisterExpression(amdgpu_gfx90a::s5, output_vec_len );
            case 6:  return makeRegisterExpression(amdgpu_gfx90a::s6, output_vec_len );
            case 7:  return makeRegisterExpression(amdgpu_gfx90a::s7, output_vec_len );
            case 8:  return makeRegisterExpression(amdgpu_gfx90a::s8, output_vec_len );
            case 9:  return makeRegisterExpression(amdgpu_gfx90a::s9, output_vec_len );
            case 10:  return makeRegisterExpression(amdgpu_gfx90a::s10, output_vec_len );
            case 11:  return makeRegisterExpression(amdgpu_gfx90a::s11, output_vec_len );
            case 12:  return makeRegisterExpression(amdgpu_gfx90a::s12, output_vec_len );
            case 13:  return makeRegisterExpression(amdgpu_gfx90a::s13, output_vec_len );
            case 14:  return makeRegisterExpression(amdgpu_gfx90a::s14, output_vec_len );
            case 15:  return makeRegisterExpression(amdgpu_gfx90a::s15, output_vec_len );
            case 16:  return makeRegisterExpression(amdgpu_gfx90a::s16, output_vec_len );
            case 17:  return makeRegisterExpression(amdgpu_gfx90a::s17, output_vec_len );
            case 18:  return makeRegisterExpression(amdgpu_gfx90a::s18, output_vec_len );
            case 19:  return makeRegisterExpression(amdgpu_gfx90a::s19, output_vec_len );
            case 20:  return makeRegisterExpression(amdgpu_gfx90a::s20, output_vec_len );
            case 21:  return makeRegisterExpression(amdgpu_gfx90a::s21, output_vec_len );
            case 22:  return makeRegisterExpression(amdgpu_gfx90a::s22, output_vec_len );
            case 23:  return makeRegisterExpression(amdgpu_gfx90a::s23, output_vec_len );
            case 24:  return makeRegisterExpression(amdgpu_gfx90a::s24, output_vec_len );
            case 25:  return makeRegisterExpression(amdgpu_gfx90a::s25, output_vec_len );
            case 26:  return makeRegisterExpression(amdgpu_gfx90a::s26, output_vec_len );
            case 27:  return makeRegisterExpression(amdgpu_gfx90a::s27, output_vec_len );
            case 28:  return makeRegisterExpression(amdgpu_gfx90a::s28, output_vec_len );
            case 29:  return makeRegisterExpression(amdgpu_gfx90a::s29, output_vec_len );
            case 30:  return makeRegisterExpression(amdgpu_gfx90a::s30, output_vec_len );
            case 31:  return makeRegisterExpression(amdgpu_gfx90a::s31, output_vec_len );
            case 32:  return makeRegisterExpression(amdgpu_gfx90a::s32, output_vec_len );
            case 33:  return makeRegisterExpression(amdgpu_gfx90a::s33, output_vec_len );
            case 34:  return makeRegisterExpression(amdgpu_gfx90a::s34, output_vec_len );
            case 35:  return makeRegisterExpression(amdgpu_gfx90a::s35, output_vec_len );
            case 36:  return makeRegisterExpression(amdgpu_gfx90a::s36, output_vec_len );
            case 37:  return makeRegisterExpression(amdgpu_gfx90a::s37, output_vec_len );
            case 38:  return makeRegisterExpression(amdgpu_gfx90a::s38, output_vec_len );
            case 39:  return makeRegisterExpression(amdgpu_gfx90a::s39, output_vec_len );
            case 40:  return makeRegisterExpression(amdgpu_gfx90a::s40, output_vec_len );
            case 41:  return makeRegisterExpression(amdgpu_gfx90a::s41, output_vec_len );
            case 42:  return makeRegisterExpression(amdgpu_gfx90a::s42, output_vec_len );
            case 43:  return makeRegisterExpression(amdgpu_gfx90a::s43, output_vec_len );
            case 44:  return makeRegisterExpression(amdgpu_gfx90a::s44, output_vec_len );
            case 45:  return makeRegisterExpression(amdgpu_gfx90a::s45, output_vec_len );
            case 46:  return makeRegisterExpression(amdgpu_gfx90a::s46, output_vec_len );
            case 47:  return makeRegisterExpression(amdgpu_gfx90a::s47, output_vec_len );
            case 48:  return makeRegisterExpression(amdgpu_gfx90a::s48, output_vec_len );
            case 49:  return makeRegisterExpression(amdgpu_gfx90a::s49, output_vec_len );
            case 50:  return makeRegisterExpression(amdgpu_gfx90a::s50, output_vec_len );
            case 51:  return makeRegisterExpression(amdgpu_gfx90a::s51, output_vec_len );
            case 52:  return makeRegisterExpression(amdgpu_gfx90a::s52, output_vec_len );
            case 53:  return makeRegisterExpression(amdgpu_gfx90a::s53, output_vec_len );
            case 54:  return makeRegisterExpression(amdgpu_gfx90a::s54, output_vec_len );
            case 55:  return makeRegisterExpression(amdgpu_gfx90a::s55, output_vec_len );
            case 56:  return makeRegisterExpression(amdgpu_gfx90a::s56, output_vec_len );
            case 57:  return makeRegisterExpression(amdgpu_gfx90a::s57, output_vec_len );
            case 58:  return makeRegisterExpression(amdgpu_gfx90a::s58, output_vec_len );
            case 59:  return makeRegisterExpression(amdgpu_gfx90a::s59, output_vec_len );
            case 60:  return makeRegisterExpression(amdgpu_gfx90a::s60, output_vec_len );
            case 61:  return makeRegisterExpression(amdgpu_gfx90a::s61, output_vec_len );
            case 62:  return makeRegisterExpression(amdgpu_gfx90a::s62, output_vec_len );
            case 63:  return makeRegisterExpression(amdgpu_gfx90a::s63, output_vec_len );
            case 64:  return makeRegisterExpression(amdgpu_gfx90a::s64, output_vec_len );
            case 65:  return makeRegisterExpression(amdgpu_gfx90a::s65, output_vec_len );
            case 66:  return makeRegisterExpression(amdgpu_gfx90a::s66, output_vec_len );
            case 67:  return makeRegisterExpression(amdgpu_gfx90a::s67, output_vec_len );
            case 68:  return makeRegisterExpression(amdgpu_gfx90a::s68, output_vec_len );
            case 69:  return makeRegisterExpression(amdgpu_gfx90a::s69, output_vec_len );
            case 70:  return makeRegisterExpression(amdgpu_gfx90a::s70, output_vec_len );
            case 71:  return makeRegisterExpression(amdgpu_gfx90a::s71, output_vec_len );
            case 72:  return makeRegisterExpression(amdgpu_gfx90a::s72, output_vec_len );
            case 73:  return makeRegisterExpression(amdgpu_gfx90a::s73, output_vec_len );
            case 74:  return makeRegisterExpression(amdgpu_gfx90a::s74, output_vec_len );
            case 75:  return makeRegisterExpression(amdgpu_gfx90a::s75, output_vec_len );
            case 76:  return makeRegisterExpression(amdgpu_gfx90a::s76, output_vec_len );
            case 77:  return makeRegisterExpression(amdgpu_gfx90a::s77, output_vec_len );
            case 78:  return makeRegisterExpression(amdgpu_gfx90a::s78, output_vec_len );
            case 79:  return makeRegisterExpression(amdgpu_gfx90a::s79, output_vec_len );
            case 80:  return makeRegisterExpression(amdgpu_gfx90a::s80, output_vec_len );
            case 81:  return makeRegisterExpression(amdgpu_gfx90a::s81, output_vec_len );
            case 82:  return makeRegisterExpression(amdgpu_gfx90a::s82, output_vec_len );
            case 83:  return makeRegisterExpression(amdgpu_gfx90a::s83, output_vec_len );
            case 84:  return makeRegisterExpression(amdgpu_gfx90a::s84, output_vec_len );
            case 85:  return makeRegisterExpression(amdgpu_gfx90a::s85, output_vec_len );
            case 86:  return makeRegisterExpression(amdgpu_gfx90a::s86, output_vec_len );
            case 87:  return makeRegisterExpression(amdgpu_gfx90a::s87, output_vec_len );
            case 88:  return makeRegisterExpression(amdgpu_gfx90a::s88, output_vec_len );
            case 89:  return makeRegisterExpression(amdgpu_gfx90a::s89, output_vec_len );
            case 90:  return makeRegisterExpression(amdgpu_gfx90a::s90, output_vec_len );
            case 91:  return makeRegisterExpression(amdgpu_gfx90a::s91, output_vec_len );
            case 92:  return makeRegisterExpression(amdgpu_gfx90a::s92, output_vec_len );
            case 93:  return makeRegisterExpression(amdgpu_gfx90a::s93, output_vec_len );
            case 94:  return makeRegisterExpression(amdgpu_gfx90a::s94, output_vec_len );
            case 95:  return makeRegisterExpression(amdgpu_gfx90a::s95, output_vec_len );
            case 96:  return makeRegisterExpression(amdgpu_gfx90a::s96, output_vec_len );
            case 97:  return makeRegisterExpression(amdgpu_gfx90a::s97, output_vec_len );
            case 98:  return makeRegisterExpression(amdgpu_gfx90a::s98, output_vec_len );
            case 99:  return makeRegisterExpression(amdgpu_gfx90a::s99, output_vec_len );
            case 100:  return makeRegisterExpression(amdgpu_gfx90a::s100, output_vec_len );
            case 101:  return makeRegisterExpression(amdgpu_gfx90a::s101, output_vec_len );
            case 104:  return makeRegisterExpression(amdgpu_gfx90a::xnack_mask_lo, output_vec_len );
            case 105:  return makeRegisterExpression(amdgpu_gfx90a::xnack_mask_hi, output_vec_len );
            case 102:  return makeRegisterExpression(amdgpu_gfx90a::flat_scratch_lo, output_vec_len );
            case 103:  return makeRegisterExpression(amdgpu_gfx90a::flat_scratch_hi, output_vec_len );
            case 108:  return makeRegisterExpression(amdgpu_gfx90a::ttmp0, output_vec_len );
            case 109:  return makeRegisterExpression(amdgpu_gfx90a::ttmp1, output_vec_len );
            case 110:  return makeRegisterExpression(amdgpu_gfx90a::ttmp2, output_vec_len );
            case 111:  return makeRegisterExpression(amdgpu_gfx90a::ttmp3, output_vec_len );
            case 112:  return makeRegisterExpression(amdgpu_gfx90a::ttmp4, output_vec_len );
            case 113:  return makeRegisterExpression(amdgpu_gfx90a::ttmp5, output_vec_len );
            case 114:  return makeRegisterExpression(amdgpu_gfx90a::ttmp6, output_vec_len );
            case 115:  return makeRegisterExpression(amdgpu_gfx90a::ttmp7, output_vec_len );
            case 116:  return makeRegisterExpression(amdgpu_gfx90a::ttmp8, output_vec_len );
            case 117:  return makeRegisterExpression(amdgpu_gfx90a::ttmp9, output_vec_len );
            case 118:  return makeRegisterExpression(amdgpu_gfx90a::ttmp10, output_vec_len );
            case 119:  return makeRegisterExpression(amdgpu_gfx90a::ttmp11, output_vec_len );
            case 120:  return makeRegisterExpression(amdgpu_gfx90a::ttmp12, output_vec_len );
            case 121:  return makeRegisterExpression(amdgpu_gfx90a::ttmp13, output_vec_len );
            case 122:  return makeRegisterExpression(amdgpu_gfx90a::ttmp14, output_vec_len );
            case 123:  return makeRegisterExpression(amdgpu_gfx90a::ttmp15, output_vec_len );
            case 106:  return makeRegisterExpression(amdgpu_gfx90a::vcc_lo, output_vec_len );
            case 107:  return makeRegisterExpression(amdgpu_gfx90a::vcc_hi, output_vec_len );
            case 124:  return makeRegisterExpression(amdgpu_gfx90a::m0, output_vec_len );
            case 126:  return makeRegisterExpression(amdgpu_gfx90a::exec_lo, output_vec_len );
            case 127:  return makeRegisterExpression(amdgpu_gfx90a::exec_hi, output_vec_len );
            case 128:  return Immediate::makeImmediate(Result(u32, 0));
            case 129:  return Immediate::makeImmediate(Result(u32, 1));
            case 130:  return Immediate::makeImmediate(Result(u32, 2));
            case 131:  return Immediate::makeImmediate(Result(u32, 3));
            case 132:  return Immediate::makeImmediate(Result(u32, 4));
            case 133:  return Immediate::makeImmediate(Result(u32, 5));
            case 134:  return Immediate::makeImmediate(Result(u32, 6));
            case 135:  return Immediate::makeImmediate(Result(u32, 7));
            case 136:  return Immediate::makeImmediate(Result(u32, 8));
            case 137:  return Immediate::makeImmediate(Result(u32, 9));
            case 138:  return Immediate::makeImmediate(Result(u32, 10));
            case 139:  return Immediate::makeImmediate(Result(u32, 11));
            case 140:  return Immediate::makeImmediate(Result(u32, 12));
            case 141:  return Immediate::makeImmediate(Result(u32, 13));
            case 142:  return Immediate::makeImmediate(Result(u32, 14));
            case 143:  return Immediate::makeImmediate(Result(u32, 15));
            case 144:  return Immediate::makeImmediate(Result(u32, 16));
            case 145:  return Immediate::makeImmediate(Result(u32, 17));
            case 146:  return Immediate::makeImmediate(Result(u32, 18));
            case 147:  return Immediate::makeImmediate(Result(u32, 19));
            case 148:  return Immediate::makeImmediate(Result(u32, 20));
            case 149:  return Immediate::makeImmediate(Result(u32, 21));
            case 150:  return Immediate::makeImmediate(Result(u32, 22));
            case 151:  return Immediate::makeImmediate(Result(u32, 23));
            case 152:  return Immediate::makeImmediate(Result(u32, 24));
            case 153:  return Immediate::makeImmediate(Result(u32, 25));
            case 154:  return Immediate::makeImmediate(Result(u32, 26));
            case 155:  return Immediate::makeImmediate(Result(u32, 27));
            case 156:  return Immediate::makeImmediate(Result(u32, 28));
            case 157:  return Immediate::makeImmediate(Result(u32, 29));
            case 158:  return Immediate::makeImmediate(Result(u32, 30));
            case 159:  return Immediate::makeImmediate(Result(u32, 31));
            case 160:  return Immediate::makeImmediate(Result(u32, 32));
            case 161:  return Immediate::makeImmediate(Result(u32, 33));
            case 162:  return Immediate::makeImmediate(Result(u32, 34));
            case 163:  return Immediate::makeImmediate(Result(u32, 35));
            case 164:  return Immediate::makeImmediate(Result(u32, 36));
            case 165:  return Immediate::makeImmediate(Result(u32, 37));
            case 166:  return Immediate::makeImmediate(Result(u32, 38));
            case 167:  return Immediate::makeImmediate(Result(u32, 39));
            case 168:  return Immediate::makeImmediate(Result(u32, 40));
            case 169:  return Immediate::makeImmediate(Result(u32, 41));
            case 170:  return Immediate::makeImmediate(Result(u32, 42));
            case 171:  return Immediate::makeImmediate(Result(u32, 43));
            case 172:  return Immediate::makeImmediate(Result(u32, 44));
            case 173:  return Immediate::makeImmediate(Result(u32, 45));
            case 174:  return Immediate::makeImmediate(Result(u32, 46));
            case 175:  return Immediate::makeImmediate(Result(u32, 47));
            case 176:  return Immediate::makeImmediate(Result(u32, 48));
            case 177:  return Immediate::makeImmediate(Result(u32, 49));
            case 178:  return Immediate::makeImmediate(Result(u32, 50));
            case 179:  return Immediate::makeImmediate(Result(u32, 51));
            case 180:  return Immediate::makeImmediate(Result(u32, 52));
            case 181:  return Immediate::makeImmediate(Result(u32, 53));
            case 182:  return Immediate::makeImmediate(Result(u32, 54));
            case 183:  return Immediate::makeImmediate(Result(u32, 55));
            case 184:  return Immediate::makeImmediate(Result(u32, 56));
            case 185:  return Immediate::makeImmediate(Result(u32, 57));
            case 186:  return Immediate::makeImmediate(Result(u32, 58));
            case 187:  return Immediate::makeImmediate(Result(u32, 59));
            case 188:  return Immediate::makeImmediate(Result(u32, 60));
            case 189:  return Immediate::makeImmediate(Result(u32, 61));
            case 190:  return Immediate::makeImmediate(Result(u32, 62));
            case 191:  return Immediate::makeImmediate(Result(u32, 63));
            case 192:  return Immediate::makeImmediate(Result(u32, 64));
            case 193:  return Immediate::makeImmediate(Result(u32, -1));
            case 194:  return Immediate::makeImmediate(Result(u32, -2));
            case 195:  return Immediate::makeImmediate(Result(u32, -3));
            case 196:  return Immediate::makeImmediate(Result(u32, -4));
            case 197:  return Immediate::makeImmediate(Result(u32, -5));
            case 198:  return Immediate::makeImmediate(Result(u32, -6));
            case 199:  return Immediate::makeImmediate(Result(u32, -7));
            case 200:  return Immediate::makeImmediate(Result(u32, -8));
            case 201:  return Immediate::makeImmediate(Result(u32, -9));
            case 202:  return Immediate::makeImmediate(Result(u32, -10));
            case 203:  return Immediate::makeImmediate(Result(u32, -11));
            case 204:  return Immediate::makeImmediate(Result(u32, -12));
            case 205:  return Immediate::makeImmediate(Result(u32, -13));
            case 206:  return Immediate::makeImmediate(Result(u32, -14));
            case 207:  return Immediate::makeImmediate(Result(u32, -15));
            case 208:  return Immediate::makeImmediate(Result(u32, -16));
            case 240:  return Immediate::makeImmediate(Result(sp_float, 0.5));
            case 241:  return Immediate::makeImmediate(Result(sp_float, -0.5));
            case 242:  return Immediate::makeImmediate(Result(sp_float, 1.0));
            case 243:  return Immediate::makeImmediate(Result(sp_float, -1.0));
            case 244:  return Immediate::makeImmediate(Result(sp_float, 2.0));
            case 245:  return Immediate::makeImmediate(Result(sp_float, -2.0));
            case 246:  return Immediate::makeImmediate(Result(sp_float, 4.0));
            case 247:  return Immediate::makeImmediate(Result(sp_float, -4.0));
            case 248:  return Immediate::makeImmediate(Result(sp_float, 0.15915494));
            case 251:  return makeRegisterExpression(amdgpu_gfx90a::src_vccz, output_vec_len );
            case 252:  return makeRegisterExpression(amdgpu_gfx90a::src_execz, output_vec_len );
            case 253:  return makeRegisterExpression(amdgpu_gfx90a::src_scc, output_vec_len );
            case 235:  return makeRegisterExpression(amdgpu_gfx90a::src_shared_base, output_vec_len );
            case 236:  return makeRegisterExpression(amdgpu_gfx90a::src_shared_limit, output_vec_len );
            case 237:  return makeRegisterExpression(amdgpu_gfx90a::src_private_base, output_vec_len );
            case 238:  return makeRegisterExpression(amdgpu_gfx90a::src_private_limit, output_vec_len );
            case 239:  return makeRegisterExpression(amdgpu_gfx90a::src_pops_exiting_wave_id, output_vec_len );
            case 255:  return Immediate::makeImmediate(Result(u32,decodeOPR_LITERAL()));
            case 249 :  return decodeOPR_SDWA();
            default: return makeRegisterExpression(amdgpu_gfx90a::invalid);
        }
    }

    Expression::Ptr InstructionDecoder_amdgpu_gfx90a::decodeOPR_SSRC_LANESEL(uint64_t input, uint32_t output_vec_len)
    {
        switch (input)  {
            case 0:  return makeRegisterExpression(amdgpu_gfx90a::s0, output_vec_len );
            case 1:  return makeRegisterExpression(amdgpu_gfx90a::s1, output_vec_len );
            case 2:  return makeRegisterExpression(amdgpu_gfx90a::s2, output_vec_len );
            case 3:  return makeRegisterExpression(amdgpu_gfx90a::s3, output_vec_len );
            case 4:  return makeRegisterExpression(amdgpu_gfx90a::s4, output_vec_len );
            case 5:  return makeRegisterExpression(amdgpu_gfx90a::s5, output_vec_len );
            case 6:  return makeRegisterExpression(amdgpu_gfx90a::s6, output_vec_len );
            case 7:  return makeRegisterExpression(amdgpu_gfx90a::s7, output_vec_len );
            case 8:  return makeRegisterExpression(amdgpu_gfx90a::s8, output_vec_len );
            case 9:  return makeRegisterExpression(amdgpu_gfx90a::s9, output_vec_len );
            case 10:  return makeRegisterExpression(amdgpu_gfx90a::s10, output_vec_len );
            case 11:  return makeRegisterExpression(amdgpu_gfx90a::s11, output_vec_len );
            case 12:  return makeRegisterExpression(amdgpu_gfx90a::s12, output_vec_len );
            case 13:  return makeRegisterExpression(amdgpu_gfx90a::s13, output_vec_len );
            case 14:  return makeRegisterExpression(amdgpu_gfx90a::s14, output_vec_len );
            case 15:  return makeRegisterExpression(amdgpu_gfx90a::s15, output_vec_len );
            case 16:  return makeRegisterExpression(amdgpu_gfx90a::s16, output_vec_len );
            case 17:  return makeRegisterExpression(amdgpu_gfx90a::s17, output_vec_len );
            case 18:  return makeRegisterExpression(amdgpu_gfx90a::s18, output_vec_len );
            case 19:  return makeRegisterExpression(amdgpu_gfx90a::s19, output_vec_len );
            case 20:  return makeRegisterExpression(amdgpu_gfx90a::s20, output_vec_len );
            case 21:  return makeRegisterExpression(amdgpu_gfx90a::s21, output_vec_len );
            case 22:  return makeRegisterExpression(amdgpu_gfx90a::s22, output_vec_len );
            case 23:  return makeRegisterExpression(amdgpu_gfx90a::s23, output_vec_len );
            case 24:  return makeRegisterExpression(amdgpu_gfx90a::s24, output_vec_len );
            case 25:  return makeRegisterExpression(amdgpu_gfx90a::s25, output_vec_len );
            case 26:  return makeRegisterExpression(amdgpu_gfx90a::s26, output_vec_len );
            case 27:  return makeRegisterExpression(amdgpu_gfx90a::s27, output_vec_len );
            case 28:  return makeRegisterExpression(amdgpu_gfx90a::s28, output_vec_len );
            case 29:  return makeRegisterExpression(amdgpu_gfx90a::s29, output_vec_len );
            case 30:  return makeRegisterExpression(amdgpu_gfx90a::s30, output_vec_len );
            case 31:  return makeRegisterExpression(amdgpu_gfx90a::s31, output_vec_len );
            case 32:  return makeRegisterExpression(amdgpu_gfx90a::s32, output_vec_len );
            case 33:  return makeRegisterExpression(amdgpu_gfx90a::s33, output_vec_len );
            case 34:  return makeRegisterExpression(amdgpu_gfx90a::s34, output_vec_len );
            case 35:  return makeRegisterExpression(amdgpu_gfx90a::s35, output_vec_len );
            case 36:  return makeRegisterExpression(amdgpu_gfx90a::s36, output_vec_len );
            case 37:  return makeRegisterExpression(amdgpu_gfx90a::s37, output_vec_len );
            case 38:  return makeRegisterExpression(amdgpu_gfx90a::s38, output_vec_len );
            case 39:  return makeRegisterExpression(amdgpu_gfx90a::s39, output_vec_len );
            case 40:  return makeRegisterExpression(amdgpu_gfx90a::s40, output_vec_len );
            case 41:  return makeRegisterExpression(amdgpu_gfx90a::s41, output_vec_len );
            case 42:  return makeRegisterExpression(amdgpu_gfx90a::s42, output_vec_len );
            case 43:  return makeRegisterExpression(amdgpu_gfx90a::s43, output_vec_len );
            case 44:  return makeRegisterExpression(amdgpu_gfx90a::s44, output_vec_len );
            case 45:  return makeRegisterExpression(amdgpu_gfx90a::s45, output_vec_len );
            case 46:  return makeRegisterExpression(amdgpu_gfx90a::s46, output_vec_len );
            case 47:  return makeRegisterExpression(amdgpu_gfx90a::s47, output_vec_len );
            case 48:  return makeRegisterExpression(amdgpu_gfx90a::s48, output_vec_len );
            case 49:  return makeRegisterExpression(amdgpu_gfx90a::s49, output_vec_len );
            case 50:  return makeRegisterExpression(amdgpu_gfx90a::s50, output_vec_len );
            case 51:  return makeRegisterExpression(amdgpu_gfx90a::s51, output_vec_len );
            case 52:  return makeRegisterExpression(amdgpu_gfx90a::s52, output_vec_len );
            case 53:  return makeRegisterExpression(amdgpu_gfx90a::s53, output_vec_len );
            case 54:  return makeRegisterExpression(amdgpu_gfx90a::s54, output_vec_len );
            case 55:  return makeRegisterExpression(amdgpu_gfx90a::s55, output_vec_len );
            case 56:  return makeRegisterExpression(amdgpu_gfx90a::s56, output_vec_len );
            case 57:  return makeRegisterExpression(amdgpu_gfx90a::s57, output_vec_len );
            case 58:  return makeRegisterExpression(amdgpu_gfx90a::s58, output_vec_len );
            case 59:  return makeRegisterExpression(amdgpu_gfx90a::s59, output_vec_len );
            case 60:  return makeRegisterExpression(amdgpu_gfx90a::s60, output_vec_len );
            case 61:  return makeRegisterExpression(amdgpu_gfx90a::s61, output_vec_len );
            case 62:  return makeRegisterExpression(amdgpu_gfx90a::s62, output_vec_len );
            case 63:  return makeRegisterExpression(amdgpu_gfx90a::s63, output_vec_len );
            case 64:  return makeRegisterExpression(amdgpu_gfx90a::s64, output_vec_len );
            case 65:  return makeRegisterExpression(amdgpu_gfx90a::s65, output_vec_len );
            case 66:  return makeRegisterExpression(amdgpu_gfx90a::s66, output_vec_len );
            case 67:  return makeRegisterExpression(amdgpu_gfx90a::s67, output_vec_len );
            case 68:  return makeRegisterExpression(amdgpu_gfx90a::s68, output_vec_len );
            case 69:  return makeRegisterExpression(amdgpu_gfx90a::s69, output_vec_len );
            case 70:  return makeRegisterExpression(amdgpu_gfx90a::s70, output_vec_len );
            case 71:  return makeRegisterExpression(amdgpu_gfx90a::s71, output_vec_len );
            case 72:  return makeRegisterExpression(amdgpu_gfx90a::s72, output_vec_len );
            case 73:  return makeRegisterExpression(amdgpu_gfx90a::s73, output_vec_len );
            case 74:  return makeRegisterExpression(amdgpu_gfx90a::s74, output_vec_len );
            case 75:  return makeRegisterExpression(amdgpu_gfx90a::s75, output_vec_len );
            case 76:  return makeRegisterExpression(amdgpu_gfx90a::s76, output_vec_len );
            case 77:  return makeRegisterExpression(amdgpu_gfx90a::s77, output_vec_len );
            case 78:  return makeRegisterExpression(amdgpu_gfx90a::s78, output_vec_len );
            case 79:  return makeRegisterExpression(amdgpu_gfx90a::s79, output_vec_len );
            case 80:  return makeRegisterExpression(amdgpu_gfx90a::s80, output_vec_len );
            case 81:  return makeRegisterExpression(amdgpu_gfx90a::s81, output_vec_len );
            case 82:  return makeRegisterExpression(amdgpu_gfx90a::s82, output_vec_len );
            case 83:  return makeRegisterExpression(amdgpu_gfx90a::s83, output_vec_len );
            case 84:  return makeRegisterExpression(amdgpu_gfx90a::s84, output_vec_len );
            case 85:  return makeRegisterExpression(amdgpu_gfx90a::s85, output_vec_len );
            case 86:  return makeRegisterExpression(amdgpu_gfx90a::s86, output_vec_len );
            case 87:  return makeRegisterExpression(amdgpu_gfx90a::s87, output_vec_len );
            case 88:  return makeRegisterExpression(amdgpu_gfx90a::s88, output_vec_len );
            case 89:  return makeRegisterExpression(amdgpu_gfx90a::s89, output_vec_len );
            case 90:  return makeRegisterExpression(amdgpu_gfx90a::s90, output_vec_len );
            case 91:  return makeRegisterExpression(amdgpu_gfx90a::s91, output_vec_len );
            case 92:  return makeRegisterExpression(amdgpu_gfx90a::s92, output_vec_len );
            case 93:  return makeRegisterExpression(amdgpu_gfx90a::s93, output_vec_len );
            case 94:  return makeRegisterExpression(amdgpu_gfx90a::s94, output_vec_len );
            case 95:  return makeRegisterExpression(amdgpu_gfx90a::s95, output_vec_len );
            case 96:  return makeRegisterExpression(amdgpu_gfx90a::s96, output_vec_len );
            case 97:  return makeRegisterExpression(amdgpu_gfx90a::s97, output_vec_len );
            case 98:  return makeRegisterExpression(amdgpu_gfx90a::s98, output_vec_len );
            case 99:  return makeRegisterExpression(amdgpu_gfx90a::s99, output_vec_len );
            case 100:  return makeRegisterExpression(amdgpu_gfx90a::s100, output_vec_len );
            case 101:  return makeRegisterExpression(amdgpu_gfx90a::s101, output_vec_len );
            case 104:  return makeRegisterExpression(amdgpu_gfx90a::xnack_mask_lo, output_vec_len );
            case 105:  return makeRegisterExpression(amdgpu_gfx90a::xnack_mask_hi, output_vec_len );
            case 102:  return makeRegisterExpression(amdgpu_gfx90a::flat_scratch_lo, output_vec_len );
            case 103:  return makeRegisterExpression(amdgpu_gfx90a::flat_scratch_hi, output_vec_len );
            case 108:  return makeRegisterExpression(amdgpu_gfx90a::ttmp0, output_vec_len );
            case 109:  return makeRegisterExpression(amdgpu_gfx90a::ttmp1, output_vec_len );
            case 110:  return makeRegisterExpression(amdgpu_gfx90a::ttmp2, output_vec_len );
            case 111:  return makeRegisterExpression(amdgpu_gfx90a::ttmp3, output_vec_len );
            case 112:  return makeRegisterExpression(amdgpu_gfx90a::ttmp4, output_vec_len );
            case 113:  return makeRegisterExpression(amdgpu_gfx90a::ttmp5, output_vec_len );
            case 114:  return makeRegisterExpression(amdgpu_gfx90a::ttmp6, output_vec_len );
            case 115:  return makeRegisterExpression(amdgpu_gfx90a::ttmp7, output_vec_len );
            case 116:  return makeRegisterExpression(amdgpu_gfx90a::ttmp8, output_vec_len );
            case 117:  return makeRegisterExpression(amdgpu_gfx90a::ttmp9, output_vec_len );
            case 118:  return makeRegisterExpression(amdgpu_gfx90a::ttmp10, output_vec_len );
            case 119:  return makeRegisterExpression(amdgpu_gfx90a::ttmp11, output_vec_len );
            case 120:  return makeRegisterExpression(amdgpu_gfx90a::ttmp12, output_vec_len );
            case 121:  return makeRegisterExpression(amdgpu_gfx90a::ttmp13, output_vec_len );
            case 122:  return makeRegisterExpression(amdgpu_gfx90a::ttmp14, output_vec_len );
            case 123:  return makeRegisterExpression(amdgpu_gfx90a::ttmp15, output_vec_len );
            case 106:  return makeRegisterExpression(amdgpu_gfx90a::vcc_lo, output_vec_len );
            case 107:  return makeRegisterExpression(amdgpu_gfx90a::vcc_hi, output_vec_len );
            case 124:  return makeRegisterExpression(amdgpu_gfx90a::m0, output_vec_len );
            case 128:  return Immediate::makeImmediate(Result(u32, 0));
            case 129:  return Immediate::makeImmediate(Result(u32, 1));
            case 130:  return Immediate::makeImmediate(Result(u32, 2));
            case 131:  return Immediate::makeImmediate(Result(u32, 3));
            case 132:  return Immediate::makeImmediate(Result(u32, 4));
            case 133:  return Immediate::makeImmediate(Result(u32, 5));
            case 134:  return Immediate::makeImmediate(Result(u32, 6));
            case 135:  return Immediate::makeImmediate(Result(u32, 7));
            case 136:  return Immediate::makeImmediate(Result(u32, 8));
            case 137:  return Immediate::makeImmediate(Result(u32, 9));
            case 138:  return Immediate::makeImmediate(Result(u32, 10));
            case 139:  return Immediate::makeImmediate(Result(u32, 11));
            case 140:  return Immediate::makeImmediate(Result(u32, 12));
            case 141:  return Immediate::makeImmediate(Result(u32, 13));
            case 142:  return Immediate::makeImmediate(Result(u32, 14));
            case 143:  return Immediate::makeImmediate(Result(u32, 15));
            case 144:  return Immediate::makeImmediate(Result(u32, 16));
            case 145:  return Immediate::makeImmediate(Result(u32, 17));
            case 146:  return Immediate::makeImmediate(Result(u32, 18));
            case 147:  return Immediate::makeImmediate(Result(u32, 19));
            case 148:  return Immediate::makeImmediate(Result(u32, 20));
            case 149:  return Immediate::makeImmediate(Result(u32, 21));
            case 150:  return Immediate::makeImmediate(Result(u32, 22));
            case 151:  return Immediate::makeImmediate(Result(u32, 23));
            case 152:  return Immediate::makeImmediate(Result(u32, 24));
            case 153:  return Immediate::makeImmediate(Result(u32, 25));
            case 154:  return Immediate::makeImmediate(Result(u32, 26));
            case 155:  return Immediate::makeImmediate(Result(u32, 27));
            case 156:  return Immediate::makeImmediate(Result(u32, 28));
            case 157:  return Immediate::makeImmediate(Result(u32, 29));
            case 158:  return Immediate::makeImmediate(Result(u32, 30));
            case 159:  return Immediate::makeImmediate(Result(u32, 31));
            case 160:  return Immediate::makeImmediate(Result(u32, 32));
            case 161:  return Immediate::makeImmediate(Result(u32, 33));
            case 162:  return Immediate::makeImmediate(Result(u32, 34));
            case 163:  return Immediate::makeImmediate(Result(u32, 35));
            case 164:  return Immediate::makeImmediate(Result(u32, 36));
            case 165:  return Immediate::makeImmediate(Result(u32, 37));
            case 166:  return Immediate::makeImmediate(Result(u32, 38));
            case 167:  return Immediate::makeImmediate(Result(u32, 39));
            case 168:  return Immediate::makeImmediate(Result(u32, 40));
            case 169:  return Immediate::makeImmediate(Result(u32, 41));
            case 170:  return Immediate::makeImmediate(Result(u32, 42));
            case 171:  return Immediate::makeImmediate(Result(u32, 43));
            case 172:  return Immediate::makeImmediate(Result(u32, 44));
            case 173:  return Immediate::makeImmediate(Result(u32, 45));
            case 174:  return Immediate::makeImmediate(Result(u32, 46));
            case 175:  return Immediate::makeImmediate(Result(u32, 47));
            case 176:  return Immediate::makeImmediate(Result(u32, 48));
            case 177:  return Immediate::makeImmediate(Result(u32, 49));
            case 178:  return Immediate::makeImmediate(Result(u32, 50));
            case 179:  return Immediate::makeImmediate(Result(u32, 51));
            case 180:  return Immediate::makeImmediate(Result(u32, 52));
            case 181:  return Immediate::makeImmediate(Result(u32, 53));
            case 182:  return Immediate::makeImmediate(Result(u32, 54));
            case 183:  return Immediate::makeImmediate(Result(u32, 55));
            case 184:  return Immediate::makeImmediate(Result(u32, 56));
            case 185:  return Immediate::makeImmediate(Result(u32, 57));
            case 186:  return Immediate::makeImmediate(Result(u32, 58));
            case 187:  return Immediate::makeImmediate(Result(u32, 59));
            case 188:  return Immediate::makeImmediate(Result(u32, 60));
            case 189:  return Immediate::makeImmediate(Result(u32, 61));
            case 190:  return Immediate::makeImmediate(Result(u32, 62));
            case 191:  return Immediate::makeImmediate(Result(u32, 63));
            default: return makeRegisterExpression(amdgpu_gfx90a::invalid);
        }
    }

    Expression::Ptr InstructionDecoder_amdgpu_gfx90a::decodeOPR_SSRC_NOLIT(uint64_t input, uint32_t output_vec_len)
    {
        switch (input)  {
            case 0:  return makeRegisterExpression(amdgpu_gfx90a::s0, output_vec_len );
            case 1:  return makeRegisterExpression(amdgpu_gfx90a::s1, output_vec_len );
            case 2:  return makeRegisterExpression(amdgpu_gfx90a::s2, output_vec_len );
            case 3:  return makeRegisterExpression(amdgpu_gfx90a::s3, output_vec_len );
            case 4:  return makeRegisterExpression(amdgpu_gfx90a::s4, output_vec_len );
            case 5:  return makeRegisterExpression(amdgpu_gfx90a::s5, output_vec_len );
            case 6:  return makeRegisterExpression(amdgpu_gfx90a::s6, output_vec_len );
            case 7:  return makeRegisterExpression(amdgpu_gfx90a::s7, output_vec_len );
            case 8:  return makeRegisterExpression(amdgpu_gfx90a::s8, output_vec_len );
            case 9:  return makeRegisterExpression(amdgpu_gfx90a::s9, output_vec_len );
            case 10:  return makeRegisterExpression(amdgpu_gfx90a::s10, output_vec_len );
            case 11:  return makeRegisterExpression(amdgpu_gfx90a::s11, output_vec_len );
            case 12:  return makeRegisterExpression(amdgpu_gfx90a::s12, output_vec_len );
            case 13:  return makeRegisterExpression(amdgpu_gfx90a::s13, output_vec_len );
            case 14:  return makeRegisterExpression(amdgpu_gfx90a::s14, output_vec_len );
            case 15:  return makeRegisterExpression(amdgpu_gfx90a::s15, output_vec_len );
            case 16:  return makeRegisterExpression(amdgpu_gfx90a::s16, output_vec_len );
            case 17:  return makeRegisterExpression(amdgpu_gfx90a::s17, output_vec_len );
            case 18:  return makeRegisterExpression(amdgpu_gfx90a::s18, output_vec_len );
            case 19:  return makeRegisterExpression(amdgpu_gfx90a::s19, output_vec_len );
            case 20:  return makeRegisterExpression(amdgpu_gfx90a::s20, output_vec_len );
            case 21:  return makeRegisterExpression(amdgpu_gfx90a::s21, output_vec_len );
            case 22:  return makeRegisterExpression(amdgpu_gfx90a::s22, output_vec_len );
            case 23:  return makeRegisterExpression(amdgpu_gfx90a::s23, output_vec_len );
            case 24:  return makeRegisterExpression(amdgpu_gfx90a::s24, output_vec_len );
            case 25:  return makeRegisterExpression(amdgpu_gfx90a::s25, output_vec_len );
            case 26:  return makeRegisterExpression(amdgpu_gfx90a::s26, output_vec_len );
            case 27:  return makeRegisterExpression(amdgpu_gfx90a::s27, output_vec_len );
            case 28:  return makeRegisterExpression(amdgpu_gfx90a::s28, output_vec_len );
            case 29:  return makeRegisterExpression(amdgpu_gfx90a::s29, output_vec_len );
            case 30:  return makeRegisterExpression(amdgpu_gfx90a::s30, output_vec_len );
            case 31:  return makeRegisterExpression(amdgpu_gfx90a::s31, output_vec_len );
            case 32:  return makeRegisterExpression(amdgpu_gfx90a::s32, output_vec_len );
            case 33:  return makeRegisterExpression(amdgpu_gfx90a::s33, output_vec_len );
            case 34:  return makeRegisterExpression(amdgpu_gfx90a::s34, output_vec_len );
            case 35:  return makeRegisterExpression(amdgpu_gfx90a::s35, output_vec_len );
            case 36:  return makeRegisterExpression(amdgpu_gfx90a::s36, output_vec_len );
            case 37:  return makeRegisterExpression(amdgpu_gfx90a::s37, output_vec_len );
            case 38:  return makeRegisterExpression(amdgpu_gfx90a::s38, output_vec_len );
            case 39:  return makeRegisterExpression(amdgpu_gfx90a::s39, output_vec_len );
            case 40:  return makeRegisterExpression(amdgpu_gfx90a::s40, output_vec_len );
            case 41:  return makeRegisterExpression(amdgpu_gfx90a::s41, output_vec_len );
            case 42:  return makeRegisterExpression(amdgpu_gfx90a::s42, output_vec_len );
            case 43:  return makeRegisterExpression(amdgpu_gfx90a::s43, output_vec_len );
            case 44:  return makeRegisterExpression(amdgpu_gfx90a::s44, output_vec_len );
            case 45:  return makeRegisterExpression(amdgpu_gfx90a::s45, output_vec_len );
            case 46:  return makeRegisterExpression(amdgpu_gfx90a::s46, output_vec_len );
            case 47:  return makeRegisterExpression(amdgpu_gfx90a::s47, output_vec_len );
            case 48:  return makeRegisterExpression(amdgpu_gfx90a::s48, output_vec_len );
            case 49:  return makeRegisterExpression(amdgpu_gfx90a::s49, output_vec_len );
            case 50:  return makeRegisterExpression(amdgpu_gfx90a::s50, output_vec_len );
            case 51:  return makeRegisterExpression(amdgpu_gfx90a::s51, output_vec_len );
            case 52:  return makeRegisterExpression(amdgpu_gfx90a::s52, output_vec_len );
            case 53:  return makeRegisterExpression(amdgpu_gfx90a::s53, output_vec_len );
            case 54:  return makeRegisterExpression(amdgpu_gfx90a::s54, output_vec_len );
            case 55:  return makeRegisterExpression(amdgpu_gfx90a::s55, output_vec_len );
            case 56:  return makeRegisterExpression(amdgpu_gfx90a::s56, output_vec_len );
            case 57:  return makeRegisterExpression(amdgpu_gfx90a::s57, output_vec_len );
            case 58:  return makeRegisterExpression(amdgpu_gfx90a::s58, output_vec_len );
            case 59:  return makeRegisterExpression(amdgpu_gfx90a::s59, output_vec_len );
            case 60:  return makeRegisterExpression(amdgpu_gfx90a::s60, output_vec_len );
            case 61:  return makeRegisterExpression(amdgpu_gfx90a::s61, output_vec_len );
            case 62:  return makeRegisterExpression(amdgpu_gfx90a::s62, output_vec_len );
            case 63:  return makeRegisterExpression(amdgpu_gfx90a::s63, output_vec_len );
            case 64:  return makeRegisterExpression(amdgpu_gfx90a::s64, output_vec_len );
            case 65:  return makeRegisterExpression(amdgpu_gfx90a::s65, output_vec_len );
            case 66:  return makeRegisterExpression(amdgpu_gfx90a::s66, output_vec_len );
            case 67:  return makeRegisterExpression(amdgpu_gfx90a::s67, output_vec_len );
            case 68:  return makeRegisterExpression(amdgpu_gfx90a::s68, output_vec_len );
            case 69:  return makeRegisterExpression(amdgpu_gfx90a::s69, output_vec_len );
            case 70:  return makeRegisterExpression(amdgpu_gfx90a::s70, output_vec_len );
            case 71:  return makeRegisterExpression(amdgpu_gfx90a::s71, output_vec_len );
            case 72:  return makeRegisterExpression(amdgpu_gfx90a::s72, output_vec_len );
            case 73:  return makeRegisterExpression(amdgpu_gfx90a::s73, output_vec_len );
            case 74:  return makeRegisterExpression(amdgpu_gfx90a::s74, output_vec_len );
            case 75:  return makeRegisterExpression(amdgpu_gfx90a::s75, output_vec_len );
            case 76:  return makeRegisterExpression(amdgpu_gfx90a::s76, output_vec_len );
            case 77:  return makeRegisterExpression(amdgpu_gfx90a::s77, output_vec_len );
            case 78:  return makeRegisterExpression(amdgpu_gfx90a::s78, output_vec_len );
            case 79:  return makeRegisterExpression(amdgpu_gfx90a::s79, output_vec_len );
            case 80:  return makeRegisterExpression(amdgpu_gfx90a::s80, output_vec_len );
            case 81:  return makeRegisterExpression(amdgpu_gfx90a::s81, output_vec_len );
            case 82:  return makeRegisterExpression(amdgpu_gfx90a::s82, output_vec_len );
            case 83:  return makeRegisterExpression(amdgpu_gfx90a::s83, output_vec_len );
            case 84:  return makeRegisterExpression(amdgpu_gfx90a::s84, output_vec_len );
            case 85:  return makeRegisterExpression(amdgpu_gfx90a::s85, output_vec_len );
            case 86:  return makeRegisterExpression(amdgpu_gfx90a::s86, output_vec_len );
            case 87:  return makeRegisterExpression(amdgpu_gfx90a::s87, output_vec_len );
            case 88:  return makeRegisterExpression(amdgpu_gfx90a::s88, output_vec_len );
            case 89:  return makeRegisterExpression(amdgpu_gfx90a::s89, output_vec_len );
            case 90:  return makeRegisterExpression(amdgpu_gfx90a::s90, output_vec_len );
            case 91:  return makeRegisterExpression(amdgpu_gfx90a::s91, output_vec_len );
            case 92:  return makeRegisterExpression(amdgpu_gfx90a::s92, output_vec_len );
            case 93:  return makeRegisterExpression(amdgpu_gfx90a::s93, output_vec_len );
            case 94:  return makeRegisterExpression(amdgpu_gfx90a::s94, output_vec_len );
            case 95:  return makeRegisterExpression(amdgpu_gfx90a::s95, output_vec_len );
            case 96:  return makeRegisterExpression(amdgpu_gfx90a::s96, output_vec_len );
            case 97:  return makeRegisterExpression(amdgpu_gfx90a::s97, output_vec_len );
            case 98:  return makeRegisterExpression(amdgpu_gfx90a::s98, output_vec_len );
            case 99:  return makeRegisterExpression(amdgpu_gfx90a::s99, output_vec_len );
            case 100:  return makeRegisterExpression(amdgpu_gfx90a::s100, output_vec_len );
            case 101:  return makeRegisterExpression(amdgpu_gfx90a::s101, output_vec_len );
            case 104:  return makeRegisterExpression(amdgpu_gfx90a::xnack_mask_lo, output_vec_len );
            case 105:  return makeRegisterExpression(amdgpu_gfx90a::xnack_mask_hi, output_vec_len );
            case 102:  return makeRegisterExpression(amdgpu_gfx90a::flat_scratch_lo, output_vec_len );
            case 103:  return makeRegisterExpression(amdgpu_gfx90a::flat_scratch_hi, output_vec_len );
            case 108:  return makeRegisterExpression(amdgpu_gfx90a::ttmp0, output_vec_len );
            case 109:  return makeRegisterExpression(amdgpu_gfx90a::ttmp1, output_vec_len );
            case 110:  return makeRegisterExpression(amdgpu_gfx90a::ttmp2, output_vec_len );
            case 111:  return makeRegisterExpression(amdgpu_gfx90a::ttmp3, output_vec_len );
            case 112:  return makeRegisterExpression(amdgpu_gfx90a::ttmp4, output_vec_len );
            case 113:  return makeRegisterExpression(amdgpu_gfx90a::ttmp5, output_vec_len );
            case 114:  return makeRegisterExpression(amdgpu_gfx90a::ttmp6, output_vec_len );
            case 115:  return makeRegisterExpression(amdgpu_gfx90a::ttmp7, output_vec_len );
            case 116:  return makeRegisterExpression(amdgpu_gfx90a::ttmp8, output_vec_len );
            case 117:  return makeRegisterExpression(amdgpu_gfx90a::ttmp9, output_vec_len );
            case 118:  return makeRegisterExpression(amdgpu_gfx90a::ttmp10, output_vec_len );
            case 119:  return makeRegisterExpression(amdgpu_gfx90a::ttmp11, output_vec_len );
            case 120:  return makeRegisterExpression(amdgpu_gfx90a::ttmp12, output_vec_len );
            case 121:  return makeRegisterExpression(amdgpu_gfx90a::ttmp13, output_vec_len );
            case 122:  return makeRegisterExpression(amdgpu_gfx90a::ttmp14, output_vec_len );
            case 123:  return makeRegisterExpression(amdgpu_gfx90a::ttmp15, output_vec_len );
            case 106:  return makeRegisterExpression(amdgpu_gfx90a::vcc_lo, output_vec_len );
            case 107:  return makeRegisterExpression(amdgpu_gfx90a::vcc_hi, output_vec_len );
            case 124:  return makeRegisterExpression(amdgpu_gfx90a::m0, output_vec_len );
            case 126:  return makeRegisterExpression(amdgpu_gfx90a::exec_lo, output_vec_len );
            case 127:  return makeRegisterExpression(amdgpu_gfx90a::exec_hi, output_vec_len );
            case 128:  return Immediate::makeImmediate(Result(u32, 0));
            case 129:  return Immediate::makeImmediate(Result(u32, 1));
            case 130:  return Immediate::makeImmediate(Result(u32, 2));
            case 131:  return Immediate::makeImmediate(Result(u32, 3));
            case 132:  return Immediate::makeImmediate(Result(u32, 4));
            case 133:  return Immediate::makeImmediate(Result(u32, 5));
            case 134:  return Immediate::makeImmediate(Result(u32, 6));
            case 135:  return Immediate::makeImmediate(Result(u32, 7));
            case 136:  return Immediate::makeImmediate(Result(u32, 8));
            case 137:  return Immediate::makeImmediate(Result(u32, 9));
            case 138:  return Immediate::makeImmediate(Result(u32, 10));
            case 139:  return Immediate::makeImmediate(Result(u32, 11));
            case 140:  return Immediate::makeImmediate(Result(u32, 12));
            case 141:  return Immediate::makeImmediate(Result(u32, 13));
            case 142:  return Immediate::makeImmediate(Result(u32, 14));
            case 143:  return Immediate::makeImmediate(Result(u32, 15));
            case 144:  return Immediate::makeImmediate(Result(u32, 16));
            case 145:  return Immediate::makeImmediate(Result(u32, 17));
            case 146:  return Immediate::makeImmediate(Result(u32, 18));
            case 147:  return Immediate::makeImmediate(Result(u32, 19));
            case 148:  return Immediate::makeImmediate(Result(u32, 20));
            case 149:  return Immediate::makeImmediate(Result(u32, 21));
            case 150:  return Immediate::makeImmediate(Result(u32, 22));
            case 151:  return Immediate::makeImmediate(Result(u32, 23));
            case 152:  return Immediate::makeImmediate(Result(u32, 24));
            case 153:  return Immediate::makeImmediate(Result(u32, 25));
            case 154:  return Immediate::makeImmediate(Result(u32, 26));
            case 155:  return Immediate::makeImmediate(Result(u32, 27));
            case 156:  return Immediate::makeImmediate(Result(u32, 28));
            case 157:  return Immediate::makeImmediate(Result(u32, 29));
            case 158:  return Immediate::makeImmediate(Result(u32, 30));
            case 159:  return Immediate::makeImmediate(Result(u32, 31));
            case 160:  return Immediate::makeImmediate(Result(u32, 32));
            case 161:  return Immediate::makeImmediate(Result(u32, 33));
            case 162:  return Immediate::makeImmediate(Result(u32, 34));
            case 163:  return Immediate::makeImmediate(Result(u32, 35));
            case 164:  return Immediate::makeImmediate(Result(u32, 36));
            case 165:  return Immediate::makeImmediate(Result(u32, 37));
            case 166:  return Immediate::makeImmediate(Result(u32, 38));
            case 167:  return Immediate::makeImmediate(Result(u32, 39));
            case 168:  return Immediate::makeImmediate(Result(u32, 40));
            case 169:  return Immediate::makeImmediate(Result(u32, 41));
            case 170:  return Immediate::makeImmediate(Result(u32, 42));
            case 171:  return Immediate::makeImmediate(Result(u32, 43));
            case 172:  return Immediate::makeImmediate(Result(u32, 44));
            case 173:  return Immediate::makeImmediate(Result(u32, 45));
            case 174:  return Immediate::makeImmediate(Result(u32, 46));
            case 175:  return Immediate::makeImmediate(Result(u32, 47));
            case 176:  return Immediate::makeImmediate(Result(u32, 48));
            case 177:  return Immediate::makeImmediate(Result(u32, 49));
            case 178:  return Immediate::makeImmediate(Result(u32, 50));
            case 179:  return Immediate::makeImmediate(Result(u32, 51));
            case 180:  return Immediate::makeImmediate(Result(u32, 52));
            case 181:  return Immediate::makeImmediate(Result(u32, 53));
            case 182:  return Immediate::makeImmediate(Result(u32, 54));
            case 183:  return Immediate::makeImmediate(Result(u32, 55));
            case 184:  return Immediate::makeImmediate(Result(u32, 56));
            case 185:  return Immediate::makeImmediate(Result(u32, 57));
            case 186:  return Immediate::makeImmediate(Result(u32, 58));
            case 187:  return Immediate::makeImmediate(Result(u32, 59));
            case 188:  return Immediate::makeImmediate(Result(u32, 60));
            case 189:  return Immediate::makeImmediate(Result(u32, 61));
            case 190:  return Immediate::makeImmediate(Result(u32, 62));
            case 191:  return Immediate::makeImmediate(Result(u32, 63));
            case 192:  return Immediate::makeImmediate(Result(u32, 64));
            case 193:  return Immediate::makeImmediate(Result(u32, -1));
            case 194:  return Immediate::makeImmediate(Result(u32, -2));
            case 195:  return Immediate::makeImmediate(Result(u32, -3));
            case 196:  return Immediate::makeImmediate(Result(u32, -4));
            case 197:  return Immediate::makeImmediate(Result(u32, -5));
            case 198:  return Immediate::makeImmediate(Result(u32, -6));
            case 199:  return Immediate::makeImmediate(Result(u32, -7));
            case 200:  return Immediate::makeImmediate(Result(u32, -8));
            case 201:  return Immediate::makeImmediate(Result(u32, -9));
            case 202:  return Immediate::makeImmediate(Result(u32, -10));
            case 203:  return Immediate::makeImmediate(Result(u32, -11));
            case 204:  return Immediate::makeImmediate(Result(u32, -12));
            case 205:  return Immediate::makeImmediate(Result(u32, -13));
            case 206:  return Immediate::makeImmediate(Result(u32, -14));
            case 207:  return Immediate::makeImmediate(Result(u32, -15));
            case 208:  return Immediate::makeImmediate(Result(u32, -16));
            case 240:  return Immediate::makeImmediate(Result(sp_float, 0.5));
            case 241:  return Immediate::makeImmediate(Result(sp_float, -0.5));
            case 242:  return Immediate::makeImmediate(Result(sp_float, 1.0));
            case 243:  return Immediate::makeImmediate(Result(sp_float, -1.0));
            case 244:  return Immediate::makeImmediate(Result(sp_float, 2.0));
            case 245:  return Immediate::makeImmediate(Result(sp_float, -2.0));
            case 246:  return Immediate::makeImmediate(Result(sp_float, 4.0));
            case 247:  return Immediate::makeImmediate(Result(sp_float, -4.0));
            case 248:  return Immediate::makeImmediate(Result(sp_float, 0.15915494));
            case 251:  return makeRegisterExpression(amdgpu_gfx90a::src_vccz, output_vec_len );
            case 252:  return makeRegisterExpression(amdgpu_gfx90a::src_execz, output_vec_len );
            case 253:  return makeRegisterExpression(amdgpu_gfx90a::src_scc, output_vec_len );
            case 235:  return makeRegisterExpression(amdgpu_gfx90a::src_shared_base, output_vec_len );
            case 236:  return makeRegisterExpression(amdgpu_gfx90a::src_shared_limit, output_vec_len );
            case 237:  return makeRegisterExpression(amdgpu_gfx90a::src_private_base, output_vec_len );
            case 238:  return makeRegisterExpression(amdgpu_gfx90a::src_private_limit, output_vec_len );
            case 239:  return makeRegisterExpression(amdgpu_gfx90a::src_pops_exiting_wave_id, output_vec_len );
            default: return makeRegisterExpression(amdgpu_gfx90a::invalid);
        }
    }

    Expression::Ptr InstructionDecoder_amdgpu_gfx90a::decodeOPR_SSRC_SPECIAL_SCC(uint64_t input, uint32_t output_vec_len)
    {
        switch (input)  {
            case 253:  return makeRegisterExpression(amdgpu_gfx90a::src_scc, output_vec_len );
            default: return makeRegisterExpression(amdgpu_gfx90a::invalid);
        }
    }

    Expression::Ptr InstructionDecoder_amdgpu_gfx90a::decodeOPR_VCC(uint64_t input, uint32_t )
    {
        switch (input)  {
            case 0:  return makeRegisterExpression(amdgpu_gfx90a::vcc);
            default: return makeRegisterExpression(amdgpu_gfx90a::invalid);
        }
    }

    Expression::Ptr InstructionDecoder_amdgpu_gfx90a::decodeOPR_VGPR(uint64_t input, uint32_t output_vec_len)
    {
        switch (input)  {
            case 0:  return makeRegisterExpression(amdgpu_gfx90a::v0, output_vec_len );
            case 1:  return makeRegisterExpression(amdgpu_gfx90a::v1, output_vec_len );
            case 2:  return makeRegisterExpression(amdgpu_gfx90a::v2, output_vec_len );
            case 3:  return makeRegisterExpression(amdgpu_gfx90a::v3, output_vec_len );
            case 4:  return makeRegisterExpression(amdgpu_gfx90a::v4, output_vec_len );
            case 5:  return makeRegisterExpression(amdgpu_gfx90a::v5, output_vec_len );
            case 6:  return makeRegisterExpression(amdgpu_gfx90a::v6, output_vec_len );
            case 7:  return makeRegisterExpression(amdgpu_gfx90a::v7, output_vec_len );
            case 8:  return makeRegisterExpression(amdgpu_gfx90a::v8, output_vec_len );
            case 9:  return makeRegisterExpression(amdgpu_gfx90a::v9, output_vec_len );
            case 10:  return makeRegisterExpression(amdgpu_gfx90a::v10, output_vec_len );
            case 11:  return makeRegisterExpression(amdgpu_gfx90a::v11, output_vec_len );
            case 12:  return makeRegisterExpression(amdgpu_gfx90a::v12, output_vec_len );
            case 13:  return makeRegisterExpression(amdgpu_gfx90a::v13, output_vec_len );
            case 14:  return makeRegisterExpression(amdgpu_gfx90a::v14, output_vec_len );
            case 15:  return makeRegisterExpression(amdgpu_gfx90a::v15, output_vec_len );
            case 16:  return makeRegisterExpression(amdgpu_gfx90a::v16, output_vec_len );
            case 17:  return makeRegisterExpression(amdgpu_gfx90a::v17, output_vec_len );
            case 18:  return makeRegisterExpression(amdgpu_gfx90a::v18, output_vec_len );
            case 19:  return makeRegisterExpression(amdgpu_gfx90a::v19, output_vec_len );
            case 20:  return makeRegisterExpression(amdgpu_gfx90a::v20, output_vec_len );
            case 21:  return makeRegisterExpression(amdgpu_gfx90a::v21, output_vec_len );
            case 22:  return makeRegisterExpression(amdgpu_gfx90a::v22, output_vec_len );
            case 23:  return makeRegisterExpression(amdgpu_gfx90a::v23, output_vec_len );
            case 24:  return makeRegisterExpression(amdgpu_gfx90a::v24, output_vec_len );
            case 25:  return makeRegisterExpression(amdgpu_gfx90a::v25, output_vec_len );
            case 26:  return makeRegisterExpression(amdgpu_gfx90a::v26, output_vec_len );
            case 27:  return makeRegisterExpression(amdgpu_gfx90a::v27, output_vec_len );
            case 28:  return makeRegisterExpression(amdgpu_gfx90a::v28, output_vec_len );
            case 29:  return makeRegisterExpression(amdgpu_gfx90a::v29, output_vec_len );
            case 30:  return makeRegisterExpression(amdgpu_gfx90a::v30, output_vec_len );
            case 31:  return makeRegisterExpression(amdgpu_gfx90a::v31, output_vec_len );
            case 32:  return makeRegisterExpression(amdgpu_gfx90a::v32, output_vec_len );
            case 33:  return makeRegisterExpression(amdgpu_gfx90a::v33, output_vec_len );
            case 34:  return makeRegisterExpression(amdgpu_gfx90a::v34, output_vec_len );
            case 35:  return makeRegisterExpression(amdgpu_gfx90a::v35, output_vec_len );
            case 36:  return makeRegisterExpression(amdgpu_gfx90a::v36, output_vec_len );
            case 37:  return makeRegisterExpression(amdgpu_gfx90a::v37, output_vec_len );
            case 38:  return makeRegisterExpression(amdgpu_gfx90a::v38, output_vec_len );
            case 39:  return makeRegisterExpression(amdgpu_gfx90a::v39, output_vec_len );
            case 40:  return makeRegisterExpression(amdgpu_gfx90a::v40, output_vec_len );
            case 41:  return makeRegisterExpression(amdgpu_gfx90a::v41, output_vec_len );
            case 42:  return makeRegisterExpression(amdgpu_gfx90a::v42, output_vec_len );
            case 43:  return makeRegisterExpression(amdgpu_gfx90a::v43, output_vec_len );
            case 44:  return makeRegisterExpression(amdgpu_gfx90a::v44, output_vec_len );
            case 45:  return makeRegisterExpression(amdgpu_gfx90a::v45, output_vec_len );
            case 46:  return makeRegisterExpression(amdgpu_gfx90a::v46, output_vec_len );
            case 47:  return makeRegisterExpression(amdgpu_gfx90a::v47, output_vec_len );
            case 48:  return makeRegisterExpression(amdgpu_gfx90a::v48, output_vec_len );
            case 49:  return makeRegisterExpression(amdgpu_gfx90a::v49, output_vec_len );
            case 50:  return makeRegisterExpression(amdgpu_gfx90a::v50, output_vec_len );
            case 51:  return makeRegisterExpression(amdgpu_gfx90a::v51, output_vec_len );
            case 52:  return makeRegisterExpression(amdgpu_gfx90a::v52, output_vec_len );
            case 53:  return makeRegisterExpression(amdgpu_gfx90a::v53, output_vec_len );
            case 54:  return makeRegisterExpression(amdgpu_gfx90a::v54, output_vec_len );
            case 55:  return makeRegisterExpression(amdgpu_gfx90a::v55, output_vec_len );
            case 56:  return makeRegisterExpression(amdgpu_gfx90a::v56, output_vec_len );
            case 57:  return makeRegisterExpression(amdgpu_gfx90a::v57, output_vec_len );
            case 58:  return makeRegisterExpression(amdgpu_gfx90a::v58, output_vec_len );
            case 59:  return makeRegisterExpression(amdgpu_gfx90a::v59, output_vec_len );
            case 60:  return makeRegisterExpression(amdgpu_gfx90a::v60, output_vec_len );
            case 61:  return makeRegisterExpression(amdgpu_gfx90a::v61, output_vec_len );
            case 62:  return makeRegisterExpression(amdgpu_gfx90a::v62, output_vec_len );
            case 63:  return makeRegisterExpression(amdgpu_gfx90a::v63, output_vec_len );
            case 64:  return makeRegisterExpression(amdgpu_gfx90a::v64, output_vec_len );
            case 65:  return makeRegisterExpression(amdgpu_gfx90a::v65, output_vec_len );
            case 66:  return makeRegisterExpression(amdgpu_gfx90a::v66, output_vec_len );
            case 67:  return makeRegisterExpression(amdgpu_gfx90a::v67, output_vec_len );
            case 68:  return makeRegisterExpression(amdgpu_gfx90a::v68, output_vec_len );
            case 69:  return makeRegisterExpression(amdgpu_gfx90a::v69, output_vec_len );
            case 70:  return makeRegisterExpression(amdgpu_gfx90a::v70, output_vec_len );
            case 71:  return makeRegisterExpression(amdgpu_gfx90a::v71, output_vec_len );
            case 72:  return makeRegisterExpression(amdgpu_gfx90a::v72, output_vec_len );
            case 73:  return makeRegisterExpression(amdgpu_gfx90a::v73, output_vec_len );
            case 74:  return makeRegisterExpression(amdgpu_gfx90a::v74, output_vec_len );
            case 75:  return makeRegisterExpression(amdgpu_gfx90a::v75, output_vec_len );
            case 76:  return makeRegisterExpression(amdgpu_gfx90a::v76, output_vec_len );
            case 77:  return makeRegisterExpression(amdgpu_gfx90a::v77, output_vec_len );
            case 78:  return makeRegisterExpression(amdgpu_gfx90a::v78, output_vec_len );
            case 79:  return makeRegisterExpression(amdgpu_gfx90a::v79, output_vec_len );
            case 80:  return makeRegisterExpression(amdgpu_gfx90a::v80, output_vec_len );
            case 81:  return makeRegisterExpression(amdgpu_gfx90a::v81, output_vec_len );
            case 82:  return makeRegisterExpression(amdgpu_gfx90a::v82, output_vec_len );
            case 83:  return makeRegisterExpression(amdgpu_gfx90a::v83, output_vec_len );
            case 84:  return makeRegisterExpression(amdgpu_gfx90a::v84, output_vec_len );
            case 85:  return makeRegisterExpression(amdgpu_gfx90a::v85, output_vec_len );
            case 86:  return makeRegisterExpression(amdgpu_gfx90a::v86, output_vec_len );
            case 87:  return makeRegisterExpression(amdgpu_gfx90a::v87, output_vec_len );
            case 88:  return makeRegisterExpression(amdgpu_gfx90a::v88, output_vec_len );
            case 89:  return makeRegisterExpression(amdgpu_gfx90a::v89, output_vec_len );
            case 90:  return makeRegisterExpression(amdgpu_gfx90a::v90, output_vec_len );
            case 91:  return makeRegisterExpression(amdgpu_gfx90a::v91, output_vec_len );
            case 92:  return makeRegisterExpression(amdgpu_gfx90a::v92, output_vec_len );
            case 93:  return makeRegisterExpression(amdgpu_gfx90a::v93, output_vec_len );
            case 94:  return makeRegisterExpression(amdgpu_gfx90a::v94, output_vec_len );
            case 95:  return makeRegisterExpression(amdgpu_gfx90a::v95, output_vec_len );
            case 96:  return makeRegisterExpression(amdgpu_gfx90a::v96, output_vec_len );
            case 97:  return makeRegisterExpression(amdgpu_gfx90a::v97, output_vec_len );
            case 98:  return makeRegisterExpression(amdgpu_gfx90a::v98, output_vec_len );
            case 99:  return makeRegisterExpression(amdgpu_gfx90a::v99, output_vec_len );
            case 100:  return makeRegisterExpression(amdgpu_gfx90a::v100, output_vec_len );
            case 101:  return makeRegisterExpression(amdgpu_gfx90a::v101, output_vec_len );
            case 102:  return makeRegisterExpression(amdgpu_gfx90a::v102, output_vec_len );
            case 103:  return makeRegisterExpression(amdgpu_gfx90a::v103, output_vec_len );
            case 104:  return makeRegisterExpression(amdgpu_gfx90a::v104, output_vec_len );
            case 105:  return makeRegisterExpression(amdgpu_gfx90a::v105, output_vec_len );
            case 106:  return makeRegisterExpression(amdgpu_gfx90a::v106, output_vec_len );
            case 107:  return makeRegisterExpression(amdgpu_gfx90a::v107, output_vec_len );
            case 108:  return makeRegisterExpression(amdgpu_gfx90a::v108, output_vec_len );
            case 109:  return makeRegisterExpression(amdgpu_gfx90a::v109, output_vec_len );
            case 110:  return makeRegisterExpression(amdgpu_gfx90a::v110, output_vec_len );
            case 111:  return makeRegisterExpression(amdgpu_gfx90a::v111, output_vec_len );
            case 112:  return makeRegisterExpression(amdgpu_gfx90a::v112, output_vec_len );
            case 113:  return makeRegisterExpression(amdgpu_gfx90a::v113, output_vec_len );
            case 114:  return makeRegisterExpression(amdgpu_gfx90a::v114, output_vec_len );
            case 115:  return makeRegisterExpression(amdgpu_gfx90a::v115, output_vec_len );
            case 116:  return makeRegisterExpression(amdgpu_gfx90a::v116, output_vec_len );
            case 117:  return makeRegisterExpression(amdgpu_gfx90a::v117, output_vec_len );
            case 118:  return makeRegisterExpression(amdgpu_gfx90a::v118, output_vec_len );
            case 119:  return makeRegisterExpression(amdgpu_gfx90a::v119, output_vec_len );
            case 120:  return makeRegisterExpression(amdgpu_gfx90a::v120, output_vec_len );
            case 121:  return makeRegisterExpression(amdgpu_gfx90a::v121, output_vec_len );
            case 122:  return makeRegisterExpression(amdgpu_gfx90a::v122, output_vec_len );
            case 123:  return makeRegisterExpression(amdgpu_gfx90a::v123, output_vec_len );
            case 124:  return makeRegisterExpression(amdgpu_gfx90a::v124, output_vec_len );
            case 125:  return makeRegisterExpression(amdgpu_gfx90a::v125, output_vec_len );
            case 126:  return makeRegisterExpression(amdgpu_gfx90a::v126, output_vec_len );
            case 127:  return makeRegisterExpression(amdgpu_gfx90a::v127, output_vec_len );
            case 128:  return makeRegisterExpression(amdgpu_gfx90a::v128, output_vec_len );
            case 129:  return makeRegisterExpression(amdgpu_gfx90a::v129, output_vec_len );
            case 130:  return makeRegisterExpression(amdgpu_gfx90a::v130, output_vec_len );
            case 131:  return makeRegisterExpression(amdgpu_gfx90a::v131, output_vec_len );
            case 132:  return makeRegisterExpression(amdgpu_gfx90a::v132, output_vec_len );
            case 133:  return makeRegisterExpression(amdgpu_gfx90a::v133, output_vec_len );
            case 134:  return makeRegisterExpression(amdgpu_gfx90a::v134, output_vec_len );
            case 135:  return makeRegisterExpression(amdgpu_gfx90a::v135, output_vec_len );
            case 136:  return makeRegisterExpression(amdgpu_gfx90a::v136, output_vec_len );
            case 137:  return makeRegisterExpression(amdgpu_gfx90a::v137, output_vec_len );
            case 138:  return makeRegisterExpression(amdgpu_gfx90a::v138, output_vec_len );
            case 139:  return makeRegisterExpression(amdgpu_gfx90a::v139, output_vec_len );
            case 140:  return makeRegisterExpression(amdgpu_gfx90a::v140, output_vec_len );
            case 141:  return makeRegisterExpression(amdgpu_gfx90a::v141, output_vec_len );
            case 142:  return makeRegisterExpression(amdgpu_gfx90a::v142, output_vec_len );
            case 143:  return makeRegisterExpression(amdgpu_gfx90a::v143, output_vec_len );
            case 144:  return makeRegisterExpression(amdgpu_gfx90a::v144, output_vec_len );
            case 145:  return makeRegisterExpression(amdgpu_gfx90a::v145, output_vec_len );
            case 146:  return makeRegisterExpression(amdgpu_gfx90a::v146, output_vec_len );
            case 147:  return makeRegisterExpression(amdgpu_gfx90a::v147, output_vec_len );
            case 148:  return makeRegisterExpression(amdgpu_gfx90a::v148, output_vec_len );
            case 149:  return makeRegisterExpression(amdgpu_gfx90a::v149, output_vec_len );
            case 150:  return makeRegisterExpression(amdgpu_gfx90a::v150, output_vec_len );
            case 151:  return makeRegisterExpression(amdgpu_gfx90a::v151, output_vec_len );
            case 152:  return makeRegisterExpression(amdgpu_gfx90a::v152, output_vec_len );
            case 153:  return makeRegisterExpression(amdgpu_gfx90a::v153, output_vec_len );
            case 154:  return makeRegisterExpression(amdgpu_gfx90a::v154, output_vec_len );
            case 155:  return makeRegisterExpression(amdgpu_gfx90a::v155, output_vec_len );
            case 156:  return makeRegisterExpression(amdgpu_gfx90a::v156, output_vec_len );
            case 157:  return makeRegisterExpression(amdgpu_gfx90a::v157, output_vec_len );
            case 158:  return makeRegisterExpression(amdgpu_gfx90a::v158, output_vec_len );
            case 159:  return makeRegisterExpression(amdgpu_gfx90a::v159, output_vec_len );
            case 160:  return makeRegisterExpression(amdgpu_gfx90a::v160, output_vec_len );
            case 161:  return makeRegisterExpression(amdgpu_gfx90a::v161, output_vec_len );
            case 162:  return makeRegisterExpression(amdgpu_gfx90a::v162, output_vec_len );
            case 163:  return makeRegisterExpression(amdgpu_gfx90a::v163, output_vec_len );
            case 164:  return makeRegisterExpression(amdgpu_gfx90a::v164, output_vec_len );
            case 165:  return makeRegisterExpression(amdgpu_gfx90a::v165, output_vec_len );
            case 166:  return makeRegisterExpression(amdgpu_gfx90a::v166, output_vec_len );
            case 167:  return makeRegisterExpression(amdgpu_gfx90a::v167, output_vec_len );
            case 168:  return makeRegisterExpression(amdgpu_gfx90a::v168, output_vec_len );
            case 169:  return makeRegisterExpression(amdgpu_gfx90a::v169, output_vec_len );
            case 170:  return makeRegisterExpression(amdgpu_gfx90a::v170, output_vec_len );
            case 171:  return makeRegisterExpression(amdgpu_gfx90a::v171, output_vec_len );
            case 172:  return makeRegisterExpression(amdgpu_gfx90a::v172, output_vec_len );
            case 173:  return makeRegisterExpression(amdgpu_gfx90a::v173, output_vec_len );
            case 174:  return makeRegisterExpression(amdgpu_gfx90a::v174, output_vec_len );
            case 175:  return makeRegisterExpression(amdgpu_gfx90a::v175, output_vec_len );
            case 176:  return makeRegisterExpression(amdgpu_gfx90a::v176, output_vec_len );
            case 177:  return makeRegisterExpression(amdgpu_gfx90a::v177, output_vec_len );
            case 178:  return makeRegisterExpression(amdgpu_gfx90a::v178, output_vec_len );
            case 179:  return makeRegisterExpression(amdgpu_gfx90a::v179, output_vec_len );
            case 180:  return makeRegisterExpression(amdgpu_gfx90a::v180, output_vec_len );
            case 181:  return makeRegisterExpression(amdgpu_gfx90a::v181, output_vec_len );
            case 182:  return makeRegisterExpression(amdgpu_gfx90a::v182, output_vec_len );
            case 183:  return makeRegisterExpression(amdgpu_gfx90a::v183, output_vec_len );
            case 184:  return makeRegisterExpression(amdgpu_gfx90a::v184, output_vec_len );
            case 185:  return makeRegisterExpression(amdgpu_gfx90a::v185, output_vec_len );
            case 186:  return makeRegisterExpression(amdgpu_gfx90a::v186, output_vec_len );
            case 187:  return makeRegisterExpression(amdgpu_gfx90a::v187, output_vec_len );
            case 188:  return makeRegisterExpression(amdgpu_gfx90a::v188, output_vec_len );
            case 189:  return makeRegisterExpression(amdgpu_gfx90a::v189, output_vec_len );
            case 190:  return makeRegisterExpression(amdgpu_gfx90a::v190, output_vec_len );
            case 191:  return makeRegisterExpression(amdgpu_gfx90a::v191, output_vec_len );
            case 192:  return makeRegisterExpression(amdgpu_gfx90a::v192, output_vec_len );
            case 193:  return makeRegisterExpression(amdgpu_gfx90a::v193, output_vec_len );
            case 194:  return makeRegisterExpression(amdgpu_gfx90a::v194, output_vec_len );
            case 195:  return makeRegisterExpression(amdgpu_gfx90a::v195, output_vec_len );
            case 196:  return makeRegisterExpression(amdgpu_gfx90a::v196, output_vec_len );
            case 197:  return makeRegisterExpression(amdgpu_gfx90a::v197, output_vec_len );
            case 198:  return makeRegisterExpression(amdgpu_gfx90a::v198, output_vec_len );
            case 199:  return makeRegisterExpression(amdgpu_gfx90a::v199, output_vec_len );
            case 200:  return makeRegisterExpression(amdgpu_gfx90a::v200, output_vec_len );
            case 201:  return makeRegisterExpression(amdgpu_gfx90a::v201, output_vec_len );
            case 202:  return makeRegisterExpression(amdgpu_gfx90a::v202, output_vec_len );
            case 203:  return makeRegisterExpression(amdgpu_gfx90a::v203, output_vec_len );
            case 204:  return makeRegisterExpression(amdgpu_gfx90a::v204, output_vec_len );
            case 205:  return makeRegisterExpression(amdgpu_gfx90a::v205, output_vec_len );
            case 206:  return makeRegisterExpression(amdgpu_gfx90a::v206, output_vec_len );
            case 207:  return makeRegisterExpression(amdgpu_gfx90a::v207, output_vec_len );
            case 208:  return makeRegisterExpression(amdgpu_gfx90a::v208, output_vec_len );
            case 209:  return makeRegisterExpression(amdgpu_gfx90a::v209, output_vec_len );
            case 210:  return makeRegisterExpression(amdgpu_gfx90a::v210, output_vec_len );
            case 211:  return makeRegisterExpression(amdgpu_gfx90a::v211, output_vec_len );
            case 212:  return makeRegisterExpression(amdgpu_gfx90a::v212, output_vec_len );
            case 213:  return makeRegisterExpression(amdgpu_gfx90a::v213, output_vec_len );
            case 214:  return makeRegisterExpression(amdgpu_gfx90a::v214, output_vec_len );
            case 215:  return makeRegisterExpression(amdgpu_gfx90a::v215, output_vec_len );
            case 216:  return makeRegisterExpression(amdgpu_gfx90a::v216, output_vec_len );
            case 217:  return makeRegisterExpression(amdgpu_gfx90a::v217, output_vec_len );
            case 218:  return makeRegisterExpression(amdgpu_gfx90a::v218, output_vec_len );
            case 219:  return makeRegisterExpression(amdgpu_gfx90a::v219, output_vec_len );
            case 220:  return makeRegisterExpression(amdgpu_gfx90a::v220, output_vec_len );
            case 221:  return makeRegisterExpression(amdgpu_gfx90a::v221, output_vec_len );
            case 222:  return makeRegisterExpression(amdgpu_gfx90a::v222, output_vec_len );
            case 223:  return makeRegisterExpression(amdgpu_gfx90a::v223, output_vec_len );
            case 224:  return makeRegisterExpression(amdgpu_gfx90a::v224, output_vec_len );
            case 225:  return makeRegisterExpression(amdgpu_gfx90a::v225, output_vec_len );
            case 226:  return makeRegisterExpression(amdgpu_gfx90a::v226, output_vec_len );
            case 227:  return makeRegisterExpression(amdgpu_gfx90a::v227, output_vec_len );
            case 228:  return makeRegisterExpression(amdgpu_gfx90a::v228, output_vec_len );
            case 229:  return makeRegisterExpression(amdgpu_gfx90a::v229, output_vec_len );
            case 230:  return makeRegisterExpression(amdgpu_gfx90a::v230, output_vec_len );
            case 231:  return makeRegisterExpression(amdgpu_gfx90a::v231, output_vec_len );
            case 232:  return makeRegisterExpression(amdgpu_gfx90a::v232, output_vec_len );
            case 233:  return makeRegisterExpression(amdgpu_gfx90a::v233, output_vec_len );
            case 234:  return makeRegisterExpression(amdgpu_gfx90a::v234, output_vec_len );
            case 235:  return makeRegisterExpression(amdgpu_gfx90a::v235, output_vec_len );
            case 236:  return makeRegisterExpression(amdgpu_gfx90a::v236, output_vec_len );
            case 237:  return makeRegisterExpression(amdgpu_gfx90a::v237, output_vec_len );
            case 238:  return makeRegisterExpression(amdgpu_gfx90a::v238, output_vec_len );
            case 239:  return makeRegisterExpression(amdgpu_gfx90a::v239, output_vec_len );
            case 240:  return makeRegisterExpression(amdgpu_gfx90a::v240, output_vec_len );
            case 241:  return makeRegisterExpression(amdgpu_gfx90a::v241, output_vec_len );
            case 242:  return makeRegisterExpression(amdgpu_gfx90a::v242, output_vec_len );
            case 243:  return makeRegisterExpression(amdgpu_gfx90a::v243, output_vec_len );
            case 244:  return makeRegisterExpression(amdgpu_gfx90a::v244, output_vec_len );
            case 245:  return makeRegisterExpression(amdgpu_gfx90a::v245, output_vec_len );
            case 246:  return makeRegisterExpression(amdgpu_gfx90a::v246, output_vec_len );
            case 247:  return makeRegisterExpression(amdgpu_gfx90a::v247, output_vec_len );
            case 248:  return makeRegisterExpression(amdgpu_gfx90a::v248, output_vec_len );
            case 249:  return makeRegisterExpression(amdgpu_gfx90a::v249, output_vec_len );
            case 250:  return makeRegisterExpression(amdgpu_gfx90a::v250, output_vec_len );
            case 251:  return makeRegisterExpression(amdgpu_gfx90a::v251, output_vec_len );
            case 252:  return makeRegisterExpression(amdgpu_gfx90a::v252, output_vec_len );
            case 253:  return makeRegisterExpression(amdgpu_gfx90a::v253, output_vec_len );
            case 254:  return makeRegisterExpression(amdgpu_gfx90a::v254, output_vec_len );
            case 255:  return makeRegisterExpression(amdgpu_gfx90a::v255, output_vec_len );
            default: return makeRegisterExpression(amdgpu_gfx90a::invalid);
        }
    }

    Expression::Ptr InstructionDecoder_amdgpu_gfx90a::decodeOPR_VGPR_OR_ACCVGPR(uint64_t input, uint32_t output_vec_len)
    {
        switch (input)  {
            case 0:  return makeRegisterExpression(amdgpu_gfx90a::v0, output_vec_len );
            case 1:  return makeRegisterExpression(amdgpu_gfx90a::v1, output_vec_len );
            case 2:  return makeRegisterExpression(amdgpu_gfx90a::v2, output_vec_len );
            case 3:  return makeRegisterExpression(amdgpu_gfx90a::v3, output_vec_len );
            case 4:  return makeRegisterExpression(amdgpu_gfx90a::v4, output_vec_len );
            case 5:  return makeRegisterExpression(amdgpu_gfx90a::v5, output_vec_len );
            case 6:  return makeRegisterExpression(amdgpu_gfx90a::v6, output_vec_len );
            case 7:  return makeRegisterExpression(amdgpu_gfx90a::v7, output_vec_len );
            case 8:  return makeRegisterExpression(amdgpu_gfx90a::v8, output_vec_len );
            case 9:  return makeRegisterExpression(amdgpu_gfx90a::v9, output_vec_len );
            case 10:  return makeRegisterExpression(amdgpu_gfx90a::v10, output_vec_len );
            case 11:  return makeRegisterExpression(amdgpu_gfx90a::v11, output_vec_len );
            case 12:  return makeRegisterExpression(amdgpu_gfx90a::v12, output_vec_len );
            case 13:  return makeRegisterExpression(amdgpu_gfx90a::v13, output_vec_len );
            case 14:  return makeRegisterExpression(amdgpu_gfx90a::v14, output_vec_len );
            case 15:  return makeRegisterExpression(amdgpu_gfx90a::v15, output_vec_len );
            case 16:  return makeRegisterExpression(amdgpu_gfx90a::v16, output_vec_len );
            case 17:  return makeRegisterExpression(amdgpu_gfx90a::v17, output_vec_len );
            case 18:  return makeRegisterExpression(amdgpu_gfx90a::v18, output_vec_len );
            case 19:  return makeRegisterExpression(amdgpu_gfx90a::v19, output_vec_len );
            case 20:  return makeRegisterExpression(amdgpu_gfx90a::v20, output_vec_len );
            case 21:  return makeRegisterExpression(amdgpu_gfx90a::v21, output_vec_len );
            case 22:  return makeRegisterExpression(amdgpu_gfx90a::v22, output_vec_len );
            case 23:  return makeRegisterExpression(amdgpu_gfx90a::v23, output_vec_len );
            case 24:  return makeRegisterExpression(amdgpu_gfx90a::v24, output_vec_len );
            case 25:  return makeRegisterExpression(amdgpu_gfx90a::v25, output_vec_len );
            case 26:  return makeRegisterExpression(amdgpu_gfx90a::v26, output_vec_len );
            case 27:  return makeRegisterExpression(amdgpu_gfx90a::v27, output_vec_len );
            case 28:  return makeRegisterExpression(amdgpu_gfx90a::v28, output_vec_len );
            case 29:  return makeRegisterExpression(amdgpu_gfx90a::v29, output_vec_len );
            case 30:  return makeRegisterExpression(amdgpu_gfx90a::v30, output_vec_len );
            case 31:  return makeRegisterExpression(amdgpu_gfx90a::v31, output_vec_len );
            case 32:  return makeRegisterExpression(amdgpu_gfx90a::v32, output_vec_len );
            case 33:  return makeRegisterExpression(amdgpu_gfx90a::v33, output_vec_len );
            case 34:  return makeRegisterExpression(amdgpu_gfx90a::v34, output_vec_len );
            case 35:  return makeRegisterExpression(amdgpu_gfx90a::v35, output_vec_len );
            case 36:  return makeRegisterExpression(amdgpu_gfx90a::v36, output_vec_len );
            case 37:  return makeRegisterExpression(amdgpu_gfx90a::v37, output_vec_len );
            case 38:  return makeRegisterExpression(amdgpu_gfx90a::v38, output_vec_len );
            case 39:  return makeRegisterExpression(amdgpu_gfx90a::v39, output_vec_len );
            case 40:  return makeRegisterExpression(amdgpu_gfx90a::v40, output_vec_len );
            case 41:  return makeRegisterExpression(amdgpu_gfx90a::v41, output_vec_len );
            case 42:  return makeRegisterExpression(amdgpu_gfx90a::v42, output_vec_len );
            case 43:  return makeRegisterExpression(amdgpu_gfx90a::v43, output_vec_len );
            case 44:  return makeRegisterExpression(amdgpu_gfx90a::v44, output_vec_len );
            case 45:  return makeRegisterExpression(amdgpu_gfx90a::v45, output_vec_len );
            case 46:  return makeRegisterExpression(amdgpu_gfx90a::v46, output_vec_len );
            case 47:  return makeRegisterExpression(amdgpu_gfx90a::v47, output_vec_len );
            case 48:  return makeRegisterExpression(amdgpu_gfx90a::v48, output_vec_len );
            case 49:  return makeRegisterExpression(amdgpu_gfx90a::v49, output_vec_len );
            case 50:  return makeRegisterExpression(amdgpu_gfx90a::v50, output_vec_len );
            case 51:  return makeRegisterExpression(amdgpu_gfx90a::v51, output_vec_len );
            case 52:  return makeRegisterExpression(amdgpu_gfx90a::v52, output_vec_len );
            case 53:  return makeRegisterExpression(amdgpu_gfx90a::v53, output_vec_len );
            case 54:  return makeRegisterExpression(amdgpu_gfx90a::v54, output_vec_len );
            case 55:  return makeRegisterExpression(amdgpu_gfx90a::v55, output_vec_len );
            case 56:  return makeRegisterExpression(amdgpu_gfx90a::v56, output_vec_len );
            case 57:  return makeRegisterExpression(amdgpu_gfx90a::v57, output_vec_len );
            case 58:  return makeRegisterExpression(amdgpu_gfx90a::v58, output_vec_len );
            case 59:  return makeRegisterExpression(amdgpu_gfx90a::v59, output_vec_len );
            case 60:  return makeRegisterExpression(amdgpu_gfx90a::v60, output_vec_len );
            case 61:  return makeRegisterExpression(amdgpu_gfx90a::v61, output_vec_len );
            case 62:  return makeRegisterExpression(amdgpu_gfx90a::v62, output_vec_len );
            case 63:  return makeRegisterExpression(amdgpu_gfx90a::v63, output_vec_len );
            case 64:  return makeRegisterExpression(amdgpu_gfx90a::v64, output_vec_len );
            case 65:  return makeRegisterExpression(amdgpu_gfx90a::v65, output_vec_len );
            case 66:  return makeRegisterExpression(amdgpu_gfx90a::v66, output_vec_len );
            case 67:  return makeRegisterExpression(amdgpu_gfx90a::v67, output_vec_len );
            case 68:  return makeRegisterExpression(amdgpu_gfx90a::v68, output_vec_len );
            case 69:  return makeRegisterExpression(amdgpu_gfx90a::v69, output_vec_len );
            case 70:  return makeRegisterExpression(amdgpu_gfx90a::v70, output_vec_len );
            case 71:  return makeRegisterExpression(amdgpu_gfx90a::v71, output_vec_len );
            case 72:  return makeRegisterExpression(amdgpu_gfx90a::v72, output_vec_len );
            case 73:  return makeRegisterExpression(amdgpu_gfx90a::v73, output_vec_len );
            case 74:  return makeRegisterExpression(amdgpu_gfx90a::v74, output_vec_len );
            case 75:  return makeRegisterExpression(amdgpu_gfx90a::v75, output_vec_len );
            case 76:  return makeRegisterExpression(amdgpu_gfx90a::v76, output_vec_len );
            case 77:  return makeRegisterExpression(amdgpu_gfx90a::v77, output_vec_len );
            case 78:  return makeRegisterExpression(amdgpu_gfx90a::v78, output_vec_len );
            case 79:  return makeRegisterExpression(amdgpu_gfx90a::v79, output_vec_len );
            case 80:  return makeRegisterExpression(amdgpu_gfx90a::v80, output_vec_len );
            case 81:  return makeRegisterExpression(amdgpu_gfx90a::v81, output_vec_len );
            case 82:  return makeRegisterExpression(amdgpu_gfx90a::v82, output_vec_len );
            case 83:  return makeRegisterExpression(amdgpu_gfx90a::v83, output_vec_len );
            case 84:  return makeRegisterExpression(amdgpu_gfx90a::v84, output_vec_len );
            case 85:  return makeRegisterExpression(amdgpu_gfx90a::v85, output_vec_len );
            case 86:  return makeRegisterExpression(amdgpu_gfx90a::v86, output_vec_len );
            case 87:  return makeRegisterExpression(amdgpu_gfx90a::v87, output_vec_len );
            case 88:  return makeRegisterExpression(amdgpu_gfx90a::v88, output_vec_len );
            case 89:  return makeRegisterExpression(amdgpu_gfx90a::v89, output_vec_len );
            case 90:  return makeRegisterExpression(amdgpu_gfx90a::v90, output_vec_len );
            case 91:  return makeRegisterExpression(amdgpu_gfx90a::v91, output_vec_len );
            case 92:  return makeRegisterExpression(amdgpu_gfx90a::v92, output_vec_len );
            case 93:  return makeRegisterExpression(amdgpu_gfx90a::v93, output_vec_len );
            case 94:  return makeRegisterExpression(amdgpu_gfx90a::v94, output_vec_len );
            case 95:  return makeRegisterExpression(amdgpu_gfx90a::v95, output_vec_len );
            case 96:  return makeRegisterExpression(amdgpu_gfx90a::v96, output_vec_len );
            case 97:  return makeRegisterExpression(amdgpu_gfx90a::v97, output_vec_len );
            case 98:  return makeRegisterExpression(amdgpu_gfx90a::v98, output_vec_len );
            case 99:  return makeRegisterExpression(amdgpu_gfx90a::v99, output_vec_len );
            case 100:  return makeRegisterExpression(amdgpu_gfx90a::v100, output_vec_len );
            case 101:  return makeRegisterExpression(amdgpu_gfx90a::v101, output_vec_len );
            case 102:  return makeRegisterExpression(amdgpu_gfx90a::v102, output_vec_len );
            case 103:  return makeRegisterExpression(amdgpu_gfx90a::v103, output_vec_len );
            case 104:  return makeRegisterExpression(amdgpu_gfx90a::v104, output_vec_len );
            case 105:  return makeRegisterExpression(amdgpu_gfx90a::v105, output_vec_len );
            case 106:  return makeRegisterExpression(amdgpu_gfx90a::v106, output_vec_len );
            case 107:  return makeRegisterExpression(amdgpu_gfx90a::v107, output_vec_len );
            case 108:  return makeRegisterExpression(amdgpu_gfx90a::v108, output_vec_len );
            case 109:  return makeRegisterExpression(amdgpu_gfx90a::v109, output_vec_len );
            case 110:  return makeRegisterExpression(amdgpu_gfx90a::v110, output_vec_len );
            case 111:  return makeRegisterExpression(amdgpu_gfx90a::v111, output_vec_len );
            case 112:  return makeRegisterExpression(amdgpu_gfx90a::v112, output_vec_len );
            case 113:  return makeRegisterExpression(amdgpu_gfx90a::v113, output_vec_len );
            case 114:  return makeRegisterExpression(amdgpu_gfx90a::v114, output_vec_len );
            case 115:  return makeRegisterExpression(amdgpu_gfx90a::v115, output_vec_len );
            case 116:  return makeRegisterExpression(amdgpu_gfx90a::v116, output_vec_len );
            case 117:  return makeRegisterExpression(amdgpu_gfx90a::v117, output_vec_len );
            case 118:  return makeRegisterExpression(amdgpu_gfx90a::v118, output_vec_len );
            case 119:  return makeRegisterExpression(amdgpu_gfx90a::v119, output_vec_len );
            case 120:  return makeRegisterExpression(amdgpu_gfx90a::v120, output_vec_len );
            case 121:  return makeRegisterExpression(amdgpu_gfx90a::v121, output_vec_len );
            case 122:  return makeRegisterExpression(amdgpu_gfx90a::v122, output_vec_len );
            case 123:  return makeRegisterExpression(amdgpu_gfx90a::v123, output_vec_len );
            case 124:  return makeRegisterExpression(amdgpu_gfx90a::v124, output_vec_len );
            case 125:  return makeRegisterExpression(amdgpu_gfx90a::v125, output_vec_len );
            case 126:  return makeRegisterExpression(amdgpu_gfx90a::v126, output_vec_len );
            case 127:  return makeRegisterExpression(amdgpu_gfx90a::v127, output_vec_len );
            case 128:  return makeRegisterExpression(amdgpu_gfx90a::v128, output_vec_len );
            case 129:  return makeRegisterExpression(amdgpu_gfx90a::v129, output_vec_len );
            case 130:  return makeRegisterExpression(amdgpu_gfx90a::v130, output_vec_len );
            case 131:  return makeRegisterExpression(amdgpu_gfx90a::v131, output_vec_len );
            case 132:  return makeRegisterExpression(amdgpu_gfx90a::v132, output_vec_len );
            case 133:  return makeRegisterExpression(amdgpu_gfx90a::v133, output_vec_len );
            case 134:  return makeRegisterExpression(amdgpu_gfx90a::v134, output_vec_len );
            case 135:  return makeRegisterExpression(amdgpu_gfx90a::v135, output_vec_len );
            case 136:  return makeRegisterExpression(amdgpu_gfx90a::v136, output_vec_len );
            case 137:  return makeRegisterExpression(amdgpu_gfx90a::v137, output_vec_len );
            case 138:  return makeRegisterExpression(amdgpu_gfx90a::v138, output_vec_len );
            case 139:  return makeRegisterExpression(amdgpu_gfx90a::v139, output_vec_len );
            case 140:  return makeRegisterExpression(amdgpu_gfx90a::v140, output_vec_len );
            case 141:  return makeRegisterExpression(amdgpu_gfx90a::v141, output_vec_len );
            case 142:  return makeRegisterExpression(amdgpu_gfx90a::v142, output_vec_len );
            case 143:  return makeRegisterExpression(amdgpu_gfx90a::v143, output_vec_len );
            case 144:  return makeRegisterExpression(amdgpu_gfx90a::v144, output_vec_len );
            case 145:  return makeRegisterExpression(amdgpu_gfx90a::v145, output_vec_len );
            case 146:  return makeRegisterExpression(amdgpu_gfx90a::v146, output_vec_len );
            case 147:  return makeRegisterExpression(amdgpu_gfx90a::v147, output_vec_len );
            case 148:  return makeRegisterExpression(amdgpu_gfx90a::v148, output_vec_len );
            case 149:  return makeRegisterExpression(amdgpu_gfx90a::v149, output_vec_len );
            case 150:  return makeRegisterExpression(amdgpu_gfx90a::v150, output_vec_len );
            case 151:  return makeRegisterExpression(amdgpu_gfx90a::v151, output_vec_len );
            case 152:  return makeRegisterExpression(amdgpu_gfx90a::v152, output_vec_len );
            case 153:  return makeRegisterExpression(amdgpu_gfx90a::v153, output_vec_len );
            case 154:  return makeRegisterExpression(amdgpu_gfx90a::v154, output_vec_len );
            case 155:  return makeRegisterExpression(amdgpu_gfx90a::v155, output_vec_len );
            case 156:  return makeRegisterExpression(amdgpu_gfx90a::v156, output_vec_len );
            case 157:  return makeRegisterExpression(amdgpu_gfx90a::v157, output_vec_len );
            case 158:  return makeRegisterExpression(amdgpu_gfx90a::v158, output_vec_len );
            case 159:  return makeRegisterExpression(amdgpu_gfx90a::v159, output_vec_len );
            case 160:  return makeRegisterExpression(amdgpu_gfx90a::v160, output_vec_len );
            case 161:  return makeRegisterExpression(amdgpu_gfx90a::v161, output_vec_len );
            case 162:  return makeRegisterExpression(amdgpu_gfx90a::v162, output_vec_len );
            case 163:  return makeRegisterExpression(amdgpu_gfx90a::v163, output_vec_len );
            case 164:  return makeRegisterExpression(amdgpu_gfx90a::v164, output_vec_len );
            case 165:  return makeRegisterExpression(amdgpu_gfx90a::v165, output_vec_len );
            case 166:  return makeRegisterExpression(amdgpu_gfx90a::v166, output_vec_len );
            case 167:  return makeRegisterExpression(amdgpu_gfx90a::v167, output_vec_len );
            case 168:  return makeRegisterExpression(amdgpu_gfx90a::v168, output_vec_len );
            case 169:  return makeRegisterExpression(amdgpu_gfx90a::v169, output_vec_len );
            case 170:  return makeRegisterExpression(amdgpu_gfx90a::v170, output_vec_len );
            case 171:  return makeRegisterExpression(amdgpu_gfx90a::v171, output_vec_len );
            case 172:  return makeRegisterExpression(amdgpu_gfx90a::v172, output_vec_len );
            case 173:  return makeRegisterExpression(amdgpu_gfx90a::v173, output_vec_len );
            case 174:  return makeRegisterExpression(amdgpu_gfx90a::v174, output_vec_len );
            case 175:  return makeRegisterExpression(amdgpu_gfx90a::v175, output_vec_len );
            case 176:  return makeRegisterExpression(amdgpu_gfx90a::v176, output_vec_len );
            case 177:  return makeRegisterExpression(amdgpu_gfx90a::v177, output_vec_len );
            case 178:  return makeRegisterExpression(amdgpu_gfx90a::v178, output_vec_len );
            case 179:  return makeRegisterExpression(amdgpu_gfx90a::v179, output_vec_len );
            case 180:  return makeRegisterExpression(amdgpu_gfx90a::v180, output_vec_len );
            case 181:  return makeRegisterExpression(amdgpu_gfx90a::v181, output_vec_len );
            case 182:  return makeRegisterExpression(amdgpu_gfx90a::v182, output_vec_len );
            case 183:  return makeRegisterExpression(amdgpu_gfx90a::v183, output_vec_len );
            case 184:  return makeRegisterExpression(amdgpu_gfx90a::v184, output_vec_len );
            case 185:  return makeRegisterExpression(amdgpu_gfx90a::v185, output_vec_len );
            case 186:  return makeRegisterExpression(amdgpu_gfx90a::v186, output_vec_len );
            case 187:  return makeRegisterExpression(amdgpu_gfx90a::v187, output_vec_len );
            case 188:  return makeRegisterExpression(amdgpu_gfx90a::v188, output_vec_len );
            case 189:  return makeRegisterExpression(amdgpu_gfx90a::v189, output_vec_len );
            case 190:  return makeRegisterExpression(amdgpu_gfx90a::v190, output_vec_len );
            case 191:  return makeRegisterExpression(amdgpu_gfx90a::v191, output_vec_len );
            case 192:  return makeRegisterExpression(amdgpu_gfx90a::v192, output_vec_len );
            case 193:  return makeRegisterExpression(amdgpu_gfx90a::v193, output_vec_len );
            case 194:  return makeRegisterExpression(amdgpu_gfx90a::v194, output_vec_len );
            case 195:  return makeRegisterExpression(amdgpu_gfx90a::v195, output_vec_len );
            case 196:  return makeRegisterExpression(amdgpu_gfx90a::v196, output_vec_len );
            case 197:  return makeRegisterExpression(amdgpu_gfx90a::v197, output_vec_len );
            case 198:  return makeRegisterExpression(amdgpu_gfx90a::v198, output_vec_len );
            case 199:  return makeRegisterExpression(amdgpu_gfx90a::v199, output_vec_len );
            case 200:  return makeRegisterExpression(amdgpu_gfx90a::v200, output_vec_len );
            case 201:  return makeRegisterExpression(amdgpu_gfx90a::v201, output_vec_len );
            case 202:  return makeRegisterExpression(amdgpu_gfx90a::v202, output_vec_len );
            case 203:  return makeRegisterExpression(amdgpu_gfx90a::v203, output_vec_len );
            case 204:  return makeRegisterExpression(amdgpu_gfx90a::v204, output_vec_len );
            case 205:  return makeRegisterExpression(amdgpu_gfx90a::v205, output_vec_len );
            case 206:  return makeRegisterExpression(amdgpu_gfx90a::v206, output_vec_len );
            case 207:  return makeRegisterExpression(amdgpu_gfx90a::v207, output_vec_len );
            case 208:  return makeRegisterExpression(amdgpu_gfx90a::v208, output_vec_len );
            case 209:  return makeRegisterExpression(amdgpu_gfx90a::v209, output_vec_len );
            case 210:  return makeRegisterExpression(amdgpu_gfx90a::v210, output_vec_len );
            case 211:  return makeRegisterExpression(amdgpu_gfx90a::v211, output_vec_len );
            case 212:  return makeRegisterExpression(amdgpu_gfx90a::v212, output_vec_len );
            case 213:  return makeRegisterExpression(amdgpu_gfx90a::v213, output_vec_len );
            case 214:  return makeRegisterExpression(amdgpu_gfx90a::v214, output_vec_len );
            case 215:  return makeRegisterExpression(amdgpu_gfx90a::v215, output_vec_len );
            case 216:  return makeRegisterExpression(amdgpu_gfx90a::v216, output_vec_len );
            case 217:  return makeRegisterExpression(amdgpu_gfx90a::v217, output_vec_len );
            case 218:  return makeRegisterExpression(amdgpu_gfx90a::v218, output_vec_len );
            case 219:  return makeRegisterExpression(amdgpu_gfx90a::v219, output_vec_len );
            case 220:  return makeRegisterExpression(amdgpu_gfx90a::v220, output_vec_len );
            case 221:  return makeRegisterExpression(amdgpu_gfx90a::v221, output_vec_len );
            case 222:  return makeRegisterExpression(amdgpu_gfx90a::v222, output_vec_len );
            case 223:  return makeRegisterExpression(amdgpu_gfx90a::v223, output_vec_len );
            case 224:  return makeRegisterExpression(amdgpu_gfx90a::v224, output_vec_len );
            case 225:  return makeRegisterExpression(amdgpu_gfx90a::v225, output_vec_len );
            case 226:  return makeRegisterExpression(amdgpu_gfx90a::v226, output_vec_len );
            case 227:  return makeRegisterExpression(amdgpu_gfx90a::v227, output_vec_len );
            case 228:  return makeRegisterExpression(amdgpu_gfx90a::v228, output_vec_len );
            case 229:  return makeRegisterExpression(amdgpu_gfx90a::v229, output_vec_len );
            case 230:  return makeRegisterExpression(amdgpu_gfx90a::v230, output_vec_len );
            case 231:  return makeRegisterExpression(amdgpu_gfx90a::v231, output_vec_len );
            case 232:  return makeRegisterExpression(amdgpu_gfx90a::v232, output_vec_len );
            case 233:  return makeRegisterExpression(amdgpu_gfx90a::v233, output_vec_len );
            case 234:  return makeRegisterExpression(amdgpu_gfx90a::v234, output_vec_len );
            case 235:  return makeRegisterExpression(amdgpu_gfx90a::v235, output_vec_len );
            case 236:  return makeRegisterExpression(amdgpu_gfx90a::v236, output_vec_len );
            case 237:  return makeRegisterExpression(amdgpu_gfx90a::v237, output_vec_len );
            case 238:  return makeRegisterExpression(amdgpu_gfx90a::v238, output_vec_len );
            case 239:  return makeRegisterExpression(amdgpu_gfx90a::v239, output_vec_len );
            case 240:  return makeRegisterExpression(amdgpu_gfx90a::v240, output_vec_len );
            case 241:  return makeRegisterExpression(amdgpu_gfx90a::v241, output_vec_len );
            case 242:  return makeRegisterExpression(amdgpu_gfx90a::v242, output_vec_len );
            case 243:  return makeRegisterExpression(amdgpu_gfx90a::v243, output_vec_len );
            case 244:  return makeRegisterExpression(amdgpu_gfx90a::v244, output_vec_len );
            case 245:  return makeRegisterExpression(amdgpu_gfx90a::v245, output_vec_len );
            case 246:  return makeRegisterExpression(amdgpu_gfx90a::v246, output_vec_len );
            case 247:  return makeRegisterExpression(amdgpu_gfx90a::v247, output_vec_len );
            case 248:  return makeRegisterExpression(amdgpu_gfx90a::v248, output_vec_len );
            case 249:  return makeRegisterExpression(amdgpu_gfx90a::v249, output_vec_len );
            case 250:  return makeRegisterExpression(amdgpu_gfx90a::v250, output_vec_len );
            case 251:  return makeRegisterExpression(amdgpu_gfx90a::v251, output_vec_len );
            case 252:  return makeRegisterExpression(amdgpu_gfx90a::v252, output_vec_len );
            case 253:  return makeRegisterExpression(amdgpu_gfx90a::v253, output_vec_len );
            case 254:  return makeRegisterExpression(amdgpu_gfx90a::v254, output_vec_len );
            case 255:  return makeRegisterExpression(amdgpu_gfx90a::v255, output_vec_len );
            case 512:  return makeRegisterExpression(amdgpu_gfx90a::acc0, output_vec_len );
            case 513:  return makeRegisterExpression(amdgpu_gfx90a::acc1, output_vec_len );
            case 514:  return makeRegisterExpression(amdgpu_gfx90a::acc2, output_vec_len );
            case 515:  return makeRegisterExpression(amdgpu_gfx90a::acc3, output_vec_len );
            case 516:  return makeRegisterExpression(amdgpu_gfx90a::acc4, output_vec_len );
            case 517:  return makeRegisterExpression(amdgpu_gfx90a::acc5, output_vec_len );
            case 518:  return makeRegisterExpression(amdgpu_gfx90a::acc6, output_vec_len );
            case 519:  return makeRegisterExpression(amdgpu_gfx90a::acc7, output_vec_len );
            case 520:  return makeRegisterExpression(amdgpu_gfx90a::acc8, output_vec_len );
            case 521:  return makeRegisterExpression(amdgpu_gfx90a::acc9, output_vec_len );
            case 522:  return makeRegisterExpression(amdgpu_gfx90a::acc10, output_vec_len );
            case 523:  return makeRegisterExpression(amdgpu_gfx90a::acc11, output_vec_len );
            case 524:  return makeRegisterExpression(amdgpu_gfx90a::acc12, output_vec_len );
            case 525:  return makeRegisterExpression(amdgpu_gfx90a::acc13, output_vec_len );
            case 526:  return makeRegisterExpression(amdgpu_gfx90a::acc14, output_vec_len );
            case 527:  return makeRegisterExpression(amdgpu_gfx90a::acc15, output_vec_len );
            case 528:  return makeRegisterExpression(amdgpu_gfx90a::acc16, output_vec_len );
            case 529:  return makeRegisterExpression(amdgpu_gfx90a::acc17, output_vec_len );
            case 530:  return makeRegisterExpression(amdgpu_gfx90a::acc18, output_vec_len );
            case 531:  return makeRegisterExpression(amdgpu_gfx90a::acc19, output_vec_len );
            case 532:  return makeRegisterExpression(amdgpu_gfx90a::acc20, output_vec_len );
            case 533:  return makeRegisterExpression(amdgpu_gfx90a::acc21, output_vec_len );
            case 534:  return makeRegisterExpression(amdgpu_gfx90a::acc22, output_vec_len );
            case 535:  return makeRegisterExpression(amdgpu_gfx90a::acc23, output_vec_len );
            case 536:  return makeRegisterExpression(amdgpu_gfx90a::acc24, output_vec_len );
            case 537:  return makeRegisterExpression(amdgpu_gfx90a::acc25, output_vec_len );
            case 538:  return makeRegisterExpression(amdgpu_gfx90a::acc26, output_vec_len );
            case 539:  return makeRegisterExpression(amdgpu_gfx90a::acc27, output_vec_len );
            case 540:  return makeRegisterExpression(amdgpu_gfx90a::acc28, output_vec_len );
            case 541:  return makeRegisterExpression(amdgpu_gfx90a::acc29, output_vec_len );
            case 542:  return makeRegisterExpression(amdgpu_gfx90a::acc30, output_vec_len );
            case 543:  return makeRegisterExpression(amdgpu_gfx90a::acc31, output_vec_len );
            case 544:  return makeRegisterExpression(amdgpu_gfx90a::acc32, output_vec_len );
            case 545:  return makeRegisterExpression(amdgpu_gfx90a::acc33, output_vec_len );
            case 546:  return makeRegisterExpression(amdgpu_gfx90a::acc34, output_vec_len );
            case 547:  return makeRegisterExpression(amdgpu_gfx90a::acc35, output_vec_len );
            case 548:  return makeRegisterExpression(amdgpu_gfx90a::acc36, output_vec_len );
            case 549:  return makeRegisterExpression(amdgpu_gfx90a::acc37, output_vec_len );
            case 550:  return makeRegisterExpression(amdgpu_gfx90a::acc38, output_vec_len );
            case 551:  return makeRegisterExpression(amdgpu_gfx90a::acc39, output_vec_len );
            case 552:  return makeRegisterExpression(amdgpu_gfx90a::acc40, output_vec_len );
            case 553:  return makeRegisterExpression(amdgpu_gfx90a::acc41, output_vec_len );
            case 554:  return makeRegisterExpression(amdgpu_gfx90a::acc42, output_vec_len );
            case 555:  return makeRegisterExpression(amdgpu_gfx90a::acc43, output_vec_len );
            case 556:  return makeRegisterExpression(amdgpu_gfx90a::acc44, output_vec_len );
            case 557:  return makeRegisterExpression(amdgpu_gfx90a::acc45, output_vec_len );
            case 558:  return makeRegisterExpression(amdgpu_gfx90a::acc46, output_vec_len );
            case 559:  return makeRegisterExpression(amdgpu_gfx90a::acc47, output_vec_len );
            case 560:  return makeRegisterExpression(amdgpu_gfx90a::acc48, output_vec_len );
            case 561:  return makeRegisterExpression(amdgpu_gfx90a::acc49, output_vec_len );
            case 562:  return makeRegisterExpression(amdgpu_gfx90a::acc50, output_vec_len );
            case 563:  return makeRegisterExpression(amdgpu_gfx90a::acc51, output_vec_len );
            case 564:  return makeRegisterExpression(amdgpu_gfx90a::acc52, output_vec_len );
            case 565:  return makeRegisterExpression(amdgpu_gfx90a::acc53, output_vec_len );
            case 566:  return makeRegisterExpression(amdgpu_gfx90a::acc54, output_vec_len );
            case 567:  return makeRegisterExpression(amdgpu_gfx90a::acc55, output_vec_len );
            case 568:  return makeRegisterExpression(amdgpu_gfx90a::acc56, output_vec_len );
            case 569:  return makeRegisterExpression(amdgpu_gfx90a::acc57, output_vec_len );
            case 570:  return makeRegisterExpression(amdgpu_gfx90a::acc58, output_vec_len );
            case 571:  return makeRegisterExpression(amdgpu_gfx90a::acc59, output_vec_len );
            case 572:  return makeRegisterExpression(amdgpu_gfx90a::acc60, output_vec_len );
            case 573:  return makeRegisterExpression(amdgpu_gfx90a::acc61, output_vec_len );
            case 574:  return makeRegisterExpression(amdgpu_gfx90a::acc62, output_vec_len );
            case 575:  return makeRegisterExpression(amdgpu_gfx90a::acc63, output_vec_len );
            case 576:  return makeRegisterExpression(amdgpu_gfx90a::acc64, output_vec_len );
            case 577:  return makeRegisterExpression(amdgpu_gfx90a::acc65, output_vec_len );
            case 578:  return makeRegisterExpression(amdgpu_gfx90a::acc66, output_vec_len );
            case 579:  return makeRegisterExpression(amdgpu_gfx90a::acc67, output_vec_len );
            case 580:  return makeRegisterExpression(amdgpu_gfx90a::acc68, output_vec_len );
            case 581:  return makeRegisterExpression(amdgpu_gfx90a::acc69, output_vec_len );
            case 582:  return makeRegisterExpression(amdgpu_gfx90a::acc70, output_vec_len );
            case 583:  return makeRegisterExpression(amdgpu_gfx90a::acc71, output_vec_len );
            case 584:  return makeRegisterExpression(amdgpu_gfx90a::acc72, output_vec_len );
            case 585:  return makeRegisterExpression(amdgpu_gfx90a::acc73, output_vec_len );
            case 586:  return makeRegisterExpression(amdgpu_gfx90a::acc74, output_vec_len );
            case 587:  return makeRegisterExpression(amdgpu_gfx90a::acc75, output_vec_len );
            case 588:  return makeRegisterExpression(amdgpu_gfx90a::acc76, output_vec_len );
            case 589:  return makeRegisterExpression(amdgpu_gfx90a::acc77, output_vec_len );
            case 590:  return makeRegisterExpression(amdgpu_gfx90a::acc78, output_vec_len );
            case 591:  return makeRegisterExpression(amdgpu_gfx90a::acc79, output_vec_len );
            case 592:  return makeRegisterExpression(amdgpu_gfx90a::acc80, output_vec_len );
            case 593:  return makeRegisterExpression(amdgpu_gfx90a::acc81, output_vec_len );
            case 594:  return makeRegisterExpression(amdgpu_gfx90a::acc82, output_vec_len );
            case 595:  return makeRegisterExpression(amdgpu_gfx90a::acc83, output_vec_len );
            case 596:  return makeRegisterExpression(amdgpu_gfx90a::acc84, output_vec_len );
            case 597:  return makeRegisterExpression(amdgpu_gfx90a::acc85, output_vec_len );
            case 598:  return makeRegisterExpression(amdgpu_gfx90a::acc86, output_vec_len );
            case 599:  return makeRegisterExpression(amdgpu_gfx90a::acc87, output_vec_len );
            case 600:  return makeRegisterExpression(amdgpu_gfx90a::acc88, output_vec_len );
            case 601:  return makeRegisterExpression(amdgpu_gfx90a::acc89, output_vec_len );
            case 602:  return makeRegisterExpression(amdgpu_gfx90a::acc90, output_vec_len );
            case 603:  return makeRegisterExpression(amdgpu_gfx90a::acc91, output_vec_len );
            case 604:  return makeRegisterExpression(amdgpu_gfx90a::acc92, output_vec_len );
            case 605:  return makeRegisterExpression(amdgpu_gfx90a::acc93, output_vec_len );
            case 606:  return makeRegisterExpression(amdgpu_gfx90a::acc94, output_vec_len );
            case 607:  return makeRegisterExpression(amdgpu_gfx90a::acc95, output_vec_len );
            case 608:  return makeRegisterExpression(amdgpu_gfx90a::acc96, output_vec_len );
            case 609:  return makeRegisterExpression(amdgpu_gfx90a::acc97, output_vec_len );
            case 610:  return makeRegisterExpression(amdgpu_gfx90a::acc98, output_vec_len );
            case 611:  return makeRegisterExpression(amdgpu_gfx90a::acc99, output_vec_len );
            case 612:  return makeRegisterExpression(amdgpu_gfx90a::acc100, output_vec_len );
            case 613:  return makeRegisterExpression(amdgpu_gfx90a::acc101, output_vec_len );
            case 614:  return makeRegisterExpression(amdgpu_gfx90a::acc102, output_vec_len );
            case 615:  return makeRegisterExpression(amdgpu_gfx90a::acc103, output_vec_len );
            case 616:  return makeRegisterExpression(amdgpu_gfx90a::acc104, output_vec_len );
            case 617:  return makeRegisterExpression(amdgpu_gfx90a::acc105, output_vec_len );
            case 618:  return makeRegisterExpression(amdgpu_gfx90a::acc106, output_vec_len );
            case 619:  return makeRegisterExpression(amdgpu_gfx90a::acc107, output_vec_len );
            case 620:  return makeRegisterExpression(amdgpu_gfx90a::acc108, output_vec_len );
            case 621:  return makeRegisterExpression(amdgpu_gfx90a::acc109, output_vec_len );
            case 622:  return makeRegisterExpression(amdgpu_gfx90a::acc110, output_vec_len );
            case 623:  return makeRegisterExpression(amdgpu_gfx90a::acc111, output_vec_len );
            case 624:  return makeRegisterExpression(amdgpu_gfx90a::acc112, output_vec_len );
            case 625:  return makeRegisterExpression(amdgpu_gfx90a::acc113, output_vec_len );
            case 626:  return makeRegisterExpression(amdgpu_gfx90a::acc114, output_vec_len );
            case 627:  return makeRegisterExpression(amdgpu_gfx90a::acc115, output_vec_len );
            case 628:  return makeRegisterExpression(amdgpu_gfx90a::acc116, output_vec_len );
            case 629:  return makeRegisterExpression(amdgpu_gfx90a::acc117, output_vec_len );
            case 630:  return makeRegisterExpression(amdgpu_gfx90a::acc118, output_vec_len );
            case 631:  return makeRegisterExpression(amdgpu_gfx90a::acc119, output_vec_len );
            case 632:  return makeRegisterExpression(amdgpu_gfx90a::acc120, output_vec_len );
            case 633:  return makeRegisterExpression(amdgpu_gfx90a::acc121, output_vec_len );
            case 634:  return makeRegisterExpression(amdgpu_gfx90a::acc122, output_vec_len );
            case 635:  return makeRegisterExpression(amdgpu_gfx90a::acc123, output_vec_len );
            case 636:  return makeRegisterExpression(amdgpu_gfx90a::acc124, output_vec_len );
            case 637:  return makeRegisterExpression(amdgpu_gfx90a::acc125, output_vec_len );
            case 638:  return makeRegisterExpression(amdgpu_gfx90a::acc126, output_vec_len );
            case 639:  return makeRegisterExpression(amdgpu_gfx90a::acc127, output_vec_len );
            case 640:  return makeRegisterExpression(amdgpu_gfx90a::acc128, output_vec_len );
            case 641:  return makeRegisterExpression(amdgpu_gfx90a::acc129, output_vec_len );
            case 642:  return makeRegisterExpression(amdgpu_gfx90a::acc130, output_vec_len );
            case 643:  return makeRegisterExpression(amdgpu_gfx90a::acc131, output_vec_len );
            case 644:  return makeRegisterExpression(amdgpu_gfx90a::acc132, output_vec_len );
            case 645:  return makeRegisterExpression(amdgpu_gfx90a::acc133, output_vec_len );
            case 646:  return makeRegisterExpression(amdgpu_gfx90a::acc134, output_vec_len );
            case 647:  return makeRegisterExpression(amdgpu_gfx90a::acc135, output_vec_len );
            case 648:  return makeRegisterExpression(amdgpu_gfx90a::acc136, output_vec_len );
            case 649:  return makeRegisterExpression(amdgpu_gfx90a::acc137, output_vec_len );
            case 650:  return makeRegisterExpression(amdgpu_gfx90a::acc138, output_vec_len );
            case 651:  return makeRegisterExpression(amdgpu_gfx90a::acc139, output_vec_len );
            case 652:  return makeRegisterExpression(amdgpu_gfx90a::acc140, output_vec_len );
            case 653:  return makeRegisterExpression(amdgpu_gfx90a::acc141, output_vec_len );
            case 654:  return makeRegisterExpression(amdgpu_gfx90a::acc142, output_vec_len );
            case 655:  return makeRegisterExpression(amdgpu_gfx90a::acc143, output_vec_len );
            case 656:  return makeRegisterExpression(amdgpu_gfx90a::acc144, output_vec_len );
            case 657:  return makeRegisterExpression(amdgpu_gfx90a::acc145, output_vec_len );
            case 658:  return makeRegisterExpression(amdgpu_gfx90a::acc146, output_vec_len );
            case 659:  return makeRegisterExpression(amdgpu_gfx90a::acc147, output_vec_len );
            case 660:  return makeRegisterExpression(amdgpu_gfx90a::acc148, output_vec_len );
            case 661:  return makeRegisterExpression(amdgpu_gfx90a::acc149, output_vec_len );
            case 662:  return makeRegisterExpression(amdgpu_gfx90a::acc150, output_vec_len );
            case 663:  return makeRegisterExpression(amdgpu_gfx90a::acc151, output_vec_len );
            case 664:  return makeRegisterExpression(amdgpu_gfx90a::acc152, output_vec_len );
            case 665:  return makeRegisterExpression(amdgpu_gfx90a::acc153, output_vec_len );
            case 666:  return makeRegisterExpression(amdgpu_gfx90a::acc154, output_vec_len );
            case 667:  return makeRegisterExpression(amdgpu_gfx90a::acc155, output_vec_len );
            case 668:  return makeRegisterExpression(amdgpu_gfx90a::acc156, output_vec_len );
            case 669:  return makeRegisterExpression(amdgpu_gfx90a::acc157, output_vec_len );
            case 670:  return makeRegisterExpression(amdgpu_gfx90a::acc158, output_vec_len );
            case 671:  return makeRegisterExpression(amdgpu_gfx90a::acc159, output_vec_len );
            case 672:  return makeRegisterExpression(amdgpu_gfx90a::acc160, output_vec_len );
            case 673:  return makeRegisterExpression(amdgpu_gfx90a::acc161, output_vec_len );
            case 674:  return makeRegisterExpression(amdgpu_gfx90a::acc162, output_vec_len );
            case 675:  return makeRegisterExpression(amdgpu_gfx90a::acc163, output_vec_len );
            case 676:  return makeRegisterExpression(amdgpu_gfx90a::acc164, output_vec_len );
            case 677:  return makeRegisterExpression(amdgpu_gfx90a::acc165, output_vec_len );
            case 678:  return makeRegisterExpression(amdgpu_gfx90a::acc166, output_vec_len );
            case 679:  return makeRegisterExpression(amdgpu_gfx90a::acc167, output_vec_len );
            case 680:  return makeRegisterExpression(amdgpu_gfx90a::acc168, output_vec_len );
            case 681:  return makeRegisterExpression(amdgpu_gfx90a::acc169, output_vec_len );
            case 682:  return makeRegisterExpression(amdgpu_gfx90a::acc170, output_vec_len );
            case 683:  return makeRegisterExpression(amdgpu_gfx90a::acc171, output_vec_len );
            case 684:  return makeRegisterExpression(amdgpu_gfx90a::acc172, output_vec_len );
            case 685:  return makeRegisterExpression(amdgpu_gfx90a::acc173, output_vec_len );
            case 686:  return makeRegisterExpression(amdgpu_gfx90a::acc174, output_vec_len );
            case 687:  return makeRegisterExpression(amdgpu_gfx90a::acc175, output_vec_len );
            case 688:  return makeRegisterExpression(amdgpu_gfx90a::acc176, output_vec_len );
            case 689:  return makeRegisterExpression(amdgpu_gfx90a::acc177, output_vec_len );
            case 690:  return makeRegisterExpression(amdgpu_gfx90a::acc178, output_vec_len );
            case 691:  return makeRegisterExpression(amdgpu_gfx90a::acc179, output_vec_len );
            case 692:  return makeRegisterExpression(amdgpu_gfx90a::acc180, output_vec_len );
            case 693:  return makeRegisterExpression(amdgpu_gfx90a::acc181, output_vec_len );
            case 694:  return makeRegisterExpression(amdgpu_gfx90a::acc182, output_vec_len );
            case 695:  return makeRegisterExpression(amdgpu_gfx90a::acc183, output_vec_len );
            case 696:  return makeRegisterExpression(amdgpu_gfx90a::acc184, output_vec_len );
            case 697:  return makeRegisterExpression(amdgpu_gfx90a::acc185, output_vec_len );
            case 698:  return makeRegisterExpression(amdgpu_gfx90a::acc186, output_vec_len );
            case 699:  return makeRegisterExpression(amdgpu_gfx90a::acc187, output_vec_len );
            case 700:  return makeRegisterExpression(amdgpu_gfx90a::acc188, output_vec_len );
            case 701:  return makeRegisterExpression(amdgpu_gfx90a::acc189, output_vec_len );
            case 702:  return makeRegisterExpression(amdgpu_gfx90a::acc190, output_vec_len );
            case 703:  return makeRegisterExpression(amdgpu_gfx90a::acc191, output_vec_len );
            case 704:  return makeRegisterExpression(amdgpu_gfx90a::acc192, output_vec_len );
            case 705:  return makeRegisterExpression(amdgpu_gfx90a::acc193, output_vec_len );
            case 706:  return makeRegisterExpression(amdgpu_gfx90a::acc194, output_vec_len );
            case 707:  return makeRegisterExpression(amdgpu_gfx90a::acc195, output_vec_len );
            case 708:  return makeRegisterExpression(amdgpu_gfx90a::acc196, output_vec_len );
            case 709:  return makeRegisterExpression(amdgpu_gfx90a::acc197, output_vec_len );
            case 710:  return makeRegisterExpression(amdgpu_gfx90a::acc198, output_vec_len );
            case 711:  return makeRegisterExpression(amdgpu_gfx90a::acc199, output_vec_len );
            case 712:  return makeRegisterExpression(amdgpu_gfx90a::acc200, output_vec_len );
            case 713:  return makeRegisterExpression(amdgpu_gfx90a::acc201, output_vec_len );
            case 714:  return makeRegisterExpression(amdgpu_gfx90a::acc202, output_vec_len );
            case 715:  return makeRegisterExpression(amdgpu_gfx90a::acc203, output_vec_len );
            case 716:  return makeRegisterExpression(amdgpu_gfx90a::acc204, output_vec_len );
            case 717:  return makeRegisterExpression(amdgpu_gfx90a::acc205, output_vec_len );
            case 718:  return makeRegisterExpression(amdgpu_gfx90a::acc206, output_vec_len );
            case 719:  return makeRegisterExpression(amdgpu_gfx90a::acc207, output_vec_len );
            case 720:  return makeRegisterExpression(amdgpu_gfx90a::acc208, output_vec_len );
            case 721:  return makeRegisterExpression(amdgpu_gfx90a::acc209, output_vec_len );
            case 722:  return makeRegisterExpression(amdgpu_gfx90a::acc210, output_vec_len );
            case 723:  return makeRegisterExpression(amdgpu_gfx90a::acc211, output_vec_len );
            case 724:  return makeRegisterExpression(amdgpu_gfx90a::acc212, output_vec_len );
            case 725:  return makeRegisterExpression(amdgpu_gfx90a::acc213, output_vec_len );
            case 726:  return makeRegisterExpression(amdgpu_gfx90a::acc214, output_vec_len );
            case 727:  return makeRegisterExpression(amdgpu_gfx90a::acc215, output_vec_len );
            case 728:  return makeRegisterExpression(amdgpu_gfx90a::acc216, output_vec_len );
            case 729:  return makeRegisterExpression(amdgpu_gfx90a::acc217, output_vec_len );
            case 730:  return makeRegisterExpression(amdgpu_gfx90a::acc218, output_vec_len );
            case 731:  return makeRegisterExpression(amdgpu_gfx90a::acc219, output_vec_len );
            case 732:  return makeRegisterExpression(amdgpu_gfx90a::acc220, output_vec_len );
            case 733:  return makeRegisterExpression(amdgpu_gfx90a::acc221, output_vec_len );
            case 734:  return makeRegisterExpression(amdgpu_gfx90a::acc222, output_vec_len );
            case 735:  return makeRegisterExpression(amdgpu_gfx90a::acc223, output_vec_len );
            case 736:  return makeRegisterExpression(amdgpu_gfx90a::acc224, output_vec_len );
            case 737:  return makeRegisterExpression(amdgpu_gfx90a::acc225, output_vec_len );
            case 738:  return makeRegisterExpression(amdgpu_gfx90a::acc226, output_vec_len );
            case 739:  return makeRegisterExpression(amdgpu_gfx90a::acc227, output_vec_len );
            case 740:  return makeRegisterExpression(amdgpu_gfx90a::acc228, output_vec_len );
            case 741:  return makeRegisterExpression(amdgpu_gfx90a::acc229, output_vec_len );
            case 742:  return makeRegisterExpression(amdgpu_gfx90a::acc230, output_vec_len );
            case 743:  return makeRegisterExpression(amdgpu_gfx90a::acc231, output_vec_len );
            case 744:  return makeRegisterExpression(amdgpu_gfx90a::acc232, output_vec_len );
            case 745:  return makeRegisterExpression(amdgpu_gfx90a::acc233, output_vec_len );
            case 746:  return makeRegisterExpression(amdgpu_gfx90a::acc234, output_vec_len );
            case 747:  return makeRegisterExpression(amdgpu_gfx90a::acc235, output_vec_len );
            case 748:  return makeRegisterExpression(amdgpu_gfx90a::acc236, output_vec_len );
            case 749:  return makeRegisterExpression(amdgpu_gfx90a::acc237, output_vec_len );
            case 750:  return makeRegisterExpression(amdgpu_gfx90a::acc238, output_vec_len );
            case 751:  return makeRegisterExpression(amdgpu_gfx90a::acc239, output_vec_len );
            case 752:  return makeRegisterExpression(amdgpu_gfx90a::acc240, output_vec_len );
            case 753:  return makeRegisterExpression(amdgpu_gfx90a::acc241, output_vec_len );
            case 754:  return makeRegisterExpression(amdgpu_gfx90a::acc242, output_vec_len );
            case 755:  return makeRegisterExpression(amdgpu_gfx90a::acc243, output_vec_len );
            case 756:  return makeRegisterExpression(amdgpu_gfx90a::acc244, output_vec_len );
            case 757:  return makeRegisterExpression(amdgpu_gfx90a::acc245, output_vec_len );
            case 758:  return makeRegisterExpression(amdgpu_gfx90a::acc246, output_vec_len );
            case 759:  return makeRegisterExpression(amdgpu_gfx90a::acc247, output_vec_len );
            case 760:  return makeRegisterExpression(amdgpu_gfx90a::acc248, output_vec_len );
            case 761:  return makeRegisterExpression(amdgpu_gfx90a::acc249, output_vec_len );
            case 762:  return makeRegisterExpression(amdgpu_gfx90a::acc250, output_vec_len );
            case 763:  return makeRegisterExpression(amdgpu_gfx90a::acc251, output_vec_len );
            case 764:  return makeRegisterExpression(amdgpu_gfx90a::acc252, output_vec_len );
            case 765:  return makeRegisterExpression(amdgpu_gfx90a::acc253, output_vec_len );
            case 766:  return makeRegisterExpression(amdgpu_gfx90a::acc254, output_vec_len );
            case 767:  return makeRegisterExpression(amdgpu_gfx90a::acc255, output_vec_len );
            default: return makeRegisterExpression(amdgpu_gfx90a::invalid);
        }
    }

    Expression::Ptr InstructionDecoder_amdgpu_gfx90a::decodeOPR_VGPR_OR_LDS(uint64_t input, uint32_t output_vec_len)
    {
        switch (input)  {
            case 256:  return makeRegisterExpression(amdgpu_gfx90a::v0, output_vec_len );
            case 257:  return makeRegisterExpression(amdgpu_gfx90a::v1, output_vec_len );
            case 258:  return makeRegisterExpression(amdgpu_gfx90a::v2, output_vec_len );
            case 259:  return makeRegisterExpression(amdgpu_gfx90a::v3, output_vec_len );
            case 260:  return makeRegisterExpression(amdgpu_gfx90a::v4, output_vec_len );
            case 261:  return makeRegisterExpression(amdgpu_gfx90a::v5, output_vec_len );
            case 262:  return makeRegisterExpression(amdgpu_gfx90a::v6, output_vec_len );
            case 263:  return makeRegisterExpression(amdgpu_gfx90a::v7, output_vec_len );
            case 264:  return makeRegisterExpression(amdgpu_gfx90a::v8, output_vec_len );
            case 265:  return makeRegisterExpression(amdgpu_gfx90a::v9, output_vec_len );
            case 266:  return makeRegisterExpression(amdgpu_gfx90a::v10, output_vec_len );
            case 267:  return makeRegisterExpression(amdgpu_gfx90a::v11, output_vec_len );
            case 268:  return makeRegisterExpression(amdgpu_gfx90a::v12, output_vec_len );
            case 269:  return makeRegisterExpression(amdgpu_gfx90a::v13, output_vec_len );
            case 270:  return makeRegisterExpression(amdgpu_gfx90a::v14, output_vec_len );
            case 271:  return makeRegisterExpression(amdgpu_gfx90a::v15, output_vec_len );
            case 272:  return makeRegisterExpression(amdgpu_gfx90a::v16, output_vec_len );
            case 273:  return makeRegisterExpression(amdgpu_gfx90a::v17, output_vec_len );
            case 274:  return makeRegisterExpression(amdgpu_gfx90a::v18, output_vec_len );
            case 275:  return makeRegisterExpression(amdgpu_gfx90a::v19, output_vec_len );
            case 276:  return makeRegisterExpression(amdgpu_gfx90a::v20, output_vec_len );
            case 277:  return makeRegisterExpression(amdgpu_gfx90a::v21, output_vec_len );
            case 278:  return makeRegisterExpression(amdgpu_gfx90a::v22, output_vec_len );
            case 279:  return makeRegisterExpression(amdgpu_gfx90a::v23, output_vec_len );
            case 280:  return makeRegisterExpression(amdgpu_gfx90a::v24, output_vec_len );
            case 281:  return makeRegisterExpression(amdgpu_gfx90a::v25, output_vec_len );
            case 282:  return makeRegisterExpression(amdgpu_gfx90a::v26, output_vec_len );
            case 283:  return makeRegisterExpression(amdgpu_gfx90a::v27, output_vec_len );
            case 284:  return makeRegisterExpression(amdgpu_gfx90a::v28, output_vec_len );
            case 285:  return makeRegisterExpression(amdgpu_gfx90a::v29, output_vec_len );
            case 286:  return makeRegisterExpression(amdgpu_gfx90a::v30, output_vec_len );
            case 287:  return makeRegisterExpression(amdgpu_gfx90a::v31, output_vec_len );
            case 288:  return makeRegisterExpression(amdgpu_gfx90a::v32, output_vec_len );
            case 289:  return makeRegisterExpression(amdgpu_gfx90a::v33, output_vec_len );
            case 290:  return makeRegisterExpression(amdgpu_gfx90a::v34, output_vec_len );
            case 291:  return makeRegisterExpression(amdgpu_gfx90a::v35, output_vec_len );
            case 292:  return makeRegisterExpression(amdgpu_gfx90a::v36, output_vec_len );
            case 293:  return makeRegisterExpression(amdgpu_gfx90a::v37, output_vec_len );
            case 294:  return makeRegisterExpression(amdgpu_gfx90a::v38, output_vec_len );
            case 295:  return makeRegisterExpression(amdgpu_gfx90a::v39, output_vec_len );
            case 296:  return makeRegisterExpression(amdgpu_gfx90a::v40, output_vec_len );
            case 297:  return makeRegisterExpression(amdgpu_gfx90a::v41, output_vec_len );
            case 298:  return makeRegisterExpression(amdgpu_gfx90a::v42, output_vec_len );
            case 299:  return makeRegisterExpression(amdgpu_gfx90a::v43, output_vec_len );
            case 300:  return makeRegisterExpression(amdgpu_gfx90a::v44, output_vec_len );
            case 301:  return makeRegisterExpression(amdgpu_gfx90a::v45, output_vec_len );
            case 302:  return makeRegisterExpression(amdgpu_gfx90a::v46, output_vec_len );
            case 303:  return makeRegisterExpression(amdgpu_gfx90a::v47, output_vec_len );
            case 304:  return makeRegisterExpression(amdgpu_gfx90a::v48, output_vec_len );
            case 305:  return makeRegisterExpression(amdgpu_gfx90a::v49, output_vec_len );
            case 306:  return makeRegisterExpression(amdgpu_gfx90a::v50, output_vec_len );
            case 307:  return makeRegisterExpression(amdgpu_gfx90a::v51, output_vec_len );
            case 308:  return makeRegisterExpression(amdgpu_gfx90a::v52, output_vec_len );
            case 309:  return makeRegisterExpression(amdgpu_gfx90a::v53, output_vec_len );
            case 310:  return makeRegisterExpression(amdgpu_gfx90a::v54, output_vec_len );
            case 311:  return makeRegisterExpression(amdgpu_gfx90a::v55, output_vec_len );
            case 312:  return makeRegisterExpression(amdgpu_gfx90a::v56, output_vec_len );
            case 313:  return makeRegisterExpression(amdgpu_gfx90a::v57, output_vec_len );
            case 314:  return makeRegisterExpression(amdgpu_gfx90a::v58, output_vec_len );
            case 315:  return makeRegisterExpression(amdgpu_gfx90a::v59, output_vec_len );
            case 316:  return makeRegisterExpression(amdgpu_gfx90a::v60, output_vec_len );
            case 317:  return makeRegisterExpression(amdgpu_gfx90a::v61, output_vec_len );
            case 318:  return makeRegisterExpression(amdgpu_gfx90a::v62, output_vec_len );
            case 319:  return makeRegisterExpression(amdgpu_gfx90a::v63, output_vec_len );
            case 320:  return makeRegisterExpression(amdgpu_gfx90a::v64, output_vec_len );
            case 321:  return makeRegisterExpression(amdgpu_gfx90a::v65, output_vec_len );
            case 322:  return makeRegisterExpression(amdgpu_gfx90a::v66, output_vec_len );
            case 323:  return makeRegisterExpression(amdgpu_gfx90a::v67, output_vec_len );
            case 324:  return makeRegisterExpression(amdgpu_gfx90a::v68, output_vec_len );
            case 325:  return makeRegisterExpression(amdgpu_gfx90a::v69, output_vec_len );
            case 326:  return makeRegisterExpression(amdgpu_gfx90a::v70, output_vec_len );
            case 327:  return makeRegisterExpression(amdgpu_gfx90a::v71, output_vec_len );
            case 328:  return makeRegisterExpression(amdgpu_gfx90a::v72, output_vec_len );
            case 329:  return makeRegisterExpression(amdgpu_gfx90a::v73, output_vec_len );
            case 330:  return makeRegisterExpression(amdgpu_gfx90a::v74, output_vec_len );
            case 331:  return makeRegisterExpression(amdgpu_gfx90a::v75, output_vec_len );
            case 332:  return makeRegisterExpression(amdgpu_gfx90a::v76, output_vec_len );
            case 333:  return makeRegisterExpression(amdgpu_gfx90a::v77, output_vec_len );
            case 334:  return makeRegisterExpression(amdgpu_gfx90a::v78, output_vec_len );
            case 335:  return makeRegisterExpression(amdgpu_gfx90a::v79, output_vec_len );
            case 336:  return makeRegisterExpression(amdgpu_gfx90a::v80, output_vec_len );
            case 337:  return makeRegisterExpression(amdgpu_gfx90a::v81, output_vec_len );
            case 338:  return makeRegisterExpression(amdgpu_gfx90a::v82, output_vec_len );
            case 339:  return makeRegisterExpression(amdgpu_gfx90a::v83, output_vec_len );
            case 340:  return makeRegisterExpression(amdgpu_gfx90a::v84, output_vec_len );
            case 341:  return makeRegisterExpression(amdgpu_gfx90a::v85, output_vec_len );
            case 342:  return makeRegisterExpression(amdgpu_gfx90a::v86, output_vec_len );
            case 343:  return makeRegisterExpression(amdgpu_gfx90a::v87, output_vec_len );
            case 344:  return makeRegisterExpression(amdgpu_gfx90a::v88, output_vec_len );
            case 345:  return makeRegisterExpression(amdgpu_gfx90a::v89, output_vec_len );
            case 346:  return makeRegisterExpression(amdgpu_gfx90a::v90, output_vec_len );
            case 347:  return makeRegisterExpression(amdgpu_gfx90a::v91, output_vec_len );
            case 348:  return makeRegisterExpression(amdgpu_gfx90a::v92, output_vec_len );
            case 349:  return makeRegisterExpression(amdgpu_gfx90a::v93, output_vec_len );
            case 350:  return makeRegisterExpression(amdgpu_gfx90a::v94, output_vec_len );
            case 351:  return makeRegisterExpression(amdgpu_gfx90a::v95, output_vec_len );
            case 352:  return makeRegisterExpression(amdgpu_gfx90a::v96, output_vec_len );
            case 353:  return makeRegisterExpression(amdgpu_gfx90a::v97, output_vec_len );
            case 354:  return makeRegisterExpression(amdgpu_gfx90a::v98, output_vec_len );
            case 355:  return makeRegisterExpression(amdgpu_gfx90a::v99, output_vec_len );
            case 356:  return makeRegisterExpression(amdgpu_gfx90a::v100, output_vec_len );
            case 357:  return makeRegisterExpression(amdgpu_gfx90a::v101, output_vec_len );
            case 358:  return makeRegisterExpression(amdgpu_gfx90a::v102, output_vec_len );
            case 359:  return makeRegisterExpression(amdgpu_gfx90a::v103, output_vec_len );
            case 360:  return makeRegisterExpression(amdgpu_gfx90a::v104, output_vec_len );
            case 361:  return makeRegisterExpression(amdgpu_gfx90a::v105, output_vec_len );
            case 362:  return makeRegisterExpression(amdgpu_gfx90a::v106, output_vec_len );
            case 363:  return makeRegisterExpression(amdgpu_gfx90a::v107, output_vec_len );
            case 364:  return makeRegisterExpression(amdgpu_gfx90a::v108, output_vec_len );
            case 365:  return makeRegisterExpression(amdgpu_gfx90a::v109, output_vec_len );
            case 366:  return makeRegisterExpression(amdgpu_gfx90a::v110, output_vec_len );
            case 367:  return makeRegisterExpression(amdgpu_gfx90a::v111, output_vec_len );
            case 368:  return makeRegisterExpression(amdgpu_gfx90a::v112, output_vec_len );
            case 369:  return makeRegisterExpression(amdgpu_gfx90a::v113, output_vec_len );
            case 370:  return makeRegisterExpression(amdgpu_gfx90a::v114, output_vec_len );
            case 371:  return makeRegisterExpression(amdgpu_gfx90a::v115, output_vec_len );
            case 372:  return makeRegisterExpression(amdgpu_gfx90a::v116, output_vec_len );
            case 373:  return makeRegisterExpression(amdgpu_gfx90a::v117, output_vec_len );
            case 374:  return makeRegisterExpression(amdgpu_gfx90a::v118, output_vec_len );
            case 375:  return makeRegisterExpression(amdgpu_gfx90a::v119, output_vec_len );
            case 376:  return makeRegisterExpression(amdgpu_gfx90a::v120, output_vec_len );
            case 377:  return makeRegisterExpression(amdgpu_gfx90a::v121, output_vec_len );
            case 378:  return makeRegisterExpression(amdgpu_gfx90a::v122, output_vec_len );
            case 379:  return makeRegisterExpression(amdgpu_gfx90a::v123, output_vec_len );
            case 380:  return makeRegisterExpression(amdgpu_gfx90a::v124, output_vec_len );
            case 381:  return makeRegisterExpression(amdgpu_gfx90a::v125, output_vec_len );
            case 382:  return makeRegisterExpression(amdgpu_gfx90a::v126, output_vec_len );
            case 383:  return makeRegisterExpression(amdgpu_gfx90a::v127, output_vec_len );
            case 384:  return makeRegisterExpression(amdgpu_gfx90a::v128, output_vec_len );
            case 385:  return makeRegisterExpression(amdgpu_gfx90a::v129, output_vec_len );
            case 386:  return makeRegisterExpression(amdgpu_gfx90a::v130, output_vec_len );
            case 387:  return makeRegisterExpression(amdgpu_gfx90a::v131, output_vec_len );
            case 388:  return makeRegisterExpression(amdgpu_gfx90a::v132, output_vec_len );
            case 389:  return makeRegisterExpression(amdgpu_gfx90a::v133, output_vec_len );
            case 390:  return makeRegisterExpression(amdgpu_gfx90a::v134, output_vec_len );
            case 391:  return makeRegisterExpression(amdgpu_gfx90a::v135, output_vec_len );
            case 392:  return makeRegisterExpression(amdgpu_gfx90a::v136, output_vec_len );
            case 393:  return makeRegisterExpression(amdgpu_gfx90a::v137, output_vec_len );
            case 394:  return makeRegisterExpression(amdgpu_gfx90a::v138, output_vec_len );
            case 395:  return makeRegisterExpression(amdgpu_gfx90a::v139, output_vec_len );
            case 396:  return makeRegisterExpression(amdgpu_gfx90a::v140, output_vec_len );
            case 397:  return makeRegisterExpression(amdgpu_gfx90a::v141, output_vec_len );
            case 398:  return makeRegisterExpression(amdgpu_gfx90a::v142, output_vec_len );
            case 399:  return makeRegisterExpression(amdgpu_gfx90a::v143, output_vec_len );
            case 400:  return makeRegisterExpression(amdgpu_gfx90a::v144, output_vec_len );
            case 401:  return makeRegisterExpression(amdgpu_gfx90a::v145, output_vec_len );
            case 402:  return makeRegisterExpression(amdgpu_gfx90a::v146, output_vec_len );
            case 403:  return makeRegisterExpression(amdgpu_gfx90a::v147, output_vec_len );
            case 404:  return makeRegisterExpression(amdgpu_gfx90a::v148, output_vec_len );
            case 405:  return makeRegisterExpression(amdgpu_gfx90a::v149, output_vec_len );
            case 406:  return makeRegisterExpression(amdgpu_gfx90a::v150, output_vec_len );
            case 407:  return makeRegisterExpression(amdgpu_gfx90a::v151, output_vec_len );
            case 408:  return makeRegisterExpression(amdgpu_gfx90a::v152, output_vec_len );
            case 409:  return makeRegisterExpression(amdgpu_gfx90a::v153, output_vec_len );
            case 410:  return makeRegisterExpression(amdgpu_gfx90a::v154, output_vec_len );
            case 411:  return makeRegisterExpression(amdgpu_gfx90a::v155, output_vec_len );
            case 412:  return makeRegisterExpression(amdgpu_gfx90a::v156, output_vec_len );
            case 413:  return makeRegisterExpression(amdgpu_gfx90a::v157, output_vec_len );
            case 414:  return makeRegisterExpression(amdgpu_gfx90a::v158, output_vec_len );
            case 415:  return makeRegisterExpression(amdgpu_gfx90a::v159, output_vec_len );
            case 416:  return makeRegisterExpression(amdgpu_gfx90a::v160, output_vec_len );
            case 417:  return makeRegisterExpression(amdgpu_gfx90a::v161, output_vec_len );
            case 418:  return makeRegisterExpression(amdgpu_gfx90a::v162, output_vec_len );
            case 419:  return makeRegisterExpression(amdgpu_gfx90a::v163, output_vec_len );
            case 420:  return makeRegisterExpression(amdgpu_gfx90a::v164, output_vec_len );
            case 421:  return makeRegisterExpression(amdgpu_gfx90a::v165, output_vec_len );
            case 422:  return makeRegisterExpression(amdgpu_gfx90a::v166, output_vec_len );
            case 423:  return makeRegisterExpression(amdgpu_gfx90a::v167, output_vec_len );
            case 424:  return makeRegisterExpression(amdgpu_gfx90a::v168, output_vec_len );
            case 425:  return makeRegisterExpression(amdgpu_gfx90a::v169, output_vec_len );
            case 426:  return makeRegisterExpression(amdgpu_gfx90a::v170, output_vec_len );
            case 427:  return makeRegisterExpression(amdgpu_gfx90a::v171, output_vec_len );
            case 428:  return makeRegisterExpression(amdgpu_gfx90a::v172, output_vec_len );
            case 429:  return makeRegisterExpression(amdgpu_gfx90a::v173, output_vec_len );
            case 430:  return makeRegisterExpression(amdgpu_gfx90a::v174, output_vec_len );
            case 431:  return makeRegisterExpression(amdgpu_gfx90a::v175, output_vec_len );
            case 432:  return makeRegisterExpression(amdgpu_gfx90a::v176, output_vec_len );
            case 433:  return makeRegisterExpression(amdgpu_gfx90a::v177, output_vec_len );
            case 434:  return makeRegisterExpression(amdgpu_gfx90a::v178, output_vec_len );
            case 435:  return makeRegisterExpression(amdgpu_gfx90a::v179, output_vec_len );
            case 436:  return makeRegisterExpression(amdgpu_gfx90a::v180, output_vec_len );
            case 437:  return makeRegisterExpression(amdgpu_gfx90a::v181, output_vec_len );
            case 438:  return makeRegisterExpression(amdgpu_gfx90a::v182, output_vec_len );
            case 439:  return makeRegisterExpression(amdgpu_gfx90a::v183, output_vec_len );
            case 440:  return makeRegisterExpression(amdgpu_gfx90a::v184, output_vec_len );
            case 441:  return makeRegisterExpression(amdgpu_gfx90a::v185, output_vec_len );
            case 442:  return makeRegisterExpression(amdgpu_gfx90a::v186, output_vec_len );
            case 443:  return makeRegisterExpression(amdgpu_gfx90a::v187, output_vec_len );
            case 444:  return makeRegisterExpression(amdgpu_gfx90a::v188, output_vec_len );
            case 445:  return makeRegisterExpression(amdgpu_gfx90a::v189, output_vec_len );
            case 446:  return makeRegisterExpression(amdgpu_gfx90a::v190, output_vec_len );
            case 447:  return makeRegisterExpression(amdgpu_gfx90a::v191, output_vec_len );
            case 448:  return makeRegisterExpression(amdgpu_gfx90a::v192, output_vec_len );
            case 449:  return makeRegisterExpression(amdgpu_gfx90a::v193, output_vec_len );
            case 450:  return makeRegisterExpression(amdgpu_gfx90a::v194, output_vec_len );
            case 451:  return makeRegisterExpression(amdgpu_gfx90a::v195, output_vec_len );
            case 452:  return makeRegisterExpression(amdgpu_gfx90a::v196, output_vec_len );
            case 453:  return makeRegisterExpression(amdgpu_gfx90a::v197, output_vec_len );
            case 454:  return makeRegisterExpression(amdgpu_gfx90a::v198, output_vec_len );
            case 455:  return makeRegisterExpression(amdgpu_gfx90a::v199, output_vec_len );
            case 456:  return makeRegisterExpression(amdgpu_gfx90a::v200, output_vec_len );
            case 457:  return makeRegisterExpression(amdgpu_gfx90a::v201, output_vec_len );
            case 458:  return makeRegisterExpression(amdgpu_gfx90a::v202, output_vec_len );
            case 459:  return makeRegisterExpression(amdgpu_gfx90a::v203, output_vec_len );
            case 460:  return makeRegisterExpression(amdgpu_gfx90a::v204, output_vec_len );
            case 461:  return makeRegisterExpression(amdgpu_gfx90a::v205, output_vec_len );
            case 462:  return makeRegisterExpression(amdgpu_gfx90a::v206, output_vec_len );
            case 463:  return makeRegisterExpression(amdgpu_gfx90a::v207, output_vec_len );
            case 464:  return makeRegisterExpression(amdgpu_gfx90a::v208, output_vec_len );
            case 465:  return makeRegisterExpression(amdgpu_gfx90a::v209, output_vec_len );
            case 466:  return makeRegisterExpression(amdgpu_gfx90a::v210, output_vec_len );
            case 467:  return makeRegisterExpression(amdgpu_gfx90a::v211, output_vec_len );
            case 468:  return makeRegisterExpression(amdgpu_gfx90a::v212, output_vec_len );
            case 469:  return makeRegisterExpression(amdgpu_gfx90a::v213, output_vec_len );
            case 470:  return makeRegisterExpression(amdgpu_gfx90a::v214, output_vec_len );
            case 471:  return makeRegisterExpression(amdgpu_gfx90a::v215, output_vec_len );
            case 472:  return makeRegisterExpression(amdgpu_gfx90a::v216, output_vec_len );
            case 473:  return makeRegisterExpression(amdgpu_gfx90a::v217, output_vec_len );
            case 474:  return makeRegisterExpression(amdgpu_gfx90a::v218, output_vec_len );
            case 475:  return makeRegisterExpression(amdgpu_gfx90a::v219, output_vec_len );
            case 476:  return makeRegisterExpression(amdgpu_gfx90a::v220, output_vec_len );
            case 477:  return makeRegisterExpression(amdgpu_gfx90a::v221, output_vec_len );
            case 478:  return makeRegisterExpression(amdgpu_gfx90a::v222, output_vec_len );
            case 479:  return makeRegisterExpression(amdgpu_gfx90a::v223, output_vec_len );
            case 480:  return makeRegisterExpression(amdgpu_gfx90a::v224, output_vec_len );
            case 481:  return makeRegisterExpression(amdgpu_gfx90a::v225, output_vec_len );
            case 482:  return makeRegisterExpression(amdgpu_gfx90a::v226, output_vec_len );
            case 483:  return makeRegisterExpression(amdgpu_gfx90a::v227, output_vec_len );
            case 484:  return makeRegisterExpression(amdgpu_gfx90a::v228, output_vec_len );
            case 485:  return makeRegisterExpression(amdgpu_gfx90a::v229, output_vec_len );
            case 486:  return makeRegisterExpression(amdgpu_gfx90a::v230, output_vec_len );
            case 487:  return makeRegisterExpression(amdgpu_gfx90a::v231, output_vec_len );
            case 488:  return makeRegisterExpression(amdgpu_gfx90a::v232, output_vec_len );
            case 489:  return makeRegisterExpression(amdgpu_gfx90a::v233, output_vec_len );
            case 490:  return makeRegisterExpression(amdgpu_gfx90a::v234, output_vec_len );
            case 491:  return makeRegisterExpression(amdgpu_gfx90a::v235, output_vec_len );
            case 492:  return makeRegisterExpression(amdgpu_gfx90a::v236, output_vec_len );
            case 493:  return makeRegisterExpression(amdgpu_gfx90a::v237, output_vec_len );
            case 494:  return makeRegisterExpression(amdgpu_gfx90a::v238, output_vec_len );
            case 495:  return makeRegisterExpression(amdgpu_gfx90a::v239, output_vec_len );
            case 496:  return makeRegisterExpression(amdgpu_gfx90a::v240, output_vec_len );
            case 497:  return makeRegisterExpression(amdgpu_gfx90a::v241, output_vec_len );
            case 498:  return makeRegisterExpression(amdgpu_gfx90a::v242, output_vec_len );
            case 499:  return makeRegisterExpression(amdgpu_gfx90a::v243, output_vec_len );
            case 500:  return makeRegisterExpression(amdgpu_gfx90a::v244, output_vec_len );
            case 501:  return makeRegisterExpression(amdgpu_gfx90a::v245, output_vec_len );
            case 502:  return makeRegisterExpression(amdgpu_gfx90a::v246, output_vec_len );
            case 503:  return makeRegisterExpression(amdgpu_gfx90a::v247, output_vec_len );
            case 504:  return makeRegisterExpression(amdgpu_gfx90a::v248, output_vec_len );
            case 505:  return makeRegisterExpression(amdgpu_gfx90a::v249, output_vec_len );
            case 506:  return makeRegisterExpression(amdgpu_gfx90a::v250, output_vec_len );
            case 507:  return makeRegisterExpression(amdgpu_gfx90a::v251, output_vec_len );
            case 508:  return makeRegisterExpression(amdgpu_gfx90a::v252, output_vec_len );
            case 509:  return makeRegisterExpression(amdgpu_gfx90a::v253, output_vec_len );
            case 510:  return makeRegisterExpression(amdgpu_gfx90a::v254, output_vec_len );
            case 511:  return makeRegisterExpression(amdgpu_gfx90a::v255, output_vec_len );
            default: return makeRegisterExpression(amdgpu_gfx90a::invalid);
        }
    }

}
}
